/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !gpc_reg_operand (operands[1], E_DImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 3;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 4;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != LABEL_REF)
    return -1;
  x6 = XEXP (x2, 2);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XEXP (x1, 0);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x3, 0);
  operands[2] = x8;
  if (!cc_reg_operand (operands[2], E_VOIDmode))
    return -1;
  x9 = XEXP (x5, 0);
  operands[0] = x9;
  return 0;
}

int
pattern36 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!gpc_reg_operand (operands[0], E_DImode)
      || GET_MODE (x2) != E_DImode)
    return -1;
  x5 = XEXP (x2, 0);
  operands[3] = x5;
  if (!gpc_reg_operand (operands[3], E_DImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!gpc_reg_operand (operands[1], E_DImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  if (!scc_eq_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern46 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern56 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern63 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_QImode:
      if (!gpc_reg_operand (operands[1], E_V16QImode)
          || !const_int_operand (operands[2], E_QImode))
        return -1;
      return 1;

    case E_HImode:
      if (!gpc_reg_operand (operands[1], E_V8HImode)
          || !const_int_operand (operands[2], E_QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern70 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !scratch_operand (operands[2], E_DImode))
    return -1;
  return pattern69 (); /* [-1, 2] */
}

int
pattern75 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x6;
      x7 = XEXP (x2, 0);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!gpc_reg_operand (operands[0], E_SFmode)
              || GET_MODE (x5) != E_SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !scratch_operand (operands[2], E_DImode))
                return -1;
              return 0;

            case E_DImode:
              return 1;

            default:
              return -1;
            }

        case E_DFmode:
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || GET_MODE (x5) != E_DFmode
              || !scratch_operand (operands[2], E_DImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode))
                return -1;
              return 2;

            case E_DImode:
              if (!memory_operand (operands[1], E_DImode))
                return -1;
              return 3;

            default:
              return -1;
            }

        case E_KFmode:
          res = pattern70 (x5, 
E_KFmode);
          if (res >= 0)
            return res + 4; /* [4, 6] */
          return -1;

        case E_TFmode:
          res = pattern70 (x5, 
E_TFmode);
          if (res >= 0)
            return res + 7; /* [7, 9] */
          return -1;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      res = pattern71 (x1);
      if (res >= 0)
        return res + 10; /* [10, 11] */
      return -1;

    case ZERO_EXTEND:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      x7 = XEXP (x2, 0);
      operands[2] = x7;
      if (!scratch_operand (operands[2], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          res = pattern72 (x5, 
E_SFmode);
          if (res >= 0)
            return res + 12; /* [12, 13] */
          return -1;

        case E_DFmode:
          res = pattern72 (x5, 
E_DFmode);
          if (res >= 0)
            return res + 14; /* [14, 15] */
          return -1;

        default:
          return -1;
        }

    case VEC_SELECT:
      res = pattern74 (x1);
      if (res >= 0)
        return res + 16; /* [16, 27] */
      return -1;

    default:
      return -1;
    }
}

int
pattern109 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !scratch_operand (operands[3], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return pattern108 (); /* [-1, 1] */
}

int
pattern111 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  return pattern110 (x1); /* [-1, 3] */
}

int
pattern115 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  return 0;
}

int
pattern121 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i1
      || GET_MODE (x2) != E_DImode
      || !gpc_reg_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!gpc_reg_operand (operands[1], E_DImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!scc_eq_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern129 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern135 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!gpc_reg_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!gpc_reg_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!rs6000_tls_symbol_ref (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern144 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i2))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern153 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DDmode:
      if (!gpc_reg_operand (operands[0], E_DDmode)
          || GET_MODE (x3) != E_DDmode
          || !gpc_reg_operand (operands[1], E_DDmode))
        return -1;
      return 0;

    case E_TDmode:
      if (!gpc_reg_operand (operands[0], E_TDmode)
          || GET_MODE (x3) != E_TDmode
          || !gpc_reg_operand (operands[1], E_TDmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern163 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i2))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_V16QImode))
    return -1;
  return 0;
}

int
pattern170 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  switch (GET_MODE (x6))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !scratch_operand (operands[0], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !scratch_operand (operands[0], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern176 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  operands[3] = x5;
  if (!cc_reg_operand (operands[3], E_CCmode)
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 0);
  x7 = XEXP (x6, 1);
  operands[2] = x7;
  x8 = XEXP (x6, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      operands[1] = x8;
      if (!reg_or_cint_operand (operands[2], E_SImode))
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x9))
        {
        case CLOBBER:
          return pattern170 (x1); /* [-1, 1] */

        case SET:
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != ASHIFT)
            return -1;
          res = pattern174 (x1);
          if (res >= 0)
            return res + 2; /* [2, 3] */
          return -1;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x8) != E_DImode
          || GET_MODE (x6) != E_DImode)
        return -1;
      x11 = XEXP (x8, 0);
      operands[1] = x11;
      if (!reg_or_mem_operand (operands[1], E_SImode)
          || !u6bit_cint_operand (operands[2], E_DImode))
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x9))
        {
        case CLOBBER:
          x12 = XEXP (x9, 0);
          operands[0] = x12;
          if (!scratch_operand (operands[0], E_DImode))
            return -1;
          return 4;

        case SET:
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != ASHIFT
              || GET_MODE (x10) != E_DImode)
            return -1;
          x13 = XEXP (x10, 0);
          if (GET_CODE (x13) != SIGN_EXTEND
              || GET_MODE (x13) != E_DImode)
            return -1;
          x12 = XEXP (x9, 0);
          operands[0] = x12;
          if (!gpc_reg_operand (operands[0], E_DImode))
            return -1;
          x14 = XEXP (x13, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          x15 = XEXP (x10, 1);
          if (!rtx_equal_p (x15, operands[2]))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern204 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern208 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[3], i1)
      || !const_int_operand (operands[4], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern217 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!altivec_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !altivec_register_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!altivec_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !altivec_register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern225 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V4SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 282
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 109
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  if (!register_operand (operands[0], E_V4SImode))
    return -1;
  x9 = XVECEXP (x3, 0, 0);
  operands[1] = x9;
  if (!register_operand (operands[1], i1))
    return -1;
  x10 = XVECEXP (x3, 0, 1);
  operands[2] = x10;
  if (!register_operand (operands[2], E_V4SImode))
    return -1;
  return 0;
}

int
pattern239 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[2] = x4;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          return pattern235 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern235 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern236 (x1, 
E_V4SImode) != 0)
            return -1;
          return 2;

        case E_V8HImode:
          if (pattern236 (x1, 
E_V8HImode) != 0)
            return -1;
          return 3;

        case E_V16QImode:
          if (pattern236 (x1, 
E_V16QImode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern236 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 5;

        case E_V2DFmode:
          if (pattern236 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 6;

        case E_V2DImode:
          if (pattern236 (x1, 
E_V2DImode) != 0)
            return -1;
          return 7;

        case E_V1TImode:
          if (pattern236 (x1, 
E_V1TImode) != 0)
            return -1;
          return 8;

        case E_TImode:
          if (pattern236 (x1, 
E_TImode) != 0)
            return -1;
          return 9;

        case E_KFmode:
          if (pattern236 (x1, 
E_KFmode) != 0)
            return -1;
          return 10;

        case E_TFmode:
          if (pattern236 (x1, 
E_TFmode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    case NOT:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          if (pattern237 (x1, 
E_SImode) != 0)
            return -1;
          return 12;

        case E_DImode:
          if (pattern237 (x1, 
E_DImode) != 0)
            return -1;
          return 13;

        case E_V4SImode:
          if (pattern238 (x1, 
E_V4SImode) != 0)
            return -1;
          return 14;

        case E_V8HImode:
          if (pattern238 (x1, 
E_V8HImode) != 0)
            return -1;
          return 15;

        case E_V16QImode:
          if (pattern238 (x1, 
E_V16QImode) != 0)
            return -1;
          return 16;

        case E_V4SFmode:
          if (pattern238 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 17;

        case E_V2DFmode:
          if (pattern238 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 18;

        case E_V2DImode:
          if (pattern238 (x1, 
E_V2DImode) != 0)
            return -1;
          return 19;

        case E_V1TImode:
          if (pattern238 (x1, 
E_V1TImode) != 0)
            return -1;
          return 20;

        case E_TImode:
          if (pattern238 (x1, 
E_TImode) != 0)
            return -1;
          return 21;

        case E_KFmode:
          if (pattern238 (x1, 
E_KFmode) != 0)
            return -1;
          return 22;

        case E_TFmode:
          if (pattern238 (x1, 
E_TFmode) != 0)
            return -1;
          return 23;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern275 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != NOT)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      return pattern268 (x1); /* [-1, 11] */

    case NOT:
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      x8 = XEXP (x5, 1);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          res = pattern271 (x1);
          if (res >= 0)
            return res + 12; /* [12, 23] */
          return -1;

        case NOT:
          res = pattern274 (x1);
          if (res >= 0)
            return res + 24; /* [24, 35] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern285 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern284 (x1, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern284 (x1, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern292 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  x9 = XEXP (x5, 1);
  operands[4] = x9;
  x10 = XEXP (x5, 2);
  operands[5] = x10;
  x11 = XEXP (x2, 0);
  operands[6] = x11;
  if (!scratch_operand (operands[6], E_V2DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern290 (x5, 
E_SFmode); /* [-1, 1] */

    case E_DFmode:
      res = pattern290 (x5, 
E_DFmode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case E_KFmode:
      if (pattern291 (x5, 
E_KFmode) != 0)
        return -1;
      return 4;

    case E_TFmode:
      if (pattern291 (x5, 
E_TFmode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern310 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !scc_rev_comparison_operator (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_CCmode:
      if (!cc_reg_operand (operands[2], E_CCmode))
        return -1;
      return 0;

    case E_CCUNSmode:
      if (!cc_reg_operand (operands[2], E_CCUNSmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern321 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_KFmode:
      if (!altivec_register_operand (operands[1], E_KFmode))
        return -1;
      return 0;

    case E_TFmode:
      if (!altivec_register_operand (operands[1], E_TFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern332 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 282
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 109
      || GET_MODE (x7) != E_SImode
      || !register_operand (operands[0], i1)
      || !register_operand (operands[1], E_V8HImode))
    return -1;
  x8 = XVECEXP (x3, 0, 1);
  operands[2] = x8;
  if (!register_operand (operands[2], E_V8HImode))
    return -1;
  x9 = XVECEXP (x3, 0, 2);
  operands[3] = x9;
  if (!register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern346 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V2DImode
      || !vsx_register_operand (operands[0], E_V2DImode)
      || !vsx_register_operand (operands[1], E_V2DImode)
      || !vsx_register_operand (operands[2], E_V2DImode))
    return -1;
  return 0;
}

int
pattern352 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vsx_register_operand (operands[1], i1)
      || !vsx_register_operand (operands[2], i1)
      || !vsx_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern358 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || !boolean_operator (operands[3], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern364 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern372 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x7))
        {
        case CLOBBER:
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              return pattern366 (
E_SImode); /* [-1, 0] */

            case E_DImode:
              if (pattern366 (
E_DImode) != 0)
                return -1;
              return 1;

            default:
              return -1;
            }

        case SET:
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          x9 = XEXP (x7, 1);
          if (!rtx_equal_p (x9, operands[3]))
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern367 (
E_SImode) != 0)
                return -1;
              return 2;

            case E_DImode:
              if (pattern367 (
E_DImode) != 0)
                return -1;
              return 3;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          x10 = XEXP (x5, 0);
          operands[2] = x10;
          x7 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x7))
            {
            case CLOBBER:
              x8 = XEXP (x7, 0);
              operands[0] = x8;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern368 (x5, 
E_SImode) != 0)
                    return -1;
                  return 4;

                case E_DImode:
                  if (pattern368 (x5, 
E_DImode) != 0)
                    return -1;
                  return 5;

                default:
                  return -1;
                }

            case SET:
              x8 = XEXP (x7, 0);
              operands[0] = x8;
              x9 = XEXP (x7, 1);
              if (!rtx_equal_p (x9, operands[3]))
                return -1;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern369 (x5, 
E_SImode) != 0)
                    return -1;
                  return 6;

                case E_DImode:
                  if (pattern369 (x5, 
E_DImode) != 0)
                    return -1;
                  return 7;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case NOT:
          x10 = XEXP (x5, 0);
          operands[1] = x10;
          x11 = XEXP (x6, 0);
          operands[2] = x11;
          x7 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x7))
            {
            case CLOBBER:
              x8 = XEXP (x7, 0);
              operands[0] = x8;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern370 (operands[3], 
E_SImode) != 0)
                    return -1;
                  return 8;

                case E_DImode:
                  if (pattern370 (operands[3], 
E_DImode) != 0)
                    return -1;
                  return 9;

                default:
                  return -1;
                }

            case SET:
              x8 = XEXP (x7, 0);
              operands[0] = x8;
              x9 = XEXP (x7, 1);
              if (!rtx_equal_p (x9, operands[3]))
                return -1;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern371 (operands[3], 
E_SImode) != 0)
                    return -1;
                  return 10;

                case E_DImode:
                  if (pattern371 (operands[3], 
E_DImode) != 0)
                    return -1;
                  return 11;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern427 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !memory_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !memory_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !memory_operand (operands[1], E_V16QImode))
        return -1;
      return 2;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !memory_operand (operands[1], E_V4SFmode))
        return -1;
      return 3;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !memory_operand (operands[1], E_V2DFmode))
        return -1;
      return 4;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !memory_operand (operands[1], E_V2DImode))
        return -1;
      return 5;

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || !memory_operand (operands[1], E_V1TImode))
        return -1;
      return 6;

    case E_KFmode:
      if (!register_operand (operands[0], E_KFmode)
          || !memory_operand (operands[1], E_KFmode))
        return -1;
      return 7;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || !memory_operand (operands[1], E_TFmode))
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern455 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!scratch_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_KFmode:
      if (!altivec_register_operand (operands[1], E_KFmode))
        return -1;
      return 2;

    case E_TFmode:
      if (!altivec_register_operand (operands[1], E_TFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern466 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern473 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 3
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 2
      || GET_MODE (x3) != E_DImode)
    return -1;
  return 0;
}

int
pattern479 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsx_register_operand (operands[4], i1)
      || !vsx_register_operand (operands[5], i1))
    return -1;
  return pattern478 (); /* [-1, 1] */
}

int
pattern485 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode)
        return -1;
      return 0;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode)
        return -1;
      return 1;

    case E_KFmode:
      if (!register_operand (operands[0], E_KFmode)
          || GET_MODE (x1) != E_KFmode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern496 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern505 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern512 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!fpr_reg_operand (operands[1], E_XOmode)
      || !vsx_register_operand (operands[2], E_OOmode)
      || !vsx_register_operand (operands[3], E_V16QImode)
      || !const_0_to_3_operand (operands[5], E_SImode))
    return -1;
  return 0;
}

int
pattern518 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern529 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !reg_or_short_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern534 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern541 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !exact_log2_cint_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern549 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[1], E_V2DFmode)
      || !vsx_register_operand (operands[2], E_V2DFmode)
      || !vsx_register_operand (operands[0], E_V2DFmode)
      || GET_MODE (x1) != E_V2DFmode)
    return -1;
  return 0;
}

int
pattern559 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != i1)
    return -1;
  x11 = XEXP (x9, 1);
  if (GET_CODE (x11) != i1)
    return -1;
  x12 = XEXP (x5, 0);
  x13 = XEXP (x12, 0);
  operands[1] = x13;
  if (!gpc_reg_operand (operands[1], E_HImode))
    return -1;
  x14 = XEXP (x6, 0);
  operands[2] = x14;
  if (!gpc_reg_operand (operands[2], E_HImode))
    return -1;
  x15 = XEXP (x10, 0);
  if (!rtx_equal_p (x15, operands[1]))
    return -1;
  x16 = XEXP (x11, 0);
  if (!rtx_equal_p (x16, operands[2]))
    return -1;
  return 0;
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case EQ:
      res = recog_7 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case LT:
      if (pattern44 (x1, 
E_CCmode, 
GT) == 0
          && 
#line 15710 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC))
        return 1096; /* setb_signed */
      break;

    case LTU:
      if (pattern44 (x1, 
E_CCUNSmode, 
GTU) == 0
          && 
#line 15723 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC))
        return 1097; /* setb_unsigned */
      break;

    default:
      break;
    }
  operands[1] = x3;
  if (!scc_comparison_operator (operands[1], E_VOIDmode))
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[4] = x6;
  x7 = XEXP (x2, 1);
  operands[2] = x7;
  x8 = XEXP (x2, 2);
  operands[3] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern434 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 5570 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ISEL))
            return -1;
          return 342; /* isel_cc_si */

        case 1:
          if (!
#line 5570 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ISEL))
            return -1;
          return 344; /* isel_ccuns_si */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern434 (x2, 
E_DImode))
        {
        case 0:
          if (!(
#line 5570 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ISEL) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 343; /* isel_cc_di */

        case 1:
          if (!(
#line 5570 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ISEL) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 345; /* isel_ccuns_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case XOR:
      x6 = XEXP (x5, 0);
      operands[0] = x6;
      x7 = XEXP (x5, 1);
      operands[1] = x7;
      x8 = XEXP (x3, 1);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          switch (pattern409 (x3))
            {
            case 0:
              if (!
#line 403 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2378; /* *fuse_eqv_and */

            case 1:
              if (!(
#line 403 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2379; /* *fuse_eqv_and */

            case 2:
              if (!
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2562; /* *fuse_veqv_vand */

            case 3:
              if (!
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2563; /* *fuse_veqv_vand */

            case 4:
              if (!
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2564; /* *fuse_veqv_vand */

            case 5:
              if (!
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2565; /* *fuse_veqv_vand */

            case 6:
              if (!
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2566; /* *fuse_veqv_vand */

            case 7:
              if (!
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2567; /* *fuse_veqv_vand */

            case 8:
              if (!
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2568; /* *fuse_veqv_vand */

            case 9:
              if (!
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2569; /* *fuse_veqv_vand */

            case 10:
              if (!(
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2570; /* *fuse_veqv_vand */

            case 11:
              if (!(
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2571; /* *fuse_veqv_vand */

            default:
              return -1;
            }

        case NOT:
          x9 = XEXP (x8, 0);
          operands[2] = x9;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern266 (x3, 
E_SImode) != 0
                  || !
#line 583 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2398; /* *fuse_eqv_andc */

            case E_DImode:
              if (pattern266 (x3, 
E_DImode) != 0
                  || !(
#line 583 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2399; /* *fuse_eqv_andc */

            case E_V4SImode:
              if (pattern267 (x3, 
E_V4SImode) != 0
                  || !
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2642; /* *fuse_veqv_vandc */

            case E_V8HImode:
              if (pattern267 (x3, 
E_V8HImode) != 0
                  || !
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2643; /* *fuse_veqv_vandc */

            case E_V16QImode:
              if (pattern267 (x3, 
E_V16QImode) != 0
                  || !
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2644; /* *fuse_veqv_vandc */

            case E_V4SFmode:
              if (pattern267 (x3, 
E_V4SFmode) != 0
                  || !
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2645; /* *fuse_veqv_vandc */

            case E_V2DFmode:
              if (pattern267 (x3, 
E_V2DFmode) != 0
                  || !
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2646; /* *fuse_veqv_vandc */

            case E_V2DImode:
              if (pattern267 (x3, 
E_V2DImode) != 0
                  || !
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2647; /* *fuse_veqv_vandc */

            case E_V1TImode:
              if (pattern267 (x3, 
E_V1TImode) != 0
                  || !
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2648; /* *fuse_veqv_vandc */

            case E_TImode:
              if (pattern267 (x3, 
E_TImode) != 0
                  || !
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2649; /* *fuse_veqv_vandc */

            case E_KFmode:
              if (pattern267 (x3, 
E_KFmode) != 0
                  || !(
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2650; /* *fuse_veqv_vandc */

            case E_TFmode:
              if (pattern267 (x3, 
E_TFmode) != 0
                  || !(
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2651; /* *fuse_veqv_vandc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      switch (pattern275 (x3))
        {
        case 0:
          if (!
#line 1015 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2446; /* *fuse_and_nor */

        case 1:
          if (!(
#line 1015 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2447; /* *fuse_and_nor */

        case 2:
          if (!
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2862; /* *fuse_vand_vnor */

        case 3:
          if (!
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2863; /* *fuse_vand_vnor */

        case 4:
          if (!
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2864; /* *fuse_vand_vnor */

        case 5:
          if (!
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2865; /* *fuse_vand_vnor */

        case 6:
          if (!
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2866; /* *fuse_vand_vnor */

        case 7:
          if (!
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2867; /* *fuse_vand_vnor */

        case 8:
          if (!
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2868; /* *fuse_vand_vnor */

        case 9:
          if (!
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2869; /* *fuse_vand_vnor */

        case 10:
          if (!(
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2870; /* *fuse_vand_vnor */

        case 11:
          if (!(
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2871; /* *fuse_vand_vnor */

        case 12:
          if (!
#line 1033 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2448; /* *fuse_andc_nor */

        case 13:
          if (!(
#line 1033 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2449; /* *fuse_andc_nor */

        case 14:
          if (!
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2872; /* *fuse_vandc_vnor */

        case 15:
          if (!
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2873; /* *fuse_vandc_vnor */

        case 16:
          if (!
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2874; /* *fuse_vandc_vnor */

        case 17:
          if (!
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2875; /* *fuse_vandc_vnor */

        case 18:
          if (!
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2876; /* *fuse_vandc_vnor */

        case 19:
          if (!
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2877; /* *fuse_vandc_vnor */

        case 20:
          if (!
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2878; /* *fuse_vandc_vnor */

        case 21:
          if (!
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2879; /* *fuse_vandc_vnor */

        case 22:
          if (!(
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2880; /* *fuse_vandc_vnor */

        case 23:
          if (!(
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2881; /* *fuse_vandc_vnor */

        case 24:
          if (!
#line 1087 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2454; /* *fuse_nor_nor */

        case 25:
          if (!(
#line 1087 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2455; /* *fuse_nor_nor */

        case 26:
          if (!
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2902; /* *fuse_vnor_vnor */

        case 27:
          if (!
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2903; /* *fuse_vnor_vnor */

        case 28:
          if (!
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2904; /* *fuse_vnor_vnor */

        case 29:
          if (!
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2905; /* *fuse_vnor_vnor */

        case 30:
          if (!
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2906; /* *fuse_vnor_vnor */

        case 31:
          if (!
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2907; /* *fuse_vnor_vnor */

        case 32:
          if (!
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2908; /* *fuse_vnor_vnor */

        case 33:
          if (!
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2909; /* *fuse_vnor_vnor */

        case 34:
          if (!(
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2910; /* *fuse_vnor_vnor */

        case 35:
          if (!(
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2911; /* *fuse_vnor_vnor */

        default:
          return -1;
        }

    case NOT:
      switch (pattern278 (x3))
        {
        case 0:
          if (!
#line 1051 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2450; /* *fuse_eqv_nor */

        case 1:
          if (!(
#line 1051 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2451; /* *fuse_eqv_nor */

        case 2:
          if (!
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2882; /* *fuse_veqv_vnor */

        case 3:
          if (!
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2883; /* *fuse_veqv_vnor */

        case 4:
          if (!
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2884; /* *fuse_veqv_vnor */

        case 5:
          if (!
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2885; /* *fuse_veqv_vnor */

        case 6:
          if (!
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2886; /* *fuse_veqv_vnor */

        case 7:
          if (!
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2887; /* *fuse_veqv_vnor */

        case 8:
          if (!
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2888; /* *fuse_veqv_vnor */

        case 9:
          if (!
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2889; /* *fuse_veqv_vnor */

        case 10:
          if (!(
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2890; /* *fuse_veqv_vnor */

        case 11:
          if (!(
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2891; /* *fuse_veqv_vnor */

        default:
          return -1;
        }

    case IOR:
      switch (pattern279 (x3))
        {
        case 0:
          if (!
#line 1069 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2452; /* *fuse_nand_nor */

        case 1:
          if (!(
#line 1069 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2453; /* *fuse_nand_nor */

        case 2:
          if (!
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2892; /* *fuse_vnand_vnor */

        case 3:
          if (!
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2893; /* *fuse_vnand_vnor */

        case 4:
          if (!
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2894; /* *fuse_vnand_vnor */

        case 5:
          if (!
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2895; /* *fuse_vnand_vnor */

        case 6:
          if (!
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2896; /* *fuse_vnand_vnor */

        case 7:
          if (!
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2897; /* *fuse_vnand_vnor */

        case 8:
          if (!
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2898; /* *fuse_vnand_vnor */

        case 9:
          if (!
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2899; /* *fuse_vnand_vnor */

        case 10:
          if (!(
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2900; /* *fuse_vnand_vnor */

        case 11:
          if (!(
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2901; /* *fuse_vnand_vnor */

        case 12:
          if (!
#line 1123 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2458; /* *fuse_orc_nor */

        case 13:
          if (!(
#line 1123 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2459; /* *fuse_orc_nor */

        case 14:
          if (!
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2922; /* *fuse_vorc_vnor */

        case 15:
          if (!
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2923; /* *fuse_vorc_vnor */

        case 16:
          if (!
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2924; /* *fuse_vorc_vnor */

        case 17:
          if (!
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2925; /* *fuse_vorc_vnor */

        case 18:
          if (!
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2926; /* *fuse_vorc_vnor */

        case 19:
          if (!
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2927; /* *fuse_vorc_vnor */

        case 20:
          if (!
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2928; /* *fuse_vorc_vnor */

        case 21:
          if (!
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2929; /* *fuse_vorc_vnor */

        case 22:
          if (!(
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2930; /* *fuse_vorc_vnor */

        case 23:
          if (!(
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2931; /* *fuse_vorc_vnor */

        case 24:
          if (!
#line 1105 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2456; /* *fuse_or_nor */

        case 25:
          if (!(
#line 1105 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2457; /* *fuse_or_nor */

        case 26:
          if (!
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2912; /* *fuse_vor_vnor */

        case 27:
          if (!
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2913; /* *fuse_vor_vnor */

        case 28:
          if (!
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2914; /* *fuse_vor_vnor */

        case 29:
          if (!
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2915; /* *fuse_vor_vnor */

        case 30:
          if (!
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2916; /* *fuse_vor_vnor */

        case 31:
          if (!
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2917; /* *fuse_vor_vnor */

        case 32:
          if (!
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2918; /* *fuse_vor_vnor */

        case 33:
          if (!
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2919; /* *fuse_vor_vnor */

        case 34:
          if (!(
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2920; /* *fuse_vor_vnor */

        case 35:
          if (!(
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2921; /* *fuse_vor_vnor */

        default:
          return -1;
        }

    case PLUS:
      switch (pattern280 (x3))
        {
        case 0:
          if (!
#line 1159 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2462; /* *fuse_add_nor */

        case 1:
          if (!(
#line 1159 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2463; /* *fuse_add_nor */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern280 (x3))
        {
        case 0:
          if (!
#line 1177 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2464; /* *fuse_subf_nor */

        case 1:
          if (!(
#line 1177 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2465; /* *fuse_subf_nor */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode)
        return -1;
      if (gpc_reg_operand (operands[1], E_V2DFmode)
          && 
#line 3658 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode) && TARGET_DIRECT_MOVE_64BIT))
        {
          *pnum_clobbers = 2;
          return 1389; /* vsx_extract_v2df_var */
        }
      if (!memory_operand (operands[1], E_V2DFmode)
          || !
#line 3675 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode) && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 1391; /* *vsx_extract_v2df_var_load */

    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      if (gpc_reg_operand (operands[1], E_V4SFmode)
          && 
#line 3745 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_DIRECT_MOVE_64BIT))
        {
          *pnum_clobbers = 2;
          return 1395; /* vsx_extract_v4sf_var */
        }
      if (!memory_operand (operands[1], E_V4SFmode)
          || !
#line 3762 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 1396; /* *vsx_extract_v4sf_var_load */

    case E_QImode:
      if (!gpc_reg_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode)
        return -1;
      if (gpc_reg_operand (operands[1], E_V16QImode)
          && 
#line 4185 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT))
        {
          *pnum_clobbers = 2;
          return 1416; /* vsx_extract_v16qi_var */
        }
      if (!memory_operand (operands[1], E_V16QImode)
          || !
#line 4204 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 1419; /* *vsx_extract_v16qi_var_load */

    case E_HImode:
      if (!gpc_reg_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      if (gpc_reg_operand (operands[1], E_V8HImode)
          && 
#line 4185 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT))
        {
          *pnum_clobbers = 2;
          return 1417; /* vsx_extract_v8hi_var */
        }
      if (!memory_operand (operands[1], E_V8HImode)
          || !
#line 4204 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 1420; /* *vsx_extract_v8hi_var_load */

    default:
      return -1;
    }
}

 int
recog_40 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_DFmode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_DFmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !
#line 9556 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE))
        return -1;
      return 631; /* p8_fmrgow_di */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !
#line 9556 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE))
        return -1;
      return 632; /* p8_fmrgow_df */

    case E_DDmode:
      if (!register_operand (operands[0], E_DDmode)
          || GET_MODE (x3) != E_DDmode
          || !
#line 9556 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE))
        return -1;
      return 633; /* p8_fmrgow_dd */

    default:
      return -1;
    }
}

 int
recog_46 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!vsx_register_operand (operands[0], E_DFmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[1]))
    {
    case E_DImode:
      switch (pattern437 (
E_DImode))
        {
        case 0:
          if (!
#line 5261 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && TARGET_POWERPC64))
            return -1;
          return 1561; /* xsiexpdp_si */

        case 1:
          if (!(
#line 5261 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && TARGET_POWERPC64) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 1562; /* xsiexpdp_di */

        default:
          return -1;
        }

    case E_DFmode:
      switch (pattern437 (
E_DFmode))
        {
        case 0:
          if (!
#line 5271 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && TARGET_POWERPC64))
            return -1;
          return 1563; /* xsiexpdpf_si */

        case 1:
          if (!(
#line 5271 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && TARGET_POWERPC64) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 1564; /* xsiexpdpf_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_59 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern364 (x3, 
E_SImode) != 0
          || !
#line 2600 "../../gcc/config/rs6000/rs6000.md"
(TARGET_CMPB))
        return -1;
      return 137; /* cmpbsi3 */

    case E_DImode:
      if (pattern364 (x3, 
E_DImode) != 0
          || !(
#line 2600 "../../gcc/config/rs6000/rs6000.md"
(TARGET_CMPB) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
        return -1;
      return 138; /* cmpbdi3 */

    default:
      return -1;
    }
}

 int
recog_67 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x2) != E_SFmode
          || !gpc_reg_operand (operands[1], E_SFmode)
          || !
#line 6851 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND))
        return -1;
      return 474; /* roundsf2 */

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x2) != E_DFmode
          || !gpc_reg_operand (operands[1], E_DFmode)
          || !
#line 6851 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND))
        return -1;
      return 475; /* rounddf2 */

    case E_KFmode:
      if (!altivec_register_operand (operands[0], E_KFmode)
          || GET_MODE (x2) != E_KFmode
          || !altivec_register_operand (operands[1], E_KFmode)
          || !(
#line 15477 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1069; /* roundkf2 */

    case E_TFmode:
      if (!altivec_register_operand (operands[0], E_TFmode)
          || GET_MODE (x2) != E_TFmode
          || !altivec_register_operand (operands[1], E_TFmode)
          || !(
#line 15477 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1070; /* roundtf2 */

    default:
      return -1;
    }
}

 int
recog_72 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x2) != E_V16QImode
          || !
#line 9580 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 636; /* p8_mtvsrd_v16qidi2 */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x2) != E_DFmode
          || !
#line 9614 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 640; /* p8_mtvsrd_df */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x2) != E_SFmode
          || !
#line 9679 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 661; /* p8_mtvsrd_sf */

    default:
      return -1;
    }
}

 int
recog_78 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x2) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !
#line 100 "../../gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 2332; /* crypto_vsbox_v16qi */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 100 "../../gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 2333; /* crypto_vsbox_v2di */

    default:
      return -1;
    }
}

 int
recog_86 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_PTImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_CODE (operands[1]))
    {
    case MEM:
      if (!quad_memory_operand (operands[1], E_TImode)
          || !quad_int_reg_operand (operands[0], E_PTImode)
          || !
#line 130 "../../gcc/config/rs6000/sync.md"
(TARGET_SYNC_TI
   && !reg_mentioned_p (operands[0], operands[1])))
        return -1;
      return 1110; /* load_quadpti */

    case REG:
      if (!quad_int_reg_operand (operands[1], E_PTImode)
          || !quad_memory_operand (operands[0], E_PTImode)
          || !
#line 206 "../../gcc/config/rs6000/sync.md"
(TARGET_SYNC_TI))
        return -1;
      return 1111; /* store_quadpti */

    default:
      return -1;
    }
}

 int
recog_96 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!u5bit_cint_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (pattern133 (x3, 
E_V16QImode) != 0
          || !
#line 4907 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode)))
        return -1;
      return 1510; /* vsx_xxsldwi_v16qi */

    case E_V8HImode:
      if (pattern133 (x3, 
E_V8HImode) != 0
          || !
#line 4907 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode)))
        return -1;
      return 1511; /* vsx_xxsldwi_v8hi */

    case E_V4SImode:
      if (pattern133 (x3, 
E_V4SImode) != 0
          || !
#line 4907 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode)))
        return -1;
      return 1512; /* vsx_xxsldwi_v4si */

    case E_V2DImode:
      if (pattern133 (x3, 
E_V2DImode) != 0
          || !
#line 4907 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
        return -1;
      return 1513; /* vsx_xxsldwi_v2di */

    case E_V4SFmode:
      if (pattern133 (x3, 
E_V4SFmode) != 0
          || !
#line 4907 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode)))
        return -1;
      return 1514; /* vsx_xxsldwi_v4sf */

    case E_V2DFmode:
      if (pattern133 (x3, 
E_V2DFmode) != 0
          || !
#line 4907 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
        return -1;
      return 1515; /* vsx_xxsldwi_v2df */

    case E_V1TImode:
      if (pattern133 (x3, 
E_V1TImode) != 0
          || !
#line 4907 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V1TImode)))
        return -1;
      return 1516; /* vsx_xxsldwi_v1ti */

    case E_TImode:
      if (pattern133 (x3, 
E_TImode) != 0
          || !
#line 4907 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (TImode)))
        return -1;
      return 1517; /* vsx_xxsldwi_ti */

    case E_KFmode:
      if (pattern133 (x3, 
E_KFmode) != 0
          || !(
#line 4907 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (KFmode)) && 
#line 58 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (KFmode))))
        return -1;
      return 1518; /* vsx_xxsldwi_kf */

    case E_TFmode:
      if (pattern133 (x3, 
E_TFmode) != 0
          || !(
#line 4907 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (TFmode)) && 
#line 59 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (TFmode))))
        return -1;
      return 1519; /* vsx_xxsldwi_tf */

    default:
      return -1;
    }
}

 int
recog_108 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (SUBREG_BYTE (x3))
    {
    case 0:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case MULT:
          x5 = XEXP (x4, 0);
          switch (GET_CODE (x5))
            {
            case SIGN_EXTEND:
              switch (pattern444 (x3, 
SIGN_EXTEND))
                {
                case 0:
                  if (!
#line 3200 "../../gcc/config/rs6000/rs6000.md"
(WORDS_BIG_ENDIAN && !(SImode == SImode && TARGET_POWERPC64)))
                    return -1;
                  return 160; /* *smulsi3_highpart */

                case 1:
                  if (!(
#line 3200 "../../gcc/config/rs6000/rs6000.md"
(WORDS_BIG_ENDIAN && !(DImode == SImode && TARGET_POWERPC64)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 162; /* *smuldi3_highpart */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern444 (x3, 
ZERO_EXTEND))
                {
                case 0:
                  if (!
#line 3200 "../../gcc/config/rs6000/rs6000.md"
(WORDS_BIG_ENDIAN && !(SImode == SImode && TARGET_POWERPC64)))
                    return -1;
                  return 161; /* *umulsi3_highpart */

                case 1:
                  if (!(
#line 3200 "../../gcc/config/rs6000/rs6000.md"
(WORDS_BIG_ENDIAN && !(DImode == SImode && TARGET_POWERPC64)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 163; /* *umuldi3_highpart */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case PLUS:
          if (GET_MODE (x4) != E_TImode)
            return -1;
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != MULT
              || GET_MODE (x5) != E_TImode
              || !gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          switch (pattern524 (x4))
            {
            case 0:
              if (!
#line 3314 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MADDLD && BYTES_BIG_ENDIAN && TARGET_POWERPC64))
                return -1;
              return 172; /* madddi4_highpart */

            case 1:
              if (!
#line 3314 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MADDLD && BYTES_BIG_ENDIAN && TARGET_POWERPC64))
                return -1;
              return 173; /* umadddi4_highpart */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != MULT
          || GET_MODE (x4) != E_DImode
          || !gpc_reg_operand (operands[0], E_SImode))
        return -1;
      switch (pattern483 (x4, 
E_SImode, 
E_DImode))
        {
        case 0:
          if (!
#line 3213 "../../gcc/config/rs6000/rs6000.md"
(!WORDS_BIG_ENDIAN && !TARGET_POWERPC64))
            return -1;
          return 164; /* smulsi3_highpart_le */

        case 1:
          if (!
#line 3213 "../../gcc/config/rs6000/rs6000.md"
(!WORDS_BIG_ENDIAN && !TARGET_POWERPC64))
            return -1;
          return 165; /* umulsi3_highpart_le */

        default:
          return -1;
        }

    case 8:
      if (GET_MODE (x3) != E_DImode
          || !gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_TImode)
        return -1;
      switch (GET_CODE (x4))
        {
        case MULT:
          switch (pattern483 (x4, 
E_DImode, 
E_TImode))
            {
            case 0:
              if (!
#line 3225 "../../gcc/config/rs6000/rs6000.md"
(!WORDS_BIG_ENDIAN && TARGET_POWERPC64))
                return -1;
              return 166; /* smuldi3_highpart_le */

            case 1:
              if (!
#line 3225 "../../gcc/config/rs6000/rs6000.md"
(!WORDS_BIG_ENDIAN && TARGET_POWERPC64))
                return -1;
              return 167; /* umuldi3_highpart_le */

            default:
              return -1;
            }

        case PLUS:
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != MULT
              || GET_MODE (x5) != E_TImode)
            return -1;
          switch (pattern524 (x4))
            {
            case 0:
              if (!
#line 3326 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MADDLD && !BYTES_BIG_ENDIAN && TARGET_POWERPC64))
                return -1;
              return 174; /* madddi4_highpart_le */

            case 1:
              if (!
#line 3326 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MADDLD && !BYTES_BIG_ENDIAN && TARGET_POWERPC64))
                return -1;
              return 175; /* umadddi4_highpart_le */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_115 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (!vsx_register_operand (operands[0], E_V2DImode)
              || GET_MODE (x2) != E_V2DImode)
            return -1;
          if (gpc_reg_operand (operands[1], E_DImode)
              && 
#line 4787 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
            return 1496; /* vsx_splat_v2di_reg */
          if (!memory_operand (operands[1], E_DImode)
              || !
#line 4797 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
            return -1;
          return 1498; /* vsx_splat_v2di_mem */

        case E_V4SImode:
          if (!vsx_register_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !splat_input_operand (operands[1], E_SImode)
              || !
#line 4806 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1499; /* vsx_splat_v4si */

        default:
          return -1;
        }

    case TRUNCATE:
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (!vsx_register_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || GET_MODE (x3) != E_SImode
              || !gpc_reg_operand (operands[1], E_DImode)
              || !
#line 4820 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1500; /* vsx_splat_v4si_di */

        case E_V8HImode:
          if (!altivec_register_operand (operands[0], E_V8HImode)
              || GET_MODE (x2) != E_V8HImode
              || GET_MODE (x3) != E_HImode
              || !altivec_register_operand (operands[1], E_DImode)
              || !
#line 4880 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1507; /* vsx_vsplth_di */

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x6 = XVECEXP (x5, 0, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (GET_MODE (x2) != E_V4SImode
              || GET_MODE (x3) != E_SImode)
            return -1;
          if (vsx_register_operand (operands[0], E_V4SImode)
              && vsx_register_operand (operands[1], E_V4SImode)
              && u5bit_cint_operand (operands[2], E_QImode)
              && 
#line 4856 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode)))
            return 1503; /* vsx_xxspltw_v4si */
          if (!register_operand (operands[0], E_V4SImode)
              || !register_operand (operands[1], E_V4SImode)
              || !const_0_to_3_operand (operands[2], E_QImode)
              || !
#line 2410 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1948; /* *altivec_vspltw_internal */

        case E_V8HImode:
          if (pattern417 (x2, 
E_V8HImode, 
E_HImode) != 0
              || !const_0_to_7_operand (operands[2], E_QImode)
              || !
#line 2372 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1946; /* *altivec_vsplth_internal */

        default:
          return -1;
        }

    case CONST_INT:
      operands[1] = x3;
      if (!s5bit_cint_operand (operands[1], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !
#line 2461 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1951; /* altivec_vspltisw */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x2) != E_V8HImode
              || !
#line 2461 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1952; /* altivec_vspltish */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_119 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      switch (pattern22 (x1, pnum_clobbers))
        {
        case 0:
          *pnum_clobbers = 1;
          return 6; /* *zero_extendqisi2_dot */

        case 1:
          *pnum_clobbers = 1;
          return 12; /* *zero_extendhisi2_dot */

        case 2:
          if (!
#line 490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 7; /* *zero_extendqidi2_dot */

        case 3:
          if (!
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 13; /* *zero_extendhidi2_dot */

        case 4:
          if (!
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 17; /* *zero_extendsidi2_dot */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern22 (x1, pnum_clobbers))
        {
        case 0:
          *pnum_clobbers = 1;
          return 21; /* *extendqisi2_dot */

        case 1:
          *pnum_clobbers = 1;
          return 27; /* *extendhisi2_dot */

        case 2:
          if (!
#line 490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 22; /* *extendqidi2_dot */

        case 3:
          if (!
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 28; /* *extendhidi2_dot */

        case 4:
          if (!
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 32; /* *extendsidi2_dot */

        default:
          return -1;
        }

    case PLUS:
      if (pattern23 (x1, pnum_clobbers) != 0)
        return -1;
      switch (GET_CODE (operands[2]))
        {
        case REG:
        case SUBREG:
          switch (pattern398 (x3))
            {
            case 0:
              if (!
#line 1872 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              *pnum_clobbers = 1;
              return 67; /* *addsi3_dot */

            case 1:
              if (!(
#line 1872 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 68; /* *adddi3_dot */

            default:
              return -1;
            }

        case CONST_INT:
          switch (GET_MODE (x3))
            {
            case E_SImode:
              if (!gpc_reg_operand (operands[1], E_SImode)
                  || !short_cint_operand (operands[2], E_SImode)
                  || !
#line 1919 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              *pnum_clobbers = 2;
              return 71; /* *addsi3_imm_dot */

            case E_DImode:
              if (!gpc_reg_operand (operands[1], E_DImode)
                  || !short_cint_operand (operands[2], E_DImode)
                  || !(
#line 1919 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 2;
              return 72; /* *adddi3_imm_dot */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      switch (pattern24 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 2132 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 1;
          return 90; /* *one_cmplsi2_dot */

        case 1:
          if (!(
#line 2132 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 91; /* *one_cmpldi2_dot */

        default:
          return -1;
        }

    case MINUS:
      if (pattern25 (x1, pnum_clobbers) != 0)
        return -1;
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      switch (GET_MODE (x3))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[2], E_SImode)
              || !gpc_reg_operand (operands[1], E_SImode)
              || !
#line 2215 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 1;
          return 96; /* *subfsi3_dot */

        case E_DImode:
          if (!gpc_reg_operand (operands[2], E_DImode)
              || !gpc_reg_operand (operands[1], E_DImode)
              || !(
#line 2215 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 97; /* *subfdi3_dot */

        default:
          return -1;
        }

    case NEG:
      switch (pattern24 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 2410 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 1;
          return 118; /* *negsi2_dot */

        case 1:
          if (!(
#line 2410 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 119; /* *negdi2_dot */

        default:
          return -1;
        }

    case MULT:
      if (pattern23 (x1, pnum_clobbers) != 0)
        return -1;
      switch (pattern398 (x3))
        {
        case 0:
          if (!
#line 3124 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 1;
          return 156; /* *mulsi3_dot */

        case 1:
          if (!(
#line 3124 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 157; /* *muldi3_dot */

        default:
          return -1;
        }

    case DIV:
      if (pattern23 (x1, pnum_clobbers) != 0)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[1], E_SImode)
              || !exact_log2_cint_operand (operands[2], E_SImode)
              || !
#line 3394 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 2;
          return 183; /* *divsi3_sra_dot */

        case E_DImode:
          if (!gpc_reg_operand (operands[1], E_DImode)
              || !exact_log2_cint_operand (operands[2], E_DImode)
              || !(
#line 3394 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 2;
          return 184; /* *divdi3_sra_dot */

        default:
          return -1;
        }

    case AND:
    case IOR:
    case XOR:
      return recog_3 (x1, insn, pnum_clobbers);

    case ROTATE:
      switch (pattern27 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 4590 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 1;
          return 267; /* *rotlsi3_dot */

        case 1:
          if (!(
#line 4590 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 268; /* *rotldi3_dot */

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern25 (x1, pnum_clobbers) != 0)
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          switch (pattern26 (x3))
            {
            case 0:
              if (!
#line 4658 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              *pnum_clobbers = 1;
              return 274; /* *ashlsi3_dot */

            case 1:
              if (!(
#line 4658 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 275; /* *ashldi3_dot */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (GET_MODE (x4) != E_DImode
              || GET_MODE (x3) != E_DImode)
            return -1;
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (!reg_or_mem_operand (operands[1], E_SImode)
              || !u6bit_cint_operand (operands[2], E_DImode)
              || !
#line 4732 "../../gcc/config/rs6000/rs6000.md"
(TARGET_EXTSWSLI))
            return -1;
          *pnum_clobbers = 1;
          return 279; /* ashdi3_extswsli_dot */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern27 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 4847 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 1;
          return 284; /* *lshrsi3_dot */

        case 1:
          if (!(
#line 4847 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 285; /* *lshrdi3_dot */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern27 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 4918 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 2;
          return 291; /* *ashrsi3_dot */

        case 1:
          if (!(
#line 4918 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 2;
          return 292; /* *ashrdi3_dot */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x3;
      x7 = XEXP (x1, 0);
      operands[0] = x7;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_CCFPmode:
          if (!cc_reg_operand (operands[0], E_CCFPmode)
              || GET_MODE (x2) != E_CCFPmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!gpc_reg_operand (operands[1], E_SFmode)
                  || !gpc_reg_operand (operands[2], E_SFmode)
                  || !
#line 5221 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 315; /* *cmpsf_fpr */

            case E_DFmode:
              if (!gpc_reg_operand (operands[1], E_DFmode)
                  || !gpc_reg_operand (operands[2], E_DFmode)
                  || !
#line 5221 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 316; /* *cmpdf_fpr */

            case E_IFmode:
              if (!gpc_reg_operand (operands[1], E_IFmode)
                  || !gpc_reg_operand (operands[2], E_IFmode))
                return -1;
              if ((
#line 12704 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
                return 804; /* *cmpif_internal1 */
              if (pnum_clobbers == NULL)
                return -1;
              if ((
#line 12723 "../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
                {
                  *pnum_clobbers = 9;
                  return 806; /* *cmpif_internal2 */
                }
              if (!(
#line 12723 "../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                return -1;
              *pnum_clobbers = 9;
              return 807; /* *cmpif_internal2 */

            case E_TFmode:
              if (gpc_reg_operand (operands[1], E_TFmode)
                  && gpc_reg_operand (operands[2], E_TFmode))
                {
                  if ((
#line 12704 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
                    return 805; /* *cmptf_internal1 */
                  if (pnum_clobbers != NULL)
                    {
                      if ((
#line 12723 "../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
                        {
                          *pnum_clobbers = 9;
                          return 808; /* *cmptf_internal2 */
                        }
                      if ((
#line 12723 "../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                        {
                          *pnum_clobbers = 9;
                          return 809; /* *cmptf_internal2 */
                        }
                    }
                }
              if (!altivec_register_operand (operands[1], E_TFmode)
                  || !altivec_register_operand (operands[2], E_TFmode)
                  || !(
#line 15603 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1092; /* *cmptf_hw */

            case E_KFmode:
              if (!altivec_register_operand (operands[1], E_KFmode)
                  || !altivec_register_operand (operands[2], E_KFmode)
                  || !(
#line 15603 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1091; /* *cmpkf_hw */

            case E_DDmode:
              if (!gpc_reg_operand (operands[1], E_DDmode)
                  || !gpc_reg_operand (operands[2], E_DDmode)
                  || !
#line 209 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
                return -1;
              return 2287; /* *cmpdd_internal1 */

            case E_TDmode:
              if (!gpc_reg_operand (operands[1], E_TDmode)
                  || !gpc_reg_operand (operands[2], E_TDmode)
                  || !
#line 209 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
                return -1;
              return 2288; /* *cmptd_internal1 */

            default:
              return -1;
            }

        case E_CCmode:
          if (!cc_reg_operand (operands[0], E_CCmode))
            return -1;
          switch (pattern302 (x2, 
E_CCmode))
            {
            case 0:
              return 800; /* *cmpsi_signed */

            case 1:
              if (!
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 801; /* *cmpdi_signed */

            default:
              return -1;
            }

        case E_CCUNSmode:
          if (!cc_reg_operand (operands[0], E_CCUNSmode))
            return -1;
          switch (pattern127 (x2, 
E_CCUNSmode))
            {
            case 0:
              return 802; /* *cmpsi_unsigned */

            case 1:
              if (!
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 803; /* *cmpdi_unsigned */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNLE:
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x1, 0);
      operands[0] = x7;
      if (!cc_reg_operand (operands[0], E_CCEQmode)
          || GET_MODE (x2) != E_CCEQmode)
        return -1;
      operands[1] = x3;
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      if (!cc_reg_operand (operands[2], E_VOIDmode))
        return -1;
      switch (GET_CODE (operands[1]))
        {
        case EQ:
        case GT:
        case LT:
        case GTU:
        case LTU:
        case UNORDERED:
          x8 = XEXP (x2, 1);
          if (x8 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (branch_positive_comparison_operator (operands[1], E_SImode))
                    return 890; /* cceq_rev_compare_si */
                  break;

                case E_DImode:
                  if (branch_positive_comparison_operator (operands[1], E_DImode)
                      && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    return 891; /* cceq_rev_compare_di */
                  break;

                default:
                  break;
                }
            }
          break;

        default:
          break;
        }
      x8 = XEXP (x2, 1);
      if (!branch_comparison_operator (x8, E_VOIDmode))
        return -1;
      operands[3] = x8;
      x9 = XEXP (x8, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !branch_comparison_operator (operands[1], E_VOIDmode))
        return -1;
      x10 = XEXP (x8, 0);
      operands[4] = x10;
      if (!cc_reg_operand (operands[4], E_VOIDmode))
        return -1;
      return 892; /* *rs6000.md:13454 */

    case UNSPEC:
      return recog_2 (x1, insn, pnum_clobbers);

    case MEM:
      if (pnum_clobbers == NULL)
        return -1;
      operands[1] = x3;
      x7 = XEXP (x1, 0);
      operands[2] = x7;
      x8 = XEXP (x2, 1);
      operands[3] = x8;
      switch (GET_MODE (operands[2]))
        {
        case E_CCmode:
          if (!cc_reg_operand (operands[2], E_CCmode)
              || GET_MODE (x2) != E_CCmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!non_update_memory_operand (operands[1], E_DImode)
                  || !const_m1_to_1_operand (operands[3], E_DImode)
                  || !
#line 28 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2352; /* *ld_cmpdi_cr0_DI_clobber_CC_none */

            case E_SImode:
              if (!non_update_memory_operand (operands[1], E_SImode)
                  || !const_m1_to_1_operand (operands[3], E_SImode)
                  || !
#line 112 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2356; /* *lwz_cmpwi_cr0_SI_clobber_CC_none */

            case E_HImode:
              if (!non_update_memory_operand (operands[1], E_HImode)
                  || !const_m1_to_1_operand (operands[3], E_HImode))
                return -1;
              if (
#line 239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                {
                  *pnum_clobbers = 1;
                  return 2362; /* *lha_cmpdi_cr0_HI_clobber_CC_sign */
                }
              if (!(
#line 239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2363; /* *lha_cmpdi_cr0_HI_clobber_CC_sign */

            default:
              return -1;
            }

        case E_CCUNSmode:
          if (!cc_reg_operand (operands[2], E_CCUNSmode)
              || GET_MODE (x2) != E_CCUNSmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!non_update_memory_operand (operands[1], E_DImode)
                  || !const_0_to_1_operand (operands[3], E_DImode)
                  || !
#line 49 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2353; /* *ld_cmpldi_cr0_DI_clobber_CCUNS_none */

            case E_SImode:
              if (!non_update_memory_operand (operands[1], E_SImode)
                  || !const_0_to_1_operand (operands[3], E_SImode)
                  || !
#line 133 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2357; /* *lwz_cmpldi_cr0_SI_clobber_CCUNS_none */

            case E_HImode:
              if (!non_update_memory_operand (operands[1], E_HImode)
                  || !const_0_to_1_operand (operands[3], E_HImode))
                return -1;
              if (
#line 260 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                {
                  *pnum_clobbers = 1;
                  return 2364; /* *lhz_cmpldi_cr0_HI_clobber_CCUNS_zero */
                }
              if (!(
#line 260 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2365; /* *lhz_cmpldi_cr0_HI_clobber_CCUNS_zero */

            case E_QImode:
              if (!non_update_memory_operand (operands[1], E_QImode)
                  || !const_0_to_1_operand (operands[3], E_QImode))
                return -1;
              if (
#line 323 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                {
                  *pnum_clobbers = 1;
                  return 2370; /* *lbz_cmpldi_cr0_QI_clobber_CCUNS_zero */
                }
              if (!(
#line 323 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2371; /* *lbz_cmpldi_cr0_QI_clobber_CCUNS_zero */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_129 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      res = recog_113 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case VEC_DUPLICATE:
      res = recog_114 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (vsx_register_operand (operands[0], E_V8HImode)
          && xxspltib_constant_nosplit (operands[1], E_V8HImode)
          && 
#line 1156 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return 1172; /* xxspltib_v8hi_nosplit */
      if (altivec_register_operand (operands[0], E_V8HImode)
          && xxspltib_constant_split (operands[1], E_V8HImode)
          && 
#line 1174 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return 1175; /* *xxspltib_v8hi_split */
      if (nonimmediate_operand (operands[0], E_V8HImode)
          && input_operand (operands[1], E_V8HImode))
        {
          if (
#line 1258 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V8HImode)
   && (register_operand (operands[0], V8HImode) 
       || register_operand (operands[1], V8HImode))))
            return 1180; /* vsx_movv8hi_64bit */
          if (
#line 1312 "../../gcc/config/rs6000/vsx.md"
(!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V8HImode)
   && (register_operand (operands[0], V8HImode) 
       || register_operand (operands[1], V8HImode))))
            return 1190; /* *vsx_movv8hi_32bit */
          if (
#line 245 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (V8HImode)
   && (register_operand (operands[0], V8HImode) 
       || register_operand (operands[1], V8HImode))))
            return 1675; /* *altivec_movv8hi */
        }
      break;

    case E_V4SImode:
      if (vsx_register_operand (operands[0], E_V4SImode)
          && xxspltib_constant_nosplit (operands[1], E_V4SImode)
          && 
#line 1156 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return 1173; /* xxspltib_v4si_nosplit */
      if (altivec_register_operand (operands[0], E_V4SImode)
          && xxspltib_constant_split (operands[1], E_V4SImode)
          && 
#line 1174 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return 1176; /* *xxspltib_v4si_split */
      if (nonimmediate_operand (operands[0], E_V4SImode)
          && input_operand (operands[1], E_V4SImode))
        {
          if (
#line 1258 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V4SImode)
   && (register_operand (operands[0], V4SImode) 
       || register_operand (operands[1], V4SImode))))
            return 1181; /* vsx_movv4si_64bit */
          if (
#line 1312 "../../gcc/config/rs6000/vsx.md"
(!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V4SImode)
   && (register_operand (operands[0], V4SImode) 
       || register_operand (operands[1], V4SImode))))
            return 1191; /* *vsx_movv4si_32bit */
        }
      break;

    case E_V2DImode:
      if (vsx_register_operand (operands[0], E_V2DImode)
          && xxspltib_constant_nosplit (operands[1], E_V2DImode)
          && 
#line 1156 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return 1174; /* xxspltib_v2di_nosplit */
      if (altivec_register_operand (operands[0], E_V2DImode))
        {
          if (xxspltib_constant_split (operands[1], E_V2DImode)
              && 
#line 1174 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return 1177; /* *xxspltib_v2di_split */
          if (vspltisw_vupkhsw_constant_split (operands[1], E_V2DImode)
              && 
#line 1213 "../../gcc/config/rs6000/vsx.md"
(TARGET_P8_VECTOR && vspltisw_vupkhsw_constant_split (operands[1], V2DImode)))
            return 1178; /* *vspltisw_v2di_split */
        }
      if (nonimmediate_operand (operands[0], E_V2DImode)
          && input_operand (operands[1], E_V2DImode))
        {
          if (
#line 1258 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DImode)
   && (register_operand (operands[0], V2DImode) 
       || register_operand (operands[1], V2DImode))))
            return 1182; /* vsx_movv2di_64bit */
          if (
#line 1312 "../../gcc/config/rs6000/vsx.md"
(!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DImode)
   && (register_operand (operands[0], V2DImode) 
       || register_operand (operands[1], V2DImode))))
            return 1192; /* *vsx_movv2di_32bit */
          if (
#line 245 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (V2DImode)
   && (register_operand (operands[0], V2DImode) 
       || register_operand (operands[1], V2DImode))))
            return 1679; /* *altivec_movv2di */
        }
      break;

    default:
      break;
    }
  operands[0] = x2;
  if (GET_CODE (x3) == MEM)
    {
      x4 = XEXP (x3, 0);
      switch (pattern30 (x4))
        {
        case 0:
          switch (GET_MODE (x3))
            {
            case E_V8HImode:
              if (register_operand (operands[0], E_V8HImode)
                  && (
#line 3218 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return 2104; /* altivec_stvx_v8hi_2op_di */
              break;

            case E_V2DImode:
              if (register_operand (operands[0], E_V2DImode)
                  && (
#line 3218 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return 2108; /* altivec_stvx_v2di_2op_di */
              break;

            default:
              break;
            }
          break;

        case 1:
          switch (GET_MODE (x3))
            {
            case E_V8HImode:
              if (register_operand (operands[0], E_V8HImode)
                  && (
#line 3226 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return 2113; /* altivec_stvx_v8hi_1op_di */
              break;

            case E_V2DImode:
              if (register_operand (operands[0], E_V2DImode)
                  && (
#line 3226 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return 2117; /* altivec_stvx_v2di_1op_di */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
    }
  operands[0] = x3;
  switch (GET_CODE (x2))
    {
    case VEC_DUPLICATE:
      res = recog_115 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MEM:
      x5 = XEXP (x2, 0);
      switch (pattern68 (x5))
        {
        case 0:
          switch (pattern418 (x2))
            {
            case 0:
              if ((
#line 3162 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return 2077; /* altivec_lvx_v8hi_2op_di */
              break;

            case 1:
              if ((
#line 3162 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return 2081; /* altivec_lvx_v2di_2op_di */
              break;

            default:
              break;
            }
          break;

        case 1:
          switch (pattern418 (x2))
            {
            case 0:
              if ((
#line 3170 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return 2086; /* altivec_lvx_v8hi_1op_di */
              break;

            case 1:
              if ((
#line 3170 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return 2090; /* altivec_lvx_v2di_1op_di */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  if (pnum_clobbers != NULL
      && memory_operand (operands[0], E_V4SImode))
    {
      operands[1] = x2;
      if (immediate_operand (operands[1], E_V4SImode)
          && 
#line 3458 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN
   && VECTOR_MEM_VSX_P (V4SImode)
   && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], V4SImode)
   && const_vec_duplicate_p (operands[1])))
        {
          *pnum_clobbers = 1;
          return 1376; /* vsx_stxvd2x4_le_const_v4si */
        }
    }
  if (nonimmediate_operand (operands[0], E_V4SImode))
    {
      operands[1] = x2;
      if (input_operand (operands[1], E_V4SImode)
          && 
#line 245 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (V4SImode)
   && (register_operand (operands[0], V4SImode) 
       || register_operand (operands[1], V4SImode))))
        return 1674; /* *altivec_movv4si */
    }
  operands[0] = x2;
  switch (pattern31 (x3, 
E_V4SImode))
    {
    case 0:
      if ((
#line 3218 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return 2103; /* altivec_stvx_v4si_2op_di */
      break;

    case 1:
      if ((
#line 3226 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return 2112; /* altivec_stvx_v4si_1op_di */
      break;

    default:
      break;
    }
  if (GET_CODE (x2) != MEM)
    return -1;
  switch (pattern33 (x1, 
E_V4SImode))
    {
    case 0:
      if (!(
#line 3162 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return -1;
      return 2076; /* altivec_lvx_v4si_2op_di */

    case 1:
      if (!(
#line 3170 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return -1;
      return 2085; /* altivec_lvx_v4si_1op_di */

    default:
      return -1;
    }
}

 int
recog_142 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_CODE (operands[2]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern19 (x3, 
E_SImode) != 0)
            return -1;
          return 179; /* *divsi3 */

        case E_DImode:
          if (pattern19 (x3, 
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 180; /* *divdi3 */

        case E_TImode:
          if (pattern1 (x3, 
E_TImode) != 0
              || !
#line 3441 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_POWERPC64))
            return -1;
          return 187; /* divti3 */

        case E_SFmode:
          if (pattern19 (x3, 
E_SFmode) != 0
              || !
#line 5123 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 307; /* *divsf3_fpr */

        case E_DFmode:
          if (pattern19 (x3, 
E_DFmode) != 0
              || !
#line 5123 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 308; /* *divdf3_fpr */

        case E_KFmode:
          if (pattern1 (x3, 
E_KFmode) != 0
              || !(
#line 15050 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 987; /* divkf3 */

        case E_TFmode:
          if (pattern1 (x3, 
E_TFmode) != 0
              || !(
#line 15050 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 988; /* divtf3 */

        case E_V4SFmode:
          if (pattern2 (x3, 
E_V4SFmode) != 0
              || !
#line 1773 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1229; /* *vsx_divv4sf3 */

        case E_V2DFmode:
          if (pattern2 (x3, 
E_V2DFmode) != 0
              || !
#line 1773 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1230; /* *vsx_divv2df3 */

        case E_V2DImode:
          if (pattern2 (x3, 
E_V2DImode) != 0
              || !
#line 6516 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1647; /* divv2di3 */

        case E_V4SImode:
          if (pattern2 (x3, 
E_V4SImode) != 0
              || !
#line 6516 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1648; /* divv4si3 */

        case E_DDmode:
          if (pattern19 (x3, 
E_DDmode) != 0
              || !
#line 201 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2285; /* divdd3 */

        case E_TDmode:
          if (pattern19 (x3, 
E_TDmode) != 0
              || !
#line 201 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2286; /* divtd3 */

        default:
          return -1;
        }

    case CONST_INT:
      if (pnum_clobbers == NULL)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern311 (x3, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 181; /* divsi3_sra */

        case E_DImode:
          if (pattern311 (x3, 
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 182; /* divdi3_sra */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_150 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XINT (x3, 1))
    {
    case 87:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!nonimmediate_operand (operands[0], E_SImode))
        return -1;
      x6 = XVECEXP (x3, 0, 0);
      operands[1] = x6;
      if (!input_operand (operands[1], E_SFmode))
        return -1;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!scratch_operand (operands[2], E_V4SFmode)
          || !
#line 7832 "../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG
   && (register_operand (operands[0], SImode)
       || register_operand (operands[1], SFmode))))
        return -1;
      return 558; /* movsi_from_sf */

    case 86:
      if (GET_MODE (x3) != E_SFmode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!scratch_operand (operands[2], E_DImode))
        return -1;
      if (nonimmediate_operand (operands[0], E_SFmode))
        {
          x6 = XVECEXP (x3, 0, 0);
          operands[1] = x6;
          if (input_operand (operands[1], E_SImode)
              && 
#line 8385 "../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG
   && (register_operand (operands[0], SFmode)
       || register_operand (operands[1], SImode))))
            return 575; /* movsf_from_si */
        }
      x6 = XVECEXP (x3, 0, 0);
      if (!lowpart_subreg_operator (x6, E_SImode))
        return -1;
      switch (pattern469 (x6))
        {
        case 0:
          if (!
#line 8452 "../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG))
            return -1;
          return 576; /* movsf_from_si2_ashiftrt */

        case 1:
          if (!
#line 8452 "../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG))
            return -1;
          return 577; /* movsf_from_si2_lshiftrt */

        default:
          return -1;
        }

    case 30:
      if (GET_MODE (x3) != E_DFmode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!gpc_reg_operand (operands[0], E_DFmode))
        return -1;
      x6 = XVECEXP (x3, 0, 0);
      operands[1] = x6;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!gpc_reg_operand (operands[2], E_DFmode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_IFmode:
          if (!gpc_reg_operand (operands[1], E_IFmode)
              || !(
#line 9049 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT) && 
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
            return -1;
          return 608; /* fix_trunc_helperif */

        case E_TFmode:
          if (!gpc_reg_operand (operands[1], E_TFmode)
              || !(
#line 9049 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT) && 
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
            return -1;
          return 609; /* fix_trunc_helpertf */

        default:
          return -1;
        }

    case 61:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x6 = XVECEXP (x3, 0, 0);
      operands[1] = x6;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern445 (x3, 
E_DImode, 
E_IFmode) != 0
              || !
#line 9589 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE))
            return -1;
          return 637; /* reload_fpr_from_gprdi */

        case E_DFmode:
          if (pattern445 (x3, 
E_DFmode, 
E_IFmode) != 0
              || !
#line 9589 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE))
            return -1;
          return 638; /* reload_fpr_from_gprdf */

        case E_DDmode:
          if (pattern445 (x3, 
E_DDmode, 
E_IFmode) != 0
              || !
#line 9589 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE))
            return -1;
          return 639; /* reload_fpr_from_gprdd */

        case E_TImode:
          if (pattern445 (x3, 
E_TImode, 
E_IFmode) != 0
              || !
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 651; /* reload_vsx_from_gprti */

        case E_V16QImode:
          if (pattern445 (x3, 
E_V16QImode, 
E_IFmode) != 0
              || !
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 652; /* reload_vsx_from_gprv16qi */

        case E_V8HImode:
          if (pattern445 (x3, 
E_V8HImode, 
E_IFmode) != 0
              || !
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 653; /* reload_vsx_from_gprv8hi */

        case E_V4SImode:
          if (pattern445 (x3, 
E_V4SImode, 
E_IFmode) != 0
              || !
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 654; /* reload_vsx_from_gprv4si */

        case E_V4SFmode:
          if (pattern445 (x3, 
E_V4SFmode, 
E_IFmode) != 0
              || !
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 655; /* reload_vsx_from_gprv4sf */

        case E_V2DImode:
          if (pattern445 (x3, 
E_V2DImode, 
E_IFmode) != 0
              || !
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 656; /* reload_vsx_from_gprv2di */

        case E_V2DFmode:
          if (pattern445 (x3, 
E_V2DFmode, 
E_IFmode) != 0
              || !
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 657; /* reload_vsx_from_gprv2df */

        case E_V1TImode:
          if (pattern445 (x3, 
E_V1TImode, 
E_IFmode) != 0
              || !
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 658; /* reload_vsx_from_gprv1ti */

        case E_KFmode:
          if (pattern445 (x3, 
E_KFmode, 
E_IFmode) != 0
              || !(
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 560 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 659; /* reload_vsx_from_gprkf */

        case E_TFmode:
          if (pattern445 (x3, 
E_TFmode, 
E_IFmode) != 0
              || !(
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 561 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 660; /* reload_vsx_from_gprtf */

        case E_SFmode:
          if (pattern445 (x3, 
E_SFmode, 
E_DImode) != 0
              || !
#line 9688 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 662; /* reload_vsx_from_gprsf */

        default:
          return -1;
        }

    case 64:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x6 = XVECEXP (x3, 0, 0);
      operands[1] = x6;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (pattern446 (x3, 
E_TImode) != 0
              || !
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 673; /* reload_gpr_from_vsxti */

        case E_V16QImode:
          if (pattern446 (x3, 
E_V16QImode) != 0
              || !
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 674; /* reload_gpr_from_vsxv16qi */

        case E_V8HImode:
          if (pattern446 (x3, 
E_V8HImode) != 0
              || !
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 675; /* reload_gpr_from_vsxv8hi */

        case E_V4SImode:
          if (pattern446 (x3, 
E_V4SImode) != 0
              || !
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 676; /* reload_gpr_from_vsxv4si */

        case E_V4SFmode:
          if (pattern446 (x3, 
E_V4SFmode) != 0
              || !
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 677; /* reload_gpr_from_vsxv4sf */

        case E_V2DImode:
          if (pattern446 (x3, 
E_V2DImode) != 0
              || !
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 678; /* reload_gpr_from_vsxv2di */

        case E_V2DFmode:
          if (pattern446 (x3, 
E_V2DFmode) != 0
              || !
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 679; /* reload_gpr_from_vsxv2df */

        case E_V1TImode:
          if (pattern446 (x3, 
E_V1TImode) != 0
              || !
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 680; /* reload_gpr_from_vsxv1ti */

        case E_KFmode:
          if (pattern446 (x3, 
E_KFmode) != 0
              || !(
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 560 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 681; /* reload_gpr_from_vsxkf */

        case E_TFmode:
          if (pattern446 (x3, 
E_TFmode) != 0
              || !(
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 561 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 682; /* reload_gpr_from_vsxtf */

        case E_SFmode:
          if (pattern445 (x3, 
E_SFmode, 
E_V4SFmode) != 0
              || !
#line 9752 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 683; /* reload_gpr_from_vsxsf */

        default:
          return -1;
        }

    case 2:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XVECEXP (x3, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (pattern331 (x4, 
E_DImode, 
2, 
USE) != 0)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!gpc_reg_operand (operands[0], E_DImode)
          || !
#line 11115 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2) && TARGET_64BIT))
        return -1;
      return 758; /* load_toc_aix_di */

    case 34:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x8 = XEXP (x4, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!memory_operand (operands[0], E_DImode))
        return -1;
      x6 = XVECEXP (x3, 0, 0);
      operands[1] = x6;
      if (!memory_operand (operands[1], E_DImode))
        return -1;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!scratch_operand (operands[2], E_DImode))
        return -1;
      return 798; /* stack_protect_setdi */

    case 101:
      if (GET_MODE (x3) != E_CCmode
          || pattern177 (x1, 
SET, 
E_CCmode) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x4, 0);
      operands[0] = x7;
      x6 = XVECEXP (x3, 0, 0);
      switch (GET_CODE (x6))
        {
        case EQ:
          switch (pattern490 (x1, 
EQ))
            {
            case 0:
              x8 = XEXP (x4, 1);
              if (GET_MODE (x8) != E_V4SFmode)
                return -1;
              if (vsx_register_operand (operands[1], E_V4SFmode)
                  && vsx_register_operand (operands[2], E_V4SFmode)
                  && vsx_register_operand (operands[0], E_V4SFmode)
                  && 
#line 2190 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
                return 1275; /* *vsx_eq_v4sf_p */
              if (!register_operand (operands[1], E_V4SFmode)
                  || !register_operand (operands[2], E_V4SFmode)
                  || !register_operand (operands[0], E_V4SFmode)
                  || !
#line 2893 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
                return -1;
              return 2036; /* *altivec_vcmpeqfp_p */

            case 1:
              x8 = XEXP (x4, 1);
              if (pattern549 (x8) != 0
                  || !
#line 2190 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
                return -1;
              return 1276; /* *vsx_eq_v2df_p */

            case 2:
              x8 = XEXP (x4, 1);
              if (pattern550 (x8, 
E_V4SImode) != 0
                  || !
#line 2809 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
                return -1;
              return 2021; /* altivec_vcmpequw_p */

            case 3:
              x8 = XEXP (x4, 1);
              if (pattern550 (x8, 
E_V8HImode) != 0
                  || !
#line 2809 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
                return -1;
              return 2022; /* altivec_vcmpequh_p */

            case 4:
              x8 = XEXP (x4, 1);
              if (pattern550 (x8, 
E_V16QImode) != 0
                  || !
#line 2809 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
                return -1;
              return 2023; /* altivec_vcmpequb_p */

            case 5:
              x8 = XEXP (x4, 1);
              if (pattern550 (x8, 
E_V2DImode) != 0
                  || !
#line 2809 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
                return -1;
              return 2024; /* altivec_vcmpequd_p */

            case 6:
              if (!altivec_register_operand (operands[1], E_V1TImode)
                  || !altivec_register_operand (operands[2], E_V1TImode)
                  || !altivec_register_operand (operands[0], E_V1TImode))
                return -1;
              x8 = XEXP (x4, 1);
              if (GET_MODE (x8) != E_V1TImode
                  || !
#line 2821 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
                return -1;
              return 2025; /* altivec_vcmpequt_p */

            default:
              return -1;
            }

        case GT:
          switch (pattern490 (x1, 
GT))
            {
            case 0:
              x8 = XEXP (x4, 1);
              if (GET_MODE (x8) != E_V4SFmode)
                return -1;
              if (vsx_register_operand (operands[1], E_V4SFmode)
                  && vsx_register_operand (operands[2], E_V4SFmode)
                  && vsx_register_operand (operands[0], E_V4SFmode)
                  && 
#line 2203 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
                return 1277; /* *vsx_gt_v4sf_p */
              if (!register_operand (operands[1], E_V4SFmode)
                  || !register_operand (operands[2], E_V4SFmode)
                  || !register_operand (operands[0], E_V4SFmode)
                  || !
#line 2905 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
                return -1;
              return 2037; /* *altivec_vcmpgtfp_p */

            case 1:
              x8 = XEXP (x4, 1);
              if (pattern549 (x8) != 0
                  || !
#line 2203 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
                return -1;
              return 1278; /* *vsx_gt_v2df_p */

            case 2:
              x8 = XEXP (x4, 1);
              if (pattern550 (x8, 
E_V4SImode) != 0
                  || !
#line 2845 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
                return -1;
              return 2026; /* *altivec_vcmpgtsw_p */

            case 3:
              x8 = XEXP (x4, 1);
              if (pattern550 (x8, 
E_V8HImode) != 0
                  || !
#line 2845 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
                return -1;
              return 2027; /* *altivec_vcmpgtsh_p */

            case 4:
              x8 = XEXP (x4, 1);
              if (pattern550 (x8, 
E_V16QImode) != 0
                  || !
#line 2845 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
                return -1;
              return 2028; /* *altivec_vcmpgtsb_p */

            case 5:
              x8 = XEXP (x4, 1);
              if (pattern550 (x8, 
E_V2DImode) != 0
                  || !
#line 2845 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
                return -1;
              return 2029; /* *altivec_vcmpgtsd_p */

            case 6:
              x8 = XEXP (x4, 1);
              if (pattern550 (x8, 
E_V1TImode) != 0
                  || !
#line 2857 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
                return -1;
              return 2030; /* *altivec_vcmpgtst_p */

            default:
              return -1;
            }

        case GE:
          if (pattern491 (x1, 
GE) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SFmode:
              x8 = XEXP (x4, 1);
              if (GET_MODE (x8) != E_V4SFmode)
                return -1;
              if (vsx_register_operand (operands[1], E_V4SFmode)
                  && vsx_register_operand (operands[2], E_V4SFmode)
                  && vsx_register_operand (operands[0], E_V4SFmode)
                  && 
#line 2255 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
                return 1280; /* *vsx_ge_v4sf_p */
              if (!register_operand (operands[1], E_V4SFmode)
                  || !register_operand (operands[2], E_V4SFmode)
                  || !register_operand (operands[0], E_V4SFmode)
                  || !
#line 2917 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
                return -1;
              return 2038; /* *altivec_vcmpgefp_p */

            case E_V2DFmode:
              x8 = XEXP (x4, 1);
              if (pattern549 (x8) != 0
                  || !
#line 2255 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
                return -1;
              return 1281; /* *vsx_ge_v2df_p */

            default:
              return -1;
            }

        case NE:
          if (pattern491 (x1, 
NE) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16QImode:
              x8 = XEXP (x4, 1);
              if (pattern551 (x8, 
E_V16QImode) != 0
                  || !
#line 5517 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1580; /* *vsx_ne_v16qi_p */

            case E_V8HImode:
              x8 = XEXP (x4, 1);
              if (pattern551 (x8, 
E_V8HImode) != 0
                  || !
#line 5517 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1581; /* *vsx_ne_v8hi_p */

            case E_V4SImode:
              x8 = XEXP (x4, 1);
              if (pattern551 (x8, 
E_V4SImode) != 0
                  || !
#line 5517 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1582; /* *vsx_ne_v4si_p */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x6, 0) != 2
              || XINT (x6, 1) != 103)
            return -1;
          x8 = XEXP (x4, 1);
          if (GET_CODE (x8) != UNSPEC
              || XVECLEN (x8, 0) != 2
              || XINT (x8, 1) != 103)
            return -1;
          x9 = XVECEXP (x6, 0, 0);
          operands[1] = x9;
          x10 = XVECEXP (x6, 0, 1);
          operands[2] = x10;
          x11 = XVECEXP (x8, 0, 0);
          if (!rtx_equal_p (x11, operands[1]))
            return -1;
          x12 = XVECEXP (x8, 0, 1);
          if (!rtx_equal_p (x12, operands[2]))
            return -1;
          switch (GET_MODE (x6))
            {
            case E_V4SImode:
              if (pattern555 (x8, 
E_V4SImode) != 0
                  || !
#line 5532 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1583; /* *vector_nez_v4si_p */

            case E_V8HImode:
              if (pattern555 (x8, 
E_V8HImode) != 0
                  || !
#line 5532 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1584; /* *vector_nez_v8hi_p */

            case E_V16QImode:
              if (pattern555 (x8, 
E_V16QImode) != 0
                  || !
#line 5532 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1585; /* *vector_nez_v16qi_p */

            default:
              return -1;
            }

        case GTU:
          if (pattern491 (x1, 
GTU) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SImode:
              x8 = XEXP (x4, 1);
              if (pattern550 (x8, 
E_V4SImode) != 0
                  || !
#line 2869 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
                return -1;
              return 2031; /* *altivec_vcmpgtuw_p */

            case E_V8HImode:
              x8 = XEXP (x4, 1);
              if (pattern550 (x8, 
E_V8HImode) != 0
                  || !
#line 2869 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
                return -1;
              return 2032; /* *altivec_vcmpgtuh_p */

            case E_V16QImode:
              x8 = XEXP (x4, 1);
              if (pattern550 (x8, 
E_V16QImode) != 0
                  || !
#line 2869 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
                return -1;
              return 2033; /* *altivec_vcmpgtub_p */

            case E_V2DImode:
              x8 = XEXP (x4, 1);
              if (pattern550 (x8, 
E_V2DImode) != 0
                  || !
#line 2869 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
                return -1;
              return 2034; /* *altivec_vcmpgtud_p */

            case E_V1TImode:
              x8 = XEXP (x4, 1);
              if (pattern550 (x8, 
E_V1TImode) != 0
                  || !
#line 2881 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
                return -1;
              return 2035; /* *altivec_vcmpgtut_p */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 356:
      switch (pattern227 (x1))
        {
        case 0:
          if (!
#line 937 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1803; /* vstrir_p_direct_v8hi */

        case 1:
          if (!
#line 937 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1804; /* vstrir_p_direct_v16qi */

        default:
          return -1;
        }

    case 357:
      switch (pattern227 (x1))
        {
        case 0:
          if (!
#line 989 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1807; /* vstril_p_direct_v8hi */

        case 1:
          if (!
#line 989 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1808; /* vstril_p_direct_v16qi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_170 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      switch (XINT (x3, 1))
        {
        case 12:
          if (GET_MODE (x3) != E_DFmode)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != USE)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          if (!gpc_reg_operand (operands[0], E_DFmode))
            return -1;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (!gpc_reg_operand (operands[1], E_DFmode)
              || !
#line 6542 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC))
            return -1;
          return 452; /* rs6000_mffscdrn */

        case 2:
          if (GET_MODE (x3) != E_CCmode)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != SET)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          if (!cc_reg_operand (operands[0], E_CCmode))
            return -1;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          x8 = XEXP (x5, 1);
          operands[2] = x8;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!memory_operand (operands[1], E_QImode)
                  || !int_reg_operand (operands[2], E_QImode)
                  || !
#line 273 "../../gcc/config/rs6000/sync.md"
(TARGET_SYNC_HI_QI))
                return -1;
              return 1119; /* store_conditionalqi */

            case E_HImode:
              if (!memory_operand (operands[1], E_HImode)
                  || !int_reg_operand (operands[2], E_HImode)
                  || !
#line 274 "../../gcc/config/rs6000/sync.md"
(TARGET_SYNC_HI_QI))
                return -1;
              return 1120; /* store_conditionalhi */

            case E_SImode:
              if (!memory_operand (operands[1], E_SImode)
                  || !int_reg_operand (operands[2], E_SImode))
                return -1;
              return 1121; /* store_conditionalsi */

            case E_DImode:
              if (!memory_operand (operands[1], E_DImode)
                  || !int_reg_operand (operands[2], E_DImode)
                  || !
#line 276 "../../gcc/config/rs6000/sync.md"
(TARGET_POWERPC64))
                return -1;
              return 1122; /* store_conditionaldi */

            case E_PTImode:
              if (!indexed_or_indirect_operand (operands[1], E_PTImode)
                  || !quad_int_reg_operand (operands[2], E_PTImode)
                  || !
#line 398 "../../gcc/config/rs6000/sync.md"
(TARGET_SYNC_TI && quad_int_reg_operand (operands[2], PTImode)))
                return -1;
              return 1123; /* store_conditionalpti */

            default:
              return -1;
            }

        case 28:
          if (pattern251 (x1) != 0
              || !base_reg_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          x8 = XEXP (x5, 1);
          x9 = XVECEXP (x8, 0, 0);
          if (!rtx_equal_p (x9, operands[2])
              || !
#line 73 "../../gcc/config/rs6000/htm.md"
(TARGET_HTM))
            return -1;
          return 2336; /* *tabort */

        case 31:
          if (pattern252 (x1) != 0
              || !
#line 144 "../../gcc/config/rs6000/htm.md"
(TARGET_HTM))
            return -1;
          return 2341; /* *tbegin */

        case 32:
          if (pattern253 (x1) != 0
              || !
#line 163 "../../gcc/config/rs6000/htm.md"
(TARGET_HTM))
            return -1;
          return 2342; /* *tcheck */

        case 33:
          if (pattern252 (x1) != 0
              || !
#line 184 "../../gcc/config/rs6000/htm.md"
(TARGET_HTM))
            return -1;
          return 2343; /* *tend */

        case 34:
          if (pattern253 (x1) != 0
              || !
#line 203 "../../gcc/config/rs6000/htm.md"
(TARGET_HTM))
            return -1;
          return 2344; /* *trechkpt */

        case 35:
          if (pattern251 (x1) != 0
              || !gpc_reg_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          x8 = XEXP (x5, 1);
          x9 = XVECEXP (x8, 0, 0);
          if (!rtx_equal_p (x9, operands[2])
              || !
#line 224 "../../gcc/config/rs6000/htm.md"
(TARGET_HTM))
            return -1;
          return 2345; /* *treclaim */

        case 36:
          if (pattern252 (x1) != 0
              || !
#line 245 "../../gcc/config/rs6000/htm.md"
(TARGET_HTM))
            return -1;
          return 2346; /* *tsr */

        case 37:
          if (pattern253 (x1) != 0
              || !
#line 264 "../../gcc/config/rs6000/htm.md"
(TARGET_HTM))
            return -1;
          return 2347; /* *ttest */

        default:
          return -1;
        }

    case 3:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern188 (x5, 
440, 
1) != 0)
        return -1;
      x8 = XEXP (x5, 1);
      if (GET_MODE (x8) != E_BLKmode)
        return -1;
      x6 = XEXP (x2, 0);
      operands[3] = x6;
      if (!cc_reg_operand (operands[3], E_CCmode)
          || GET_MODE (x3) != E_CCmode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[0] = x4;
      if (!u5bit_cint_operand (operands[0], E_VOIDmode))
        return -1;
      x10 = XVECEXP (x3, 0, 1);
      operands[1] = x10;
      x11 = XVECEXP (x3, 0, 2);
      operands[2] = x11;
      x7 = XEXP (x5, 0);
      operands[4] = x7;
      x9 = XVECEXP (x8, 0, 0);
      if (!rtx_equal_p (x9, operands[4]))
        return -1;
      switch (XINT (x3, 1))
        {
        case 29:
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!gpc_reg_operand (operands[1], E_SImode)
                  || !gpc_reg_operand (operands[2], E_SImode)
                  || !
#line 98 "../../gcc/config/rs6000/htm.md"
(TARGET_HTM))
                return -1;
              return 2337; /* *tabortwc */

            case E_DImode:
              if (!gpc_reg_operand (operands[1], E_DImode)
                  || !gpc_reg_operand (operands[2], E_DImode)
                  || !(
#line 98 "../../gcc/config/rs6000/htm.md"
(TARGET_HTM) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2338; /* *tabortdc */

            default:
              return -1;
            }

        case 30:
          if (!s5bit_cint_operand (operands[2], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!gpc_reg_operand (operands[1], E_SImode)
                  || !
#line 123 "../../gcc/config/rs6000/htm.md"
(TARGET_HTM))
                return -1;
              return 2339; /* *tabortwci */

            case E_DImode:
              if (!gpc_reg_operand (operands[1], E_DImode)
                  || !(
#line 123 "../../gcc/config/rs6000/htm.md"
(TARGET_HTM) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2340; /* *tabortdci */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_174 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      res = recog_160 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MEM:
      res = recog_161 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  switch (XINT (x4, 1))
    {
    case 278:
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || !memory_operand (operands[1], E_V4SImode)
              || !
#line 3096 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2054; /* altivec_lvewx */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || !memory_operand (operands[1], E_V8HImode)
              || !
#line 3096 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2055; /* altivec_lvehx */

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || !memory_operand (operands[1], E_V16QImode)
              || !
#line 3096 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2056; /* altivec_lvebx */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || !memory_operand (operands[1], E_V4SFmode)
              || !
#line 3105 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2057; /* *altivec_lvesfx */

        default:
          return -1;
        }

    case 282:
      switch (pattern427 ())
        {
        case 0:
          if (!
#line 3114 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2058; /* altivec_lvxl_v4si */

        case 1:
          if (!
#line 3114 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2059; /* altivec_lvxl_v8hi */

        case 2:
          if (!
#line 3114 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2060; /* altivec_lvxl_v16qi */

        case 3:
          if (!
#line 3114 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2061; /* altivec_lvxl_v4sf */

        case 4:
          if (!
#line 3114 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2062; /* altivec_lvxl_v2df */

        case 5:
          if (!
#line 3114 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2063; /* altivec_lvxl_v2di */

        case 6:
          if (!
#line 3114 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2064; /* altivec_lvxl_v1ti */

        case 7:
          if (!(
#line 3114 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 211 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2065; /* altivec_lvxl_kf */

        case 8:
          if (!(
#line 3114 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 212 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2066; /* altivec_lvxl_tf */

        default:
          return -1;
        }

    case 284:
      switch (pattern427 ())
        {
        case 0:
          if (!
#line 3126 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2067; /* altivec_lvx_v4si_internal */

        case 1:
          if (!
#line 3126 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2068; /* altivec_lvx_v8hi_internal */

        case 2:
          if (!
#line 3126 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2069; /* altivec_lvx_v16qi_internal */

        case 3:
          if (!
#line 3126 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2070; /* altivec_lvx_v4sf_internal */

        case 4:
          if (!
#line 3126 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2071; /* altivec_lvx_v2df_internal */

        case 5:
          if (!
#line 3126 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2072; /* altivec_lvx_v2di_internal */

        case 6:
          if (!
#line 3126 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2073; /* altivec_lvx_v1ti_internal */

        case 7:
          if (!(
#line 3126 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 211 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2074; /* altivec_lvx_kf_internal */

        case 8:
          if (!(
#line 3126 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 212 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2075; /* altivec_lvx_tf_internal */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_183 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case FLOAT:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          switch (pattern297 (x1))
            {
            case 0:
              if (!
#line 6217 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 406; /* *floatqisf2_internal */

            case 1:
              if (!
#line 6217 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 407; /* *floathisf2_internal */

            case 2:
              if (!
#line 6217 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 408; /* *floatqidf2_internal */

            case 3:
              if (!
#line 6217 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 409; /* *floathidf2_internal */

            default:
              return -1;
            }

        case CALL:
          x7 = XEXP (x3, 0);
          if (GET_CODE (x7) != MEM
              || GET_MODE (x7) != E_SImode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != USE)
            return -1;
          x8 = XEXP (x2, 0);
          operands[0] = x8;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          x10 = XEXP (x3, 1);
          operands[2] = x10;
          if (!unspec_tls (operands[2], E_DImode))
            return -1;
          x11 = XEXP (x4, 0);
          operands[3] = x11;
          if (!immediate_operand (operands[3], E_SImode))
            return -1;
          switch (GET_CODE (operands[1]))
            {
            case SYMBOL_REF:
              if (!symbol_ref_operand (operands[1], E_DImode))
                return -1;
              x5 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x5) != USE)
                return -1;
              x6 = XVECEXP (x1, 0, 3);
              if (pattern474 (x6, 
96) != 0)
                return -1;
              x12 = XEXP (x5, 0);
              operands[4] = x12;
              if (!register_operand (operands[4], E_SImode)
                  || !(
#line 11662 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_V4
    && TARGET_SECURE_PLT && flag_pic && !SYMBOL_REF_LOCAL_P (operands[1])
    && (INTVAL (operands[3]) & CALL_LONG) == 0)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 776; /* *call_value_nonlocal_sysv_securedi */

            case UNSPEC:
            case REG:
              if (!indirect_call_operand (operands[1], E_DImode))
                return -1;
              switch (pattern475 (x1, pnum_clobbers))
                {
                case 0:
                  x5 = XVECEXP (x1, 0, 2);
                  x12 = XEXP (x5, 0);
                  operands[4] = x12;
                  if (!memory_operand (operands[4], E_DImode))
                    return -1;
                  x6 = XVECEXP (x1, 0, 3);
                  x13 = XEXP (x6, 1);
                  x14 = XVECEXP (x13, 0, 0);
                  operands[5] = x14;
                  if (!const_int_operand (operands[5], E_DImode)
                      || !(
#line 11749 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 780; /* *call_value_indirect_aixdi */

                case 1:
                  x5 = XVECEXP (x1, 0, 2);
                  x15 = XEXP (x5, 1);
                  x16 = XVECEXP (x15, 0, 0);
                  operands[4] = x16;
                  if (!const_int_operand (operands[4], E_DImode)
                      || !(
#line 11806 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 784; /* *call_value_indirect_elfv2di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case EQ:
          switch (pattern111 (x1))
            {
            case 0:
              if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 812; /* eqsisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 832; /* eqsidi2_isel */

            case 2:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 822; /* eqdisi2_isel */

            case 3:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 842; /* eqdidi2_isel */

            default:
              return -1;
            }

        case NE:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          x8 = XEXP (x2, 0);
          operands[0] = x8;
          x7 = XEXP (x3, 0);
          operands[1] = x7;
          x10 = XEXP (x3, 1);
          operands[2] = x10;
          x11 = XEXP (x4, 0);
          operands[3] = x11;
          x12 = XEXP (x5, 0);
          operands[4] = x12;
          x17 = XEXP (x6, 0);
          operands[5] = x17;
          switch (pattern506 (x3))
            {
            case 0:
              if (
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return 813; /* nesisi2_isel */
              break;

            case 1:
              if ((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return 833; /* nesidi2_isel */
              break;

            case 2:
              if (reg_or_short_operand (operands[2], E_SImode)
                  && scratch_operand (operands[3], E_DImode)
                  && scratch_operand (operands[4], E_DImode)
                  && scratch_operand (operands[5], E_CCmode)
                  && (
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return 823; /* nedisi2_isel */
              if (scc_eq_operand (operands[2], E_SImode)
                  && scratch_operand (operands[3], E_SImode)
                  && scratch_operand (operands[4], E_SImode)
                  && scratch_operand (operands[5], E_DImode)
                  && (
#line 13248 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_ISEL) && 
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return 862; /* *nesi3_extdi */
              break;

            case 3:
              if ((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return 843; /* nedidi2_isel */
              break;

            default:
              break;
            }
          if (!scratch_operand (operands[4], E_DImode)
              || pattern507 (x1) != 0
              || !(
#line 12993 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 854; /* *nedi3 */

        case LT:
          switch (pattern111 (x1))
            {
            case 0:
              if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 814; /* ltsisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 834; /* ltsidi2_isel */

            case 2:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 824; /* ltdisi2_isel */

            case 3:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 844; /* ltdidi2_isel */

            default:
              return -1;
            }

        case LTU:
          switch (pattern114 (x1))
            {
            case 0:
              if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 815; /* ltusisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 835; /* ltusidi2_isel */

            case 2:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 825; /* ltudisi2_isel */

            case 3:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 845; /* ltudidi2_isel */

            default:
              return -1;
            }

        case GT:
          switch (pattern111 (x1))
            {
            case 0:
              if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 816; /* gtsisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 836; /* gtsidi2_isel */

            case 2:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 826; /* gtdisi2_isel */

            case 3:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 846; /* gtdidi2_isel */

            default:
              return -1;
            }

        case GTU:
          switch (pattern114 (x1))
            {
            case 0:
              if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 817; /* gtusisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 837; /* gtusidi2_isel */

            case 2:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 827; /* gtudisi2_isel */

            case 3:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 847; /* gtudidi2_isel */

            default:
              return -1;
            }

        case LE:
          switch (pattern111 (x1))
            {
            case 0:
              if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 818; /* lesisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 838; /* lesidi2_isel */

            case 2:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 828; /* ledisi2_isel */

            case 3:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 848; /* ledidi2_isel */

            default:
              return -1;
            }

        case LEU:
          switch (pattern114 (x1))
            {
            case 0:
              if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 819; /* leusisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 839; /* leusidi2_isel */

            case 2:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 829; /* leudisi2_isel */

            case 3:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 849; /* leudidi2_isel */

            default:
              return -1;
            }

        case GE:
          switch (pattern111 (x1))
            {
            case 0:
              if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 820; /* gesisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 840; /* gesidi2_isel */

            case 2:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 830; /* gedisi2_isel */

            case 3:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 850; /* gedidi2_isel */

            default:
              return -1;
            }

        case GEU:
          switch (pattern114 (x1))
            {
            case 0:
              if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              return 821; /* geusisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 841; /* geusidi2_isel */

            case 2:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 831; /* geudisi2_isel */

            case 3:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 851; /* geudidi2_isel */

            default:
              return -1;
            }

        case NEG:
          if (pattern115 (x1) != 0)
            return -1;
          switch (pattern339 (x1))
            {
            case 0:
              if (!(
#line 13026 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 855; /* *neg_eq_di */

            case 1:
              if (!(
#line 13058 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 856; /* *neg_ne_di */

            default:
              return -1;
            }

        case PLUS:
          if (pattern115 (x1) != 0)
            return -1;
          switch (pattern340 (x1))
            {
            case 0:
              return 857; /* *plus_eq_di */

            case 1:
              return 858; /* *plus_ne_di */

            default:
              return -1;
            }

        case MINUS:
          if (pattern115 (x1) != 0)
            return -1;
          switch (pattern341 (x1))
            {
            case 0:
              return 859; /* *minus_eq_di */

            case 1:
              return 860; /* *minus_ne_di */

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          if (pattern116 (x1) != 0)
            return -1;
          x10 = XEXP (x3, 1);
          x18 = XEXP (x10, 0);
          operands[0] = x18;
          x4 = XVECEXP (x1, 0, 1);
          x11 = XEXP (x4, 0);
          operands[2] = x11;
          if (!nonimmediate_operand (operands[2], E_DImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          x12 = XEXP (x5, 0);
          operands[3] = x12;
          if (!scratch_operand (operands[3], E_CCmode))
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          x17 = XEXP (x6, 0);
          operands[4] = x17;
          if (!scratch_operand (operands[4], E_DImode))
            return -1;
          x7 = XEXP (x3, 0);
          switch (GET_CODE (x7))
            {
            case EQ:
              x19 = XEXP (x7, 1);
              if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x9 = XEXP (x7, 0);
              operands[1] = x9;
              if (!register_operand (operands[1], E_DImode))
                return -1;
              x20 = XEXP (x4, 1);
              x21 = XEXP (x20, 0);
              if (!rtx_equal_p (x21, operands[1]))
                return -1;
              return 903; /* bdz_di */

            case NE:
              x19 = XEXP (x7, 1);
              if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x9 = XEXP (x7, 0);
              operands[1] = x9;
              if (!register_operand (operands[1], E_DImode))
                return -1;
              x20 = XEXP (x4, 1);
              x21 = XEXP (x20, 0);
              if (!rtx_equal_p (x21, operands[1]))
                return -1;
              return 904; /* bdnz_di */

            default:
              return -1;
            }

        case VEC_SELECT:
          if (GET_MODE (x3) != E_SFmode)
            return -1;
          x10 = XEXP (x3, 1);
          if (GET_CODE (x10) != PARALLEL
              || XVECLEN (x10, 0) != 1)
            return -1;
          x22 = XVECEXP (x10, 0, 0);
          if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          switch (pattern459 (x1))
            {
            case 0:
              if (!
#line 5024 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)))
                return -1;
              return 1529; /* *vsx_reduc_plus_v4sf_scalar */

            case 1:
              if (!
#line 5024 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)))
                return -1;
              return 1530; /* *vsx_reduc_smin_v4sf_scalar */

            case 2:
              if (!
#line 5024 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)))
                return -1;
              return 1531; /* *vsx_reduc_smax_v4sf_scalar */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) != MEM)
        return -1;
      switch (pattern117 (x1))
        {
        case 0:
          if (!symbol_ref_operand (operands[0], E_DImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != USE)
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          if (pattern474 (x6, 
96) != 0)
            return -1;
          x12 = XEXP (x5, 0);
          operands[3] = x12;
          if (!register_operand (operands[3], E_SImode)
              || !(
#line 11588 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_V4
    && TARGET_SECURE_PLT && flag_pic && !SYMBOL_REF_LOCAL_P (operands[0])
    && (INTVAL (operands[2]) & CALL_LONG) == 0)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 773; /* *call_nonlocal_sysv_securedi */

        case 1:
          if (!indirect_call_operand (operands[0], E_DImode))
            return -1;
          switch (pattern475 (x1, pnum_clobbers))
            {
            case 0:
              x5 = XVECEXP (x1, 0, 2);
              x12 = XEXP (x5, 0);
              operands[3] = x12;
              if (!memory_operand (operands[3], E_DImode))
                return -1;
              x6 = XVECEXP (x1, 0, 3);
              x13 = XEXP (x6, 1);
              x14 = XVECEXP (x13, 0, 0);
              operands[4] = x14;
              if (!const_int_operand (operands[4], E_DImode)
                  || !(
#line 11728 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 779; /* *call_indirect_aixdi */

            case 1:
              x5 = XVECEXP (x1, 0, 2);
              x15 = XEXP (x5, 1);
              x16 = XVECEXP (x15, 0, 0);
              operands[3] = x16;
              if (!const_int_operand (operands[3], E_DImode)
                  || !(
#line 11770 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 781; /* *call_indirect_elfv2di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_17 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case XOR:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (GET_MODE (x3) != E_TImode
              || GET_MODE (x4) != E_TImode)
            return NULL;
          if (vlogical_operand (operands[0], E_TImode)
              && vlogical_operand (operands[1], E_TImode)
              && vlogical_operand (operands[2], E_TImode)
              && 
#line 7582 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], TImode)))
            return gen_split_270 (insn, operands);
          if (!int_reg_operand (operands[0], E_TImode)
              || !int_reg_operand (operands[1], E_TImode)
              || !int_reg_operand (operands[2], E_TImode)
              || !
#line 7611 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_P8_VECTOR))
            return NULL;
          return gen_split_279 (insn, operands);

        case E_PTImode:
          if (GET_MODE (x3) != E_PTImode
              || GET_MODE (x4) != E_PTImode)
            return NULL;
          if (vlogical_operand (operands[0], E_PTImode)
              && vlogical_operand (operands[1], E_PTImode)
              && vlogical_operand (operands[2], E_PTImode)
              && 
#line 7582 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], PTImode)))
            return gen_split_271 (insn, operands);
          if (!int_reg_operand (operands[0], E_PTImode)
              || !int_reg_operand (operands[1], E_PTImode)
              || !int_reg_operand (operands[2], E_PTImode)
              || !
#line 7611 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_P8_VECTOR))
            return NULL;
          return gen_split_280 (insn, operands);

        case E_V16QImode:
          if (pattern300 (x3, 
E_V16QImode) != 0
              || !(
#line 7582 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V16QImode)) && 
#line 778 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_272 (insn, operands);

        case E_V8HImode:
          if (pattern300 (x3, 
E_V8HImode) != 0
              || !(
#line 7582 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V8HImode)) && 
#line 779 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_273 (insn, operands);

        case E_V4SImode:
          if (pattern300 (x3, 
E_V4SImode) != 0
              || !(
#line 7582 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V4SImode)) && 
#line 780 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_274 (insn, operands);

        case E_V4SFmode:
          if (pattern300 (x3, 
E_V4SFmode) != 0
              || !(
#line 7582 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V4SFmode)) && 
#line 781 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_275 (insn, operands);

        case E_V2DImode:
          if (pattern300 (x3, 
E_V2DImode) != 0
              || !(
#line 7582 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V2DImode)) && 
#line 782 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_276 (insn, operands);

        case E_V2DFmode:
          if (pattern300 (x3, 
E_V2DFmode) != 0
              || !(
#line 7582 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V2DFmode)) && 
#line 783 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_277 (insn, operands);

        case E_V1TImode:
          if (pattern300 (x3, 
E_V1TImode) != 0
              || !(
#line 7582 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V1TImode)) && 
#line 784 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_278 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (!vlogical_operand (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode
              || !vlogical_operand (operands[1], E_TImode)
              || !
#line 7639 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], TImode)))
            return NULL;
          return gen_split_281 (insn, operands);

        case E_PTImode:
          if (!vlogical_operand (operands[0], E_PTImode)
              || GET_MODE (x3) != E_PTImode
              || !vlogical_operand (operands[1], E_PTImode)
              || !
#line 7639 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], PTImode)))
            return NULL;
          return gen_split_282 (insn, operands);

        case E_V16QImode:
          if (!vlogical_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !vlogical_operand (operands[1], E_V16QImode)
              || !(
#line 7639 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V16QImode)) && 
#line 778 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_283 (insn, operands);

        case E_V8HImode:
          if (!vlogical_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !vlogical_operand (operands[1], E_V8HImode)
              || !(
#line 7639 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V8HImode)) && 
#line 779 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_284 (insn, operands);

        case E_V4SImode:
          if (!vlogical_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !vlogical_operand (operands[1], E_V4SImode)
              || !(
#line 7639 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V4SImode)) && 
#line 780 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_285 (insn, operands);

        case E_V4SFmode:
          if (!vlogical_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !vlogical_operand (operands[1], E_V4SFmode)
              || !(
#line 7639 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V4SFmode)) && 
#line 781 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_286 (insn, operands);

        case E_V2DImode:
          if (!vlogical_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !vlogical_operand (operands[1], E_V2DImode)
              || !(
#line 7639 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V2DImode)) && 
#line 782 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_287 (insn, operands);

        case E_V2DFmode:
          if (!vlogical_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !vlogical_operand (operands[1], E_V2DFmode)
              || !(
#line 7639 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V2DFmode)) && 
#line 783 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_288 (insn, operands);

        case E_V1TImode:
          if (!vlogical_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !vlogical_operand (operands[1], E_V1TImode)
              || !(
#line 7639 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V1TImode)) && 
#line 784 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_289 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 4
      || !logical_const_operand (operands[1], E_SImode)
      || !register_operand (operands[0], E_SImode))
    return NULL;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XEXP (x2, 1);
  if (!boolean_or_operator (x3, E_SImode))
    return NULL;
  operands[3] = x3;
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  if (!logical_const_operand (operands[2], E_SImode))
    return NULL;
  x5 = XEXP (x3, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return NULL;
  x6 = XEXP (x2, 0);
  if (!rtx_equal_p (x6, operands[0]))
    return NULL;
  x7 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x7) != SET)
    return NULL;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != COMPARE
      || GET_MODE (x8) != E_CCmode)
    return NULL;
  x9 = XEXP (x7, 0);
  operands[4] = x9;
  if (!cc_reg_operand (operands[4], E_CCmode))
    return NULL;
  x10 = XEXP (x8, 0);
  operands[5] = x10;
  if (!gpc_reg_operand (operands[5], E_SImode))
    return NULL;
  x11 = XEXP (x8, 1);
  if (!rtx_equal_p (x11, operands[0]))
    return NULL;
  x12 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x12) != SET)
    return NULL;
  x13 = XEXP (x12, 1);
  if (GET_CODE (x13) != IF_THEN_ELSE)
    return NULL;
  x14 = XEXP (x13, 0);
  if (!equality_operator (x14, E_VOIDmode))
    return NULL;
  operands[6] = x14;
  x15 = XEXP (x14, 1);
  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x16 = XEXP (x12, 0);
  if (GET_CODE (x16) != PC)
    return NULL;
  x17 = XEXP (x13, 1);
  operands[7] = x17;
  x18 = XEXP (x13, 2);
  operands[8] = x18;
  x19 = XEXP (x14, 0);
  if (!rtx_equal_p (x19, operands[4])
      || !
#line 12677 "../../gcc/config/rs6000/rs6000.md"
(peep2_reg_dead_p (3, operands[0])
   && peep2_reg_dead_p (4, operands[4])
   && REGNO (operands[0]) != REGNO (operands[5])))
    return NULL;
  *pmatch_len_ = 3;
  return gen_peephole2_13 (insn, operands);
}
