/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  return pattern12 (x3); /* [-1, 3] */
}

int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern19 (x3, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern19 (x3, 
E_DFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern27 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[3] = x4;
  if (!cc_reg_operand (operands[3], E_CCmode)
      || GET_MODE (x2) != E_CCmode)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  return pattern26 (x5); /* [-1, 1] */
}

int
pattern32 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case PLUS:
      if (GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      operands[1] = x2;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x3 = XEXP (x1, 1);
      operands[2] = x3;
      if (!register_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      operands[1] = x1;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern43 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_SImode
      || !gpc_reg_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!gpc_reg_operand (operands[1], E_HImode))
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_HImode))
    return -1;
  return 0;
}

int
pattern53 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern51 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern51 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern52 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern52 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern52 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern52 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern52 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern52 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern52 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern52 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern52 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern52 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern66 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern74 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 1)
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  x7 = XVECEXP (x5, 0, 0);
  operands[2] = x7;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[1], E_V4SImode))
            return -1;
          return 0;

        case E_QImode:
          if (!gpc_reg_operand (operands[1], E_V16QImode)
              || !const_int_operand (operands[2], E_QImode)
              || !scratch_operand (operands[3], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!gpc_reg_operand (operands[1], E_V8HImode)
              || !const_int_operand (operands[2], E_QImode)
              || !scratch_operand (operands[3], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SFmode:
      res = pattern73 (x3, 
E_SFmode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_KFmode:
      res = pattern73 (x3, 
E_KFmode);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    case E_TFmode:
      res = pattern73 (x3, 
E_TFmode);
      if (res >= 0)
        return res + 9; /* [9, 11] */
      return -1;

    default:
      return -1;
    }
}

int
pattern93 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !logical_const_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern101 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!gpc_reg_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  x8 = XEXP (x4, 0);
  operands[2] = x8;
  if (!gpc_reg_operand (operands[2], E_DImode))
    return -1;
  x9 = XEXP (x5, 0);
  operands[3] = x9;
  if (!offsettable_mem_operand (operands[3], E_DImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern110 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XVECEXP (x1, 0, 2);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XVECEXP (x1, 0, 3);
  x12 = XEXP (x11, 0);
  operands[5] = x12;
  if (!scratch_operand (operands[5], E_CCmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern109 (x4, 
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern109 (x4, 
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern119 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = PATTERN (peep2_next_insn (1));
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  x10 = XEXP (x7, 1);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern118 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern118 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern133 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsx_register_operand (operands[1], i1)
      || !vsx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern137 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_KFmode:
      return pattern136 (x3, 
E_KFmode); /* [-1, 0] */

    case E_TFmode:
      if (pattern136 (x3, 
E_TFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern145 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      return pattern142 (x3, 
E_V4SFmode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern142 (x3, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern155 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!altivec_register_operand (operands[0], E_V2DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!altivec_register_operand (operands[1], E_V16QImode)
          || !altivec_register_operand (operands[2], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!altivec_register_operand (operands[1], E_V8HImode)
          || !altivec_register_operand (operands[2], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!altivec_register_operand (operands[1], E_V4SImode)
          || !altivec_register_operand (operands[2], E_V4SImode))
        return -1;
      return 2;

    case E_V2DImode:
      if (!altivec_register_operand (operands[1], E_V2DImode)
          || !altivec_register_operand (operands[2], E_V2DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern169 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  if (!cc_reg_operand (operands[2], E_CCmode)
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x8))
    {
    case CLOBBER:
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      switch (GET_MODE (x6))
        {
        case E_SImode:
          if (!scratch_operand (operands[0], E_SImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!gpc_reg_operand (operands[1], E_QImode))
                return -1;
              return 0;

            case E_HImode:
              if (!gpc_reg_operand (operands[1], E_HImode))
                return -1;
              return 1;

            default:
              return -1;
            }

        case E_DImode:
          if (!scratch_operand (operands[0], E_DImode))
            return -1;
          res = pattern168 ();
          if (res >= 0)
            return res + 2; /* [2, 4] */
          return -1;

        default:
          return -1;
        }

    case SET:
      x10 = XEXP (x8, 1);
      if (GET_CODE (x10) != i1)
        return -1;
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      x11 = XEXP (x10, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      switch (GET_MODE (x6))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x10) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!gpc_reg_operand (operands[1], E_QImode))
                return -1;
              return 5;

            case E_HImode:
              if (!gpc_reg_operand (operands[1], E_HImode))
                return -1;
              return 6;

            default:
              return -1;
            }

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x10) != E_DImode)
            return -1;
          res = pattern168 ();
          if (res >= 0)
            return res + 7; /* [7, 9] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern195 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  operands[3] = x5;
  if (!cc_reg_operand (operands[3], E_CCmode)
      || GET_MODE (x3) != E_CCmode)
    return -1;
  return pattern194 (x1, 
i1); /* [-1, 3] */
}

int
pattern203 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern213 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !gpc_reg_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !gpc_reg_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_KFmode:
      if (!altivec_register_operand (operands[0], E_KFmode)
          || GET_MODE (x1) != E_KFmode
          || !altivec_register_operand (operands[1], E_KFmode))
        return -1;
      return 2;

    case E_TFmode:
      if (!altivec_register_operand (operands[0], E_TFmode)
          || GET_MODE (x1) != E_TFmode
          || !altivec_register_operand (operands[1], E_TFmode))
        return -1;
      return 3;

    case E_V4SFmode:
      if (GET_MODE (x1) != E_V4SFmode)
        return -1;
      return 4;

    case E_V2DFmode:
      if (!vsx_register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || !vsx_register_operand (operands[1], E_V2DFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern229 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern233 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      operands[2] = x2;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          return pattern182 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern182 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern228 (x1, 
E_V4SImode) != 0)
            return -1;
          return 2;

        case E_V8HImode:
          if (pattern228 (x1, 
E_V8HImode) != 0)
            return -1;
          return 3;

        case E_V16QImode:
          if (pattern228 (x1, 
E_V16QImode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern228 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 5;

        case E_V2DFmode:
          if (pattern228 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 6;

        case E_V2DImode:
          if (pattern228 (x1, 
E_V2DImode) != 0)
            return -1;
          return 7;

        case E_V1TImode:
          if (pattern228 (x1, 
E_V1TImode) != 0)
            return -1;
          return 8;

        case E_TImode:
          if (pattern228 (x1, 
E_TImode) != 0)
            return -1;
          return 9;

        case E_KFmode:
          if (pattern228 (x1, 
E_KFmode) != 0)
            return -1;
          return 10;

        case E_TFmode:
          if (pattern228 (x1, 
E_TFmode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    case NOT:
      x3 = XEXP (x2, 0);
      operands[2] = x3;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          if (pattern230 (x1, 
E_SImode) != 0)
            return -1;
          return 12;

        case E_DImode:
          if (pattern230 (x1, 
E_DImode) != 0)
            return -1;
          return 13;

        case E_V4SImode:
          if (pattern232 (x1, 
E_V4SImode) != 0)
            return -1;
          return 14;

        case E_V8HImode:
          if (pattern232 (x1, 
E_V8HImode) != 0)
            return -1;
          return 15;

        case E_V16QImode:
          if (pattern232 (x1, 
E_V16QImode) != 0)
            return -1;
          return 16;

        case E_V4SFmode:
          if (pattern232 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 17;

        case E_V2DFmode:
          if (pattern232 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 18;

        case E_V2DImode:
          if (pattern232 (x1, 
E_V2DImode) != 0)
            return -1;
          return 19;

        case E_V1TImode:
          if (pattern232 (x1, 
E_V1TImode) != 0)
            return -1;
          return 20;

        case E_TImode:
          if (pattern232 (x1, 
E_TImode) != 0)
            return -1;
          return 21;

        case E_KFmode:
          if (pattern232 (x1, 
E_KFmode) != 0)
            return -1;
          return 22;

        case E_TFmode:
          if (pattern232 (x1, 
E_TFmode) != 0)
            return -1;
          return 23;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern269 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern276 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern282 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
      || !gpc_reg_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || GET_MODE (x2) != E_SImode)
    return -1;
  x5 = XEXP (x3, 0);
  if (!gpc_reg_operand (x5, E_SImode))
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != E_SImode
      || !gpc_reg_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern291 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[2], i1)
      || !altivec_register_operand (operands[3], i1)
      || !altivec_register_operand (operands[4], i1)
      || !altivec_register_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern299 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!nonimmediate_operand (operands[1], E_DFmode))
        return -1;
      return 0;

    case E_IFmode:
      if (!gpc_reg_operand (operands[1], E_IFmode))
        return -1;
      return 1;

    case E_KFmode:
      if (!gpc_reg_operand (operands[1], E_KFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern307 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !short_cint_operand (operands[2], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern314 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern322 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DImode
      || !gpc_reg_operand (operands[0], E_DImode)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern328 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsx_register_operand (operands[1], i1)
      || !vsx_register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !vsx_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern338 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case EQ:
      x2 = XEXP (x1, 0);
      operands[1] = x2;
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      x3 = XEXP (x1, 1);
      operands[2] = x3;
      if (!scc_eq_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case NE:
      x2 = XEXP (x1, 0);
      operands[1] = x2;
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      x3 = XEXP (x1, 1);
      operands[2] = x3;
      if (!scc_eq_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern345 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DImode
      || !gpc_reg_operand (operands[0], E_DImode)
      || !gpc_reg_operand (operands[1], E_DImode)
      || !rs6000_tls_symbol_ref (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern351 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !altivec_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern357 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern37 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern37 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern55 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern55 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern55 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern55 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern55 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern55 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern55 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern55 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern55 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern55 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern385 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern390 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XVECEXP (x4, 0, 0);
  operands[1] = x5;
  x6 = XVECEXP (x4, 0, 1);
  operands[2] = x6;
  if (!int_reg_operand (operands[2], E_DImode))
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  operands[3] = x7;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!scratch_operand (operands[4], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return 0;

    case E_SImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern398 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !gpc_reg_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !gpc_reg_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern404 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern412 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_1_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_TFmode:
      if (!register_operand (operands[1], E_TFmode))
        return -1;
      return 0;

    case E_IFmode:
      if (!register_operand (operands[1], E_IFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern419 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != MULT
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != i1
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XEXP (x9, 1);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
      || GET_MODE (x4) != E_SImode)
    return -1;
  x11 = XEXP (x5, 0);
  if (!gpc_reg_operand (x11, E_SImode))
    return -1;
  x12 = XEXP (x4, 1);
  if (GET_MODE (x12) != E_SImode)
    return -1;
  x13 = XEXP (x7, 0);
  operands[0] = x13;
  if (!gpc_reg_operand (operands[0], E_SImode))
    return -1;
  x14 = XEXP (x8, 1);
  if (GET_MODE (x14) != E_SImode)
    return -1;
  return 0;
}

int
pattern433 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern442 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !gpc_reg_operand (operands[1], i2)
      || !gpc_reg_operand (operands[2], i1)
      || !const_0_to_3_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern451 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != NOT)
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern450 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern450 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern462 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !reg_or_zero_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_CCmode:
      if (!cc_reg_operand (operands[4], E_CCmode))
        return -1;
      return 0;

    case E_CCUNSmode:
      if (!cc_reg_operand (operands[4], E_CCUNSmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern469 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  operands[3] = x1;
  if (!gpc_reg_operand (operands[0], E_SFmode))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  switch (GET_CODE (x2))
    {
    case ASHIFTRT:
      x3 = XEXP (x2, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!input_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case LSHIFTRT:
      x3 = XEXP (x2, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!input_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern482 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern490 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  x8 = XEXP (x4, 1);
  operands[2] = x8;
  x9 = XEXP (x6, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  x10 = XEXP (x6, 1);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SFmode:
      return 0;

    case E_V2DFmode:
      return 1;

    case E_V4SImode:
      return 2;

    case E_V8HImode:
      return 3;

    case E_V16QImode:
      return 4;

    case E_V2DImode:
      return 5;

    case E_V1TImode:
      return 6;

    default:
      return -1;
    }
}

int
pattern504 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern511 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!fpr_reg_operand (operands[1], E_XOmode)
      || !vsx_register_operand (operands[2], E_V16QImode)
      || !vsx_register_operand (operands[3], E_V16QImode)
      || !const_0_to_15_operand (operands[5], E_SImode))
    return -1;
  return 0;
}

int
pattern514 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern522 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern531 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!boolean_operator (operands[3], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern538 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !reg_or_short_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern542 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !reg_or_aligned_short_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern550 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern558 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != i1)
    return -1;
  x12 = XEXP (x11, 1);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x13 = XEXP (x6, 0);
  if (!gpc_reg_operand (x13, E_SImode))
    return -1;
  return 0;
}

 int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern308 (x2, 
E_SImode) != 0)
            return -1;
          return 233; /* *eqvsi3 */

        case E_DImode:
          if (pattern308 (x2, 
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 234; /* *eqvdi3 */

        case E_TImode:
          if (GET_MODE (x2) != E_TImode
              || GET_MODE (x3) != E_TImode)
            return -1;
          if (vlogical_operand (operands[0], E_TImode)
              && vlogical_operand (operands[1], E_TImode)
              && vlogical_operand (operands[2], E_TImode)
              && 
#line 7572 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR))
            return 536; /* *eqvti3_internal1 */
          if (!int_reg_operand (operands[0], E_TImode)
              || !int_reg_operand (operands[1], E_TImode)
              || !int_reg_operand (operands[2], E_TImode)
              || !
#line 7609 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_P8_VECTOR))
            return -1;
          return 545; /* *eqvti3_internal2 */

        case E_PTImode:
          if (GET_MODE (x2) != E_PTImode
              || GET_MODE (x3) != E_PTImode)
            return -1;
          if (vlogical_operand (operands[0], E_PTImode)
              && vlogical_operand (operands[1], E_PTImode)
              && vlogical_operand (operands[2], E_PTImode)
              && 
#line 7572 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR))
            return 537; /* *eqvpti3_internal1 */
          if (!int_reg_operand (operands[0], E_PTImode)
              || !int_reg_operand (operands[1], E_PTImode)
              || !int_reg_operand (operands[2], E_PTImode)
              || !
#line 7609 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_P8_VECTOR))
            return -1;
          return 546; /* *eqvpti3_internal2 */

        case E_V16QImode:
          if (pattern300 (x2, 
E_V16QImode) != 0
              || !(
#line 7572 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR) && 
#line 778 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return -1;
          return 538; /* *eqvv16qi3_internal1 */

        case E_V8HImode:
          if (pattern300 (x2, 
E_V8HImode) != 0
              || !(
#line 7572 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR) && 
#line 779 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return -1;
          return 539; /* *eqvv8hi3_internal1 */

        case E_V4SImode:
          if (pattern300 (x2, 
E_V4SImode) != 0
              || !(
#line 7572 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR) && 
#line 780 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return -1;
          return 540; /* *eqvv4si3_internal1 */

        case E_V4SFmode:
          if (pattern300 (x2, 
E_V4SFmode) != 0
              || !(
#line 7572 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR) && 
#line 781 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return -1;
          return 541; /* *eqvv4sf3_internal1 */

        case E_V2DImode:
          if (pattern300 (x2, 
E_V2DImode) != 0
              || !(
#line 7572 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR) && 
#line 782 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return -1;
          return 542; /* *eqvv2di3_internal1 */

        case E_V2DFmode:
          if (pattern300 (x2, 
E_V2DFmode) != 0
              || !(
#line 7572 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR) && 
#line 783 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return -1;
          return 543; /* *eqvv2df3_internal1 */

        case E_V1TImode:
          if (pattern300 (x2, 
E_V1TImode) != 0
              || !(
#line 7572 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR) && 
#line 784 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return -1;
          return 544; /* *eqvv1ti3_internal1 */

        default:
          return -1;
        }

    case AND:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          switch (pattern263 (x2))
            {
            case 0:
              if (!
#line 691 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2410; /* *fuse_and_eqv */

            case 1:
              if (!(
#line 691 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2411; /* *fuse_and_eqv */

            case 2:
              if (!
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2702; /* *fuse_vand_veqv */

            case 3:
              if (!
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2703; /* *fuse_vand_veqv */

            case 4:
              if (!
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2704; /* *fuse_vand_veqv */

            case 5:
              if (!
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2705; /* *fuse_vand_veqv */

            case 6:
              if (!
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2706; /* *fuse_vand_veqv */

            case 7:
              if (!
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2707; /* *fuse_vand_veqv */

            case 8:
              if (!
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2708; /* *fuse_vand_veqv */

            case 9:
              if (!
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2709; /* *fuse_vand_veqv */

            case 10:
              if (!(
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2710; /* *fuse_vand_veqv */

            case 11:
              if (!(
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2711; /* *fuse_vand_veqv */

            default:
              return -1;
            }

        case NOT:
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          x9 = XEXP (x5, 1);
          switch (GET_CODE (x9))
            {
            case REG:
            case SUBREG:
              switch (pattern402 (x2))
                {
                case 0:
                  if (!
#line 709 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2412; /* *fuse_andc_eqv */

                case 1:
                  if (!(
#line 709 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2413; /* *fuse_andc_eqv */

                case 2:
                  if (!
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2712; /* *fuse_vandc_veqv */

                case 3:
                  if (!
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2713; /* *fuse_vandc_veqv */

                case 4:
                  if (!
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2714; /* *fuse_vandc_veqv */

                case 5:
                  if (!
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2715; /* *fuse_vandc_veqv */

                case 6:
                  if (!
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2716; /* *fuse_vandc_veqv */

                case 7:
                  if (!
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2717; /* *fuse_vandc_veqv */

                case 8:
                  if (!
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2718; /* *fuse_vandc_veqv */

                case 9:
                  if (!
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2719; /* *fuse_vandc_veqv */

                case 10:
                  if (!(
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2720; /* *fuse_vandc_veqv */

                case 11:
                  if (!(
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2721; /* *fuse_vandc_veqv */

                default:
                  return -1;
                }

            case NOT:
              switch (pattern405 (x2))
                {
                case 0:
                  if (!
#line 763 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2418; /* *fuse_nor_eqv */

                case 1:
                  if (!(
#line 763 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2419; /* *fuse_nor_eqv */

                case 2:
                  if (!
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2742; /* *fuse_vnor_veqv */

                case 3:
                  if (!
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2743; /* *fuse_vnor_veqv */

                case 4:
                  if (!
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2744; /* *fuse_vnor_veqv */

                case 5:
                  if (!
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2745; /* *fuse_vnor_veqv */

                case 6:
                  if (!
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2746; /* *fuse_vnor_veqv */

                case 7:
                  if (!
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2747; /* *fuse_vnor_veqv */

                case 8:
                  if (!
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2748; /* *fuse_vnor_veqv */

                case 9:
                  if (!
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2749; /* *fuse_vnor_veqv */

                case 10:
                  if (!(
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2750; /* *fuse_vnor_veqv */

                case 11:
                  if (!(
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2751; /* *fuse_vnor_veqv */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      if (pnum_clobbers == NULL)
        return -1;
      x7 = XEXP (x5, 0);
      if (GET_CODE (x7) != XOR)
        return -1;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      x10 = XEXP (x7, 1);
      operands[1] = x10;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          if (pattern430 (x2, 
E_SImode) != 0
              || !
#line 727 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2414; /* *fuse_eqv_eqv */

        case E_DImode:
          if (pattern430 (x2, 
E_DImode) != 0
              || !(
#line 727 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2415; /* *fuse_eqv_eqv */

        case E_V4SImode:
          if (pattern431 (x2, 
E_V4SImode) != 0
              || !
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2722; /* *fuse_veqv_veqv */

        case E_V8HImode:
          if (pattern431 (x2, 
E_V8HImode) != 0
              || !
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2723; /* *fuse_veqv_veqv */

        case E_V16QImode:
          if (pattern431 (x2, 
E_V16QImode) != 0
              || !
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2724; /* *fuse_veqv_veqv */

        case E_V4SFmode:
          if (pattern431 (x2, 
E_V4SFmode) != 0
              || !
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2725; /* *fuse_veqv_veqv */

        case E_V2DFmode:
          if (pattern431 (x2, 
E_V2DFmode) != 0
              || !
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2726; /* *fuse_veqv_veqv */

        case E_V2DImode:
          if (pattern431 (x2, 
E_V2DImode) != 0
              || !
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2727; /* *fuse_veqv_veqv */

        case E_V1TImode:
          if (pattern431 (x2, 
E_V1TImode) != 0
              || !
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2728; /* *fuse_veqv_veqv */

        case E_TImode:
          if (pattern431 (x2, 
E_TImode) != 0
              || !
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2729; /* *fuse_veqv_veqv */

        case E_KFmode:
          if (pattern431 (x2, 
E_KFmode) != 0
              || !(
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2730; /* *fuse_veqv_veqv */

        case E_TFmode:
          if (pattern431 (x2, 
E_TFmode) != 0
              || !(
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2731; /* *fuse_veqv_veqv */

        default:
          return -1;
        }

    case IOR:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case NOT:
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          x9 = XEXP (x5, 1);
          switch (GET_CODE (x9))
            {
            case NOT:
              switch (pattern405 (x2))
                {
                case 0:
                  if (!
#line 745 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2416; /* *fuse_nand_eqv */

                case 1:
                  if (!(
#line 745 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2417; /* *fuse_nand_eqv */

                case 2:
                  if (!
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2732; /* *fuse_vnand_veqv */

                case 3:
                  if (!
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2733; /* *fuse_vnand_veqv */

                case 4:
                  if (!
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2734; /* *fuse_vnand_veqv */

                case 5:
                  if (!
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2735; /* *fuse_vnand_veqv */

                case 6:
                  if (!
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2736; /* *fuse_vnand_veqv */

                case 7:
                  if (!
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2737; /* *fuse_vnand_veqv */

                case 8:
                  if (!
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2738; /* *fuse_vnand_veqv */

                case 9:
                  if (!
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2739; /* *fuse_vnand_veqv */

                case 10:
                  if (!(
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2740; /* *fuse_vnand_veqv */

                case 11:
                  if (!(
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2741; /* *fuse_vnand_veqv */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              switch (pattern402 (x2))
                {
                case 0:
                  if (!
#line 799 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2422; /* *fuse_orc_eqv */

                case 1:
                  if (!(
#line 799 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2423; /* *fuse_orc_eqv */

                case 2:
                  if (!
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2762; /* *fuse_vorc_veqv */

                case 3:
                  if (!
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2763; /* *fuse_vorc_veqv */

                case 4:
                  if (!
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2764; /* *fuse_vorc_veqv */

                case 5:
                  if (!
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2765; /* *fuse_vorc_veqv */

                case 6:
                  if (!
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2766; /* *fuse_vorc_veqv */

                case 7:
                  if (!
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2767; /* *fuse_vorc_veqv */

                case 8:
                  if (!
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2768; /* *fuse_vorc_veqv */

                case 9:
                  if (!
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2769; /* *fuse_vorc_veqv */

                case 10:
                  if (!(
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2770; /* *fuse_vorc_veqv */

                case 11:
                  if (!(
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2771; /* *fuse_vorc_veqv */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern263 (x2))
            {
            case 0:
              if (!
#line 781 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2420; /* *fuse_or_eqv */

            case 1:
              if (!(
#line 781 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2421; /* *fuse_or_eqv */

            case 2:
              if (!
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2752; /* *fuse_vor_veqv */

            case 3:
              if (!
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2753; /* *fuse_vor_veqv */

            case 4:
              if (!
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2754; /* *fuse_vor_veqv */

            case 5:
              if (!
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2755; /* *fuse_vor_veqv */

            case 6:
              if (!
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2756; /* *fuse_vor_veqv */

            case 7:
              if (!
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2757; /* *fuse_vor_veqv */

            case 8:
              if (!
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2758; /* *fuse_vor_veqv */

            case 9:
              if (!
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2759; /* *fuse_vor_veqv */

            case 10:
              if (!(
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2760; /* *fuse_vor_veqv */

            case 11:
              if (!(
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2761; /* *fuse_vor_veqv */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case XOR:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      switch (pattern263 (x2))
        {
        case 0:
          if (!
#line 817 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2424; /* *fuse_xor_eqv */

        case 1:
          if (!(
#line 817 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2425; /* *fuse_xor_eqv */

        case 2:
          if (!
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2772; /* *fuse_vxor_veqv */

        case 3:
          if (!
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2773; /* *fuse_vxor_veqv */

        case 4:
          if (!
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2774; /* *fuse_vxor_veqv */

        case 5:
          if (!
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2775; /* *fuse_vxor_veqv */

        case 6:
          if (!
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2776; /* *fuse_vxor_veqv */

        case 7:
          if (!
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2777; /* *fuse_vxor_veqv */

        case 8:
          if (!
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2778; /* *fuse_vxor_veqv */

        case 9:
          if (!
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2779; /* *fuse_vxor_veqv */

        case 10:
          if (!(
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2780; /* *fuse_vxor_veqv */

        case 11:
          if (!(
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2781; /* *fuse_vxor_veqv */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_36 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !const_0_to_15_operand (operands[2], E_QImode)
          || !
#line 2348 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1945; /* altivec_vspltb_direct */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !const_0_to_7_operand (operands[2], E_QImode)
          || !
#line 2386 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1947; /* altivec_vsplth_direct */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !const_0_to_3_operand (operands[2], E_QImode)
          || !
#line 2424 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1949; /* altivec_vspltw_direct */

    default:
      return -1;
    }
}

 int
recog_39 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_TFmode:
      if (pattern147 (x3, 
E_DFmode, 
E_TFmode) != 0)
        return -1;
      if ((
#line 14940 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TFmode) && TARGET_HARD_FLOAT) && 
#line 543 "../../gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)))
        return 973; /* packtf_hard */
      if (!(
#line 14964 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TFmode) && TARGET_SOFT_FLOAT) && 
#line 543 "../../gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)))
        return -1;
      return 976; /* packtf_soft */

    case E_IFmode:
      if (pattern147 (x3, 
E_DFmode, 
E_IFmode) != 0
          || !(
#line 14940 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (IFmode) && TARGET_HARD_FLOAT) && 
#line 544 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
        return -1;
      return 974; /* packif_hard */

    case E_TDmode:
      if (pattern147 (x3, 
E_DImode, 
E_TDmode) != 0
          || !(
#line 14940 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TDmode) && TARGET_HARD_FLOAT) && 
#line 545 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)))
        return -1;
      return 975; /* packtd_hard */

    case E_V1TImode:
      if (pattern147 (x3, 
E_DImode, 
E_V1TImode) != 0
          || !
#line 15007 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX))
        return -1;
      return 979; /* packv1ti */

    case E_KFmode:
      if (pattern147 (x3, 
E_DImode, 
E_KFmode) != 0
          || !
#line 15007 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX))
        return -1;
      return 980; /* packkf */

    default:
      return -1;
    }
}

 int
recog_48 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!nonimmediate_operand (operands[0], E_DFmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  switch (pattern412 ())
    {
    case 0:
      if ((
#line 14881 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (TFmode)) && 
#line 543 "../../gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)))
        return 967; /* unpacktf_dm */
      if (!(
#line 14904 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (TFmode)) && 
#line 543 "../../gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)))
        return -1;
      return 970; /* unpacktf_nodm */

    case 1:
      if ((
#line 14881 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (IFmode)) && 
#line 544 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
        return 968; /* unpackif_dm */
      if (!(
#line 14904 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (IFmode)) && 
#line 544 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
        return -1;
      return 971; /* unpackif_nodm */

    default:
      return -1;
    }
}

 int
recog_60 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || !gpc_reg_operand (operands[1], E_SImode)
          || !
#line 2547 "../../gcc/config/rs6000/rs6000.md"
(TARGET_CMPB && TARGET_POPCNTB))
        return -1;
      return 130; /* paritysi2_cmpb */

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode
          || !gpc_reg_operand (operands[1], E_DImode)
          || !(
#line 2547 "../../gcc/config/rs6000/rs6000.md"
(TARGET_CMPB && TARGET_POPCNTB) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
        return -1;
      return 131; /* paritydi2_cmpb */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x2) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 4410 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2161; /* rs6000_vprtybv8hi2 */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x2) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 4410 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2162; /* rs6000_vprtybv4si2 */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 4410 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2163; /* rs6000_vprtybv2di2 */

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || GET_MODE (x2) != E_V1TImode
          || !register_operand (operands[1], E_V1TImode)
          || !
#line 4410 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2164; /* rs6000_vprtybv1ti2 */

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || GET_MODE (x2) != E_TImode
          || !register_operand (operands[1], E_TImode)
          || !
#line 4410 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2165; /* rs6000_vprtybti2 */

    default:
      return -1;
    }
}

 int
recog_73 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode
      || !gpc_reg_operand (operands[0], E_DImode))
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[1]))
    {
    case E_KFmode:
      if (gpc_reg_operand (operands[1], E_KFmode)
          && (
#line 5356 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 660 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))))
        return 320; /* signbitkf2_dm */
      if (!memory_operand (operands[1], E_KFmode)
          || !(
#line 5375 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 660 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))))
        return -1;
      return 322; /* signbitkf2_dm_mem */

    case E_TFmode:
      if (gpc_reg_operand (operands[1], E_TFmode)
          && (
#line 5356 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 661 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))))
        return 321; /* signbittf2_dm */
      if (!memory_operand (operands[1], E_TFmode)
          || !(
#line 5375 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 661 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))))
        return -1;
      return 323; /* signbittf2_dm_mem */

    default:
      return -1;
    }
}

 int
recog_80 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCFPmode
      || !cc_reg_operand (operands[0], E_CCFPmode))
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!vsx_register_operand (operands[1], E_DFmode)
          || !
#line 2065 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (DFmode)))
        return -1;
      return 1258; /* *vsx_tsqrtdf2_internal */

    case E_V4SFmode:
      if (!vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 2065 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1259; /* *vsx_tsqrtv4sf2_internal */

    case E_V2DFmode:
      if (!vsx_register_operand (operands[1], E_V2DFmode)
          || !
#line 2065 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1260; /* *vsx_tsqrtv2df2_internal */

    default:
      return -1;
    }
}

 int
recog_94 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern441 (x3, 
E_QImode, 
E_V16QImode) != 0
              || !const_0_to_15_operand (operands[3], E_QImode)
              || !
#line 4592 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_P9_VECTOR && TARGET_POWERPC64))
            return -1;
          return 1488; /* vsx_set_v16qi_p9 */

        case E_V8HImode:
          if (pattern441 (x3, 
E_HImode, 
E_V8HImode) != 0
              || !const_0_to_7_operand (operands[3], E_QImode)
              || !
#line 4592 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_P9_VECTOR && TARGET_POWERPC64))
            return -1;
          return 1489; /* vsx_set_v8hi_p9 */

        case E_V4SImode:
          if (pattern442 (x3, 
E_SImode, 
E_V4SImode) != 0
              || !
#line 4592 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_P9_VECTOR && TARGET_POWERPC64))
            return -1;
          return 1490; /* vsx_set_v4si_p9 */

        case E_V4SFmode:
          if (pnum_clobbers == NULL
              || pattern442 (x3, 
E_SFmode, 
E_V4SFmode) != 0
              || !
#line 4616 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_P9_VECTOR && TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 1491; /* vsx_set_v4sf_p9 */

        default:
          return -1;
        }

    case CONST_DOUBLE:
      if (pnum_clobbers == NULL)
        return -1;
      operands[2] = x5;
      if (!zero_fp_constant (operands[2], E_SFmode)
          || !gpc_reg_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !gpc_reg_operand (operands[1], E_V4SFmode))
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!const_0_to_3_operand (operands[3], E_QImode)
          || !
#line 4652 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_P9_VECTOR && TARGET_POWERPC64))
        return -1;
      *pnum_clobbers = 1;
      return 1492; /* *vsx_set_v4sf_p9_zero */

    case VEC_SELECT:
      if (GET_MODE (x5) != E_SFmode)
        return -1;
      x7 = XEXP (x5, 1);
      if (GET_CODE (x7) != PARALLEL
          || XVECLEN (x7, 0) != 1
          || !gpc_reg_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !gpc_reg_operand (operands[1], E_V4SFmode))
        return -1;
      x8 = XEXP (x5, 0);
      operands[2] = x8;
      if (!gpc_reg_operand (operands[2], E_V4SFmode))
        return -1;
      x9 = XVECEXP (x7, 0, 0);
      operands[3] = x9;
      if (!const_0_to_3_operand (operands[3], E_QImode))
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      operands[4] = x6;
      if (!const_0_to_3_operand (operands[4], E_QImode))
        return -1;
      if (
#line 4683 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_P9_VECTOR && TARGET_POWERPC64
   && (INTVAL (operands[3]) == (BYTES_BIG_ENDIAN ? 1 : 2))))
        return 1493; /* *vsx_insert_extract_v4sf_p9 */
      if (pnum_clobbers == NULL
          || !
#line 4712 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && VECTOR_MEM_VSX_P (V4SImode)
   && TARGET_P9_VECTOR && TARGET_POWERPC64
   && (INTVAL (operands[3]) != (BYTES_BIG_ENDIAN ? 1 : 2))))
        return -1;
      *pnum_clobbers = 1;
      return 1494; /* *vsx_insert_extract_v4sf_p9_2 */

    default:
      return -1;
    }
}

 int
recog_111 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LABEL_REF:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) == PC)
        {
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          return 893; /* jump */
        }
      break;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case SYMBOL_REF:
      res = recog_110 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (nonimmediate_operand (operands[0], E_SFmode)
          && input_operand (operands[1], E_SFmode))
        {
          if (
#line 8257 "../../gcc/config/rs6000/rs6000.md"
((register_operand (operands[0], SFmode)
   || register_operand (operands[1], SFmode))
   && TARGET_HARD_FLOAT
   && (TARGET_ALLOW_SF_SUBREG
       || valid_sf_si_move (operands[0], operands[1], SFmode))))
            return 571; /* movsf_hardfloat */
          if (
#line 8335 "../../gcc/config/rs6000/rs6000.md"
((gpc_reg_operand (operands[0], SFmode)
   || gpc_reg_operand (operands[1], SFmode))
   && TARGET_SOFT_FLOAT))
            return 573; /* *movsf_softfloat */
        }
      break;

    case E_SDmode:
      if (nonimmediate_operand (operands[0], E_SDmode)
          && input_operand (operands[1], E_SDmode))
        {
          if (
#line 8302 "../../gcc/config/rs6000/rs6000.md"
((register_operand (operands[0], SDmode)
   || register_operand (operands[1], SDmode))
   && TARGET_HARD_FLOAT))
            return 572; /* movsd_hardfloat */
          if (
#line 8335 "../../gcc/config/rs6000/rs6000.md"
((gpc_reg_operand (operands[0], SDmode)
   || gpc_reg_operand (operands[1], SDmode))
   && TARGET_SOFT_FLOAT))
            return 574; /* *movsd_softfloat */
        }
      break;

    case E_DFmode:
      if (nonimmediate_operand (operands[0], E_DFmode)
          && input_operand (operands[1], E_DFmode))
        {
          if (
#line 8575 "../../gcc/config/rs6000/rs6000.md"
(! TARGET_POWERPC64 && TARGET_HARD_FLOAT
   && (gpc_reg_operand (operands[0], DFmode)
       || gpc_reg_operand (operands[1], DFmode))))
            return 578; /* *movdf_hardfloat32 */
          if (
#line 8620 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64
   && (gpc_reg_operand (operands[0], DFmode)
       || gpc_reg_operand (operands[1], DFmode))))
            return 580; /* *movdf_softfloat32 */
          if (
#line 8649 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_HARD_FLOAT
   && (gpc_reg_operand (operands[0], DFmode)
       || gpc_reg_operand (operands[1], DFmode))))
            return 582; /* *movdf_hardfloat64 */
          if (
#line 8701 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_SOFT_FLOAT
   && (gpc_reg_operand (operands[0], DFmode)
       || gpc_reg_operand (operands[1], DFmode))))
            return 584; /* *movdf_softfloat64 */
        }
      break;

    case E_DDmode:
      if (nonimmediate_operand (operands[0], E_DDmode)
          && input_operand (operands[1], E_DDmode))
        {
          if (
#line 8575 "../../gcc/config/rs6000/rs6000.md"
(! TARGET_POWERPC64 && TARGET_HARD_FLOAT
   && (gpc_reg_operand (operands[0], DDmode)
       || gpc_reg_operand (operands[1], DDmode))))
            return 579; /* *movdd_hardfloat32 */
          if (
#line 8620 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64
   && (gpc_reg_operand (operands[0], DDmode)
       || gpc_reg_operand (operands[1], DDmode))))
            return 581; /* *movdd_softfloat32 */
          if (
#line 8649 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_HARD_FLOAT
   && (gpc_reg_operand (operands[0], DDmode)
       || gpc_reg_operand (operands[1], DDmode))))
            return 583; /* *movdd_hardfloat64 */
          if (
#line 8701 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_SOFT_FLOAT
   && (gpc_reg_operand (operands[0], DDmode)
       || gpc_reg_operand (operands[1], DDmode))))
            return 585; /* *movdd_softfloat64 */
        }
      break;

    case E_TFmode:
      if (nonimmediate_operand (operands[0], E_TFmode)
          && input_operand (operands[1], E_TFmode))
        {
          if ((
#line 8807 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_POWERPC64 && FLOAT128_2REG_P (TFmode)
   && (TFmode != TDmode || WORDS_BIG_ENDIAN)
   && (gpc_reg_operand (operands[0], TFmode)
       || gpc_reg_operand (operands[1], TFmode))) && 
#line 547 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TFmode))))
            return 590; /* *movtf_64bit_dm */
          if ((
#line 8843 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && !TARGET_POWERPC64
   && (FLOAT128_2REG_P (TFmode)
       || int_reg_operand_not_pseudo (operands[0], TFmode)
       || int_reg_operand_not_pseudo (operands[1], TFmode))
   && (gpc_reg_operand (operands[0], TFmode)
       || gpc_reg_operand (operands[1], TFmode))) && 
#line 547 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TFmode))))
            return 594; /* *movtf_32bit */
          if ((
#line 8861 "../../gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT
   && (gpc_reg_operand (operands[0], TFmode)
       || gpc_reg_operand (operands[1], TFmode))) && 
#line 543 "../../gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)))
            return 597; /* *movtf_softfloat */
        }
      if (vsx_register_operand (operands[0], E_TFmode)
          && memory_operand (operands[1], E_TFmode)
          && (
#line 1040 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[1], TFmode)) && 
#line 36 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (TFmode))))
        return 1164; /* *vsx_le_perm_load_tf */
      if (memory_operand (operands[0], E_TFmode)
          && vsx_register_operand (operands[1], E_TFmode)
          && (
#line 1063 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], TFmode)) && 
#line 36 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (TFmode))))
        return 1168; /* *vsx_le_perm_store_tf */
      if (nonimmediate_operand (operands[0], E_TFmode)
          && input_operand (operands[1], E_TFmode))
        {
          if ((
#line 1258 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (TFmode)
   && (register_operand (operands[0], TFmode) 
       || register_operand (operands[1], TFmode))) && 
#line 70 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (TFmode))))
            return 1187; /* vsx_movtf_64bit */
          if ((
#line 1312 "../../gcc/config/rs6000/vsx.md"
(!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (TFmode)
   && (register_operand (operands[0], TFmode) 
       || register_operand (operands[1], TFmode))) && 
#line 70 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (TFmode))))
            return 1197; /* *vsx_movtf_32bit */
          if ((
#line 245 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (TFmode)
   && (register_operand (operands[0], TFmode) 
       || register_operand (operands[1], TFmode))) && 
#line 212 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return 1682; /* *altivec_movtf */
        }
      break;

    case E_IFmode:
      if (nonimmediate_operand (operands[0], E_IFmode)
          && input_operand (operands[1], E_IFmode))
        {
          if ((
#line 8807 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_POWERPC64 && FLOAT128_2REG_P (IFmode)
   && (IFmode != TDmode || WORDS_BIG_ENDIAN)
   && (gpc_reg_operand (operands[0], IFmode)
       || gpc_reg_operand (operands[1], IFmode))) && 
#line 548 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (IFmode))))
            return 591; /* *movif_64bit_dm */
          if ((
#line 8843 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && !TARGET_POWERPC64
   && (FLOAT128_2REG_P (IFmode)
       || int_reg_operand_not_pseudo (operands[0], IFmode)
       || int_reg_operand_not_pseudo (operands[1], IFmode))
   && (gpc_reg_operand (operands[0], IFmode)
       || gpc_reg_operand (operands[1], IFmode))) && 
#line 548 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (IFmode))))
            return 595; /* *movif_32bit */
          if ((
#line 8861 "../../gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT
   && (gpc_reg_operand (operands[0], IFmode)
       || gpc_reg_operand (operands[1], IFmode))) && 
#line 544 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
            return 598; /* *movif_softfloat */
        }
      break;

    case E_TDmode:
      if (nonimmediate_operand (operands[0], E_TDmode)
          && input_operand (operands[1], E_TDmode))
        {
          if ((
#line 8807 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_POWERPC64 && FLOAT128_2REG_P (TDmode)
   && (TDmode != TDmode || WORDS_BIG_ENDIAN)
   && (gpc_reg_operand (operands[0], TDmode)
       || gpc_reg_operand (operands[1], TDmode))) && 
#line 549 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)))
            return 592; /* *movtd_64bit_dm */
          if (
#line 8826 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_POWERPC64 && !WORDS_BIG_ENDIAN
   && (gpc_reg_operand (operands[0], TDmode)
       || gpc_reg_operand (operands[1], TDmode))))
            return 593; /* *movtd_64bit_nodm */
          if ((
#line 8843 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && !TARGET_POWERPC64
   && (FLOAT128_2REG_P (TDmode)
       || int_reg_operand_not_pseudo (operands[0], TDmode)
       || int_reg_operand_not_pseudo (operands[1], TDmode))
   && (gpc_reg_operand (operands[0], TDmode)
       || gpc_reg_operand (operands[1], TDmode))) && 
#line 549 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)))
            return 596; /* *movtd_32bit */
          if ((
#line 8861 "../../gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT
   && (gpc_reg_operand (operands[0], TDmode)
       || gpc_reg_operand (operands[1], TDmode))) && 
#line 545 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)))
            return 599; /* *movtd_softfloat */
        }
      break;

    case E_DImode:
      if (nonimmediate_operand (operands[0], E_DImode)
          && input_operand (operands[1], E_DImode))
        {
          if (
#line 9795 "../../gcc/config/rs6000/rs6000.md"
(! TARGET_POWERPC64
   && (gpc_reg_operand (operands[0], DImode)
       || gpc_reg_operand (operands[1], DImode))))
            return 684; /* *movdi_internal32 */
          if (
#line 9892 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64
   && (gpc_reg_operand (operands[0], DImode)
       || gpc_reg_operand (operands[1], DImode))))
            return 685; /* *movdi_internal64 */
        }
      if (gpc_reg_operand (operands[0], E_DImode))
        {
          if (pcrel_local_address (operands[1], E_DImode)
              && 
#line 11071 "../../gcc/config/rs6000/rs6000.md"
(TARGET_PCREL))
            return 756; /* *pcrel_local_addr */
          if (pcrel_external_address (operands[1], E_DImode)
              && 
#line 11083 "../../gcc/config/rs6000/rs6000.md"
(TARGET_PCREL))
            return 757; /* *pcrel_extern_addr */
        }
      break;

    case E_TImode:
      if (input_operand (operands[1], E_TImode))
        {
          if (reg_or_mem_operand (operands[0], E_TImode)
              && 
#line 10037 "../../gcc/config/rs6000/rs6000.md"
(! TARGET_POWERPC64
   && (TImode != TImode || VECTOR_MEM_NONE_P (TImode))
   && (gpc_reg_operand (operands[0], TImode)
       || gpc_reg_operand (operands[1], TImode))))
            return 686; /* *movti_string */
          if (nonimmediate_operand (operands[0], E_TImode)
              && 
#line 10050 "../../gcc/config/rs6000/rs6000.md"
((TARGET_POWERPC64 && VECTOR_MEM_NONE_P (TImode)
   && (gpc_reg_operand (operands[0], TImode)
       || gpc_reg_operand (operands[1], TImode)))))
            return 688; /* *movti_ppc64 */
        }
      if (indexed_or_indirect_operand (operands[0], E_TImode)
          && indexed_or_indirect_operand (operands[1], E_TImode)
          && 
#line 427 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN
   && TARGET_VSX
   && !TARGET_P9_VECTOR
   && can_create_pseudo_p ()))
        return 1146; /* *vsx_le_mem_to_mem_mov_ti */
      if (vsx_register_operand (operands[0], E_TImode)
          && memory_operand (operands[1], E_TImode)
          && 
#line 1040 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[1], TImode)))
        return 1165; /* *vsx_le_perm_load_ti */
      if (memory_operand (operands[0], E_TImode)
          && vsx_register_operand (operands[1], E_TImode)
          && 
#line 1063 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], TImode)))
        return 1169; /* *vsx_le_perm_store_ti */
      if (nonimmediate_operand (operands[0], E_TImode)
          && input_operand (operands[1], E_TImode))
        {
          if (
#line 1258 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (TImode)
   && (register_operand (operands[0], TImode) 
       || register_operand (operands[1], TImode))))
            return 1188; /* vsx_movti_64bit */
          if (
#line 1312 "../../gcc/config/rs6000/vsx.md"
(!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (TImode)
   && (register_operand (operands[0], TImode) 
       || register_operand (operands[1], TImode))))
            return 1198; /* *vsx_movti_32bit */
          if (
#line 267 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (TImode)
   && (register_operand (operands[0], TImode) 
       || register_operand (operands[1], TImode))))
            return 1683; /* *altivec_movti */
        }
      break;

    case E_PTImode:
      if (input_operand (operands[1], E_PTImode))
        {
          if (reg_or_mem_operand (operands[0], E_PTImode)
              && 
#line 10037 "../../gcc/config/rs6000/rs6000.md"
(! TARGET_POWERPC64
   && (PTImode != TImode || VECTOR_MEM_NONE_P (TImode))
   && (gpc_reg_operand (operands[0], PTImode)
       || gpc_reg_operand (operands[1], PTImode))))
            return 687; /* *movpti_string */
          if (nonimmediate_operand (operands[0], E_PTImode)
              && 
#line 10050 "../../gcc/config/rs6000/rs6000.md"
((TARGET_POWERPC64 && VECTOR_MEM_NONE_P (PTImode)
   && (gpc_reg_operand (operands[0], PTImode)
       || gpc_reg_operand (operands[1], PTImode)))))
            return 689; /* *movpti_ppc64 */
        }
      break;

    default:
      break;
    }
  operands[0] = x2;
  switch (pattern31 (x3, 
E_TFmode))
    {
    case 0:
      if ((
#line 3218 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && (((((
#line 212 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 212 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode)))))
        return 2111; /* altivec_stvx_tf_2op_di */
      break;

    case 1:
      if ((
#line 3226 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && (((
#line 212 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 212 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode)))))
        return 2120; /* altivec_stvx_tf_1op_di */
      break;

    default:
      break;
    }
  if (GET_CODE (x2) != MEM)
    return -1;
  switch (pattern33 (x1, 
E_TFmode))
    {
    case 0:
      if (!(
#line 3162 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && ((((
#line 212 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))))
        return -1;
      return 2084; /* altivec_lvx_tf_2op_di */

    case 1:
      if (!(
#line 3170 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && ((
#line 212 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))))
        return -1;
      return 2093; /* altivec_lvx_tf_1op_di */

    default:
      return -1;
    }
}

 int
recog_120 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern8 (x1))
    {
    case 0:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pnum_clobbers != NULL
              && nonimmediate_operand (operands[0], E_SImode))
            {
              x2 = XEXP (x1, 1);
              if (GET_MODE (x2) == E_SImode)
                {
                  switch (GET_MODE (operands[1]))
                    {
                    case E_SFmode:
                      if (gpc_reg_operand (operands[1], E_SFmode)
                          && 
#line 6326 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE))
                        {
                          *pnum_clobbers = 1;
                          return 414; /* fix_truncsfsi2_stfiwx */
                        }
                      break;

                    case E_DFmode:
                      if (gpc_reg_operand (operands[1], E_DFmode)
                          && 
#line 6326 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE))
                        {
                          *pnum_clobbers = 1;
                          return 415; /* fix_truncdfsi2_stfiwx */
                        }
                      break;

                    default:
                      break;
                    }
                }
            }
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_SImode)
            return -1;
          if (gpc_reg_operand (operands[0], E_SImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SFmode:
                  if (gpc_reg_operand (operands[1], E_SFmode)
                      && 
#line 6425 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                    return 428; /* *fix_truncsfsi2_p8 */
                  break;

                case E_DFmode:
                  if (gpc_reg_operand (operands[1], E_DFmode)
                      && 
#line 6425 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                    return 430; /* *fix_truncdfsi2_p8 */
                  break;

                default:
                  break;
                }
            }
          if (pnum_clobbers != NULL
              && memory_operand (operands[0], E_SImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SFmode:
                  if (gpc_reg_operand (operands[1], E_SFmode)
                      && 
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                    {
                      *pnum_clobbers = 1;
                      return 436; /* *fix_truncsfsi2_mem */
                    }
                  break;

                case E_DFmode:
                  if (gpc_reg_operand (operands[1], E_DFmode)
                      && 
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                    {
                      *pnum_clobbers = 1;
                      return 442; /* *fix_truncdfsi2_mem */
                    }
                  break;

                default:
                  break;
                }
            }
          if (altivec_register_operand (operands[0], E_SImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_KFmode:
                  if (altivec_register_operand (operands[1], E_KFmode)
                      && (
#line 15287 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return 1019; /* fix_kfsi2_hw */
                  break;

                case E_TFmode:
                  if (altivec_register_operand (operands[1], E_TFmode)
                      && (
#line 15287 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return 1021; /* fix_tfsi2_hw */
                  break;

                default:
                  break;
                }
            }
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern318 (
E_SImode))
            {
            case 0:
              if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1039; /* *fix_trunckfsi2_mem */

            case 1:
              if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1045; /* *fix_trunctfsi2_mem */

            default:
              return -1;
            }

        case E_DImode:
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_DImode)
            return -1;
          if (gpc_reg_operand (operands[0], E_DImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SFmode:
                  if (gpc_reg_operand (operands[1], E_SFmode)
                      && 
#line 6389 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFID))
                    return 418; /* *fix_truncsfdi2_fctidz */
                  break;

                case E_DFmode:
                  if (gpc_reg_operand (operands[1], E_DFmode)
                      && 
#line 6389 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFID))
                    return 419; /* *fix_truncdfdi2_fctidz */
                  break;

                case E_DDmode:
                  if (gpc_reg_operand (operands[1], E_DDmode)
                      && 
#line 253 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
                    return 2294; /* fixdddi2 */
                  break;

                case E_TDmode:
                  if (gpc_reg_operand (operands[1], E_TDmode)
                      && 
#line 253 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
                    return 2295; /* fixtddi2 */
                  break;

                default:
                  break;
                }
            }
          if (!altivec_register_operand (operands[0], E_DImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_KFmode:
              if (!altivec_register_operand (operands[1], E_KFmode)
                  || !(
#line 15287 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1023; /* fix_kfdi2_hw */

            case E_TFmode:
              if (!altivec_register_operand (operands[1], E_TFmode)
                  || !(
#line 15287 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1025; /* fix_tfdi2_hw */

            default:
              return -1;
            }

        case E_QImode:
          if (pnum_clobbers != NULL)
            {
              x2 = XEXP (x1, 1);
              if (GET_MODE (x2) == E_QImode)
                {
                  if (gpc_reg_operand (operands[0], E_QImode))
                    {
                      switch (GET_MODE (operands[1]))
                        {
                        case E_SFmode:
                          if (gpc_reg_operand (operands[1], E_SFmode)
                              && 
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                            {
                              *pnum_clobbers = 1;
                              return 420; /* fix_truncsfqi2 */
                            }
                          break;

                        case E_DFmode:
                          if (gpc_reg_operand (operands[1], E_DFmode)
                              && 
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                            {
                              *pnum_clobbers = 1;
                              return 424; /* fix_truncdfqi2 */
                            }
                          break;

                        default:
                          break;
                        }
                    }
                  if (memory_operand (operands[0], E_QImode))
                    {
                      switch (GET_MODE (operands[1]))
                        {
                        case E_SFmode:
                          if (gpc_reg_operand (operands[1], E_SFmode)
                              && 
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                            {
                              *pnum_clobbers = 1;
                              return 432; /* *fix_truncsfqi2_mem */
                            }
                          break;

                        case E_DFmode:
                          if (gpc_reg_operand (operands[1], E_DFmode)
                              && 
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                            {
                              *pnum_clobbers = 1;
                              return 438; /* *fix_truncdfqi2_mem */
                            }
                          break;

                        default:
                          break;
                        }
                    }
                }
            }
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_QImode)
            return -1;
          if (altivec_register_operand (operands[0], E_QImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_KFmode:
                  if (altivec_register_operand (operands[1], E_KFmode)
                      && (
#line 15296 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return 1027; /* fix_trunckfqi2 */
                  break;

                case E_TFmode:
                  if (altivec_register_operand (operands[1], E_TFmode)
                      && (
#line 15296 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return 1031; /* fix_trunctfqi2 */
                  break;

                default:
                  break;
                }
            }
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern318 (
E_QImode))
            {
            case 0:
              if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1035; /* *fix_trunckfqi2_mem */

            case 1:
              if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1041; /* *fix_trunctfqi2_mem */

            default:
              return -1;
            }

        case E_HImode:
          if (pnum_clobbers != NULL)
            {
              x2 = XEXP (x1, 1);
              if (GET_MODE (x2) == E_HImode)
                {
                  if (gpc_reg_operand (operands[0], E_HImode))
                    {
                      switch (GET_MODE (operands[1]))
                        {
                        case E_SFmode:
                          if (gpc_reg_operand (operands[1], E_SFmode)
                              && 
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                            {
                              *pnum_clobbers = 1;
                              return 422; /* fix_truncsfhi2 */
                            }
                          break;

                        case E_DFmode:
                          if (gpc_reg_operand (operands[1], E_DFmode)
                              && 
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                            {
                              *pnum_clobbers = 1;
                              return 426; /* fix_truncdfhi2 */
                            }
                          break;

                        default:
                          break;
                        }
                    }
                  if (memory_operand (operands[0], E_HImode))
                    {
                      switch (GET_MODE (operands[1]))
                        {
                        case E_SFmode:
                          if (gpc_reg_operand (operands[1], E_SFmode)
                              && 
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                            {
                              *pnum_clobbers = 1;
                              return 434; /* *fix_truncsfhi2_mem */
                            }
                          break;

                        case E_DFmode:
                          if (gpc_reg_operand (operands[1], E_DFmode)
                              && 
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                            {
                              *pnum_clobbers = 1;
                              return 440; /* *fix_truncdfhi2_mem */
                            }
                          break;

                        default:
                          break;
                        }
                    }
                }
            }
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_HImode)
            return -1;
          if (altivec_register_operand (operands[0], E_HImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_KFmode:
                  if (altivec_register_operand (operands[1], E_KFmode)
                      && (
#line 15296 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return 1029; /* fix_trunckfhi2 */
                  break;

                case E_TFmode:
                  if (altivec_register_operand (operands[1], E_TFmode)
                      && (
#line 15296 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return 1033; /* fix_trunctfhi2 */
                  break;

                default:
                  break;
                }
            }
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern318 (
E_HImode))
            {
            case 0:
              if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1037; /* *fix_trunckfhi2_mem */

            case 1:
              if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1043; /* *fix_trunctfhi2_mem */

            default:
              return -1;
            }

        case E_TImode:
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_TImode)
            return -1;
          if (vsx_register_operand (operands[0], E_TImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_KFmode:
                  if (vsx_register_operand (operands[1], E_KFmode)
                      && (
#line 6951 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return 484; /* fix_trunckfti2 */
                  break;

                case E_TFmode:
                  if (vsx_register_operand (operands[1], E_TFmode)
                      && (
#line 6951 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return 485; /* fix_trunctfti2 */
                  break;

                default:
                  break;
                }
            }
          if (!gpc_reg_operand (operands[0], E_TImode)
              || !gpc_reg_operand (operands[1], E_TDmode)
              || !
#line 261 "../../gcc/config/rs6000/dfp.md"
(TARGET_POWER10))
            return -1;
          return 2296; /* fixtdti2 */

        case E_V4SImode:
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_V4SImode)
            return -1;
          if (gpc_reg_operand (operands[0], E_V4SImode)
              && gpc_reg_operand (operands[1], E_V4SFmode)
              && 
#line 2292 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return 1288; /* vsx_fix_truncv4sfv4si2 */
          if (!vsx_register_operand (operands[0], E_V4SImode)
              || !vsx_register_operand (operands[1], E_V4SFmode)
              || !
#line 2503 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1324; /* vsx_xvcvspsxws */

        case E_V2DImode:
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_V2DImode)
            return -1;
          if (gpc_reg_operand (operands[0], E_V2DImode)
              && gpc_reg_operand (operands[1], E_V2DFmode)
              && 
#line 2292 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return 1289; /* vsx_fix_truncv2dfv2di2 */
          if (!vsx_register_operand (operands[0], E_V2DImode)
              || !vsx_register_operand (operands[1], E_V2DFmode)
              || !
#line 2510 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1326; /* vsx_xvcvdpsxds */

        case E_V4SFmode:
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_V4SFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_V4SFmode)
              && vsx_register_operand (operands[1], E_V4SFmode)
              && 
#line 2323 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return 1298; /* vsx_btruncv4sf2 */
          if (!register_operand (operands[0], E_V4SFmode)
              || !register_operand (operands[1], E_V4SFmode)
              || !
#line 2468 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
            return -1;
          return 1954; /* *altivec_vrfiz */

        case E_V2DFmode:
          if (!vsx_register_operand (operands[0], E_V2DFmode))
            return -1;
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_V2DFmode
              || !vsx_register_operand (operands[1], E_V2DFmode)
              || !
#line 2323 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1299; /* vsx_btruncv2df2 */

        case E_DDmode:
          if (!gpc_reg_operand (operands[0], E_DDmode))
            return -1;
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_DDmode
              || !gpc_reg_operand (operands[1], E_DDmode)
              || !
#line 242 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2292; /* ftruncdd2 */

        case E_TDmode:
          if (!gpc_reg_operand (operands[0], E_TDmode))
            return -1;
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_TDmode
              || !gpc_reg_operand (operands[1], E_TDmode)
              || !
#line 242 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2293; /* ftrunctd2 */

        default:
          return -1;
        }

    case 1:
      if (!
#line 2680 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode) && BYTES_BIG_ENDIAN))
        return -1;
      return 1338; /* vsx_xvcvspsxds_be */

    case 2:
      if (!
#line 2689 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode) && !BYTES_BIG_ENDIAN))
        return -1;
      return 1340; /* vsx_xvcvspsxds_le */

    default:
      return -1;
    }
}

 int
recog_134 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (GET_MODE (x3) != E_HImode)
        return -1;
      if (gpc_reg_operand (operands[0], E_HImode)
          && memory_operand (operands[1], E_HImode))
        return 142; /* bswaphi2_load */
      if (!gpc_reg_operand (operands[1], E_HImode))
        return -1;
      if (memory_operand (operands[0], E_HImode))
        return 144; /* bswaphi2_store */
      if (pnum_clobbers == NULL
          || !gpc_reg_operand (operands[0], E_HImode))
        return -1;
      *pnum_clobbers = 1;
      return 146; /* bswaphi2_reg */

    case E_SImode:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      if (gpc_reg_operand (operands[0], E_SImode)
          && memory_operand (operands[1], E_SImode))
        return 143; /* bswapsi2_load */
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      if (memory_operand (operands[0], E_SImode))
        return 145; /* bswapsi2_store */
      if (!gpc_reg_operand (operands[0], E_SImode))
        return -1;
      return 147; /* bswapsi2_reg */

    case E_DImode:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      if (gpc_reg_operand (operands[0], E_DImode)
          && memory_operand (operands[1], E_DImode)
          && 
#line 2780 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_LDBRX))
        return 148; /* bswapdi2_load */
      if (gpc_reg_operand (operands[1], E_DImode))
        {
          if (memory_operand (operands[0], E_DImode)
              && 
#line 2787 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_LDBRX))
            return 149; /* bswapdi2_store */
          if (gpc_reg_operand (operands[0], E_DImode))
            {
              if (
#line 2794 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR))
                return 150; /* bswapdi2_brd */
              if (pnum_clobbers != NULL
                  && 
#line 2806 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_LDBRX && !TARGET_P9_VECTOR))
                {
                  *pnum_clobbers = 2;
                  return 151; /* bswapdi2_reg */
                }
            }
        }
      if (pnum_clobbers == NULL
          || !reg_or_mem_operand (operands[0], E_DImode)
          || !reg_or_mem_operand (operands[1], E_DImode))
        return -1;
      if (
#line 2816 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && !TARGET_LDBRX
   && (REG_P (operands[0]) || REG_P (operands[1]))
   && !(MEM_P (operands[0]) && MEM_VOLATILE_P (operands[0]))
   && !(MEM_P (operands[1]) && MEM_VOLATILE_P (operands[1]))))
        {
          *pnum_clobbers = 2;
          return 152; /* *bswapdi2_64bit */
        }
      if (!
#line 2978 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && (REG_P (operands[0]) || REG_P (operands[1]))))
        return -1;
      *pnum_clobbers = 1;
      return 153; /* bswapdi2_32bit */

    case E_V1TImode:
      if (!vsx_register_operand (operands[0], E_V1TImode)
          || GET_MODE (x3) != E_V1TImode
          || !vsx_register_operand (operands[1], E_V1TImode)
          || !
#line 6154 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1617; /* p9_xxbrq_v1ti */

    case E_V2DImode:
      if (!vsx_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !vsx_register_operand (operands[1], E_V2DImode)
          || !
#line 6174 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1618; /* p9_xxbrd_v2di */

    case E_V4SImode:
      if (!vsx_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !vsx_register_operand (operands[1], E_V4SImode)
          || !
#line 6194 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1619; /* p9_xxbrw_v4si */

    case E_V8HImode:
      if (!vsx_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !vsx_register_operand (operands[1], E_V8HImode)
          || !
#line 6254 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1620; /* p9_xxbrh_v8hi */

    default:
      return -1;
    }
}

 int
recog_140 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern5 (x1, pnum_clobbers))
    {
    case 0:
      if (vsx_register_operand (operands[0], E_SFmode)
          && vsx_register_operand (operands[1], E_SFmode)
          && vsx_register_operand (operands[2], E_SFmode)
          && 
#line 5488 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && TARGET_HARD_FLOAT))
        return 326; /* *sminsf3_vsx */
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || !gpc_reg_operand (operands[1], E_SFmode)
          || !gpc_reg_operand (operands[2], E_SFmode)
          || !
#line 5515 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_MINMAX))
        return -1;
      return 334; /* *sminsf3_fpr */

    case 1:
      if (vsx_register_operand (operands[0], E_DFmode)
          && vsx_register_operand (operands[1], E_DFmode)
          && vsx_register_operand (operands[2], E_DFmode)
          && 
#line 5488 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && TARGET_HARD_FLOAT))
        return 328; /* *smindf3_vsx */
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || !gpc_reg_operand (operands[1], E_DFmode)
          || !gpc_reg_operand (operands[2], E_DFmode)
          || !
#line 5515 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_MINMAX))
        return -1;
      return 336; /* *smindf3_fpr */

    case 2:
      if (!(
#line 5502 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 330; /* sminkf3 */

    case 3:
      if (!(
#line 5502 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 332; /* smintf3 */

    case 4:
      if (vsx_register_operand (operands[0], E_V4SFmode)
          && vsx_register_operand (operands[1], E_V4SFmode)
          && vsx_register_operand (operands[2], E_V4SFmode)
          && 
#line 2016 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return 1252; /* *vsx_sminv4sf3 */
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode)
          || !register_operand (operands[2], E_V4SFmode)
          || !
#line 1113 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
        return -1;
      return 1835; /* *altivec_sminv4sf3 */

    case 5:
      if (!
#line 2016 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1253; /* *vsx_sminv2df3 */

    case 6:
      if (!
#line 1105 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
        return -1;
      return 1831; /* sminv4si3 */

    case 7:
      if (!
#line 1105 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
        return -1;
      return 1832; /* sminv8hi3 */

    case 8:
      if (!
#line 1105 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
        return -1;
      return 1833; /* sminv16qi3 */

    case 9:
      if (!
#line 1105 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
        return -1;
      return 1834; /* sminv2di3 */

    case 10:
      if (!
#line 4927 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      *pnum_clobbers = 1;
      return 1521; /* vsx_reduc_smin_v2df */

    case 11:
      if (!
#line 4949 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      *pnum_clobbers = 2;
      return 1524; /* vsx_reduc_smin_v4sf */

    default:
      return -1;
    }
}

 int
recog_149 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  operands[3] = x5;
  if (!cc_reg_operand (operands[3], E_CCmode)
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 0);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case MULT:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != SET)
        return -1;
      x9 = XEXP (x8, 1);
      if (GET_CODE (x9) != PLUS
          || GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != MULT
          || GET_MODE (x10) != E_SImode
          || GET_MODE (x6) != E_SImode)
        return -1;
      x11 = XEXP (x7, 0);
      if (GET_MODE (x11) != E_SImode)
        return -1;
      x12 = XEXP (x7, 1);
      if (GET_MODE (x12) != E_SImode)
        return -1;
      x13 = XEXP (x6, 1);
      operands[4] = x13;
      if (!gpc_reg_operand (operands[4], E_SImode))
        return -1;
      x14 = XEXP (x8, 0);
      operands[0] = x14;
      if (!gpc_reg_operand (operands[0], E_SImode))
        return -1;
      x15 = XEXP (x10, 0);
      if (GET_MODE (x15) != E_SImode)
        return -1;
      x16 = XEXP (x10, 1);
      if (GET_MODE (x16) != E_SImode)
        return -1;
      x17 = XEXP (x9, 1);
      if (!rtx_equal_p (x17, operands[4]))
        return -1;
      switch (GET_CODE (x11))
        {
        case ASHIFTRT:
          if (pattern558 (x1, 
ASHIFTRT) != 0)
            return -1;
          switch (GET_CODE (x12))
            {
            case SIGN_EXTEND:
              if (pattern560 (x1, 
SIGN_EXTEND) != 0
                  || !
#line 1274 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 34; /* *macchwc */

            case ASHIFTRT:
              if (pattern561 (x1, 
ASHIFTRT) != 0
                  || !
#line 1340 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 38; /* *machhwc */

            default:
              return -1;
            }

        case LSHIFTRT:
          if (pattern558 (x1, 
LSHIFTRT) != 0)
            return -1;
          switch (GET_CODE (x12))
            {
            case ZERO_EXTEND:
              if (pattern560 (x1, 
ZERO_EXTEND) != 0
                  || !
#line 1306 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 36; /* *macchwuc */

            case LSHIFTRT:
              if (pattern561 (x1, 
LSHIFTRT) != 0
                  || !
#line 1375 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 40; /* *machhwuc */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern559 (x1, 
SIGN_EXTEND) != 0
              || !
#line 1406 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 42; /* *maclhwc */

        case ZERO_EXTEND:
          if (pattern559 (x1, 
ZERO_EXTEND) != 0
              || !
#line 1435 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 44; /* *maclhwuc */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x7;
      x13 = XEXP (x6, 1);
      operands[2] = x13;
      switch (GET_CODE (operands[2]))
        {
        case REG:
        case SUBREG:
          switch (pattern193 (x1, 
PLUS))
            {
            case 0:
              if (!
#line 1872 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 67; /* *addsi3_dot */

            case 1:
              if (!(
#line 1872 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 68; /* *adddi3_dot */

            case 2:
              if (!
#line 1896 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 69; /* *addsi3_dot2 */

            case 3:
              if (!(
#line 1896 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 70; /* *adddi3_dot2 */

            default:
              return -1;
            }

        case CONST_INT:
          if (pnum_clobbers == NULL)
            return -1;
          x8 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x8) != SET)
            return -1;
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) != PLUS)
            return -1;
          x14 = XEXP (x8, 0);
          operands[0] = x14;
          x10 = XEXP (x9, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          x17 = XEXP (x9, 1);
          if (!rtx_equal_p (x17, operands[2]))
            return -1;
          switch (GET_MODE (x6))
            {
            case E_SImode:
              if (pattern547 (x9, 
E_SImode) != 0
                  || !
#line 1944 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              *pnum_clobbers = 1;
              return 73; /* *addsi3_imm_dot2 */

            case E_DImode:
              if (pattern547 (x9, 
E_DImode) != 0
                  || !(
#line 1944 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 74; /* *adddi3_imm_dot2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_162 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ZERO_EXTEND:
      switch (pattern169 (x1, 
ZERO_EXTEND))
        {
        case 0:
          return 6; /* *zero_extendqisi2_dot */

        case 1:
          return 12; /* *zero_extendhisi2_dot */

        case 2:
          if (!
#line 490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 7; /* *zero_extendqidi2_dot */

        case 3:
          if (!
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 13; /* *zero_extendhidi2_dot */

        case 4:
          if (!
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 17; /* *zero_extendsidi2_dot */

        case 5:
          return 8; /* *zero_extendqisi2_dot2 */

        case 6:
          return 14; /* *zero_extendhisi2_dot2 */

        case 7:
          if (!
#line 490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 9; /* *zero_extendqidi2_dot2 */

        case 8:
          if (!
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 15; /* *zero_extendhidi2_dot2 */

        case 9:
          if (!
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 18; /* *zero_extendsidi2_dot2 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern169 (x1, 
SIGN_EXTEND))
        {
        case 0:
          return 21; /* *extendqisi2_dot */

        case 1:
          return 27; /* *extendhisi2_dot */

        case 2:
          if (!
#line 490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 22; /* *extendqidi2_dot */

        case 3:
          if (!
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 28; /* *extendhidi2_dot */

        case 4:
          if (!
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 32; /* *extendsidi2_dot */

        case 5:
          return 23; /* *extendqisi2_dot2 */

        case 6:
          return 29; /* *extendhisi2_dot2 */

        case 7:
          if (!
#line 490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 24; /* *extendqidi2_dot2 */

        case 8:
          if (!
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 30; /* *extendhidi2_dot2 */

        case 9:
          if (!
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 33; /* *extendsidi2_dot2 */

        default:
          return -1;
        }

    case PLUS:
      return recog_149 (x1, insn, pnum_clobbers);

    case MINUS:
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x2, 0);
      operands[3] = x6;
      if (!cc_reg_operand (operands[3], E_CCmode)
          || GET_MODE (x3) != E_CCmode)
        return -1;
      x7 = XEXP (x4, 1);
      switch (GET_CODE (x7))
        {
        case MULT:
          if (GET_MODE (x7) != E_SImode)
            return -1;
          x8 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x8) != SET)
            return -1;
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) != MINUS
              || GET_MODE (x9) != E_SImode)
            return -1;
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != MULT
              || GET_MODE (x10) != E_SImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          x11 = XEXP (x4, 0);
          operands[4] = x11;
          if (!gpc_reg_operand (operands[4], E_SImode))
            return -1;
          x12 = XEXP (x7, 0);
          if (GET_MODE (x12) != E_SImode)
            return -1;
          x13 = XEXP (x7, 1);
          if (GET_MODE (x13) != E_SImode)
            return -1;
          x14 = XEXP (x8, 0);
          operands[0] = x14;
          if (!gpc_reg_operand (operands[0], E_SImode))
            return -1;
          x15 = XEXP (x10, 0);
          if (GET_MODE (x15) != E_SImode)
            return -1;
          x16 = XEXP (x10, 1);
          if (GET_MODE (x16) != E_SImode)
            return -1;
          x17 = XEXP (x9, 0);
          if (!rtx_equal_p (x17, operands[4]))
            return -1;
          switch (GET_CODE (x12))
            {
            case ASHIFTRT:
              x18 = XEXP (x12, 1);
              if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
                  || GET_CODE (x15) != ASHIFTRT)
                return -1;
              x19 = XEXP (x15, 1);
              if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x20 = XEXP (x12, 0);
              if (!gpc_reg_operand (x20, E_SImode))
                return -1;
              switch (GET_CODE (x13))
                {
                case SIGN_EXTEND:
                  if (GET_CODE (x16) != SIGN_EXTEND)
                    return -1;
                  operands[2] = x20;
                  x21 = XEXP (x13, 0);
                  operands[1] = x21;
                  if (!gpc_reg_operand (operands[1], E_HImode))
                    return -1;
                  x22 = XEXP (x15, 0);
                  if (!rtx_equal_p (x22, operands[2]))
                    return -1;
                  x23 = XEXP (x16, 0);
                  if (!rtx_equal_p (x23, operands[1])
                      || !
#line 1466 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                    return -1;
                  return 46; /* *nmacchwc */

                case ASHIFTRT:
                  x24 = XEXP (x13, 1);
                  if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
                      || GET_CODE (x16) != ASHIFTRT)
                    return -1;
                  x25 = XEXP (x16, 1);
                  if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                    return -1;
                  operands[1] = x20;
                  x21 = XEXP (x13, 0);
                  operands[2] = x21;
                  if (!gpc_reg_operand (operands[2], E_SImode))
                    return -1;
                  x22 = XEXP (x15, 0);
                  if (!rtx_equal_p (x22, operands[1]))
                    return -1;
                  x23 = XEXP (x16, 0);
                  if (!rtx_equal_p (x23, operands[2])
                      || !
#line 1500 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                    return -1;
                  return 48; /* *nmachhwc */

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              if (GET_CODE (x13) != SIGN_EXTEND
                  || GET_CODE (x15) != SIGN_EXTEND
                  || GET_CODE (x16) != SIGN_EXTEND)
                return -1;
              x20 = XEXP (x12, 0);
              operands[1] = x20;
              if (!gpc_reg_operand (operands[1], E_HImode))
                return -1;
              x21 = XEXP (x13, 0);
              operands[2] = x21;
              if (!gpc_reg_operand (operands[2], E_HImode))
                return -1;
              x22 = XEXP (x15, 0);
              if (!rtx_equal_p (x22, operands[1]))
                return -1;
              x23 = XEXP (x16, 0);
              if (!rtx_equal_p (x23, operands[2])
                  || !
#line 1531 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 50; /* *nmaclhwc */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x7;
          x11 = XEXP (x4, 0);
          operands[2] = x11;
          switch (pattern461 (x1))
            {
            case 0:
              if (!
#line 2215 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 96; /* *subfsi3_dot */

            case 1:
              if (!(
#line 2215 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 97; /* *subfdi3_dot */

            case 2:
              if (!
#line 2239 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 98; /* *subfsi3_dot2 */

            case 3:
              if (!(
#line 2239 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 99; /* *subfdi3_dot2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x2, 0);
      operands[3] = x6;
      if (!cc_reg_operand (operands[3], E_CCmode)
          || GET_MODE (x3) != E_CCmode)
        return -1;
      x11 = XEXP (x4, 0);
      switch (GET_CODE (x11))
        {
        case ASHIFTRT:
          if (pattern419 (x1, 
ASHIFTRT) != 0)
            return -1;
          x7 = XEXP (x4, 1);
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              if (pattern556 (x1, 
SIGN_EXTEND) != 0
                  || !
#line 1560 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 52; /* *mulchwc */

            case ASHIFTRT:
              if (pattern557 (x1, 
ASHIFTRT) != 0
                  || !
#line 1620 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 56; /* *mulhhwc */

            default:
              return -1;
            }

        case LSHIFTRT:
          if (pattern419 (x1, 
LSHIFTRT) != 0)
            return -1;
          x7 = XEXP (x4, 1);
          switch (GET_CODE (x7))
            {
            case ZERO_EXTEND:
              if (pattern556 (x1, 
ZERO_EXTEND) != 0
                  || !
#line 1589 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 54; /* *mulchwuc */

            case LSHIFTRT:
              if (pattern557 (x1, 
LSHIFTRT) != 0
                  || !
#line 1652 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 58; /* *mulhhwuc */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern420 (x1, 
SIGN_EXTEND) != 0
              || !
#line 1680 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 60; /* *mullhwc */

        case ZERO_EXTEND:
          if (pattern420 (x1, 
ZERO_EXTEND) != 0
              || !
#line 1706 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 62; /* *mullhwuc */

        case REG:
        case SUBREG:
          switch (pattern194 (x1, 
MULT))
            {
            case 0:
              if (!
#line 3124 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 156; /* *mulsi3_dot */

            case 1:
              if (!(
#line 3124 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 157; /* *muldi3_dot */

            case 2:
              if (!
#line 3149 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 158; /* *mulsi3_dot2 */

            case 3:
              if (!(
#line 3149 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 159; /* *muldi3_dot2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      switch (pattern172 (x1, 
NOT))
        {
        case 0:
          if (!
#line 2132 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 90; /* *one_cmplsi2_dot */

        case 1:
          if (!(
#line 2132 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 91; /* *one_cmpldi2_dot */

        case 2:
          if (!
#line 2153 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 92; /* *one_cmplsi2_dot2 */

        case 3:
          if (!(
#line 2153 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 93; /* *one_cmpldi2_dot2 */

        default:
          return -1;
        }

    case NEG:
      switch (pattern172 (x1, 
NEG))
        {
        case 0:
          if (!
#line 2410 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 118; /* *negsi2_dot */

        case 1:
          if (!(
#line 2410 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 119; /* *negdi2_dot */

        case 2:
          if (!
#line 2431 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 120; /* *negsi2_dot2 */

        case 3:
          if (!(
#line 2431 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 121; /* *negdi2_dot2 */

        default:
          return -1;
        }

    case DIV:
      if (pattern173 (x1, pnum_clobbers, 
DIV) != 0
          || GET_MODE (x3) != E_CCmode)
        return -1;
      x11 = XEXP (x4, 0);
      operands[1] = x11;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      x8 = XVECEXP (x1, 0, 1);
      x14 = XEXP (x8, 0);
      operands[0] = x14;
      x9 = XEXP (x8, 1);
      x17 = XEXP (x9, 0);
      if (!rtx_equal_p (x17, operands[1]))
        return -1;
      x10 = XEXP (x9, 1);
      if (!rtx_equal_p (x10, operands[2]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (pattern541 (x9, 
E_SImode) != 0
              || !
#line 3420 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 1;
          return 185; /* *divsi3_sra_dot2 */

        case E_DImode:
          if (pattern541 (x9, 
E_DImode) != 0
              || !(
#line 3420 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 186; /* *divdi3_sra_dot2 */

        default:
          return -1;
        }

    case AND:
    case IOR:
    case XOR:
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x2, 0);
      if (!cc_reg_operand (x6, E_CCmode)
          || GET_MODE (x3) != E_CCmode)
        return -1;
      if (GET_CODE (x4) == AND)
        {
          res = recog_148 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[4] = x6;
      switch (pattern372 (x1))
        {
        case 0:
          if (!
#line 4016 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 217; /* *boolsi3_dot */

        case 1:
          if (!(
#line 4016 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 218; /* *booldi3_dot */

        case 2:
          if (!
#line 4039 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 219; /* *boolsi3_dot2 */

        case 3:
          if (!(
#line 4039 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 220; /* *booldi3_dot2 */

        case 4:
          if (!
#line 4071 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 223; /* *boolcsi3_dot */

        case 5:
          if (!(
#line 4071 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 224; /* *boolcdi3_dot */

        case 6:
          if (!
#line 4094 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 225; /* *boolcsi3_dot2 */

        case 7:
          if (!(
#line 4094 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 226; /* *boolcdi3_dot2 */

        case 8:
          if (!
#line 4126 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 229; /* *boolccsi3_dot */

        case 9:
          if (!(
#line 4126 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 230; /* *boolccdi3_dot */

        case 10:
          if (!
#line 4149 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 231; /* *boolccsi3_dot2 */

        case 11:
          if (!(
#line 4149 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 232; /* *boolccdi3_dot2 */

        default:
          return -1;
        }

    case ROTATE:
      switch (pattern175 (x1, 
ROTATE))
        {
        case 0:
          if (!
#line 4590 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 267; /* *rotlsi3_dot */

        case 1:
          if (!(
#line 4590 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 268; /* *rotldi3_dot */

        case 2:
          if (!
#line 4615 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 269; /* *rotlsi3_dot2 */

        case 3:
          if (!(
#line 4615 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 270; /* *rotldi3_dot2 */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern176 (x1))
        {
        case 0:
          if (!
#line 4658 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 274; /* *ashlsi3_dot */

        case 1:
          if (!(
#line 4658 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 275; /* *ashldi3_dot */

        case 2:
          if (!
#line 4683 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 276; /* *ashlsi3_dot2 */

        case 3:
          if (!(
#line 4683 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 277; /* *ashldi3_dot2 */

        case 4:
          if (!
#line 4732 "../../gcc/config/rs6000/rs6000.md"
(TARGET_EXTSWSLI))
            return -1;
          return 279; /* ashdi3_extswsli_dot */

        case 5:
          if (!
#line 4782 "../../gcc/config/rs6000/rs6000.md"
(TARGET_EXTSWSLI))
            return -1;
          return 280; /* ashdi3_extswsli_dot2 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern175 (x1, 
LSHIFTRT))
        {
        case 0:
          if (!
#line 4847 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 284; /* *lshrsi3_dot */

        case 1:
          if (!(
#line 4847 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 285; /* *lshrdi3_dot */

        case 2:
          if (!
#line 4872 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 286; /* *lshrsi3_dot2 */

        case 3:
          if (!(
#line 4872 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 287; /* *lshrdi3_dot2 */

        default:
          return -1;
        }

    case ASHIFTRT:
      if (pattern173 (x1, pnum_clobbers, 
ASHIFTRT) != 0
          || GET_MODE (x3) != E_CCmode)
        return -1;
      x11 = XEXP (x4, 0);
      operands[1] = x11;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      if (!reg_or_cint_operand (operands[2], E_SImode))
        return -1;
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 4945 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 1;
          return 293; /* *ashrsi3_dot2 */

        case 1:
          if (!(
#line 4945 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 294; /* *ashrdi3_dot2 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != SET)
        return -1;
      x6 = XEXP (x2, 0);
      operands[2] = x6;
      if (!cc_reg_operand (operands[2], E_CCmode))
        return -1;
      switch (pattern421 (x1))
        {
        case 0:
          if (!
#line 513 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64))
            return -1;
          return 563; /* *movsi_internal2 */

        case 1:
          if (!
#line 513 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 564; /* *movdi_internal2 */

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern177 (x1, 
CLOBBER, 
E_CCFPmode) != 0
          || GET_MODE (x3) != E_CCFPmode
          || GET_MODE (x4) != E_V2DFmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (!zero_constant (x5, E_V2DFmode))
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      x14 = XEXP (x8, 0);
      operands[0] = x14;
      switch (XVECLEN (x4, 0))
        {
        case 3:
          x26 = XVECEXP (x4, 0, 0);
          operands[1] = x26;
          x27 = XVECEXP (x4, 0, 1);
          operands[2] = x27;
          x28 = XVECEXP (x4, 0, 2);
          operands[3] = x28;
          if (!const_0_to_1_operand (operands[3], E_QImode))
            return -1;
          operands[4] = x5;
          switch (XINT (x4, 1))
            {
            case 342:
              switch (pattern548 ())
                {
                case 0:
                  if (!
#line 4610 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                    return -1;
                  return 2182; /* *bcdadd_test_v1ti */

                case 1:
                  if (!
#line 4610 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                    return -1;
                  return 2184; /* *bcdadd_test_v16qi */

                default:
                  return -1;
                }

            case 343:
              switch (pattern548 ())
                {
                case 0:
                  if (!
#line 4610 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                    return -1;
                  return 2183; /* *bcdsub_test_v1ti */

                case 1:
                  if (!
#line 4610 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                    return -1;
                  return 2185; /* *bcdsub_test_v16qi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 1:
          if (XINT (x4, 1) != 343)
            return -1;
          x26 = XVECEXP (x4, 0, 0);
          operands[1] = x26;
          operands[2] = x5;
          switch (GET_MODE (operands[1]))
            {
            case E_V1TImode:
              if (!register_operand (operands[1], E_V1TImode)
                  || !scratch_operand (operands[0], E_V1TImode)
                  || !
#line 4737 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2198; /* *bcdinvalid_v1ti */

            case E_V16QImode:
              if (!register_operand (operands[1], E_V16QImode)
                  || !scratch_operand (operands[0], E_V16QImode)
                  || !
#line 4737 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2199; /* *bcdinvalid_v16qi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MEM:
      switch (pattern181 (x1))
        {
        case 0:
          if (!
#line 28 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2352; /* *ld_cmpdi_cr0_DI_clobber_CC_none */

        case 1:
          if (!
#line 112 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2356; /* *lwz_cmpwi_cr0_SI_clobber_CC_none */

        case 2:
          if (!
#line 239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2362; /* *lha_cmpdi_cr0_HI_clobber_CC_sign */

        case 3:
          if (!(
#line 239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2363; /* *lha_cmpdi_cr0_HI_clobber_CC_sign */

        case 4:
          if (!
#line 49 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2353; /* *ld_cmpldi_cr0_DI_clobber_CCUNS_none */

        case 5:
          if (!
#line 133 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2357; /* *lwz_cmpldi_cr0_SI_clobber_CCUNS_none */

        case 6:
          if (!
#line 260 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2364; /* *lhz_cmpldi_cr0_HI_clobber_CCUNS_zero */

        case 7:
          if (!(
#line 260 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2365; /* *lhz_cmpldi_cr0_HI_clobber_CCUNS_zero */

        case 8:
          if (!
#line 323 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2370; /* *lbz_cmpldi_cr0_QI_clobber_CCUNS_zero */

        case 9:
          if (!(
#line 323 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2371; /* *lbz_cmpldi_cr0_QI_clobber_CCUNS_zero */

        case 10:
          if (!
#line 70 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2354; /* *ld_cmpdi_cr0_DI_DI_CC_none */

        case 11:
          if (!
#line 154 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2358; /* *lwz_cmpwi_cr0_SI_SI_CC_none */

        case 12:
          if (!
#line 91 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2355; /* *ld_cmpldi_cr0_DI_DI_CCUNS_none */

        case 13:
          if (!
#line 175 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2359; /* *lwz_cmpldi_cr0_SI_SI_CCUNS_none */

        case 14:
          if (!(
#line 196 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2360; /* *lwa_cmpdi_cr0_SI_EXTSI_CC_sign */

        case 15:
          if (!
#line 281 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2366; /* *lha_cmpdi_cr0_HI_EXTHI_CC_sign */

        case 16:
          if (!(
#line 281 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2367; /* *lha_cmpdi_cr0_HI_EXTHI_CC_sign */

        case 17:
          if (!(
#line 218 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2361; /* *lwz_cmpldi_cr0_SI_EXTSI_CCUNS_zero */

        case 18:
          if (!
#line 302 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2368; /* *lhz_cmpldi_cr0_HI_EXTHI_CCUNS_zero */

        case 19:
          if (!(
#line 302 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2369; /* *lhz_cmpldi_cr0_HI_EXTHI_CCUNS_zero */

        case 20:
          if (!
#line 344 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2372; /* *lbz_cmpldi_cr0_QI_GPR_CCUNS_zero */

        case 21:
          if (!(
#line 344 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2373; /* *lbz_cmpldi_cr0_QI_GPR_CCUNS_zero */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_178 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case EQ:
    case GE:
    case GT:
      operands[1] = x4;
      if (fpmask_comparison_operator (operands[1], E_CCFPmode))
        {
          switch (pattern292 (x1))
            {
            case 0:
              if (
#line 5665 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 370; /* *movsfsfcc_p9 */
              break;

            case 1:
              if (
#line 5665 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 372; /* *movsfdfcc_p9 */
              break;

            case 2:
              if (
#line 5665 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 371; /* *movdfsfcc_p9 */
              break;

            case 3:
              if (
#line 5665 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 373; /* *movdfdfcc_p9 */
              break;

            case 4:
              if ((
#line 5770 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return 382; /* *movkfcc_p10 */
              break;

            case 5:
              if ((
#line 5770 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return 383; /* *movtfcc_p10 */
              break;

            default:
              break;
            }
        }
      if (pnum_clobbers == NULL
          || pattern250 (x1, 
EQ) != 0)
        return -1;
      *pnum_clobbers = 2;
      return 903; /* bdz_di */

    case NE:
    case UNLE:
    case UNLT:
      operands[1] = x4;
      if (invert_fpmask_comparison_operator (operands[1], E_CCFPmode))
        {
          switch (pattern292 (x1))
            {
            case 0:
              if (
#line 5697 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 374; /* *movsfsfcc_invert_p9 */
              break;

            case 1:
              if (
#line 5697 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 376; /* *movsfdfcc_invert_p9 */
              break;

            case 2:
              if (
#line 5697 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 375; /* *movdfsfcc_invert_p9 */
              break;

            case 3:
              if (
#line 5697 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 377; /* *movdfdfcc_invert_p9 */
              break;

            case 4:
              if ((
#line 5802 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return 384; /* *movkfcc_invert_p10 */
              break;

            case 5:
              if ((
#line 5802 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return 385; /* *movtfcc_invert_p10 */
              break;

            default:
              break;
            }
        }
      if (pnum_clobbers == NULL
          || pattern250 (x1, 
NE) != 0)
        return -1;
      *pnum_clobbers = 2;
      return 904; /* bdnz_di */

    case AND:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XEXP (x4, 1);
      if (!branch_comparison_operator (x5, E_VOIDmode))
        return -1;
      operands[3] = x5;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != LABEL_REF)
        return -1;
      x8 = XEXP (x3, 2);
      if (GET_CODE (x8) != PC
          || pattern396 (x1) != 0)
        return -1;
      x9 = XEXP (x5, 0);
      operands[4] = x9;
      if (!cc_reg_operand (operands[4], E_VOIDmode))
        return -1;
      x10 = XEXP (x7, 0);
      operands[0] = x10;
      x11 = XVECEXP (x1, 0, 1);
      x12 = XEXP (x11, 0);
      operands[2] = x12;
      if (!nonimmediate_operand (operands[2], E_DImode))
        return -1;
      switch (pattern554 (x1))
        {
        case 0:
          *pnum_clobbers = 3;
          return 905; /* bdztf_di */

        case 1:
          *pnum_clobbers = 3;
          return 906; /* bdnztf_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_185 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != USE)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != USE)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x2, 0);
  operands[1] = x6;
  if (!symbol_ref_operand (operands[1], E_DImode))
    return -1;
  x7 = XEXP (x5, 0);
  operands[2] = x7;
  x8 = XEXP (x5, 1);
  operands[3] = x8;
  x9 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x9))
    {
    case CLOBBER:
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 96
          || GET_MODE (x10) != E_DImode)
        return -1;
      switch (REGNO (x4))
        {
        case 11:
          switch (GET_MODE (operands[2]))
            {
            case E_DImode:
              if (memory_operand (operands[2], E_DImode)
                  && gpc_reg_operand (operands[3], E_DImode))
                return 914; /* *save_gpregs_di_r11 */
              if (!gpc_reg_operand (operands[2], E_DImode)
                  || !memory_operand (operands[3], E_DImode))
                return -1;
              return 924; /* *restore_gpregs_di_r11 */

            case E_DFmode:
              if (!memory_operand (operands[2], E_DFmode)
                  || !gpc_reg_operand (operands[3], E_DFmode))
                return -1;
              return 917; /* *save_fpregs_di_r11 */

            default:
              return -1;
            }

        case 12:
          switch (GET_MODE (operands[2]))
            {
            case E_DImode:
              if (memory_operand (operands[2], E_DImode)
                  && gpc_reg_operand (operands[3], E_DImode))
                return 915; /* *save_gpregs_di_r12 */
              if (!gpc_reg_operand (operands[2], E_DImode)
                  || !memory_operand (operands[3], E_DImode))
                return -1;
              return 925; /* *restore_gpregs_di_r12 */

            case E_DFmode:
              if (!memory_operand (operands[2], E_DFmode)
                  || !gpc_reg_operand (operands[3], E_DFmode))
                return -1;
              return 918; /* *save_fpregs_di_r12 */

            default:
              return -1;
            }

        case 1:
          switch (GET_MODE (operands[2]))
            {
            case E_DImode:
              if (memory_operand (operands[2], E_DImode)
                  && gpc_reg_operand (operands[3], E_DImode))
                return 916; /* *save_gpregs_di_r1 */
              if (!gpc_reg_operand (operands[2], E_DImode)
                  || !memory_operand (operands[3], E_DImode))
                return -1;
              return 926; /* *restore_gpregs_di_r1 */

            case E_DFmode:
              if (!memory_operand (operands[2], E_DFmode)
                  || !gpc_reg_operand (operands[3], E_DFmode))
                return -1;
              return 919; /* *save_fpregs_di_r1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case RETURN:
      if (!gpc_reg_operand (operands[2], E_DFmode)
          || !memory_operand (operands[3], E_DFmode))
        return -1;
      switch (REGNO (x4))
        {
        case 11:
          return 933; /* *return_and_restore_fpregs_aix_di_r11 */

        case 1:
          return 934; /* *return_and_restore_fpregs_aix_di_r1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_5 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern75 (x1))
    {
    case 0:
      if (!(
#line 5879 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX
   && TARGET_FCFIDS && can_create_pseudo_p ()) && 
#line 5882 "../../gcc/config/rs6000/rs6000.md"
( 1)))
        return NULL;
      return gen_split_173 (insn, operands);

    case 1:
      if (memory_operand (operands[1], E_DImode)
          && scratch_operand (operands[2], E_DImode)
          && (
#line 7048 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDS) && 
#line 7050 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return gen_split_227 (insn, operands);
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !scratch_operand (operands[2], E_DFmode)
          || !(
#line 7068 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FCFID && TARGET_HARD_FLOAT && !TARGET_FCFIDS) && 
#line 7070 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return NULL;
      return gen_split_228 (insn, operands);

    case 2:
      if (!(
#line 5879 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX
   && TARGET_FCFID && can_create_pseudo_p ()) && 
#line 5882 "../../gcc/config/rs6000/rs6000.md"
( 1)))
        return NULL;
      return gen_split_174 (insn, operands);

    case 3:
      if (!(
#line 6975 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFID) && 
#line 6977 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return NULL;
      return gen_split_225 (insn, operands);

    case 4:
      if (!((
#line 15328 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15330 "../../gcc/config/rs6000/rs6000.md"
( 1)))
        return NULL;
      return gen_split_504 (insn, operands);

    case 5:
      if (!((
#line 15347 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15349 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return NULL;
      return gen_split_506 (insn, operands);

    case 6:
      if (!((
#line 15347 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15349 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return NULL;
      return gen_split_507 (insn, operands);

    case 7:
      if (!((
#line 15328 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15330 "../../gcc/config/rs6000/rs6000.md"
( 1)))
        return NULL;
      return gen_split_505 (insn, operands);

    case 8:
      if (!((
#line 15347 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15349 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return NULL;
      return gen_split_508 (insn, operands);

    case 9:
      if (!((
#line 15347 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15349 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return NULL;
      return gen_split_509 (insn, operands);

    case 10:
      if (!(
#line 5920 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX && TARGET_FCFIDS) && 
#line 5922 "../../gcc/config/rs6000/rs6000.md"
( 1)))
        return NULL;
      return gen_split_175 (insn, operands);

    case 11:
      if (!(
#line 5920 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX && TARGET_FCFID) && 
#line 5922 "../../gcc/config/rs6000/rs6000.md"
( 1)))
        return NULL;
      return gen_split_176 (insn, operands);

    case 12:
      if (!(
#line 5944 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDS && TARGET_P9_VECTOR
   && TARGET_DIRECT_MOVE_64BIT) && 
#line 5947 "../../gcc/config/rs6000/rs6000.md"
( 1)))
        return NULL;
      return gen_split_177 (insn, operands);

    case 13:
      if (!(
#line 5944 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDS && TARGET_P9_VECTOR
   && TARGET_DIRECT_MOVE_64BIT) && 
#line 5947 "../../gcc/config/rs6000/rs6000.md"
( 1)))
        return NULL;
      return gen_split_178 (insn, operands);

    case 14:
      if (!(
#line 5944 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFID && TARGET_P9_VECTOR
   && TARGET_DIRECT_MOVE_64BIT) && 
#line 5947 "../../gcc/config/rs6000/rs6000.md"
( 1)))
        return NULL;
      return gen_split_179 (insn, operands);

    case 15:
      if (!(
#line 5944 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFID && TARGET_P9_VECTOR
   && TARGET_DIRECT_MOVE_64BIT) && 
#line 5947 "../../gcc/config/rs6000/rs6000.md"
( 1)))
        return NULL;
      return gen_split_180 (insn, operands);

    case 16:
      if (const_0_to_3_operand (operands[2], E_QImode)
          && scratch_operand (operands[3], E_V4SImode)
          && (
#line 4437 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4439 "../../gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_621 (insn, operands);
      if (!const_int_operand (operands[2], E_QImode)
          || !scratch_operand (operands[3], E_SImode)
          || !(
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4546 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
        return NULL;
      return gen_split_640 (insn, operands);

    case 17:
      if (!(
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4546 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
        return NULL;
      return gen_split_632 (insn, operands);

    case 18:
      if (!(
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4546 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
        return NULL;
      return gen_split_636 (insn, operands);

    case 19:
      if (!(
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4546 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
        return NULL;
      return gen_split_631 (insn, operands);

    case 20:
      if (!(
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4546 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
        return NULL;
      return gen_split_635 (insn, operands);

    case 21:
      if (!(
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4546 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
        return NULL;
      return gen_split_639 (insn, operands);

    case 22:
      if (!((
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)) && 
#line 4546 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
        return NULL;
      return gen_split_633 (insn, operands);

    case 23:
      if (!((
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)) && 
#line 4546 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
        return NULL;
      return gen_split_637 (insn, operands);

    case 24:
      if (!((
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)) && 
#line 4546 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
        return NULL;
      return gen_split_641 (insn, operands);

    case 25:
      if (!((
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))) && 
#line 4546 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
        return NULL;
      return gen_split_634 (insn, operands);

    case 26:
      if (!((
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))) && 
#line 4546 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
        return NULL;
      return gen_split_638 (insn, operands);

    case 27:
      if (!((
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))) && 
#line 4546 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
        return NULL;
      return gen_split_642 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_8 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return NULL;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != CLOBBER)
    return NULL;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case FLOAT:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern297 (x1))
        {
        case 0:
          if (!(
#line 6217 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT) && 
#line 6219 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_187 (insn, operands);

        case 1:
          if (!(
#line 6217 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT) && 
#line 6219 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_188 (insn, operands);

        case 2:
          if (!(
#line 6217 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT) && 
#line 6219 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_189 (insn, operands);

        case 3:
          if (!(
#line 6217 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT) && 
#line 6219 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_190 (insn, operands);

        default:
          return NULL;
        }

    case EQ:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern110 (x1))
        {
        case 0:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_401 (insn, operands);

        case 1:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_421 (insn, operands);

        case 2:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_411 (insn, operands);

        case 3:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_431 (insn, operands);

        default:
          return NULL;
        }

    case NE:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      x9 = XEXP (x5, 1);
      operands[2] = x9;
      x10 = XEXP (x6, 0);
      operands[3] = x10;
      x11 = XEXP (x3, 0);
      operands[4] = x11;
      x12 = XEXP (x4, 0);
      operands[5] = x12;
      switch (pattern506 (x5))
        {
        case 0:
          if ((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return gen_split_402 (insn, operands);
          break;

        case 1:
          if (((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return gen_split_422 (insn, operands);
          break;

        case 2:
          if (reg_or_short_operand (operands[2], E_SImode)
              && scratch_operand (operands[3], E_DImode)
              && scratch_operand (operands[4], E_DImode)
              && scratch_operand (operands[5], E_CCmode)
              && ((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return gen_split_412 (insn, operands);
          if (scc_eq_operand (operands[2], E_SImode)
              && scratch_operand (operands[3], E_SImode)
              && scratch_operand (operands[4], E_SImode)
              && scratch_operand (operands[5], E_DImode)
              && ((
#line 13248 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_ISEL) && 
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13250 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return gen_split_451 (insn, operands);
          break;

        case 3:
          if (((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(NE == EQ && operands[2] == const0_rtx)
   && !(NE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return gen_split_432 (insn, operands);
          break;

        default:
          break;
        }
      if (!scratch_operand (operands[4], E_DImode)
          || pattern507 (x1) != 0
          || !((
#line 12993 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 12995 "../../gcc/config/rs6000/rs6000.md"
( 1)))
        return NULL;
      return gen_split_443 (insn, operands);

    case LT:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern110 (x1))
        {
        case 0:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_403 (insn, operands);

        case 1:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_423 (insn, operands);

        case 2:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_413 (insn, operands);

        case 3:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_433 (insn, operands);

        default:
          return NULL;
        }

    case LTU:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern113 (x1))
        {
        case 0:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_404 (insn, operands);

        case 1:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_424 (insn, operands);

        case 2:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_414 (insn, operands);

        case 3:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_434 (insn, operands);

        default:
          return NULL;
        }

    case GT:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern110 (x1))
        {
        case 0:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_405 (insn, operands);

        case 1:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_425 (insn, operands);

        case 2:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_415 (insn, operands);

        case 3:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_435 (insn, operands);

        default:
          return NULL;
        }

    case GTU:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern113 (x1))
        {
        case 0:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_406 (insn, operands);

        case 1:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_426 (insn, operands);

        case 2:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_416 (insn, operands);

        case 3:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_436 (insn, operands);

        default:
          return NULL;
        }

    case LE:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern110 (x1))
        {
        case 0:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_407 (insn, operands);

        case 1:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_427 (insn, operands);

        case 2:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_417 (insn, operands);

        case 3:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_437 (insn, operands);

        default:
          return NULL;
        }

    case LEU:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern113 (x1))
        {
        case 0:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_408 (insn, operands);

        case 1:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_428 (insn, operands);

        case 2:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_418 (insn, operands);

        case 3:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LEU == EQ && operands[2] == const0_rtx)
   && !(LEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_438 (insn, operands);

        default:
          return NULL;
        }

    case GE:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern110 (x1))
        {
        case 0:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_409 (insn, operands);

        case 1:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_429 (insn, operands);

        case 2:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_419 (insn, operands);

        case 3:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_439 (insn, operands);

        default:
          return NULL;
        }

    case GEU:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern113 (x1))
        {
        case 0:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_410 (insn, operands);

        case 1:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_430 (insn, operands);

        case 2:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_420 (insn, operands);

        case 3:
          if (!((
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GEU == EQ && operands[2] == const0_rtx)
   && !(GEU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12829 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_440 (insn, operands);

        default:
          return NULL;
        }

    case NEG:
      if (GET_MODE (x5) != E_DImode)
        return NULL;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern339 (x1))
        {
        case 0:
          if (!((
#line 13026 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 13028 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_444 (insn, operands);

        case 1:
          if (!((
#line 13058 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 13060 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_445 (insn, operands);

        default:
          return NULL;
        }

    case PLUS:
      if (GET_MODE (x5) != E_DImode)
        return NULL;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern340 (x1))
        {
        case 0:
          return gen_split_446 (insn, operands);

        case 1:
          return gen_split_447 (insn, operands);

        default:
          return NULL;
        }

    case MINUS:
      if (GET_MODE (x5) != E_DImode)
        return NULL;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern341 (x1))
        {
        case 0:
          return gen_split_448 (insn, operands);

        case 1:
          return gen_split_449 (insn, operands);

        default:
          return NULL;
        }

    case IF_THEN_ELSE:
      x8 = XEXP (x5, 0);
      if (!comparison_operator (x8, E_VOIDmode))
        return NULL;
      operands[2] = x8;
      x13 = XEXP (x8, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || pattern396 (x1) != 0)
        return NULL;
      x14 = XEXP (x8, 0);
      operands[1] = x14;
      if (!gpc_reg_operand (operands[1], E_DImode))
        return NULL;
      x9 = XEXP (x5, 1);
      operands[5] = x9;
      x15 = XEXP (x5, 2);
      operands[6] = x15;
      x6 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x6, 0);
      operands[0] = x10;
      if (!nonimmediate_operand (operands[0], E_DImode))
        return NULL;
      x11 = XEXP (x3, 0);
      operands[3] = x11;
      if (!scratch_operand (operands[3], E_CCmode))
        return NULL;
      x12 = XEXP (x4, 0);
      operands[4] = x12;
      if (!scratch_operand (operands[4], E_DImode))
        return NULL;
      x16 = XEXP (x6, 1);
      x17 = XEXP (x16, 0);
      if (!rtx_equal_p (x17, operands[1])
          || !(
#line 13768 "../../gcc/config/rs6000/rs6000.md"
(reload_completed) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return NULL;
      return gen_split_474 (insn, operands);

    case VEC_SELECT:
      if (GET_MODE (x5) != E_SFmode)
        return NULL;
      x9 = XEXP (x5, 1);
      if (GET_CODE (x9) != PARALLEL
          || XVECLEN (x9, 0) != 1)
        return NULL;
      x18 = XVECEXP (x9, 0, 0);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return NULL;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return NULL;
      switch (pattern459 (x1))
        {
        case 0:
          if (!(
#line 5024 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)) && 
#line 5026 "../../gcc/config/rs6000/vsx.md"
( 1)))
            return NULL;
          return gen_split_668 (insn, operands);

        case 1:
          if (!(
#line 5024 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)) && 
#line 5026 "../../gcc/config/rs6000/vsx.md"
( 1)))
            return NULL;
          return gen_split_669 (insn, operands);

        case 2:
          if (!(
#line 5024 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)) && 
#line 5026 "../../gcc/config/rs6000/vsx.md"
( 1)))
            return NULL;
          return gen_split_670 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
