/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern12 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
      if (XWINT (x2, 0) != 0L
          || !cc_reg_operand (operands[1], E_CCFPmode))
        return -1;
      return pattern9 (x1); /* [-1, 1] */

    case REG:
    case SUBREG:
      res = pattern11 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern21 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  return pattern11 (x3); /* [-1, 1] */
}

int
pattern24 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  if (!cc_reg_operand (operands[2], E_CCmode)
      || GET_MODE (x2) != E_CCmode)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  switch (GET_MODE (x5))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern33 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != AND
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + -16])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], i1))
    return -1;
  x6 = XEXP (x3, 0);
  return pattern32 (x6); /* [-1, 1] */
}

int
pattern41 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      return pattern38 (x3); /* [-1, 1] */

    case NOT:
      res = pattern40 (x3);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern49 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern55 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern62 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!indexed_or_indirect_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode)
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern69 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 1;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern76 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!memory_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern81 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!vfloat_operand (operands[1], E_V2DFmode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  if (!scratch_operand (operands[2], E_V2DFmode))
    return -1;
  x9 = XEXP (x4, 1);
  x10 = XEXP (x9, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x3, 1);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  return 0;
}

int
pattern89 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !short_cint_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern95 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  operands[3] = x5;
  if (!cc_reg_operand (operands[3], E_CCmode))
    return -1;
  x6 = XEXP (x3, 0);
  switch (GET_CODE (x6))
    {
    case PLUS:
      x7 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 98)
        return -1;
      x9 = XEXP (x6, 0);
      operands[1] = x9;
      x10 = XEXP (x6, 1);
      operands[2] = x10;
      x11 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x11))
        {
        case CLOBBER:
          x12 = XEXP (x11, 0);
          operands[0] = x12;
          switch (GET_MODE (x6))
            {
            case E_SImode:
              return pattern88 (x8, 
E_SImode); /* [-1, 0] */

            case E_DImode:
              if (pattern88 (x8, 
E_DImode) != 0)
                return -1;
              return 1;

            default:
              return -1;
            }

        case SET:
          x13 = XEXP (x11, 1);
          if (GET_CODE (x13) != PLUS)
            return -1;
          x12 = XEXP (x11, 0);
          operands[0] = x12;
          x14 = XEXP (x13, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          x15 = XEXP (x13, 1);
          if (!rtx_equal_p (x15, operands[2]))
            return -1;
          switch (GET_MODE (x6))
            {
            case E_SImode:
              if (pattern89 (x1, 
E_SImode) != 0)
                return -1;
              return 2;

            case E_DImode:
              if (pattern89 (x1, 
E_DImode) != 0)
                return -1;
              return 3;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x11 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x11) != SET)
        return -1;
      x13 = XEXP (x11, 1);
      if (GET_CODE (x13) != MINUS)
        return -1;
      x7 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x7) != SET)
        return -1;
      x16 = XEXP (x7, 1);
      if (GET_CODE (x16) != LEU)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 98)
        return -1;
      x9 = XEXP (x6, 0);
      operands[2] = x9;
      x10 = XEXP (x6, 1);
      operands[1] = x10;
      x12 = XEXP (x11, 0);
      operands[0] = x12;
      x14 = XEXP (x13, 0);
      if (!rtx_equal_p (x14, operands[2]))
        return -1;
      x15 = XEXP (x13, 1);
      if (!rtx_equal_p (x15, operands[1]))
        return -1;
      x17 = XEXP (x16, 0);
      if (!rtx_equal_p (x17, operands[1]))
        return -1;
      x18 = XEXP (x16, 1);
      if (!rtx_equal_p (x18, operands[2]))
        return -1;
      switch (GET_MODE (x6))
        {
        case E_SImode:
          if (pattern90 (x1, 
E_SImode) != 0)
            return -1;
          return 4;

        case E_DImode:
          if (pattern90 (x1, 
E_DImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    case DIV:
      x7 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 98)
        return -1;
      x9 = XEXP (x6, 0);
      operands[1] = x9;
      x10 = XEXP (x6, 1);
      operands[2] = x10;
      x11 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x11))
        {
        case CLOBBER:
          x12 = XEXP (x11, 0);
          operands[0] = x12;
          switch (GET_MODE (x6))
            {
            case E_SImode:
              if (pattern91 (x8, 
E_SImode) != 0)
                return -1;
              return 6;

            case E_DImode:
              if (pattern91 (x8, 
E_DImode) != 0)
                return -1;
              return 7;

            default:
              return -1;
            }

        case SET:
          x13 = XEXP (x11, 1);
          if (GET_CODE (x13) != DIV)
            return -1;
          x12 = XEXP (x11, 0);
          operands[0] = x12;
          x14 = XEXP (x13, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          x15 = XEXP (x13, 1);
          if (!rtx_equal_p (x15, operands[2]))
            return -1;
          switch (GET_MODE (x6))
            {
            case E_SImode:
              if (pattern92 (x1, 
E_SImode) != 0)
                return -1;
              return 8;

            case E_DImode:
              if (pattern92 (x1, 
E_DImode) != 0)
                return -1;
              return 9;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      x7 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x9 = XEXP (x6, 0);
      operands[1] = x9;
      x10 = XEXP (x6, 1);
      operands[2] = x10;
      x8 = XEXP (x7, 0);
      operands[4] = x8;
      if (!scratch_operand (operands[4], E_CCmode))
        return -1;
      x11 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x11))
        {
        case CLOBBER:
          x12 = XEXP (x11, 0);
          operands[0] = x12;
          switch (GET_MODE (x6))
            {
            case E_SImode:
              if (!gpc_reg_operand (operands[1], E_SImode)
                  || !logical_const_operand (operands[2], E_SImode)
                  || !scratch_operand (operands[0], E_SImode))
                return -1;
              return 10;

            case E_DImode:
              if (!gpc_reg_operand (operands[1], E_DImode)
                  || !logical_const_operand (operands[2], E_DImode)
                  || !scratch_operand (operands[0], E_DImode))
                return -1;
              return 11;

            default:
              return -1;
            }

        case SET:
          x13 = XEXP (x11, 1);
          if (GET_CODE (x13) != AND)
            return -1;
          x12 = XEXP (x11, 0);
          operands[0] = x12;
          x14 = XEXP (x13, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          x15 = XEXP (x13, 1);
          if (!rtx_equal_p (x15, operands[2]))
            return -1;
          switch (GET_MODE (x6))
            {
            case E_SImode:
              if (pattern93 (x13, 
E_SImode) != 0)
                return -1;
              return 12;

            case E_DImode:
              if (pattern93 (x13, 
E_DImode) != 0)
                return -1;
              return 13;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      x7 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 98)
        return -1;
      x9 = XEXP (x6, 0);
      operands[1] = x9;
      x10 = XEXP (x6, 1);
      operands[2] = x10;
      if (!reg_or_cint_operand (operands[2], E_SImode))
        return -1;
      x11 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x11))
        {
        case CLOBBER:
          x12 = XEXP (x11, 0);
          operands[0] = x12;
          switch (GET_MODE (x6))
            {
            case E_SImode:
              if (!gpc_reg_operand (operands[1], E_SImode)
                  || !scratch_operand (operands[0], E_SImode)
                  || GET_MODE (x8) != E_SImode)
                return -1;
              return 14;

            case E_DImode:
              if (!gpc_reg_operand (operands[1], E_DImode)
                  || !scratch_operand (operands[0], E_DImode)
                  || GET_MODE (x8) != E_DImode)
                return -1;
              return 15;

            default:
              return -1;
            }

        case SET:
          x13 = XEXP (x11, 1);
          if (GET_CODE (x13) != ASHIFTRT)
            return -1;
          x12 = XEXP (x11, 0);
          operands[0] = x12;
          x14 = XEXP (x13, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          x15 = XEXP (x13, 1);
          if (!rtx_equal_p (x15, operands[2]))
            return -1;
          switch (GET_MODE (x6))
            {
            case E_SImode:
              if (pattern94 (x1, 
E_SImode) != 0)
                return -1;
              return 16;

            case E_DImode:
              if (pattern94 (x1, 
E_DImode) != 0)
                return -1;
              return 17;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern201 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern207 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 0;

    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern216 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!vsx_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !vsx_register_operand (operands[1], E_V4SFmode))
        return -1;
      return 0;

    case E_V2DFmode:
      if (!vsx_register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || !vsx_register_operand (operands[1], E_V2DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern224 (rtx x1, machine_mode i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 106
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC
      || XVECLEN (x6, 0) != 2
      || XINT (x6, 1) != i2
      || GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern231 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern236 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern245 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  switch (GET_CODE (x8))
    {
    case NOT:
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      x10 = XEXP (x7, 1);
      switch (GET_CODE (x10))
        {
        case NOT:
          return pattern243 (x6); /* [-1, 23] */

        case REG:
        case SUBREG:
          res = pattern239 (x6);
          if (res >= 0)
            return res + 24; /* [24, 47] */
          return -1;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      res = pattern234 (x6);
      if (res >= 0)
        return res + 48; /* [48, 71] */
      return -1;

    default:
      return -1;
    }
}

int
pattern255 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern257 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern256 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern256 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern263 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern261 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern261 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern262 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern262 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern262 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern262 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern262 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern262 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern262 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern262 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern262 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern262 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern280 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != NOT)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  operands[1] = x6;
  x7 = XEXP (x2, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern266 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern266 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern287 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 98)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  return 0;
}

int
pattern295 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  return pattern293 (x5); /* [-1, 1] */
}

int
pattern301 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  operands[2] = x2;
  if (!u5bit_cint_operand (operands[2], E_QImode))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!altivec_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !const_vector_each_byte_same (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!altivec_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !const_vector_each_byte_same (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V16QImode:
      if (!altivec_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !const_vector_each_byte_same (operands[1], E_V16QImode))
        return -1;
      return 2;

    case E_V4SFmode:
      if (!altivec_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !const_vector_each_byte_same (operands[1], E_V4SFmode))
        return -1;
      return 3;

    case E_V2DFmode:
      if (!altivec_register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || !const_vector_each_byte_same (operands[1], E_V2DFmode))
        return -1;
      return 4;

    case E_V2DImode:
      if (!altivec_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !const_vector_each_byte_same (operands[1], E_V2DImode))
        return -1;
      return 5;

    case E_V1TImode:
      if (!altivec_register_operand (operands[0], E_V1TImode)
          || GET_MODE (x1) != E_V1TImode
          || !const_vector_each_byte_same (operands[1], E_V1TImode))
        return -1;
      return 6;

    case E_TImode:
      if (!altivec_register_operand (operands[0], E_TImode)
          || GET_MODE (x1) != E_TImode
          || !const_vector_each_byte_same (operands[1], E_TImode))
        return -1;
      return 7;

    case E_KFmode:
      if (!altivec_register_operand (operands[0], E_KFmode)
          || GET_MODE (x1) != E_KFmode
          || !const_vector_each_byte_same (operands[1], E_KFmode))
        return -1;
      return 8;

    case E_TFmode:
      if (!altivec_register_operand (operands[0], E_TFmode)
          || GET_MODE (x1) != E_TFmode
          || !const_vector_each_byte_same (operands[1], E_TFmode))
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern344 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !non_add_cint_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern350 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern355 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vlogical_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vlogical_operand (operands[1], i1)
      || !vlogical_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern360 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern371 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!boolean_operator (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern381 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern388 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != NOT)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case NOT:
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      x8 = XEXP (x5, 1);
      switch (GET_CODE (x8))
        {
        case NOT:
          return pattern383 (x1); /* [-1, 11] */

        case REG:
        case SUBREG:
          res = pattern380 (x1);
          if (res >= 0)
            return res + 12; /* [12, 23] */
          return -1;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      res = pattern377 (x1);
      if (res >= 0)
        return res + 24; /* [24, 35] */
      return -1;

    default:
      return -1;
    }
}

int
pattern397 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern399 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern405 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern403 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern403 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern404 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern404 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern404 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern404 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern404 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern404 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern404 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern404 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern404 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern404 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern425 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern431 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern439 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern449 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern448 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern448 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern458 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 102
      || GET_MODE (x2) != E_V4SFmode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 1);
  operands[1] = x4;
  if (!vfloat_operand (operands[1], E_V4SFmode))
    return -1;
  return 0;
}

int
pattern465 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern471 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  if (!scratch_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (x4))
    {
    case E_QImode:
      if (!gpc_reg_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!gpc_reg_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern483 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  switch (GET_CODE (x2))
    {
    case SIGN_EXTEND:
      if (GET_CODE (x3) != SIGN_EXTEND)
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], i1))
        return -1;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      if (!gpc_reg_operand (operands[2], i1))
        return -1;
      return 0;

    case ZERO_EXTEND:
      if (GET_CODE (x3) != ZERO_EXTEND)
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], i1))
        return -1;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      if (!gpc_reg_operand (operands[2], i1))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern498 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern496 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern496 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern497 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern497 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern497 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern497 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern497 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern497 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern497 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern497 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern497 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern497 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern520 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern533 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !rotate_mask_operator (operands[4], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !const_int_operand (operands[3], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[5], i1)
      || !const_int_operand (operands[6], i1))
    return -1;
  return 0;
}

int
pattern544 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern551 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern560 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  x12 = XEXP (x9, 1);
  x13 = XEXP (x12, 0);
  operands[1] = x13;
  if (!gpc_reg_operand (operands[1], E_HImode))
    return -1;
  x14 = XEXP (x4, 0);
  x15 = XEXP (x14, 0);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  x16 = XEXP (x5, 0);
  if (!rtx_equal_p (x16, operands[1]))
    return -1;
  return 0;
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern309 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 5618 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 358; /* *setnbc_cc_si */

        case 1:
          if (!
#line 5618 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 360; /* *setnbc_ccuns_si */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern309 (x2, 
E_DImode))
        {
        case 0:
          if (!(
#line 5618 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 359; /* *setnbc_cc_di */

        case 1:
          if (!(
#line 5618 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 361; /* *setnbc_ccuns_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case GE:
    case LE:
    case GEU:
    case LEU:
    case ORDERED:
      res = recog_10 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  switch (GET_CODE (x3))
    {
    case GE:
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      operands[4] = x6;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      x8 = XEXP (x2, 2);
      operands[3] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          switch (pattern406 (x2, 
E_SFmode))
            {
            case 0:
              if (!
#line 5652 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_PPC_GFXOPT))
                return -1;
              return 366; /* *fselsfsf4 */

            case 1:
              if (!
#line 5652 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_PPC_GFXOPT))
                return -1;
              return 368; /* *fselsfdf4 */

            default:
              return -1;
            }

        case E_DFmode:
          switch (pattern406 (x2, 
E_DFmode))
            {
            case 0:
              if (!
#line 5652 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_PPC_GFXOPT))
                return -1;
              return 367; /* *fseldfsf4 */

            case 1:
              if (!
#line 5652 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_PPC_GFXOPT))
                return -1;
              return 369; /* *fseldfdf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NE:
    case UNLE:
    case UNLT:
      if (pnum_clobbers == NULL)
        return -1;
      operands[1] = x3;
      if (!invert_fpmask_comparison_operator (operands[1], E_CCFPmode))
        return -1;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      x6 = XEXP (x3, 1);
      operands[3] = x6;
      x7 = XEXP (x2, 1);
      operands[4] = x7;
      x8 = XEXP (x2, 2);
      operands[5] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          switch (pattern479 (x2, 
E_SFmode))
            {
            case 0:
              if (!
#line 5697 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 374; /* *movsfsfcc_invert_p9 */

            case 1:
              if (!
#line 5697 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 376; /* *movsfdfcc_invert_p9 */

            default:
              return -1;
            }

        case E_DFmode:
          switch (pattern479 (x2, 
E_DFmode))
            {
            case 0:
              if (!
#line 5697 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 375; /* *movdfsfcc_invert_p9 */

            case 1:
              if (!
#line 5697 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 377; /* *movdfdfcc_invert_p9 */

            default:
              return -1;
            }

        case E_KFmode:
          if (pattern480 (x2, 
E_KFmode) != 0
              || !(
#line 5802 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 384; /* *movkfcc_invert_p10 */

        case E_TFmode:
          if (pattern480 (x2, 
E_TFmode) != 0
              || !(
#line 5802 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 385; /* *movtfcc_invert_p10 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case AND:
          x6 = XEXP (x1, 0);
          operands[0] = x6;
          x7 = XEXP (x3, 0);
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (pattern464 (x2, 
E_V4SImode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_V4SImode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && 
#line 703 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SImode)))
                    return 1749; /* altivec_vselv4si */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_V4SImode)
                  || !rtx_equal_p (x9, operands[3])
                  || !
#line 719 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SImode)))
                return -1;
              return 1759; /* altivec_vselv4si2 */

            case E_V8HImode:
              if (pattern464 (x2, 
E_V8HImode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_V8HImode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && 
#line 703 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V8HImode)))
                    return 1750; /* altivec_vselv8hi */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_V8HImode)
                  || !rtx_equal_p (x9, operands[3])
                  || !
#line 719 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V8HImode)))
                return -1;
              return 1760; /* altivec_vselv8hi2 */

            case E_V16QImode:
              if (pattern464 (x2, 
E_V16QImode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_V16QImode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && 
#line 703 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V16QImode)))
                    return 1751; /* altivec_vselv16qi */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_V16QImode)
                  || !rtx_equal_p (x9, operands[3])
                  || !
#line 719 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V16QImode)))
                return -1;
              return 1761; /* altivec_vselv16qi2 */

            case E_V4SFmode:
              if (pattern464 (x2, 
E_V4SFmode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_V4SFmode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && 
#line 703 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SFmode)))
                    return 1752; /* altivec_vselv4sf */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_V4SFmode)
                  || !rtx_equal_p (x9, operands[3])
                  || !
#line 719 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SFmode)))
                return -1;
              return 1762; /* altivec_vselv4sf2 */

            case E_V2DFmode:
              if (pattern464 (x2, 
E_V2DFmode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_V2DFmode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && 
#line 703 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DFmode)))
                    return 1753; /* altivec_vselv2df */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_V2DFmode)
                  || !rtx_equal_p (x9, operands[3])
                  || !
#line 719 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DFmode)))
                return -1;
              return 1763; /* altivec_vselv2df2 */

            case E_V2DImode:
              if (pattern464 (x2, 
E_V2DImode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_V2DImode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && 
#line 703 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DImode)))
                    return 1754; /* altivec_vselv2di */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_V2DImode)
                  || !rtx_equal_p (x9, operands[3])
                  || !
#line 719 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DImode)))
                return -1;
              return 1764; /* altivec_vselv2di2 */

            case E_V1TImode:
              if (pattern464 (x2, 
E_V1TImode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_V1TImode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && 
#line 703 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode)))
                    return 1755; /* altivec_vselv1ti */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_V1TImode)
                  || !rtx_equal_p (x9, operands[3])
                  || !
#line 719 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode)))
                return -1;
              return 1765; /* altivec_vselv1ti2 */

            case E_TImode:
              if (pattern464 (x2, 
E_TImode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_TImode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && 
#line 703 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TImode)))
                    return 1756; /* altivec_vselti */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_TImode)
                  || !rtx_equal_p (x9, operands[3])
                  || !
#line 719 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TImode)))
                return -1;
              return 1766; /* altivec_vselti2 */

            case E_KFmode:
              if (pattern464 (x2, 
E_KFmode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_KFmode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && (
#line 703 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return 1757; /* altivec_vselkf */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_KFmode)
                  || !rtx_equal_p (x9, operands[3])
                  || !(
#line 719 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 1767; /* altivec_vselkf2 */

            case E_TFmode:
              if (pattern464 (x2, 
E_TFmode) != 0)
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (register_operand (operands[2], E_TFmode))
                {
                  x10 = XEXP (x5, 0);
                  if (rtx_equal_p (x10, operands[3])
                      && (
#line 703 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TFmode)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return 1758; /* altivec_vseltf */
                }
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_TFmode)
                  || !rtx_equal_p (x9, operands[3])
                  || !(
#line 719 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TFmode)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 1768; /* altivec_vseltf2 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x5;
          x6 = XEXP (x1, 0);
          operands[3] = x6;
          x7 = XEXP (x3, 0);
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern49 (x2, 
E_SImode) != 0
                  || !
#line 1213 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2468; /* *fuse_andc_or */

            case E_DImode:
              if (pattern49 (x2, 
E_DImode) != 0
                  || !(
#line 1213 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2469; /* *fuse_andc_or */

            case E_V4SImode:
              if (pattern50 (x2, 
E_V4SImode) != 0
                  || !
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2952; /* *fuse_vandc_vor */

            case E_V8HImode:
              if (pattern50 (x2, 
E_V8HImode) != 0
                  || !
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2953; /* *fuse_vandc_vor */

            case E_V16QImode:
              if (pattern50 (x2, 
E_V16QImode) != 0
                  || !
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2954; /* *fuse_vandc_vor */

            case E_V4SFmode:
              if (pattern50 (x2, 
E_V4SFmode) != 0
                  || !
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2955; /* *fuse_vandc_vor */

            case E_V2DFmode:
              if (pattern50 (x2, 
E_V2DFmode) != 0
                  || !
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2956; /* *fuse_vandc_vor */

            case E_V2DImode:
              if (pattern50 (x2, 
E_V2DImode) != 0
                  || !
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2957; /* *fuse_vandc_vor */

            case E_V1TImode:
              if (pattern50 (x2, 
E_V1TImode) != 0
                  || !
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2958; /* *fuse_vandc_vor */

            case E_TImode:
              if (pattern50 (x2, 
E_TImode) != 0
                  || !
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2959; /* *fuse_vandc_vor */

            case E_KFmode:
              if (pattern50 (x2, 
E_KFmode) != 0
                  || !(
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2960; /* *fuse_vandc_vor */

            case E_TFmode:
              if (pattern50 (x2, 
E_TFmode) != 0
                  || !(
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2961; /* *fuse_vandc_vor */

            default:
              return -1;
            }

        case NOT:
          if (pnum_clobbers == NULL)
            return -1;
          x6 = XEXP (x1, 0);
          operands[3] = x6;
          x7 = XEXP (x3, 0);
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          switch (pattern53 (x2))
            {
            case 0:
              if (!
#line 1393 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2488; /* *fuse_andc_orc */

            case 1:
              if (!(
#line 1393 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2489; /* *fuse_andc_orc */

            case 2:
              if (!
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3032; /* *fuse_vandc_vorc */

            case 3:
              if (!
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3033; /* *fuse_vandc_vorc */

            case 4:
              if (!
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3034; /* *fuse_vandc_vorc */

            case 5:
              if (!
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3035; /* *fuse_vandc_vorc */

            case 6:
              if (!
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3036; /* *fuse_vandc_vorc */

            case 7:
              if (!
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3037; /* *fuse_vandc_vorc */

            case 8:
              if (!
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3038; /* *fuse_vandc_vorc */

            case 9:
              if (!
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3039; /* *fuse_vandc_vorc */

            case 10:
              if (!(
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3040; /* *fuse_vandc_vorc */

            case 11:
              if (!(
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3041; /* *fuse_vandc_vorc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x3, 0);
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      switch (pattern48 (x2))
        {
        case 0:
          if (!
#line 1267 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2474; /* *fuse_nor_or */

        case 1:
          if (!(
#line 1267 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2475; /* *fuse_nor_or */

        case 2:
          if (!
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2982; /* *fuse_vnor_vor */

        case 3:
          if (!
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2983; /* *fuse_vnor_vor */

        case 4:
          if (!
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2984; /* *fuse_vnor_vor */

        case 5:
          if (!
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2985; /* *fuse_vnor_vor */

        case 6:
          if (!
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2986; /* *fuse_vnor_vor */

        case 7:
          if (!
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2987; /* *fuse_vnor_vor */

        case 8:
          if (!
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2988; /* *fuse_vnor_vor */

        case 9:
          if (!
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2989; /* *fuse_vnor_vor */

        case 10:
          if (!(
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2990; /* *fuse_vnor_vor */

        case 11:
          if (!(
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2991; /* *fuse_vnor_vor */

        case 12:
          if (!
#line 1447 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2494; /* *fuse_nor_orc */

        case 13:
          if (!(
#line 1447 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2495; /* *fuse_nor_orc */

        case 14:
          if (!
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3062; /* *fuse_vnor_vorc */

        case 15:
          if (!
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3063; /* *fuse_vnor_vorc */

        case 16:
          if (!
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3064; /* *fuse_vnor_vorc */

        case 17:
          if (!
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3065; /* *fuse_vnor_vorc */

        case 18:
          if (!
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3066; /* *fuse_vnor_vorc */

        case 19:
          if (!
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3067; /* *fuse_vnor_vorc */

        case 20:
          if (!
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3068; /* *fuse_vnor_vorc */

        case 21:
          if (!
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3069; /* *fuse_vnor_vorc */

        case 22:
          if (!(
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3070; /* *fuse_vnor_vorc */

        case 23:
          if (!(
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3071; /* *fuse_vnor_vorc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_32 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_DFmode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_DFmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || GET_MODE (x3) != E_TImode
          || !
#line 9624 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 641; /* p8_xxpermdi_ti */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !
#line 9624 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 642; /* p8_xxpermdi_v16qi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !
#line 9624 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 643; /* p8_xxpermdi_v8hi */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !
#line 9624 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 644; /* p8_xxpermdi_v4si */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !
#line 9624 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 645; /* p8_xxpermdi_v4sf */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !
#line 9624 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 646; /* p8_xxpermdi_v2di */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !
#line 9624 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 647; /* p8_xxpermdi_v2df */

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || GET_MODE (x3) != E_V1TImode
          || !
#line 9624 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 648; /* p8_xxpermdi_v1ti */

    case E_KFmode:
      if (!register_operand (operands[0], E_KFmode)
          || GET_MODE (x3) != E_KFmode
          || !(
#line 9624 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 560 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))))
        return -1;
      return 649; /* p8_xxpermdi_kf */

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !(
#line 9624 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 561 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))))
        return -1;
      return 650; /* p8_xxpermdi_tf */

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!const_0_to_1_operand (operands[1], E_QImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DDmode:
      if (!gpc_reg_operand (operands[0], E_DDmode)
          || GET_MODE (x3) != E_DDmode
          || !gpc_reg_operand (operands[2], E_DDmode)
          || !
#line 294 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
        return -1;
      return 2299; /* dfp_denbcd_dd */

    case E_TDmode:
      if (!gpc_reg_operand (operands[0], E_TDmode)
          || GET_MODE (x3) != E_TDmode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_TDmode:
          if (!gpc_reg_operand (operands[2], E_TDmode)
              || !
#line 294 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2300; /* dfp_denbcd_td */

        case E_V16QImode:
          if (!register_operand (operands[2], E_V16QImode)
              || !
#line 304 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2301; /* dfp_denbcd_v16qi_inst */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (pattern142 (x3, 
E_V16QImode) != 0
          || !
#line 80 "../../gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2324; /* crypto_vpmsumb */

    case E_V8HImode:
      if (pattern142 (x3, 
E_V8HImode) != 0
          || !
#line 80 "../../gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2325; /* crypto_vpmsumh */

    case E_V4SImode:
      if (pattern142 (x3, 
E_V4SImode) != 0
          || !
#line 80 "../../gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2326; /* crypto_vpmsumw */

    case E_V2DImode:
      if (pattern142 (x3, 
E_V2DImode) != 0
          || !
#line 80 "../../gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2327; /* crypto_vpmsumd */

    default:
      return -1;
    }
}

 int
recog_52 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!vsx_register_operand (operands[0], E_V2DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!vsx_register_operand (operands[1], E_V16QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!const_0_to_12_operand (operands[2], E_QImode)
      || !
#line 6041 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
    return -1;
  return 1615; /* extract4b */
}

 int
recog_58 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!gpc_reg_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!got_no_const_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_SImode)
      || !
#line 7696 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4 && flag_pic == 1))
    return -1;
  return 556; /* *movsi_got_internal */
}

 int
recog_65 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!vsx_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DFmode:
          if (!vsx_register_operand (operands[1], E_DFmode)
              || !
#line 2362 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (DFmode)))
            return -1;
          return 1307; /* vsx_xscvdpsp */

        case E_V2DFmode:
          if (!vsx_register_operand (operands[1], E_V2DFmode)
              || !
#line 2400 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1310; /* vsx_xvcvdpsp */

        case E_SFmode:
          if (!vsx_register_operand (operands[1], E_SFmode)
              || !
#line 2446 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1315; /* vsx_xscvdpsp_scalar */

        default:
          return -1;
        }

    case E_DFmode:
      if (!vsx_register_operand (operands[0], E_DFmode)
          || GET_MODE (x2) != E_DFmode
          || !vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 2409 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1311; /* vsx_xscvspdp */

    case E_SFmode:
      if (!vsx_register_operand (operands[0], E_SFmode)
          || GET_MODE (x2) != E_SFmode
          || !vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 2418 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1312; /* vsx_xscvspdp_scalar2 */

    default:
      return -1;
    }
}

 int
recog_69 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!memory_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 3242 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2131; /* altivec_stvehx */

    case E_QImode:
      if (!memory_operand (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode
          || !register_operand (operands[1], E_V16QImode)
          || !
#line 3242 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2132; /* altivec_stvebx */

    case E_SFmode:
      if (!memory_operand (operands[0], E_SFmode)
          || GET_MODE (x2) != E_SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 3249 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2133; /* *altivec_stvesfx */

    default:
      return -1;
    }
}

 int
recog_76 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern211 (x2))
    {
    case 0:
      if (!
#line 5209 "../../gcc/config/rs6000/rs6000.md"
(RS6000_RECIP_HAVE_RSQRTE_P (SFmode)))
        return -1;
      return 313; /* *rsqrtsf2 */

    case 1:
      if (!
#line 5209 "../../gcc/config/rs6000/rs6000.md"
(RS6000_RECIP_HAVE_RSQRTE_P (DFmode)))
        return -1;
      return 314; /* *rsqrtdf2 */

    case 2:
      if (vsx_register_operand (operands[0], E_V4SFmode)
          && vsx_register_operand (operands[1], E_V4SFmode)
          && 
#line 2031 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return 1256; /* *vsx_rsqrtev4sf2 */
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 2651 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
        return -1;
      return 1995; /* *altivec_vrsqrtefp */

    case 3:
      if (!
#line 2031 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1257; /* *vsx_rsqrtev2df2 */

    default:
      return -1;
    }
}

 int
recog_87 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x2) != E_DFmode
          || !
#line 9564 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE))
        return -1;
      return 634; /* p8_mtvsrwz */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x2) != E_V16QImode
          || !
#line 9572 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE))
        return -1;
      return 635; /* p8_mtvsrwz_v16qisi2 */

    default:
      return -1;
    }
}

 int
recog_97 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!int_reg_operand (operands[2], E_DImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!int_reg_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode
          || !d_form_memory (operands[1], E_QImode)
          || !
#line 152 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
        return -1;
      *pnum_clobbers = 1;
      return 3187; /* *pcrel_opt_ldqi_gpr */

    case E_HImode:
      if (!int_reg_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !d_form_memory (operands[1], E_HImode)
          || !
#line 152 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
        return -1;
      *pnum_clobbers = 1;
      return 3188; /* *pcrel_opt_ldhi_gpr */

    case E_SFmode:
      if (!int_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !d_form_memory (operands[1], E_SFmode)
          || !
#line 152 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
        return -1;
      *pnum_clobbers = 1;
      return 3191; /* *pcrel_opt_ldsf_gpr */

    case E_DFmode:
      if (!int_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !d_form_memory (operands[1], E_DFmode)
          || !
#line 152 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
        return -1;
      *pnum_clobbers = 1;
      return 3192; /* *pcrel_opt_lddf_gpr */

    default:
      return -1;
    }
}

 int
recog_106 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 2:
      return recog_103 (x1, insn, pnum_clobbers);

    case 1:
      return recog_104 (x1, insn, pnum_clobbers);

    case 3:
      return recog_105 (x1, insn, pnum_clobbers);

    case 4:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 3);
      operands[4] = x7;
      switch (XINT (x2, 1))
        {
        case 208:
          if (pattern415 (x2, 
E_V16QImode) != 0
              || !u3bit_cint_operand (operands[4], E_QImode)
              || !
#line 6746 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1671; /* xxpermx_inst */

        case 203:
          if (pattern415 (x2, 
E_V2DImode) != 0
              || !u8bit_cint_operand (operands[4], E_QImode)
              || !
#line 6759 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1672; /* xxeval */

        case 372:
          if (pattern416 (x2, 
E_V16QImode) != 0
              || !const_0_to_15_operand (operands[4], E_SImode)
              || !
#line 581 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2253; /* mma_pmxvf32ger */

        case 377:
          if (pattern416 (x2, 
E_OOmode) != 0
              || !const_0_to_3_operand (operands[4], E_SImode)
              || !
#line 606 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2258; /* mma_pmxvf64ger */

        default:
          return -1;
        }

    case 5:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!fpr_reg_operand (operands[0], E_XOmode)
          || GET_MODE (x2) != E_XOmode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 3);
      operands[4] = x7;
      if (!const_0_to_15_operand (operands[4], E_SImode))
        return -1;
      x8 = XVECEXP (x2, 0, 4);
      operands[5] = x8;
      switch (XINT (x2, 1))
        {
        case 386:
          if (!vsx_register_operand (operands[1], E_V16QImode)
              || !vsx_register_operand (operands[2], E_V16QImode)
              || !const_0_to_15_operand (operands[3], E_SImode)
              || !u8bit_cint_operand (operands[5], E_SImode)
              || !
#line 528 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2237; /* mma_pmxvi4ger8 */

        case 382:
          if (pattern510 () != 0
              || !
#line 555 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2239; /* mma_pmxvi16ger2 */

        case 384:
          if (pattern510 () != 0
              || !
#line 555 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2240; /* mma_pmxvi16ger2s */

        case 367:
          if (pattern510 () != 0
              || !
#line 555 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2241; /* mma_pmxvf16ger2 */

        case 362:
          if (pattern510 () != 0
              || !
#line 555 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2242; /* mma_pmxvbf16ger2 */

        case 376:
          if (pattern511 () != 0
              || !
#line 594 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2254; /* mma_pmxvf32gerpp */

        case 375:
          if (pattern511 () != 0
              || !
#line 594 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2255; /* mma_pmxvf32gerpn */

        case 374:
          if (pattern511 () != 0
              || !
#line 594 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2256; /* mma_pmxvf32gernp */

        case 373:
          if (pattern511 () != 0
              || !
#line 594 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2257; /* mma_pmxvf32gernn */

        case 381:
          if (pattern512 () != 0
              || !
#line 619 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2259; /* mma_pmxvf64gerpp */

        case 380:
          if (pattern512 () != 0
              || !
#line 619 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2260; /* mma_pmxvf64gerpn */

        case 379:
          if (pattern512 () != 0
              || !
#line 619 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2261; /* mma_pmxvf64gernp */

        case 378:
          if (pattern512 () != 0
              || !
#line 619 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2262; /* mma_pmxvf64gernn */

        case 388:
          if (!vsx_register_operand (operands[1], E_V16QImode)
              || !vsx_register_operand (operands[2], E_V16QImode)
              || !const_0_to_15_operand (operands[3], E_SImode)
              || !const_0_to_15_operand (operands[5], E_SImode)
              || !
#line 632 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2263; /* mma_pmxvi8ger4 */

        default:
          return -1;
        }

    case 6:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!fpr_reg_operand (operands[0], E_XOmode)
          || GET_MODE (x2) != E_XOmode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!fpr_reg_operand (operands[1], E_XOmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!vsx_register_operand (operands[2], E_V16QImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!vsx_register_operand (operands[3], E_V16QImode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      operands[4] = x7;
      if (!const_0_to_15_operand (operands[4], E_SImode))
        return -1;
      x8 = XVECEXP (x2, 0, 4);
      operands[5] = x8;
      if (!const_0_to_15_operand (operands[5], E_SImode))
        return -1;
      x9 = XVECEXP (x2, 0, 5);
      operands[6] = x9;
      switch (XINT (x2, 1))
        {
        case 387:
          if (!u8bit_cint_operand (operands[6], E_SImode)
              || !
#line 542 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2238; /* mma_pmxvi4ger8pp */

        case 383:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 569 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2243; /* mma_pmxvi16ger2pp */

        case 385:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 569 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2244; /* mma_pmxvi16ger2spp */

        case 371:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 569 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2245; /* mma_pmxvf16ger2pp */

        case 370:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 569 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2246; /* mma_pmxvf16ger2pn */

        case 369:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 569 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2247; /* mma_pmxvf16ger2np */

        case 368:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 569 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2248; /* mma_pmxvf16ger2nn */

        case 366:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 569 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2249; /* mma_pmxvbf16ger2pp */

        case 365:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 569 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2250; /* mma_pmxvbf16ger2pn */

        case 364:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 569 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2251; /* mma_pmxvbf16ger2np */

        case 363:
          if (!const_0_to_3_operand (operands[6], E_SImode)
              || !
#line 569 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2252; /* mma_pmxvbf16ger2nn */

        case 389:
          if (!const_0_to_15_operand (operands[6], E_SImode)
              || !
#line 646 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2264; /* mma_pmxvi8ger4pp */

        case 390:
          if (!const_0_to_15_operand (operands[6], E_SImode)
              || !
#line 646 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2265; /* mma_pmxvi8ger4spp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_118 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !gpc_reg_operand (operands[1], E_SImode))
            return -1;
          return 116; /* negsi2 */

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !gpc_reg_operand (operands[1], E_DImode)
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 117; /* negdi2 */

        case E_SFmode:
          if (!gpc_reg_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !gpc_reg_operand (operands[1], E_SFmode)
              || !
#line 5044 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 299; /* *negsf2_fpr */

        case E_DFmode:
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !gpc_reg_operand (operands[1], E_DFmode)
              || !
#line 5044 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 300; /* *negdf2_fpr */

        case E_IFmode:
          if (!gpc_reg_operand (operands[0], E_IFmode)
              || GET_MODE (x3) != E_IFmode
              || !gpc_reg_operand (operands[1], E_IFmode)
              || !(
#line 9205 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT) && 
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
            return -1;
          return 612; /* negif2_internal */

        case E_TFmode:
          if (GET_MODE (x3) != E_TFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_TFmode)
              && gpc_reg_operand (operands[1], E_TFmode)
              && (
#line 9205 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT) && 
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
            return 613; /* negtf2_internal */
          if (pnum_clobbers != NULL
              && register_operand (operands[0], E_TFmode)
              && register_operand (operands[1], E_TFmode)
              && (
#line 9299 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            {
              *pnum_clobbers = 1;
              return 615; /* ieee_128bit_vsx_negtf2 */
            }
          if (!altivec_register_operand (operands[0], E_TFmode)
              || !altivec_register_operand (operands[1], E_TFmode)
              || !(
#line 15122 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 996; /* negtf2_hw */

        case E_KFmode:
          if (pnum_clobbers != NULL
              && register_operand (operands[0], E_KFmode)
              && GET_MODE (x3) == E_KFmode
              && register_operand (operands[1], E_KFmode)
              && (
#line 9299 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            {
              *pnum_clobbers = 1;
              return 614; /* ieee_128bit_vsx_negkf2 */
            }
          if (!altivec_register_operand (operands[0], E_KFmode)
              || GET_MODE (x3) != E_KFmode
              || !altivec_register_operand (operands[1], E_KFmode)
              || !(
#line 15122 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 995; /* negkf2_hw */

        case E_V4SFmode:
          if (!vsx_register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !vsx_register_operand (operands[1], E_V4SFmode)
              || !
#line 1984 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1244; /* *vsx_negv4sf2 */

        case E_V2DFmode:
          if (!vsx_register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !vsx_register_operand (operands[1], E_V2DFmode)
              || !
#line 1984 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1245; /* *vsx_negv2df2 */

        case E_V4SImode:
          if (!altivec_register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !altivec_register_operand (operands[1], E_V4SImode)
              || !
#line 3731 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2134; /* *p9_negv4si2 */

        case E_V2DImode:
          if (!altivec_register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !altivec_register_operand (operands[1], E_V2DImode)
              || !
#line 3731 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2135; /* *p9_negv2di2 */

        case E_DDmode:
          if (!gpc_reg_operand (operands[0], E_DDmode)
              || GET_MODE (x3) != E_DDmode
              || !gpc_reg_operand (operands[1], E_DDmode)
              || !
#line 87 "../../gcc/config/rs6000/dfp.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2270; /* negdd2 */

        case E_TDmode:
          if (!gpc_reg_operand (operands[0], E_TDmode)
              || GET_MODE (x3) != E_TDmode
              || !gpc_reg_operand (operands[1], E_TDmode)
              || !
#line 108 "../../gcc/config/rs6000/dfp.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2273; /* negtd2 */

        default:
          return -1;
        }

    case ABS:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern204 (x3, 
E_SFmode) != 0
              || !
#line 5029 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 297; /* *nabssf2_fpr */

        case E_DFmode:
          if (pattern204 (x3, 
E_DFmode) != 0
              || !
#line 5029 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 298; /* *nabsdf2_fpr */

        case E_KFmode:
          if (pnum_clobbers != NULL
              && pattern265 (x3, 
E_KFmode) == 0
              && (
#line 9357 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            {
              *pnum_clobbers = 1;
              return 622; /* *ieee_128bit_vsx_nabskf2 */
            }
          if (!altivec_register_operand (operands[0], E_KFmode)
              || GET_MODE (x3) != E_KFmode
              || GET_MODE (x4) != E_KFmode
              || !altivec_register_operand (operands[1], E_KFmode)
              || !(
#line 15143 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 999; /* *nabskf2_hw */

        case E_TFmode:
          if (pnum_clobbers != NULL
              && pattern265 (x3, 
E_TFmode) == 0
              && (
#line 9357 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            {
              *pnum_clobbers = 1;
              return 623; /* *ieee_128bit_vsx_nabstf2 */
            }
          if (!altivec_register_operand (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode
              || GET_MODE (x4) != E_TFmode
              || !altivec_register_operand (operands[1], E_TFmode)
              || !(
#line 15143 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1000; /* *nabstf2_hw */

        case E_V4SFmode:
          if (pattern205 (x3, 
E_V4SFmode) != 0
              || !
#line 2000 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1248; /* vsx_nabsv4sf2 */

        case E_V2DFmode:
          if (pattern205 (x3, 
E_V2DFmode) != 0
              || !
#line 2000 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1249; /* vsx_nabsv2df2 */

        case E_DDmode:
          if (pattern204 (x3, 
E_DDmode) != 0
              || !
#line 101 "../../gcc/config/rs6000/dfp.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2272; /* *nabsdd2_fpr */

        case E_TDmode:
          if (pattern204 (x3, 
E_TDmode) != 0
              || !
#line 128 "../../gcc/config/rs6000/dfp.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2275; /* *nabstd2_fpr */

        default:
          return -1;
        }

    case EQ:
    case GT:
    case LT:
    case GTU:
    case LTU:
    case UNORDERED:
      operands[1] = x4;
      res = recog_5 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL
          || pattern121 (x3, 
EQ) != 0
          || !(
#line 13026 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 3;
      return 855; /* *neg_eq_di */

    case NE:
    case GE:
    case LE:
    case GEU:
    case LEU:
    case ORDERED:
      operands[1] = x4;
      res = recog_6 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL
          || pattern121 (x3, 
NE) != 0
          || !(
#line 13058 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 3;
      return 856; /* *neg_ne_di */

    case FMA:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x4, 2);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern350 (x3, 
E_SFmode) != 0
                  || !
#line 14538 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 945; /* *nfmasf4_fpr */

            case E_DFmode:
              if (pattern350 (x3, 
E_DFmode) != 0
                  || !
#line 14538 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 946; /* *nfmadf4_fpr */

            case E_KFmode:
              if (pattern351 (x3, 
E_KFmode) != 0
                  || !(
#line 15179 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1005; /* *nfmakf4_hw */

            case E_TFmode:
              if (pattern351 (x3, 
E_TFmode) != 0
                  || !(
#line 15179 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1006; /* *nfmatf4_hw */

            case E_V4SFmode:
              if (pattern352 (x3, 
E_V4SFmode) != 0
                  || !
#line 2120 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
                return -1;
              return 1265; /* *vsx_nfmav4sf4 */

            case E_V2DFmode:
              if (pattern352 (x3, 
E_V2DFmode) != 0
                  || !
#line 2120 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
                return -1;
              return 1266; /* *vsx_nfmav2df4 */

            default:
              return -1;
            }

        case NEG:
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern353 (x3, 
E_SFmode) != 0
                  || !
#line 14565 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 947; /* *nfmssf4_fpr */

            case E_DFmode:
              if (pattern353 (x3, 
E_DFmode) != 0
                  || !
#line 14565 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 948; /* *nfmssf4_fpr */

            case E_KFmode:
              if (pattern354 (x3, 
E_KFmode) != 0
                  || !(
#line 15192 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1007; /* *nfmskf4_hw */

            case E_TFmode:
              if (pattern354 (x3, 
E_TFmode) != 0
                  || !(
#line 15192 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1008; /* *nfmstf4_hw */

            case E_V4SFmode:
              if (GET_MODE (x3) != E_V4SFmode
                  || GET_MODE (x4) != E_V4SFmode
                  || GET_MODE (x7) != E_V4SFmode)
                return -1;
              if (vsx_register_operand (operands[0], E_V4SFmode)
                  && vsx_register_operand (operands[1], E_V4SFmode)
                  && vsx_register_operand (operands[2], E_V4SFmode)
                  && vsx_register_operand (operands[3], E_V4SFmode)
                  && 
#line 2134 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
                return 1267; /* *vsx_nfmsv4sf4 */
              if (!register_operand (operands[0], E_V4SFmode)
                  || !register_operand (operands[1], E_V4SFmode)
                  || !register_operand (operands[2], E_V4SFmode)
                  || !register_operand (operands[3], E_V4SFmode)
                  || !
#line 1001 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
                return -1;
              return 1809; /* *altivec_vnmsubfp */

            case E_V2DFmode:
              if (!vsx_register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x3) != E_V2DFmode
                  || GET_MODE (x4) != E_V2DFmode
                  || !vsx_register_operand (operands[1], E_V2DFmode)
                  || !vsx_register_operand (operands[2], E_V2DFmode)
                  || GET_MODE (x7) != E_V2DFmode
                  || !vsx_register_operand (operands[3], E_V2DFmode)
                  || !
#line 2148 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
                return -1;
              return 1268; /* *vsx_nfmsv2df4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 3
          || XINT (x4, 1) != 82)
        return -1;
      x9 = XVECEXP (x4, 0, 0);
      operands[1] = x9;
      x10 = XVECEXP (x4, 0, 1);
      operands[2] = x10;
      x11 = XVECEXP (x4, 0, 2);
      switch (GET_CODE (x11))
        {
        case REG:
        case SUBREG:
          operands[3] = x11;
          switch (GET_MODE (operands[0]))
            {
            case E_KFmode:
              if (pattern432 (x3, 
E_KFmode) != 0
                  || !(
#line 15570 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1085; /* *nfmakf4_odd */

            case E_TFmode:
              if (pattern432 (x3, 
E_TFmode) != 0
                  || !(
#line 15570 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1086; /* *nfmatf4_odd */

            default:
              return -1;
            }

        case NEG:
          x12 = XEXP (x11, 0);
          operands[3] = x12;
          switch (GET_MODE (operands[0]))
            {
            case E_KFmode:
              if (pattern433 (x3, 
E_KFmode) != 0
                  || !(
#line 15584 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1087; /* *nfmskf4_odd */

            case E_TFmode:
              if (pattern433 (x3, 
E_TFmode) != 0
                  || !(
#line 15584 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1088; /* *nfmstf4_odd */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_127 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case AND:
      res = recog_17 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case IOR:
    case XOR:
      res = recog_23 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[3] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern312 (
E_SImode) != 0)
            return -1;
          return 215; /* *boolsi3 */

        case E_DImode:
          if (pattern312 (
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 216; /* *booldi3 */

        default:
          return -1;
        }

    case NOT:
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern358 (x4, 
E_SImode) != 0)
                return -1;
              return 221; /* *boolcsi3 */

            case E_DImode:
              if (pattern358 (x4, 
E_DImode) != 0
                  || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 222; /* *boolcdi3 */

            case E_TImode:
              if (!boolean_operator (operands[3], E_TImode)
                  || GET_MODE (x4) != E_TImode)
                return -1;
              if (vlogical_operand (operands[0], E_TImode)
                  && vlogical_operand (operands[2], E_TImode)
                  && vlogical_operand (operands[1], E_TImode)
                  && 
#line 7451 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)))
                return 514; /* *boolcti3_internal1 */
              if (!int_reg_operand (operands[0], E_TImode)
                  || !int_reg_operand (operands[2], E_TImode)
                  || !int_reg_operand (operands[1], E_TImode)
                  || !
#line 7488 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_P8_VECTOR && (GET_CODE (operands[3]) != AND)))
                return -1;
              return 523; /* *boolcti3_internal2 */

            case E_PTImode:
              if (!boolean_operator (operands[3], E_PTImode)
                  || GET_MODE (x4) != E_PTImode)
                return -1;
              if (vlogical_operand (operands[0], E_PTImode)
                  && vlogical_operand (operands[2], E_PTImode)
                  && vlogical_operand (operands[1], E_PTImode)
                  && 
#line 7451 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)))
                return 515; /* *boolcpti3_internal1 */
              if (!int_reg_operand (operands[0], E_PTImode)
                  || !int_reg_operand (operands[2], E_PTImode)
                  || !int_reg_operand (operands[1], E_PTImode)
                  || !
#line 7488 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_P8_VECTOR && (GET_CODE (operands[3]) != AND)))
                return -1;
              return 524; /* *boolcpti3_internal2 */

            case E_V16QImode:
              if (pattern359 (x4, 
E_V16QImode) != 0
                  || !(
#line 7451 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 778 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 516; /* *boolcv16qi3_internal1 */

            case E_V8HImode:
              if (pattern359 (x4, 
E_V8HImode) != 0
                  || !(
#line 7451 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 779 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 517; /* *boolcv8hi3_internal1 */

            case E_V4SImode:
              if (pattern359 (x4, 
E_V4SImode) != 0
                  || !(
#line 7451 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 780 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 518; /* *boolcv4si3_internal1 */

            case E_V4SFmode:
              if (pattern359 (x4, 
E_V4SFmode) != 0
                  || !(
#line 7451 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 781 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 519; /* *boolcv4sf3_internal1 */

            case E_V2DImode:
              if (pattern359 (x4, 
E_V2DImode) != 0
                  || !(
#line 7451 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 782 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 520; /* *boolcv2di3_internal1 */

            case E_V2DFmode:
              if (pattern359 (x4, 
E_V2DFmode) != 0
                  || !(
#line 7451 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 783 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 521; /* *boolcv2df3_internal1 */

            case E_V1TImode:
              if (pattern359 (x4, 
E_V1TImode) != 0
                  || !(
#line 7451 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 784 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 522; /* *boolcv1ti3_internal1 */

            default:
              return -1;
            }

        case NOT:
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern361 (x2, 
E_SImode) != 0)
                return -1;
              return 227; /* *boolccsi3 */

            case E_DImode:
              if (pattern361 (x2, 
E_DImode) != 0
                  || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 228; /* *boolccdi3 */

            case E_TImode:
              if (!boolean_operator (operands[3], E_TImode)
                  || GET_MODE (x4) != E_TImode
                  || GET_MODE (x5) != E_TImode)
                return -1;
              if (vlogical_operand (operands[0], E_TImode)
                  && vlogical_operand (operands[1], E_TImode)
                  && vlogical_operand (operands[2], E_TImode)
                  && 
#line 7511 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)))
                return 525; /* *boolccti3_internal1 */
              if (!int_reg_operand (operands[0], E_TImode)
                  || !int_reg_operand (operands[1], E_TImode)
                  || !int_reg_operand (operands[2], E_TImode)
                  || !
#line 7549 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_P8_VECTOR && (GET_CODE (operands[3]) != AND)))
                return -1;
              return 534; /* *boolccti3_internal2 */

            case E_PTImode:
              if (!boolean_operator (operands[3], E_PTImode)
                  || GET_MODE (x4) != E_PTImode
                  || GET_MODE (x5) != E_PTImode)
                return -1;
              if (vlogical_operand (operands[0], E_PTImode)
                  && vlogical_operand (operands[1], E_PTImode)
                  && vlogical_operand (operands[2], E_PTImode)
                  && 
#line 7511 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)))
                return 526; /* *boolccpti3_internal1 */
              if (!int_reg_operand (operands[0], E_PTImode)
                  || !int_reg_operand (operands[1], E_PTImode)
                  || !int_reg_operand (operands[2], E_PTImode)
                  || !
#line 7549 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_P8_VECTOR && (GET_CODE (operands[3]) != AND)))
                return -1;
              return 535; /* *boolccpti3_internal2 */

            case E_V16QImode:
              if (pattern362 (x2, 
E_V16QImode) != 0
                  || !(
#line 7511 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 778 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 527; /* *boolccv16qi3_internal1 */

            case E_V8HImode:
              if (pattern362 (x2, 
E_V8HImode) != 0
                  || !(
#line 7511 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 779 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 528; /* *boolccv8hi3_internal1 */

            case E_V4SImode:
              if (pattern362 (x2, 
E_V4SImode) != 0
                  || !(
#line 7511 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 780 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 529; /* *boolccv4si3_internal1 */

            case E_V4SFmode:
              if (pattern362 (x2, 
E_V4SFmode) != 0
                  || !(
#line 7511 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 781 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 530; /* *boolccv4sf3_internal1 */

            case E_V2DImode:
              if (pattern362 (x2, 
E_V2DImode) != 0
                  || !(
#line 7511 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 782 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 531; /* *boolccv2di3_internal1 */

            case E_V2DFmode:
              if (pattern362 (x2, 
E_V2DFmode) != 0
                  || !(
#line 7511 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 783 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 532; /* *boolccv2df3_internal1 */

            case E_V1TImode:
              if (pattern362 (x2, 
E_V1TImode) != 0
                  || !(
#line 7511 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND)) && 
#line 784 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return -1;
              return 533; /* *boolccv1ti3_internal1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_131 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ASHIFTRT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      switch (XWINT (x5, 0))
        {
        case 16L:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          x6 = XEXP (x4, 0);
          if (!gpc_reg_operand (x6, E_SImode))
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_SImode)
            return -1;
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              operands[2] = x6;
              x8 = XEXP (x7, 0);
              operands[1] = x8;
              if (!gpc_reg_operand (operands[1], E_HImode)
                  || !
#line 1571 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 53; /* *mulchw */

            case ASHIFTRT:
              x9 = XEXP (x7, 1);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              operands[1] = x6;
              x8 = XEXP (x7, 0);
              operands[2] = x8;
              if (!gpc_reg_operand (operands[2], E_SImode)
                  || !
#line 1632 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 57; /* *mulhhw */

            default:
              return -1;
            }

        case 32L:
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != ASHIFTRT)
            return -1;
          x9 = XEXP (x7, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          switch (pattern285 (x3))
            {
            case 0:
              if (!
#line 6556 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1655; /* smulv2di3_highpart */

            case 1:
              if (!
#line 6556 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1656; /* smulv4si3_highpart */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
          || !gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (!gpc_reg_operand (x6, E_SImode))
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_MODE (x7) != E_SImode)
        return -1;
      switch (GET_CODE (x7))
        {
        case ZERO_EXTEND:
          operands[2] = x6;
          x8 = XEXP (x7, 0);
          operands[1] = x8;
          if (!gpc_reg_operand (operands[1], E_HImode)
              || !
#line 1600 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 55; /* *mulchwu */

        case LSHIFTRT:
          x9 = XEXP (x7, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return -1;
          operands[1] = x6;
          x8 = XEXP (x7, 0);
          operands[2] = x8;
          if (!gpc_reg_operand (operands[2], E_SImode)
              || !
#line 1664 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 59; /* *mulhhwu */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pattern43 (x3, 
SIGN_EXTEND) != 0
          || !
#line 1690 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
        return -1;
      return 61; /* *mullhw */

    case ZERO_EXTEND:
      if (pattern43 (x3, 
ZERO_EXTEND) != 0
          || !
#line 1716 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
        return -1;
      return 63; /* *mullhwu */

    case REG:
    case SUBREG:
      operands[1] = x4;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern260 (x3, 
E_SImode) != 0)
            return -1;
          return 154; /* mulsi3 */

        case E_DImode:
          if (pattern260 (x3, 
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 155; /* muldi3 */

        case E_SFmode:
          if (pattern19 (x3, 
E_SFmode) != 0
              || !
#line 5097 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 305; /* *mulsf3_fpr */

        case E_DFmode:
          if (pattern19 (x3, 
E_DFmode) != 0
              || !
#line 5097 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 306; /* *muldf3_fpr */

        case E_KFmode:
          if (pattern1 (x3, 
E_KFmode) != 0
              || !(
#line 15040 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 985; /* mulkf3 */

        case E_TFmode:
          if (pattern1 (x3, 
E_TFmode) != 0
              || !(
#line 15040 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 986; /* multf3 */

        case E_V4SFmode:
          if (pattern2 (x3, 
E_V4SFmode) != 0
              || !
#line 1718 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1226; /* *vsx_mulv4sf3 */

        case E_V2DFmode:
          if (pattern2 (x3, 
E_V2DFmode) != 0
              || !
#line 1718 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1227; /* *vsx_mulv2df3 */

        case E_V2DImode:
          if (pattern2 (x3, 
E_V2DImode) != 0
              || !
#line 6577 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1659; /* mulv2di3 */

        case E_V4SImode:
          if (pattern3 (x3, 
E_V4SImode) != 0
              || !
#line 803 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 1790; /* mulv4si3_p8 */

        case E_DDmode:
          if (pattern19 (x3, 
E_DDmode) != 0
              || !
#line 193 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2283; /* muldd3 */

        case E_TDmode:
          if (pattern19 (x3, 
E_TDmode) != 0
              || !
#line 193 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2284; /* multd3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_145 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case LSHIFTRT:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != MULT
          || pattern34 (x3, 
E_SImode, 
32, 
E_DImode) != 0)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x5, 1);
      if (GET_MODE (x7) != E_DImode)
        return -1;
      switch (GET_CODE (x6))
        {
        case SIGN_EXTEND:
          if (GET_CODE (x7) != SIGN_EXTEND)
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          if (!gpc_reg_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          if (!gpc_reg_operand (operands[2], E_SImode)
              || !
#line 3239 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 168; /* smulsi3_highpart_64 */

        case ZERO_EXTEND:
          if (GET_CODE (x7) != ZERO_EXTEND)
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          if (!gpc_reg_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          if (!gpc_reg_operand (operands[2], E_SImode)
              || !
#line 3239 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 169; /* umulsi3_highpart_64 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_TImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!memory_operand (operands[0], E_QImode)
              || GET_MODE (x3) != E_QImode
              || !
#line 1382 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1203; /* vsx_stxvrbx */

        case E_HImode:
          if (!memory_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !
#line 1382 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1204; /* vsx_stxvrhx */

        case E_SImode:
          if (!memory_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !
#line 1382 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1205; /* vsx_stxvrwx */

        case E_DImode:
          if (!memory_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !
#line 1382 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1206; /* vsx_stxvrdx */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_153 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (gpc_reg_operand (operands[1], E_DImode))
    {
      res = recog_152 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
      if (XWINT (x5, 0) != -1L)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET
          || pattern335 (x1, 
NE) != 0)
        return -1;
      return 78; /* *adddi3_imm_carry_m1 */

    case REG:
      if (REGNO (x5) != 98)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 98)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern492 (x1, 
E_SImode) != 0)
            return -1;
          return 84; /* addsi3_carry_in_0 */

        case E_DImode:
          if (pattern492 (x1, 
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 85; /* adddi3_carry_in_0 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_155 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  if (!altivec_register_operand (operands[3], E_V2DImode))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != E_V2DImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_V2DImode)
    return -1;
  x6 = XEXP (x5, 1);
  operands[1] = x6;
  if (!altivec_register_operand (operands[1], E_V2DImode))
    return -1;
  x7 = XEXP (x4, 1);
  operands[2] = x7;
  if (!altivec_register_operand (operands[2], E_V2DImode))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!scratch_operand (operands[4], E_V2DImode)
      || !
#line 3049 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
    return -1;
  return 3184; /* *fuse_vaddudm_vaddudm */
}

 int
recog_159 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[0] = x3;
      if (!gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 98
          || GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x2, 1);
      operands[1] = x7;
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      return 77; /* *adddi3_imm_carry_0 */

    case MEM:
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != PLUS)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PLUS)
        return -1;
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      x10 = XEXP (x8, 1);
      operands[2] = x10;
      x7 = XEXP (x2, 1);
      operands[3] = x7;
      x6 = XEXP (x4, 0);
      operands[0] = x6;
      x11 = XEXP (x5, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      x12 = XEXP (x5, 1);
      if (!rtx_equal_p (x12, operands[2]))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_DImode:
          if (!gpc_reg_operand (operands[3], E_DImode))
            return -1;
          switch (GET_MODE (x8))
            {
            case E_SImode:
              if (pattern545 (x5, 
E_SImode) != 0
                  || !(
#line 10257 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DImode)
       || !gpc_reg_operand (operands[2], Pmode)
       || (REG_P (operands[0])
	   && REGNO (operands[0]) == STACK_POINTER_REGNUM))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 692; /* movdi_si_update */

            case E_DImode:
              if (pattern545 (x5, 
E_DImode) != 0)
                return -1;
              if ((
#line 10257 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DImode)
       || !gpc_reg_operand (operands[2], Pmode)
       || (REG_P (operands[0])
	   && REGNO (operands[0]) == STACK_POINTER_REGNUM))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return 693; /* movdi_di_update */
              return 694; /* movdi_update_stack */

            default:
              return -1;
            }

        case E_SImode:
          switch (pattern539 (x1, 
E_SImode))
            {
            case 0:
              if (!(
#line 10321 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (SImode)
       || !gpc_reg_operand (operands[2], Pmode)
       || (REG_P (operands[0])
	   && REGNO (operands[0]) == STACK_POINTER_REGNUM))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 699; /* movsi_si_update */

            case 1:
              if (!(
#line 10321 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (SImode)
       || !gpc_reg_operand (operands[2], Pmode)
       || (REG_P (operands[0])
	   && REGNO (operands[0]) == STACK_POINTER_REGNUM))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 700; /* movsi_di_update */

            default:
              return -1;
            }

        case E_HImode:
          switch (pattern539 (x1, 
E_HImode))
            {
            case 0:
              if (!(
#line 10406 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (HImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 711; /* *movhi_update4 */

            case 1:
              if (!(
#line 10406 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (HImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 712; /* *movhi_update4 */

            default:
              return -1;
            }

        case E_QImode:
          switch (pattern539 (x1, 
E_QImode))
            {
            case 0:
              if (!(
#line 10455 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (QImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 719; /* *movqi_update3 */

            case 1:
              if (!(
#line 10455 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (QImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 720; /* *movqi_update3 */

            default:
              return -1;
            }

        case E_SFmode:
          switch (pattern539 (x1, 
E_SFmode))
            {
            case 0:
              if ((
#line 10488 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (SFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return 725; /* *movsf_update2 */
              if (!(
#line 10521 "../../gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (SFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 731; /* *movsf_update4 */

            case 1:
              if ((
#line 10488 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (SFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return 726; /* *movsf_update2 */
              if (!(
#line 10521 "../../gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (SFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 732; /* *movsf_update4 */

            default:
              return -1;
            }

        case E_DFmode:
          switch (pattern539 (x1, 
E_DFmode))
            {
            case 0:
              if (!(
#line 10488 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 727; /* *movdf_update2 */

            case 1:
              if (!(
#line 10488 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 728; /* *movdf_update2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_167 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      return recog_151 (x1, insn, pnum_clobbers);

    case 1:
      return recog_150 (x1, insn, pnum_clobbers);

    case 3:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      switch (XINT (x3, 1))
        {
        case 123:
          if (GET_MODE (x3) != E_V4SFmode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER
              || !gpc_reg_operand (operands[0], E_V4SFmode))
            return -1;
          switch (pattern447 (x1))
            {
            case 0:
              if (!
#line 4616 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_P9_VECTOR && TARGET_POWERPC64))
                return -1;
              return 1491; /* vsx_set_v4sf_p9 */

            case 1:
              if (!
#line 4652 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_P9_VECTOR && TARGET_POWERPC64))
                return -1;
              return 1492; /* *vsx_set_v4sf_p9_zero */

            case 2:
              if (!
#line 4712 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && VECTOR_MEM_VSX_P (V4SImode)
   && TARGET_P9_VECTOR && TARGET_POWERPC64
   && (INTVAL (operands[3]) != (BYTES_BIG_ENDIAN ? 1 : 2))))
                return -1;
              return 1494; /* *vsx_insert_extract_v4sf_p9_2 */

            default:
              return -1;
            }

        case 214:
          if (pattern332 (x1, 
E_V4SImode) != 0
              || !
#line 1052 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1816; /* altivec_vmsumuhs */

        case 215:
          if (pattern332 (x1, 
E_V4SImode) != 0
              || !
#line 1063 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1817; /* altivec_vmsumshs */

        case 216:
          if (pattern332 (x1, 
E_V8HImode) != 0
              || !
#line 1124 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1836; /* altivec_vmhaddshs */

        case 217:
          if (pattern332 (x1, 
E_V8HImode) != 0
              || !
#line 1135 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1837; /* altivec_vmhraddshs */

        case 342:
          switch (pattern334 (x1, 
342))
            {
            case 0:
              if (!
#line 4592 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2178; /* bcdadd_v1ti */

            case 1:
              if (!
#line 4592 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2180; /* bcdadd_v16qi */

            case 2:
              if (!
#line 4627 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2186; /* *bcdadd_test2_v1ti */

            case 3:
              if (!
#line 4627 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2188; /* *bcdadd_test2_v16qi */

            default:
              return -1;
            }

        case 343:
          switch (pattern334 (x1, 
343))
            {
            case 0:
              if (!
#line 4592 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2179; /* bcdsub_v1ti */

            case 1:
              if (!
#line 4592 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2181; /* bcdsub_v16qi */

            case 2:
              if (!
#line 4627 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2187; /* *bcdsub_test2_v1ti */

            case 3:
              if (!
#line 4627 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2189; /* *bcdsub_test2_v16qi */

            default:
              return -1;
            }

        case 345:
          if (GET_MODE (x3) != E_V16QImode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (pattern331 (x6, 
E_CCFPmode, 
106, 
CLOBBER) != 0
              || !register_operand (operands[0], E_V16QImode)
              || !register_operand (operands[1], E_V16QImode))
            return -1;
          x7 = XVECEXP (x3, 0, 1);
          operands[2] = x7;
          if (!register_operand (operands[2], E_V16QImode))
            return -1;
          x8 = XVECEXP (x3, 0, 2);
          operands[3] = x8;
          if (!const_0_to_1_operand (operands[3], E_QImode)
              || !
#line 4763 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2200; /* bcdshift_v16qi */

        case 444:
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          x7 = XVECEXP (x3, 0, 1);
          operands[2] = x7;
          x8 = XVECEXP (x3, 0, 2);
          operands[3] = x8;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return -1;
          x9 = XEXP (x6, 0);
          operands[4] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern516 (x3, 
E_QImode) != 0
                  || !
#line 152 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                return -1;
              return 3187; /* *pcrel_opt_ldqi_gpr */

            case E_HImode:
              if (pattern516 (x3, 
E_HImode) != 0
                  || !
#line 152 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                return -1;
              return 3188; /* *pcrel_opt_ldhi_gpr */

            case E_SImode:
              if (pattern516 (x3, 
E_SImode) != 0
                  || !
#line 152 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                return -1;
              return 3189; /* *pcrel_opt_ldsi_gpr */

            case E_DImode:
              if (GET_MODE (x3) != E_DImode
                  || !d_form_memory (operands[1], E_DImode))
                return -1;
              if (int_reg_operand (operands[0], E_DImode)
                  && int_reg_operand (operands[2], E_DImode)
                  && scratch_operand (operands[4], E_DImode)
                  && 
#line 152 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                return 3190; /* *pcrel_opt_lddi_gpr */
              if (!vsx_register_operand (operands[0], E_DImode)
                  || !vsx_register_operand (operands[2], E_DImode)
                  || !base_reg_operand (operands[4], E_DImode)
                  || !
#line 224 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3201; /* *pcrel_opt_lddi_vsx */

            case E_SFmode:
              if (GET_MODE (x3) != E_SFmode
                  || !d_form_memory (operands[1], E_SFmode))
                return -1;
              if (int_reg_operand (operands[0], E_SFmode)
                  && int_reg_operand (operands[2], E_DImode)
                  && scratch_operand (operands[4], E_DImode)
                  && 
#line 152 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                return 3191; /* *pcrel_opt_ldsf_gpr */
              if (!vsx_register_operand (operands[0], E_SFmode)
                  || !vsx_register_operand (operands[2], E_DImode)
                  || !base_reg_operand (operands[4], E_DImode)
                  || !
#line 224 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3203; /* *pcrel_opt_ldsf_vsx */

            case E_DFmode:
              if (GET_MODE (x3) != E_DFmode
                  || !d_form_memory (operands[1], E_DFmode))
                return -1;
              if (int_reg_operand (operands[0], E_DFmode)
                  && int_reg_operand (operands[2], E_DImode)
                  && scratch_operand (operands[4], E_DImode)
                  && 
#line 152 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                return 3192; /* *pcrel_opt_lddf_gpr */
              if (!vsx_register_operand (operands[0], E_DFmode)
                  || !vsx_register_operand (operands[2], E_DImode)
                  || !base_reg_operand (operands[4], E_DImode)
                  || !
#line 224 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3202; /* *pcrel_opt_lddf_vsx */

            case E_TImode:
              if (pattern517 (x3, 
E_TImode) != 0
                  || !
#line 256 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3205; /* *pcrel_opt_ldti */

            case E_KFmode:
              if (pattern517 (x3, 
E_KFmode) != 0
                  || !
#line 256 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3206; /* *pcrel_opt_ldkf */

            case E_V1TImode:
              if (pattern517 (x3, 
E_V1TImode) != 0
                  || !
#line 256 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3207; /* *pcrel_opt_ldv1ti */

            case E_V2DImode:
              if (pattern517 (x3, 
E_V2DImode) != 0
                  || !
#line 256 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3208; /* *pcrel_opt_ldv2di */

            case E_V4SImode:
              if (pattern517 (x3, 
E_V4SImode) != 0
                  || !
#line 256 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3209; /* *pcrel_opt_ldv4si */

            case E_V8HImode:
              if (pattern517 (x3, 
E_V8HImode) != 0
                  || !
#line 256 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3210; /* *pcrel_opt_ldv8hi */

            case E_V16QImode:
              if (pattern517 (x3, 
E_V16QImode) != 0
                  || !
#line 256 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3211; /* *pcrel_opt_ldv16qi */

            case E_V2DFmode:
              if (pattern517 (x3, 
E_V2DFmode) != 0
                  || !
#line 256 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3212; /* *pcrel_opt_ldv2df */

            case E_V4SFmode:
              if (pattern517 (x3, 
E_V4SFmode) != 0
                  || !
#line 256 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3213; /* *pcrel_opt_ldv4sf */

            case E_TFmode:
              if (pattern517 (x3, 
E_TFmode) != 0
                  || !(
#line 256 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 99 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_FLOAT128_TYPE && TARGET_IEEEQUAD)))
                return -1;
              return 3214; /* *pcrel_opt_ldtf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_169 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      res = recog_153 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 98
          || pattern287 (x1, 
-1) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern493 (x1, 
E_SImode) != 0)
            return -1;
          return 113; /* subfsi3_carry_in_xx */

        case E_DImode:
          if (pattern493 (x1, 
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 114; /* subfdi3_carry_in_xx */

        default:
          return -1;
        }

    case PLUS:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          res = recog_154 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          operands[0] = x6;
          if (altivec_register_operand (operands[0], E_V2DImode))
            {
              res = recog_155 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[1] = x6;
          if (pattern288 (x1) == 0)
            {
              x7 = XEXP (x3, 1);
              switch (GET_CODE (x7))
                {
                case REG:
                case SUBREG:
                  operands[2] = x7;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern535 (x1, 
E_SImode) == 0)
                        return 82; /* *addsi3_carry_in_internal2 */
                      break;

                    case E_DImode:
                      if (pattern535 (x1, 
E_DImode) == 0
                          && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                        return 83; /* *adddi3_carry_in_internal2 */
                      break;

                    default:
                      break;
                    }
                  break;

                case CONST_INT:
                  if (XWINT (x7, 0) == -1L)
                    {
                      switch (GET_MODE (operands[0]))
                        {
                        case E_SImode:
                          if (pattern536 (x1, 
E_SImode) == 0)
                            return 86; /* addsi3_carry_in_m1 */
                          break;

                        case E_DImode:
                          if (pattern536 (x1, 
E_DImode) == 0
                              && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                            return 87; /* adddi3_carry_in_m1 */
                          break;

                        default:
                          break;
                        }
                    }
                  break;

                default:
                  break;
                }
            }
          operands[0] = x6;
          x8 = XEXP (x2, 0);
          operands[3] = x8;
          switch (pattern247 (x1))
            {
            case 0:
              if (!
#line 3031 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3182; /* *fuse_add_add */

            case 1:
              if (!(
#line 3031 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 3183; /* *fuse_add_add */

            default:
              return -1;
            }

        case NOT:
          if (pattern288 (x1) != 0)
            return -1;
          x9 = XEXP (x6, 0);
          operands[1] = x9;
          x7 = XEXP (x3, 1);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern526 (x1, 
E_SImode) != 0)
                return -1;
              return 107; /* *subfsi3_carry_in_internal */

            case E_DImode:
              if (pattern526 (x1, 
E_DImode) != 0
                  || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 108; /* *subfdi3_carry_in_internal */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 98)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x10 = XEXP (x5, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 98)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern494 (x1, 
E_SImode) != 0)
            return -1;
          return 109; /* subfsi3_carry_in_0 */

        case E_DImode:
          if (pattern494 (x1, 
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 110; /* subfdi3_carry_in_0 */

        default:
          return -1;
        }

    case MINUS:
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 98
          || pattern287 (x1, 
-2) != 0)
        return -1;
      x11 = XEXP (x4, 1);
      operands[1] = x11;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern518 (x1, 
E_SImode) != 0)
            return -1;
          return 111; /* subfsi3_carry_in_m1 */

        case E_DImode:
          if (pattern518 (x1, 
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 112; /* subfdi3_carry_in_m1 */

        default:
          return -1;
        }

    case VEC_CONCAT:
      if (GET_MODE (x4) != E_V2DFmode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != VEC_SELECT
          || GET_MODE (x6) != E_DFmode)
        return -1;
      x12 = XEXP (x6, 1);
      if (GET_CODE (x12) != PARALLEL
          || XVECLEN (x12, 0) != 1)
        return -1;
      x13 = XVECEXP (x12, 0, 0);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x11 = XEXP (x4, 1);
      if (GET_CODE (x11) != VEC_SELECT
          || GET_MODE (x11) != E_DFmode)
        return -1;
      x14 = XEXP (x11, 1);
      if (GET_CODE (x14) != PARALLEL
          || XVECLEN (x14, 0) != 1)
        return -1;
      x15 = XVECEXP (x14, 0, 0);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      if (!vfloat_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || pattern81 (x1) != 0
          || !
#line 4927 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1520; /* vsx_reduc_plus_v2df */

    case AND:
      switch (pattern186 (x1))
        {
        case 0:
          if (!
#line 1663 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2518; /* *fuse_and_add */

        case 1:
          if (!(
#line 1663 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2519; /* *fuse_and_add */

        case 2:
          if (!
#line 1699 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2522; /* *fuse_nor_add */

        case 3:
          if (!(
#line 1699 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2523; /* *fuse_nor_add */

        default:
          return -1;
        }

    case IOR:
      switch (pattern187 (x1))
        {
        case 0:
          if (!
#line 1681 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2520; /* *fuse_nand_add */

        case 1:
          if (!(
#line 1681 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2521; /* *fuse_nand_add */

        case 2:
          if (!
#line 1717 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2524; /* *fuse_or_add */

        case 3:
          if (!(
#line 1717 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2525; /* *fuse_or_add */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_175 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern80 (x1))
    {
    case 0:
      if (gpc_reg_operand (operands[0], E_QImode))
        {
          switch (pattern454 (
E_SImode))
            {
            case 0:
              if (
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                return 421; /* fixuns_truncsfqi2 */
              break;

            case 1:
              if (
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                return 425; /* fixuns_truncdfqi2 */
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_QImode))
        return -1;
      switch (pattern456 (
E_QImode))
        {
        case 0:
          if (!
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 433; /* *fixuns_truncsfqi2_mem */

        case 1:
          if (!
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 439; /* *fixuns_truncdfqi2_mem */

        case 2:
          if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1036; /* *fixuns_trunckfqi2_mem */

        case 3:
          if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1042; /* *fixuns_trunctfqi2_mem */

        default:
          return -1;
        }

    case 1:
      if (gpc_reg_operand (operands[0], E_HImode))
        {
          switch (pattern454 (
E_SImode))
            {
            case 0:
              if (
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                return 423; /* fixuns_truncsfhi2 */
              break;

            case 1:
              if (
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                return 427; /* fixuns_truncdfhi2 */
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_HImode))
        return -1;
      switch (pattern456 (
E_HImode))
        {
        case 0:
          if (!
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 435; /* *fixuns_truncsfhi2_mem */

        case 1:
          if (!
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 441; /* *fixuns_truncdfhi2_mem */

        case 2:
          if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1038; /* *fixuns_trunckfhi2_mem */

        case 3:
          if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1044; /* *fixuns_trunctfhi2_mem */

        default:
          return -1;
        }

    case 2:
      if (memory_operand (operands[0], E_SImode))
        {
          switch (pattern455 ())
            {
            case 0:
              if (
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                return 437; /* *fixuns_truncsfsi2_mem */
              break;

            case 1:
              if (
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                return 443; /* *fixuns_truncdfsi2_mem */
              break;

            case 2:
              if ((
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return 1040; /* *fixuns_trunckfsi2_mem */
              break;

            case 3:
              if ((
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return 1046; /* *fixuns_trunctfsi2_mem */
              break;

            default:
              break;
            }
        }
      if (!nonimmediate_operand (operands[0], E_SImode))
        return -1;
      switch (pattern454 (
E_DImode))
        {
        case 0:
          if (!
#line 6467 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTIWUZ
   && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE))
            return -1;
          return 444; /* fixuns_truncsfsi2_stfiwx */

        case 1:
          if (!
#line 6467 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTIWUZ
   && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE))
            return -1;
          return 445; /* fixuns_truncdfsi2_stfiwx */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_182 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x3))
    {
    case SET:
      x4 = XEXP (x3, 1);
      switch (GET_CODE (x4))
        {
        case UNSIGNED_FLOAT:
          if (pattern191 (x1, 
USE, 
E_DFmode) != 0
              || pattern392 (x1) != 0
              || !
#line 6170 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_FCFIDU && TARGET_HARD_FLOAT
   && !(TARGET_FCFID && TARGET_POWERPC64)))
            return -1;
          return 405; /* *floatunssidf2_internal */

        case FIX:
          if (pattern191 (x1, 
CLOBBER, 
E_SImode) != 0)
            return -1;
          switch (pattern393 (x1))
            {
            case 0:
              if (!(
#line 9097 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
                return -1;
              return 610; /* *fix_truncifsi2_internal */

            case 1:
              if (!(
#line 9097 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
                return -1;
              return 611; /* *fix_trunctfsi2_internal */

            default:
              return -1;
            }

        case CALL:
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != MEM
              || GET_MODE (x5) != E_SImode
              || pattern254 (x1) != 0)
            return -1;
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (!indirect_call_operand (operands[1], E_DImode))
            return -1;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          if (!unspec_tls (operands[2], E_DImode))
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          x10 = XEXP (x9, 0);
          operands[3] = x10;
          if (!immediate_operand (operands[3], E_SImode))
            return -1;
          x11 = XVECEXP (x1, 0, 2);
          x12 = XEXP (x11, 0);
          operands[4] = x12;
          if (!memory_operand (operands[4], E_DImode))
            return -1;
          x13 = XVECEXP (x1, 0, 3);
          x14 = XEXP (x13, 1);
          x15 = XVECEXP (x14, 0, 0);
          operands[5] = x15;
          if (!const_int_operand (operands[5], E_DImode)
              || !(
#line 11749 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 780; /* *call_value_indirect_aixdi */

        case IF_THEN_ELSE:
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != AND)
            return -1;
          x16 = XEXP (x5, 1);
          if (!branch_comparison_operator (x16, E_VOIDmode))
            return -1;
          operands[3] = x16;
          x17 = XEXP (x16, 1);
          if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || pattern116 (x1) != 0)
            return -1;
          x18 = XEXP (x16, 0);
          operands[4] = x18;
          if (!cc_reg_operand (operands[4], E_VOIDmode))
            return -1;
          x8 = XEXP (x4, 1);
          x19 = XEXP (x8, 0);
          operands[0] = x19;
          x9 = XVECEXP (x1, 0, 1);
          x10 = XEXP (x9, 0);
          operands[2] = x10;
          if (!nonimmediate_operand (operands[2], E_DImode))
            return -1;
          x11 = XVECEXP (x1, 0, 2);
          x12 = XEXP (x11, 0);
          operands[5] = x12;
          if (!scratch_operand (operands[5], E_DImode))
            return -1;
          x13 = XVECEXP (x1, 0, 3);
          x20 = XEXP (x13, 0);
          operands[6] = x20;
          if (!scratch_operand (operands[6], E_CCmode))
            return -1;
          x21 = XEXP (x2, 0);
          operands[7] = x21;
          if (!scratch_operand (operands[7], E_CCEQmode))
            return -1;
          switch (pattern554 (x1))
            {
            case 0:
              return 905; /* bdztf_di */

            case 1:
              return 906; /* bdnztf_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != E_SImode
          || pattern254 (x1) != 0)
        return -1;
      x22 = XEXP (x6, 0);
      operands[0] = x22;
      if (!indirect_call_operand (operands[0], E_DImode))
        return -1;
      x4 = XEXP (x3, 1);
      operands[1] = x4;
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 0);
      operands[2] = x10;
      if (!immediate_operand (operands[2], E_SImode))
        return -1;
      x11 = XVECEXP (x1, 0, 2);
      x12 = XEXP (x11, 0);
      operands[3] = x12;
      if (!memory_operand (operands[3], E_DImode))
        return -1;
      x13 = XVECEXP (x1, 0, 3);
      x14 = XEXP (x13, 1);
      x15 = XVECEXP (x14, 0, 0);
      operands[4] = x15;
      if (!const_int_operand (operands[4], E_DImode)
          || !(
#line 11728 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return -1;
      return 779; /* *call_indirect_aixdi */

    default:
      return -1;
    }
}

 rtx_insn *
split_3 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return NULL;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  switch (XVECLEN (x5, 0))
    {
    case 1:
      x6 = XEXP (x2, 0);
      operands[2] = x6;
      switch (XINT (x5, 1))
        {
        case 87:
          if (GET_MODE (x5) != E_SImode
              || !nonimmediate_operand (operands[0], E_SImode))
            return NULL;
          x7 = XVECEXP (x5, 0, 0);
          operands[1] = x7;
          if (!input_operand (operands[1], E_SFmode)
              || !scratch_operand (operands[2], E_V4SFmode)
              || !(
#line 7832 "../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG
   && (register_operand (operands[0], SImode)
       || register_operand (operands[1], SFmode))) && 
#line 7847 "../../gcc/config/rs6000/rs6000.md"
( reload_completed
   && int_reg_operand (operands[0], SImode)
   && vsx_reg_sfsubreg_ok (operands[1], SFmode))))
            return NULL;
          return gen_split_291 (insn, operands);

        case 86:
          if (GET_MODE (x5) != E_SFmode
              || !scratch_operand (operands[2], E_DImode))
            return NULL;
          if (nonimmediate_operand (operands[0], E_SFmode))
            {
              x7 = XVECEXP (x5, 0, 0);
              operands[1] = x7;
              if (input_operand (operands[1], E_SImode)
                  && (
#line 8385 "../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG
   && (register_operand (operands[0], SFmode)
       || register_operand (operands[1], SImode))) && 
#line 8400 "../../gcc/config/rs6000/rs6000.md"
( reload_completed
   && vsx_reg_sfsubreg_ok (operands[0], SFmode)
   && int_reg_operand_not_pseudo (operands[1], SImode))))
                return gen_split_301 (insn, operands);
            }
          x7 = XVECEXP (x5, 0, 0);
          if (!lowpart_subreg_operator (x7, E_SImode))
            return NULL;
          switch (pattern469 (x7))
            {
            case 0:
              if (!(
#line 8452 "../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG) && 
#line 8454 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_302 (insn, operands);

            case 1:
              if (!(
#line 8452 "../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG) && 
#line 8454 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_303 (insn, operands);

            default:
              return NULL;
            }

        case 61:
          x7 = XVECEXP (x5, 0, 0);
          operands[1] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern445 (x5, 
E_DImode, 
E_IFmode) != 0
                  || !(
#line 9589 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE) && 
#line 9591 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_341 (insn, operands);

            case E_DFmode:
              if (pattern445 (x5, 
E_DFmode, 
E_IFmode) != 0
                  || !(
#line 9589 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE) && 
#line 9591 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_342 (insn, operands);

            case E_DDmode:
              if (pattern445 (x5, 
E_DDmode, 
E_IFmode) != 0
                  || !(
#line 9589 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE) && 
#line 9591 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_343 (insn, operands);

            case E_TImode:
              if (pattern445 (x5, 
E_TImode, 
E_IFmode) != 0
                  || !(
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9636 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_344 (insn, operands);

            case E_V16QImode:
              if (pattern445 (x5, 
E_V16QImode, 
E_IFmode) != 0
                  || !(
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9636 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_345 (insn, operands);

            case E_V8HImode:
              if (pattern445 (x5, 
E_V8HImode, 
E_IFmode) != 0
                  || !(
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9636 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_346 (insn, operands);

            case E_V4SImode:
              if (pattern445 (x5, 
E_V4SImode, 
E_IFmode) != 0
                  || !(
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9636 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_347 (insn, operands);

            case E_V4SFmode:
              if (pattern445 (x5, 
E_V4SFmode, 
E_IFmode) != 0
                  || !(
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9636 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_348 (insn, operands);

            case E_V2DImode:
              if (pattern445 (x5, 
E_V2DImode, 
E_IFmode) != 0
                  || !(
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9636 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_349 (insn, operands);

            case E_V2DFmode:
              if (pattern445 (x5, 
E_V2DFmode, 
E_IFmode) != 0
                  || !(
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9636 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_350 (insn, operands);

            case E_V1TImode:
              if (pattern445 (x5, 
E_V1TImode, 
E_IFmode) != 0
                  || !(
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9636 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_351 (insn, operands);

            case E_KFmode:
              if (pattern445 (x5, 
E_KFmode, 
E_IFmode) != 0
                  || !((
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 560 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))) && 
#line 9636 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_352 (insn, operands);

            case E_TFmode:
              if (pattern445 (x5, 
E_TFmode, 
E_IFmode) != 0
                  || !((
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 561 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))) && 
#line 9636 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_353 (insn, operands);

            case E_SFmode:
              if (pattern445 (x5, 
E_SFmode, 
E_DImode) != 0
                  || !(
#line 9688 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9690 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_364 (insn, operands);

            default:
              return NULL;
            }

        case 64:
          x7 = XVECEXP (x5, 0, 0);
          operands[1] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_TImode:
              if (pattern446 (x5, 
E_TImode) != 0
                  || !(
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_365 (insn, operands);

            case E_V16QImode:
              if (pattern446 (x5, 
E_V16QImode) != 0
                  || !(
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_366 (insn, operands);

            case E_V8HImode:
              if (pattern446 (x5, 
E_V8HImode) != 0
                  || !(
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_367 (insn, operands);

            case E_V4SImode:
              if (pattern446 (x5, 
E_V4SImode) != 0
                  || !(
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_368 (insn, operands);

            case E_V4SFmode:
              if (pattern445 (x5, 
E_V4SFmode, 
E_V4SFmode) != 0
                  || !(
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_369 (insn, operands);

            case E_V2DImode:
              if (pattern446 (x5, 
E_V2DImode) != 0
                  || !(
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_370 (insn, operands);

            case E_V2DFmode:
              if (pattern446 (x5, 
E_V2DFmode) != 0
                  || !(
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_371 (insn, operands);

            case E_V1TImode:
              if (pattern446 (x5, 
E_V1TImode) != 0
                  || !(
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_372 (insn, operands);

            case E_KFmode:
              if (pattern446 (x5, 
E_KFmode) != 0
                  || !((
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 560 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))) && 
#line 9726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_373 (insn, operands);

            case E_TFmode:
              if (pattern446 (x5, 
E_TFmode) != 0
                  || !((
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 561 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))) && 
#line 9726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_374 (insn, operands);

            case E_SFmode:
              if (pattern445 (x5, 
E_SFmode, 
E_V4SFmode) != 0
                  || !(
#line 9752 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9754 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_375 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 2:
      if (XINT (x5, 1) != 145)
        return NULL;
      switch (pattern330 (x1))
        {
        case 0:
          if (!(
#line 3675 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 3677 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_594 (insn, operands);

        case 1:
          if (!(
#line 3675 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 3677 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_595 (insn, operands);

        case 2:
          if (!(
#line 3762 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 3764 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_599 (insn, operands);

        case 3:
          if (!(
#line 4204 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4206 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_618 (insn, operands);

        case 4:
          if (!(
#line 4204 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4206 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_619 (insn, operands);

        case 5:
          if (!(
#line 4204 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4206 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_620 (insn, operands);

        default:
          return NULL;
        }

    case 3:
      if (XINT (x5, 1) != 123
          || GET_MODE (x5) != E_V4SFmode
          || !gpc_reg_operand (operands[0], E_V4SFmode))
        return NULL;
      x7 = XVECEXP (x5, 0, 0);
      operands[1] = x7;
      switch (pattern447 (x1))
        {
        case 0:
          if (!(
#line 4616 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_P9_VECTOR && TARGET_POWERPC64) && 
#line 4618 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_655 (insn, operands);

        case 1:
          if (!(
#line 4652 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_P9_VECTOR && TARGET_POWERPC64) && 
#line 4654 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_656 (insn, operands);

        case 2:
          if (!(
#line 4712 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && VECTOR_MEM_VSX_P (V4SImode)
   && TARGET_P9_VECTOR && TARGET_POWERPC64
   && (INTVAL (operands[3]) != (BYTES_BIG_ENDIAN ? 1 : 2))) && 
#line 4716 "../../gcc/config/rs6000/vsx.md"
( 1)))
            return NULL;
          return gen_split_657 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_10 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      switch (pattern257 (x2))
        {
        case 0:
          return gen_split_85 (insn, operands);

        case 1:
          if (!
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return NULL;
          return gen_split_87 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      if (!const_int_operand (x5, E_SImode))
        return NULL;
      x6 = XEXP (x2, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[3] = x6;
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern197 (x2, 
E_SImode) != 0
                  || !
#line 4348 "../../gcc/config/rs6000/rs6000.md"
(nonzero_bits (operands[3], SImode)
   < HOST_WIDE_INT_1U << INTVAL (operands[2])))
                return NULL;
              return gen_split_110 (insn, operands);

            case E_DImode:
              if (pattern197 (x2, 
E_DImode) != 0
                  || !(
#line 4348 "../../gcc/config/rs6000/rs6000.md"
(nonzero_bits (operands[3], DImode)
   < HOST_WIDE_INT_1U << INTVAL (operands[2])) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return NULL;
              return gen_split_113 (insn, operands);

            default:
              return NULL;
            }

        case LSHIFTRT:
          operands[3] = x5;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          x8 = XEXP (x6, 1);
          operands[4] = x8;
          if (!const_int_operand (operands[4], E_SImode))
            return NULL;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern521 (x2, 
E_SImode) != 0
                  || !
#line 4422 "../../gcc/config/rs6000/rs6000.md"
(can_create_pseudo_p ()
   && INTVAL (operands[3]) + INTVAL (operands[4])
      >= GET_MODE_PRECISION (SImode)))
                return NULL;
              return gen_split_115 (insn, operands);

            case E_DImode:
              if (pattern521 (x2, 
E_DImode) != 0
                  || !(
#line 4422 "../../gcc/config/rs6000/rs6000.md"
(can_create_pseudo_p ()
   && INTVAL (operands[3]) + INTVAL (operands[4])
      >= GET_MODE_PRECISION (DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return NULL;
              return gen_split_116 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          operands[2] = x5;
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern411 (x2, 
E_DImode) != 0)
                return NULL;
              switch (GET_MODE (operands[3]))
                {
                case E_QImode:
                  if (!memory_operand (operands[3], E_QImode)
                      || !
#line 4504 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) == 8))
                    return NULL;
                  return gen_split_121 (insn, operands);

                case E_HImode:
                  if (!memory_operand (operands[3], E_HImode)
                      || !
#line 4504 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) == 16))
                    return NULL;
                  return gen_split_122 (insn, operands);

                case E_SImode:
                  if (!memory_operand (operands[3], E_SImode)
                      || !
#line 4504 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) == 32))
                    return NULL;
                  return gen_split_123 (insn, operands);

                default:
                  return NULL;
                }

            case E_SImode:
              if (pattern411 (x2, 
E_SImode) != 0)
                return NULL;
              switch (GET_MODE (operands[3]))
                {
                case E_QImode:
                  if (!memory_operand (operands[3], E_QImode)
                      || !
#line 4549 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) == 8))
                    return NULL;
                  return gen_split_127 (insn, operands);

                case E_HImode:
                  if (!memory_operand (operands[3], E_HImode)
                      || !
#line 4549 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) == 16))
                    return NULL;
                  return gen_split_128 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case LSHIFTRT:
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != ASHIFT)
        return NULL;
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      x5 = XEXP (x3, 1);
      operands[4] = x5;
      if (!const_int_operand (operands[4], E_SImode))
        return NULL;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      x8 = XEXP (x6, 1);
      operands[3] = x8;
      if (!const_int_operand (operands[3], E_SImode))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern522 (x2, 
E_SImode) != 0
              || !
#line 4446 "../../gcc/config/rs6000/rs6000.md"
(can_create_pseudo_p ()
   && INTVAL (operands[3]) + INTVAL (operands[4])
      >= GET_MODE_PRECISION (SImode)))
            return NULL;
          return gen_split_117 (insn, operands);

        case E_DImode:
          if (pattern522 (x2, 
E_DImode) != 0
              || !(
#line 4446 "../../gcc/config/rs6000/rs6000.md"
(can_create_pseudo_p ()
   && INTVAL (operands[3]) + INTVAL (operands[4])
      >= GET_MODE_PRECISION (DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return NULL;
          return gen_split_118 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_13 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (vsx_register_operand (operands[0], E_SFmode)
          && vsx_prefixed_constant (operands[1], E_SFmode)
          && 
#line 8750 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
        return gen_split_310 (insn, operands);
      break;

    case E_DFmode:
      if (vsx_register_operand (operands[0], E_DFmode)
          && vsx_prefixed_constant (operands[1], E_DFmode)
          && 
#line 8750 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
        return gen_split_311 (insn, operands);
      break;

    default:
      break;
    }
  switch (GET_MODE (operands[0]))
    {
    case E_TFmode:
      if (nonimmediate_operand (operands[0], E_TFmode)
          && input_operand (operands[1], E_TFmode))
        {
          if (((
#line 8807 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_POWERPC64 && FLOAT128_2REG_P (TFmode)
   && (TFmode != TDmode || WORDS_BIG_ENDIAN)
   && (gpc_reg_operand (operands[0], TFmode)
       || gpc_reg_operand (operands[1], TFmode))) && 
#line 547 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TFmode))) && 
#line 8812 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return gen_split_312 (insn, operands);
          if (((
#line 8843 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && !TARGET_POWERPC64
   && (FLOAT128_2REG_P (TFmode)
       || int_reg_operand_not_pseudo (operands[0], TFmode)
       || int_reg_operand_not_pseudo (operands[1], TFmode))
   && (gpc_reg_operand (operands[0], TFmode)
       || gpc_reg_operand (operands[1], TFmode))) && 
#line 547 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TFmode))) && 
#line 8850 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return gen_split_316 (insn, operands);
          if (((
#line 8861 "../../gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT
   && (gpc_reg_operand (operands[0], TFmode)
       || gpc_reg_operand (operands[1], TFmode))) && 
#line 543 "../../gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)) && 
#line 8865 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return gen_split_319 (insn, operands);
          if ((
#line 9660 "../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], TFmode)
       || int_reg_operand (operands[1], TFmode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], TFmode)
           && !vsx_register_operand (operands[1], TFmode)))) && 
#line 561 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))))
            return gen_split_363 (insn, operands);
          if (
#line 171 "../../gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TFmode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
            return gen_split_525 (insn, operands);
        }
      if (vsx_register_operand (operands[0], E_TFmode)
          && memory_operand (operands[1], E_TFmode)
          && (
#line 1045 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[1], TFmode)) && 
#line 36 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (TFmode))))
        return gen_split_570 (insn, operands);
      if (memory_operand (operands[0], E_TFmode)
          && vsx_register_operand (operands[1], E_TFmode))
        {
          if ((
#line 1075 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], TFmode)) && 
#line 36 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (TFmode))))
            return gen_split_574 (insn, operands);
          if ((
#line 1131 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], TFmode)) && 
#line 36 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (TFmode))))
            return gen_split_578 (insn, operands);
        }
      if (!altivec_register_operand (operands[0], E_TFmode))
        return NULL;
      if (easy_vector_constant_msb (operands[1], E_TFmode)
          && (
#line 286 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (TFmode) && reload_completed) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
        return gen_split_683 (insn, operands);
      if (easy_vector_constant_add_self (operands[1], E_TFmode)
          && (
#line 324 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (TFmode) && reload_completed) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
        return gen_split_693 (insn, operands);
      if (!easy_vector_constant_vsldoi (operands[1], E_TFmode)
          || !(
#line 353 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (TFmode) && can_create_pseudo_p ()) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
        return NULL;
      return gen_split_703 (insn, operands);

    case E_IFmode:
      if (!nonimmediate_operand (operands[0], E_IFmode)
          || !input_operand (operands[1], E_IFmode))
        return NULL;
      if (((
#line 8807 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_POWERPC64 && FLOAT128_2REG_P (IFmode)
   && (IFmode != TDmode || WORDS_BIG_ENDIAN)
   && (gpc_reg_operand (operands[0], IFmode)
       || gpc_reg_operand (operands[1], IFmode))) && 
#line 548 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (IFmode))) && 
#line 8812 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return gen_split_313 (insn, operands);
      if (((
#line 8843 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && !TARGET_POWERPC64
   && (FLOAT128_2REG_P (IFmode)
       || int_reg_operand_not_pseudo (operands[0], IFmode)
       || int_reg_operand_not_pseudo (operands[1], IFmode))
   && (gpc_reg_operand (operands[0], IFmode)
       || gpc_reg_operand (operands[1], IFmode))) && 
#line 548 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (IFmode))) && 
#line 8850 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return gen_split_317 (insn, operands);
      if (!((
#line 8861 "../../gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT
   && (gpc_reg_operand (operands[0], IFmode)
       || gpc_reg_operand (operands[1], IFmode))) && 
#line 544 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))) && 
#line 8865 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return NULL;
      return gen_split_320 (insn, operands);

    case E_TDmode:
      if (!nonimmediate_operand (operands[0], E_TDmode)
          || !input_operand (operands[1], E_TDmode))
        return NULL;
      if (((
#line 8807 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_POWERPC64 && FLOAT128_2REG_P (TDmode)
   && (TDmode != TDmode || WORDS_BIG_ENDIAN)
   && (gpc_reg_operand (operands[0], TDmode)
       || gpc_reg_operand (operands[1], TDmode))) && 
#line 549 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)) && 
#line 8812 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return gen_split_314 (insn, operands);
      if ((
#line 8826 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_POWERPC64 && !WORDS_BIG_ENDIAN
   && (gpc_reg_operand (operands[0], TDmode)
       || gpc_reg_operand (operands[1], TDmode))) && 
#line 8830 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return gen_split_315 (insn, operands);
      if (((
#line 8843 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && !TARGET_POWERPC64
   && (FLOAT128_2REG_P (TDmode)
       || int_reg_operand_not_pseudo (operands[0], TDmode)
       || int_reg_operand_not_pseudo (operands[1], TDmode))
   && (gpc_reg_operand (operands[0], TDmode)
       || gpc_reg_operand (operands[1], TDmode))) && 
#line 549 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)) && 
#line 8850 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return gen_split_318 (insn, operands);
      if (!((
#line 8861 "../../gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT
   && (gpc_reg_operand (operands[0], TDmode)
       || gpc_reg_operand (operands[1], TDmode))) && 
#line 545 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)) && 
#line 8865 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return NULL;
      return gen_split_321 (insn, operands);

    case E_TImode:
      return split_12 (x1, insn);

    case E_V16QImode:
      if (nonimmediate_operand (operands[0], E_V16QImode)
          && input_operand (operands[1], E_V16QImode))
        {
          if (
#line 9660 "../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], V16QImode)
       || int_reg_operand (operands[1], V16QImode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], V16QImode)
           && !vsx_register_operand (operands[1], V16QImode)))))
            return gen_split_355 (insn, operands);
          if (
#line 171 "../../gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V16QImode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
            return gen_split_516 (insn, operands);
        }
      if (vsx_register_operand (operands[0], E_V16QImode)
          && indexed_or_indirect_operand (operands[1], E_V16QImode)
          && (
#line 601 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR) && 
#line 603 "../../gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_554 (insn, operands);
      if (indexed_or_indirect_operand (operands[0], E_V16QImode)
          && vsx_register_operand (operands[1], E_V16QImode))
        {
          if (
#line 901 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && !reload_completed))
            return gen_split_565 (insn, operands);
          if (
#line 959 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && reload_completed))
            return gen_split_566 (insn, operands);
        }
      if (!altivec_register_operand (operands[0], E_V16QImode))
        return NULL;
      if (easy_vector_constant_msb (operands[1], E_V16QImode)
          && 
#line 286 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V16QImode) && reload_completed))
        return gen_split_676 (insn, operands);
      if (easy_vector_constant_add_self (operands[1], E_V16QImode)
          && 
#line 324 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V16QImode) && reload_completed))
        return gen_split_686 (insn, operands);
      if (!easy_vector_constant_vsldoi (operands[1], E_V16QImode)
          || !
#line 353 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V16QImode) && can_create_pseudo_p ()))
        return NULL;
      return gen_split_696 (insn, operands);

    case E_V8HImode:
      if (nonimmediate_operand (operands[0], E_V8HImode)
          && input_operand (operands[1], E_V8HImode))
        {
          if (
#line 9660 "../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], V8HImode)
       || int_reg_operand (operands[1], V8HImode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], V8HImode)
           && !vsx_register_operand (operands[1], V8HImode)))))
            return gen_split_356 (insn, operands);
          if (
#line 171 "../../gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V8HImode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
            return gen_split_517 (insn, operands);
        }
      if (vsx_register_operand (operands[0], E_V8HImode)
          && indexed_or_indirect_operand (operands[1], E_V8HImode)
          && (
#line 547 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR) && 
#line 549 "../../gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_553 (insn, operands);
      if (!indexed_or_indirect_operand (operands[0], E_V8HImode)
          || !vsx_register_operand (operands[1], E_V8HImode))
        return NULL;
      if (
#line 816 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && !reload_completed))
        return gen_split_563 (insn, operands);
      if (!
#line 866 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && reload_completed))
        return NULL;
      return gen_split_564 (insn, operands);

    case E_V4SImode:
      if (nonimmediate_operand (operands[0], E_V4SImode)
          && input_operand (operands[1], E_V4SImode))
        {
          if (
#line 9660 "../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], V4SImode)
       || int_reg_operand (operands[1], V4SImode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], V4SImode)
           && !vsx_register_operand (operands[1], V4SImode)))))
            return gen_split_357 (insn, operands);
          if (
#line 171 "../../gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SImode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
            return gen_split_518 (insn, operands);
        }
      if (vsx_register_operand (operands[0], E_V4SImode)
          && indexed_or_indirect_operand (operands[1], E_V4SImode)
          && (
#line 497 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR) && 
#line 499 "../../gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_552 (insn, operands);
      if (!indexed_or_indirect_operand (operands[0], E_V4SImode)
          || !vsx_register_operand (operands[1], E_V4SImode))
        return NULL;
      if (
#line 741 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && !reload_completed))
        return gen_split_560 (insn, operands);
      if (!
#line 787 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && reload_completed))
        return NULL;
      return gen_split_562 (insn, operands);

    case E_V4SFmode:
      if (nonimmediate_operand (operands[0], E_V4SFmode)
          && input_operand (operands[1], E_V4SFmode))
        {
          if (
#line 9660 "../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], V4SFmode)
       || int_reg_operand (operands[1], V4SFmode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], V4SFmode)
           && !vsx_register_operand (operands[1], V4SFmode)))))
            return gen_split_358 (insn, operands);
          if (
#line 171 "../../gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SFmode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
            return gen_split_520 (insn, operands);
        }
      if (vsx_register_operand (operands[0], E_V4SFmode)
          && indexed_or_indirect_operand (operands[1], E_V4SFmode)
          && (
#line 497 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR) && 
#line 499 "../../gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_551 (insn, operands);
      if (indexed_or_indirect_operand (operands[0], E_V4SFmode)
          && vsx_register_operand (operands[1], E_V4SFmode))
        {
          if (
#line 741 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && !reload_completed))
            return gen_split_559 (insn, operands);
          if (
#line 787 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && reload_completed))
            return gen_split_561 (insn, operands);
        }
      if (!altivec_register_operand (operands[0], E_V4SFmode))
        return NULL;
      if (easy_vector_constant_msb (operands[1], E_V4SFmode)
          && 
#line 286 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && reload_completed))
        return gen_split_677 (insn, operands);
      if (easy_vector_constant_add_self (operands[1], E_V4SFmode)
          && 
#line 324 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && reload_completed))
        return gen_split_687 (insn, operands);
      if (!easy_vector_constant_vsldoi (operands[1], E_V4SFmode)
          || !
#line 353 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
        return NULL;
      return gen_split_697 (insn, operands);

    case E_V2DImode:
      if (nonimmediate_operand (operands[0], E_V2DImode)
          && input_operand (operands[1], E_V2DImode))
        {
          if (
#line 9660 "../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], V2DImode)
       || int_reg_operand (operands[1], V2DImode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], V2DImode)
           && !vsx_register_operand (operands[1], V2DImode)))))
            return gen_split_359 (insn, operands);
          if (
#line 171 "../../gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DImode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
            return gen_split_519 (insn, operands);
        }
      if (vsx_register_operand (operands[0], E_V2DImode)
          && indexed_or_indirect_operand (operands[1], E_V2DImode)
          && (
#line 449 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR) && 
#line 451 "../../gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_550 (insn, operands);
      if (!indexed_or_indirect_operand (operands[0], E_V2DImode)
          || !vsx_register_operand (operands[1], E_V2DImode))
        return NULL;
      if (
#line 671 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && !reload_completed))
        return gen_split_556 (insn, operands);
      if (!
#line 715 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && reload_completed))
        return NULL;
      return gen_split_558 (insn, operands);

    case E_V2DFmode:
      if (nonimmediate_operand (operands[0], E_V2DFmode)
          && input_operand (operands[1], E_V2DFmode))
        {
          if (
#line 9660 "../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], V2DFmode)
       || int_reg_operand (operands[1], V2DFmode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], V2DFmode)
           && !vsx_register_operand (operands[1], V2DFmode)))))
            return gen_split_360 (insn, operands);
          if (
#line 171 "../../gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DFmode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
            return gen_split_521 (insn, operands);
        }
      if (vsx_register_operand (operands[0], E_V2DFmode)
          && indexed_or_indirect_operand (operands[1], E_V2DFmode)
          && (
#line 449 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR) && 
#line 451 "../../gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_549 (insn, operands);
      if (indexed_or_indirect_operand (operands[0], E_V2DFmode)
          && vsx_register_operand (operands[1], E_V2DFmode))
        {
          if (
#line 671 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && !reload_completed))
            return gen_split_555 (insn, operands);
          if (
#line 715 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR && reload_completed))
            return gen_split_557 (insn, operands);
        }
      if (!altivec_register_operand (operands[0], E_V2DFmode))
        return NULL;
      if (easy_vector_constant_msb (operands[1], E_V2DFmode)
          && 
#line 286 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && reload_completed))
        return gen_split_678 (insn, operands);
      if (easy_vector_constant_add_self (operands[1], E_V2DFmode)
          && 
#line 324 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && reload_completed))
        return gen_split_688 (insn, operands);
      if (!easy_vector_constant_vsldoi (operands[1], E_V2DFmode)
          || !
#line 353 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
        return NULL;
      return gen_split_698 (insn, operands);

    case E_V1TImode:
      if (nonimmediate_operand (operands[0], E_V1TImode)
          && input_operand (operands[1], E_V1TImode))
        {
          if (
#line 9660 "../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], V1TImode)
       || int_reg_operand (operands[1], V1TImode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], V1TImode)
           && !vsx_register_operand (operands[1], V1TImode)))))
            return gen_split_361 (insn, operands);
          if (
#line 171 "../../gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
            return gen_split_522 (insn, operands);
        }
      if (vsx_register_operand (operands[0], E_V1TImode)
          && memory_operand (operands[1], E_V1TImode)
          && 
#line 1045 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[1], V1TImode)))
        return gen_split_572 (insn, operands);
      if (memory_operand (operands[0], E_V1TImode)
          && vsx_register_operand (operands[1], E_V1TImode))
        {
          if (
#line 1075 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], V1TImode)))
            return gen_split_576 (insn, operands);
          if (
#line 1131 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], V1TImode)))
            return gen_split_580 (insn, operands);
        }
      if (!altivec_register_operand (operands[0], E_V1TImode))
        return NULL;
      if (easy_vector_constant_msb (operands[1], E_V1TImode)
          && 
#line 286 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V1TImode) && reload_completed))
        return gen_split_680 (insn, operands);
      if (easy_vector_constant_add_self (operands[1], E_V1TImode)
          && 
#line 324 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V1TImode) && reload_completed))
        return gen_split_690 (insn, operands);
      if (!easy_vector_constant_vsldoi (operands[1], E_V1TImode)
          || !
#line 353 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V1TImode) && can_create_pseudo_p ()))
        return NULL;
      return gen_split_700 (insn, operands);

    case E_KFmode:
      if (nonimmediate_operand (operands[0], E_KFmode)
          && input_operand (operands[1], E_KFmode))
        {
          if ((
#line 9660 "../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], KFmode)
       || int_reg_operand (operands[1], KFmode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], KFmode)
           && !vsx_register_operand (operands[1], KFmode)))) && 
#line 560 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))))
            return gen_split_362 (insn, operands);
          if (
#line 171 "../../gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
            return gen_split_524 (insn, operands);
        }
      if (vsx_register_operand (operands[0], E_KFmode)
          && memory_operand (operands[1], E_KFmode)
          && (
#line 1045 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[1], KFmode)) && 
#line 35 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (KFmode))))
        return gen_split_569 (insn, operands);
      if (memory_operand (operands[0], E_KFmode)
          && vsx_register_operand (operands[1], E_KFmode))
        {
          if ((
#line 1075 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], KFmode)) && 
#line 35 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (KFmode))))
            return gen_split_573 (insn, operands);
          if ((
#line 1131 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], KFmode)) && 
#line 35 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (KFmode))))
            return gen_split_577 (insn, operands);
        }
      if (!altivec_register_operand (operands[0], E_KFmode))
        return NULL;
      if (easy_vector_constant_msb (operands[1], E_KFmode)
          && (
#line 286 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (KFmode) && reload_completed) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
        return gen_split_682 (insn, operands);
      if (easy_vector_constant_add_self (operands[1], E_KFmode)
          && (
#line 324 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (KFmode) && reload_completed) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
        return gen_split_692 (insn, operands);
      if (!easy_vector_constant_vsldoi (operands[1], E_KFmode)
          || !(
#line 353 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (KFmode) && can_create_pseudo_p ()) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
        return NULL;
      return gen_split_702 (insn, operands);

    case E_DImode:
      if (nonimmediate_operand (operands[0], E_DImode)
          && input_operand (operands[1], E_DImode)
          && 
#line 9856 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_POWERPC64
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])))
        return gen_split_377 (insn, operands);
      if (int_reg_operand (operands[0], E_DImode)
          && const_int_operand (operands[1], E_DImode))
        {
          if (
#line 9957 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64
   && num_insns_constant (operands[1], DImode) > 1
   && !IN_RANGE (INTVAL (operands[1]), -0x80000000, 0xffffffff)
   && rs6000_is_valid_and_mask (operands[1], DImode)))
            return gen_split_380 (insn, operands);
          if (
#line 9975 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && num_insns_constant (operands[1], DImode) > 1))
            return gen_split_381 (insn, operands);
        }
      if (!altivec_register_operand (operands[0], E_DImode)
          || !s5bit_cint_operand (operands[1], E_DImode)
          || !
#line 9987 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && reload_completed))
        return NULL;
      return gen_split_382 (insn, operands);

    case E_DFmode:
      if (!nonimmediate_operand (operands[0], E_DFmode)
          || !input_operand (operands[1], E_DFmode)
          || !
#line 9856 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_POWERPC64
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])))
        return NULL;
      return gen_split_378 (insn, operands);

    case E_DDmode:
      if (!nonimmediate_operand (operands[0], E_DDmode)
          || !input_operand (operands[1], E_DDmode)
          || !
#line 9856 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_POWERPC64
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])))
        return NULL;
      return gen_split_379 (insn, operands);

    case E_PTImode:
      if (!nonimmediate_operand (operands[0], E_PTImode)
          || !input_operand (operands[1], E_PTImode)
          || !
#line 10090 "../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
        return NULL;
      return gen_split_390 (insn, operands);

    case E_OOmode:
      if (!nonimmediate_operand (operands[0], E_OOmode)
          || !input_operand (operands[1], E_OOmode)
          || !(
#line 297 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA
   && (gpc_reg_operand (operands[0], OOmode)
       || gpc_reg_operand (operands[1], OOmode))) && 
#line 304 "../../gcc/config/rs6000/mma.md"
( reload_completed
   && (!MEM_P (operands[0]) && !MEM_P (operands[1])))))
        return NULL;
      return gen_split_720 (insn, operands);

    case E_XOmode:
      if (!nonimmediate_operand (operands[0], E_XOmode)
          || !input_operand (operands[1], E_XOmode)
          || !(
#line 344 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA
   && (gpc_reg_operand (operands[0], XOmode)
       || gpc_reg_operand (operands[1], XOmode))) && 
#line 351 "../../gcc/config/rs6000/mma.md"
( reload_completed)))
        return NULL;
      return gen_split_721 (insn, operands);

    default:
      return NULL;
    }
}
