/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsx_register_operand (operands[1], i1)
      || !vsx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      return pattern10 (x1, 
E_V4SFmode); /* [-1, 0] */

    case E_V2DFmode:
      if (pattern10 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern19 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern23 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[3] = x4;
  if (!cc_reg_operand (operands[3], E_CCmode)
      || GET_MODE (x2) != E_CCmode)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  return 0;
}

int
pattern30 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != AND
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + -16])
    return -1;
  x3 = XEXP (x1, 0);
  switch (GET_CODE (x3))
    {
    case PLUS:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      operands[1] = x3;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern42 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case NOT:
      return pattern40 (x3); /* [-1, 1] */

    case REG:
    case SUBREG:
      res = pattern38 (x3);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern51 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern58 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern56 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern56 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern57 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern57 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern57 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern57 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern57 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern57 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern57 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern57 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern57 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern57 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern72 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!indexed_or_indirect_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!indexed_or_indirect_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern78 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x6;
      x7 = XEXP (x2, 0);
      operands[2] = x7;
      if (!scratch_operand (operands[2], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          return pattern76 (x5, 
E_SFmode); /* [-1, 1] */

        case E_DFmode:
          res = pattern76 (x5, 
E_DFmode);
          if (res >= 0)
            return res + 2; /* [2, 3] */
          return -1;

        case E_KFmode:
          res = pattern77 (x5, 
E_KFmode);
          if (res >= 0)
            return res + 4; /* [4, 6] */
          return -1;

        case E_TFmode:
          res = pattern77 (x5, 
E_TFmode);
          if (res >= 0)
            return res + 7; /* [7, 9] */
          return -1;

        default:
          return -1;
        }

    case ZERO_EXTEND:
      res = pattern71 (x1);
      if (res >= 0)
        return res + 10; /* [10, 11] */
      return -1;

    case VEC_SELECT:
      res = pattern74 (x1);
      if (res >= 0)
        return res + 12; /* [12, 23] */
      return -1;

    default:
      return -1;
    }
}

int
pattern96 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != LABEL_REF)
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x7, 0);
  if (!scratch_operand (x9, E_DImode))
    return -1;
  x10 = XEXP (x3, 0);
  switch (GET_CODE (x10))
    {
    case EQ:
      x11 = XEXP (x10, 0);
      switch (GET_CODE (x11))
        {
        case AND:
          if (GET_MODE (x11) != E_DImode)
            return -1;
          x12 = XEXP (x10, 1);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x13 = XEXP (x8, 0);
          if (GET_CODE (x13) != REG
              || REGNO (x13) != 100
              || GET_MODE (x13) != E_CCmode)
            return -1;
          x14 = XEXP (x11, 0);
          operands[1] = x14;
          if (!gpc_reg_operand (operands[1], E_DImode))
            return -1;
          x15 = XEXP (x11, 1);
          operands[2] = x15;
          if (!const_int_operand (operands[2], E_DImode))
            return -1;
          x16 = XEXP (x4, 0);
          operands[3] = x16;
          operands[0] = x9;
          return 0;

        case REG:
        case SUBREG:
          operands[1] = x11;
          if (!gpc_reg_operand (operands[1], E_DImode))
            return -1;
          x12 = XEXP (x10, 1);
          operands[2] = x12;
          if (!const_int_operand (operands[2], E_DImode))
            return -1;
          x16 = XEXP (x4, 0);
          operands[0] = x16;
          operands[3] = x9;
          x13 = XEXP (x8, 0);
          operands[4] = x13;
          if (!scratch_operand (operands[4], E_CCUNSmode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case NE:
      x11 = XEXP (x10, 0);
      operands[1] = x11;
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[2] = x12;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x16 = XEXP (x4, 0);
      operands[0] = x16;
      operands[3] = x9;
      x13 = XEXP (x8, 0);
      operands[4] = x13;
      if (!scratch_operand (operands[4], E_CCUNSmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern125 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern124 (x1, 
E_V4SImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern124 (x1, 
E_V2DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern134 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern133 (x3, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern133 (x3, 
E_DFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern143 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern142 (x3, 
E_V4SImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern142 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern142 (x3, 
E_V16QImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern154 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern142 (x3, 
E_V16QImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern142 (x3, 
E_V2DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern161 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V4SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_V4SImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      if (!register_operand (operands[1], E_V8HImode)
          || !register_operand (operands[2], E_V8HImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode)
          || !register_operand (operands[2], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern168 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!gpc_reg_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!gpc_reg_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern174 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XEXP (x4, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  return pattern171 (x1); /* [-1, 1] */
}

int
pattern177 (rtx x1, rtx_code i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 106
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern181 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  x6 = XEXP (x3, 1);
  operands[3] = x6;
  x7 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x7))
    {
    case CLOBBER:
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      switch (GET_MODE (operands[2]))
        {
        case E_CCmode:
          if (!cc_reg_operand (operands[2], E_CCmode)
              || GET_MODE (x3) != E_CCmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!non_update_memory_operand (operands[1], E_DImode)
                  || !const_m1_to_1_operand (operands[3], E_DImode)
                  || !scratch_operand (operands[0], E_DImode))
                return -1;
              return 0;

            case E_SImode:
              if (!non_update_memory_operand (operands[1], E_SImode)
                  || !const_m1_to_1_operand (operands[3], E_SImode)
                  || !scratch_operand (operands[0], E_SImode))
                return -1;
              return 1;

            case E_HImode:
              if (!non_update_memory_operand (operands[1], E_HImode)
                  || !const_m1_to_1_operand (operands[3], E_HImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!scratch_operand (operands[0], E_SImode))
                    return -1;
                  return 2;

                case E_DImode:
                  if (!scratch_operand (operands[0], E_DImode))
                    return -1;
                  return 3;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case E_CCUNSmode:
          if (!cc_reg_operand (operands[2], E_CCUNSmode)
              || GET_MODE (x3) != E_CCUNSmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!non_update_memory_operand (operands[1], E_DImode)
                  || !const_0_to_1_operand (operands[3], E_DImode)
                  || !scratch_operand (operands[0], E_DImode))
                return -1;
              return 4;

            case E_SImode:
              if (!non_update_memory_operand (operands[1], E_SImode)
                  || !const_0_to_1_operand (operands[3], E_SImode)
                  || !scratch_operand (operands[0], E_SImode))
                return -1;
              return 5;

            case E_HImode:
              res = pattern178 (
E_HImode);
              if (res >= 0)
                return res + 6; /* [6, 7] */
              return -1;

            case E_QImode:
              res = pattern178 (
E_QImode);
              if (res >= 0)
                return res + 8; /* [8, 9] */
              return -1;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      x9 = XEXP (x7, 1);
      switch (GET_CODE (x9))
        {
        case MEM:
          if (!rtx_equal_p (x9, operands[1]))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_CCmode:
              if (!cc_reg_operand (operands[2], E_CCmode)
                  || GET_MODE (x3) != E_CCmode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_DImode:
                  if (!non_update_memory_operand (operands[1], E_DImode)
                      || !const_m1_to_1_operand (operands[3], E_DImode)
                      || !gpc_reg_operand (operands[0], E_DImode))
                    return -1;
                  return 10;

                case E_SImode:
                  if (!non_update_memory_operand (operands[1], E_SImode)
                      || !const_m1_to_1_operand (operands[3], E_SImode)
                      || !gpc_reg_operand (operands[0], E_SImode))
                    return -1;
                  return 11;

                default:
                  return -1;
                }

            case E_CCUNSmode:
              if (!cc_reg_operand (operands[2], E_CCUNSmode)
                  || GET_MODE (x3) != E_CCUNSmode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_DImode:
                  if (!non_update_memory_operand (operands[1], E_DImode)
                      || !const_0_to_1_operand (operands[3], E_DImode)
                      || !gpc_reg_operand (operands[0], E_DImode))
                    return -1;
                  return 12;

                case E_SImode:
                  if (!non_update_memory_operand (operands[1], E_SImode)
                      || !const_0_to_1_operand (operands[3], E_SImode)
                      || !gpc_reg_operand (operands[0], E_SImode))
                    return -1;
                  return 13;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (!cc_reg_operand (operands[2], E_CCmode)
              || GET_MODE (x3) != E_CCmode)
            return -1;
          x10 = XEXP (x9, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!non_update_memory_operand (operands[1], E_SImode)
                  || !const_m1_to_1_operand (operands[3], E_SImode)
                  || !gpc_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x9) != E_DImode)
                return -1;
              return 14;

            case E_HImode:
              if (!non_update_memory_operand (operands[1], E_HImode)
                  || !const_m1_to_1_operand (operands[3], E_HImode))
                return -1;
              res = pattern179 (x9);
              if (res >= 0)
                return res + 15; /* [15, 16] */
              return -1;

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (!cc_reg_operand (operands[2], E_CCUNSmode)
              || GET_MODE (x3) != E_CCUNSmode)
            return -1;
          x10 = XEXP (x9, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!non_update_memory_operand (operands[1], E_SImode)
                  || !const_0_to_1_operand (operands[3], E_SImode)
                  || !gpc_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x9) != E_DImode)
                return -1;
              return 17;

            case E_HImode:
              res = pattern180 (x9, 
E_HImode);
              if (res >= 0)
                return res + 18; /* [18, 19] */
              return -1;

            case E_QImode:
              res = pattern180 (x9, 
E_QImode);
              if (res >= 0)
                return res + 20; /* [20, 21] */
              return -1;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern272 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern278 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != XOR)
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != NOT)
    return -1;
  x6 = XEXP (x4, 0);
  operands[0] = x6;
  x7 = XEXP (x4, 1);
  operands[1] = x7;
  x8 = XEXP (x5, 0);
  operands[2] = x8;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern276 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern276 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern277 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern277 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern277 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern277 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern277 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern277 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern277 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern277 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern277 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern277 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern302 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !reg_or_short_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !reg_or_short_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern313 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern323 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !register_operand (operands[0], E_SImode)
      || !register_operand (operands[1], E_SImode)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern329 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern336 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern341 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 98
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!gpc_reg_operand (operands[0], E_DImode))
    return -1;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!gpc_reg_operand (operands[3], E_DImode))
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != E_DImode)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  if (!scratch_operand (operands[4], E_DImode))
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  x12 = XEXP (x11, 0);
  operands[5] = x12;
  if (!scratch_operand (operands[5], E_DImode))
    return -1;
  switch (GET_CODE (x8))
    {
    case EQ:
      x13 = XEXP (x8, 0);
      operands[1] = x13;
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      x14 = XEXP (x8, 1);
      operands[2] = x14;
      if (!scc_eq_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case NE:
      x13 = XEXP (x8, 0);
      operands[1] = x13;
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      x14 = XEXP (x8, 1);
      operands[2] = x14;
      if (!scc_eq_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern363 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !add_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern370 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!boolean_operator (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern380 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern378 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern378 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern379 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern379 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern379 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern379 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern379 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern379 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern379 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern379 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern379 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern379 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern395 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_V2DFmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != VEC_CONCAT
      || GET_MODE (x5) != E_V2DFmode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != VEC_SELECT
      || GET_MODE (x6) != E_DFmode)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PARALLEL
      || XVECLEN (x7, 0) != 1)
    return -1;
  x8 = XVECEXP (x7, 0, 0);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x9 = XEXP (x5, 1);
  if (GET_CODE (x9) != VEC_SELECT
      || GET_MODE (x9) != E_DFmode)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != PARALLEL
      || XVECLEN (x10, 0) != 1)
    return -1;
  x11 = XVECEXP (x10, 0, 0);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x12 = XEXP (x3, 1);
  x13 = XVECEXP (x12, 0, 0);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || pattern394 (x1) != 0)
    return -1;
  return 0;
}

int
pattern407 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern413 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern418 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode)
        return -1;
      return 0;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern426 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_V2DFmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != VEC_CONCAT
      || GET_MODE (x5) != E_V2DFmode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != VEC_SELECT
      || GET_MODE (x6) != E_DFmode)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PARALLEL
      || XVECLEN (x7, 0) != 1)
    return -1;
  x8 = XVECEXP (x7, 0, 0);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x9 = XEXP (x5, 1);
  if (GET_CODE (x9) != VEC_SELECT
      || GET_MODE (x9) != E_DFmode)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != PARALLEL
      || XVECLEN (x10, 0) != 1)
    return -1;
  x11 = XVECEXP (x10, 0, 0);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x12 = XEXP (x3, 1);
  x13 = XVECEXP (x12, 0, 0);
  if (XWINT (x13, 0) != 1L
      || pattern394 (x1) != 0)
    return -1;
  return 0;
}

int
pattern441 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !gpc_reg_operand (operands[1], i2)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern450 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern460 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern464 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern472 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!memory_operand (operands[0], E_V4SImode)
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!memory_operand (operands[0], E_V8HImode)
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V16QImode:
      if (!memory_operand (operands[0], E_V16QImode)
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 2;

    case E_V4SFmode:
      if (!memory_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 3;

    case E_V2DFmode:
      if (!memory_operand (operands[0], E_V2DFmode)
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 4;

    case E_V2DImode:
      if (!memory_operand (operands[0], E_V2DImode)
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 5;

    case E_V1TImode:
      if (!memory_operand (operands[0], E_V1TImode)
          || !register_operand (operands[1], E_V1TImode))
        return -1;
      return 6;

    case E_KFmode:
      if (!memory_operand (operands[0], E_KFmode)
          || !register_operand (operands[1], E_KFmode))
        return -1;
      return 7;

    case E_TFmode:
      if (!memory_operand (operands[0], E_TFmode)
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern497 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern506 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !scratch_operand (operands[3], E_SImode)
          || !scratch_operand (operands[4], E_SImode)
          || !scratch_operand (operands[5], E_CCmode))
        return -1;
      return pattern108 (); /* [-1, 1] */

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[1], E_SImode))
            return -1;
          return 2;

        case E_DImode:
          if (!gpc_reg_operand (operands[1], E_DImode)
              || !reg_or_short_operand (operands[2], E_DImode)
              || !scratch_operand (operands[3], E_DImode)
              || !scratch_operand (operands[4], E_DImode)
              || !scratch_operand (operands[5], E_CCmode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern527 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !reg_or_short_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern532 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!boolean_operator (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern540 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[5], i1)
      || !const_int_operand (operands[6], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !rotate_mask_operator (operands[4], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !const_int_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern552 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern561 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != i1)
    return -1;
  x12 = XEXP (x11, 1);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x13 = XEXP (x5, 0);
  x14 = XEXP (x13, 0);
  operands[1] = x14;
  x15 = XEXP (x6, 0);
  operands[2] = x15;
  if (!gpc_reg_operand (operands[2], E_SImode))
    return -1;
  x16 = XEXP (x10, 0);
  x17 = XEXP (x16, 0);
  if (!rtx_equal_p (x17, operands[1]))
    return -1;
  x18 = XEXP (x11, 0);
  if (!rtx_equal_p (x18, operands[2]))
    return -1;
  return 0;
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[4] = x6;
  x7 = XEXP (x2, 1);
  operands[2] = x7;
  x8 = XEXP (x2, 2);
  operands[3] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern462 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 5586 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ISEL))
            return -1;
          return 346; /* *isel_reversed_cc_si */

        case 1:
          if (!
#line 5586 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ISEL))
            return -1;
          return 348; /* *isel_reversed_ccuns_si */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern462 (x2, 
E_DImode))
        {
        case 0:
          if (!(
#line 5586 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ISEL) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 347; /* *isel_reversed_cc_di */

        case 1:
          if (!(
#line 5586 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ISEL) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 349; /* *isel_reversed_ccuns_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[3] = x5;
  x6 = XEXP (x3, 1);
  operands[4] = x6;
  x7 = XEXP (x3, 2);
  operands[5] = x7;
  switch (GET_CODE (operands[4]))
    {
    case REG:
    case SUBREG:
      if (pnum_clobbers == NULL)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          switch (pattern479 (x3, 
E_SFmode))
            {
            case 0:
              if (!
#line 5665 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 370; /* *movsfsfcc_p9 */

            case 1:
              if (!
#line 5665 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 372; /* *movsfdfcc_p9 */

            default:
              return -1;
            }

        case E_DFmode:
          switch (pattern479 (x3, 
E_DFmode))
            {
            case 0:
              if (!
#line 5665 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 371; /* *movdfsfcc_p9 */

            case 1:
              if (!
#line 5665 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return -1;
              *pnum_clobbers = 1;
              return 373; /* *movdfdfcc_p9 */

            default:
              return -1;
            }

        case E_KFmode:
          if (pattern480 (x3, 
E_KFmode) != 0
              || !(
#line 5770 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 382; /* *movkfcc_p10 */

        case E_TFmode:
          if (pattern480 (x3, 
E_TFmode) != 0
              || !(
#line 5770 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 383; /* *movtfcc_p10 */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      if (!all_ones_constant (operands[4], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !zero_constant (operands[5], E_V2DImode))
        return -1;
      if (vsx_register_operand (operands[0], E_V2DImode))
        {
          switch (pattern478 ())
            {
            case 0:
              if (
#line 5732 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 378; /* *fpmasksf */
              break;

            case 1:
              if (
#line 5732 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 379; /* *fpmaskdf */
              break;

            default:
              break;
            }
        }
      if (!altivec_register_operand (operands[0], E_V2DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_KFmode:
          if (!altivec_register_operand (operands[2], E_KFmode)
              || !altivec_register_operand (operands[3], E_KFmode)
              || !(
#line 5837 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 386; /* *fpmaskkf */

        case E_TFmode:
          if (!altivec_register_operand (operands[2], E_TFmode)
              || !altivec_register_operand (operands[3], E_TFmode)
              || !(
#line 5837 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 387; /* *fpmasktf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ASHIFT:
    case ROTATE:
    case LSHIFTRT:
      operands[4] = x4;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != AND)
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[3] = x9;
      x10 = XEXP (x5, 0);
      operands[5] = x10;
      x11 = XEXP (x5, 1);
      operands[6] = x11;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern533 (x2, 
E_SImode) != 0
              || !
#line 4281 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_insert_mask (operands[3], operands[4], SImode)
   && UINTVAL (operands[3]) + UINTVAL (operands[6]) + 1 == 0))
            return -1;
          return 245; /* *rotlsi3_insert */

        case E_DImode:
          if (pattern533 (x2, 
E_DImode) != 0
              || !(
#line 4281 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_insert_mask (operands[3], operands[4], DImode)
   && UINTVAL (operands[3]) + UINTVAL (operands[6]) + 1 == 0) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 246; /* *rotldi3_insert */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      x9 = XEXP (x3, 1);
      switch (GET_CODE (x9))
        {
        case CONST_INT:
          x6 = XEXP (x1, 0);
          operands[0] = x6;
          x5 = XEXP (x2, 1);
          switch (GET_CODE (x5))
            {
            case AND:
              x10 = XEXP (x5, 0);
              switch (GET_CODE (x10))
                {
                case ASHIFT:
                case ROTATE:
                case LSHIFTRT:
                  operands[4] = x10;
                  operands[5] = x4;
                  operands[6] = x9;
                  x12 = XEXP (x10, 0);
                  operands[1] = x12;
                  x13 = XEXP (x10, 1);
                  operands[2] = x13;
                  if (!const_int_operand (operands[2], E_SImode))
                    return -1;
                  x11 = XEXP (x5, 1);
                  operands[3] = x11;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern540 (x2, 
E_SImode) != 0
                          || !
#line 4299 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_insert_mask (operands[3], operands[4], SImode)
   && UINTVAL (operands[3]) + UINTVAL (operands[6]) + 1 == 0))
                        return -1;
                      return 247; /* *rotlsi3_insert_2 */

                    case E_DImode:
                      if (pattern540 (x2, 
E_DImode) != 0
                          || !(
#line 4299 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_insert_mask (operands[3], operands[4], DImode)
   && UINTVAL (operands[3]) + UINTVAL (operands[6]) + 1 == 0) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                        return -1;
                      return 248; /* *rotldi3_insert_2 */

                    default:
                      return -1;
                    }

                case REG:
                case SUBREG:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (!gpc_reg_operand (operands[0], E_SImode)
                          || GET_MODE (x2) != E_SImode
                          || GET_MODE (x3) != E_SImode)
                        return -1;
                      operands[1] = x4;
                      if (!gpc_reg_operand (operands[1], E_SImode))
                        return -1;
                      operands[2] = x9;
                      if (!const_int_operand (operands[2], E_SImode)
                          || GET_MODE (x5) != E_SImode)
                        return -1;
                      operands[3] = x10;
                      if (!gpc_reg_operand (operands[3], E_SImode))
                        return -1;
                      x11 = XEXP (x5, 1);
                      operands[4] = x11;
                      if (!const_int_operand (operands[4], E_SImode)
                          || !
#line 4375 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_mask (operands[2], NULL, NULL, SImode)
   && UINTVAL (operands[2]) != 0 && UINTVAL (operands[4]) != 0
   && UINTVAL (operands[2]) + UINTVAL (operands[4]) + 1 == 0))
                        return -1;
                      return 256; /* *rotlsi3_insert_5 */

                    case E_DImode:
                      if (!gpc_reg_operand (operands[0], E_DImode)
                          || GET_MODE (x2) != E_DImode
                          || GET_MODE (x3) != E_DImode
                          || !gpc_reg_operand (x4, E_DImode)
                          || !const_int_operand (x9, E_DImode))
                        return -1;
                      operands[2] = x9;
                      operands[1] = x4;
                      if (GET_MODE (x5) == E_DImode)
                        {
                          operands[3] = x10;
                          if (gpc_reg_operand (operands[3], E_DImode))
                            {
                              x11 = XEXP (x5, 1);
                              operands[4] = x11;
                              if (const_int_operand (operands[4], E_DImode)
                                  && 
#line 4389 "../../gcc/config/rs6000/rs6000.md"
(exact_log2 (-UINTVAL (operands[2])) > 0
   && UINTVAL (operands[2]) + UINTVAL (operands[4]) + 1 == 0))
                                return 257; /* *rotldi3_insert_6 */
                            }
                        }
                      operands[4] = x9;
                      operands[3] = x4;
                      if (GET_MODE (x5) != E_DImode)
                        return -1;
                      operands[1] = x10;
                      if (!gpc_reg_operand (operands[1], E_DImode))
                        return -1;
                      x11 = XEXP (x5, 1);
                      operands[2] = x11;
                      if (!const_int_operand (operands[2], E_DImode)
                          || !
#line 4404 "../../gcc/config/rs6000/rs6000.md"
(exact_log2 (-UINTVAL (operands[2])) > 0
   && UINTVAL (operands[2]) + UINTVAL (operands[4]) + 1 == 0))
                        return -1;
                      return 258; /* *rotldi3_insert_7 */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case ASHIFT:
              switch (pattern210 (x2))
                {
                case 0:
                  if (!
#line 4313 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)))
                    return -1;
                  return 249; /* rotlsi3_insert_3 */

                case 1:
                  if (!(
#line 4313 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 250; /* rotldi3_insert_3 */

                default:
                  return -1;
                }

            case LSHIFTRT:
              if (GET_MODE (x5) != E_SImode
                  || !gpc_reg_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || GET_MODE (x3) != E_SImode)
                return -1;
              operands[3] = x4;
              if (!gpc_reg_operand (operands[3], E_SImode))
                return -1;
              operands[4] = x9;
              if (!const_int_operand (operands[4], E_SImode))
                return -1;
              x10 = XEXP (x5, 0);
              operands[1] = x10;
              if (!gpc_reg_operand (operands[1], E_SImode))
                return -1;
              x11 = XEXP (x5, 1);
              operands[2] = x11;
              if (!const_int_operand (operands[2], E_SImode)
                  || !
#line 4365 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) + exact_log2 (-UINTVAL (operands[4])) == 32))
                return -1;
              return 255; /* *rotlsi3_insert_4 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          x5 = XEXP (x2, 1);
          switch (GET_CODE (x5))
            {
            case AND:
              x10 = XEXP (x5, 0);
              if (GET_CODE (x10) != NOT)
                return -1;
              x6 = XEXP (x1, 0);
              operands[0] = x6;
              x11 = XEXP (x5, 1);
              operands[2] = x11;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern463 (x2, 
E_V4SImode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern543 (x5, 
E_V4SImode) == 0
                      && 
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SImode)))
                    return 1769; /* altivec_vselv4si3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern543 (x5, 
E_V4SImode) != 0
                      || !
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SImode)))
                    return -1;
                  return 1779; /* altivec_vselv4si4 */

                case E_V8HImode:
                  if (pattern463 (x2, 
E_V8HImode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern543 (x5, 
E_V8HImode) == 0
                      && 
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V8HImode)))
                    return 1770; /* altivec_vselv8hi3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern543 (x5, 
E_V8HImode) != 0
                      || !
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V8HImode)))
                    return -1;
                  return 1780; /* altivec_vselv8hi4 */

                case E_V16QImode:
                  if (pattern463 (x2, 
E_V16QImode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern543 (x5, 
E_V16QImode) == 0
                      && 
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V16QImode)))
                    return 1771; /* altivec_vselv16qi3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern543 (x5, 
E_V16QImode) != 0
                      || !
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V16QImode)))
                    return -1;
                  return 1781; /* altivec_vselv16qi4 */

                case E_V4SFmode:
                  if (pattern463 (x2, 
E_V4SFmode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern543 (x5, 
E_V4SFmode) == 0
                      && 
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SFmode)))
                    return 1772; /* altivec_vselv4sf3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern543 (x5, 
E_V4SFmode) != 0
                      || !
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V4SFmode)))
                    return -1;
                  return 1782; /* altivec_vselv4sf4 */

                case E_V2DFmode:
                  if (pattern463 (x2, 
E_V2DFmode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern543 (x5, 
E_V2DFmode) == 0
                      && 
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DFmode)))
                    return 1773; /* altivec_vselv2df3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern543 (x5, 
E_V2DFmode) != 0
                      || !
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DFmode)))
                    return -1;
                  return 1783; /* altivec_vselv2df4 */

                case E_V2DImode:
                  if (pattern463 (x2, 
E_V2DImode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern543 (x5, 
E_V2DImode) == 0
                      && 
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DImode)))
                    return 1774; /* altivec_vselv2di3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern543 (x5, 
E_V2DImode) != 0
                      || !
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V2DImode)))
                    return -1;
                  return 1784; /* altivec_vselv2di4 */

                case E_V1TImode:
                  if (pattern463 (x2, 
E_V1TImode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern543 (x5, 
E_V1TImode) == 0
                      && 
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode)))
                    return 1775; /* altivec_vselv1ti3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern543 (x5, 
E_V1TImode) != 0
                      || !
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode)))
                    return -1;
                  return 1785; /* altivec_vselv1ti4 */

                case E_TImode:
                  if (pattern463 (x2, 
E_TImode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern543 (x5, 
E_TImode) == 0
                      && 
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TImode)))
                    return 1776; /* altivec_vselti3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern543 (x5, 
E_TImode) != 0
                      || !
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TImode)))
                    return -1;
                  return 1786; /* altivec_vselti4 */

                case E_KFmode:
                  if (pattern463 (x2, 
E_KFmode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern543 (x5, 
E_KFmode) == 0
                      && (
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return 1777; /* altivec_vselkf3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern543 (x5, 
E_KFmode) != 0
                      || !(
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  return 1787; /* altivec_vselkf4 */

                case E_TFmode:
                  if (pattern463 (x2, 
E_TFmode) != 0)
                    return -1;
                  operands[1] = x9;
                  operands[3] = x4;
                  if (pattern543 (x5, 
E_TFmode) == 0
                      && (
#line 735 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TFmode)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return 1778; /* altivec_vseltf3 */
                  operands[3] = x9;
                  operands[1] = x4;
                  if (pattern543 (x5, 
E_TFmode) != 0
                      || !(
#line 751 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TFmode)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  return 1788; /* altivec_vseltf4 */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              if (pnum_clobbers == NULL)
                return -1;
              operands[2] = x5;
              x6 = XEXP (x1, 0);
              operands[3] = x6;
              switch (pattern357 (x2))
                {
                case 0:
                  if (!
#line 1195 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2466; /* *fuse_and_or */

                case 1:
                  if (!(
#line 1195 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2467; /* *fuse_and_or */

                case 2:
                  if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2942; /* *fuse_vand_vor */

                case 3:
                  if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2943; /* *fuse_vand_vor */

                case 4:
                  if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2944; /* *fuse_vand_vor */

                case 5:
                  if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2945; /* *fuse_vand_vor */

                case 6:
                  if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2946; /* *fuse_vand_vor */

                case 7:
                  if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2947; /* *fuse_vand_vor */

                case 8:
                  if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2948; /* *fuse_vand_vor */

                case 9:
                  if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2949; /* *fuse_vand_vor */

                case 10:
                  if (!(
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2950; /* *fuse_vand_vor */

                case 11:
                  if (!(
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2951; /* *fuse_vand_vor */

                default:
                  return -1;
                }

            case NOT:
              if (pnum_clobbers == NULL)
                return -1;
              x6 = XEXP (x1, 0);
              operands[3] = x6;
              operands[0] = x4;
              operands[1] = x9;
              switch (pattern58 (x2))
                {
                case 0:
                  if (!
#line 1375 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2486; /* *fuse_and_orc */

                case 1:
                  if (!(
#line 1375 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2487; /* *fuse_and_orc */

                case 2:
                  if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3022; /* *fuse_vand_vorc */

                case 3:
                  if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3023; /* *fuse_vand_vorc */

                case 4:
                  if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3024; /* *fuse_vand_vorc */

                case 5:
                  if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3025; /* *fuse_vand_vorc */

                case 6:
                  if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3026; /* *fuse_vand_vorc */

                case 7:
                  if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3027; /* *fuse_vand_vorc */

                case 8:
                  if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3028; /* *fuse_vand_vorc */

                case 9:
                  if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3029; /* *fuse_vand_vorc */

                case 10:
                  if (!(
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3030; /* *fuse_vand_vorc */

                case 11:
                  if (!(
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3031; /* *fuse_vand_vorc */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      return recog_19 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_35 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_0_to_3_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!altivec_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !altivec_register_operand (operands[1], E_V16QImode)
          || !
#line 3360 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1361; /* xxgenpcvm_v16qi_internal */

    case E_V8HImode:
      if (!altivec_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !altivec_register_operand (operands[1], E_V8HImode)
          || !
#line 3360 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1362; /* xxgenpcvm_v8hi_internal */

    case E_V4SImode:
      if (!altivec_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !altivec_register_operand (operands[1], E_V4SImode)
          || !
#line 3360 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1363; /* xxgenpcvm_v4si_internal */

    case E_V2DImode:
      if (!altivec_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !altivec_register_operand (operands[1], E_V2DImode)
          || !
#line 3360 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1364; /* xxgenpcvm_v2di_internal */

    default:
      return -1;
    }
}

 int
recog_38 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCFPmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!cc_reg_operand (operands[0], E_CCFPmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!vsx_register_operand (operands[1], E_DFmode)
          || !vsx_register_operand (operands[2], E_DFmode)
          || !
#line 1969 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (DFmode)))
        return -1;
      return 1239; /* *vsx_tdivdf3_internal */

    case E_V4SFmode:
      if (!vsx_register_operand (operands[1], E_V4SFmode)
          || !vsx_register_operand (operands[2], E_V4SFmode)
          || !
#line 1969 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1240; /* *vsx_tdivv4sf3_internal */

    case E_V2DFmode:
      if (!vsx_register_operand (operands[1], E_V2DFmode)
          || !vsx_register_operand (operands[2], E_V2DFmode)
          || !
#line 1969 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1241; /* *vsx_tdivv2df3_internal */

    default:
      return -1;
    }
}

 int
recog_45 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V16QImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !
#line 4510 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2175; /* altivec_vbpermq */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !
#line 4520 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2176; /* altivec_vbpermq2 */

    default:
      return -1;
    }
}

 int
recog_51 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_OOmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!vsx_register_operand (operands[0], E_OOmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!mma_assemble_input_operand (operands[1], E_V16QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!mma_assemble_input_operand (operands[2], E_V16QImode)
      || !
#line 382 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
    return -1;
  return 2203; /* *vsx_assemble_pair */
}

 int
recog_54 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!gpc_reg_operand (operands[0], E_DFmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!gpc_reg_operand (operands[1], E_V2DFmode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_V2DImode)
      || !
#line 3646 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode) && TARGET_DIRECT_MOVE_64BIT))
    return -1;
  return 1387; /* vsx_vslo_v2df */
}

 int
recog_61 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x2) != E_SFmode
          || !gpc_reg_operand (operands[1], E_SFmode)
          || !
#line 6820 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND))
        return -1;
      return 468; /* btruncsf2 */

    case E_DFmode:
      if (GET_MODE (x2) != E_DFmode)
        return -1;
      if (gpc_reg_operand (operands[0], E_DFmode)
          && gpc_reg_operand (operands[1], E_DFmode)
          && 
#line 6820 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND))
        return 469; /* btruncdf2 */
      if (!vsx_register_operand (operands[0], E_DFmode)
          || !vsx_register_operand (operands[1], E_DFmode)
          || !
#line 2331 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (DFmode)))
        return -1;
      return 1300; /* *vsx_b2truncdf2 */

    case E_KFmode:
      if (!altivec_register_operand (operands[0], E_KFmode)
          || GET_MODE (x2) != E_KFmode
          || !altivec_register_operand (operands[1], E_KFmode)
          || !(
#line 15467 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1067; /* btrunckf2 */

    case E_TFmode:
      if (!altivec_register_operand (operands[0], E_TFmode)
          || GET_MODE (x2) != E_TFmode
          || !altivec_register_operand (operands[1], E_TFmode)
          || !(
#line 15467 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1068; /* btrunctf2 */

    case E_V4SFmode:
      if (!vsx_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode
          || !vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 2331 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1301; /* *vsx_b2truncv4sf2 */

    case E_V2DFmode:
      if (!vsx_register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x2) != E_V2DFmode
          || !vsx_register_operand (operands[1], E_V2DFmode)
          || !
#line 2331 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1302; /* *vsx_b2truncv2df2 */

    default:
      return -1;
    }
}

 int
recog_74 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case SYMBOL_REF:
      if (pnum_clobbers == NULL)
        return -1;
      operands[1] = x3;
      if (!input_operand (operands[1], E_SFmode)
          || !nonimmediate_operand (operands[0], E_SImode)
          || !
#line 7832 "../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG
   && (register_operand (operands[0], SImode)
       || register_operand (operands[1], SFmode))))
        return -1;
      *pnum_clobbers = 1;
      return 558; /* movsi_from_sf */

    case FLOAT_TRUNCATE:
      if (GET_MODE (x3) != E_SFmode
          || !gpc_reg_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], E_DFmode)
          || !
#line 7938 "../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG))
        return -1;
      return 560; /* *movsi_from_df */

    default:
      return -1;
    }
}

 int
recog_82 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!base_reg_operand (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode
          || !fusion_addis_mem_combo_load (operands[1], E_QImode)
          || !
#line 14733 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION))
        return -1;
      return 956; /* *fusion_gpr_load_qi */

    case E_HImode:
      if (!base_reg_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode
          || !fusion_addis_mem_combo_load (operands[1], E_HImode)
          || !
#line 14733 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION))
        return -1;
      return 957; /* *fusion_gpr_load_hi */

    default:
      return -1;
    }
}

 int
recog_91 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DFmode
      || !vsx_register_operand (operands[0], E_DFmode))
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[1]))
    {
    case E_KFmode:
      if (!altivec_register_operand (operands[1], E_KFmode)
          || !(
#line 15593 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1089; /* trunckfdf2_odd */

    case E_TFmode:
      if (!altivec_register_operand (operands[1], E_TFmode)
          || !(
#line 15593 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1090; /* trunctfdf2_odd */

    default:
      return -1;
    }
}

 int
recog_100 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_0_to_1_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_15_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 111 "../../gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 2334; /* crypto_vshasigmaw */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 111 "../../gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 2335; /* crypto_vshasigmad */

    default:
      return -1;
    }
}

 int
recog_103 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 11:
      if (pattern130 (x1) != 0
          || !(
#line 177 "../../gcc/config/rs6000/darwin.md"
((DEFAULT_ABI == ABI_DARWIN) && flag_pic) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return -1;
      return 2; /* load_macho_picbase_di */

    case 12:
      if (pattern130 (x1) != 0
          || !(
#line 193 "../../gcc/config/rs6000/darwin.md"
((DEFAULT_ABI == ABI_DARWIN) && flag_pic) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return -1;
      return 3; /* reload_macho_picbase_di */

    case 90:
      if (pattern131 (x1) != 0
          || !
#line 2556 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_64BIT))
        return -1;
      return 132; /* cfuged */

    case 91:
      if (pattern131 (x1) != 0
          || !
#line 2565 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_POWERPC64))
        return -1;
      return 133; /* cntlzdm */

    case 92:
      if (pattern131 (x1) != 0
          || !
#line 2574 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_POWERPC64))
        return -1;
      return 134; /* cnttzdm */

    case 93:
      if (pattern132 (x1) != 0
          || !
#line 2583 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_POWERPC64))
        return -1;
      return 135; /* pdepd */

    case 94:
      if (pattern132 (x1) != 0
          || !
#line 2592 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_POWERPC64))
        return -1;
      return 136; /* pextd */

    case 51:
      return recog_59 (x1, insn, pnum_clobbers);

    case 99:
      switch (pattern134 (x1))
        {
        case 0:
          if (!
#line 5535 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !flag_finite_math_only))
            return -1;
          return 338; /* fmaxsf3 */

        case 1:
          if (!
#line 5535 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !flag_finite_math_only))
            return -1;
          return 340; /* fmaxdf3 */

        default:
          return -1;
        }

    case 100:
      switch (pattern134 (x1))
        {
        case 0:
          if (!
#line 5535 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !flag_finite_math_only))
            return -1;
          return 339; /* fminsf3 */

        case 1:
          if (!
#line 5535 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !flag_finite_math_only))
            return -1;
          return 341; /* fmindf3 */

        default:
          return -1;
        }

    case 4:
      return recog_58 (x1, insn, pnum_clobbers);

    case 59:
      return recog_40 (x1, insn, pnum_clobbers);

    case 63:
      return recog_32 (x1, insn, pnum_clobbers);

    case 14:
      return recog_49 (x1, insn, pnum_clobbers);

    case 20:
      if (pattern135 (x1) != 0)
        return -1;
      return 741; /* tls_dtprel_64 */

    case 21:
      if (pattern135 (x1) != 0)
        return -1;
      return 742; /* tls_dtprel_ha_64 */

    case 22:
      if (pattern135 (x1) != 0)
        return -1;
      return 743; /* tls_dtprel_lo_64 */

    case 23:
      if (pattern135 (x1) != 0)
        return -1;
      return 744; /* tls_got_dtprel_64 */

    case 24:
      if (pattern135 (x1) != 0)
        return -1;
      return 747; /* tls_tprel_64 */

    case 25:
      if (pattern135 (x1) != 0)
        return -1;
      return 748; /* tls_tprel_ha_64 */

    case 26:
      if (pattern135 (x1) != 0)
        return -1;
      return 749; /* tls_tprel_lo_64 */

    case 27:
      return recog_50 (x1, insn, pnum_clobbers);

    case 29:
      if (pattern135 (x1) != 0)
        return -1;
      return 754; /* tls_tls_pcrel_64 */

    case 28:
      if (pattern135 (x1) != 0)
        return -1;
      return 755; /* tls_tls_64 */

    case 18:
      return recog_57 (x1, insn, pnum_clobbers);

    case 70:
      return recog_48 (x1, insn, pnum_clobbers);

    case 71:
      return recog_39 (x1, insn, pnum_clobbers);

    case 78:
      switch (pattern137 (x1))
        {
        case 0:
          if (!(
#line 15489 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1071; /* addkf3_odd */

        case 1:
          if (!(
#line 15489 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1072; /* addtf3_odd */

        default:
          return -1;
        }

    case 79:
      switch (pattern137 (x1))
        {
        case 0:
          if (!(
#line 15500 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1073; /* subkf3_odd */

        case 1:
          if (!(
#line 15500 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1074; /* subtf3_odd */

        default:
          return -1;
        }

    case 80:
      switch (pattern137 (x1))
        {
        case 0:
          if (!(
#line 15511 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1075; /* mulkf3_odd */

        case 1:
          if (!(
#line 15511 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1076; /* multf3_odd */

        default:
          return -1;
        }

    case 81:
      switch (pattern137 (x1))
        {
        case 0:
          if (!(
#line 15522 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1077; /* divkf3_odd */

        case 1:
          if (!(
#line 15522 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1078; /* divtf3_odd */

        default:
          return -1;
        }

    case 75:
      if (pattern138 (x1) != 0
          || !
#line 15691 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC))
        return -1;
      return 1095; /* *cmprb_internal */

    case 76:
      if (pattern138 (x1) != 0
          || !
#line 15778 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC))
        return -1;
      return 1098; /* *cmprb2_internal */

    case 77:
      return recog_56 (x1, insn, pnum_clobbers);

    case 138:
      if (pattern139 (x1, 
E_V2DImode) != 0
          || !
#line 1728 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
        return -1;
      return 1228; /* vsx_mul_v2di */

    case 130:
      if (pattern139 (x1, 
E_V2DImode) != 0
          || !
#line 1783 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
        return -1;
      return 1231; /* vsx_div_v2di */

    case 131:
      if (pattern139 (x1, 
E_V2DImode) != 0
          || !
#line 1830 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
        return -1;
      return 1232; /* vsx_udiv_v2di */

    case 132:
      if (pattern139 (x1, 
E_V1TImode) != 0
          || !
#line 1887 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1233; /* vsx_div_v1ti */

    case 133:
      if (pattern139 (x1, 
E_V1TImode) != 0
          || !
#line 1896 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1234; /* vsx_udiv_v1ti */

    case 134:
      if (pattern139 (x1, 
E_V1TImode) != 0
          || !
#line 1905 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1235; /* vsx_dives_v1ti */

    case 135:
      if (pattern139 (x1, 
E_V1TImode) != 0
          || !
#line 1914 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1236; /* vsx_diveu_v1ti */

    case 136:
      if (pattern139 (x1, 
E_V1TImode) != 0
          || !
#line 1923 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1237; /* vsx_mods_v1ti */

    case 137:
      if (pattern139 (x1, 
E_V1TImode) != 0
          || !
#line 1932 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1238; /* vsx_modu_v1ti */

    case 121:
      return recog_38 (x1, insn, pnum_clobbers);

    case 104:
      return recog_55 (x1, insn, pnum_clobbers);

    case 188:
      return recog_35 (x1, insn, pnum_clobbers);

    case 144:
      return recog_54 (x1, insn, pnum_clobbers);

    case 145:
      return recog_33 (x1, insn, pnum_clobbers);

    case 128:
      return recog_43 (x1, insn, pnum_clobbers);

    case 129:
      return recog_42 (x1, insn, pnum_clobbers);

    case 149:
      return recog_34 (x1, insn, pnum_clobbers);

    case 148:
      return recog_46 (x1, insn, pnum_clobbers);

    case 157:
      return recog_53 (x1, insn, pnum_clobbers);

    case 158:
      return recog_41 (x1, insn, pnum_clobbers);

    case 177:
      if (pattern140 (x1, 
E_V16QImode) != 0
          || !
#line 5887 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1591; /* vcmpnezb */

    case 179:
      if (pattern140 (x1, 
E_V8HImode) != 0
          || !
#line 5923 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1594; /* vcmpnezh */

    case 181:
      if (pattern140 (x1, 
E_V4SImode) != 0
          || !
#line 5943 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1596; /* vcmpnezw */

    case 182:
      return recog_52 (x1, insn, pnum_clobbers);

    case 200:
      switch (pattern141 (x1))
        {
        case 0:
          if (!
#line 6497 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1643; /* dives_v2di */

        case 1:
          if (!
#line 6497 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1644; /* dives_v4si */

        default:
          return -1;
        }

    case 201:
      switch (pattern141 (x1))
        {
        case 0:
          if (!
#line 6507 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1645; /* diveu_v2di */

        case 1:
          if (!
#line 6507 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1646; /* diveu_v4si */

        default:
          return -1;
        }

    case 218:
      if (pattern66 (x1, 
E_V4SImode) != 0
          || !
#line 528 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
        return -1;
      return 1705; /* altivec_vaddcuw */

    case 248:
      if (pattern66 (x1, 
E_V4SImode) != 0
          || !
#line 572 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
        return -1;
      return 1717; /* altivec_vsubcuw */

    case 219:
      switch (pattern143 (x1))
        {
        case 0:
          if (!
#line 600 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1724; /* uavgv4si3_ceil */

        case 1:
          if (!
#line 600 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1725; /* uavgv8hi3_ceil */

        case 2:
          if (!
#line 600 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1726; /* uavgv16qi3_ceil */

        default:
          return -1;
        }

    case 220:
      switch (pattern143 (x1))
        {
        case 0:
          if (!
#line 609 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1727; /* avgv4si3_ceil */

        case 1:
          if (!
#line 609 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1728; /* avgv8hi3_ceil */

        case 2:
          if (!
#line 609 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return -1;
          return 1729; /* avgv16qi3_ceil */

        default:
          return -1;
        }

    case 209:
      if (pattern144 (x1, 
E_V4SFmode, 
E_V4SImode) != 0
          || !
#line 618 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
        return -1;
      return 1730; /* altivec_vcmpbfp */

    case 331:
      switch (pattern145 (x1))
        {
        case 0:
          if (!
#line 1535 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 1861; /* p8_vmrgew_v4sf_direct */

        case 1:
          if (!
#line 1535 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 1862; /* p8_vmrgew_v4si_direct */

        default:
          return -1;
        }

    case 332:
      switch (pattern145 (x1))
        {
        case 0:
          if (!
#line 1544 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 1863; /* p8_vmrgow_v4sf_direct */

        case 1:
          if (!
#line 1544 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 1864; /* p8_vmrgow_v4si_direct */

        default:
          return -1;
        }

    case 221:
      if (pattern146 (x1) != 0
          || !
#line 1761 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1865; /* altivec_vmuleub */

    case 229:
      if (pattern146 (x1) != 0
          || !
#line 1770 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1866; /* altivec_vmuloub */

    case 222:
      if (pattern146 (x1) != 0
          || !
#line 1779 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1867; /* altivec_vmulesb */

    case 230:
      if (pattern146 (x1) != 0
          || !
#line 1788 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1868; /* altivec_vmulosb */

    case 223:
      if (pattern144 (x1, 
E_V8HImode, 
E_V4SImode) != 0
          || !
#line 1797 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1869; /* altivec_vmuleuh */

    case 231:
      if (pattern144 (x1, 
E_V8HImode, 
E_V4SImode) != 0
          || !
#line 1806 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1870; /* altivec_vmulouh */

    case 224:
      if (pattern144 (x1, 
E_V8HImode, 
E_V4SImode) != 0
          || !
#line 1815 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1871; /* altivec_vmulesh */

    case 232:
      if (pattern144 (x1, 
E_V8HImode, 
E_V4SImode) != 0
          || !
#line 1824 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1872; /* altivec_vmulosh */

    case 225:
      if (pattern144 (x1, 
E_V4SImode, 
E_V2DImode) != 0
          || !
#line 1833 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 1873; /* altivec_vmuleuw */

    case 227:
      if (pattern144 (x1, 
E_V2DImode, 
E_V1TImode) != 0
          || !
#line 1842 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 1874; /* altivec_vmuleud */

    case 233:
      if (pattern144 (x1, 
E_V4SImode, 
E_V2DImode) != 0
          || !
#line 1851 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 1875; /* altivec_vmulouw */

    case 235:
      if (pattern144 (x1, 
E_V2DImode, 
E_V1TImode) != 0
          || !
#line 1860 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 1876; /* altivec_vmuloud */

    case 226:
      if (pattern144 (x1, 
E_V4SImode, 
E_V2DImode) != 0
          || !
#line 1869 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 1877; /* altivec_vmulesw */

    case 228:
      if (pattern144 (x1, 
E_V2DImode, 
E_V1TImode) != 0
          || !
#line 1878 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 1878; /* altivec_vmulesd */

    case 234:
      if (pattern144 (x1, 
E_V4SImode, 
E_V2DImode) != 0
          || !
#line 1887 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 1879; /* altivec_vmulosw */

    case 236:
      if (pattern144 (x1, 
E_V2DImode, 
E_V1TImode) != 0
          || !
#line 1896 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 1880; /* altivec_vmulosd */

    case 237:
      if (pattern144 (x1, 
E_V4SImode, 
E_V8HImode) != 0
          || !
#line 1906 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1881; /* altivec_vpkpx */

    case 238:
      switch (pattern148 (x1))
        {
        case 0:
          if (!
#line 1920 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 1882; /* altivec_vpksdss */

        case 1:
          if (!
#line 1920 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1883; /* altivec_vpkswss */

        case 2:
          if (!
#line 1920 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1884; /* altivec_vpkshss */

        default:
          return -1;
        }

    case 239:
      switch (pattern148 (x1))
        {
        case 0:
          if (!
#line 1934 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 1885; /* altivec_vpksdus */

        case 1:
          if (!
#line 1934 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1886; /* altivec_vpkswus */

        case 2:
          if (!
#line 1934 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1887; /* altivec_vpkshus */

        default:
          return -1;
        }

    case 240:
      switch (pattern148 (x1))
        {
        case 0:
          if (!
#line 1948 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 1888; /* altivec_vpkudus */

        case 1:
          if (!
#line 1948 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1889; /* altivec_vpkuwus */

        case 2:
          if (!
#line 1948 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1890; /* altivec_vpkuhus */

        default:
          return -1;
        }

    case 241:
      switch (pattern148 (x1))
        {
        case 0:
          if (!
#line 1962 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 1891; /* altivec_vpkudum */

        case 1:
          if (!
#line 1962 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1892; /* altivec_vpkuwum */

        case 2:
          if (!
#line 1962 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1893; /* altivec_vpkuhum */

        default:
          return -1;
        }

    case 242:
      switch (pattern148 (x1))
        {
        case 0:
          if (!
#line 1976 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 1894; /* altivec_vpkudum_direct */

        case 1:
          if (!
#line 1976 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1895; /* altivec_vpkuwum_direct */

        case 2:
          if (!
#line 1976 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1896; /* altivec_vpkuhum_direct */

        default:
          return -1;
        }

    case 347:
      return recog_47 (x1, insn, pnum_clobbers);

    case 244:
      if (pattern66 (x1, 
E_V4SImode) != 0
          || !
#line 2079 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1908; /* altivec_vsl */

    case 245:
      if (pattern66 (x1, 
E_V4SImode) != 0
          || !
#line 2088 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1909; /* altivec_vslo */

    case 309:
      if (pattern149 (x1, 
E_V16QImode) != 0
          || !
#line 2097 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1910; /* vslv */

    case 310:
      if (pattern149 (x1, 
E_V16QImode) != 0
          || !
#line 2106 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1911; /* vsrv */

    case 246:
      if (pattern66 (x1, 
E_V4SImode) != 0
          || !
#line 2166 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1929; /* altivec_vsr */

    case 247:
      if (pattern66 (x1, 
E_V4SImode) != 0
          || !
#line 2175 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1930; /* altivec_vsro */

    case 330:
      return recog_36 (x1, insn, pnum_clobbers);

    case 257:
      if (pattern150 (x1) != 0
          || !
#line 2598 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1989; /* altivec_vcfux */

    case 258:
      if (pattern150 (x1) != 0
          || !
#line 2607 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1990; /* altivec_vcfsx */

    case 334:
      if (pattern66 (x1, 
E_V1TImode) != 0
          || !
#line 4442 "../../gcc/config/rs6000/altivec.md"
(TARGET_VADDUQM))
        return -1;
      return 2168; /* altivec_vaddcuq */

    case 337:
      if (pattern66 (x1, 
E_V1TImode) != 0
          || !
#line 4459 "../../gcc/config/rs6000/altivec.md"
(TARGET_VADDUQM))
        return -1;
      return 2170; /* altivec_vsubcuq */

    case 340:
      return recog_45 (x1, insn, pnum_clobbers);

    case 341:
      if (pattern149 (x1, 
E_V2DImode) != 0
          || !
#line 4529 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2177; /* altivec_vbpermd */

    case 348:
      if (pattern140 (x1, 
E_V2DImode) != 0
          || !
#line 4636 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 2190; /* vcfuged */

    case 349:
      if (pattern140 (x1, 
E_V2DImode) != 0
          || !
#line 4645 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 2191; /* vclzdm */

    case 350:
      if (pattern140 (x1, 
E_V2DImode) != 0
          || !
#line 4654 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 2192; /* vctzdm */

    case 352:
      if (pattern140 (x1, 
E_V2DImode) != 0
          || !
#line 4663 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 2193; /* vpdepd */

    case 353:
      if (pattern140 (x1, 
E_V2DImode) != 0
          || !
#line 4672 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 2194; /* vpextd */

    case 354:
      if (pattern151 (x1) != 0
          || !
#line 4690 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 2196; /* vclrlb */

    case 355:
      if (pattern151 (x1) != 0
          || !
#line 4704 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 2197; /* vclrrb */

    case 361:
      return recog_51 (x1, insn, pnum_clobbers);

    case 415:
      if (pattern152 (x1, 
E_V16QImode) != 0
          || !
#line 487 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2208; /* mma_xvi4ger8 */

    case 417:
      if (pattern152 (x1, 
E_V16QImode) != 0
          || !
#line 487 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2209; /* mma_xvi8ger4 */

    case 411:
      if (pattern152 (x1, 
E_V16QImode) != 0
          || !
#line 487 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2210; /* mma_xvi16ger2 */

    case 413:
      if (pattern152 (x1, 
E_V16QImode) != 0
          || !
#line 487 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2211; /* mma_xvi16ger2s */

    case 396:
      if (pattern152 (x1, 
E_V16QImode) != 0
          || !
#line 487 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2212; /* mma_xvf16ger2 */

    case 391:
      if (pattern152 (x1, 
E_V16QImode) != 0
          || !
#line 487 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2213; /* mma_xvbf16ger2 */

    case 401:
      if (pattern152 (x1, 
E_V16QImode) != 0
          || !
#line 487 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2214; /* mma_xvf32ger */

    case 406:
      if (pattern152 (x1, 
E_OOmode) != 0
          || !
#line 506 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2232; /* mma_xvf64ger */

    case 424:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!const_0_to_3_operand (operands[1], E_QImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (pattern365 (x2))
        {
        case 0:
          if (!
#line 284 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2297; /* dfp_ddedpd_dd */

        case 1:
          if (!
#line 284 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2298; /* dfp_ddedpd_td */

        default:
          return -1;
        }

    case 425:
      return recog_37 (x1, insn, pnum_clobbers);

    case 426:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (pattern365 (x2))
        {
        case 0:
          if (!
#line 335 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2304; /* dfp_diex_dd */

        case 1:
          if (!
#line 335 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2305; /* dfp_diex_td */

        default:
          return -1;
        }

    case 428:
      switch (pattern153 (x1))
        {
        case 0:
          if (!
#line 385 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2308; /* dfp_dscli_dd */

        case 1:
          if (!
#line 385 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2309; /* dfp_dscli_td */

        default:
          return -1;
        }

    case 430:
      switch (pattern153 (x1))
        {
        case 0:
          if (!
#line 395 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2310; /* dfp_dscri_dd */

        case 1:
          if (!
#line 395 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2311; /* dfp_dscri_td */

        default:
          return -1;
        }

    case 432:
      switch (pattern154 (x1))
        {
        case 0:
          if (!
#line 71 "../../gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 2316; /* crypto_vcipher_v16qi */

        case 1:
          if (!
#line 71 "../../gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 2320; /* crypto_vcipher_v2di */

        default:
          return -1;
        }

    case 433:
      switch (pattern154 (x1))
        {
        case 0:
          if (!
#line 71 "../../gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 2317; /* crypto_vncipher_v16qi */

        case 1:
          if (!
#line 71 "../../gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 2321; /* crypto_vncipher_v2di */

        default:
          return -1;
        }

    case 434:
      switch (pattern154 (x1))
        {
        case 0:
          if (!
#line 71 "../../gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 2318; /* crypto_vcipherlast_v16qi */

        case 1:
          if (!
#line 71 "../../gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 2322; /* crypto_vcipherlast_v2di */

        default:
          return -1;
        }

    case 435:
      switch (pattern154 (x1))
        {
        case 0:
          if (!
#line 71 "../../gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 2319; /* crypto_vncipherlast_v16qi */

        case 1:
          if (!
#line 71 "../../gcc/config/rs6000/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 2323; /* crypto_vncipherlast_v2di */

        default:
          return -1;
        }

    case 439:
      return recog_44 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_128 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      switch (XINT (x2, 1))
        {
        case 11:
          if (GET_MODE (x2) != E_DFmode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!gpc_reg_operand (operands[0], E_DFmode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          switch (GET_CODE (operands[1]))
            {
            case REG:
            case SUBREG:
              if (!gpc_reg_operand (operands[1], E_DFmode)
                  || !
#line 6526 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC))
                return -1;
              return 450; /* rs6000_mffscrn */

            case CONST_INT:
              if (!const_0_to_3_operand (operands[1], E_SImode)
                  || !
#line 6534 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC))
                return -1;
              return 451; /* rs6000_mffscrni */

            default:
              return -1;
            }

        case 6:
          x4 = XVECEXP (x2, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          switch (pattern207 (x2))
            {
            case 0:
              if (pnum_clobbers != NULL
                  && 
#line 14589 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64))
                {
                  *pnum_clobbers = 2;
                  return 949; /* rs6000_get_timebase_ppc32 */
                }
              if (!
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 951; /* rs6000_mftb_di */

            case 1:
              return 950; /* rs6000_mftb_si */

            default:
              return -1;
            }

        case 10:
          if (GET_MODE (x2) != E_DFmode)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || !
#line 14645 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 952; /* rs6000_mffsl_hw */

        case 9:
          if (GET_MODE (x2) != E_DFmode)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || !
#line 14681 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 953; /* rs6000_mffs */

        case 7:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!const_int_operand (operands[1], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !
#line 15638 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC))
                return -1;
              return 1093; /* darnsi */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !(
#line 15638 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 1094; /* darndi */

            default:
              return -1;
            }

        case 95:
          if (GET_MODE (x2) != E_DImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!simple_offsettable_mem_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!int_reg_operand (operands[1], E_DImode)
              || !
#line 15845 "../../gcc/config/rs6000/rs6000.md"
(rs6000_rop_protect))
            return -1;
          return 1100; /* hashst */

        case 1:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!int_reg_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !memory_operand (operands[1], E_QImode)
                  || !
#line 273 "../../gcc/config/rs6000/sync.md"
(TARGET_SYNC_HI_QI))
                return -1;
              return 1112; /* load_lockedqi */

            case E_HImode:
              if (!int_reg_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !memory_operand (operands[1], E_HImode)
                  || !
#line 274 "../../gcc/config/rs6000/sync.md"
(TARGET_SYNC_HI_QI))
                return -1;
              return 1113; /* load_lockedhi */

            case E_SImode:
              if (!int_reg_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (!memory_operand (operands[1], E_SImode))
                    return -1;
                  return 1114; /* load_lockedsi */

                case E_QImode:
                  if (!memory_operand (operands[1], E_QImode)
                      || !
#line 290 "../../gcc/config/rs6000/sync.md"
(TARGET_SYNC_HI_QI))
                    return -1;
                  return 1116; /* load_lockedqi_si */

                case E_HImode:
                  if (!memory_operand (operands[1], E_HImode)
                      || !
#line 290 "../../gcc/config/rs6000/sync.md"
(TARGET_SYNC_HI_QI))
                    return -1;
                  return 1117; /* load_lockedhi_si */

                default:
                  return -1;
                }

            case E_DImode:
              if (!int_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !memory_operand (operands[1], E_DImode)
                  || !
#line 276 "../../gcc/config/rs6000/sync.md"
(TARGET_POWERPC64))
                return -1;
              return 1115; /* load_lockeddi */

            case E_PTImode:
              if (!quad_int_reg_operand (operands[0], E_PTImode)
                  || GET_MODE (x2) != E_PTImode
                  || !indexed_or_indirect_operand (operands[1], E_TImode)
                  || !
#line 334 "../../gcc/config/rs6000/sync.md"
(TARGET_SYNC_TI
   && !reg_mentioned_p (operands[0], operands[1])
   && quad_int_reg_operand (operands[0], PTImode)))
                return -1;
              return 1118; /* load_lockedpti */

            default:
              return -1;
            }

        case 22:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != REG
              || REGNO (x3) != 109
              || GET_MODE (x3) != E_SImode)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_V4SImode)
              || !
#line 2938 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2040; /* altivec_mtvscr */

        case 23:
          if (pattern65 (x2, 
E_SImode, 
109, 
E_V8HImode) != 0)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_V8HImode)
              || !
#line 2945 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2041; /* altivec_mfvscr */

        case 27:
          if (GET_MODE (x2) != E_XOmode)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!fpr_reg_operand (operands[0], E_XOmode)
              || !
#line 478 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
            return -1;
          return 2207; /* mma_xxsetaccz */

        case 38:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!u10bit_cint_operand (operands[1], E_VOIDmode))
            return -1;
          switch (pattern9 (x2))
            {
            case 0:
              if (!
#line 272 "../../gcc/config/rs6000/htm.md"
(TARGET_HTM))
                return -1;
              return 2348; /* htm_mfspr_si */

            case 1:
              if (!(
#line 272 "../../gcc/config/rs6000/htm.md"
(TARGET_HTM) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2349; /* htm_mfspr_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      if (XINT (x2, 1) != 3
          || pattern66 (x1, 
E_DImode) != 0)
        return -1;
      x5 = XVECEXP (x2, 0, 2);
      operands[3] = x5;
      if (!register_operand (operands[3], E_DImode))
        return -1;
      return 797; /* probe_stack_rangedi */

    case 4:
      if (pattern29 (x1) != 0
          || !
#line 433 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA
   && fpr_reg_operand (operands[0], XOmode)))
        return -1;
      return 2204; /* *mma_assemble_acc */

    default:
      return -1;
    }
}

 int
recog_133 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !gpc_reg_operand (operands[1], E_SImode))
            return -1;
          return 88; /* *one_cmplsi2 */

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !gpc_reg_operand (operands[1], E_DImode)
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 89; /* *one_cmpldi2 */

        case E_TImode:
          if (!vlogical_operand (operands[0], E_TImode)
              || GET_MODE (x2) != E_TImode
              || !vlogical_operand (operands[1], E_TImode))
            return -1;
          return 547; /* one_cmplti2 */

        case E_PTImode:
          if (!vlogical_operand (operands[0], E_PTImode)
              || GET_MODE (x2) != E_PTImode
              || !vlogical_operand (operands[1], E_PTImode))
            return -1;
          return 548; /* one_cmplpti2 */

        case E_V16QImode:
          if (!vlogical_operand (operands[0], E_V16QImode)
              || GET_MODE (x2) != E_V16QImode
              || !vlogical_operand (operands[1], E_V16QImode)
              || !
#line 778 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 549; /* one_cmplv16qi2 */

        case E_V8HImode:
          if (!vlogical_operand (operands[0], E_V8HImode)
              || GET_MODE (x2) != E_V8HImode
              || !vlogical_operand (operands[1], E_V8HImode)
              || !
#line 779 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 550; /* one_cmplv8hi2 */

        case E_V4SImode:
          if (!vlogical_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !vlogical_operand (operands[1], E_V4SImode)
              || !
#line 780 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 551; /* one_cmplv4si2 */

        case E_V4SFmode:
          if (!vlogical_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !vlogical_operand (operands[1], E_V4SFmode)
              || !
#line 781 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 552; /* one_cmplv4sf2 */

        case E_V2DImode:
          if (!vlogical_operand (operands[0], E_V2DImode)
              || GET_MODE (x2) != E_V2DImode
              || !vlogical_operand (operands[1], E_V2DImode)
              || !
#line 782 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 553; /* one_cmplv2di2 */

        case E_V2DFmode:
          if (!vlogical_operand (operands[0], E_V2DFmode)
              || GET_MODE (x2) != E_V2DFmode
              || !vlogical_operand (operands[1], E_V2DFmode)
              || !
#line 783 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 554; /* one_cmplv2df2 */

        case E_V1TImode:
          if (!vlogical_operand (operands[0], E_V1TImode)
              || GET_MODE (x2) != E_V1TImode
              || !vlogical_operand (operands[1], E_V1TImode)
              || !
#line 784 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 555; /* one_cmplv1ti2 */

        default:
          return -1;
        }

    case XOR:
      return recog_4 (x1, insn, pnum_clobbers);

    case EQ:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern264 (x2, 
E_V16QImode) != 0
              || !
#line 5863 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1590; /* vcmpneb */

        case E_V8HImode:
          if (pattern264 (x2, 
E_V8HImode) != 0
              || !
#line 5913 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1593; /* vcmpneh */

        case E_V4SImode:
          if (pattern264 (x2, 
E_V4SImode) != 0
              || !
#line 5933 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1595; /* vcmpnew */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_141 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (pattern329 (x3, 
E_DFmode, 
E_V2DFmode) != 0
                  || !
#line 3132 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
                return -1;
              return 1343; /* vsx_concat_v2df */

            case E_V2DImode:
              if (pattern329 (x3, 
E_DImode, 
E_V2DImode) != 0
                  || !
#line 3132 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
                return -1;
              return 1344; /* vsx_concat_v2di */

            default:
              return -1;
            }

        case VEC_SELECT:
          x6 = XEXP (x5, 1);
          if (GET_CODE (x6) != PARALLEL
              || XVECLEN (x6, 0) != 1)
            return -1;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          x8 = XVECEXP (x6, 0, 0);
          operands[3] = x8;
          if (!const_0_to_1_operand (operands[3], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (pattern467 (x3, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 3181 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
                return -1;
              return 1347; /* *vsx_concat_v2df_2 */

            case E_V2DImode:
              if (pattern467 (x3, 
E_V2DImode, 
E_DImode) != 0
                  || !
#line 3181 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
                return -1;
              return 1348; /* *vsx_concat_v2di_2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x9 = XEXP (x4, 1);
      if (GET_CODE (x9) != PARALLEL
          || XVECLEN (x9, 0) != 1)
        return -1;
      x10 = XEXP (x4, 0);
      operands[1] = x10;
      x11 = XVECEXP (x9, 0, 0);
      operands[2] = x11;
      if (!const_0_to_1_operand (operands[2], E_QImode))
        return -1;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[3] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (pattern468 (x3, 
E_DFmode, 
E_V2DFmode) != 0
                  || !
#line 3158 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
                return -1;
              return 1345; /* *vsx_concat_v2df_1 */

            case E_V2DImode:
              if (pattern468 (x3, 
E_DImode, 
E_V2DImode) != 0
                  || !
#line 3158 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
                return -1;
              return 1346; /* *vsx_concat_v2di_1 */

            default:
              return -1;
            }

        case VEC_SELECT:
          x6 = XEXP (x5, 1);
          if (GET_CODE (x6) != PARALLEL
              || XVECLEN (x6, 0) != 1)
            return -1;
          x7 = XEXP (x5, 0);
          operands[3] = x7;
          x8 = XVECEXP (x6, 0, 0);
          operands[4] = x8;
          if (!const_0_to_1_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (pattern534 (x3, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 3206 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
                return -1;
              return 1349; /* *vsx_concat_v2df_3 */

            case E_V2DImode:
              if (pattern534 (x3, 
E_V2DImode, 
E_DImode) != 0
                  || !
#line 3206 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
                return -1;
              return 1350; /* *vsx_concat_v2di_3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_151 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XINT (x3, 1))
    {
    case 44:
      if (GET_MODE (x3) != E_CCmode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (pattern188 (x4, 
43, 
2) != 0)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x2, 0);
      operands[3] = x6;
      if (!cc_reg_operand (operands[3], E_CCmode))
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      if (!gpc_reg_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x4, 0);
      operands[0] = x9;
      if (!gpc_reg_operand (operands[0], E_SImode))
        return -1;
      x10 = XVECEXP (x5, 0, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x11 = XVECEXP (x5, 0, 1);
      if (!rtx_equal_p (x11, operands[2])
          || !
#line 1730 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DLMZB))
        return -1;
      return 64; /* dlmzb */

    case 1:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x8) != LABEL_REF)
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 96
          || GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[0] = x7;
      if (!immediate_operand (operands[0], E_SImode))
        return -1;
      x12 = XEXP (x8, 0);
      operands[1] = x12;
      x4 = XVECEXP (x1, 0, 1);
      if (!rtx_equal_p (x4, operands[1])
          || !
#line 11189 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_LINK_STACK && TARGET_ELF && DEFAULT_ABI == ABI_V4 && flag_pic == 2))
        return -1;
      return 760; /* load_toc_v4_PIC_1b_normal */

    case 35:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_CCEQmode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!cc_reg_operand (operands[0], E_CCEQmode))
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      if (!memory_operand (operands[1], E_DImode))
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      if (!memory_operand (operands[2], E_DImode))
        return -1;
      x9 = XEXP (x4, 0);
      operands[4] = x9;
      if (!scratch_operand (operands[4], E_DImode))
        return -1;
      *pnum_clobbers = 1;
      return 799; /* stack_protect_testdi */

    case 145:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      switch (pattern330 (x1))
        {
        case 0:
          if (!
#line 3675 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1391; /* *vsx_extract_v2df_var_load */

        case 1:
          if (!
#line 3675 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1392; /* *vsx_extract_v2di_var_load */

        case 2:
          if (!
#line 3762 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1396; /* *vsx_extract_v4sf_var_load */

        case 3:
          if (!
#line 4204 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1419; /* *vsx_extract_v16qi_var_load */

        case 4:
          if (!
#line 4204 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1420; /* *vsx_extract_v8hi_var_load */

        case 5:
          if (!
#line 4204 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1421; /* *vsx_extract_v4si_var_load */

        default:
          return -1;
        }

    case 177:
      if (pattern224 (x1, 
E_V16QImode, 
177) != 0)
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      if (!altivec_register_operand (operands[1], E_V16QImode))
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      if (!altivec_register_operand (operands[2], E_V16QImode))
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x4, 0);
      operands[0] = x9;
      if (!altivec_register_operand (operands[0], E_V16QImode))
        return -1;
      x5 = XEXP (x4, 1);
      x10 = XVECEXP (x5, 0, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x11 = XVECEXP (x5, 0, 1);
      if (!rtx_equal_p (x11, operands[2])
          || !
#line 5903 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1592; /* vcmpnezb_p */

    case 249:
      if (pattern225 (x1, 
E_V16QImode) != 0
          || !
#line 2235 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1939; /* altivec_vsum4ubs */

    case 250:
      if (GET_MODE (x3) != E_V4SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (pattern286 (x4, 
E_SImode, 
282) != 0
          || pattern255 (x1, 
E_V4SImode, 
E_SImode, 
109) != 0)
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      if (!register_operand (operands[2], E_V4SImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode)
              || !
#line 2245 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1940; /* altivec_vsum4shs */

        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode)
              || !
#line 2245 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1941; /* altivec_vsum4sbs */

        default:
          return -1;
        }

    case 251:
      if (pattern225 (x1, 
E_V4SImode) != 0
          || !
#line 2278 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1942; /* altivec_vsum2sws_direct */

    case 333:
      if (pattern225 (x1, 
E_V4SImode) != 0
          || !
#line 2310 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1943; /* altivec_vsumsws_direct */

    case 259:
      if (pattern226 (x1) != 0
          || !
#line 2617 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1991; /* altivec_vctuxs */

    case 260:
      if (pattern226 (x1) != 0
          || !
#line 2627 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1992; /* altivec_vctsxs */

    case 209:
      if (pattern224 (x1, 
E_V4SFmode, 
209) != 0)
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      if (!register_operand (operands[2], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x4, 0);
      operands[0] = x9;
      if (!register_operand (operands[0], E_V4SFmode))
        return -1;
      x5 = XEXP (x4, 1);
      x10 = XVECEXP (x5, 0, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x11 = XVECEXP (x5, 0, 1);
      if (!rtx_equal_p (x11, operands[2])
          || !
#line 2930 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode)))
        return -1;
      return 2039; /* altivec_vcmpbfp_p */

    case 441:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (pattern286 (x4, 
E_DImode, 
442) != 0)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!base_reg_operand (operands[0], E_DImode))
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      if (!pcrel_external_address (operands[1], E_DImode))
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x9 = XEXP (x4, 0);
      operands[3] = x9;
      if (!gpc_reg_operand (operands[3], E_DImode)
          || !
#line 111 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && reg_or_subregno (operands[0]) != reg_or_subregno (operands[3])))
        return -1;
      return 3185; /* pcrel_opt_ld_addr */

    case 445:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      if (!pcrel_external_address (operands[1], E_DImode))
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x9 = XEXP (x4, 0);
      operands[3] = x9;
      switch (GET_MODE (operands[3]))
        {
        case E_QImode:
          if (!gpc_reg_operand (operands[3], E_QImode)
              || !
#line 300 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3215; /* *pcrel_opt_st_addrqi */

        case E_HImode:
          if (!gpc_reg_operand (operands[3], E_HImode)
              || !
#line 300 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3216; /* *pcrel_opt_st_addrhi */

        case E_SImode:
          if (!gpc_reg_operand (operands[3], E_SImode)
              || !
#line 300 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3217; /* *pcrel_opt_st_addrsi */

        case E_DImode:
          if (!gpc_reg_operand (operands[3], E_DImode)
              || !
#line 300 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3218; /* *pcrel_opt_st_addrdi */

        case E_TImode:
          if (!gpc_reg_operand (operands[3], E_TImode)
              || !
#line 300 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3219; /* *pcrel_opt_st_addrti */

        case E_SFmode:
          if (!gpc_reg_operand (operands[3], E_SFmode)
              || !
#line 300 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3220; /* *pcrel_opt_st_addrsf */

        case E_DFmode:
          if (!gpc_reg_operand (operands[3], E_DFmode)
              || !
#line 300 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3221; /* *pcrel_opt_st_addrdf */

        case E_KFmode:
          if (!gpc_reg_operand (operands[3], E_KFmode)
              || !
#line 300 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3222; /* *pcrel_opt_st_addrkf */

        case E_V1TImode:
          if (!gpc_reg_operand (operands[3], E_V1TImode)
              || !
#line 300 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3223; /* *pcrel_opt_st_addrv1ti */

        case E_V2DImode:
          if (!gpc_reg_operand (operands[3], E_V2DImode)
              || !
#line 300 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3224; /* *pcrel_opt_st_addrv2di */

        case E_V4SImode:
          if (!gpc_reg_operand (operands[3], E_V4SImode)
              || !
#line 300 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3225; /* *pcrel_opt_st_addrv4si */

        case E_V8HImode:
          if (!gpc_reg_operand (operands[3], E_V8HImode)
              || !
#line 300 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3226; /* *pcrel_opt_st_addrv8hi */

        case E_V16QImode:
          if (!gpc_reg_operand (operands[3], E_V16QImode)
              || !
#line 300 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3227; /* *pcrel_opt_st_addrv16qi */

        case E_V2DFmode:
          if (!gpc_reg_operand (operands[3], E_V2DFmode)
              || !
#line 300 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3228; /* *pcrel_opt_st_addrv2df */

        case E_V4SFmode:
          if (!gpc_reg_operand (operands[3], E_V4SFmode)
              || !
#line 300 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3229; /* *pcrel_opt_st_addrv4sf */

        case E_TFmode:
          if (!gpc_reg_operand (operands[3], E_TFmode)
              || !(
#line 300 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 95 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_FLOAT128_TYPE && TARGET_IEEEQUAD)))
            return -1;
          return 3230; /* *pcrel_opt_st_addrtf */

        default:
          return -1;
        }

    case 446:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      x7 = XVECEXP (x3, 0, 0);
      operands[1] = x7;
      x8 = XVECEXP (x3, 0, 1);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x9 = XEXP (x4, 0);
      operands[3] = x9;
      if (!base_reg_operand (operands[3], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!d_form_memory (operands[0], E_QImode)
              || GET_MODE (x3) != E_QImode
              || !gpc_reg_operand (operands[1], E_QImode)
              || !
#line 313 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3231; /* *pcrel_opt_stqi */

        case E_HImode:
          if (!d_form_memory (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !gpc_reg_operand (operands[1], E_HImode)
              || !
#line 313 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3232; /* *pcrel_opt_sthi */

        case E_SImode:
          if (!d_form_memory (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !gpc_reg_operand (operands[1], E_SImode)
              || !
#line 313 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3233; /* *pcrel_opt_stsi */

        case E_DImode:
          if (!d_form_memory (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !gpc_reg_operand (operands[1], E_DImode)
              || !
#line 326 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT && TARGET_POWERPC64))
            return -1;
          return 3234; /* *pcrel_opt_stdi */

        case E_SFmode:
          if (!d_form_memory (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !gpc_reg_operand (operands[1], E_SFmode)
              || !
#line 349 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3235; /* *pcrel_opt_stsf */

        case E_DFmode:
          if (!d_form_memory (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !gpc_reg_operand (operands[1], E_DFmode)
              || !
#line 372 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (TARGET_POWERPC64 || vsx_register_operand (operands[1], DFmode))))
            return -1;
          return 3236; /* *pcrel_opt_stdf */

        case E_TImode:
          if (!d_form_memory (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode
              || !gpc_reg_operand (operands[1], E_TImode)
              || !
#line 396 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3237; /* *pcrel_opt_stti */

        case E_KFmode:
          if (!d_form_memory (operands[0], E_KFmode)
              || GET_MODE (x3) != E_KFmode
              || !gpc_reg_operand (operands[1], E_KFmode)
              || !
#line 396 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3238; /* *pcrel_opt_stkf */

        case E_V1TImode:
          if (!d_form_memory (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !gpc_reg_operand (operands[1], E_V1TImode)
              || !
#line 396 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3239; /* *pcrel_opt_stv1ti */

        case E_V2DImode:
          if (!d_form_memory (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !gpc_reg_operand (operands[1], E_V2DImode)
              || !
#line 396 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3240; /* *pcrel_opt_stv2di */

        case E_V4SImode:
          if (!d_form_memory (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !gpc_reg_operand (operands[1], E_V4SImode)
              || !
#line 396 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3241; /* *pcrel_opt_stv4si */

        case E_V8HImode:
          if (!d_form_memory (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !gpc_reg_operand (operands[1], E_V8HImode)
              || !
#line 396 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3242; /* *pcrel_opt_stv8hi */

        case E_V16QImode:
          if (!d_form_memory (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !gpc_reg_operand (operands[1], E_V16QImode)
              || !
#line 396 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3243; /* *pcrel_opt_stv16qi */

        case E_V2DFmode:
          if (!d_form_memory (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !gpc_reg_operand (operands[1], E_V2DFmode)
              || !
#line 396 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3244; /* *pcrel_opt_stv2df */

        case E_V4SFmode:
          if (!d_form_memory (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !gpc_reg_operand (operands[1], E_V4SFmode)
              || !
#line 396 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3245; /* *pcrel_opt_stv4sf */

        case E_TFmode:
          if (!d_form_memory (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode
              || !gpc_reg_operand (operands[1], E_TFmode)
              || !(
#line 396 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 99 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_FLOAT128_TYPE && TARGET_IEEEQUAD)))
            return -1;
          return 3246; /* *pcrel_opt_sttf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_168 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  x8 = XEXP (x3, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x8;
      if (vsx_register_operand (operands[1], E_V1TImode)
          && XWINT (x5, 0) == 0L
          && memory_operand (operands[0], E_V1TImode)
          && GET_MODE (x3) == E_V1TImode)
        {
          x9 = XEXP (x6, 0);
          if (rtx_equal_p (x9, operands[1])
              && 
#line 1543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && !BYTES_BIG_ENDIAN))
            return 1214; /* vsx_st_elemrev_v1ti */
        }
      operands[2] = x5;
      x9 = XEXP (x6, 0);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (pattern509 (x3, 
E_V2DFmode, 
E_DFmode) != 0
              || !(
#line 3613 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DFmode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 1383; /* *vsx_extract_di_v2df_load */

        case E_DImode:
          if (pattern509 (x3, 
E_V2DImode, 
E_DImode) != 0
              || !(
#line 3613 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DImode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 1384; /* *vsx_extract_di_v2di_load */

        case E_SFmode:
          if (GET_MODE (x3) != E_SFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_SFmode)
              && vsx_register_operand (operands[1], E_V4SFmode)
              && u5bit_cint_operand (operands[2], E_QImode)
              && scratch_operand (operands[3], E_V4SFmode)
              && 
#line 3692 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return 1393; /* vsx_extract_v4sf */
          if (!register_operand (operands[0], E_SFmode)
              || !memory_operand (operands[1], E_V4SFmode)
              || !const_0_to_3_operand (operands[2], E_QImode)
              || !scratch_operand (operands[3], E_DImode)
              || !(
#line 3725 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 1394; /* *vsx_extract_v4sf_di_load */

        case E_SImode:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          if (gpc_reg_operand (operands[1], E_V4SImode)
              && const_0_to_3_operand (operands[2], E_QImode))
            {
              if (nonimmediate_operand (operands[0], E_SImode)
                  && scratch_operand (operands[3], E_V4SImode))
                {
                  if (
#line 3932 "../../gcc/config/rs6000/vsx.md"
(TARGET_DIRECT_MOVE_64BIT
   && INTVAL (operands[2]) == (BYTES_BIG_ENDIAN ? 1 : 2)))
                    return 1399; /* vsx_extract_v4si_w1 */
                  if (
#line 4081 "../../gcc/config/rs6000/vsx.md"
(TARGET_DIRECT_MOVE_64BIT))
                    return 1410; /* *vsx_extract_v4si_w023 */
                }
              if (gpc_reg_operand (operands[0], E_SImode)
                  && scratch_operand (operands[3], E_SImode)
                  && 
#line 3969 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_VEXTRACTUB))
                return 1403; /* vsx_extract_v4si_p9 */
            }
          if (!register_operand (operands[0], E_SImode)
              || !memory_operand (operands[1], E_V4SImode)
              || !const_0_to_3_operand (operands[2], E_QImode)
              || !scratch_operand (operands[3], E_DImode)
              || !
#line 4165 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1415; /* *vsx_extract_v4si_load */

        case E_QImode:
          if (GET_MODE (x3) != E_QImode)
            return -1;
          if (gpc_reg_operand (operands[1], E_V16QImode)
              && const_0_to_15_operand (operands[2], E_QImode))
            {
              if (gpc_reg_operand (operands[0], E_QImode)
                  && scratch_operand (operands[3], E_SImode)
                  && 
#line 3969 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_VEXTRACTUB))
                return 1401; /* vsx_extract_v16qi_p9 */
              if (nonimmediate_operand (operands[0], E_QImode)
                  && scratch_operand (operands[3], E_V16QImode)
                  && 
#line 4117 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && !TARGET_P9_VECTOR))
                return 1411; /* *vsx_extract_v16qi_p8 */
            }
          if (!register_operand (operands[0], E_QImode)
              || !memory_operand (operands[1], E_V16QImode)
              || !const_0_to_15_operand (operands[2], E_QImode)
              || !scratch_operand (operands[3], E_DImode)
              || !
#line 4165 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1413; /* *vsx_extract_v16qi_load */

        case E_HImode:
          if (GET_MODE (x3) != E_HImode)
            return -1;
          if (gpc_reg_operand (operands[1], E_V8HImode)
              && const_0_to_7_operand (operands[2], E_QImode))
            {
              if (gpc_reg_operand (operands[0], E_HImode)
                  && scratch_operand (operands[3], E_SImode)
                  && 
#line 3969 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_VEXTRACTUB))
                return 1402; /* vsx_extract_v8hi_p9 */
              if (nonimmediate_operand (operands[0], E_HImode)
                  && scratch_operand (operands[3], E_V8HImode)
                  && 
#line 4117 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && !TARGET_P9_VECTOR))
                return 1412; /* *vsx_extract_v8hi_p8 */
            }
          if (!register_operand (operands[0], E_HImode)
              || !memory_operand (operands[1], E_V8HImode)
              || !const_0_to_7_operand (operands[2], E_QImode)
              || !scratch_operand (operands[3], E_DImode)
              || !
#line 4165 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1414; /* *vsx_extract_v8hi_load */

        default:
          return -1;
        }

    case PLUS:
      if (pattern426 (x1) != 0
          || !
#line 4997 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1526; /* *vsx_reduc_plus_v2df_scalar */

    case SMIN:
      if (pattern426 (x1) != 0
          || !
#line 4997 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1527; /* *vsx_reduc_smin_v2df_scalar */

    case SMAX:
      if (pattern426 (x1) != 0
          || !
#line 4997 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1528; /* *vsx_reduc_smax_v2df_scalar */

    default:
      return -1;
    }
}

 int
recog_173 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern75 (x1))
    {
    case 0:
      if (!
#line 5879 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX
   && TARGET_FCFIDS && can_create_pseudo_p ()))
        return -1;
      return 391; /* floatsisf2_lfiwax */

    case 1:
      if (memory_operand (operands[1], E_DImode)
          && scratch_operand (operands[2], E_DImode)
          && 
#line 7048 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDS))
        return 492; /* *floatdisf2_mem */
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !scratch_operand (operands[2], E_DFmode)
          || !
#line 7068 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FCFID && TARGET_HARD_FLOAT && !TARGET_FCFIDS))
        return -1;
      return 493; /* floatdisf2_internal1 */

    case 2:
      if (!
#line 5879 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX
   && TARGET_FCFID && can_create_pseudo_p ()))
        return -1;
      return 392; /* floatsidf2_lfiwax */

    case 3:
      if (!
#line 6975 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFID))
        return -1;
      return 488; /* *floatdidf2_mem */

    case 4:
      if (!(
#line 15328 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1049; /* float_kfsi2_hw */

    case 5:
      if (!(
#line 15347 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1051; /* floatqikf2 */

    case 6:
      if (!(
#line 15347 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1052; /* floathikf2 */

    case 7:
      if (!(
#line 15328 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1050; /* float_tfsi2_hw */

    case 8:
      if (!(
#line 15347 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1053; /* floatqitf2 */

    case 9:
      if (!(
#line 15347 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1054; /* floathitf2 */

    case 10:
      if (!
#line 5920 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX && TARGET_FCFIDS))
        return -1;
      return 393; /* floatsisf2_lfiwax_mem */

    case 11:
      if (!
#line 5920 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX && TARGET_FCFID))
        return -1;
      return 394; /* floatsidf2_lfiwax_mem */

    case 12:
      if (!
#line 5944 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDS && TARGET_P9_VECTOR
   && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 395; /* floatsisf2_lfiwax_qi_mem_zext */

    case 13:
      if (!
#line 5944 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDS && TARGET_P9_VECTOR
   && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 396; /* floatsisf2_lfiwax_hi_mem_zext */

    case 14:
      if (!
#line 5944 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFID && TARGET_P9_VECTOR
   && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 397; /* floatsidf2_lfiwax_qi_mem_zext */

    case 15:
      if (!
#line 5944 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFID && TARGET_P9_VECTOR
   && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 398; /* floatsidf2_lfiwax_hi_mem_zext */

    case 16:
      if (const_0_to_3_operand (operands[2], E_QImode)
          && scratch_operand (operands[3], E_V4SImode)
          && 
#line 4437 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
        return 1454; /* *vsx_extract_si_float_df */
      if (!const_int_operand (operands[2], E_QImode)
          || !scratch_operand (operands[3], E_SImode)
          || !
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
        return -1;
      return 1473; /* *vsx_ext_SI_fl_df */

    case 17:
      if (!
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
        return -1;
      return 1465; /* *vsx_ext_QI_fl_df */

    case 18:
      if (!
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
        return -1;
      return 1469; /* *vsx_ext_HI_fl_df */

    case 19:
      if (!
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
        return -1;
      return 1464; /* *vsx_ext_QI_fl_sf */

    case 20:
      if (!
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
        return -1;
      return 1468; /* *vsx_ext_HI_fl_sf */

    case 21:
      if (!
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
        return -1;
      return 1472; /* *vsx_ext_SI_fl_sf */

    case 22:
      if (!(
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
        return -1;
      return 1466; /* *vsx_ext_QI_fl_kf */

    case 23:
      if (!(
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
        return -1;
      return 1470; /* *vsx_ext_HI_fl_kf */

    case 24:
      if (!(
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
        return -1;
      return 1474; /* *vsx_ext_SI_fl_kf */

    case 25:
      if (!(
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1467; /* *vsx_ext_QI_fl_tf */

    case 26:
      if (!(
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1471; /* *vsx_ext_HI_fl_tf */

    case 27:
      if (!(
#line 4543 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1475; /* *vsx_ext_SI_fl_tf */

    default:
      return -1;
    }
}

 int
recog_177 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern78 (x1))
    {
    case 0:
      if (!
#line 5976 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFIDS))
        return -1;
      return 400; /* floatunssisf2_lfiwzx */

    case 1:
      if (!
#line 7129 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDUS))
        return -1;
      return 495; /* *floatunsdisf2_mem */

    case 2:
      if (!
#line 5976 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFID))
        return -1;
      return 401; /* floatunssidf2_lfiwzx */

    case 3:
      if (!
#line 7004 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && (TARGET_FCFIDU || VECTOR_UNIT_VSX_P (DFmode))))
        return -1;
      return 490; /* *floatunsdidf2_mem */

    case 4:
      if (!(
#line 15394 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1057; /* floatuns_kfsi2_hw */

    case 5:
      if (!(
#line 15414 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1059; /* floatunsqikf2 */

    case 6:
      if (!(
#line 15414 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1060; /* floatunshikf2 */

    case 7:
      if (!(
#line 15394 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1058; /* floatuns_tfsi2_hw */

    case 8:
      if (!(
#line 15414 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1061; /* floatunsqitf2 */

    case 9:
      if (!(
#line 15414 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1062; /* floatunshitf2 */

    case 10:
      if (!
#line 6016 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFIDS))
        return -1;
      return 402; /* floatunssisf2_lfiwzx_mem */

    case 11:
      if (!
#line 6016 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFID))
        return -1;
      return 403; /* floatunssidf2_lfiwzx_mem */

    case 12:
      if (const_0_to_3_operand (operands[2], E_QImode)
          && scratch_operand (operands[3], E_V4SImode)
          && 
#line 4437 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
        return 1455; /* *vsx_extract_si_unsfloat_df */
      if (!const_int_operand (operands[2], E_QImode)
          || !scratch_operand (operands[3], E_SImode)
          || !
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
        return -1;
      return 1485; /* *vsx_ext_SI_ufl_df */

    case 13:
      if (!
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
        return -1;
      return 1477; /* *vsx_ext_QI_ufl_df */

    case 14:
      if (!
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
        return -1;
      return 1481; /* *vsx_ext_HI_ufl_df */

    case 15:
      if (!
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
        return -1;
      return 1476; /* *vsx_ext_QI_ufl_sf */

    case 16:
      if (!
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
        return -1;
      return 1480; /* *vsx_ext_HI_ufl_sf */

    case 17:
      if (!
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
        return -1;
      return 1484; /* *vsx_ext_SI_ufl_sf */

    case 18:
      if (!(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
        return -1;
      return 1478; /* *vsx_ext_QI_ufl_kf */

    case 19:
      if (!(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
        return -1;
      return 1482; /* *vsx_ext_HI_ufl_kf */

    case 20:
      if (!(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
        return -1;
      return 1486; /* *vsx_ext_SI_ufl_kf */

    case 21:
      if (!(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1479; /* *vsx_ext_QI_ufl_tf */

    case 22:
      if (!(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1483; /* *vsx_ext_HI_ufl_tf */

    case 23:
      if (!(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1487; /* *vsx_ext_SI_ufl_tf */

    default:
      return -1;
    }
}

 int
recog_186 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case ZERO_EXTEND:
      return recog_126 (x1, insn, pnum_clobbers);

    case COMPARE:
      return recog_119 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      return recog_136 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_125 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_131 (x1, insn, pnum_clobbers);

    case NOT:
      return recog_133 (x1, insn, pnum_clobbers);

    case NEG:
      return recog_118 (x1, insn, pnum_clobbers);

    case CLZ:
      switch (pattern0 (x1))
        {
        case 0:
          return 122; /* clzsi2 */

        case 1:
          if (!
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 123; /* clzdi2 */

        case 2:
          if (!
#line 4370 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2146; /* *p8v_clzv4si2 */

        case 3:
          if (!
#line 4370 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2147; /* *p8v_clzv8hi2 */

        case 4:
          if (!
#line 4370 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2148; /* *p8v_clzv16qi2 */

        case 5:
          if (!
#line 4370 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2149; /* *p8v_clzv2di2 */

        default:
          return -1;
        }

    case CTZ:
      switch (pattern0 (x1))
        {
        case 0:
          if (!
#line 2490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_CTZ))
            return -1;
          return 124; /* ctzsi2_hw */

        case 1:
          if (!(
#line 2490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_CTZ) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 125; /* ctzdi2_hw */

        case 2:
          if (!
#line 4392 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2153; /* *p9v_ctzv4si2 */

        case 3:
          if (!
#line 4392 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2154; /* *p9v_ctzv8hi2 */

        case 4:
          if (!
#line 4392 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2155; /* *p9v_ctzv16qi2 */

        case 5:
          if (!
#line 4392 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2156; /* *p9v_ctzv2di2 */

        default:
          return -1;
        }

    case POPCOUNT:
      switch (pattern0 (x1))
        {
        case 0:
          if (!
#line 2530 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD))
            return -1;
          return 128; /* popcntdsi2 */

        case 1:
          if (!(
#line 2530 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 129; /* popcntddi2 */

        case 2:
          if (!
#line 4400 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2157; /* *p8v_popcountv4si2 */

        case 3:
          if (!
#line 4400 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2158; /* *p8v_popcountv8hi2 */

        case 4:
          if (!
#line 4400 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2159; /* *p8v_popcountv16qi2 */

        case 5:
          if (!
#line 4400 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2160; /* *p8v_popcountv2di2 */

        default:
          return -1;
        }

    case BSWAP:
      return recog_134 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      return recog_145 (x1, insn, pnum_clobbers);

    case UDIV:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern19 (x2, 
E_SImode) != 0)
            return -1;
          return 176; /* udivsi3 */

        case E_DImode:
          if (pattern19 (x2, 
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 177; /* udivdi3 */

        case E_TImode:
          if (pattern1 (x2, 
E_TImode) != 0
              || !
#line 3343 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_POWERPC64))
            return -1;
          return 178; /* udivti3 */

        case E_V2DImode:
          if (pattern2 (x2, 
E_V2DImode) != 0
              || !
#line 6525 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1649; /* udivv2di3 */

        case E_V4SImode:
          if (pattern2 (x2, 
E_V4SImode) != 0
              || !
#line 6525 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1650; /* udivv4si3 */

        default:
          return -1;
        }

    case DIV:
      return recog_142 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case EQ:
        case GT:
        case LT:
        case GTU:
        case LTU:
        case UNORDERED:
          res = recog_8 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case NE:
        case GE:
        case LE:
        case GEU:
        case LEU:
        case ORDERED:
        case UNLE:
        case UNLT:
          res = recog_11 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      switch (GET_CODE (x4))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNLE:
          res = recog_14 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (!extra_insn_branch_comparison_operator (x4, E_VOIDmode)
          || pattern28 (x1) != 0
          || !
#line 13342 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
        return -1;
      return 884; /* *cbranch_2insn */

    case AND:
    case IOR:
    case XOR:
      return recog_127 (x1, insn, pnum_clobbers);

    case EQ:
    case GT:
    case LT:
    case GTU:
    case LTU:
    case UNORDERED:
      return recog_130 (x1, insn, pnum_clobbers);

    case ROTATE:
      return recog_144 (x1, insn, pnum_clobbers);

    case ASHIFT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          switch (pattern126 (x2, pnum_clobbers))
            {
            case 0:
              return 271; /* ashlsi3 */

            case 1:
              if (!
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 272; /* ashldi3 */

            case 2:
              if (!
#line 2114 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
                return -1;
              return 1912; /* *altivec_vslw */

            case 3:
              if (!
#line 2114 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
                return -1;
              return 1913; /* *altivec_vslh */

            case 4:
              if (!
#line 2114 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
                return -1;
              return 1914; /* *altivec_vslb */

            case 5:
              if (!
#line 2114 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
                return -1;
              return 1915; /* *altivec_vsld */

            case 6:
              if (!
#line 2122 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
                return -1;
              return 1916; /* altivec_vslq_v1ti */

            case 7:
              if (!
#line 2122 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
                return -1;
              return 1917; /* altivec_vslq_ti */

            case 8:
              if (!(
#line 2197 "../../gcc/config/rs6000/altivec.md"
(((V4SImode == V2DImode && TARGET_P8_VECTOR)
    || (V4SImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2183 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR)))
                return -1;
              *pnum_clobbers = 1;
              return 1931; /* *altivec_v4si_ashift_const */

            case 9:
              if (!(
#line 2197 "../../gcc/config/rs6000/altivec.md"
(((V2DImode == V2DImode && TARGET_P8_VECTOR)
    || (V2DImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2184 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR)))
                return -1;
              *pnum_clobbers = 1;
              return 1934; /* *altivec_v2di_ashift_const */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (GET_MODE (x4) != E_DImode
              || !gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode)
            return -1;
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (!reg_or_mem_operand (operands[1], E_SImode)
              || !u6bit_cint_operand (operands[2], E_DImode)
              || !
#line 4707 "../../gcc/config/rs6000/rs6000.md"
(TARGET_EXTSWSLI))
            return -1;
          return 278; /* ashdi3_extswsli */

        default:
          return -1;
        }

    case LSHIFTRT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (pattern126 (x2, pnum_clobbers))
        {
        case 0:
          return 281; /* lshrsi3 */

        case 1:
          if (!
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 282; /* lshrdi3 */

        case 2:
          if (!
#line 2131 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1918; /* *altivec_vsrw */

        case 3:
          if (!
#line 2131 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1919; /* *altivec_vsrh */

        case 4:
          if (!
#line 2131 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return -1;
          return 1920; /* *altivec_vsrb */

        case 5:
          if (!
#line 2131 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 1921; /* *altivec_vsrd */

        case 6:
          if (!
#line 2139 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1922; /* altivec_vsrq_v1ti */

        case 7:
          if (!
#line 2139 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1923; /* altivec_vsrq_ti */

        case 8:
          if (!(
#line 2197 "../../gcc/config/rs6000/altivec.md"
(((V4SImode == V2DImode && TARGET_P8_VECTOR)
    || (V4SImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2183 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR)))
            return -1;
          *pnum_clobbers = 1;
          return 1933; /* *altivec_v4si_lshiftrt_const */

        case 9:
          if (!(
#line 2197 "../../gcc/config/rs6000/altivec.md"
(((V2DImode == V2DImode && TARGET_P8_VECTOR)
    || (V2DImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2184 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR)))
            return -1;
          *pnum_clobbers = 1;
          return 1936; /* *altivec_v2di_lshiftrt_const */

        default:
          return -1;
        }

    case ASHIFTRT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_CODE (operands[2]))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pnum_clobbers == NULL
                  || pattern123 (x2, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 288; /* ashrsi3 */

            case E_DImode:
              if (pnum_clobbers == NULL
                  || pattern123 (x2, 
E_DImode) != 0
                  || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              *pnum_clobbers = 1;
              return 289; /* ashrdi3 */

            case E_V4SImode:
              if (pattern3 (x2, 
E_V4SImode) != 0
                  || !
#line 2148 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
                return -1;
              return 1924; /* *altivec_vsraw */

            case E_V8HImode:
              if (pattern3 (x2, 
E_V8HImode) != 0
                  || !
#line 2148 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
                return -1;
              return 1925; /* *altivec_vsrah */

            case E_V16QImode:
              if (pattern3 (x2, 
E_V16QImode) != 0
                  || !
#line 2148 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
                return -1;
              return 1926; /* *altivec_vsrab */

            case E_V2DImode:
              if (pattern3 (x2, 
E_V2DImode) != 0
                  || !
#line 2148 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
                return -1;
              return 1927; /* *altivec_vsrad */

            case E_V1TImode:
              if (pattern2 (x2, 
E_V1TImode) != 0
                  || !
#line 2156 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
                return -1;
              return 1928; /* altivec_vsraq */

            default:
              return -1;
            }

        case CONST_VECTOR:
        case VEC_DUPLICATE:
          switch (pattern125 (x2, pnum_clobbers))
            {
            case 0:
              if (!(
#line 2197 "../../gcc/config/rs6000/altivec.md"
(((V4SImode == V2DImode && TARGET_P8_VECTOR)
    || (V4SImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2183 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR)))
                return -1;
              *pnum_clobbers = 1;
              return 1932; /* *altivec_v4si_ashiftrt_const */

            case 1:
              if (!(
#line 2197 "../../gcc/config/rs6000/altivec.md"
(((V2DImode == V2DImode && TARGET_P8_VECTOR)
    || (V2DImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2184 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR)))
                return -1;
              *pnum_clobbers = 1;
              return 1935; /* *altivec_v2di_ashiftrt_const */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ABS:
      return recog_135 (x1, insn, pnum_clobbers);

    case SQRT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!gpc_reg_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !gpc_reg_operand (operands[1], E_SFmode)
              || !
#line 5133 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_PPC_GPOPT))
            return -1;
          return 309; /* *sqrtsf2_internal */

        case E_DFmode:
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !gpc_reg_operand (operands[1], E_DFmode)
              || !
#line 5133 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_PPC_GPOPT))
            return -1;
          return 310; /* *sqrtdf2_internal */

        case E_KFmode:
          if (!altivec_register_operand (operands[0], E_KFmode)
              || GET_MODE (x2) != E_KFmode
              || !altivec_register_operand (operands[1], E_KFmode)
              || !(
#line 15059 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 989; /* sqrtkf2 */

        case E_TFmode:
          if (!altivec_register_operand (operands[0], E_TFmode)
              || GET_MODE (x2) != E_TFmode
              || !altivec_register_operand (operands[1], E_TFmode)
              || !(
#line 15059 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 990; /* sqrttf2 */

        case E_V4SFmode:
          if (!vsx_register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !vsx_register_operand (operands[1], E_V4SFmode)
              || !
#line 2023 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1254; /* *vsx_sqrtv4sf2 */

        case E_V2DFmode:
          if (!vsx_register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x2) != E_V2DFmode
              || !vsx_register_operand (operands[1], E_V2DFmode)
              || !
#line 2023 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1255; /* *vsx_sqrtv2df2 */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      return recog_132 (x1, insn, pnum_clobbers);

    case FLOAT_TRUNCATE:
      return recog_138 (x1, insn, pnum_clobbers);

    case COPYSIGN:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern19 (x2, 
E_SFmode) != 0
              || !
#line 5455 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && (TARGET_CMPB || VECTOR_UNIT_VSX_P (SFmode))))
            return -1;
          return 324; /* copysignsf3_fcpsgn */

        case E_DFmode:
          if (pattern19 (x2, 
E_DFmode) != 0
              || !
#line 5455 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && (TARGET_CMPB || VECTOR_UNIT_VSX_P (DFmode))))
            return -1;
          return 325; /* copysigndf3_fcpsgn */

        case E_KFmode:
          if (pattern1 (x2, 
E_KFmode) != 0)
            return -1;
          if ((
#line 15102 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return 991; /* copysignkf3_hard */
          if (pnum_clobbers == NULL
              || !(
#line 15113 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 993; /* copysignkf3_soft */

        case E_TFmode:
          if (pattern1 (x2, 
E_TFmode) != 0)
            return -1;
          if ((
#line 15102 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return 992; /* copysigntf3_hard */
          if (pnum_clobbers == NULL
              || !(
#line 15113 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 994; /* copysigntf3_soft */

        case E_V4SFmode:
          if (pattern2 (x2, 
E_V4SFmode) != 0
              || !
#line 2265 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1282; /* vsx_copysignv4sf3 */

        case E_V2DFmode:
          if (pattern2 (x2, 
E_V2DFmode) != 0
              || !
#line 2265 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1283; /* vsx_copysignv2df3 */

        default:
          return -1;
        }

    case SMIN:
      return recog_140 (x1, insn, pnum_clobbers);

    case SMAX:
      return recog_139 (x1, insn, pnum_clobbers);

    case NE:
    case GE:
    case LE:
    case GEU:
    case LEU:
    case ORDERED:
      return recog_143 (x1, insn, pnum_clobbers);

    case FLOAT:
      return recog_121 (x1, insn, pnum_clobbers);

    case UNSIGNED_FLOAT:
      return recog_124 (x1, insn, pnum_clobbers);

    case FIX:
      return recog_120 (x1, insn, pnum_clobbers);

    case UNSIGNED_FIX:
      return recog_122 (x1, insn, pnum_clobbers);

    case UNSPEC_VOLATILE:
      return recog_128 (x1, insn, pnum_clobbers);

    case LO_SUM:
      return recog_146 (x1, insn, pnum_clobbers);

    case UNSPEC:
    case PLUS:
      switch (GET_CODE (x2))
        {
        case PLUS:
          res = recog_31 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case UNSPEC:
          res = recog_106 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern67 ())
        {
        case 0:
          if ((
#line 11337 "../../gcc/config/rs6000/rs6000.md"
(TARGET_TOC
    && legitimate_constant_pool_address_p (operands[1], QImode, false)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return 767; /* *tocrefsi */
          break;

        case 1:
          if ((
#line 11337 "../../gcc/config/rs6000/rs6000.md"
(TARGET_TOC
    && legitimate_constant_pool_address_p (operands[1], QImode, false)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return 768; /* *tocrefdi */
          break;

        default:
          break;
        }
      switch (GET_CODE (x2))
        {
        case UNSPEC:
          return recog_107 (x1, insn, pnum_clobbers);

        case PLUS:
          if (pnum_clobbers == NULL)
            return -1;
          x4 = XEXP (x2, 0);
          switch (GET_CODE (x4))
            {
            case EQ:
              if (pattern166 (x1) != 0)
                return -1;
              *pnum_clobbers = 3;
              return 857; /* *plus_eq_di */

            case NE:
              if (pattern166 (x1) != 0)
                return -1;
              *pnum_clobbers = 3;
              return 858; /* *plus_ne_di */

            case AND:
              switch (pattern41 (x1))
                {
                case 0:
                  if (!
#line 1663 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2518; /* *fuse_and_add */

                case 1:
                  if (!(
#line 1663 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2519; /* *fuse_and_add */

                case 2:
                  if (!
#line 1699 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2522; /* *fuse_nor_add */

                case 3:
                  if (!(
#line 1699 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2523; /* *fuse_nor_add */

                default:
                  return -1;
                }

            case IOR:
              switch (pattern42 (x1))
                {
                case 0:
                  if (!
#line 1681 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2520; /* *fuse_nand_add */

                case 1:
                  if (!(
#line 1681 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2521; /* *fuse_nand_add */

                case 2:
                  if (!
#line 1717 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2524; /* *fuse_or_add */

                case 3:
                  if (!(
#line 1717 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2525; /* *fuse_or_add */

                default:
                  return -1;
                }

            case PLUS:
              switch (pattern122 (x1))
                {
                case 0:
                  if (!
#line 3031 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3182; /* *fuse_add_add */

                case 1:
                  if (!(
#line 3031 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3183; /* *fuse_add_add */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNLE:
      switch (pattern13 (x1))
        {
        case 0:
          if (!
#line 13282 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
            return -1;
          return 865; /* *unlesi_cc */

        case 1:
          if (!(
#line 13282 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 869; /* *unledi_cc */

        case 2:
          if (!
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
            return -1;
          return 1130; /* vector_unlev4sf */

        case 3:
          if (!
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
            return -1;
          return 1137; /* vector_unlev2df */

        default:
          return -1;
        }

    case UNGE:
      switch (pattern13 (x1))
        {
        case 0:
          if (!
#line 13282 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
            return -1;
          return 866; /* *ungesi_cc */

        case 1:
          if (!(
#line 13282 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 870; /* *ungedi_cc */

        case 2:
          if (!
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
            return -1;
          return 1128; /* vector_ungev4sf */

        case 3:
          if (!
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
            return -1;
          return 1135; /* vector_ungev2df */

        default:
          return -1;
        }

    case LTGT:
      switch (pattern13 (x1))
        {
        case 0:
          if (!
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
            return -1;
          return 871; /* *ltgtsi_cc */

        case 1:
          if (!(
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 877; /* *ltgtdi_cc */

        case 2:
          if (!
#line 653 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
            return -1;
          return 1138; /* vector_ltgtv4sf */

        case 3:
          if (!
#line 653 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
            return -1;
          return 1142; /* vector_ltgtv2df */

        default:
          return -1;
        }

    case UNLT:
      switch (pattern13 (x1))
        {
        case 0:
          if (!
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
            return -1;
          return 874; /* *unltsi_cc */

        case 1:
          if (!(
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 880; /* *unltdi_cc */

        case 2:
          if (!
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
            return -1;
          return 1129; /* vector_unltv4sf */

        case 3:
          if (!
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
            return -1;
          return 1136; /* vector_unltv2df */

        default:
          return -1;
        }

    case UNGT:
      switch (pattern13 (x1))
        {
        case 0:
          if (!
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
            return -1;
          return 875; /* *ungtsi_cc */

        case 1:
          if (!(
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 881; /* *ungtdi_cc */

        case 2:
          if (!
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
            return -1;
          return 1127; /* vector_ungtv4sf */

        case 3:
          if (!
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
            return -1;
          return 1134; /* vector_ungtv2df */

        default:
          return -1;
        }

    case UNEQ:
      switch (pattern13 (x1))
        {
        case 0:
          if (!
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only))
            return -1;
          return 876; /* *uneqsi_cc */

        case 1:
          if (!(
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 882; /* *uneqdi_cc */

        case 2:
          if (!
#line 653 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
            return -1;
          return 1139; /* vector_uneqv4sf */

        case 3:
          if (!
#line 653 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
            return -1;
          return 1143; /* vector_uneqv2df */

        default:
          return -1;
        }

    case FMA:
      return recog_137 (x1, insn, pnum_clobbers);

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
    case VEC_DUPLICATE:
      return recog_129 (x1, insn, pnum_clobbers);

    case VEC_SELECT:
      return recog_123 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      return recog_141 (x1, insn, pnum_clobbers);

    case MOD:
      switch (pattern14 (x1))
        {
        case 0:
          if (!
#line 6534 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1651; /* modv2di3 */

        case 1:
          if (!
#line 6534 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1652; /* modv4si3 */

        default:
          return -1;
        }

    case UMOD:
      switch (pattern14 (x1))
        {
        case 0:
          if (!
#line 6543 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1653; /* umodv2di3 */

        case 1:
          if (!
#line 6543 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1654; /* umodv4si3 */

        default:
          return -1;
        }

    case US_MULT:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != ASHIFTRT)
        return -1;
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != ASHIFTRT)
        return -1;
      x8 = XEXP (x5, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern285 (x2))
        {
        case 0:
          if (!
#line 6568 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1657; /* umulv2di3_highpart */

        case 1:
          if (!
#line 6568 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1658; /* umulv4si3_highpart */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern15 (x1))
        {
        case 0:
          if (!
#line 1073 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1818; /* umaxv4si3 */

        case 1:
          if (!
#line 1073 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1819; /* umaxv8hi3 */

        case 2:
          if (!
#line 1073 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return -1;
          return 1820; /* umaxv16qi3 */

        case 3:
          if (!
#line 1073 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 1821; /* umaxv2di3 */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern15 (x1))
        {
        case 0:
          if (!
#line 1097 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1827; /* uminv4si3 */

        case 1:
          if (!
#line 1097 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1828; /* uminv8hi3 */

        case 2:
          if (!
#line 1097 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return -1;
          return 1829; /* uminv16qi3 */

        case 3:
          if (!
#line 1097 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 1830; /* uminv2di3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
peephole2_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case DIV:
      switch (pattern119 (x1, 
MOD))
        {
        case 0:
          if (!
#line 3539 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MODULO
   && ! reg_mentioned_p (operands[0], operands[1])
   && ! reg_mentioned_p (operands[0], operands[2])
   && ! reg_mentioned_p (operands[3], operands[1])
   && ! reg_mentioned_p (operands[3], operands[2])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_1 (insn, operands);

        case 1:
          if (!(
#line 3539 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MODULO
   && ! reg_mentioned_p (operands[0], operands[1])
   && ! reg_mentioned_p (operands[0], operands[2])
   && ! reg_mentioned_p (operands[3], operands[1])
   && ! reg_mentioned_p (operands[3], operands[2])) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_2 (insn, operands);

        default:
          return NULL;
        }

    case UDIV:
      switch (pattern119 (x1, 
UMOD))
        {
        case 0:
          if (!
#line 3561 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MODULO
   && ! reg_mentioned_p (operands[0], operands[1])
   && ! reg_mentioned_p (operands[0], operands[2])
   && ! reg_mentioned_p (operands[3], operands[1])
   && ! reg_mentioned_p (operands[3], operands[2])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_3 (insn, operands);

        case 1:
          if (!(
#line 3561 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MODULO
   && ! reg_mentioned_p (operands[0], operands[1])
   && ! reg_mentioned_p (operands[0], operands[2])
   && ! reg_mentioned_p (operands[3], operands[1])
   && ! reg_mentioned_p (operands[3], operands[2])) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_4 (insn, operands);

        default:
          return NULL;
        }

    case COMPARE:
      if (GET_MODE (x3) != E_CCmode)
        return NULL;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      if (!cc_reg_operand (operands[2], E_CCmode))
        return NULL;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x8 = XEXP (x2, 1);
      if (!rtx_equal_p (x8, operands[1]))
        return NULL;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!int_reg_operand (operands[1], E_SImode)
              || !int_reg_operand (operands[0], E_SImode)
              || !(
#line 8059 "../../gcc/config/rs6000/rs6000.md"
(!cc_reg_not_cr0_operand (operands[2], CCmode)) && 
#line 513 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_5 (insn, operands);

        case E_DImode:
          if (!int_reg_operand (operands[1], E_DImode)
              || !int_reg_operand (operands[0], E_DImode)
              || !(
#line 8059 "../../gcc/config/rs6000/rs6000.md"
(!cc_reg_not_cr0_operand (operands[2], CCmode)) && 
#line 513 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_6 (insn, operands);

        default:
          return NULL;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case HIGH:
      x5 = XEXP (x1, 0);
      switch (GET_MODE (x5))
        {
        case E_SImode:
          operands[0] = x5;
          operands[1] = x3;
          if (int_reg_operand (operands[1], E_SImode)
              && pattern347 (x2, 
E_SImode) == 0)
            {
              if ((
#line 8074 "../../gcc/config/rs6000/rs6000.md"
(!cc_reg_not_cr0_operand (operands[2], CCmode)) && 
#line 513 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_7 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 8074 "../../gcc/config/rs6000/rs6000.md"
(!cc_reg_not_cr0_operand (operands[2], CCmode)) && ((
#line 513 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 513 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64))))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_8 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (peep2_current_count >= 3)
            {
              res = peephole2_1 (x1, insn, pmatch_len_);
              if (res != NULL_RTX)
                return res;
            }
          if (!fusion_gpr_addis (operands[1], E_SImode))
            return NULL;
          switch (pattern348 (x2, 
E_SImode))
            {
            case 0:
              if (!(
#line 14717 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_14 (insn, operands);

            case 1:
              if (!(
#line 14717 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_15 (insn, operands);

            case 2:
              if (!(
#line 14717 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_16 (insn, operands);

            case 3:
              if (!(
#line 14717 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && ((
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT) && 
#line 484 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 484 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_17 (insn, operands);

            default:
              return NULL;
            }

        case E_DImode:
          operands[0] = x5;
          operands[1] = x3;
          if (int_reg_operand (operands[1], E_DImode)
              && pattern347 (x2, 
E_DImode) == 0
              && (
#line 8074 "../../gcc/config/rs6000/rs6000.md"
(!cc_reg_not_cr0_operand (operands[2], CCmode)) && 
#line 513 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_9 (insn, operands);
              if (res != NULL_RTX)
                return res;
              *pmatch_len_ = 1;
              res = gen_peephole2_10 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (fusion_gpr_addis (operands[1], E_DImode))
            {
              switch (pattern348 (x2, 
E_DImode))
                {
                case 0:
                  if ((
#line 14717 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_18 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 1:
                  if ((
#line 14717 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_19 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 2:
                  if ((
#line 14717 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_20 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 3:
                  if ((
#line 14717 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && ((
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT) && 
#line 484 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 484 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_21 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                default:
                  break;
                }
            }
          operands[1] = x5;
          if (!fpr_reg_operand (operands[1], E_DImode))
            return NULL;
          operands[2] = x3;
          x7 = XEXP (x2, 0);
          operands[3] = x7;
          if (altivec_register_operand (operands[3], E_DImode)
              && simple_offsettable_mem_operand (operands[2], E_DImode))
            {
              x8 = XEXP (x2, 1);
              if (rtx_equal_p (x8, operands[1]))
                {
                  if ((
#line 14757 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT) && 
#line 858 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_26 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 14757 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT) && 
#line 858 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_27 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
          if (!simple_offsettable_mem_operand (operands[3], E_DImode)
              || !altivec_register_operand (operands[2], E_DImode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (!rtx_equal_p (x8, operands[1]))
            return NULL;
          if ((
#line 14793 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT) && 
#line 858 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_32 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!(
#line 14793 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT) && 
#line 858 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_33 (insn, operands);

        case E_DFmode:
          operands[0] = x5;
          if (pattern258 (x3, 
E_DFmode) == 0
              && 
#line 10545 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_VSX
   && peep2_reg_dead_p (2, operands[0])))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_11 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          operands[1] = x5;
          if (!fpr_reg_operand (operands[1], E_DFmode))
            return NULL;
          operands[2] = x3;
          x7 = XEXP (x2, 0);
          operands[3] = x7;
          if (altivec_register_operand (operands[3], E_DFmode)
              && simple_offsettable_mem_operand (operands[2], E_DFmode))
            {
              x8 = XEXP (x2, 1);
              if (rtx_equal_p (x8, operands[1]))
                {
                  if ((
#line 14757 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_22 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 14757 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_23 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
          if (!simple_offsettable_mem_operand (operands[3], E_DFmode)
              || !altivec_register_operand (operands[2], E_DFmode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (!rtx_equal_p (x8, operands[1]))
            return NULL;
          if ((
#line 14793 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_28 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!(
#line 14793 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_29 (insn, operands);

        case E_SFmode:
          operands[0] = x5;
          if (pattern258 (x3, 
E_SFmode) == 0
              && 
#line 10554 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_P8_VECTOR
   && peep2_reg_dead_p (2, operands[0])))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_12 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          operands[1] = x5;
          if (!fpr_reg_operand (operands[1], E_SFmode))
            return NULL;
          operands[2] = x3;
          x7 = XEXP (x2, 0);
          operands[3] = x7;
          if (altivec_register_operand (operands[3], E_SFmode)
              && simple_offsettable_mem_operand (operands[2], E_SFmode))
            {
              x8 = XEXP (x2, 1);
              if (rtx_equal_p (x8, operands[1]))
                {
                  if ((
#line 14757 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT) && 
#line 857 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_24 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 14757 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT) && 
#line 857 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_25 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
          if (!simple_offsettable_mem_operand (operands[3], E_SFmode)
              || !altivec_register_operand (operands[2], E_SFmode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (!rtx_equal_p (x8, operands[1]))
            return NULL;
          if ((
#line 14793 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT) && 
#line 857 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR))))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_30 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!(
#line 14793 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT) && 
#line 857 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR))))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_31 (insn, operands);

        default:
          return NULL;
        }

    case ROTATE:
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return NULL;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x8 = XEXP (x2, 1);
      if (GET_CODE (x8) != ROTATE)
        return NULL;
      x9 = XEXP (x8, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return NULL;
      x7 = XEXP (x2, 0);
      operands[2] = x7;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_V1TImode:
          if (!int_reg_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || GET_MODE (x8) != E_V1TImode)
            return NULL;
          if (memory_operand (operands[1], E_V1TImode)
              && int_reg_operand (operands[2], E_V1TImode)
              && 
#line 1095 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && (rtx_equal_p (operands[0], operands[2])
       || peep2_reg_dead_p (2, operands[0]))))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_34 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!int_reg_operand (operands[1], E_V1TImode)
              || !memory_operand (operands[2], E_V1TImode)
              || !
#line 1107 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && peep2_reg_dead_p (2, operands[0])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_36 (insn, operands);

        case E_TImode:
          if (GET_MODE (x3) != E_TImode
              || GET_MODE (x8) != E_TImode)
            return NULL;
          if (int_reg_operand (operands[0], E_TImode))
            {
              if (memory_operand (operands[1], E_TImode)
                  && int_reg_operand (operands[2], E_TImode)
                  && 
#line 1095 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && (rtx_equal_p (operands[0], operands[2])
       || peep2_reg_dead_p (2, operands[0]))))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_35 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (int_reg_operand (operands[1], E_TImode)
                  && memory_operand (operands[2], E_TImode)
                  && 
#line 1107 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && peep2_reg_dead_p (2, operands[0])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_37 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (!vsx_register_operand (operands[0], E_TImode)
              || !vsx_register_operand (operands[1], E_TImode)
              || !vsx_register_operand (operands[2], E_TImode)
              || !
#line 1121 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && (rtx_equal_p (operands[0], operands[2])
       || peep2_reg_dead_p (2, operands[0]))))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_38 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      if (peep2_current_count < 3
          || peep2_current_count < 4
          || GET_MODE (x3) != E_DImode)
        return NULL;
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      if (!int_reg_operand (operands[2], E_DImode))
        return NULL;
      x6 = XEXP (x3, 0);
      operands[3] = x6;
      if (!vsx_register_operand (operands[3], E_SImode))
        return NULL;
      x7 = XEXP (x2, 0);
      operands[4] = x7;
      if (!int_reg_operand (operands[4], E_SImode))
        return NULL;
      x8 = XEXP (x2, 1);
      if (GET_MODE (x8) != E_SImode)
        return NULL;
      x11 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x11) != SET)
        return NULL;
      x12 = XEXP (x11, 1);
      if (GET_CODE (x12) != ASHIFT
          || GET_MODE (x12) != E_DImode)
        return NULL;
      x13 = XEXP (x12, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return NULL;
      x14 = XEXP (x11, 0);
      operands[7] = x14;
      if (!int_reg_operand (operands[7], E_DImode))
        return NULL;
      x15 = XEXP (x12, 0);
      operands[8] = x15;
      if (!int_reg_operand (operands[8], E_DImode))
        return NULL;
      x16 = PATTERN (peep2_next_insn (3));
      if (GET_CODE (x16) != SET)
        return NULL;
      x17 = XEXP (x16, 1);
      if (GET_CODE (x17) != UNSPEC
          || XVECLEN (x17, 0) != 1
          || XINT (x17, 1) != 62
          || GET_MODE (x17) != E_SFmode)
        return NULL;
      x18 = XEXP (x16, 0);
      operands[9] = x18;
      if (!vsx_register_operand (operands[9], E_SFmode))
        return NULL;
      x19 = XVECEXP (x17, 0, 0);
      if (!rtx_equal_p (x19, operands[7]))
        return NULL;
      switch (GET_CODE (x8))
        {
        case AND:
          x10 = XEXP (x8, 0);
          operands[5] = x10;
          if (!int_reg_operand (operands[5], E_SImode))
            return NULL;
          x9 = XEXP (x8, 1);
          operands[6] = x9;
          if (!reg_or_cint_operand (operands[6], E_SImode)
              || !
#line 6343 "../../gcc/config/rs6000/vsx.md"
(TARGET_DIRECT_MOVE_64BIT
   /* The REG_P (xxx) tests prevents SUBREG's, which allows us to use REGNO
      to compare registers, when the mode is different.  */
   && REG_P (operands[SFBOOL_MFVSR_D]) && REG_P (operands[SFBOOL_BOOL_D])
   && REG_P (operands[SFBOOL_BOOL_A1]) && REG_P (operands[SFBOOL_SHL_D])
   && REG_P (operands[SFBOOL_SHL_A])   && REG_P (operands[SFBOOL_MTVSR_D])
   && (REG_P (operands[SFBOOL_BOOL_A2])
       || CONST_INT_P (operands[SFBOOL_BOOL_A2]))
   && (REGNO (operands[SFBOOL_BOOL_D]) == REGNO (operands[SFBOOL_MFVSR_D])
       || peep2_reg_dead_p (2, operands[SFBOOL_MFVSR_D]))
   && (REGNO (operands[SFBOOL_MFVSR_D]) == REGNO (operands[SFBOOL_BOOL_A1])
       || (REG_P (operands[SFBOOL_BOOL_A2])
	   && REGNO (operands[SFBOOL_MFVSR_D])
		== REGNO (operands[SFBOOL_BOOL_A2])))
   && REGNO (operands[SFBOOL_BOOL_D]) == REGNO (operands[SFBOOL_SHL_A])
   && (REGNO (operands[SFBOOL_SHL_D]) == REGNO (operands[SFBOOL_BOOL_D])
       || peep2_reg_dead_p (3, operands[SFBOOL_BOOL_D]))
   && peep2_reg_dead_p (4, operands[SFBOOL_SHL_D])))
            return NULL;
          *pmatch_len_ = 3;
          return gen_peephole2_39 (insn, operands);

        case IOR:
          x10 = XEXP (x8, 0);
          operands[5] = x10;
          if (!int_reg_operand (operands[5], E_SImode))
            return NULL;
          x9 = XEXP (x8, 1);
          operands[6] = x9;
          if (!reg_or_cint_operand (operands[6], E_SImode)
              || !
#line 6343 "../../gcc/config/rs6000/vsx.md"
(TARGET_DIRECT_MOVE_64BIT
   /* The REG_P (xxx) tests prevents SUBREG's, which allows us to use REGNO
      to compare registers, when the mode is different.  */
   && REG_P (operands[SFBOOL_MFVSR_D]) && REG_P (operands[SFBOOL_BOOL_D])
   && REG_P (operands[SFBOOL_BOOL_A1]) && REG_P (operands[SFBOOL_SHL_D])
   && REG_P (operands[SFBOOL_SHL_A])   && REG_P (operands[SFBOOL_MTVSR_D])
   && (REG_P (operands[SFBOOL_BOOL_A2])
       || CONST_INT_P (operands[SFBOOL_BOOL_A2]))
   && (REGNO (operands[SFBOOL_BOOL_D]) == REGNO (operands[SFBOOL_MFVSR_D])
       || peep2_reg_dead_p (2, operands[SFBOOL_MFVSR_D]))
   && (REGNO (operands[SFBOOL_MFVSR_D]) == REGNO (operands[SFBOOL_BOOL_A1])
       || (REG_P (operands[SFBOOL_BOOL_A2])
	   && REGNO (operands[SFBOOL_MFVSR_D])
		== REGNO (operands[SFBOOL_BOOL_A2])))
   && REGNO (operands[SFBOOL_BOOL_D]) == REGNO (operands[SFBOOL_SHL_A])
   && (REGNO (operands[SFBOOL_SHL_D]) == REGNO (operands[SFBOOL_BOOL_D])
       || peep2_reg_dead_p (3, operands[SFBOOL_BOOL_D]))
   && peep2_reg_dead_p (4, operands[SFBOOL_SHL_D])))
            return NULL;
          *pmatch_len_ = 3;
          return gen_peephole2_40 (insn, operands);

        case XOR:
          x10 = XEXP (x8, 0);
          operands[5] = x10;
          if (!int_reg_operand (operands[5], E_SImode))
            return NULL;
          x9 = XEXP (x8, 1);
          operands[6] = x9;
          if (!reg_or_cint_operand (operands[6], E_SImode)
              || !
#line 6343 "../../gcc/config/rs6000/vsx.md"
(TARGET_DIRECT_MOVE_64BIT
   /* The REG_P (xxx) tests prevents SUBREG's, which allows us to use REGNO
      to compare registers, when the mode is different.  */
   && REG_P (operands[SFBOOL_MFVSR_D]) && REG_P (operands[SFBOOL_BOOL_D])
   && REG_P (operands[SFBOOL_BOOL_A1]) && REG_P (operands[SFBOOL_SHL_D])
   && REG_P (operands[SFBOOL_SHL_A])   && REG_P (operands[SFBOOL_MTVSR_D])
   && (REG_P (operands[SFBOOL_BOOL_A2])
       || CONST_INT_P (operands[SFBOOL_BOOL_A2]))
   && (REGNO (operands[SFBOOL_BOOL_D]) == REGNO (operands[SFBOOL_MFVSR_D])
       || peep2_reg_dead_p (2, operands[SFBOOL_MFVSR_D]))
   && (REGNO (operands[SFBOOL_MFVSR_D]) == REGNO (operands[SFBOOL_BOOL_A1])
       || (REG_P (operands[SFBOOL_BOOL_A2])
	   && REGNO (operands[SFBOOL_MFVSR_D])
		== REGNO (operands[SFBOOL_BOOL_A2])))
   && REGNO (operands[SFBOOL_BOOL_D]) == REGNO (operands[SFBOOL_SHL_A])
   && (REGNO (operands[SFBOOL_SHL_D]) == REGNO (operands[SFBOOL_BOOL_D])
       || peep2_reg_dead_p (3, operands[SFBOOL_BOOL_D]))
   && peep2_reg_dead_p (4, operands[SFBOOL_SHL_D])))
            return NULL;
          *pmatch_len_ = 3;
          return gen_peephole2_41 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
