/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (GET_MODE (x3) != E_SFmode)
            return -1;
          return 0;

        case E_DFmode:
          if (GET_MODE (x3) != E_DFmode)
            return -1;
          return 1;

        case E_KFmode:
          if (pattern1 (x3, 
E_KFmode) != 0)
            return -1;
          return 2;

        case E_TFmode:
          if (pattern1 (x3, 
E_TFmode) != 0)
            return -1;
          return 3;

        case E_V4SFmode:
          if (GET_MODE (x3) != E_V4SFmode)
            return -1;
          return 4;

        case E_V2DFmode:
          if (pattern2 (x3, 
E_V2DFmode) != 0)
            return -1;
          return 5;

        case E_V4SImode:
          if (pattern3 (x3, 
E_V4SImode) != 0)
            return -1;
          return 6;

        case E_V8HImode:
          if (pattern3 (x3, 
E_V8HImode) != 0)
            return -1;
          return 7;

        case E_V16QImode:
          if (pattern3 (x3, 
E_V16QImode) != 0)
            return -1;
          return 8;

        case E_V2DImode:
          if (pattern3 (x3, 
E_V2DImode) != 0)
            return -1;
          return 9;

        default:
          return -1;
        }

    case VEC_CONCAT:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_V2DFmode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != VEC_SELECT
          || GET_MODE (x6) != E_DFmode)
        return -1;
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != PARALLEL
          || XVECLEN (x7, 0) != 1)
        return -1;
      x8 = XVECEXP (x7, 0, 0);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x4, 1);
      if (GET_CODE (x9) != VEC_SELECT
          || GET_MODE (x9) != E_DFmode)
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != PARALLEL
          || XVECLEN (x10, 0) != 1)
        return -1;
      x11 = XVECEXP (x10, 0, 0);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern4 (x3) != 0)
        return -1;
      return 10;

    case UNSPEC:
      if (pnum_clobbers == NULL
          || XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != 102
          || GET_MODE (x4) != E_V4SFmode)
        return -1;
      x12 = XVECEXP (x4, 0, 0);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !vfloat_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode)
        return -1;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      if (!vfloat_operand (operands[1], E_V4SFmode))
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern47 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern60 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case NOT:
      x6 = XEXP (x5, 0);
      operands[0] = x6;
      x7 = XEXP (x4, 1);
      switch (GET_CODE (x7))
        {
        case NOT:
          return pattern48 (x3); /* [-1, 23] */

        case REG:
        case SUBREG:
          res = pattern54 (x3);
          if (res >= 0)
            return res + 24; /* [24, 47] */
          return -1;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      res = pattern59 (x3);
      if (res >= 0)
        return res + 48; /* [48, 71] */
      return -1;

    default:
      return -1;
    }
}

int
pattern67 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || !small_toc_ref (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || !small_toc_ref (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern73 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !const_int_operand (operands[2], E_QImode))
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (!gpc_reg_operand (operands[1], E_V16QImode)
          || !scratch_operand (operands[3], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!gpc_reg_operand (operands[1], E_V8HImode)
          || !scratch_operand (operands[3], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_V4SImode)
          || !scratch_operand (operands[3], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern83 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern85 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !vector_shift_constant (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern90 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern100 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x7;
      x8 = XEXP (x2, 0);
      operands[2] = x8;
      if (!scratch_operand (operands[2], E_DImode))
        return -1;
      x9 = XEXP (x3, 0);
      operands[3] = x9;
      if (!scratch_operand (operands[3], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          return pattern97 (x6, 
E_SFmode); /* [-1, 1] */

        case E_DFmode:
          res = pattern97 (x6, 
E_DFmode);
          if (res >= 0)
            return res + 2; /* [2, 3] */
          return -1;

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      res = pattern98 (x1);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    case VEC_SELECT:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      res = pattern99 (x1);
      if (res >= 0)
        return res + 6; /* [6, 9] */
      return -1;

    default:
      return -1;
    }
}

int
pattern114 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  return pattern113 (x1); /* [-1, 3] */
}

int
pattern117 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XEXP (x3, 0);
  operands[0] = x5;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_CODE (operands[0]))
    {
    case SYMBOL_REF:
      return 0;

    case UNSPEC:
    case REG:
      return 1;

    default:
      return -1;
    }
}

int
pattern128 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode))
        return -1;
      return pattern127 (x1, 
E_SImode); /* [-1, 1] */

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode))
        return -1;
      res = pattern127 (x1, 
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern139 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!vsx_register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!vsx_register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!vsx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern147 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern152 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_XOmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!fpr_reg_operand (operands[0], E_XOmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!vsx_register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!vsx_register_operand (operands[2], E_V16QImode))
    return -1;
  return 0;
}

int
pattern162 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_V16QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern142 (x3, 
E_V4SImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern142 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern142 (x3, 
E_V16QImode) != 0)
        return -1;
      return 2;

    case E_V4SFmode:
      if (pattern142 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 3;

    case E_V2DFmode:
      if (pattern142 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 4;

    case E_V2DImode:
      if (pattern142 (x3, 
E_V2DImode) != 0)
        return -1;
      return 5;

    case E_V1TImode:
      if (pattern142 (x3, 
E_V1TImode) != 0)
        return -1;
      return 6;

    case E_TImode:
      if (pattern142 (x3, 
E_TImode) != 0)
        return -1;
      return 7;

    case E_KFmode:
      if (pattern142 (x3, 
E_KFmode) != 0)
        return -1;
      return 8;

    case E_TFmode:
      if (pattern142 (x3, 
E_TFmode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern175 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  operands[3] = x5;
  if (!cc_reg_operand (operands[3], E_CCmode)
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  if (!reg_or_cint_operand (operands[2], E_SImode))
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x9))
    {
    case CLOBBER:
      return pattern170 (x1); /* [-1, 1] */

    case SET:
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != i1)
        return -1;
      res = pattern174 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern184 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern190 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  x8 = XEXP (x3, 1);
  operands[2] = x8;
  x9 = XEXP (x5, 0);
  operands[3] = x9;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  switch (GET_CODE (operands[1]))
    {
    case SYMBOL_REF:
      return 0;

    case UNSPEC:
    case REG:
      return 1;

    default:
      return -1;
    }
}

int
pattern198 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern197 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern197 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern209 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern208 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern208 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern219 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V16QImode
      || !altivec_register_operand (operands[0], E_V16QImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern223 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  return 0;
}

int
pattern230 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x3 = XEXP (x1, 1);
  return pattern229 (x3, 
i1); /* [-1, 0] */
}

int
pattern235 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern242 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern250 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != LABEL_REF)
    return -1;
  x7 = XEXP (x3, 2);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_CODE (x8) != PC)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x9) != SET)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != PLUS
      || GET_MODE (x10) != E_DImode)
    return -1;
  x11 = XEXP (x10, 1);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  x12 = XEXP (x4, 0);
  operands[1] = x12;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x13 = XEXP (x6, 0);
  operands[0] = x13;
  x14 = XEXP (x9, 0);
  operands[2] = x14;
  if (!nonimmediate_operand (operands[2], E_DImode))
    return -1;
  x15 = XEXP (x10, 0);
  if (!rtx_equal_p (x15, operands[1]))
    return -1;
  return 0;
}

int
pattern262 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern268 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern266 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern266 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern267 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern267 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern267 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern267 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern267 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern267 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern267 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern267 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern267 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern267 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern283 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != i1
      || GET_MODE (x4) != E_SImode
      || !gpc_reg_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || GET_MODE (x2) != E_SImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!gpc_reg_operand (operands[1], E_HImode))
    return -1;
  x6 = XEXP (x4, 0);
  operands[2] = x6;
  if (!gpc_reg_operand (operands[2], E_HImode)
      || !gpc_reg_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern296 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!reg_or_indexed_operand (operands[1], E_QImode)
          || !scratch_operand (operands[4], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!reg_or_indexed_operand (operands[1], E_HImode)
          || !scratch_operand (operands[4], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern305 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern316 (int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_DImode:
      if (!altivec_register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (pnum_clobbers == NULL
          || !nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_QImode:
      if (pnum_clobbers == NULL
          || !nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 2;

    case E_HImode:
      if (pnum_clobbers == NULL
          || !nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern330 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_DImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!scratch_operand (operands[3], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !memory_operand (operands[1], E_V2DFmode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !memory_operand (operands[1], E_V2DImode))
        return -1;
      return 1;

    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !memory_operand (operands[1], E_V4SFmode))
        return -1;
      return 2;

    case E_QImode:
      if (!gpc_reg_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode
          || !memory_operand (operands[1], E_V16QImode))
        return -1;
      return 3;

    case E_HImode:
      if (!gpc_reg_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !memory_operand (operands[1], E_V8HImode))
        return -1;
      return 4;

    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !memory_operand (operands[1], E_V4SImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern354 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x2, 2);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern365 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DDmode:
      if (!gpc_reg_operand (operands[0], E_DDmode)
          || GET_MODE (x1) != E_DDmode
          || !gpc_reg_operand (operands[2], E_DDmode))
        return -1;
      return 0;

    case E_TDmode:
      if (!gpc_reg_operand (operands[0], E_TDmode)
          || GET_MODE (x1) != E_TDmode
          || !gpc_reg_operand (operands[2], E_TDmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern378 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x1, 1);
  return pattern373 (x5, 
i1); /* [-1, 0] */
}

int
pattern386 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern391 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern182 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern182 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern228 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern228 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern228 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern228 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern228 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern228 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern228 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern228 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern228 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern228 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern408 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern414 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DImode)
      || GET_MODE (x1) != E_V2DImode
      || !register_operand (operands[1], E_V2DImode)
      || !register_operand (operands[2], E_V2DImode)
      || !register_operand (operands[3], E_V2DImode))
    return -1;
  return 0;
}

int
pattern420 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != i1
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != MULT
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != i1
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_CODE (x10) != i1
      || GET_MODE (x10) != E_SImode
      || GET_MODE (x4) != E_SImode)
    return -1;
  x11 = XEXP (x5, 0);
  operands[1] = x11;
  if (!gpc_reg_operand (operands[1], E_HImode))
    return -1;
  x12 = XEXP (x6, 0);
  operands[2] = x12;
  if (!gpc_reg_operand (operands[2], E_HImode))
    return -1;
  x13 = XEXP (x7, 0);
  operands[0] = x13;
  if (!gpc_reg_operand (operands[0], E_SImode))
    return -1;
  x14 = XEXP (x9, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  x15 = XEXP (x10, 0);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  return 0;
}

int
pattern438 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !altivec_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern446 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern453 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !exact_log2_cint_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern461 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case CLOBBER:
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      x6 = XEXP (x5, 0);
      switch (GET_MODE (x6))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[2], E_SImode)
              || !gpc_reg_operand (operands[1], E_SImode)
              || !scratch_operand (operands[0], E_SImode))
            return -1;
          return 0;

        case E_DImode:
          if (!gpc_reg_operand (operands[2], E_DImode)
              || !gpc_reg_operand (operands[1], E_DImode)
              || !scratch_operand (operands[0], E_DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case SET:
      x7 = XEXP (x2, 1);
      if (GET_CODE (x7) != MINUS)
        return -1;
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      x8 = XEXP (x7, 0);
      if (!rtx_equal_p (x8, operands[2]))
        return -1;
      x9 = XEXP (x7, 1);
      if (!rtx_equal_p (x9, operands[1]))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      x6 = XEXP (x5, 0);
      switch (GET_MODE (x6))
        {
        case E_SImode:
          if (pattern460 (x7, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_DImode:
          if (pattern460 (x7, 
E_DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern484 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      return 0;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode))
        return -1;
      return 1;

    case E_KFmode:
      if (!register_operand (operands[0], E_KFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern493 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern499 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern508 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern290 (x1, 
E_SFmode); /* [-1, 1] */

    case E_DFmode:
      res = pattern290 (x1, 
E_DFmode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case E_KFmode:
      if (pattern291 (x1, 
E_KFmode) != 0)
        return -1;
      return 4;

    case E_TFmode:
      if (pattern291 (x1, 
E_TFmode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern519 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern530 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      return pattern529 (x6, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (pattern529 (x6, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern543 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x2, 0);
  if (!rtx_equal_p (x3, operands[3]))
    return -1;
  return 0;
}

int
pattern553 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      operands[4] = x2;
      if (!altivec_register_operand (operands[4], E_V4SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_V4SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != PLUS
          || GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (!gpc_reg_operand (operands[2], E_DImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      if (!short_cint_operand (operands[3], E_DImode))
        return -1;
      return 0;

    case MEM:
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != PLUS
          || GET_MODE (x7) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[2] = x3;
      if (!altivec_register_operand (operands[2], E_V4SImode))
        return -1;
      x8 = XEXP (x7, 0);
      operands[3] = x8;
      if (!gpc_reg_operand (operands[3], E_DImode))
        return -1;
      x9 = XEXP (x7, 1);
      operands[4] = x9;
      if (!short_cint_operand (operands[4], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (scc_rev_comparison_operator (operands[1], E_VOIDmode))
    {
      res = recog_9 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (GET_CODE (x3) != NE)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[3] = x6;
      x7 = XEXP (x1, 0);
      operands[0] = x7;
      if (!zero_constant (operands[2], E_V2DImode))
        return -1;
      x8 = XEXP (x2, 2);
      operands[4] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern476 (x2, 
E_SFmode) != 0
              || !
#line 5742 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
            return -1;
          return 380; /* *xxselsf */

        case E_DFmode:
          if (pattern476 (x2, 
E_DFmode) != 0
              || !
#line 5742 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
            return -1;
          return 381; /* *xxseldf */

        case E_KFmode:
          if (pattern477 (x2, 
E_KFmode) != 0
              || !(
#line 5848 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 388; /* *xxselkf */

        case E_TFmode:
          if (pattern477 (x2, 
E_TFmode) != 0
              || !(
#line 5848 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 389; /* *xxseltf */

        default:
          return -1;
        }

    case LABEL_REF:
      if (pnum_clobbers == NULL)
        return -1;
      x8 = XEXP (x2, 2);
      if (GET_CODE (x8) != PC)
        return -1;
      x7 = XEXP (x1, 0);
      if (GET_CODE (x7) != PC
          || !gpc_reg_operand (operands[1], E_DImode)
          || !const_int_operand (operands[2], E_DImode))
        return -1;
      x9 = XEXP (x6, 0);
      operands[0] = x9;
      if (!
#line 7954 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && num_insns_constant (operands[2], DImode) > 1
   && (can_be_rotated_to_positive_16bits (INTVAL (operands[2]))
       || can_be_rotated_to_negative_15bits (INTVAL (operands[2])))))
        return -1;
      *pnum_clobbers = 2;
      return 562; /* *rotate_on_cmpdi */

    default:
      return -1;
    }
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_CODE (operands[2]))
        {
        case CONST_INT:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!gpc_reg_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !gpc_reg_operand (operands[1], E_SImode))
                return -1;
              if (pnum_clobbers != NULL
                  && logical_const_operand (operands[2], E_SImode)
                  && 
#line 3642 "../../gcc/config/rs6000/rs6000.md"
(!rs6000_is_valid_and_mask (operands[2], SImode)))
                {
                  *pnum_clobbers = 1;
                  return 188; /* andsi3_imm */
                }
              if (!const_int_operand (operands[2], E_SImode))
                return -1;
              if (
#line 3773 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_and_mask (operands[2], SImode)))
                return 200; /* andsi3_mask */
              if (!
#line 3840 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_2insn_and (operands[2], SImode)
   && !(rs6000_is_valid_and_mask (operands[2], SImode)
	|| logical_const_operand (operands[2], SImode))))
                return -1;
              return 206; /* *andsi3_2insn */

            case E_DImode:
              if (!gpc_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !gpc_reg_operand (operands[1], E_DImode))
                return -1;
              if (pnum_clobbers != NULL
                  && logical_const_operand (operands[2], E_DImode)
                  && (
#line 3642 "../../gcc/config/rs6000/rs6000.md"
(!rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                {
                  *pnum_clobbers = 1;
                  return 189; /* anddi3_imm */
                }
              if (!const_int_operand (operands[2], E_DImode))
                return -1;
              if ((
#line 3773 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return 201; /* anddi3_mask */
              if (!(
#line 3840 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_2insn_and (operands[2], DImode)
   && !(rs6000_is_valid_and_mask (operands[2], DImode)
	|| logical_const_operand (operands[2], DImode))) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 207; /* *anddi3_2insn */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_TImode:
              if (pattern355 (x2, 
E_TImode) != 0)
                return -1;
              return 496; /* *andti3_internal */

            case E_PTImode:
              if (pattern355 (x2, 
E_PTImode) != 0)
                return -1;
              return 497; /* *andpti3_internal */

            case E_V16QImode:
              if (pattern355 (x2, 
E_V16QImode) != 0
                  || !
#line 778 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
                return -1;
              return 498; /* *andv16qi3_internal */

            case E_V8HImode:
              if (pattern355 (x2, 
E_V8HImode) != 0
                  || !
#line 779 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
                return -1;
              return 499; /* *andv8hi3_internal */

            case E_V4SImode:
              if (pattern355 (x2, 
E_V4SImode) != 0
                  || !
#line 780 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
                return -1;
              return 500; /* *andv4si3_internal */

            case E_V4SFmode:
              if (pattern355 (x2, 
E_V4SFmode) != 0
                  || !
#line 781 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
                return -1;
              return 501; /* *andv4sf3_internal */

            case E_V2DImode:
              if (pattern355 (x2, 
E_V2DImode) != 0
                  || !
#line 782 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
                return -1;
              return 502; /* *andv2di3_internal */

            case E_V2DFmode:
              if (pattern355 (x2, 
E_V2DFmode) != 0
                  || !
#line 783 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
                return -1;
              return 503; /* *andv2df3_internal */

            case E_V1TImode:
              if (pattern355 (x2, 
E_V1TImode) != 0
                  || !
#line 784 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
                return -1;
              return 504; /* *andv1ti3_internal */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
    case ROTATE:
    case LSHIFTRT:
      operands[4] = x3;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      if (!reg_or_cint_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern435 (x2, 
E_SImode) != 0
              || !
#line 4182 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_shift_mask (operands[3], operands[4], SImode)))
            return -1;
          return 235; /* *rotlsi3_mask */

        case E_DImode:
          if (pattern435 (x2, 
E_DImode) != 0
              || !(
#line 4182 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_shift_mask (operands[3], operands[4], DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 236; /* *rotldi3_mask */

        default:
          return -1;
        }

    case PLUS:
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
          if (XWINT (x5, 0) != -16L)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || GET_MODE (x3) != E_DImode)
            return -1;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          if (!gpc_reg_operand (operands[1], E_DImode))
            return -1;
          x7 = XEXP (x3, 1);
          operands[2] = x7;
          if (!reg_or_cint_operand (operands[2], E_DImode)
              || !(
#line 9532 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC && reload_completed) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 630; /* *vec_reload_and_plus_di */

        case REG:
        case SUBREG:
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x5;
          x4 = XEXP (x1, 0);
          operands[3] = x4;
          switch (pattern38 (x2))
            {
            case 0:
              if (!
#line 511 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2390; /* *fuse_add_and */

            case 1:
              if (!(
#line 511 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2391; /* *fuse_add_and */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      return recog_16 (x1, insn, pnum_clobbers);

    case NOT:
      return recog_15 (x1, insn, pnum_clobbers);

    case IOR:
      switch (pattern60 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 421 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2380; /* *fuse_nand_and */

        case 1:
          if (!(
#line 421 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2381; /* *fuse_nand_and */

        case 2:
          if (!
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2572; /* *fuse_vnand_vand */

        case 3:
          if (!
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2573; /* *fuse_vnand_vand */

        case 4:
          if (!
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2574; /* *fuse_vnand_vand */

        case 5:
          if (!
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2575; /* *fuse_vnand_vand */

        case 6:
          if (!
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2576; /* *fuse_vnand_vand */

        case 7:
          if (!
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2577; /* *fuse_vnand_vand */

        case 8:
          if (!
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2578; /* *fuse_vnand_vand */

        case 9:
          if (!
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2579; /* *fuse_vnand_vand */

        case 10:
          if (!(
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2580; /* *fuse_vnand_vand */

        case 11:
          if (!(
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2581; /* *fuse_vnand_vand */

        case 12:
          if (!
#line 601 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2400; /* *fuse_nand_andc */

        case 13:
          if (!(
#line 601 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2401; /* *fuse_nand_andc */

        case 14:
          if (!
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2652; /* *fuse_vnand_vandc */

        case 15:
          if (!
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2653; /* *fuse_vnand_vandc */

        case 16:
          if (!
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2654; /* *fuse_vnand_vandc */

        case 17:
          if (!
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2655; /* *fuse_vnand_vandc */

        case 18:
          if (!
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2656; /* *fuse_vnand_vandc */

        case 19:
          if (!
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2657; /* *fuse_vnand_vandc */

        case 20:
          if (!
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2658; /* *fuse_vnand_vandc */

        case 21:
          if (!
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2659; /* *fuse_vnand_vandc */

        case 22:
          if (!(
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2660; /* *fuse_vnand_vandc */

        case 23:
          if (!(
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2661; /* *fuse_vnand_vandc */

        case 24:
          if (!
#line 475 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2386; /* *fuse_orc_and */

        case 25:
          if (!(
#line 475 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2387; /* *fuse_orc_and */

        case 26:
          if (!
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2602; /* *fuse_vorc_vand */

        case 27:
          if (!
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2603; /* *fuse_vorc_vand */

        case 28:
          if (!
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2604; /* *fuse_vorc_vand */

        case 29:
          if (!
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2605; /* *fuse_vorc_vand */

        case 30:
          if (!
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2606; /* *fuse_vorc_vand */

        case 31:
          if (!
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2607; /* *fuse_vorc_vand */

        case 32:
          if (!
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2608; /* *fuse_vorc_vand */

        case 33:
          if (!
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2609; /* *fuse_vorc_vand */

        case 34:
          if (!(
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2610; /* *fuse_vorc_vand */

        case 35:
          if (!(
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2611; /* *fuse_vorc_vand */

        case 36:
          if (!
#line 655 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2406; /* *fuse_orc_andc */

        case 37:
          if (!(
#line 655 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2407; /* *fuse_orc_andc */

        case 38:
          if (!
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2682; /* *fuse_vorc_vandc */

        case 39:
          if (!
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2683; /* *fuse_vorc_vandc */

        case 40:
          if (!
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2684; /* *fuse_vorc_vandc */

        case 41:
          if (!
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2685; /* *fuse_vorc_vandc */

        case 42:
          if (!
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2686; /* *fuse_vorc_vandc */

        case 43:
          if (!
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2687; /* *fuse_vorc_vandc */

        case 44:
          if (!
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2688; /* *fuse_vorc_vandc */

        case 45:
          if (!
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2689; /* *fuse_vorc_vandc */

        case 46:
          if (!(
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2690; /* *fuse_vorc_vandc */

        case 47:
          if (!(
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2691; /* *fuse_vorc_vandc */

        case 48:
          if (!
#line 457 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2384; /* *fuse_or_and */

        case 49:
          if (!(
#line 457 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2385; /* *fuse_or_and */

        case 50:
          if (!
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2592; /* *fuse_vor_vand */

        case 51:
          if (!
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2593; /* *fuse_vor_vand */

        case 52:
          if (!
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2594; /* *fuse_vor_vand */

        case 53:
          if (!
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2595; /* *fuse_vor_vand */

        case 54:
          if (!
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2596; /* *fuse_vor_vand */

        case 55:
          if (!
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2597; /* *fuse_vor_vand */

        case 56:
          if (!
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2598; /* *fuse_vor_vand */

        case 57:
          if (!
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2599; /* *fuse_vor_vand */

        case 58:
          if (!(
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2600; /* *fuse_vor_vand */

        case 59:
          if (!(
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2601; /* *fuse_vor_vand */

        case 60:
          if (!
#line 637 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2404; /* *fuse_or_andc */

        case 61:
          if (!(
#line 637 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2405; /* *fuse_or_andc */

        case 62:
          if (!
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2672; /* *fuse_vor_vandc */

        case 63:
          if (!
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2673; /* *fuse_vor_vandc */

        case 64:
          if (!
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2674; /* *fuse_vor_vandc */

        case 65:
          if (!
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2675; /* *fuse_vor_vandc */

        case 66:
          if (!
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2676; /* *fuse_vor_vandc */

        case 67:
          if (!
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2677; /* *fuse_vor_vandc */

        case 68:
          if (!
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2678; /* *fuse_vor_vandc */

        case 69:
          if (!
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2679; /* *fuse_vor_vandc */

        case 70:
          if (!(
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2680; /* *fuse_vor_vandc */

        case 71:
          if (!(
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2681; /* *fuse_vor_vandc */

        default:
          return -1;
        }

    case XOR:
      switch (pattern61 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 493 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2388; /* *fuse_xor_and */

        case 1:
          if (!(
#line 493 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2389; /* *fuse_xor_and */

        case 2:
          if (!
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2612; /* *fuse_vxor_vand */

        case 3:
          if (!
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2613; /* *fuse_vxor_vand */

        case 4:
          if (!
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2614; /* *fuse_vxor_vand */

        case 5:
          if (!
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2615; /* *fuse_vxor_vand */

        case 6:
          if (!
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2616; /* *fuse_vxor_vand */

        case 7:
          if (!
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2617; /* *fuse_vxor_vand */

        case 8:
          if (!
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2618; /* *fuse_vxor_vand */

        case 9:
          if (!
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2619; /* *fuse_vxor_vand */

        case 10:
          if (!(
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2620; /* *fuse_vxor_vand */

        case 11:
          if (!(
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2621; /* *fuse_vxor_vand */

        case 12:
          if (!
#line 673 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2408; /* *fuse_xor_andc */

        case 13:
          if (!(
#line 673 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2409; /* *fuse_xor_andc */

        case 14:
          if (!
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2692; /* *fuse_vxor_vandc */

        case 15:
          if (!
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2693; /* *fuse_vxor_vandc */

        case 16:
          if (!
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2694; /* *fuse_vxor_vandc */

        case 17:
          if (!
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2695; /* *fuse_vxor_vandc */

        case 18:
          if (!
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2696; /* *fuse_vxor_vandc */

        case 19:
          if (!
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2697; /* *fuse_vxor_vandc */

        case 20:
          if (!
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2698; /* *fuse_vxor_vandc */

        case 21:
          if (!
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2699; /* *fuse_vxor_vandc */

        case 22:
          if (!(
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2700; /* *fuse_vxor_vandc */

        case 23:
          if (!(
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2701; /* *fuse_vxor_vandc */

        default:
          return -1;
        }

    case MINUS:
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern122 (x1))
        {
        case 0:
          if (!
#line 529 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2392; /* *fuse_subf_and */

        case 1:
          if (!(
#line 529 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2393; /* *fuse_subf_and */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_41 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!u7bit_cint_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!vsx_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 5497 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1578; /* xvtstdcsp */

    case E_V2DImode:
      if (!vsx_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !vsx_register_operand (operands[1], E_V2DFmode)
          || !
#line 5497 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1579; /* xvtstdcdp */

    default:
      return -1;
    }
}

 int
recog_47 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (pattern142 (x3, 
E_V2DImode) != 0
          || !
#line 2045 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1905; /* altivec_vrldnm */

    case E_V4SImode:
      if (pattern142 (x3, 
E_V4SImode) != 0
          || !
#line 2045 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1906; /* altivec_vrlwnm */

    case E_V1TImode:
      if (pattern133 (x3, 
E_V1TImode) != 0
          || !
#line 2069 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
        return -1;
      return 1907; /* altivec_vrlqnm_inst */

    default:
      return -1;
    }
}

 int
recog_55 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2DFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!vsx_register_operand (operands[0], E_V2DFmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!vsx_register_operand (operands[1], E_SFmode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!vsx_register_operand (operands[2], E_SFmode)
      || !
#line 3232 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
    return -1;
  return 1351; /* vsx_concat_v2sf */
}

 int
recog_62 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DFmode
      || !register_operand (operands[0], E_DFmode))
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[1]))
    {
    case E_TImode:
      if (!register_operand (operands[1], E_TImode)
          || !
#line 9714 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 663; /* p8_mfvsrd_3_ti */

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode)
          || !
#line 9714 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 664; /* p8_mfvsrd_3_v16qi */

    case E_V8HImode:
      if (!register_operand (operands[1], E_V8HImode)
          || !
#line 9714 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 665; /* p8_mfvsrd_3_v8hi */

    case E_V4SImode:
      if (!register_operand (operands[1], E_V4SImode)
          || !
#line 9714 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 666; /* p8_mfvsrd_3_v4si */

    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SFmode)
          || !
#line 9714 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 667; /* p8_mfvsrd_3_v4sf */

    case E_V2DImode:
      if (!register_operand (operands[1], E_V2DImode)
          || !
#line 9714 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 668; /* p8_mfvsrd_3_v2di */

    case E_V2DFmode:
      if (!register_operand (operands[1], E_V2DFmode)
          || !
#line 9714 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 669; /* p8_mfvsrd_3_v2df */

    case E_V1TImode:
      if (!register_operand (operands[1], E_V1TImode)
          || !
#line 9714 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 670; /* p8_mfvsrd_3_v1ti */

    case E_KFmode:
      if (!register_operand (operands[1], E_KFmode)
          || !(
#line 9714 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 560 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))))
        return -1;
      return 671; /* p8_mfvsrd_3_kf */

    case E_TFmode:
      if (!register_operand (operands[1], E_TFmode)
          || !(
#line 9714 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 561 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))))
        return -1;
      return 672; /* p8_mfvsrd_3_tf */

    default:
      return -1;
    }
}

 int
recog_75 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern211 (x2))
    {
    case 0:
      if (!
#line 5162 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FRES))
        return -1;
      return 311; /* fres */

    case 1:
      if (!
#line 5162 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FRE))
        return -1;
      return 312; /* fred */

    case 2:
      if (vsx_register_operand (operands[0], E_V4SFmode)
          && vsx_register_operand (operands[1], E_V4SFmode)
          && 
#line 1977 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return 1242; /* vsx_frev4sf2 */
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 2659 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
        return -1;
      return 1996; /* altivec_vrefp */

    case 3:
      if (!
#line 1977 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1243; /* vsx_frev2df2 */

    default:
      return -1;
    }
}

 int
recog_84 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || !gpc_reg_operand (operands[1], E_SImode)
          || !
#line 2523 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTB))
        return -1;
      return 126; /* popcntbsi2 */

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode
          || !gpc_reg_operand (operands[1], E_DImode)
          || !(
#line 2523 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTB) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
        return -1;
      return 127; /* popcntbdi2 */

    default:
      return -1;
    }
}

 int
recog_92 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern319 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 6804 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_POPCNTD))
            return -1;
          return 464; /* *lrintsfsi */

        case 1:
          if (!
#line 6804 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_POPCNTD))
            return -1;
          return 465; /* *lrintdfsi */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern319 (x2, 
E_DImode))
        {
        case 0:
          if (!
#line 6812 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && !TARGET_POPCNTD))
            return -1;
          return 466; /* lrintsfsi_di */

        case 1:
          if (!
#line 6812 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && !TARGET_POPCNTD))
            return -1;
          return 467; /* lrintdfsi_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_102 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern162 (x1))
    {
    case 0:
      if (!
#line 2562 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1976; /* *altivec_vpermr_v4si_internal */

    case 1:
      if (!
#line 2562 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1977; /* *altivec_vpermr_v8hi_internal */

    case 2:
      if (!
#line 2562 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1978; /* *altivec_vpermr_v16qi_internal */

    case 3:
      if (!
#line 2562 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1979; /* *altivec_vpermr_v4sf_internal */

    case 4:
      if (!
#line 2562 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1980; /* *altivec_vpermr_v2df_internal */

    case 5:
      if (!
#line 2562 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1981; /* *altivec_vpermr_v2di_internal */

    case 6:
      if (!
#line 2562 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1982; /* *altivec_vpermr_v1ti_internal */

    case 7:
      if (!
#line 2562 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1983; /* *altivec_vpermr_ti_internal */

    case 8:
      if (!(
#line 2562 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
        return -1;
      return 1984; /* *altivec_vpermr_kf_internal */

    case 9:
      if (!(
#line 2562 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
        return -1;
      return 1985; /* *altivec_vpermr_tf_internal */

    default:
      return -1;
    }
}

 int
recog_109 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (maybe_ne (SUBREG_BYTE (x2), 0)
      || GET_MODE (x2) != E_V1TImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT
      || GET_MODE (x3) != E_V2DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SUBREG
      || maybe_ne (SUBREG_BYTE (x4), 0)
      || GET_MODE (x4) != E_V2DImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 2)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x7 = XVECEXP (x5, 0, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !vsx_register_operand (operands[0], E_V1TImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[1] = x8;
  if (!vsx_register_operand (operands[1], E_V1TImode)
      || !
#line 3348 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
    return -1;
  return 1360; /* xxswapd_v1ti */
}

 int
recog_112 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!gpc_reg_operand (operands[0], E_DImode))
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case UNSPEC:
      switch (XVECLEN (x4, 0))
        {
        case 2:
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x4, 0, 1);
          operands[2] = x6;
          switch (XINT (x4, 1))
            {
            case 14:
              if (GET_MODE (x4) != E_DImode
                  || !rs6000_tls_symbol_ref (operands[1], E_DImode)
                  || !gpc_reg_operand (operands[2], E_DImode)
                  || !(
#line 10598 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 735; /* *tls_gd_high64 */

            case 23:
              if (GET_MODE (x4) != E_DImode
                  || !gpc_reg_operand (operands[1], E_DImode)
                  || !rs6000_tls_symbol_ref (operands[2], E_DImode)
                  || !(
#line 10711 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 745; /* *tls_got_dtprel_high64 */

            case 27:
              if (GET_MODE (x4) != E_DImode
                  || !gpc_reg_operand (operands[1], E_DImode)
                  || !rs6000_tls_symbol_ref (operands[2], E_DImode)
                  || !(
#line 10791 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 752; /* *tls_got_tprel_high64 */

            case 47:
              if (!gpc_reg_operand (operands[2], E_DImode)
                  || !
#line 11286 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL))
                return -1;
              return 764; /* *largetoc_high */

            default:
              return -1;
            }

        case 1:
          if (XINT (x4, 1) != 15
              || GET_MODE (x4) != E_DImode)
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          if (!gpc_reg_operand (operands[1], E_DImode)
              || !(
#line 10644 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 739; /* *tls_ld_high64 */

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x7 = XEXP (x4, 0);
      if (GET_CODE (x7) != UNSPEC
          || XVECLEN (x7, 0) != 2
          || XINT (x7, 1) != 47)
        return -1;
      x8 = XVECEXP (x7, 0, 0);
      operands[1] = x8;
      x9 = XVECEXP (x7, 0, 1);
      operands[2] = x9;
      if (!gpc_reg_operand (operands[2], E_DImode))
        return -1;
      x10 = XEXP (x4, 1);
      operands[3] = x10;
      if (!add_cint_operand (operands[3], E_DImode)
          || !
#line 11306 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL))
        return -1;
      return 765; /* *largetoc_high_plus */

    default:
      return -1;
    }
}

 int
recog_114 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
      operands[1] = x4;
      if (s8bit_cint_operand (operands[1], E_SImode)
          && vsx_register_operand (operands[0], E_V16QImode)
          && GET_MODE (x3) == E_V16QImode
          && 
#line 1146 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return 1171; /* xxspltib_v16qi */
      if (!s5bit_cint_operand (operands[1], E_QImode)
          || !register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !
#line 2461 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1953; /* altivec_vspltisb */

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (!vsx_register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode)
            return -1;
          if (gpc_reg_operand (operands[1], E_DFmode)
              && 
#line 4787 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
            return 1495; /* vsx_splat_v2df_reg */
          if (!memory_operand (operands[1], E_DFmode)
              || !
#line 4797 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
            return -1;
          return 1497; /* vsx_splat_v2df_mem */

        case E_V4SFmode:
          if (!vsx_register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !splat_input_operand (operands[1], E_SFmode)
              || !
#line 4832 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1501; /* vsx_splat_v4sf */

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XVECEXP (x5, 0, 0);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (GET_MODE (x3) != E_V4SFmode
              || GET_MODE (x4) != E_SFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_V4SFmode)
              && vsx_register_operand (operands[1], E_V4SFmode)
              && u5bit_cint_operand (operands[2], E_QImode)
              && 
#line 4856 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode)))
            return 1502; /* vsx_xxspltw_v4sf */
          if (!register_operand (operands[0], E_V4SFmode)
              || !register_operand (operands[1], E_V4SFmode)
              || !const_0_to_3_operand (operands[2], E_QImode)
              || !
#line 2448 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
            return -1;
          return 1950; /* *altivec_vspltsf_internal */

        case E_V16QImode:
          if (pattern417 (x3, 
E_V16QImode, 
E_QImode) != 0
              || !const_0_to_15_operand (operands[2], E_QImode)
              || !
#line 2334 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1944; /* *altivec_vspltb_internal */

        default:
          return -1;
        }

    case TRUNCATE:
      if (GET_MODE (x4) != E_QImode
          || !altivec_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!altivec_register_operand (operands[1], E_DImode)
          || !
#line 4880 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      return 1506; /* vsx_vspltb_di */

    default:
      return -1;
    }
}

 int
recog_117 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  switch (XVECLEN (x4, 0))
    {
    case 2:
      x5 = XVECEXP (x4, 0, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XVECEXP (x4, 0, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (GET_MODE (x2) != E_V2DImode)
            return -1;
          if (vsx_register_operand (operands[0], E_V2DImode)
              && memory_operand (operands[1], E_V2DImode)
              && 
#line 1393 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && !BYTES_BIG_ENDIAN))
            return 1207; /* vsx_ld_elemrev_v2di */
          if (memory_operand (operands[0], E_V2DImode)
              && vsx_register_operand (operands[1], E_V2DImode))
            {
              if (
#line 1563 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && !BYTES_BIG_ENDIAN))
                return 1216; /* vsx_st_elemrev_v2di */
              if (
#line 1625 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && !BYTES_BIG_ENDIAN && TARGET_P9_VECTOR))
                return 1219; /* *vsx_st_elemrev_v2di_internal */
            }
          if (vsx_register_operand (operands[0], E_V2DImode))
            {
              if (vsx_register_operand (operands[1], E_V2DImode))
                {
                  if (
#line 3280 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V2DImode)))
                    return 1353; /* *vsx_xxpermdi2_le_v2di */
                  if (
#line 3333 "../../gcc/config/rs6000/vsx.md"
(TARGET_VSX))
                    return 1359; /* xxswapd_v2di */
                }
              if (memory_operand (operands[1], E_V2DImode)
                  && 
#line 3391 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V2DImode) && !TARGET_P9_VECTOR))
                return 1366; /* *vsx_lxvd2x2_le_v2di */
            }
          if (!memory_operand (operands[0], E_V2DImode)
              || !vsx_register_operand (operands[1], E_V2DImode)
              || !
#line 3440 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V2DImode) && !TARGET_P9_VECTOR))
            return -1;
          return 1372; /* *vsx_stxvd2x2_le_v2di */

        case E_V2DFmode:
          if (GET_MODE (x2) != E_V2DFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_V2DFmode)
              && memory_operand (operands[1], E_V2DFmode)
              && 
#line 1413 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode) && !BYTES_BIG_ENDIAN))
            return 1209; /* vsx_ld_elemrev_v2df */
          if (memory_operand (operands[0], E_V2DFmode)
              && vsx_register_operand (operands[1], E_V2DFmode)
              && 
#line 1554 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode) && !BYTES_BIG_ENDIAN))
            return 1215; /* vsx_st_elemrev_v2df */
          if (vsx_register_operand (operands[0], E_V2DFmode))
            {
              if (vsx_register_operand (operands[1], E_V2DFmode))
                {
                  if (
#line 3280 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V2DFmode)))
                    return 1352; /* *vsx_xxpermdi2_le_v2df */
                  if (
#line 3333 "../../gcc/config/rs6000/vsx.md"
(TARGET_VSX))
                    return 1358; /* xxswapd_v2df */
                }
              if (memory_operand (operands[1], E_V2DFmode)
                  && 
#line 3391 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V2DFmode) && !TARGET_P9_VECTOR))
                return 1365; /* *vsx_lxvd2x2_le_v2df */
            }
          if (!memory_operand (operands[0], E_V2DFmode)
              || !vsx_register_operand (operands[1], E_V2DFmode)
              || !
#line 3440 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V2DFmode) && !TARGET_P9_VECTOR))
            return -1;
          return 1371; /* *vsx_stxvd2x2_le_v2df */

        default:
          return -1;
        }

    case 1:
      return recog_116 (x1, insn, pnum_clobbers);

    case 4:
      if (pattern223 (x4) != 0)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      switch (XWINT (x5, 0))
        {
        case 3L:
          x6 = XVECEXP (x4, 0, 1);
          if (XWINT (x6, 0) != 2L)
            return -1;
          x7 = XVECEXP (x4, 0, 2);
          if (XWINT (x7, 0) != 1L)
            return -1;
          x8 = XVECEXP (x4, 0, 3);
          if (XWINT (x8, 0) != 0L)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (GET_MODE (x2) != E_V4SImode)
                return -1;
              if (vsx_register_operand (operands[0], E_V4SImode)
                  && memory_operand (operands[1], E_V4SImode)
                  && 
#line 1423 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && !BYTES_BIG_ENDIAN))
                return 1210; /* vsx_ld_elemrev_v4si */
              if (!memory_operand (operands[0], E_V4SImode)
                  || !vsx_register_operand (operands[1], E_V4SImode)
                  || !
#line 1583 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && !BYTES_BIG_ENDIAN))
                return -1;
              return 1218; /* vsx_st_elemrev_v4si */

            case E_V4SFmode:
              if (GET_MODE (x2) != E_V4SFmode)
                return -1;
              if (vsx_register_operand (operands[0], E_V4SFmode)
                  && memory_operand (operands[1], E_V4SFmode)
                  && 
#line 1433 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && !BYTES_BIG_ENDIAN))
                return 1211; /* vsx_ld_elemrev_v4sf */
              if (!memory_operand (operands[0], E_V4SFmode)
                  || !vsx_register_operand (operands[1], E_V4SFmode)
                  || !
#line 1573 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && !BYTES_BIG_ENDIAN))
                return -1;
              return 1217; /* vsx_st_elemrev_v4sf */

            default:
              return -1;
            }

        case 2L:
          x6 = XVECEXP (x4, 0, 1);
          if (XWINT (x6, 0) != 3L)
            return -1;
          x7 = XVECEXP (x4, 0, 2);
          if (XWINT (x7, 0) != 0L)
            return -1;
          x8 = XVECEXP (x4, 0, 3);
          if (XWINT (x8, 0) != 1L)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (GET_MODE (x2) != E_V4SFmode)
                return -1;
              if (vsx_register_operand (operands[0], E_V4SFmode))
                {
                  if (vsx_register_operand (operands[1], E_V4SFmode)
                      && 
#line 3322 "../../gcc/config/rs6000/vsx.md"
(TARGET_VSX))
                    return 1356; /* xxswapd_v4sf */
                  if (memory_operand (operands[1], E_V4SFmode)
                      && 
#line 3401 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V4SFmode) && !TARGET_P9_VECTOR))
                    return 1367; /* *vsx_lxvd2x4_le_v4sf */
                }
              if (!memory_operand (operands[0], E_V4SFmode)
                  || !vsx_register_operand (operands[1], E_V4SFmode)
                  || !
#line 3450 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V4SFmode) && !TARGET_P9_VECTOR))
                return -1;
              return 1373; /* *vsx_stxvd2x4_le_v4sf */

            case E_V4SImode:
              if (GET_MODE (x2) != E_V4SImode)
                return -1;
              if (vsx_register_operand (operands[0], E_V4SImode))
                {
                  if (vsx_register_operand (operands[1], E_V4SImode)
                      && 
#line 3322 "../../gcc/config/rs6000/vsx.md"
(TARGET_VSX))
                    return 1357; /* xxswapd_v4si */
                  if (memory_operand (operands[1], E_V4SImode)
                      && 
#line 3401 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V4SImode) && !TARGET_P9_VECTOR))
                    return 1368; /* *vsx_lxvd2x4_le_v4si */
                }
              if (!memory_operand (operands[0], E_V4SImode)
                  || !vsx_register_operand (operands[1], E_V4SImode)
                  || !
#line 3450 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V4SImode) && !TARGET_P9_VECTOR))
                return -1;
              return 1374; /* *vsx_stxvd2x4_le_v4si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 8:
      if (pattern222 (x4) != 0
          || GET_MODE (x2) != E_V8HImode)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      switch (XWINT (x5, 0))
        {
        case 7L:
          x6 = XVECEXP (x4, 0, 1);
          if (XWINT (x6, 0) != 6L)
            return -1;
          x7 = XVECEXP (x4, 0, 2);
          if (XWINT (x7, 0) != 5L)
            return -1;
          x8 = XVECEXP (x4, 0, 3);
          if (XWINT (x8, 0) != 4L)
            return -1;
          x9 = XVECEXP (x4, 0, 4);
          if (XWINT (x9, 0) != 3L)
            return -1;
          x10 = XVECEXP (x4, 0, 5);
          if (XWINT (x10, 0) != 2L)
            return -1;
          x11 = XVECEXP (x4, 0, 6);
          if (XWINT (x11, 0) != 1L)
            return -1;
          x12 = XVECEXP (x4, 0, 7);
          if (XWINT (x12, 0) != 0L)
            return -1;
          if (vsx_register_operand (operands[0], E_V8HImode)
              && memory_operand (operands[1], E_V8HImode)
              && 
#line 1479 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && !BYTES_BIG_ENDIAN && TARGET_P9_VECTOR))
            return 1212; /* *vsx_ld_elemrev_v8hi_internal */
          if (!memory_operand (operands[0], E_V8HImode)
              || !vsx_register_operand (operands[1], E_V8HImode)
              || !
#line 1637 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && !BYTES_BIG_ENDIAN && TARGET_P9_VECTOR))
            return -1;
          return 1220; /* *vsx_st_elemrev_v8hi_internal */

        case 4L:
          x6 = XVECEXP (x4, 0, 1);
          if (XWINT (x6, 0) != 5L)
            return -1;
          x7 = XVECEXP (x4, 0, 2);
          if (XWINT (x7, 0) != 6L)
            return -1;
          x8 = XVECEXP (x4, 0, 3);
          if (XWINT (x8, 0) != 7L)
            return -1;
          x9 = XVECEXP (x4, 0, 4);
          if (XWINT (x9, 0) != 0L)
            return -1;
          x10 = XVECEXP (x4, 0, 5);
          if (XWINT (x10, 0) != 1L)
            return -1;
          x11 = XVECEXP (x4, 0, 6);
          if (XWINT (x11, 0) != 2L)
            return -1;
          x12 = XVECEXP (x4, 0, 7);
          if (XWINT (x12, 0) != 3L)
            return -1;
          if (vsx_register_operand (operands[0], E_V8HImode))
            {
              if (vsx_register_operand (operands[1], E_V8HImode)
                  && 
#line 3310 "../../gcc/config/rs6000/vsx.md"
(TARGET_VSX))
                return 1355; /* xxswapd_v8hi */
              if (memory_operand (operands[1], E_V8HImode)
                  && 
#line 3413 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V8HImode) && !TARGET_P9_VECTOR))
                return 1369; /* *vsx_lxvd2x8_le_V8HI */
            }
          if (!memory_operand (operands[0], E_V8HImode)
              || !vsx_register_operand (operands[1], E_V8HImode)
              || !
#line 3489 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V8HImode) && !TARGET_P9_VECTOR))
            return -1;
          return 1377; /* *vsx_stxvd2x8_le_V8HI */

        default:
          return -1;
        }

    case 16:
      if (pattern221 (x4) != 0
          || GET_MODE (x2) != E_V16QImode)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      switch (XWINT (x5, 0))
        {
        case 15L:
          x6 = XVECEXP (x4, 0, 1);
          if (XWINT (x6, 0) != 14L)
            return -1;
          x7 = XVECEXP (x4, 0, 2);
          if (XWINT (x7, 0) != 13L)
            return -1;
          x8 = XVECEXP (x4, 0, 3);
          if (XWINT (x8, 0) != 12L)
            return -1;
          x9 = XVECEXP (x4, 0, 4);
          if (XWINT (x9, 0) != 11L)
            return -1;
          x10 = XVECEXP (x4, 0, 5);
          if (XWINT (x10, 0) != 10L)
            return -1;
          x11 = XVECEXP (x4, 0, 6);
          if (XWINT (x11, 0) != 9L)
            return -1;
          x12 = XVECEXP (x4, 0, 7);
          if (XWINT (x12, 0) != 8L)
            return -1;
          x13 = XVECEXP (x4, 0, 8);
          if (XWINT (x13, 0) != 7L)
            return -1;
          x14 = XVECEXP (x4, 0, 9);
          if (XWINT (x14, 0) != 6L)
            return -1;
          x15 = XVECEXP (x4, 0, 10);
          if (XWINT (x15, 0) != 5L)
            return -1;
          x16 = XVECEXP (x4, 0, 11);
          if (XWINT (x16, 0) != 4L)
            return -1;
          x17 = XVECEXP (x4, 0, 12);
          if (XWINT (x17, 0) != 3L)
            return -1;
          x18 = XVECEXP (x4, 0, 13);
          if (XWINT (x18, 0) != 2L)
            return -1;
          x19 = XVECEXP (x4, 0, 14);
          if (XWINT (x19, 0) != 1L)
            return -1;
          x20 = XVECEXP (x4, 0, 15);
          if (XWINT (x20, 0) != 0L)
            return -1;
          if (vsx_register_operand (operands[0], E_V16QImode)
              && memory_operand (operands[1], E_V16QImode)
              && 
#line 1533 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && !BYTES_BIG_ENDIAN && TARGET_P9_VECTOR))
            return 1213; /* vsx_ld_elemrev_v16qi_internal */
          if (!memory_operand (operands[0], E_V16QImode)
              || !vsx_register_operand (operands[1], E_V16QImode)
              || !
#line 1690 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && !BYTES_BIG_ENDIAN && TARGET_P9_VECTOR))
            return -1;
          return 1221; /* *vsx_st_elemrev_v16qi_internal */

        case 8L:
          x6 = XVECEXP (x4, 0, 1);
          if (XWINT (x6, 0) != 9L)
            return -1;
          x7 = XVECEXP (x4, 0, 2);
          if (XWINT (x7, 0) != 10L)
            return -1;
          x8 = XVECEXP (x4, 0, 3);
          if (XWINT (x8, 0) != 11L)
            return -1;
          x9 = XVECEXP (x4, 0, 4);
          if (XWINT (x9, 0) != 12L)
            return -1;
          x10 = XVECEXP (x4, 0, 5);
          if (XWINT (x10, 0) != 13L)
            return -1;
          x11 = XVECEXP (x4, 0, 6);
          if (XWINT (x11, 0) != 14L)
            return -1;
          x12 = XVECEXP (x4, 0, 7);
          if (XWINT (x12, 0) != 15L)
            return -1;
          x13 = XVECEXP (x4, 0, 8);
          if (XWINT (x13, 0) != 0L)
            return -1;
          x14 = XVECEXP (x4, 0, 9);
          if (XWINT (x14, 0) != 1L)
            return -1;
          x15 = XVECEXP (x4, 0, 10);
          if (XWINT (x15, 0) != 2L)
            return -1;
          x16 = XVECEXP (x4, 0, 11);
          if (XWINT (x16, 0) != 3L)
            return -1;
          x17 = XVECEXP (x4, 0, 12);
          if (XWINT (x17, 0) != 4L)
            return -1;
          x18 = XVECEXP (x4, 0, 13);
          if (XWINT (x18, 0) != 5L)
            return -1;
          x19 = XVECEXP (x4, 0, 14);
          if (XWINT (x19, 0) != 6L)
            return -1;
          x20 = XVECEXP (x4, 0, 15);
          if (XWINT (x20, 0) != 7L)
            return -1;
          if (vsx_register_operand (operands[0], E_V16QImode))
            {
              if (vsx_register_operand (operands[1], E_V16QImode)
                  && 
#line 3296 "../../gcc/config/rs6000/vsx.md"
(TARGET_VSX))
                return 1354; /* xxswapd_v16qi */
              if (memory_operand (operands[1], E_V16QImode)
                  && 
#line 3429 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V16QImode) && !TARGET_P9_VECTOR))
                return 1370; /* *vsx_lxvd2x16_le_V16QI */
            }
          if (!memory_operand (operands[0], E_V16QImode)
              || !vsx_register_operand (operands[1], E_V16QImode)
              || !
#line 3505 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && VECTOR_MEM_VSX_P (V16QImode) && !TARGET_P9_VECTOR))
            return -1;
          return 1378; /* *vsx_stxvd2x16_le_V16QI */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_126 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!reg_or_mem_operand (operands[1], E_QImode))
                return -1;
              return 4; /* zero_extendqisi2 */

            case E_HImode:
              if (!reg_or_mem_operand (operands[1], E_HImode))
                return -1;
              return 10; /* zero_extendhisi2 */

            default:
              return -1;
            }

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!reg_or_mem_operand (operands[1], E_QImode)
                  || !
#line 490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 5; /* zero_extendqidi2 */

            case E_HImode:
              if (!reg_or_mem_operand (operands[1], E_HImode)
                  || !
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 11; /* zero_extendhidi2 */

            case E_SImode:
              if (!reg_or_mem_operand (operands[1], E_SImode)
                  || !
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 16; /* zero_extendsidi2 */

            default:
              return -1;
            }

        case E_TImode:
          if (!vsx_register_operand (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!memory_operand (operands[1], E_QImode)
                  || !
#line 1373 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1199; /* vsx_lxvrbx */

            case E_HImode:
              if (!memory_operand (operands[1], E_HImode)
                  || !
#line 1373 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1200; /* vsx_lxvrhx */

            case E_SImode:
              if (!memory_operand (operands[1], E_SImode)
                  || !
#line 1373 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1201; /* vsx_lxvrwx */

            case E_DImode:
              if (!memory_operand (operands[1], E_DImode)
                  || !
#line 1373 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1202; /* vsx_lxvrdx */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case BSWAP:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_HImode:
              if (!memory_operand (operands[1], E_HImode)
                  || !
#line 2610 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 139; /* *bswaphi2_extenddi */

            case E_SImode:
              if (!memory_operand (operands[1], E_SImode)
                  || !
#line 2610 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 140; /* *bswapsi2_extenddi */

            default:
              return -1;
            }

        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_HImode
              || !memory_operand (operands[1], E_HImode))
            return -1;
          return 141; /* *bswaphi2_extendsi */

        default:
          return -1;
        }

    case ROTATE:
      if (GET_MODE (x4) != E_SImode
          || pattern120 (x3, 
E_SImode) != 0
          || !
#line 4579 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
        return -1;
      return 266; /* *rotlsi3_64 */

    case ASHIFT:
      if (GET_MODE (x4) != E_SImode
          || pattern120 (x3, 
E_SImode) != 0
          || !
#line 4647 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
        return -1;
      return 273; /* *ashlsi3_64 */

    case LSHIFTRT:
      if (GET_MODE (x4) != E_SImode
          || pattern120 (x3, 
E_SImode) != 0
          || !
#line 4836 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
        return -1;
      return 283; /* *lshrsi3_64 */

    case UNSPEC:
      switch (XVECLEN (x4, 0))
        {
        case 1:
          if (GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          x6 = XVECEXP (x4, 0, 0);
          operands[1] = x6;
          switch (XINT (x4, 1))
            {
            case 87:
              if (pnum_clobbers == NULL
                  || !gpc_reg_operand (operands[0], E_DImode)
                  || !input_operand (operands[1], E_SFmode)
                  || !
#line 7892 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT
   && (register_operand (operands[0], DImode)
       || register_operand (operands[1], SImode))))
                return -1;
              *pnum_clobbers = 1;
              return 559; /* *movdi_from_sf_zero_ext */

            case 168:
              switch (pattern349 ())
                {
                case 0:
                  if (!
#line 5954 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                    return -1;
                  return 1597; /* *vclzlsbb_zext_v16qi */

                case 1:
                  if (!
#line 5954 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                    return -1;
                  return 1599; /* *vclzlsbb_zext_v8hi */

                case 2:
                  if (!
#line 5954 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                    return -1;
                  return 1601; /* *vclzlsbb_zext_v4si */

                default:
                  return -1;
                }

            case 169:
              switch (pattern349 ())
                {
                case 0:
                  if (!
#line 5954 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                    return -1;
                  return 1598; /* *vctzlsbb_zext_v16qi */

                case 1:
                  if (!
#line 5954 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                    return -1;
                  return 1600; /* *vctzlsbb_zext_v8hi */

                case 2:
                  if (!
#line 5954 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                    return -1;
                  return 1602; /* *vctzlsbb_zext_v4si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 3:
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern199 (x4))
            {
            case 0:
              if (!int_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return -1;
              switch (GET_MODE (x4))
                {
                case E_SImode:
                  if (!d_form_memory (operands[1], E_SImode)
                      || !(
#line 170 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3194; /* *pcrel_opt_ldsi_udi_gpr */

                case E_HImode:
                  if (!d_form_memory (operands[1], E_HImode)
                      || !(
#line 185 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3198; /* *pcrel_opt_ldhi_udi_gpr */

                case E_QImode:
                  if (!d_form_memory (operands[1], E_QImode)
                      || !(
#line 200 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3200; /* *pcrel_opt_ldqi_udi_gpr */

                default:
                  return -1;
                }

            case 1:
              if (!int_reg_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              switch (GET_MODE (x4))
                {
                case E_HImode:
                  if (!d_form_memory (operands[1], E_HImode)
                      || !
#line 185 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3196; /* *pcrel_opt_ldhi_usi_gpr */

                case E_QImode:
                  if (!d_form_memory (operands[1], E_QImode)
                      || !
#line 200 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3199; /* *pcrel_opt_ldqi_usi_gpr */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      if (pnum_clobbers == NULL)
        return -1;
      x7 = XEXP (x4, 1);
      if (GET_CODE (x7) != PARALLEL
          || XVECLEN (x7, 0) != 1
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (vsx_register_operand (operands[1], E_V4SImode)
          && register_operand (operands[0], E_DImode)
          && GET_MODE (x4) == E_SImode)
        {
          x8 = XVECEXP (x7, 0, 0);
          operands[2] = x8;
          if (const_int_operand (operands[2], E_QImode)
              && 
#line 3957 "../../gcc/config/rs6000/vsx.md"
(TARGET_DIRECT_MOVE_64BIT
   && INTVAL (operands[2]) == (BYTES_BIG_ENDIAN ? 1 : 2)))
            {
              *pnum_clobbers = 1;
              return 1400; /* *mfvsrwz */
            }
        }
      if (!gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x8 = XVECEXP (x7, 0, 0);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_QImode:
          if (!gpc_reg_operand (operands[1], E_V16QImode)
              || !
#line 4025 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_VEXTRACTUB))
            return -1;
          *pnum_clobbers = 1;
          return 1404; /* *vsx_extract_v16qi_di_p9 */

        case E_HImode:
          if (!gpc_reg_operand (operands[1], E_V8HImode)
              || !
#line 4025 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_VEXTRACTUB))
            return -1;
          *pnum_clobbers = 1;
          return 1405; /* *vsx_extract_v8hi_di_p9 */

        case E_SImode:
          if (!gpc_reg_operand (operands[1], E_V4SImode)
              || !
#line 4025 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_VEXTRACTUB))
            return -1;
          *pnum_clobbers = 1;
          return 1406; /* *vsx_extract_v4si_di_p9 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_130 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  res = recog_24 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  x5 = XEXP (x3, 1);
  if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
    {
      res = recog_25 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[1] = x4;
  operands[2] = x5;
  switch (GET_CODE (x3))
    {
    case EQ:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!gpc_reg_operand (operands[1], E_SImode))
                return -1;
              if (reg_or_short_operand (operands[2], E_SImode)
                  && 
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                {
                  *pnum_clobbers = 3;
                  return 812; /* eqsisi2_isel */
                }
              if (!scc_eq_operand (operands[2], E_SImode)
                  || !
#line 12928 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)))
                return -1;
              *pnum_clobbers = 2;
              return 852; /* *eqsi3 */

            case E_DImode:
              if (!gpc_reg_operand (operands[1], E_DImode)
                  || !reg_or_short_operand (operands[2], E_DImode)
                  || !(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 3;
              return 832; /* eqsidi2_isel */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern314 (x3))
            {
            case 0:
              if (reg_or_short_operand (operands[2], E_SImode)
                  && (
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                {
                  *pnum_clobbers = 3;
                  return 822; /* eqdisi2_isel */
                }
              if (!scc_eq_operand (operands[2], E_SImode)
                  || !(
#line 13220 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 2;
              return 861; /* *eqsi3_extdi */

            case 1:
              if (reg_or_short_operand (operands[2], E_DImode)
                  && (
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(EQ == EQ && operands[2] == const0_rtx)
   && !(EQ == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                {
                  *pnum_clobbers = 3;
                  return 842; /* eqdidi2_isel */
                }
              if (!scc_eq_operand (operands[2], E_DImode)
                  || !(
#line 12928 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 2;
              return 853; /* *eqdi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LT:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode))
            return -1;
          switch (pattern302 (x3, 
E_SImode))
            {
            case 0:
              if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              *pnum_clobbers = 3;
              return 814; /* ltsisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 3;
              return 834; /* ltsidi2_isel */

            default:
              return -1;
            }

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode))
            return -1;
          switch (pattern302 (x3, 
E_DImode))
            {
            case 0:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 3;
              return 824; /* ltdisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LT == EQ && operands[2] == const0_rtx)
   && !(LT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 3;
              return 844; /* ltdidi2_isel */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LTU:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode))
            return -1;
          switch (pattern127 (x3, 
E_SImode))
            {
            case 0:
              if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              *pnum_clobbers = 3;
              return 815; /* ltusisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 3;
              return 835; /* ltusidi2_isel */

            default:
              return -1;
            }

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode))
            return -1;
          switch (pattern127 (x3, 
E_DImode))
            {
            case 0:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 3;
              return 825; /* ltudisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LTU == EQ && operands[2] == const0_rtx)
   && !(LTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 3;
              return 845; /* ltudidi2_isel */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case GT:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode))
            return -1;
          switch (pattern302 (x3, 
E_SImode))
            {
            case 0:
              if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              *pnum_clobbers = 3;
              return 816; /* gtsisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 3;
              return 836; /* gtsidi2_isel */

            default:
              return -1;
            }

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode))
            return -1;
          switch (pattern302 (x3, 
E_DImode))
            {
            case 0:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 3;
              return 826; /* gtdisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GT == EQ && operands[2] == const0_rtx)
   && !(GT == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 3;
              return 846; /* gtdidi2_isel */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case GTU:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode))
            return -1;
          switch (pattern127 (x3, 
E_SImode))
            {
            case 0:
              if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
                return -1;
              *pnum_clobbers = 3;
              return 817; /* gtusisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 3;
              return 837; /* gtusidi2_isel */

            default:
              return -1;
            }

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode))
            return -1;
          switch (pattern127 (x3, 
E_DImode))
            {
            case 0:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 3;
              return 827; /* gtudisi2_isel */

            case 1:
              if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GTU == EQ && operands[2] == const0_rtx)
   && !(GTU == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 3;
              return 847; /* gtudidi2_isel */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_160 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case PC:
      x4 = XEXP (x2, 1);
      operands[0] = x4;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x5))
        {
        case CLOBBER:
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (!cc_reg_operand (operands[1], E_CCmode)
              || !(
#line 13540 "../../gcc/config/rs6000/rs6000.md"
(!rs6000_speculate_indirect_jumps) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 897; /* indirect_jumpdi_nospec */

        case USE:
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != LABEL_REF)
            return -1;
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          if (!(
#line 13647 "../../gcc/config/rs6000/rs6000.md"
(rs6000_speculate_indirect_jumps) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 898; /* tablejumpdi_insn_normal */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) == SET)
        {
          res = recog_159 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[0] = x3;
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 1)
        return -1;
      x8 = XVECEXP (x5, 0, 0);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      switch (XINT (x5, 1))
        {
        case 279:
          switch (pattern472 ())
            {
            case 0:
              if (!
#line 3182 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2094; /* altivec_stvx_v4si_internal */

            case 1:
              if (!
#line 3182 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2095; /* altivec_stvx_v8hi_internal */

            case 2:
              if (!
#line 3182 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2096; /* altivec_stvx_v16qi_internal */

            case 3:
              if (!
#line 3182 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2097; /* altivec_stvx_v4sf_internal */

            case 4:
              if (!
#line 3182 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2098; /* altivec_stvx_v2df_internal */

            case 5:
              if (!
#line 3182 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2099; /* altivec_stvx_v2di_internal */

            case 6:
              if (!
#line 3182 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2100; /* altivec_stvx_v1ti_internal */

            case 7:
              if (!(
#line 3182 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 211 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 2101; /* altivec_stvx_kf_internal */

            case 8:
              if (!(
#line 3182 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 212 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 2102; /* altivec_stvx_tf_internal */

            default:
              return -1;
            }

        case 280:
          switch (pattern472 ())
            {
            case 0:
              if (!
#line 3235 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2121; /* altivec_stvxl_v4si */

            case 1:
              if (!
#line 3235 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2122; /* altivec_stvxl_v8hi */

            case 2:
              if (!
#line 3235 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2123; /* altivec_stvxl_v16qi */

            case 3:
              if (!
#line 3235 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2124; /* altivec_stvxl_v4sf */

            case 4:
              if (!
#line 3235 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2125; /* altivec_stvxl_v2df */

            case 5:
              if (!
#line 3235 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2126; /* altivec_stvxl_v2di */

            case 6:
              if (!
#line 3235 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2127; /* altivec_stvxl_v1ti */

            case 7:
              if (!(
#line 3235 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 211 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 2128; /* altivec_stvxl_kf */

            case 8:
              if (!(
#line 3235 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 212 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 2129; /* altivec_stvxl_tf */

            default:
              return -1;
            }

        case 305:
          if (!memory_operand (operands[0], E_V16QImode)
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 4280 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
            return -1;
          return 2142; /* altivec_stvlx */

        case 306:
          if (!memory_operand (operands[0], E_V16QImode)
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 4289 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
            return -1;
          return 2143; /* altivec_stvlxl */

        case 307:
          if (!memory_operand (operands[0], E_V16QImode)
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 4298 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
            return -1;
          return 2144; /* altivec_stvrx */

        case 308:
          if (!memory_operand (operands[0], E_V16QImode)
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 4307 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
            return -1;
          return 2145; /* altivec_stvrxl */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_165 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 1);
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  operands[4] = x7;
  x8 = XEXP (x5, 0);
  switch (GET_CODE (x8))
    {
    case AND:
      x9 = XEXP (x8, 0);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          switch (pattern391 (x5))
            {
            case 0:
              if (!
#line 1519 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2502; /* *fuse_and_xor */

            case 1:
              if (!(
#line 1519 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2503; /* *fuse_and_xor */

            case 2:
              if (!
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3102; /* *fuse_vand_vxor */

            case 3:
              if (!
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3103; /* *fuse_vand_vxor */

            case 4:
              if (!
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3104; /* *fuse_vand_vxor */

            case 5:
              if (!
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3105; /* *fuse_vand_vxor */

            case 6:
              if (!
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3106; /* *fuse_vand_vxor */

            case 7:
              if (!
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3107; /* *fuse_vand_vxor */

            case 8:
              if (!
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3108; /* *fuse_vand_vxor */

            case 9:
              if (!
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3109; /* *fuse_vand_vxor */

            case 10:
              if (!(
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 3110; /* *fuse_vand_vxor */

            case 11:
              if (!(
#line 2887 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 3111; /* *fuse_vand_vxor */

            default:
              return -1;
            }

        case NOT:
          x10 = XEXP (x9, 0);
          operands[0] = x10;
          x11 = XEXP (x8, 1);
          switch (GET_CODE (x11))
            {
            case REG:
            case SUBREG:
              operands[1] = x11;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern235 (x5, 
E_SImode) != 0
                      || !
#line 1537 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2504; /* *fuse_andc_xor */

                case E_DImode:
                  if (pattern235 (x5, 
E_DImode) != 0
                      || !(
#line 1537 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2505; /* *fuse_andc_xor */

                case E_V4SImode:
                  if (pattern236 (x5, 
E_V4SImode) != 0
                      || !
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3112; /* *fuse_vandc_vxor */

                case E_V8HImode:
                  if (pattern236 (x5, 
E_V8HImode) != 0
                      || !
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3113; /* *fuse_vandc_vxor */

                case E_V16QImode:
                  if (pattern236 (x5, 
E_V16QImode) != 0
                      || !
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3114; /* *fuse_vandc_vxor */

                case E_V4SFmode:
                  if (pattern236 (x5, 
E_V4SFmode) != 0
                      || !
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3115; /* *fuse_vandc_vxor */

                case E_V2DFmode:
                  if (pattern236 (x5, 
E_V2DFmode) != 0
                      || !
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3116; /* *fuse_vandc_vxor */

                case E_V2DImode:
                  if (pattern236 (x5, 
E_V2DImode) != 0
                      || !
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3117; /* *fuse_vandc_vxor */

                case E_V1TImode:
                  if (pattern236 (x5, 
E_V1TImode) != 0
                      || !
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3118; /* *fuse_vandc_vxor */

                case E_TImode:
                  if (pattern236 (x5, 
E_TImode) != 0
                      || !
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3119; /* *fuse_vandc_vxor */

                case E_KFmode:
                  if (pattern236 (x5, 
E_KFmode) != 0
                      || !(
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  return 3120; /* *fuse_vandc_vxor */

                case E_TFmode:
                  if (pattern236 (x5, 
E_TFmode) != 0
                      || !(
#line 2905 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  return 3121; /* *fuse_vandc_vxor */

                default:
                  return -1;
                }

            case NOT:
              x12 = XEXP (x11, 0);
              operands[1] = x12;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern184 (x5, 
E_SImode) != 0
                      || !
#line 1591 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2510; /* *fuse_nor_xor */

                case E_DImode:
                  if (pattern184 (x5, 
E_DImode) != 0
                      || !(
#line 1591 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2511; /* *fuse_nor_xor */

                case E_V4SImode:
                  if (pattern240 (x5, 
E_V4SImode) != 0
                      || !
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3142; /* *fuse_vnor_vxor */

                case E_V8HImode:
                  if (pattern240 (x5, 
E_V8HImode) != 0
                      || !
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3143; /* *fuse_vnor_vxor */

                case E_V16QImode:
                  if (pattern240 (x5, 
E_V16QImode) != 0
                      || !
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3144; /* *fuse_vnor_vxor */

                case E_V4SFmode:
                  if (pattern240 (x5, 
E_V4SFmode) != 0
                      || !
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3145; /* *fuse_vnor_vxor */

                case E_V2DFmode:
                  if (pattern240 (x5, 
E_V2DFmode) != 0
                      || !
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3146; /* *fuse_vnor_vxor */

                case E_V2DImode:
                  if (pattern240 (x5, 
E_V2DImode) != 0
                      || !
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3147; /* *fuse_vnor_vxor */

                case E_V1TImode:
                  if (pattern240 (x5, 
E_V1TImode) != 0
                      || !
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3148; /* *fuse_vnor_vxor */

                case E_TImode:
                  if (pattern240 (x5, 
E_TImode) != 0
                      || !
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3149; /* *fuse_vnor_vxor */

                case E_KFmode:
                  if (pattern240 (x5, 
E_KFmode) != 0
                      || !(
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  return 3150; /* *fuse_vnor_vxor */

                case E_TFmode:
                  if (pattern240 (x5, 
E_TFmode) != 0
                      || !(
#line 2959 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  return 3151; /* *fuse_vnor_vxor */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != XOR)
        return -1;
      x10 = XEXP (x9, 0);
      operands[0] = x10;
      x13 = XEXP (x9, 1);
      operands[1] = x13;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          if (pattern504 (x5, 
E_SImode) != 0
              || !
#line 1555 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2506; /* *fuse_eqv_xor */

        case E_DImode:
          if (pattern504 (x5, 
E_DImode) != 0
              || !(
#line 1555 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2507; /* *fuse_eqv_xor */

        case E_V4SImode:
          if (pattern505 (x5, 
E_V4SImode) != 0
              || !
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3122; /* *fuse_veqv_vxor */

        case E_V8HImode:
          if (pattern505 (x5, 
E_V8HImode) != 0
              || !
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3123; /* *fuse_veqv_vxor */

        case E_V16QImode:
          if (pattern505 (x5, 
E_V16QImode) != 0
              || !
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3124; /* *fuse_veqv_vxor */

        case E_V4SFmode:
          if (pattern505 (x5, 
E_V4SFmode) != 0
              || !
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3125; /* *fuse_veqv_vxor */

        case E_V2DFmode:
          if (pattern505 (x5, 
E_V2DFmode) != 0
              || !
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3126; /* *fuse_veqv_vxor */

        case E_V2DImode:
          if (pattern505 (x5, 
E_V2DImode) != 0
              || !
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3127; /* *fuse_veqv_vxor */

        case E_V1TImode:
          if (pattern505 (x5, 
E_V1TImode) != 0
              || !
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3128; /* *fuse_veqv_vxor */

        case E_TImode:
          if (pattern505 (x5, 
E_TImode) != 0
              || !
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3129; /* *fuse_veqv_vxor */

        case E_KFmode:
          if (pattern505 (x5, 
E_KFmode) != 0
              || !(
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3130; /* *fuse_veqv_vxor */

        case E_TFmode:
          if (pattern505 (x5, 
E_TFmode) != 0
              || !(
#line 2923 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3131; /* *fuse_veqv_vxor */

        default:
          return -1;
        }

    case IOR:
      x9 = XEXP (x8, 0);
      switch (GET_CODE (x9))
        {
        case NOT:
          x10 = XEXP (x9, 0);
          operands[0] = x10;
          x11 = XEXP (x8, 1);
          switch (GET_CODE (x11))
            {
            case NOT:
              x12 = XEXP (x11, 0);
              operands[1] = x12;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern184 (x5, 
E_SImode) != 0
                      || !
#line 1573 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2508; /* *fuse_nand_xor */

                case E_DImode:
                  if (pattern184 (x5, 
E_DImode) != 0
                      || !(
#line 1573 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2509; /* *fuse_nand_xor */

                case E_V4SImode:
                  if (pattern240 (x5, 
E_V4SImode) != 0
                      || !
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3132; /* *fuse_vnand_vxor */

                case E_V8HImode:
                  if (pattern240 (x5, 
E_V8HImode) != 0
                      || !
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3133; /* *fuse_vnand_vxor */

                case E_V16QImode:
                  if (pattern240 (x5, 
E_V16QImode) != 0
                      || !
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3134; /* *fuse_vnand_vxor */

                case E_V4SFmode:
                  if (pattern240 (x5, 
E_V4SFmode) != 0
                      || !
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3135; /* *fuse_vnand_vxor */

                case E_V2DFmode:
                  if (pattern240 (x5, 
E_V2DFmode) != 0
                      || !
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3136; /* *fuse_vnand_vxor */

                case E_V2DImode:
                  if (pattern240 (x5, 
E_V2DImode) != 0
                      || !
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3137; /* *fuse_vnand_vxor */

                case E_V1TImode:
                  if (pattern240 (x5, 
E_V1TImode) != 0
                      || !
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3138; /* *fuse_vnand_vxor */

                case E_TImode:
                  if (pattern240 (x5, 
E_TImode) != 0
                      || !
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3139; /* *fuse_vnand_vxor */

                case E_KFmode:
                  if (pattern240 (x5, 
E_KFmode) != 0
                      || !(
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  return 3140; /* *fuse_vnand_vxor */

                case E_TFmode:
                  if (pattern240 (x5, 
E_TFmode) != 0
                      || !(
#line 2941 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  return 3141; /* *fuse_vnand_vxor */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[1] = x11;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern235 (x5, 
E_SImode) != 0
                      || !
#line 1627 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2514; /* *fuse_orc_xor */

                case E_DImode:
                  if (pattern235 (x5, 
E_DImode) != 0
                      || !(
#line 1627 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2515; /* *fuse_orc_xor */

                case E_V4SImode:
                  if (pattern236 (x5, 
E_V4SImode) != 0
                      || !
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3162; /* *fuse_vorc_vxor */

                case E_V8HImode:
                  if (pattern236 (x5, 
E_V8HImode) != 0
                      || !
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3163; /* *fuse_vorc_vxor */

                case E_V16QImode:
                  if (pattern236 (x5, 
E_V16QImode) != 0
                      || !
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3164; /* *fuse_vorc_vxor */

                case E_V4SFmode:
                  if (pattern236 (x5, 
E_V4SFmode) != 0
                      || !
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3165; /* *fuse_vorc_vxor */

                case E_V2DFmode:
                  if (pattern236 (x5, 
E_V2DFmode) != 0
                      || !
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3166; /* *fuse_vorc_vxor */

                case E_V2DImode:
                  if (pattern236 (x5, 
E_V2DImode) != 0
                      || !
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3167; /* *fuse_vorc_vxor */

                case E_V1TImode:
                  if (pattern236 (x5, 
E_V1TImode) != 0
                      || !
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3168; /* *fuse_vorc_vxor */

                case E_TImode:
                  if (pattern236 (x5, 
E_TImode) != 0
                      || !
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 3169; /* *fuse_vorc_vxor */

                case E_KFmode:
                  if (pattern236 (x5, 
E_KFmode) != 0
                      || !(
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  return 3170; /* *fuse_vorc_vxor */

                case E_TFmode:
                  if (pattern236 (x5, 
E_TFmode) != 0
                      || !(
#line 2995 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  return 3171; /* *fuse_vorc_vxor */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern391 (x5))
            {
            case 0:
              if (!
#line 1609 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2512; /* *fuse_or_xor */

            case 1:
              if (!(
#line 1609 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2513; /* *fuse_or_xor */

            case 2:
              if (!
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3152; /* *fuse_vor_vxor */

            case 3:
              if (!
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3153; /* *fuse_vor_vxor */

            case 4:
              if (!
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3154; /* *fuse_vor_vxor */

            case 5:
              if (!
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3155; /* *fuse_vor_vxor */

            case 6:
              if (!
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3156; /* *fuse_vor_vxor */

            case 7:
              if (!
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3157; /* *fuse_vor_vxor */

            case 8:
              if (!
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3158; /* *fuse_vor_vxor */

            case 9:
              if (!
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3159; /* *fuse_vor_vxor */

            case 10:
              if (!(
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 3160; /* *fuse_vor_vxor */

            case 11:
              if (!(
#line 2977 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 3161; /* *fuse_vor_vxor */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case XOR:
      switch (pattern391 (x5))
        {
        case 0:
          if (!
#line 1645 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2516; /* *fuse_xor_xor */

        case 1:
          if (!(
#line 1645 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2517; /* *fuse_xor_xor */

        case 2:
          if (!
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3172; /* *fuse_vxor_vxor */

        case 3:
          if (!
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3173; /* *fuse_vxor_vxor */

        case 4:
          if (!
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3174; /* *fuse_vxor_vxor */

        case 5:
          if (!
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3175; /* *fuse_vxor_vxor */

        case 6:
          if (!
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3176; /* *fuse_vxor_vxor */

        case 7:
          if (!
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3177; /* *fuse_vxor_vxor */

        case 8:
          if (!
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3178; /* *fuse_vxor_vxor */

        case 9:
          if (!
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3179; /* *fuse_vxor_vxor */

        case 10:
          if (!(
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3180; /* *fuse_vxor_vxor */

        case 11:
          if (!(
#line 3013 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3181; /* *fuse_vxor_vxor */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_181 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case COMPARE:
          switch (pattern95 (x1))
            {
            case 0:
              if (!
#line 1919 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 71; /* *addsi3_imm_dot */

            case 1:
              if (!(
#line 1919 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 72; /* *adddi3_imm_dot */

            case 2:
              if (!
#line 1944 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 73; /* *addsi3_imm_dot2 */

            case 3:
              if (!(
#line 1944 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 74; /* *adddi3_imm_dot2 */

            case 4:
              if (!(
#line 2275 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 102; /* subfsi3_carry_dot2 */

            case 5:
              if (!(
#line 2275 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 103; /* subfdi3_carry_dot2 */

            case 6:
              if (!
#line 3394 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 183; /* *divsi3_sra_dot */

            case 7:
              if (!(
#line 3394 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 184; /* *divdi3_sra_dot */

            case 8:
              if (!
#line 3420 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 185; /* *divsi3_sra_dot2 */

            case 9:
              if (!(
#line 3420 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 186; /* *divdi3_sra_dot2 */

            case 10:
              if (!
#line 3654 "../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], SImode)))
                return -1;
              return 190; /* *andsi3_imm_dot */

            case 11:
              if (!(
#line 3654 "../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 191; /* *anddi3_imm_dot */

            case 12:
              if (!
#line 3681 "../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], SImode)))
                return -1;
              return 192; /* *andsi3_imm_dot2 */

            case 13:
              if (!(
#line 3681 "../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 193; /* *anddi3_imm_dot2 */

            case 14:
              if (!
#line 4918 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 291; /* *ashrsi3_dot */

            case 15:
              if (!(
#line 4918 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 292; /* *ashrdi3_dot */

            case 16:
              if (!
#line 4945 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 293; /* *ashrsi3_dot2 */

            case 17:
              if (!(
#line 4945 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 294; /* *ashrdi3_dot2 */

            default:
              return -1;
            }

        case BSWAP:
          if (GET_MODE (x3) != E_DImode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          x7 = XEXP (x3, 0);
          operands[1] = x7;
          if (gpc_reg_operand (operands[1], E_DImode)
              && gpc_reg_operand (operands[0], E_DImode))
            {
              x8 = XEXP (x4, 0);
              operands[2] = x8;
              if (scratch_operand (operands[2], E_DImode))
                {
                  x9 = XEXP (x5, 0);
                  operands[3] = x9;
                  if (scratch_operand (operands[3], E_DImode)
                      && 
#line 2806 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_LDBRX && !TARGET_P9_VECTOR))
                    return 151; /* bswapdi2_reg */
                }
            }
          if (!reg_or_mem_operand (operands[1], E_DImode)
              || !reg_or_mem_operand (operands[0], E_DImode))
            return -1;
          x8 = XEXP (x4, 0);
          operands[2] = x8;
          if (!scratch_operand (operands[2], E_DImode))
            return -1;
          x9 = XEXP (x5, 0);
          operands[3] = x9;
          if (!scratch_operand (operands[3], E_DImode)
              || !
#line 2816 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && !TARGET_LDBRX
   && (REG_P (operands[0]) || REG_P (operands[1]))
   && !(MEM_P (operands[0]) && MEM_VOLATILE_P (operands[0]))
   && !(MEM_P (operands[1]) && MEM_VOLATILE_P (operands[1]))))
            return -1;
          return 152; /* *bswapdi2_64bit */

        case IF_THEN_ELSE:
          switch (pattern96 (x1))
            {
            case 0:
              if (!
#line 3906 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_rotate_dot_mask (operands[2], DImode)
  && TARGET_POWERPC64))
                return -1;
              return 212; /* *branch_anddi3_dot */

            case 1:
              if (!
#line 7954 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && num_insns_constant (operands[2], DImode) > 1
   && (can_be_rotated_to_positive_16bits (INTVAL (operands[2]))
       || can_be_rotated_to_negative_15bits (INTVAL (operands[2])))))
                return -1;
              return 561; /* *rotate_on_cmpdi */

            case 2:
              if (!
#line 7954 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && num_insns_constant (operands[2], DImode) > 1
   && (can_be_rotated_to_positive_16bits (INTVAL (operands[2]))
       || can_be_rotated_to_negative_15bits (INTVAL (operands[2])))))
                return -1;
              return 562; /* *rotate_on_cmpdi */

            default:
              return -1;
            }

        case UNSIGNED_FLOAT:
          switch (pattern100 (x1))
            {
            case 0:
              if (!
#line 6269 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 410; /* *floatunsqisf2_internal */

            case 1:
              if (!
#line 6269 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 411; /* *floatunshisf2_internal */

            case 2:
              if (!
#line 6269 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 412; /* *floatunsqidf2_internal */

            case 3:
              if (!
#line 6269 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 413; /* *floatunshidf2_internal */

            case 4:
              if (!
#line 6744 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_LFIWZX && TARGET_STFIWX && TARGET_FCFIDU && !TARGET_DIRECT_MOVE
   && can_create_pseudo_p ()))
                return -1;
              return 460; /* *roundu32sf2_fprs */

            case 5:
              if (!
#line 6744 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_LFIWZX && TARGET_STFIWX && TARGET_FCFIDU && !TARGET_DIRECT_MOVE
   && can_create_pseudo_p ()))
                return -1;
              return 461; /* *roundu32df2_fprs */

            case 6:
              if (!
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 1457; /* *vsx_extract_si_unsfloat_sf */

            case 7:
              if (!(
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 230 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (IFmode))))
                return -1;
              return 1459; /* *vsx_extract_si_unsfloat_if */

            case 8:
              if (!(
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 231 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
                return -1;
              return 1461; /* *vsx_extract_si_unsfloat_kf */

            case 9:
              if (!(
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 232 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (TFmode)
					   || (FLOAT128_IEEE_P (TFmode)
					       && TARGET_FLOAT128_HW))))
                return -1;
              return 1463; /* *vsx_extract_si_unsfloat_tf */

            default:
              return -1;
            }

        case FIX:
          switch (pattern101 (x1))
            {
            case 0:
              if (!
#line 6362 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && !TARGET_DIRECT_MOVE))
                return -1;
              return 416; /* fix_truncsfsi2_internal */

            case 1:
              if (!
#line 6362 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && !TARGET_DIRECT_MOVE))
                return -1;
              return 417; /* fix_truncdfsi2_internal */

            default:
              return -1;
            }

        case FLOAT:
          switch (pattern102 (x1))
            {
            case 0:
              if (!
#line 6711 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_FCFIDS && TARGET_LFIWAX && TARGET_STFIWX && TARGET_FCFID
   && !TARGET_DIRECT_MOVE && can_create_pseudo_p ()))
                return -1;
              return 458; /* *round32sf2_fprs */

            case 1:
              if (!
#line 6711 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_FCFID && TARGET_LFIWAX && TARGET_STFIWX && TARGET_FCFID
   && !TARGET_DIRECT_MOVE && can_create_pseudo_p ()))
                return -1;
              return 459; /* *round32df2_fprs */

            case 2:
              if (!
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 1456; /* *vsx_extract_si_float_sf */

            case 3:
              if (!(
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 230 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (IFmode))))
                return -1;
              return 1458; /* *vsx_extract_si_float_if */

            case 4:
              if (!(
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 231 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
                return -1;
              return 1460; /* *vsx_extract_si_float_kf */

            case 5:
              if (!(
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 232 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (TFmode)
					   || (FLOAT128_IEEE_P (TFmode)
					       && TARGET_FLOAT128_HW))))
                return -1;
              return 1462; /* *vsx_extract_si_float_tf */

            default:
              return -1;
            }

        case CALL:
          x7 = XEXP (x3, 0);
          if (GET_CODE (x7) != MEM)
            return -1;
          switch (pattern190 (x1))
            {
            case 0:
              x5 = XVECEXP (x1, 0, 2);
              switch (pattern428 (x5, pnum_clobbers))
                {
                case 0:
                  if (current_file_function_operand (operands[1], E_DImode)
                      && (
#line 11512 "../../gcc/config/rs6000/rs6000.md"
((INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return 770; /* *call_value_localdi */
                  if (!symbol_ref_operand (operands[1], E_DImode)
                      || !unspec_tls (operands[2], E_DImode))
                    return -1;
                  if ((
#line 11637 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_DARWIN
    || (DEFAULT_ABI == ABI_V4
	&& (INTVAL (operands[3]) & CALL_LONG) == 0))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return 775; /* *call_value_nonlocal_sysvdi */
                  if (!(
#line 11705 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2)
   && (INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 778; /* *call_value_nonlocal_aixdi */

                case 1:
                  if (!symbol_ref_operand (operands[1], E_DImode)
                      || !unspec_tls (operands[2], E_DImode))
                    return -1;
                  x9 = XEXP (x5, 0);
                  operands[4] = x9;
                  if (!register_operand (operands[4], E_SImode)
                      || !(
#line 11662 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_V4
    && TARGET_SECURE_PLT && flag_pic && !SYMBOL_REF_LOCAL_P (operands[1])
    && (INTVAL (operands[3]) & CALL_LONG) == 0)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 776; /* *call_value_nonlocal_sysv_securedi */

                case 2:
                  if (current_file_function_operand (operands[1], E_DImode)
                      && (
#line 11949 "../../gcc/config/rs6000/rs6000.md"
((INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return 788; /* *sibcall_value_localdi */
                  if (!symbol_ref_operand (operands[1], E_DImode)
                      || !(
#line 12045 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_DARWIN
    || DEFAULT_ABI == ABI_V4)
   && (INTVAL (operands[3]) & CALL_LONG) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 792; /* *sibcall_value_nonlocal_sysvdi */

                default:
                  return -1;
                }

            case 1:
              x5 = XVECEXP (x1, 0, 2);
              switch (GET_CODE (x5))
                {
                case CLOBBER:
                  x9 = XEXP (x5, 0);
                  if (GET_CODE (x9) != REG
                      || REGNO (x9) != 96)
                    return -1;
                  switch (GET_MODE (operands[1]))
                    {
                    case E_DImode:
                      if (!indirect_call_operand (operands[1], E_DImode)
                          || !unspec_tls (operands[2], E_DImode)
                          || GET_MODE (x9) != E_DImode)
                        return -1;
                      if ((
#line 11609 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                        return 774; /* *call_value_indirect_nonlocal_sysvdi */
                      if (!(
#line 11823 "../../gcc/config/rs6000/rs6000.md"
(rs6000_pcrel_p ()) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                        return -1;
                      return 786; /* *call_value_indirect_pcreldi */

                    case E_SImode:
                      if (!indirect_call_operand (operands[1], E_SImode)
                          || !unspec_tls (operands[2], E_SImode)
                          || GET_MODE (x9) != E_SImode
                          || !(
#line 11823 "../../gcc/config/rs6000/rs6000.md"
(rs6000_pcrel_p ()) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                        return -1;
                      return 785; /* *call_value_indirect_pcrelsi */

                    default:
                      return -1;
                    }

                case SET:
                  if (pattern473 (x5, pnum_clobbers) != 0
                      || !indirect_call_operand (operands[1], E_DImode)
                      || !unspec_tls (operands[2], E_DImode))
                    return -1;
                  x10 = XEXP (x5, 1);
                  x11 = XVECEXP (x10, 0, 0);
                  operands[4] = x11;
                  if (!const_int_operand (operands[4], E_DImode)
                      || !(
#line 11806 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 784; /* *call_value_indirect_elfv2di */

                case SIMPLE_RETURN:
                  if (!indirect_call_operand (operands[1], E_DImode)
                      || !(
#line 12016 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 791; /* *sibcall_value_indirect_nonlocal_sysvdi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x3, 0) != 2)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          x12 = XVECEXP (x3, 0, 0);
          operands[1] = x12;
          x13 = XVECEXP (x3, 0, 1);
          operands[2] = x13;
          switch (XINT (x3, 1))
            {
            case 35:
              if (GET_MODE (x3) != E_CCEQmode)
                return -1;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != SET)
                return -1;
              x14 = XEXP (x4, 1);
              if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || !cc_reg_operand (operands[0], E_CCEQmode)
                  || !memory_operand (operands[1], E_DImode)
                  || !memory_operand (operands[2], E_DImode))
                return -1;
              x8 = XEXP (x4, 0);
              operands[4] = x8;
              if (!scratch_operand (operands[4], E_DImode))
                return -1;
              x9 = XEXP (x5, 0);
              operands[3] = x9;
              if (!scratch_operand (operands[3], E_DImode))
                return -1;
              return 799; /* stack_protect_testdi */

            case 145:
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != CLOBBER)
                return -1;
              switch (pattern457 (x1))
                {
                case 0:
                  if (!
#line 3658 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode) && TARGET_DIRECT_MOVE_64BIT))
                    return -1;
                  return 1389; /* vsx_extract_v2df_var */

                case 1:
                  if (!
#line 3658 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && TARGET_DIRECT_MOVE_64BIT))
                    return -1;
                  return 1390; /* vsx_extract_v2di_var */

                case 2:
                  if (!
#line 3745 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_DIRECT_MOVE_64BIT))
                    return -1;
                  return 1395; /* vsx_extract_v4sf_var */

                case 3:
                  if (!
#line 4185 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT))
                    return -1;
                  return 1416; /* vsx_extract_v16qi_var */

                case 4:
                  if (!
#line 4185 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT))
                    return -1;
                  return 1417; /* vsx_extract_v8hi_var */

                case 5:
                  if (!
#line 4185 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
                    return -1;
                  return 1418; /* vsx_extract_v4si_var */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case EQ:
          switch (pattern104 (x1))
            {
            case 0:
              if (!
#line 12928 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)))
                return -1;
              return 852; /* *eqsi3 */

            case 1:
              if (!(
#line 12928 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 853; /* *eqdi3 */

            case 2:
              if (!(
#line 13220 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 861; /* *eqsi3_extdi */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[0] = x3;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x6 = XEXP (x2, 0);
          if (GET_CODE (x6) != PC)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != USE)
            return -1;
          x8 = XEXP (x4, 0);
          if (GET_CODE (x8) != LABEL_REF)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x15 = XEXP (x8, 0);
          operands[1] = x15;
          x9 = XEXP (x5, 0);
          operands[2] = x9;
          if (!cc_reg_operand (operands[2], E_CCmode)
              || !(
#line 13656 "../../gcc/config/rs6000/rs6000.md"
(!rs6000_speculate_indirect_jumps) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 899; /* tablejumpdi_insn_nospec */

        case UNSPEC_VOLATILE:
          if (XVECLEN (x3, 0) != 1
              || XINT (x3, 1) != 6
              || GET_MODE (x3) != E_DImode)
            return -1;
          x12 = XVECEXP (x3, 0, 0);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          if (!gpc_reg_operand (operands[0], E_DImode))
            return -1;
          x8 = XEXP (x4, 0);
          operands[1] = x8;
          if (!scratch_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x5, 0);
          operands[2] = x9;
          if (!scratch_operand (operands[2], E_CCmode)
              || !
#line 14589 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64))
            return -1;
          return 949; /* rs6000_get_timebase_ppc32 */

        case VEC_SELECT:
          switch (pattern106 (x1))
            {
            case 0:
              if (!
#line 4049 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_VEXTRACTUB))
                return -1;
              return 1407; /* *vsx_extract_v16qi_store_p9 */

            case 1:
              if (!
#line 4049 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_VEXTRACTUB))
                return -1;
              return 1408; /* *vsx_extract_v8hi_store_p9 */

            case 2:
              if (!
#line 4049 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_VEXTRACTUB))
                return -1;
              return 1409; /* *vsx_extract_v4si_store_p9 */

            default:
              return -1;
            }

        case PLUS:
          if (pattern107 (x1) != 0
              || !
#line 4949 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1523; /* vsx_reduc_plus_v4sf */

        case SMIN:
          if (pattern107 (x1) != 0
              || !
#line 4949 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1524; /* vsx_reduc_smin_v4sf */

        case SMAX:
          if (pattern107 (x1) != 0
              || !
#line 4949 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1525; /* vsx_reduc_smax_v4sf */

        case FLOAT_TRUNCATE:
          if (GET_MODE (x3) != E_SDmode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          if (!gpc_reg_operand (operands[0], E_SDmode))
            return -1;
          x7 = XEXP (x3, 0);
          operands[1] = x7;
          if (!gpc_reg_operand (operands[1], E_TDmode))
            return -1;
          x8 = XEXP (x4, 0);
          operands[2] = x8;
          if (!scratch_operand (operands[2], E_TDmode))
            return -1;
          x9 = XEXP (x5, 0);
          operands[3] = x9;
          if (!scratch_operand (operands[3], E_DFmode)
              || !
#line 165 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2278; /* trunctdsd2 */

        default:
          return -1;
        }

    case CALL:
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != E_SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x16 = XEXP (x6, 0);
      operands[0] = x16;
      x3 = XEXP (x2, 1);
      operands[1] = x3;
      x8 = XEXP (x4, 0);
      operands[2] = x8;
      switch (GET_CODE (operands[0]))
        {
        case SYMBOL_REF:
          x5 = XVECEXP (x1, 0, 2);
          switch (pattern428 (x5, pnum_clobbers))
            {
            case 0:
              if (!immediate_operand (operands[2], E_SImode))
                return -1;
              if (current_file_function_operand (operands[0], E_DImode)
                  && (
#line 11491 "../../gcc/config/rs6000/rs6000.md"
((INTVAL (operands[2]) & CALL_LONG) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return 769; /* *call_localdi */
              if (!symbol_ref_operand (operands[0], E_DImode))
                return -1;
              if ((
#line 11567 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_DARWIN
   || (DEFAULT_ABI == ABI_V4
       && (INTVAL (operands[2]) & CALL_LONG) == 0))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return 772; /* *call_nonlocal_sysvdi */
              if (!(
#line 11688 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2)
   && (INTVAL (operands[2]) & CALL_LONG) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 777; /* *call_nonlocal_aixdi */

            case 1:
              if (!symbol_ref_operand (operands[0], E_DImode)
                  || !immediate_operand (operands[2], E_SImode))
                return -1;
              x9 = XEXP (x5, 0);
              operands[3] = x9;
              if (!register_operand (operands[3], E_SImode)
                  || !(
#line 11588 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_V4
    && TARGET_SECURE_PLT && flag_pic && !SYMBOL_REF_LOCAL_P (operands[0])
    && (INTVAL (operands[2]) & CALL_LONG) == 0)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 773; /* *call_nonlocal_sysv_securedi */

            case 2:
              if (current_file_function_operand (operands[0], E_DImode)
                  && immediate_operand (operands[2], E_SImode)
                  && (
#line 11930 "../../gcc/config/rs6000/rs6000.md"
((INTVAL (operands[2]) & CALL_LONG) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return 787; /* *sibcall_localdi */
              if (!symbol_ref_operand (operands[0], E_DImode)
                  || !immediate_operand (operands[2], E_VOIDmode)
                  || !(
#line 11995 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_DARWIN
    || DEFAULT_ABI == ABI_V4)
   && (INTVAL (operands[2]) & CALL_LONG) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 790; /* *sibcall_nonlocal_sysvdi */

            default:
              return -1;
            }

        case UNSPEC:
        case REG:
          if (!immediate_operand (operands[2], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          switch (GET_CODE (x5))
            {
            case CLOBBER:
              x9 = XEXP (x5, 0);
              if (GET_CODE (x9) != REG
                  || REGNO (x9) != 96)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (!indirect_call_operand (operands[0], E_DImode)
                      || GET_MODE (x9) != E_DImode)
                    return -1;
                  if ((
#line 11539 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return 771; /* *call_indirect_nonlocal_sysvdi */
                  if (!(
#line 11786 "../../gcc/config/rs6000/rs6000.md"
(rs6000_pcrel_p ()) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 783; /* *call_indirect_pcreldi */

                case E_SImode:
                  if (!indirect_call_operand (operands[0], E_SImode)
                      || GET_MODE (x9) != E_SImode
                      || !(
#line 11786 "../../gcc/config/rs6000/rs6000.md"
(rs6000_pcrel_p ()) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 782; /* *call_indirect_pcrelsi */

                default:
                  return -1;
                }

            case SET:
              if (pattern473 (x5, pnum_clobbers) != 0
                  || !indirect_call_operand (operands[0], E_DImode))
                return -1;
              x10 = XEXP (x5, 1);
              x11 = XVECEXP (x10, 0, 0);
              operands[3] = x11;
              if (!const_int_operand (operands[3], E_DImode)
                  || !(
#line 11770 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 781; /* *call_indirect_elfv2di */

            case SIMPLE_RETURN:
              if (!indirect_call_operand (operands[0], E_DImode)
                  || !(
#line 11967 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 789; /* *sibcall_indirect_nonlocal_sysvdi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_18 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case SIGN_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case MEM:
          operands[1] = x4;
          if (!indexed_or_indirect_operand (operands[1], E_HImode))
            return NULL;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!altivec_register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !
#line 1106 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && reload_completed))
                return NULL;
              return gen_split_15 (insn, operands);

            case E_DImode:
              if (!altivec_register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !(
#line 1106 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && reload_completed) && 
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return NULL;
              return gen_split_16 (insn, operands);

            default:
              return NULL;
            }

        case REG:
        case SUBREG:
          operands[1] = x4;
          if (vsx_register_operand (operands[1], E_SImode)
              && int_reg_operand (operands[0], E_DImode)
              && GET_MODE (x2) == E_DImode
              && (
#line 1180 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT && reload_completed) && 
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return gen_split_21 (insn, operands);
          if (!altivec_register_operand (operands[1], E_SImode)
              || !altivec_register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !
#line 1192 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && !TARGET_P9_VECTOR && reload_completed))
            return NULL;
          return gen_split_22 (insn, operands);

        case PLUS:
          if (pattern35 (x2) != 0
              || !(
#line 2388 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 2390 "../../gcc/config/rs6000/rs6000.md"
(1)))
            return NULL;
          return gen_split_45 (insn, operands);

        default:
          return NULL;
        }

    case BSWAP:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!gpc_reg_operand (operands[0], E_SImode))
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !
#line 2708 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_POWER10 && int_reg_operand (operands[0], SImode)))
        return NULL;
      return gen_split_51 (insn, operands);

    case ASHIFT:
      if (GET_MODE (x2) != E_DImode)
        return NULL;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != SIGN_EXTEND
          || GET_MODE (x4) != E_DImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!gpc_reg_operand (operands[0], E_DImode))
        return NULL;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!reg_or_mem_operand (operands[1], E_SImode))
        return NULL;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (!u6bit_cint_operand (operands[2], E_DImode)
          || !(
#line 4707 "../../gcc/config/rs6000/rs6000.md"
(TARGET_EXTSWSLI) && 
#line 4711 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && MEM_P (operands[1]))))
        return NULL;
      return gen_split_137 (insn, operands);

    case DIV:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], E_VOIDmode))
        return NULL;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (!gpc_reg_operand (operands[2], E_VOIDmode))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!gpc_reg_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !
#line 4984 "../../gcc/config/rs6000/rs6000.md"
(RS6000_RECIP_AUTO_RE_P (SFmode)
   && can_create_pseudo_p () && flag_finite_math_only
   && !flag_trapping_math && flag_reciprocal_math))
            return NULL;
          return gen_split_148 (insn, operands);

        case E_DFmode:
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !
#line 4984 "../../gcc/config/rs6000/rs6000.md"
(RS6000_RECIP_AUTO_RE_P (DFmode)
   && can_create_pseudo_p () && flag_finite_math_only
   && !flag_trapping_math && flag_reciprocal_math))
            return NULL;
          return gen_split_149 (insn, operands);

        case E_V4SFmode:
          if (!gpc_reg_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !
#line 4984 "../../gcc/config/rs6000/rs6000.md"
(RS6000_RECIP_AUTO_RE_P (V4SFmode)
   && can_create_pseudo_p () && flag_finite_math_only
   && !flag_trapping_math && flag_reciprocal_math))
            return NULL;
          return gen_split_150 (insn, operands);

        case E_V2DFmode:
          if (!gpc_reg_operand (operands[0], E_V2DFmode)
              || GET_MODE (x2) != E_V2DFmode
              || !
#line 4984 "../../gcc/config/rs6000/rs6000.md"
(RS6000_RECIP_AUTO_RE_P (V2DFmode)
   && can_create_pseudo_p () && flag_finite_math_only
   && !flag_trapping_math && flag_reciprocal_math))
            return NULL;
          return gen_split_151 (insn, operands);

        default:
          return NULL;
        }

    case FLOAT_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !reg_or_mem_operand (operands[1], E_SFmode)
              || !(
#line 5241 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && !HONOR_SNANS (SFmode)) && 
#line 5250 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && REG_P (operands[1]) && REGNO (operands[0]) == REGNO (operands[1]))))
            return NULL;
          return gen_split_152 (insn, operands);

        case E_IFmode:
          switch (pattern196 (x2))
            {
            case 0:
              if (!((
#line 8930 "../../gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128 && TARGET_VSX) && 
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))) && 
#line 8932 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_324 (insn, operands);

            case 1:
              if (!(
#line 9461 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (IFmode)) && 
#line 9464 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_338 (insn, operands);

            default:
              return NULL;
            }

        case E_TFmode:
          if (GET_MODE (x2) != E_TFmode)
            return NULL;
          if (gpc_reg_operand (operands[0], E_TFmode))
            {
              switch (pattern299 ())
                {
                case 0:
                  if (((
#line 8930 "../../gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128 && TARGET_VSX) && 
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))) && 
#line 8932 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return gen_split_325 (insn, operands);
                  break;

                case 1:
                  if ((
#line 9448 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (IFmode)) && 
#line 9451 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return gen_split_336 (insn, operands);
                  break;

                case 2:
                  if ((
#line 9448 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (KFmode)) && 
#line 9451 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return gen_split_337 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          if (!vsx_register_operand (operands[0], E_TFmode)
              || !vsx_register_operand (operands[1], E_KFmode)
              || !(
#line 15211 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && TARGET_IEEEQUAD) && 
#line 15215 "../../gcc/config/rs6000/rs6000.md"
( reload_completed  && REGNO (operands[0]) == REGNO (operands[1]))))
            return NULL;
          return gen_split_488 (insn, operands);

        case E_KFmode:
          if (GET_MODE (x2) != E_KFmode)
            return NULL;
          if (gpc_reg_operand (operands[0], E_KFmode)
              && gpc_reg_operand (operands[1], E_TFmode)
              && (
#line 9461 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (KFmode)) && 
#line 9464 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return gen_split_339 (insn, operands);
          if (!vsx_register_operand (operands[0], E_KFmode)
              || !vsx_register_operand (operands[1], E_TFmode)
              || !(
#line 15227 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && TARGET_IEEEQUAD) && 
#line 15231 "../../gcc/config/rs6000/rs6000.md"
( reload_completed  && REGNO (operands[0]) == REGNO (operands[1]))))
            return NULL;
          return gen_split_489 (insn, operands);

        default:
          return NULL;
        }

    case SMIN:
      switch (pattern20 (x1))
        {
        case 0:
          if (!(
#line 5515 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_MINMAX) && 
#line 5517 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_157 (insn, operands);

        case 1:
          if (!(
#line 5515 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_MINMAX) && 
#line 5517 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_159 (insn, operands);

        default:
          return NULL;
        }

    case SMAX:
      switch (pattern20 (x1))
        {
        case 0:
          if (!(
#line 5515 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_MINMAX) && 
#line 5517 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_158 (insn, operands);

        case 1:
          if (!(
#line 5515 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_MINMAX) && 
#line 5517 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_160 (insn, operands);

        default:
          return NULL;
        }

    case AND:
    case IOR:
    case XOR:
      return split_16 (x1, insn);

    case NOT:
      return split_17 (x1, insn);

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case SYMBOL_REF:
    case VEC_DUPLICATE:
      return split_15 (x1, insn);

    case FLOAT_TRUNCATE:
      if (GET_MODE (x2) != E_DFmode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!gpc_reg_operand (operands[0], E_DFmode))
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[1]))
        {
        case E_IFmode:
          if (!gpc_reg_operand (operands[1], E_IFmode)
              || !((
#line 8978 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))) && 
#line 8983 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && REGNO (operands[0]) == REGNO (operands[1]))))
            return NULL;
          return gen_split_326 (insn, operands);

        case E_TFmode:
          if (!gpc_reg_operand (operands[1], E_TFmode)
              || !((
#line 8978 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))) && 
#line 8983 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && REGNO (operands[0]) == REGNO (operands[1]))))
            return NULL;
          return gen_split_327 (insn, operands);

        default:
          return NULL;
        }

    case UNSPEC:
    case PLUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (GET_CODE (x2))
        {
        case PLUS:
          x4 = XEXP (x2, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              operands[1] = x4;
              x6 = XEXP (x2, 1);
              operands[2] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern344 (x2, 
E_SImode) == 0)
                    return gen_split_33 (insn, operands);
                  break;

                case E_DImode:
                  if (pattern344 (x2, 
E_DImode) == 0
                      && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    return gen_split_34 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case AND:
              x6 = XEXP (x2, 1);
              if (GET_CODE (x6) == ASHIFT)
                {
                  switch (pattern210 (x2))
                    {
                    case 0:
                      if ((
#line 4333 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)) && 
#line 4336 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                        return gen_split_105 (insn, operands);
                      break;

                    case 1:
                      if (((
#line 4333 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4336 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                        return gen_split_107 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              break;

            case ASHIFT:
              switch (pattern198 (x2))
                {
                case 0:
                  if (
#line 4348 "../../gcc/config/rs6000/rs6000.md"
(nonzero_bits (operands[3], SImode)
   < HOST_WIDE_INT_1U << INTVAL (operands[2])))
                    return gen_split_109 (insn, operands);
                  break;

                case 1:
                  if ((
#line 4348 "../../gcc/config/rs6000/rs6000.md"
(nonzero_bits (operands[3], DImode)
   < HOST_WIDE_INT_1U << INTVAL (operands[2])) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return gen_split_112 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
          break;

        case UNSPEC:
          res = split_14 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        default:
          break;
        }
      operands[1] = x2;
      switch (pattern67 ())
        {
        case 0:
          if (((
#line 11337 "../../gcc/config/rs6000/rs6000.md"
(TARGET_TOC
    && legitimate_constant_pool_address_p (operands[1], QImode, false)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 11340 "../../gcc/config/rs6000/rs6000.md"
( TARGET_CMODEL != CMODEL_SMALL && reload_completed)))
            return gen_split_395 (insn, operands);
          break;

        case 1:
          if (((
#line 11337 "../../gcc/config/rs6000/rs6000.md"
(TARGET_TOC
    && legitimate_constant_pool_address_p (operands[1], QImode, false)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 11340 "../../gcc/config/rs6000/rs6000.md"
( TARGET_CMODEL != CMODEL_SMALL && reload_completed)))
            return gen_split_396 (insn, operands);
          break;

        default:
          break;
        }
      if (!nonimmediate_operand (operands[0], E_DImode)
          || GET_CODE (x2) != UNSPEC
          || XVECLEN (x2, 0) != 2
          || XINT (x2, 1) != 70
          || GET_MODE (x2) != E_DImode)
        return NULL;
      x7 = XVECEXP (x2, 0, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_TDmode))
        return NULL;
      x8 = XVECEXP (x2, 0, 1);
      operands[2] = x8;
      if (!const_0_to_1_operand (operands[2], E_QImode))
        return NULL;
      if (((
#line 14881 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (TDmode)) && 
#line 545 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)) && 
#line 14883 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return gen_split_480 (insn, operands);
      if (!((
#line 14904 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (TDmode)) && 
#line 545 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)) && 
#line 14906 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return NULL;
      return gen_split_483 (insn, operands);

    case ORDERED:
      switch (pattern13 (x1))
        {
        case 0:
          if (!(
#line 13282 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13284 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_452 (insn, operands);

        case 1:
          if (!((
#line 13282 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13284 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_456 (insn, operands);

        case 2:
          if (!(
#line 653 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 655 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_543 (insn, operands);

        case 3:
          if (!(
#line 653 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 655 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_547 (insn, operands);

        default:
          return NULL;
        }

    case NE:
      switch (pattern13 (x1))
        {
        case 0:
          if (!(
#line 13282 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13284 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_453 (insn, operands);

        case 1:
          if (!((
#line 13282 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13284 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_457 (insn, operands);

        case 2:
          if (!(
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_528 (insn, operands);

        case 3:
          if (!(
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_535 (insn, operands);

        default:
          return NULL;
        }

    case UNLE:
      switch (pattern13 (x1))
        {
        case 0:
          if (!(
#line 13282 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13284 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_454 (insn, operands);

        case 1:
          if (!((
#line 13282 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13284 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_458 (insn, operands);

        case 2:
          if (!(
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_532 (insn, operands);

        case 3:
          if (!(
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_539 (insn, operands);

        default:
          return NULL;
        }

    case UNGE:
      switch (pattern13 (x1))
        {
        case 0:
          if (!(
#line 13282 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13284 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_455 (insn, operands);

        case 1:
          if (!((
#line 13282 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13284 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_459 (insn, operands);

        case 2:
          if (!(
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_530 (insn, operands);

        case 3:
          if (!(
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_537 (insn, operands);

        default:
          return NULL;
        }

    case LTGT:
      switch (pattern13 (x1))
        {
        case 0:
          if (!(
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13302 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_460 (insn, operands);

        case 1:
          if (!((
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13302 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_466 (insn, operands);

        case 2:
          if (!(
#line 653 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 655 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_540 (insn, operands);

        case 3:
          if (!(
#line 653 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 655 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_544 (insn, operands);

        default:
          return NULL;
        }

    case LE:
      switch (pattern13 (x1))
        {
        case 0:
          if (!(
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13302 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_461 (insn, operands);

        case 1:
          if (!((
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13302 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_467 (insn, operands);

        case 2:
          if (!(
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_527 (insn, operands);

        case 3:
          if (!(
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_534 (insn, operands);

        default:
          return NULL;
        }

    case GE:
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!cc_reg_operand (operands[1], E_CCFPmode))
        return NULL;
      switch (pattern9 (x2))
        {
        case 0:
          if (!(
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13302 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_462 (insn, operands);

        case 1:
          if (!((
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13302 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_468 (insn, operands);

        default:
          return NULL;
        }

    case UNLT:
      switch (pattern13 (x1))
        {
        case 0:
          if (!(
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13302 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_463 (insn, operands);

        case 1:
          if (!((
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13302 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_469 (insn, operands);

        case 2:
          if (!(
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_531 (insn, operands);

        case 3:
          if (!(
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_538 (insn, operands);

        default:
          return NULL;
        }

    case UNGT:
      switch (pattern13 (x1))
        {
        case 0:
          if (!(
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13302 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_464 (insn, operands);

        case 1:
          if (!((
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13302 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_470 (insn, operands);

        case 2:
          if (!(
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_529 (insn, operands);

        case 3:
          if (!(
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_536 (insn, operands);

        default:
          return NULL;
        }

    case UNEQ:
      switch (pattern13 (x1))
        {
        case 0:
          if (!(
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13302 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_465 (insn, operands);

        case 1:
          if (!((
#line 13300 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13302 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_471 (insn, operands);

        case 2:
          if (!(
#line 653 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 655 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_541 (insn, operands);

        case 3:
          if (!(
#line 653 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 655 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_545 (insn, operands);

        default:
          return NULL;
        }

    case IF_THEN_ELSE:
      x4 = XEXP (x2, 0);
      if (!extra_insn_branch_comparison_operator (x4, E_VOIDmode)
          || pattern28 (x1) != 0
          || !(
#line 13342 "../../gcc/config/rs6000/rs6000.md"
(!flag_finite_math_only) && 
#line 13344 "../../gcc/config/rs6000/rs6000.md"
( 1)))
        return NULL;
      return gen_split_472 (insn, operands);

    case COMPARE:
      if (GET_MODE (x2) != E_CCEQmode)
        return NULL;
      x4 = XEXP (x2, 0);
      if (!branch_comparison_operator (x4, E_VOIDmode))
        return NULL;
      operands[1] = x4;
      x9 = XEXP (x4, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x6 = XEXP (x2, 1);
      if (!branch_comparison_operator (x6, E_VOIDmode))
        return NULL;
      operands[3] = x6;
      x10 = XEXP (x6, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!cc_reg_operand (operands[0], E_CCEQmode))
        return NULL;
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (!cc_reg_operand (operands[2], E_VOIDmode))
        return NULL;
      x11 = XEXP (x6, 0);
      operands[4] = x11;
      if (!cc_reg_operand (operands[4], E_VOIDmode))
        return NULL;
      return gen_split_473 (insn, operands);

    case LT:
      switch (pattern21 (x1))
        {
        case 0:
          if (!(
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_526 (insn, operands);

        case 1:
          if (!(
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 608 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_533 (insn, operands);

        default:
          return NULL;
        }

    case UNORDERED:
      switch (pattern21 (x1))
        {
        case 0:
          if (!(
#line 653 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()) && 
#line 655 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_542 (insn, operands);

        case 1:
          if (!(
#line 653 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()) && 
#line 655 "../../gcc/config/rs6000/vector.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_546 (insn, operands);

        default:
          return NULL;
        }

    case ROTATE:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != ROTATE)
        return NULL;
      x9 = XEXP (x4, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return NULL;
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern206 (x2))
        {
        case 0:
          if (!(
#line 1021 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX) && 
#line 1025 "../../gcc/config/rs6000/vsx.md"
( 1)))
            return NULL;
          return gen_split_567 (insn, operands);

        case 1:
          if (!(
#line 1021 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX) && 
#line 1025 "../../gcc/config/rs6000/vsx.md"
( 1)))
            return NULL;
          return gen_split_568 (insn, operands);

        default:
          return NULL;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 4
          || pattern29 (x1) != 0
          || !(
#line 433 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA
   && fpr_reg_operand (operands[0], XOmode)) && 
#line 436 "../../gcc/config/rs6000/mma.md"
( reload_completed)))
        return NULL;
      return gen_split_723 (insn, operands);

    default:
      return NULL;
    }
}
