/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  switch (XWINT (x2, 0))
    {
    case 0L:
      x3 = XVECEXP (x1, 0, 1);
      if (XWINT (x3, 0) != 2L)
        return -1;
      return 0;

    case 1L:
      x3 = XVECEXP (x1, 0, 1);
      if (XWINT (x3, 0) != 3L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern3 (x3, 
E_V4SImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern3 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern3 (x3, 
E_V16QImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern3 (x3, 
E_V2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern26 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!reg_or_cint_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern31 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_CODE (x1) != MEM
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  return pattern30 (x2); /* [-1, 1] */
}

int
pattern35 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 98
      || pattern34 (x1, 
E_DImode, 
-1, 
E_SImode) != 0)
    return -1;
  return 0;
}

int
pattern37 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern44 (rtx x1, machine_mode i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  x6 = XEXP (x2, 2);
  if (GET_CODE (x6) != IF_THEN_ELSE)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i2)
    return -1;
  x8 = XEXP (x7, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x9 = XEXP (x6, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x10 = XEXP (x6, 2);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x11 = XEXP (x1, 0);
  operands[0] = x11;
  if (!gpc_reg_operand (operands[0], E_SImode)
      || GET_MODE (x2) != E_SImode)
    return -1;
  x12 = XEXP (x3, 0);
  operands[1] = x12;
  if (!cc_reg_operand (operands[1], i1))
    return -1;
  x13 = XEXP (x7, 0);
  if (!rtx_equal_p (x13, operands[1]))
    return -1;
  return 0;
}

int
pattern61 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  return pattern59 (x3); /* [-1, 23] */
}

int
pattern65 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i3)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern68 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != AND
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + -16])
    return -1;
  x3 = XEXP (x1, 0);
  return pattern32 (x3); /* [-1, 1] */
}

int
pattern71 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!indexed_or_indirect_operand (operands[1], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern82 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V2DFmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != VEC_CONCAT
      || GET_MODE (x4) != E_V2DFmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != VEC_SELECT
      || GET_MODE (x5) != E_DFmode)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL
      || XVECLEN (x6, 0) != 1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x8 = XEXP (x4, 1);
  if (GET_CODE (x8) != VEC_SELECT
      || GET_MODE (x8) != E_DFmode)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != PARALLEL
      || XVECLEN (x9, 0) != 1)
    return -1;
  x10 = XVECEXP (x9, 0, 0);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x11 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x11) != CLOBBER)
    return -1;
  x12 = XEXP (x2, 0);
  operands[0] = x12;
  if (!vfloat_operand (operands[0], E_V2DFmode)
      || pattern81 (x1) != 0)
    return -1;
  return 0;
}

int
pattern97 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!reg_or_indexed_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!reg_or_indexed_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern104 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  x9 = XEXP (x2, 0);
  operands[3] = x9;
  x10 = XEXP (x3, 0);
  operands[4] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x6) != E_SImode
          || pattern103 (
E_SImode) != 0)
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x6) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (pattern103 (
E_DImode) != 0)
            return -1;
          return 1;

        case E_SImode:
          if (pattern103 (
E_SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern116 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != LABEL_REF)
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != PLUS
      || GET_MODE (x8) != E_DImode)
    return -1;
  x9 = XEXP (x8, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  x10 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x11) != CLOBBER)
    return -1;
  return 0;
}

int
pattern127 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !reg_or_u_short_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !reg_or_u_short_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern136 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern142 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern148 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern147 (x3, 
E_V2DImode, 
E_V4SImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern147 (x3, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern147 (x3, 
E_V8HImode, 
E_V16QImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern159 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V1TImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V1TImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_V1TImode))
    return -1;
  return 0;
}

int
pattern165 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_XOmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!fpr_reg_operand (operands[0], E_XOmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!fpr_reg_operand (operands[1], E_XOmode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!vsx_register_operand (operands[2], i1))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!vsx_register_operand (operands[3], E_V16QImode))
    return -1;
  return 0;
}

int
pattern171 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !gpc_reg_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern179 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern185 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != NOT)
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern184 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern184 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern189 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PLUS)
    return -1;
  x8 = XEXP (x2, 0);
  operands[3] = x8;
  x9 = XEXP (x5, 0);
  operands[1] = x9;
  x10 = XEXP (x5, 1);
  operands[2] = x10;
  x11 = XEXP (x6, 0);
  operands[0] = x11;
  x12 = XEXP (x7, 0);
  if (!rtx_equal_p (x12, operands[1]))
    return -1;
  x13 = XEXP (x7, 1);
  if (!rtx_equal_p (x13, operands[2]))
    return -1;
  return 0;
}

int
pattern199 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (XINT (x1, 1) != 444)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!int_reg_operand (operands[2], E_DImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return 0;

    case E_SImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern210 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  return pattern209 (x1); /* [-1, 1] */
}

int
pattern214 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!c32bit_cint_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode)
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern221 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x11) != CONST_INT)
    return -1;
  x12 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x12) != CONST_INT)
    return -1;
  x13 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x13) != CONST_INT)
    return -1;
  x14 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x14) != CONST_INT)
    return -1;
  x15 = XVECEXP (x1, 0, 13);
  if (GET_CODE (x15) != CONST_INT)
    return -1;
  x16 = XVECEXP (x1, 0, 14);
  if (GET_CODE (x16) != CONST_INT)
    return -1;
  x17 = XVECEXP (x1, 0, 15);
  if (GET_CODE (x17) != CONST_INT)
    return -1;
  return 0;
}

int
pattern241 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern248 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  return pattern247 (x1); /* [-1, 1] */
}

int
pattern251 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 440
      || GET_MODE (x5) != E_BLKmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[1] = x6;
  if (!cc_reg_operand (operands[1], E_CCmode))
    return -1;
  x7 = XVECEXP (x3, 0, 0);
  operands[0] = x7;
  return 0;
}

int
pattern256 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !non_logical_cint_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern258 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  operands[1] = x1;
  if (!any_operand (operands[1], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!gpc_reg_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  return 0;
}

int
pattern265 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern271 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern269 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern269 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern270 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern270 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern270 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern270 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern270 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern270 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern270 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern270 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern270 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern270 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern286 (rtx x1, machine_mode i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != i2
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern294 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!scratch_operand (operands[2], E_V16QImode))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  return pattern293 (x5); /* [-1, 1] */
}

int
pattern300 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!vlogical_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vlogical_operand (operands[1], i1)
      || !vlogical_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern306 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != NOT)
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern305 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern305 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern317 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!indexed_or_indirect_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!indexed_or_indirect_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern325 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !altivec_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern334 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[3] = x5;
  if (!const_0_to_1_operand (operands[3], E_QImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x6))
    {
    case CLOBBER:
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 106
          || GET_MODE (x7) != E_CCFPmode)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V1TImode:
          return pattern333 (x3, 
E_V1TImode); /* [-1, 0] */

        case E_V16QImode:
          if (pattern333 (x3, 
E_V16QImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case SET:
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != COMPARE
          || GET_MODE (x8) != E_CCFPmode)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != UNSPEC
          || XVECLEN (x9, 0) != 3
          || XINT (x9, 1) != i1
          || GET_MODE (x9) != E_V2DFmode)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 106
          || GET_MODE (x7) != E_CCFPmode)
        return -1;
      x10 = XEXP (x8, 1);
      operands[4] = x10;
      if (!zero_constant (operands[4], E_V2DFmode))
        return -1;
      x11 = XVECEXP (x9, 0, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      x12 = XVECEXP (x9, 0, 1);
      if (!rtx_equal_p (x12, operands[2]))
        return -1;
      x13 = XVECEXP (x9, 0, 2);
      if (!rtx_equal_p (x13, operands[3]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V1TImode:
          if (pattern333 (x3, 
E_V1TImode) != 0)
            return -1;
          return 2;

        case E_V16QImode:
          if (pattern333 (x3, 
E_V16QImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern366 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!boolean_operator (operands[3], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern374 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x1, 1);
  return pattern373 (x4, 
i1); /* [-1, 0] */
}

int
pattern383 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern381 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern381 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern382 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern382 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern382 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern382 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern382 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern382 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern382 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern382 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern382 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern382 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern396 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PC)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PLUS
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  return 0;
}

int
pattern400 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern409 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern407 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern407 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern408 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern408 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern408 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern408 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern408 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern408 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern408 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern408 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern408 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern408 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern428 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case CLOBBER:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != REG
          || REGNO (x2) != 96
          || GET_MODE (x2) != E_DImode)
        return -1;
      return 0;

    case USE:
      if (pnum_clobbers == NULL)
        return -1;
      return 1;

    case SIMPLE_RETURN:
      return 2;

    default:
      return -1;
    }
}

int
pattern435 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !rotate_mask_operator (operands[4], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !const_int_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern440 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern448 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern457 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[2], E_DImode))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  if (!scratch_operand (operands[3], E_DImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  if (!scratch_operand (operands[4], E_V2DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (GET_MODE (x7) != E_DFmode
          || !gpc_reg_operand (operands[1], E_V2DFmode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (GET_MODE (x7) != E_DImode
          || !gpc_reg_operand (operands[1], E_V2DImode))
        return -1;
      return 1;

    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (GET_MODE (x7) != E_SFmode
          || !gpc_reg_operand (operands[1], E_V4SFmode))
        return -1;
      return 2;

    case E_QImode:
      if (!gpc_reg_operand (operands[0], E_QImode))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (GET_MODE (x7) != E_QImode
          || !gpc_reg_operand (operands[1], E_V16QImode))
        return -1;
      return 3;

    case E_HImode:
      if (!gpc_reg_operand (operands[0], E_HImode))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (GET_MODE (x7) != E_HImode
          || !gpc_reg_operand (operands[1], E_V8HImode))
        return -1;
      return 4;

    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (GET_MODE (x7) != E_SImode
          || !gpc_reg_operand (operands[1], E_V4SImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern489 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  operands[2] = x6;
  if (!reg_or_cint_operand (operands[2], E_SImode))
    return -1;
  x7 = XEXP (x4, 1);
  operands[3] = x7;
  x8 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x8))
    {
    case CLOBBER:
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          return pattern487 (
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern487 (
E_DImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case SET:
      x10 = XEXP (x8, 1);
      if (GET_CODE (x10) != AND)
        return -1;
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      x11 = XEXP (x10, 0);
      if (!rtx_equal_p (x11, operands[4]))
        return -1;
      x12 = XEXP (x10, 1);
      if (!rtx_equal_p (x12, operands[3]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (pattern488 (x10, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_DImode:
          if (pattern488 (x10, 
E_DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern510 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[1], E_V16QImode)
      || !vsx_register_operand (operands[2], E_V16QImode)
      || !const_0_to_15_operand (operands[3], E_SImode)
      || !const_0_to_3_operand (operands[5], E_SImode))
    return -1;
  return 0;
}

int
pattern513 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (!register_operand (x3, i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (!register_operand (x4, i1))
    return -1;
  return 0;
}

int
pattern525 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern536 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern546 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_DImode:
      if (!gpc_reg_operand (operands[2], E_DImode)
          || !memory_operand (operands[3], E_DImode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[2], E_DFmode)
          || !memory_operand (operands[3], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern557 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 1);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x11 = XEXP (x4, 0);
  x12 = XEXP (x11, 0);
  operands[1] = x12;
  x13 = XEXP (x5, 0);
  operands[2] = x13;
  if (!gpc_reg_operand (operands[2], E_SImode))
    return -1;
  x14 = XEXP (x8, 0);
  x15 = XEXP (x14, 0);
  if (!rtx_equal_p (x15, operands[1]))
    return -1;
  x16 = XEXP (x9, 0);
  if (!rtx_equal_p (x16, operands[2]))
    return -1;
  return 0;
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case AND:
      if (GET_MODE (x7) != E_DImode)
        return -1;
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      x10 = XEXP (x7, 1);
      operands[2] = x10;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x11 = XEXP (x3, 0);
      operands[3] = x11;
      if (!
#line 3906 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_rotate_dot_mask (operands[2], DImode)
  && TARGET_POWERPC64))
        return -1;
      *pnum_clobbers = 2;
      return 212; /* *branch_anddi3_dot */

    case REG:
    case SUBREG:
      operands[1] = x7;
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x11 = XEXP (x3, 0);
      operands[0] = x11;
      if (!
#line 7954 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && num_insns_constant (operands[2], DImode) > 1
   && (can_be_rotated_to_positive_16bits (INTVAL (operands[2]))
       || can_be_rotated_to_negative_15bits (INTVAL (operands[2])))))
        return -1;
      *pnum_clobbers = 2;
      return 561; /* *rotate_on_cmpdi */

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (branch_comparison_operator (operands[0], E_VOIDmode))
    {
      res = recog_12 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[1] = x3;
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (fpmask_comparison_operator (operands[1], E_CCFPmode))
    {
      res = recog_13 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (!cc_reg_operand (operands[2], E_VOIDmode))
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_CODE (x6) != LABEL_REF)
    return -1;
  x7 = XEXP (x2, 2);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x1, 0);
  if (GET_CODE (x8) != PC
      || !branch_comparison_operator (operands[1], E_VOIDmode))
    return -1;
  x9 = XEXP (x6, 0);
  operands[0] = x9;
  return 883; /* *cbranch */
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_CODE (operands[2]))
    {
    case CONST_INT:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern356 (
E_SImode) != 0)
            return -1;
          return 213; /* *boolsi3_imm */

        case E_DImode:
          if (pattern356 (
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 214; /* *booldi3_imm */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (pattern343 (
E_TImode) != 0)
            return -1;
          return 505; /* *boolti3_internal */

        case E_PTImode:
          if (pattern343 (
E_PTImode) != 0)
            return -1;
          return 506; /* *boolpti3_internal */

        case E_V16QImode:
          if (pattern343 (
E_V16QImode) != 0
              || !
#line 778 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 507; /* *boolv16qi3_internal */

        case E_V8HImode:
          if (pattern343 (
E_V8HImode) != 0
              || !
#line 779 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 508; /* *boolv8hi3_internal */

        case E_V4SImode:
          if (pattern343 (
E_V4SImode) != 0
              || !
#line 780 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 509; /* *boolv4si3_internal */

        case E_V4SFmode:
          if (pattern343 (
E_V4SFmode) != 0
              || !
#line 781 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 510; /* *boolv4sf3_internal */

        case E_V2DImode:
          if (pattern343 (
E_V2DImode) != 0
              || !
#line 782 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 511; /* *boolv2di3_internal */

        case E_V2DFmode:
          if (pattern343 (
E_V2DFmode) != 0
              || !
#line 783 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 512; /* *boolv2df3_internal */

        case E_V1TImode:
          if (pattern343 (
E_V1TImode) != 0
              || !
#line 784 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC))
            return -1;
          return 513; /* *boolv1ti3_internal */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case AND:
      switch (pattern275 (x3))
        {
        case 0:
          if (!
#line 835 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2426; /* *fuse_and_nand */

        case 1:
          if (!(
#line 835 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2427; /* *fuse_and_nand */

        case 2:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2782; /* *fuse_vand_vnand */

        case 3:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2783; /* *fuse_vand_vnand */

        case 4:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2784; /* *fuse_vand_vnand */

        case 5:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2785; /* *fuse_vand_vnand */

        case 6:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2786; /* *fuse_vand_vnand */

        case 7:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2787; /* *fuse_vand_vnand */

        case 8:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2788; /* *fuse_vand_vnand */

        case 9:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2789; /* *fuse_vand_vnand */

        case 10:
          if (!(
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2790; /* *fuse_vand_vnand */

        case 11:
          if (!(
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2791; /* *fuse_vand_vnand */

        case 12:
          if (!
#line 853 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2428; /* *fuse_andc_nand */

        case 13:
          if (!(
#line 853 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2429; /* *fuse_andc_nand */

        case 14:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2792; /* *fuse_vandc_vnand */

        case 15:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2793; /* *fuse_vandc_vnand */

        case 16:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2794; /* *fuse_vandc_vnand */

        case 17:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2795; /* *fuse_vandc_vnand */

        case 18:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2796; /* *fuse_vandc_vnand */

        case 19:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2797; /* *fuse_vandc_vnand */

        case 20:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2798; /* *fuse_vandc_vnand */

        case 21:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2799; /* *fuse_vandc_vnand */

        case 22:
          if (!(
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2800; /* *fuse_vandc_vnand */

        case 23:
          if (!(
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2801; /* *fuse_vandc_vnand */

        case 24:
          if (!
#line 907 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2434; /* *fuse_nor_nand */

        case 25:
          if (!(
#line 907 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2435; /* *fuse_nor_nand */

        case 26:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2822; /* *fuse_vnor_vnand */

        case 27:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2823; /* *fuse_vnor_vnand */

        case 28:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2824; /* *fuse_vnor_vnand */

        case 29:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2825; /* *fuse_vnor_vnand */

        case 30:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2826; /* *fuse_vnor_vnand */

        case 31:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2827; /* *fuse_vnor_vnand */

        case 32:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2828; /* *fuse_vnor_vnand */

        case 33:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2829; /* *fuse_vnor_vnand */

        case 34:
          if (!(
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2830; /* *fuse_vnor_vnand */

        case 35:
          if (!(
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2831; /* *fuse_vnor_vnand */

        default:
          return -1;
        }

    case NOT:
      switch (pattern278 (x3))
        {
        case 0:
          if (!
#line 871 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2430; /* *fuse_eqv_nand */

        case 1:
          if (!(
#line 871 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2431; /* *fuse_eqv_nand */

        case 2:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2802; /* *fuse_veqv_vnand */

        case 3:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2803; /* *fuse_veqv_vnand */

        case 4:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2804; /* *fuse_veqv_vnand */

        case 5:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2805; /* *fuse_veqv_vnand */

        case 6:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2806; /* *fuse_veqv_vnand */

        case 7:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2807; /* *fuse_veqv_vnand */

        case 8:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2808; /* *fuse_veqv_vnand */

        case 9:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2809; /* *fuse_veqv_vnand */

        case 10:
          if (!(
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2810; /* *fuse_veqv_vnand */

        case 11:
          if (!(
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2811; /* *fuse_veqv_vnand */

        default:
          return -1;
        }

    case IOR:
      switch (pattern279 (x3))
        {
        case 0:
          if (!
#line 889 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2432; /* *fuse_nand_nand */

        case 1:
          if (!(
#line 889 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2433; /* *fuse_nand_nand */

        case 2:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2812; /* *fuse_vnand_vnand */

        case 3:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2813; /* *fuse_vnand_vnand */

        case 4:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2814; /* *fuse_vnand_vnand */

        case 5:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2815; /* *fuse_vnand_vnand */

        case 6:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2816; /* *fuse_vnand_vnand */

        case 7:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2817; /* *fuse_vnand_vnand */

        case 8:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2818; /* *fuse_vnand_vnand */

        case 9:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2819; /* *fuse_vnand_vnand */

        case 10:
          if (!(
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2820; /* *fuse_vnand_vnand */

        case 11:
          if (!(
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2821; /* *fuse_vnand_vnand */

        case 12:
          if (!
#line 943 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2438; /* *fuse_orc_nand */

        case 13:
          if (!(
#line 943 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2439; /* *fuse_orc_nand */

        case 14:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2842; /* *fuse_vorc_vnand */

        case 15:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2843; /* *fuse_vorc_vnand */

        case 16:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2844; /* *fuse_vorc_vnand */

        case 17:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2845; /* *fuse_vorc_vnand */

        case 18:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2846; /* *fuse_vorc_vnand */

        case 19:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2847; /* *fuse_vorc_vnand */

        case 20:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2848; /* *fuse_vorc_vnand */

        case 21:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2849; /* *fuse_vorc_vnand */

        case 22:
          if (!(
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2850; /* *fuse_vorc_vnand */

        case 23:
          if (!(
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2851; /* *fuse_vorc_vnand */

        case 24:
          if (!
#line 925 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2436; /* *fuse_or_nand */

        case 25:
          if (!(
#line 925 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2437; /* *fuse_or_nand */

        case 26:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2832; /* *fuse_vor_vnand */

        case 27:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2833; /* *fuse_vor_vnand */

        case 28:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2834; /* *fuse_vor_vnand */

        case 29:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2835; /* *fuse_vor_vnand */

        case 30:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2836; /* *fuse_vor_vnand */

        case 31:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2837; /* *fuse_vor_vnand */

        case 32:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2838; /* *fuse_vor_vnand */

        case 33:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2839; /* *fuse_vor_vnand */

        case 34:
          if (!(
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2840; /* *fuse_vor_vnand */

        case 35:
          if (!(
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2841; /* *fuse_vor_vnand */

        default:
          return -1;
        }

    case XOR:
      x6 = XEXP (x5, 0);
      operands[0] = x6;
      x7 = XEXP (x5, 1);
      operands[1] = x7;
      x8 = XEXP (x3, 1);
      switch (GET_CODE (x8))
        {
        case NOT:
          x9 = XEXP (x8, 0);
          operands[2] = x9;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern266 (x3, 
E_SImode) != 0
                  || !
#line 961 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2440; /* *fuse_xor_nand */

            case E_DImode:
              if (pattern266 (x3, 
E_DImode) != 0
                  || !(
#line 961 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2441; /* *fuse_xor_nand */

            case E_V4SImode:
              if (pattern267 (x3, 
E_V4SImode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2852; /* *fuse_vxor_vnand */

            case E_V8HImode:
              if (pattern267 (x3, 
E_V8HImode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2853; /* *fuse_vxor_vnand */

            case E_V16QImode:
              if (pattern267 (x3, 
E_V16QImode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2854; /* *fuse_vxor_vnand */

            case E_V4SFmode:
              if (pattern267 (x3, 
E_V4SFmode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2855; /* *fuse_vxor_vnand */

            case E_V2DFmode:
              if (pattern267 (x3, 
E_V2DFmode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2856; /* *fuse_vxor_vnand */

            case E_V2DImode:
              if (pattern267 (x3, 
E_V2DImode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2857; /* *fuse_vxor_vnand */

            case E_V1TImode:
              if (pattern267 (x3, 
E_V1TImode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2858; /* *fuse_vxor_vnand */

            case E_TImode:
              if (pattern267 (x3, 
E_TImode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2859; /* *fuse_vxor_vnand */

            case E_KFmode:
              if (pattern267 (x3, 
E_KFmode) != 0
                  || !(
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2860; /* *fuse_vxor_vnand */

            case E_TFmode:
              if (pattern267 (x3, 
E_TFmode) != 0
                  || !(
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2861; /* *fuse_vxor_vnand */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern409 (x3))
            {
            case 0:
              if (!
#line 1231 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2470; /* *fuse_eqv_or */

            case 1:
              if (!(
#line 1231 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2471; /* *fuse_eqv_or */

            case 2:
              if (!
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2962; /* *fuse_veqv_vor */

            case 3:
              if (!
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2963; /* *fuse_veqv_vor */

            case 4:
              if (!
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2964; /* *fuse_veqv_vor */

            case 5:
              if (!
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2965; /* *fuse_veqv_vor */

            case 6:
              if (!
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2966; /* *fuse_veqv_vor */

            case 7:
              if (!
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2967; /* *fuse_veqv_vor */

            case 8:
              if (!
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2968; /* *fuse_veqv_vor */

            case 9:
              if (!
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2969; /* *fuse_veqv_vor */

            case 10:
              if (!(
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2970; /* *fuse_veqv_vor */

            case 11:
              if (!(
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2971; /* *fuse_veqv_vor */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      switch (pattern280 (x3))
        {
        case 0:
          if (!
#line 979 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2442; /* *fuse_add_nand */

        case 1:
          if (!(
#line 979 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2443; /* *fuse_add_nand */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern280 (x3))
        {
        case 0:
          if (!
#line 997 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2444; /* *fuse_subf_nand */

        case 1:
          if (!(
#line 997 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2445; /* *fuse_subf_nand */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_43 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!u5bit_cint_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!vsx_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 4870 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode)))
        return -1;
      return 1504; /* vsx_xxspltw_v4sf_direct */

    case E_V4SImode:
      if (!vsx_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !vsx_register_operand (operands[1], E_V4SImode)
          || !
#line 4870 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode)))
        return -1;
      return 1505; /* vsx_xxspltw_v4si_direct */

    default:
      return -1;
    }
}

 int
recog_50 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!gpc_reg_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (!rs6000_tls_symbol_ref (x4, E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
      if (XWINT (x5, 0) != 0L)
        return -1;
      operands[1] = x4;
      return 750; /* *tls_got_tprel_pcrel_64 */

    case REG:
    case SUBREG:
      operands[1] = x5;
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      operands[2] = x4;
      return 751; /* tls_got_tprel_64 */

    default:
      return -1;
    }
}

 int
recog_57 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!cc_reg_operand (operands[0], E_CCmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!gpc_reg_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_VOIDmode)
      || !
#line 14137 "../../gcc/config/rs6000/rs6000.md"
(REG_P (operands[0])
   && CR_REGNO_P (REGNO (operands[0]))
   && CONST_INT_P (operands[2])
   && INTVAL (operands[2]) == 1 << (7 - (REGNO (operands[0]) - CR0_REGNO))))
    return -1;
  return 922; /* *mtcrfsi */
}

 int
recog_66 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V1TImode:
      if (!vsx_register_operand (operands[0], E_V1TImode)
          || GET_MODE (x2) != E_V1TImode
          || !vsx_register_operand (operands[1], E_V2DImode)
          || !
#line 5088 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1532; /* vsx_sign_extend_v2di_v1ti */

    case E_V4SImode:
      switch (pattern320 (x2, 
E_V4SImode))
        {
        case 0:
          if (!
#line 5099 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1533; /* vsx_sign_extend_v16qi_v4si */

        case 1:
          if (!
#line 5108 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1537; /* vsx_sign_extend_v8hi_v4si */

        default:
          return -1;
        }

    case E_V2DImode:
      if (!vsx_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16QImode:
          if (!vsx_register_operand (operands[1], E_V16QImode)
              || !
#line 5099 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1534; /* vsx_sign_extend_v16qi_v2di */

        case E_V8HImode:
          if (!vsx_register_operand (operands[1], E_V8HImode)
              || !
#line 5108 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1538; /* vsx_sign_extend_v8hi_v2di */

        case E_V4SImode:
          if (!vsx_register_operand (operands[1], E_V4SImode)
              || !
#line 5116 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1541; /* vsx_sign_extend_v4si_v2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_71 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern213 (x2))
    {
    case 0:
      if (!
#line 6840 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND))
        return -1;
      return 472; /* floorsf2 */

    case 1:
      if (!
#line 6840 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND))
        return -1;
      return 473; /* floordf2 */

    case 2:
      if (!(
#line 15447 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1063; /* floorkf2 */

    case 3:
      if (!(
#line 15447 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1064; /* floortf2 */

    case 4:
      if (vsx_register_operand (operands[0], E_V4SFmode)
          && vsx_register_operand (operands[1], E_V4SFmode)
          && 
#line 2339 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return 1303; /* vsx_floorv4sf2 */
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 2589 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1988; /* *altivec_vrfim */

    case 5:
      if (!
#line 2339 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1304; /* vsx_floorv2df2 */

    default:
      return -1;
    }
}

 int
recog_83 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x2) != E_SFmode
          || !gpc_reg_operand (operands[1], E_SFmode)
          || !
#line 6859 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_VSX))
        return -1;
      return 476; /* *xsrdpisf2 */

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x2) != E_DFmode
          || !gpc_reg_operand (operands[1], E_DFmode)
          || !
#line 6859 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_VSX))
        return -1;
      return 477; /* *xsrdpidf2 */

    default:
      return -1;
    }
}

 int
recog_90 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4SFmode
      || !vsx_register_operand (operands[0], E_V4SFmode))
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!vsx_register_operand (operands[1], E_DFmode)
          || !
#line 2455 "../../gcc/config/rs6000/vsx.md"
(TARGET_XSCVDPSPN))
        return -1;
      return 1316; /* vsx_xscvdpspn */

    case E_SFmode:
      if (!vsx_register_operand (operands[1], E_SFmode)
          || !
#line 2471 "../../gcc/config/rs6000/vsx.md"
(TARGET_XSCVDPSPN))
        return -1;
      return 1318; /* vsx_xscvdpspn_scalar */

    default:
      return -1;
    }
}

 int
recog_98 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (pattern413 (x3, 
E_V4SImode) != 0
          || !
#line 6700 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1665; /* xxblend_v4si */

    case E_V8HImode:
      if (pattern413 (x3, 
E_V8HImode) != 0
          || !
#line 6700 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1666; /* xxblend_v8hi */

    case E_V16QImode:
      if (pattern413 (x3, 
E_V16QImode) != 0
          || !
#line 6700 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1667; /* xxblend_v16qi */

    case E_V4SFmode:
      if (pattern413 (x3, 
E_V4SFmode) != 0
          || !
#line 6700 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1668; /* xxblend_v4sf */

    case E_V2DFmode:
      if (pattern413 (x3, 
E_V2DFmode) != 0
          || !
#line 6700 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1669; /* xxblend_v2df */

    case E_V2DImode:
      if (pattern414 (x3) != 0
          || !
#line 6700 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1670; /* xxblend_v2di */

    default:
      return -1;
    }
}

 int
recog_105 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 82:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_KFmode:
              if (pattern438 (x2, 
E_KFmode) != 0
                  || !(
#line 15544 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1081; /* fmakf4_odd */

            case E_TFmode:
              if (pattern438 (x2, 
E_TFmode) != 0
                  || !(
#line 15544 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1082; /* fmatf4_odd */

            default:
              return -1;
            }

        case NEG:
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_KFmode:
              if (pattern439 (x2, 
E_KFmode) != 0
                  || !(
#line 15557 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1083; /* *fmskf4_odd */

            case E_TFmode:
              if (pattern439 (x2, 
E_TFmode) != 0
                  || !(
#line 15557 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1084; /* *fmstf4_odd */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 194:
      switch (pattern155 (x1))
        {
        case 0:
          if (!
#line 4241 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1422; /* vextractlv16qi_internal */

        case 1:
          if (!
#line 4241 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1423; /* vextractlv8hi_internal */

        case 2:
          if (!
#line 4241 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1424; /* vextractlv4si_internal */

        case 3:
          if (!
#line 4241 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1425; /* vextractlv2di_internal */

        default:
          return -1;
        }

    case 195:
      switch (pattern155 (x1))
        {
        case 0:
          if (!
#line 4271 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1426; /* vextractrv16qi_internal */

        case 1:
          if (!
#line 4271 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1427; /* vextractrv8hi_internal */

        case 2:
          if (!
#line 4271 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1428; /* vextractrv4si_internal */

        case 3:
          if (!
#line 4271 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1429; /* vextractrv2di_internal */

        default:
          return -1;
        }

    case 196:
      switch (pattern156 (x1))
        {
        case 0:
          if (!
#line 4298 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1430; /* vinsertvl_internal_v16qi */

        case 1:
          if (!
#line 4352 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1438; /* vinsertgl_internal_v16qi */

        case 2:
          if (!
#line 4298 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1431; /* vinsertvl_internal_v8hi */

        case 3:
          if (!
#line 4352 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1439; /* vinsertgl_internal_v8hi */

        case 4:
          if (!
#line 4298 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1432; /* vinsertvl_internal_v4si */

        case 5:
          if (!
#line 4352 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1440; /* vinsertgl_internal_v4si */

        case 6:
          if (!
#line 4298 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1433; /* vinsertvl_internal_v2di */

        case 7:
          if (!
#line 4352 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1441; /* vinsertgl_internal_v2di */

        default:
          return -1;
        }

    case 197:
      switch (pattern156 (x1))
        {
        case 0:
          if (!
#line 4325 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1434; /* vinsertvr_internal_v16qi */

        case 1:
          if (!
#line 4379 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1442; /* vinsertgr_internal_v16qi */

        case 2:
          if (!
#line 4325 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1435; /* vinsertvr_internal_v8hi */

        case 3:
          if (!
#line 4379 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1443; /* vinsertgr_internal_v8hi */

        case 4:
          if (!
#line 4325 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1436; /* vinsertvr_internal_v4si */

        case 5:
          if (!
#line 4379 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1444; /* vinsertgr_internal_v4si */

        case 6:
          if (!
#line 4325 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1437; /* vinsertvr_internal_v2di */

        case 7:
          if (!
#line 4379 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1445; /* vinsertgr_internal_v2di */

        default:
          return -1;
        }

    case 198:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!const_0_to_12_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern440 (x2, 
E_SImode, 
E_V4SImode) != 0
              || !
#line 4413 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1446; /* vreplace_elt_v4si_inst */

        case E_V4SFmode:
          if (pattern440 (x2, 
E_SFmode, 
E_V4SFmode) != 0
              || !
#line 4413 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1447; /* vreplace_elt_v4sf_inst */

        case E_V2DImode:
          if (pattern440 (x2, 
E_DImode, 
E_V2DImode) != 0
              || !
#line 4413 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1448; /* vreplace_elt_v2di_inst */

        case E_V2DFmode:
          if (pattern440 (x2, 
E_DFmode, 
E_V2DFmode) != 0
              || !
#line 4413 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1449; /* vreplace_elt_v2df_inst */

        default:
          return -1;
        }

    case 199:
      return recog_99 (x1, insn, pnum_clobbers);

    case 123:
      return recog_94 (x1, insn, pnum_clobbers);

    case 126:
      return recog_96 (x1, insn, pnum_clobbers);

    case 160:
      if (pattern157 (x1) != 0
          || !
#line 5738 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && TARGET_64BIT))
        return -1;
      return 1586; /* *lxvl */

    case 161:
      if (pattern157 (x1) != 0
          || !
#line 5748 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1587; /* lxvll */

    case 165:
      if (pattern158 (x1) != 0
          || !
#line 5777 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1588; /* stxvll */

    case 164:
      if (pattern158 (x1) != 0
          || !
#line 5834 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && TARGET_64BIT))
        return -1;
      return 1589; /* *stxvl */

    case 183:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V4SImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!vsx_register_operand (operands[2], E_V16QImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!const_0_to_12_operand (operands[3], E_QImode)
          || !
#line 6073 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1616; /* *insert4b_internal */

    case 206:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!u1bit_cint_operand (operands[2], E_QImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!s32bit_cint_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 6659 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1663; /* xxsplti32dx_v4si_inst */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !register_operand (operands[1], E_V4SFmode)
              || !
#line 6688 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1664; /* xxsplti32dx_v4sf_inst */

        default:
          return -1;
        }

    case 207:
      return recog_98 (x1, insn, pnum_clobbers);

    case 202:
      if (pattern159 (x1, 
E_V2DImode) != 0
          || !
#line 6788 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1673; /* vmsumcud */

    case 263:
      return recog_93 (x1, insn, pnum_clobbers);

    case 358:
      switch (pattern160 (x1))
        {
        case 0:
          if (!
#line 885 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1791; /* vsldb_v16qi */

        case 1:
          if (!
#line 885 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1793; /* vsldb_v8hi */

        case 2:
          if (!
#line 885 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1795; /* vsldb_v4si */

        case 3:
          if (!
#line 885 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1797; /* vsldb_v2di */

        case 4:
          if (!
#line 885 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1799; /* vsldb_v1ti */

        default:
          return -1;
        }

    case 359:
      switch (pattern160 (x1))
        {
        case 0:
          if (!
#line 885 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1792; /* vsrdb_v16qi */

        case 1:
          if (!
#line 885 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1794; /* vsrdb_v8hi */

        case 2:
          if (!
#line 885 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1796; /* vsrdb_v4si */

        case 3:
          if (!
#line 885 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1798; /* vsrdb_v2di */

        case 4:
          if (!
#line 885 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1800; /* vsrdb_v1ti */

        default:
          return -1;
        }

    case 210:
      switch (pattern161 (x1))
        {
        case 0:
          if (!
#line 1011 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1810; /* altivec_vmsumuhm */

        case 1:
          if (!
#line 1011 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1811; /* altivec_vmsumubm */

        default:
          return -1;
        }

    case 211:
      if (pattern159 (x1, 
E_V2DImode) != 0
          || !
#line 1021 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 1812; /* altivec_vmsumudm */

    case 212:
      switch (pattern161 (x1))
        {
        case 0:
          if (!
#line 1031 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1813; /* altivec_vmsummhm */

        case 1:
          if (!
#line 1031 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1814; /* altivec_vmsummbm */

        default:
          return -1;
        }

    case 213:
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V8HImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!register_operand (operands[3], E_V4SImode)
          || !
#line 1041 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1815; /* altivec_vmsumshm */

    case 346:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern414 (x2) != 0
              || !
#line 2008 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1902; /* altivec_vrldmi */

        case E_V4SImode:
          if (pattern413 (x2, 
E_V4SImode) != 0
              || !
#line 2008 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1903; /* altivec_vrlwmi */

        case E_V1TImode:
          if (pattern133 (x2, 
E_V1TImode) != 0
              || !vsx_register_operand (operands[3], E_V1TImode)
              || !
#line 2036 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1904; /* altivec_vrlqmi_inst */

        default:
          return -1;
        }

    case 253:
      return recog_95 (x1, insn, pnum_clobbers);

    case 255:
      switch (pattern162 (x1))
        {
        case 0:
          if (!
#line 2535 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1966; /* *altivec_vperm_v4si_uns_internal */

        case 1:
          if (!
#line 2535 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1967; /* *altivec_vperm_v8hi_uns_internal */

        case 2:
          if (!
#line 2535 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1968; /* *altivec_vperm_v16qi_uns_internal */

        case 3:
          if (!
#line 2535 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1969; /* *altivec_vperm_v4sf_uns_internal */

        case 4:
          if (!
#line 2535 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1970; /* *altivec_vperm_v2df_uns_internal */

        case 5:
          if (!
#line 2535 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1971; /* *altivec_vperm_v2di_uns_internal */

        case 6:
          if (!
#line 2535 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1972; /* *altivec_vperm_v1ti_uns_internal */

        case 7:
          if (!
#line 2535 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1973; /* *altivec_vperm_ti_uns_internal */

        case 8:
          if (!(
#line 2535 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 1974; /* *altivec_vperm_kf_uns_internal */

        case 9:
          if (!(
#line 2535 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 1975; /* *altivec_vperm_tf_uns_internal */

        default:
          return -1;
        }

    case 254:
      return recog_102 (x1, insn, pnum_clobbers);

    case 321:
      if (pattern163 (x1, 
E_V4SImode, 
E_V8HImode) != 0
          || !
#line 3837 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2136; /* vperm_v8hiv4si */

    case 322:
      if (pattern163 (x1, 
E_V8HImode, 
E_V16QImode) != 0
          || !
#line 3850 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2137; /* vperm_v16qiv8hi */

    case 335:
      if (pattern159 (x1, 
E_V1TImode) != 0
          || !
#line 4469 "../../gcc/config/rs6000/altivec.md"
(TARGET_VADDUQM))
        return -1;
      return 2171; /* altivec_vaddeuqm */

    case 336:
      if (pattern159 (x1, 
E_V1TImode) != 0
          || !
#line 4479 "../../gcc/config/rs6000/altivec.md"
(TARGET_VADDUQM))
        return -1;
      return 2172; /* altivec_vaddecuq */

    case 338:
      if (pattern159 (x1, 
E_V1TImode) != 0
          || !
#line 4489 "../../gcc/config/rs6000/altivec.md"
(TARGET_VADDUQM))
        return -1;
      return 2173; /* altivec_vsubeuqm */

    case 339:
      if (pattern159 (x1, 
E_V1TImode) != 0
          || !
#line 4499 "../../gcc/config/rs6000/altivec.md"
(TARGET_VADDUQM))
        return -1;
      return 2174; /* altivec_vsubecuq */

    case 342:
      switch (pattern164 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 4592 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 2178; /* bcdadd_v1ti */

        case 1:
          if (!
#line 4592 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 2180; /* bcdadd_v16qi */

        default:
          return -1;
        }

    case 343:
      switch (pattern164 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 4592 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 2179; /* bcdsub_v1ti */

        case 1:
          if (!
#line 4592 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 2181; /* bcdsub_v16qi */

        default:
          return -1;
        }

    case 345:
      if (pnum_clobbers == NULL
          || pattern149 (x1, 
E_V16QImode) != 0)
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!const_0_to_1_operand (operands[3], E_QImode)
          || !
#line 4763 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      *pnum_clobbers = 1;
      return 2200; /* bcdshift_v16qi */

    case 416:
      if (pattern165 (x1, 
E_V16QImode) != 0
          || !
#line 497 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2215; /* mma_xvi4ger8pp */

    case 418:
      if (pattern165 (x1, 
E_V16QImode) != 0
          || !
#line 497 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2216; /* mma_xvi8ger4pp */

    case 419:
      if (pattern165 (x1, 
E_V16QImode) != 0
          || !
#line 497 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2217; /* mma_xvi8ger4spp */

    case 412:
      if (pattern165 (x1, 
E_V16QImode) != 0
          || !
#line 497 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2218; /* mma_xvi16ger2pp */

    case 414:
      if (pattern165 (x1, 
E_V16QImode) != 0
          || !
#line 497 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2219; /* mma_xvi16ger2spp */

    case 400:
      if (pattern165 (x1, 
E_V16QImode) != 0
          || !
#line 497 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2220; /* mma_xvf16ger2pp */

    case 399:
      if (pattern165 (x1, 
E_V16QImode) != 0
          || !
#line 497 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2221; /* mma_xvf16ger2pn */

    case 398:
      if (pattern165 (x1, 
E_V16QImode) != 0
          || !
#line 497 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2222; /* mma_xvf16ger2np */

    case 397:
      if (pattern165 (x1, 
E_V16QImode) != 0
          || !
#line 497 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2223; /* mma_xvf16ger2nn */

    case 395:
      if (pattern165 (x1, 
E_V16QImode) != 0
          || !
#line 497 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2224; /* mma_xvbf16ger2pp */

    case 394:
      if (pattern165 (x1, 
E_V16QImode) != 0
          || !
#line 497 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2225; /* mma_xvbf16ger2pn */

    case 393:
      if (pattern165 (x1, 
E_V16QImode) != 0
          || !
#line 497 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2226; /* mma_xvbf16ger2np */

    case 392:
      if (pattern165 (x1, 
E_V16QImode) != 0
          || !
#line 497 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2227; /* mma_xvbf16ger2nn */

    case 405:
      if (pattern165 (x1, 
E_V16QImode) != 0
          || !
#line 497 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2228; /* mma_xvf32gerpp */

    case 404:
      if (pattern165 (x1, 
E_V16QImode) != 0
          || !
#line 497 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2229; /* mma_xvf32gerpn */

    case 403:
      if (pattern165 (x1, 
E_V16QImode) != 0
          || !
#line 497 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2230; /* mma_xvf32gernp */

    case 402:
      if (pattern165 (x1, 
E_V16QImode) != 0
          || !
#line 497 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2231; /* mma_xvf32gernn */

    case 410:
      if (pattern165 (x1, 
E_OOmode) != 0
          || !
#line 516 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2233; /* mma_xvf64gerpp */

    case 409:
      if (pattern165 (x1, 
E_OOmode) != 0
          || !
#line 516 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2234; /* mma_xvf64gerpn */

    case 408:
      if (pattern165 (x1, 
E_OOmode) != 0
          || !
#line 516 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2235; /* mma_xvf64gernp */

    case 407:
      if (pattern165 (x1, 
E_OOmode) != 0
          || !
#line 516 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2236; /* mma_xvf64gernn */

    case 431:
      return recog_101 (x1, insn, pnum_clobbers);

    case 438:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern413 (x2, 
E_V16QImode) != 0
              || !
#line 91 "../../gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2328; /* crypto_vpermxor_v16qi */

        case E_V8HImode:
          if (pattern413 (x2, 
E_V8HImode) != 0
              || !
#line 91 "../../gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2329; /* crypto_vpermxor_v8hi */

        case E_V4SImode:
          if (pattern413 (x2, 
E_V4SImode) != 0
              || !
#line 91 "../../gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2330; /* crypto_vpermxor_v4si */

        case E_V2DImode:
          if (pattern414 (x2) != 0
              || !
#line 91 "../../gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2331; /* crypto_vpermxor_v2di */

        default:
          return -1;
        }

    case 437:
      return recog_100 (x1, insn, pnum_clobbers);

    case 444:
      return recog_97 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_125 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case MULT:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          operands[3] = x3;
          if (!gpc_reg_operand (operands[3], E_SImode))
            return -1;
          x6 = XEXP (x4, 0);
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x4, 1);
          if (GET_MODE (x7) != E_SImode)
            return -1;
          switch (GET_CODE (x6))
            {
            case ASHIFTRT:
              x8 = XEXP (x6, 1);
              if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x9 = XEXP (x6, 0);
              if (!gpc_reg_operand (x9, E_SImode))
                return -1;
              switch (GET_CODE (x7))
                {
                case SIGN_EXTEND:
                  operands[2] = x9;
                  x10 = XEXP (x7, 0);
                  operands[1] = x10;
                  if (!gpc_reg_operand (operands[1], E_HImode)
                      || !
#line 1478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                    return -1;
                  return 47; /* *nmacchw */

                case ASHIFTRT:
                  x11 = XEXP (x7, 1);
                  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                    return -1;
                  operands[1] = x9;
                  x10 = XEXP (x7, 0);
                  operands[2] = x10;
                  if (!gpc_reg_operand (operands[2], E_SImode)
                      || !
#line 1513 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                    return -1;
                  return 49; /* *nmachhw */

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              if (GET_CODE (x7) != SIGN_EXTEND)
                return -1;
              x9 = XEXP (x6, 0);
              operands[1] = x9;
              if (!gpc_reg_operand (operands[1], E_HImode))
                return -1;
              x10 = XEXP (x7, 0);
              operands[2] = x10;
              if (!gpc_reg_operand (operands[2], E_HImode)
                  || !
#line 1542 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 51; /* *nmaclhw */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern200 (x2, 
E_SImode) != 0)
                return -1;
              return 94; /* *subfsi3 */

            case E_DImode:
              if (pattern200 (x2, 
E_DImode) != 0
                  || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 95; /* *subfdi3 */

            case E_SFmode:
              if (pattern201 (x2, 
E_SFmode) != 0
                  || !
#line 5079 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 303; /* *subsf3_fpr */

            case E_DFmode:
              if (pattern201 (x2, 
E_DFmode) != 0
                  || !
#line 5079 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 304; /* *subdf3_fpr */

            case E_KFmode:
              if (pattern202 (x2, 
E_KFmode) != 0
                  || !(
#line 15030 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 983; /* subkf3 */

            case E_TFmode:
              if (pattern202 (x2, 
E_TFmode) != 0
                  || !(
#line 15030 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 984; /* subtf3 */

            case E_V4SFmode:
              if (GET_MODE (x2) != E_V4SFmode)
                return -1;
              operands[1] = x3;
              if (vsx_register_operand (operands[1], E_V4SFmode)
                  && vsx_register_operand (operands[0], E_V4SFmode))
                {
                  operands[2] = x4;
                  if (vsx_register_operand (operands[2], E_V4SFmode)
                      && 
#line 1710 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
                    return 1224; /* *vsx_subv4sf3 */
                }
              if (!register_operand (operands[1], E_V4SFmode)
                  || !register_operand (operands[0], E_V4SFmode))
                return -1;
              operands[2] = x4;
              if (!register_operand (operands[2], E_V4SFmode)
                  || !
#line 563 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
                return -1;
              return 1716; /* *altivec_subv4sf3 */

            case E_V2DFmode:
              if (!vsx_register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x2) != E_V2DFmode)
                return -1;
              operands[1] = x3;
              if (!vsx_register_operand (operands[1], E_V2DFmode))
                return -1;
              operands[2] = x4;
              if (!vsx_register_operand (operands[2], E_V2DFmode)
                  || !
#line 1710 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
                return -1;
              return 1225; /* *vsx_subv2df3 */

            case E_V4SImode:
              if (pattern203 (x2, 
E_V4SImode) != 0
                  || !
#line 555 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
                return -1;
              return 1712; /* subv4si3 */

            case E_V8HImode:
              if (pattern203 (x2, 
E_V8HImode) != 0
                  || !
#line 555 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
                return -1;
              return 1713; /* subv8hi3 */

            case E_V16QImode:
              if (pattern203 (x2, 
E_V16QImode) != 0
                  || !
#line 555 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
                return -1;
              return 1714; /* subv16qi3 */

            case E_V2DImode:
              if (pattern203 (x2, 
E_V2DImode) != 0
                  || !
#line 555 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
                return -1;
              return 1715; /* subv2di3 */

            case E_V1TImode:
              if (pattern203 (x2, 
E_V1TImode) != 0
                  || !
#line 4450 "../../gcc/config/rs6000/altivec.md"
(TARGET_VADDUQM))
                return -1;
              return 2169; /* subv1ti3 */

            case E_DDmode:
              if (pattern201 (x2, 
E_DDmode) != 0
                  || !
#line 185 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
                return -1;
              return 2281; /* subdd3 */

            case E_TDmode:
              if (pattern201 (x2, 
E_TDmode) != 0
                  || !
#line 185 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
                return -1;
              return 2282; /* subtd3 */

            default:
              return -1;
            }

        case EQ:
          if (pattern36 (x1, pnum_clobbers) != 0)
            return -1;
          *pnum_clobbers = 3;
          return 859; /* *minus_eq_di */

        case NE:
          if (pattern36 (x1, pnum_clobbers) != 0)
            return -1;
          *pnum_clobbers = 3;
          return 860; /* *minus_ne_di */

        case AND:
          if (pnum_clobbers == NULL)
            return -1;
          x5 = XEXP (x1, 0);
          operands[3] = x5;
          operands[2] = x3;
          x6 = XEXP (x4, 0);
          switch (GET_CODE (x6))
            {
            case REG:
            case SUBREG:
              switch (pattern304 (x2))
                {
                case 0:
                  if (!
#line 1807 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2534; /* *fuse_and_rsubf */

                case 1:
                  if (!(
#line 1807 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2535; /* *fuse_and_rsubf */

                default:
                  return -1;
                }

            case NOT:
              switch (pattern306 (x2))
                {
                case 0:
                  if (!
#line 1843 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2538; /* *fuse_nor_rsubf */

                case 1:
                  if (!(
#line 1843 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2539; /* *fuse_nor_rsubf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case IOR:
          if (pnum_clobbers == NULL)
            return -1;
          x5 = XEXP (x1, 0);
          operands[3] = x5;
          operands[2] = x3;
          x6 = XEXP (x4, 0);
          switch (GET_CODE (x6))
            {
            case NOT:
              switch (pattern306 (x2))
                {
                case 0:
                  if (!
#line 1825 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2536; /* *fuse_nand_rsubf */

                case 1:
                  if (!(
#line 1825 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2537; /* *fuse_nand_rsubf */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              switch (pattern304 (x2))
                {
                case 0:
                  if (!
#line 1861 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2540; /* *fuse_or_rsubf */

                case 1:
                  if (!(
#line 1861 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2541; /* *fuse_or_rsubf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
      if (pnum_clobbers == NULL)
        return -1;
      operands[2] = x3;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern307 (x2, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 100; /* subfsi3_imm */

        case E_DImode:
          if (pattern307 (x2, 
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 101; /* subfdi3_imm */

        default:
          return -1;
        }

    case UMAX:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != UMIN)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x12 = XEXP (x3, 0);
      operands[1] = x12;
      x13 = XEXP (x3, 1);
      operands[2] = x13;
      x6 = XEXP (x4, 0);
      if (!rtx_equal_p (x6, operands[1]))
        return -1;
      x7 = XEXP (x4, 1);
      if (!rtx_equal_p (x7, operands[2]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern399 (x2, 
E_V4SImode) != 0
              || !
#line 4384 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2150; /* uabdv4si3 */

        case E_V8HImode:
          if (pattern399 (x2, 
E_V8HImode) != 0
              || !
#line 4384 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2151; /* uabdv8hi3 */

        case E_V16QImode:
          if (pattern399 (x2, 
E_V16QImode) != 0
              || !
#line 4384 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2152; /* uabdv16qi3 */

        default:
          return -1;
        }

    case AND:
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern41 (x1))
        {
        case 0:
          if (!
#line 1735 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2526; /* *fuse_and_subf */

        case 1:
          if (!(
#line 1735 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2527; /* *fuse_and_subf */

        case 2:
          if (!
#line 1771 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2530; /* *fuse_nor_subf */

        case 3:
          if (!(
#line 1771 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2531; /* *fuse_nor_subf */

        default:
          return -1;
        }

    case IOR:
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern42 (x1))
        {
        case 0:
          if (!
#line 1753 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2528; /* *fuse_nand_subf */

        case 1:
          if (!(
#line 1753 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2529; /* *fuse_nand_subf */

        case 2:
          if (!
#line 1789 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2532; /* *fuse_or_subf */

        case 3:
          if (!(
#line 1789 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2533; /* *fuse_or_subf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_137 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x3, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern324 (x3, 
E_SFmode) != 0
              || !
#line 14466 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 941; /* *fmasf4_fpr */

        case E_DFmode:
          if (pattern324 (x3, 
E_DFmode) != 0
              || !
#line 14466 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 942; /* *fmadf4_fpr */

        case E_KFmode:
          if (pattern325 (x3, 
E_KFmode) != 0
              || !(
#line 15155 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1001; /* fmakf4_hw */

        case E_TFmode:
          if (pattern325 (x3, 
E_TFmode) != 0
              || !(
#line 15155 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1002; /* fmatf4_hw */

        case E_V4SFmode:
          if (GET_MODE (x3) != E_V4SFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_V4SFmode)
              && vsx_register_operand (operands[1], E_V4SFmode)
              && vsx_register_operand (operands[2], E_V4SFmode)
              && vsx_register_operand (operands[3], E_V4SFmode)
              && 
#line 2082 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return 1261; /* *vsx_fmav4sf4 */
          if (!register_operand (operands[0], E_V4SFmode)
              || !register_operand (operands[1], E_V4SFmode)
              || !register_operand (operands[2], E_V4SFmode)
              || !register_operand (operands[3], E_V4SFmode)
              || !
#line 765 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
            return -1;
          return 1789; /* *altivec_fmav4sf4 */

        case E_V2DFmode:
          if (!vsx_register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !vsx_register_operand (operands[1], E_V2DFmode)
              || !vsx_register_operand (operands[2], E_V2DFmode)
              || !vsx_register_operand (operands[3], E_V2DFmode)
              || !
#line 2094 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1262; /* *vsx_fmav2df4 */

        default:
          return -1;
        }

    case NEG:
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern326 (x3, 
E_SFmode) != 0
              || !
#line 14490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 943; /* *fmssf4_fpr */

        case E_DFmode:
          if (pattern326 (x3, 
E_DFmode) != 0
              || !
#line 14490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 944; /* *fmsdf4_fpr */

        case E_KFmode:
          if (pattern327 (x3, 
E_KFmode) != 0
              || !(
#line 15167 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1003; /* *fmskf4_hw */

        case E_TFmode:
          if (pattern327 (x3, 
E_TFmode) != 0
              || !(
#line 15167 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1004; /* *fmstf4_hw */

        case E_V4SFmode:
          if (pattern328 (x3, 
E_V4SFmode) != 0
              || !
#line 2107 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1263; /* *vsx_fmsv4sf4 */

        case E_V2DFmode:
          if (pattern328 (x3, 
E_V2DFmode) != 0
              || !
#line 2107 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1264; /* *vsx_fmsv2df4 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_146 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case UNSPEC:
      if (pattern129 (x3, 
E_DImode) == 0)
        {
          switch (XVECLEN (x5, 0))
            {
            case 2:
              switch (XINT (x5, 1))
                {
                case 14:
                  x6 = XVECEXP (x5, 0, 0);
                  operands[2] = x6;
                  if (rs6000_tls_symbol_ref (operands[2], E_DImode))
                    {
                      x7 = XVECEXP (x5, 0, 1);
                      operands[3] = x7;
                      if (gpc_reg_operand (operands[3], E_DImode)
                          && (
#line 10607 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                        return 736; /* *tls_gd_low64 */
                    }
                  break;

                case 23:
                  x6 = XVECEXP (x5, 0, 0);
                  operands[3] = x6;
                  if (gpc_reg_operand (operands[3], E_DImode))
                    {
                      x7 = XVECEXP (x5, 0, 1);
                      operands[2] = x7;
                      if (rs6000_tls_symbol_ref (operands[2], E_DImode)
                          && (
#line 10720 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                        return 746; /* *tls_got_dtprel_low64 */
                    }
                  break;

                case 27:
                  x6 = XVECEXP (x5, 0, 0);
                  operands[3] = x6;
                  if (gpc_reg_operand (operands[3], E_DImode))
                    {
                      x7 = XVECEXP (x5, 0, 1);
                      operands[2] = x7;
                      if (rs6000_tls_symbol_ref (operands[2], E_DImode)
                          && (
#line 10800 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                        return 753; /* *tls_got_tprel_low64 */
                    }
                  break;

                default:
                  break;
                }
              break;

            case 1:
              if (XINT (x5, 1) == 15)
                {
                  x6 = XVECEXP (x5, 0, 0);
                  operands[2] = x6;
                  if (gpc_reg_operand (operands[2], E_DImode)
                      && (
#line 10652 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return 740; /* *tls_ld_low64 */
                }
              break;

            default:
              break;
            }
        }
      break;

    case CONST:
      x8 = XEXP (x5, 0);
      if (GET_CODE (x8) == MINUS
          && GET_MODE (x8) == E_SImode
          && gpc_reg_operand (operands[0], E_SImode)
          && GET_MODE (x3) == E_SImode
          && gpc_reg_operand (operands[1], E_SImode))
        {
          x9 = XEXP (x8, 0);
          operands[2] = x9;
          if (symbol_ref_operand (operands[2], E_SImode))
            {
              x10 = XEXP (x8, 1);
              operands[3] = x10;
              if (symbol_ref_operand (operands[3], E_SImode)
                  && 
#line 11241 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ELF && TARGET_SECURE_PLT && DEFAULT_ABI == ABI_V4 && flag_pic))
                return 763; /* load_toc_v4_PIC_3c */
            }
        }
      break;

    default:
      break;
    }
  if (!gpc_reg_operand (operands[1], E_DImode)
      || !gpc_reg_operand (operands[0], E_DImode)
      || GET_MODE (x3) != E_DImode)
    return -1;
  operands[2] = x5;
  if (!
#line 11324 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL))
    return -1;
  return 766; /* *largetoc_low */
}

 int
recog_157 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  switch (GET_CODE (x8))
    {
    case AND:
      switch (pattern384 (x6))
        {
        case 0:
          if (!
#line 835 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2426; /* *fuse_and_nand */

        case 1:
          if (!(
#line 835 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2427; /* *fuse_and_nand */

        case 2:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2782; /* *fuse_vand_vnand */

        case 3:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2783; /* *fuse_vand_vnand */

        case 4:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2784; /* *fuse_vand_vnand */

        case 5:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2785; /* *fuse_vand_vnand */

        case 6:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2786; /* *fuse_vand_vnand */

        case 7:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2787; /* *fuse_vand_vnand */

        case 8:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2788; /* *fuse_vand_vnand */

        case 9:
          if (!
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2789; /* *fuse_vand_vnand */

        case 10:
          if (!(
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2790; /* *fuse_vand_vnand */

        case 11:
          if (!(
#line 2311 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2791; /* *fuse_vand_vnand */

        case 12:
          if (!
#line 853 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2428; /* *fuse_andc_nand */

        case 13:
          if (!(
#line 853 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2429; /* *fuse_andc_nand */

        case 14:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2792; /* *fuse_vandc_vnand */

        case 15:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2793; /* *fuse_vandc_vnand */

        case 16:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2794; /* *fuse_vandc_vnand */

        case 17:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2795; /* *fuse_vandc_vnand */

        case 18:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2796; /* *fuse_vandc_vnand */

        case 19:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2797; /* *fuse_vandc_vnand */

        case 20:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2798; /* *fuse_vandc_vnand */

        case 21:
          if (!
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2799; /* *fuse_vandc_vnand */

        case 22:
          if (!(
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2800; /* *fuse_vandc_vnand */

        case 23:
          if (!(
#line 2329 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2801; /* *fuse_vandc_vnand */

        case 24:
          if (!
#line 907 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2434; /* *fuse_nor_nand */

        case 25:
          if (!(
#line 907 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2435; /* *fuse_nor_nand */

        case 26:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2822; /* *fuse_vnor_vnand */

        case 27:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2823; /* *fuse_vnor_vnand */

        case 28:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2824; /* *fuse_vnor_vnand */

        case 29:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2825; /* *fuse_vnor_vnand */

        case 30:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2826; /* *fuse_vnor_vnand */

        case 31:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2827; /* *fuse_vnor_vnand */

        case 32:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2828; /* *fuse_vnor_vnand */

        case 33:
          if (!
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2829; /* *fuse_vnor_vnand */

        case 34:
          if (!(
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2830; /* *fuse_vnor_vnand */

        case 35:
          if (!(
#line 2383 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2831; /* *fuse_vnor_vnand */

        default:
          return -1;
        }

    case NOT:
      switch (pattern387 (x6))
        {
        case 0:
          if (!
#line 871 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2430; /* *fuse_eqv_nand */

        case 1:
          if (!(
#line 871 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2431; /* *fuse_eqv_nand */

        case 2:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2802; /* *fuse_veqv_vnand */

        case 3:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2803; /* *fuse_veqv_vnand */

        case 4:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2804; /* *fuse_veqv_vnand */

        case 5:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2805; /* *fuse_veqv_vnand */

        case 6:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2806; /* *fuse_veqv_vnand */

        case 7:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2807; /* *fuse_veqv_vnand */

        case 8:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2808; /* *fuse_veqv_vnand */

        case 9:
          if (!
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2809; /* *fuse_veqv_vnand */

        case 10:
          if (!(
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2810; /* *fuse_veqv_vnand */

        case 11:
          if (!(
#line 2347 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2811; /* *fuse_veqv_vnand */

        default:
          return -1;
        }

    case IOR:
      switch (pattern388 (x6))
        {
        case 0:
          if (!
#line 889 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2432; /* *fuse_nand_nand */

        case 1:
          if (!(
#line 889 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2433; /* *fuse_nand_nand */

        case 2:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2812; /* *fuse_vnand_vnand */

        case 3:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2813; /* *fuse_vnand_vnand */

        case 4:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2814; /* *fuse_vnand_vnand */

        case 5:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2815; /* *fuse_vnand_vnand */

        case 6:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2816; /* *fuse_vnand_vnand */

        case 7:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2817; /* *fuse_vnand_vnand */

        case 8:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2818; /* *fuse_vnand_vnand */

        case 9:
          if (!
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2819; /* *fuse_vnand_vnand */

        case 10:
          if (!(
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2820; /* *fuse_vnand_vnand */

        case 11:
          if (!(
#line 2365 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2821; /* *fuse_vnand_vnand */

        case 12:
          if (!
#line 943 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2438; /* *fuse_orc_nand */

        case 13:
          if (!(
#line 943 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2439; /* *fuse_orc_nand */

        case 14:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2842; /* *fuse_vorc_vnand */

        case 15:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2843; /* *fuse_vorc_vnand */

        case 16:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2844; /* *fuse_vorc_vnand */

        case 17:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2845; /* *fuse_vorc_vnand */

        case 18:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2846; /* *fuse_vorc_vnand */

        case 19:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2847; /* *fuse_vorc_vnand */

        case 20:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2848; /* *fuse_vorc_vnand */

        case 21:
          if (!
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2849; /* *fuse_vorc_vnand */

        case 22:
          if (!(
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2850; /* *fuse_vorc_vnand */

        case 23:
          if (!(
#line 2419 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2851; /* *fuse_vorc_vnand */

        case 24:
          if (!
#line 925 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2436; /* *fuse_or_nand */

        case 25:
          if (!(
#line 925 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2437; /* *fuse_or_nand */

        case 26:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2832; /* *fuse_vor_vnand */

        case 27:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2833; /* *fuse_vor_vnand */

        case 28:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2834; /* *fuse_vor_vnand */

        case 29:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2835; /* *fuse_vor_vnand */

        case 30:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2836; /* *fuse_vor_vnand */

        case 31:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2837; /* *fuse_vor_vnand */

        case 32:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2838; /* *fuse_vor_vnand */

        case 33:
          if (!
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2839; /* *fuse_vor_vnand */

        case 34:
          if (!(
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2840; /* *fuse_vor_vnand */

        case 35:
          if (!(
#line 2401 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2841; /* *fuse_vor_vnand */

        default:
          return -1;
        }

    case XOR:
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      x10 = XEXP (x8, 1);
      operands[1] = x10;
      x11 = XEXP (x6, 1);
      switch (GET_CODE (x11))
        {
        case NOT:
          x12 = XEXP (x11, 0);
          operands[2] = x12;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern374 (x6, 
E_SImode) != 0
                  || !
#line 961 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2440; /* *fuse_xor_nand */

            case E_DImode:
              if (pattern374 (x6, 
E_DImode) != 0
                  || !(
#line 961 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2441; /* *fuse_xor_nand */

            case E_V4SImode:
              if (pattern376 (x6, 
E_V4SImode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2852; /* *fuse_vxor_vnand */

            case E_V8HImode:
              if (pattern376 (x6, 
E_V8HImode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2853; /* *fuse_vxor_vnand */

            case E_V16QImode:
              if (pattern376 (x6, 
E_V16QImode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2854; /* *fuse_vxor_vnand */

            case E_V4SFmode:
              if (pattern376 (x6, 
E_V4SFmode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2855; /* *fuse_vxor_vnand */

            case E_V2DFmode:
              if (pattern376 (x6, 
E_V2DFmode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2856; /* *fuse_vxor_vnand */

            case E_V2DImode:
              if (pattern376 (x6, 
E_V2DImode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2857; /* *fuse_vxor_vnand */

            case E_V1TImode:
              if (pattern376 (x6, 
E_V1TImode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2858; /* *fuse_vxor_vnand */

            case E_TImode:
              if (pattern376 (x6, 
E_TImode) != 0
                  || !
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2859; /* *fuse_vxor_vnand */

            case E_KFmode:
              if (pattern376 (x6, 
E_KFmode) != 0
                  || !(
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 2860; /* *fuse_vxor_vnand */

            case E_TFmode:
              if (pattern376 (x6, 
E_TFmode) != 0
                  || !(
#line 2437 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 2861; /* *fuse_vxor_vnand */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[2] = x11;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern504 (x6, 
E_SImode) != 0
                  || !
#line 1231 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2470; /* *fuse_eqv_or */

            case E_DImode:
              if (pattern504 (x6, 
E_DImode) != 0
                  || !(
#line 1231 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2471; /* *fuse_eqv_or */

            case E_V4SImode:
              if (pattern505 (x6, 
E_V4SImode) != 0
                  || !
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2962; /* *fuse_veqv_vor */

            case E_V8HImode:
              if (pattern505 (x6, 
E_V8HImode) != 0
                  || !
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2963; /* *fuse_veqv_vor */

            case E_V16QImode:
              if (pattern505 (x6, 
E_V16QImode) != 0
                  || !
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2964; /* *fuse_veqv_vor */

            case E_V4SFmode:
              if (pattern505 (x6, 
E_V4SFmode) != 0
                  || !
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2965; /* *fuse_veqv_vor */

            case E_V2DFmode:
              if (pattern505 (x6, 
E_V2DFmode) != 0
                  || !
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2966; /* *fuse_veqv_vor */

            case E_V2DImode:
              if (pattern505 (x6, 
E_V2DImode) != 0
                  || !
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2967; /* *fuse_veqv_vor */

            case E_V1TImode:
              if (pattern505 (x6, 
E_V1TImode) != 0
                  || !
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2968; /* *fuse_veqv_vor */

            case E_TImode:
              if (pattern505 (x6, 
E_TImode) != 0
                  || !
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2969; /* *fuse_veqv_vor */

            case E_KFmode:
              if (pattern505 (x6, 
E_KFmode) != 0
                  || !(
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 2970; /* *fuse_veqv_vor */

            case E_TFmode:
              if (pattern505 (x6, 
E_TFmode) != 0
                  || !(
#line 2635 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 2971; /* *fuse_veqv_vor */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      switch (pattern389 (x6))
        {
        case 0:
          if (!
#line 979 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2442; /* *fuse_add_nand */

        case 1:
          if (!(
#line 979 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2443; /* *fuse_add_nand */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern389 (x6))
        {
        case 0:
          if (!
#line 997 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2444; /* *fuse_subf_nand */

        case 1:
          if (!(
#line 997 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2445; /* *fuse_subf_nand */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_172 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          x7 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x7))
            {
            case CLOBBER:
              x8 = XEXP (x7, 0);
              if (GET_CODE (x8) != REG
                  || REGNO (x8) != 98)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern495 (x1, 
E_SImode) != 0)
                    return -1;
                  return 100; /* subfsi3_imm */

                case E_DImode:
                  if (pattern495 (x1, 
E_DImode) != 0
                      || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    return -1;
                  return 101; /* subfdi3_imm */

                default:
                  return -1;
                }

            case SET:
              x9 = XEXP (x7, 1);
              if (GET_CODE (x9) != LEU
                  || GET_MODE (x9) != E_DImode)
                return -1;
              x8 = XEXP (x7, 0);
              if (GET_CODE (x8) != REG
                  || REGNO (x8) != 98
                  || GET_MODE (x8) != E_DImode
                  || !gpc_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !reg_or_short_operand (operands[2], E_DImode)
                  || !gpc_reg_operand (operands[1], E_DImode))
                return -1;
              x10 = XEXP (x9, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              x11 = XEXP (x9, 1);
              if (!rtx_equal_p (x11, operands[2]))
                return -1;
              return 104; /* subfdi3_carry */

            default:
              return -1;
            }

        case AND:
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER)
            return -1;
          x6 = XEXP (x2, 0);
          operands[3] = x6;
          x8 = XEXP (x7, 0);
          operands[4] = x8;
          x12 = XEXP (x5, 0);
          switch (GET_CODE (x12))
            {
            case REG:
            case SUBREG:
              switch (pattern449 (x3))
                {
                case 0:
                  if (!
#line 1807 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2534; /* *fuse_and_rsubf */

                case 1:
                  if (!(
#line 1807 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2535; /* *fuse_and_rsubf */

                default:
                  return -1;
                }

            case NOT:
              switch (pattern451 (x3))
                {
                case 0:
                  if (!
#line 1843 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2538; /* *fuse_nor_rsubf */

                case 1:
                  if (!(
#line 1843 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2539; /* *fuse_nor_rsubf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case IOR:
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER)
            return -1;
          x6 = XEXP (x2, 0);
          operands[3] = x6;
          x8 = XEXP (x7, 0);
          operands[4] = x8;
          x12 = XEXP (x5, 0);
          switch (GET_CODE (x12))
            {
            case NOT:
              switch (pattern451 (x3))
                {
                case 0:
                  if (!
#line 1825 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2536; /* *fuse_nand_rsubf */

                case 1:
                  if (!(
#line 1825 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2537; /* *fuse_nand_rsubf */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              switch (pattern449 (x3))
                {
                case 0:
                  if (!
#line 1861 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2540; /* *fuse_or_rsubf */

                case 1:
                  if (!(
#line 1861 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2541; /* *fuse_or_rsubf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      switch (pattern186 (x1))
        {
        case 0:
          if (!
#line 1735 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2526; /* *fuse_and_subf */

        case 1:
          if (!(
#line 1735 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2527; /* *fuse_and_subf */

        case 2:
          if (!
#line 1771 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2530; /* *fuse_nor_subf */

        case 3:
          if (!(
#line 1771 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2531; /* *fuse_nor_subf */

        default:
          return -1;
        }

    case IOR:
      switch (pattern187 (x1))
        {
        case 0:
          if (!
#line 1753 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2528; /* *fuse_nand_subf */

        case 1:
          if (!(
#line 1753 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2529; /* *fuse_nand_subf */

        case 2:
          if (!
#line 1789 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2532; /* *fuse_or_subf */

        case 3:
          if (!(
#line 1789 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2533; /* *fuse_or_subf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_176 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern79 (x1))
    {
    case 0:
      if (nonimmediate_operand (operands[0], E_SImode))
        {
          switch (pattern454 (
E_DImode))
            {
            case 0:
              if (
#line 6326 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE))
                return 414; /* fix_truncsfsi2_stfiwx */
              break;

            case 1:
              if (
#line 6326 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE))
                return 415; /* fix_truncdfsi2_stfiwx */
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_SImode))
        return -1;
      switch (pattern455 ())
        {
        case 0:
          if (!
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 436; /* *fix_truncsfsi2_mem */

        case 1:
          if (!
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 442; /* *fix_truncdfsi2_mem */

        case 2:
          if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1039; /* *fix_trunckfsi2_mem */

        case 3:
          if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1045; /* *fix_trunctfsi2_mem */

        default:
          return -1;
        }

    case 1:
      if (gpc_reg_operand (operands[0], E_QImode))
        {
          switch (pattern454 (
E_SImode))
            {
            case 0:
              if (
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                return 420; /* fix_truncsfqi2 */
              break;

            case 1:
              if (
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                return 424; /* fix_truncdfqi2 */
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_QImode))
        return -1;
      switch (pattern456 (
E_QImode))
        {
        case 0:
          if (!
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 432; /* *fix_truncsfqi2_mem */

        case 1:
          if (!
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 438; /* *fix_truncdfqi2_mem */

        case 2:
          if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1035; /* *fix_trunckfqi2_mem */

        case 3:
          if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1041; /* *fix_trunctfqi2_mem */

        default:
          return -1;
        }

    case 2:
      if (gpc_reg_operand (operands[0], E_HImode))
        {
          switch (pattern454 (
E_SImode))
            {
            case 0:
              if (
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                return 422; /* fix_truncsfhi2 */
              break;

            case 1:
              if (
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                return 426; /* fix_truncdfhi2 */
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_HImode))
        return -1;
      switch (pattern456 (
E_HImode))
        {
        case 0:
          if (!
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 434; /* *fix_truncsfhi2_mem */

        case 1:
          if (!
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 440; /* *fix_truncdfhi2_mem */

        case 2:
          if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1037; /* *fix_trunckfhi2_mem */

        case 3:
          if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1043; /* *fix_trunctfhi2_mem */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_184 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case UNSPEC:
      if (XVECLEN (x3, 0) != 2)
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 0);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[3] = x6;
      if (!immediate_operand (operands[3], E_VOIDmode))
        return -1;
      switch (XINT (x3, 1))
        {
        case 17:
          if (GET_MODE (x3) != E_SImode
              || !mfcr_operation (operands[0], E_VOIDmode)
              || !gpc_reg_operand (operands[1], E_SImode)
              || !cc_reg_operand (operands[2], E_CCmode)
              || !
#line 13945 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MFCRF))
            return -1;
          return 910; /* *movesi_from_cr_one */

        case 18:
          if (GET_MODE (x3) != E_CCmode
              || !mtcrf_operation (operands[0], E_VOIDmode)
              || !cc_reg_operand (operands[1], E_CCmode)
              || !gpc_reg_operand (operands[2], E_SImode))
            return -1;
          return 921; /* *movsi_to_cr */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[2] = x3;
      if (gpc_reg_operand (operands[2], E_SImode))
        {
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          if (memory_operand (operands[1], E_SImode))
            {
              if (crsave_operation (operands[0], E_VOIDmode))
                return 912; /* *crsave */
              if (stmw_operation (operands[0], E_VOIDmode)
                  && 
#line 13984 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULTIPLE))
                return 913; /* *stmw */
            }
        }
      if (!memory_operand (operands[2], E_SImode)
          || !lmw_operation (operands[0], E_VOIDmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !
#line 14152 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULTIPLE))
        return -1;
      return 923; /* *lmw */

    case CONST_INT:
      if (XWINT (x3, 0) != 0L)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_BLKmode)
        return -1;
      x7 = XEXP (x4, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 1
          || !tie_operand (operands[0], E_VOIDmode))
        return -1;
      return 920; /* stack_tie */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x3, 0) != 2
          || XINT (x3, 1) != 21
          || GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 108
          || GET_MODE (x6) != E_SImode)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 108
          || GET_MODE (x4) != E_SImode
          || !vrsave_operation (operands[0], E_VOIDmode))
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 421 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1695; /* *set_vrsave_internal */

    default:
      return -1;
    }
}

 rtx_insn *
split_4 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return NULL;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return NULL;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  x7 = XEXP (x3, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x7;
      x8 = XVECEXP (x4, 0, 0);
      operands[2] = x8;
      x9 = XEXP (x5, 0);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (pattern509 (x3, 
E_V2DFmode, 
E_DFmode) != 0
              || !((
#line 3613 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DFmode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 3615 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_590 (insn, operands);

        case E_DImode:
          if (pattern509 (x3, 
E_V2DImode, 
E_DImode) != 0
              || !((
#line 3613 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DImode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 3615 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_591 (insn, operands);

        case E_SFmode:
          if (GET_MODE (x3) != E_SFmode)
            return NULL;
          if (vsx_register_operand (operands[0], E_SFmode)
              && vsx_register_operand (operands[1], E_V4SFmode)
              && u5bit_cint_operand (operands[2], E_QImode)
              && scratch_operand (operands[3], E_V4SFmode)
              && (
#line 3692 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)) && 
#line 3694 "../../gcc/config/rs6000/vsx.md"
( 1)))
            return gen_split_596 (insn, operands);
          if (!register_operand (operands[0], E_SFmode)
              || !memory_operand (operands[1], E_V4SFmode)
              || !const_0_to_3_operand (operands[2], E_QImode)
              || !scratch_operand (operands[3], E_DImode)
              || !((
#line 3725 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 3727 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_597 (insn, operands);

        case E_QImode:
          if (GET_MODE (x3) != E_QImode)
            return NULL;
          if (int_reg_operand (operands[0], E_QImode)
              && altivec_register_operand (operands[1], E_V16QImode)
              && const_int_operand (operands[2], E_QImode)
              && int_reg_operand (operands[3], E_SImode)
              && 
#line 4000 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_VEXTRACTUB && reload_completed))
            return gen_split_600 (insn, operands);
          if (!const_0_to_15_operand (operands[2], E_QImode))
            return NULL;
          if (nonimmediate_operand (operands[0], E_QImode)
              && gpc_reg_operand (operands[1], E_V16QImode)
              && scratch_operand (operands[3], E_V16QImode)
              && (
#line 4117 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && !TARGET_P9_VECTOR) && 
#line 4120 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return gen_split_610 (insn, operands);
          if (!register_operand (operands[0], E_QImode)
              || !memory_operand (operands[1], E_V16QImode)
              || !scratch_operand (operands[3], E_DImode)
              || !(
#line 4165 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4167 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_612 (insn, operands);

        case E_HImode:
          if (GET_MODE (x3) != E_HImode)
            return NULL;
          if (int_reg_operand (operands[0], E_HImode)
              && altivec_register_operand (operands[1], E_V8HImode)
              && const_int_operand (operands[2], E_QImode)
              && int_reg_operand (operands[3], E_SImode)
              && 
#line 4000 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_VEXTRACTUB && reload_completed))
            return gen_split_601 (insn, operands);
          if (!const_0_to_7_operand (operands[2], E_QImode))
            return NULL;
          if (nonimmediate_operand (operands[0], E_HImode)
              && gpc_reg_operand (operands[1], E_V8HImode)
              && scratch_operand (operands[3], E_V8HImode)
              && (
#line 4117 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && !TARGET_P9_VECTOR) && 
#line 4120 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return gen_split_611 (insn, operands);
          if (!register_operand (operands[0], E_HImode)
              || !memory_operand (operands[1], E_V8HImode)
              || !scratch_operand (operands[3], E_DImode)
              || !(
#line 4165 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4167 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_613 (insn, operands);

        case E_SImode:
          if (GET_MODE (x3) != E_SImode)
            return NULL;
          if (int_reg_operand (operands[0], E_SImode)
              && altivec_register_operand (operands[1], E_V4SImode)
              && const_int_operand (operands[2], E_QImode)
              && int_reg_operand (operands[3], E_SImode)
              && 
#line 4000 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_VEXTRACTUB && reload_completed))
            return gen_split_602 (insn, operands);
          if (!const_0_to_3_operand (operands[2], E_QImode))
            return NULL;
          if (nonimmediate_operand (operands[0], E_SImode)
              && gpc_reg_operand (operands[1], E_V4SImode)
              && scratch_operand (operands[3], E_V4SImode)
              && (
#line 4081 "../../gcc/config/rs6000/vsx.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 4083 "../../gcc/config/rs6000/vsx.md"
( INTVAL (operands[2]) != (BYTES_BIG_ENDIAN ? 1 : 2))))
            return gen_split_609 (insn, operands);
          if (!register_operand (operands[0], E_SImode)
              || !memory_operand (operands[1], E_V4SImode)
              || !scratch_operand (operands[3], E_DImode)
              || !(
#line 4165 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4167 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_614 (insn, operands);

        default:
          return NULL;
        }

    case PLUS:
      if (pattern395 (x1) != 0
          || !(
#line 4997 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)) && 
#line 4999 "../../gcc/config/rs6000/vsx.md"
( 1)))
        return NULL;
      return gen_split_665 (insn, operands);

    case SMIN:
      if (pattern395 (x1) != 0
          || !(
#line 4997 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)) && 
#line 4999 "../../gcc/config/rs6000/vsx.md"
( 1)))
        return NULL;
      return gen_split_666 (insn, operands);

    case SMAX:
      if (pattern395 (x1) != 0
          || !(
#line 4997 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)) && 
#line 4999 "../../gcc/config/rs6000/vsx.md"
( 1)))
        return NULL;
      return gen_split_667 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_6 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern80 (x1))
    {
    case 0:
      if (gpc_reg_operand (operands[0], E_QImode))
        {
          switch (pattern454 (
E_SImode))
            {
            case 0:
              if ((
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE) && 
#line 6410 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[0], QImode))))
                return gen_split_200 (insn, operands);
              break;

            case 1:
              if ((
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE) && 
#line 6410 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[0], QImode))))
                return gen_split_204 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_QImode))
        return NULL;
      switch (pattern456 (
E_QImode))
        {
        case 0:
          if (!(
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_208 (insn, operands);

        case 1:
          if (!(
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_214 (insn, operands);

        case 2:
          if (!((
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15310 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_493 (insn, operands);

        case 3:
          if (!((
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15310 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_499 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      if (gpc_reg_operand (operands[0], E_HImode))
        {
          switch (pattern454 (
E_SImode))
            {
            case 0:
              if ((
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE) && 
#line 6410 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[0], HImode))))
                return gen_split_202 (insn, operands);
              break;

            case 1:
              if ((
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE) && 
#line 6410 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[0], HImode))))
                return gen_split_206 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_HImode))
        return NULL;
      switch (pattern456 (
E_HImode))
        {
        case 0:
          if (!(
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_210 (insn, operands);

        case 1:
          if (!(
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_216 (insn, operands);

        case 2:
          if (!((
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15310 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_495 (insn, operands);

        case 3:
          if (!((
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15310 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_501 (insn, operands);

        default:
          return NULL;
        }

    case 2:
      if (memory_operand (operands[0], E_SImode))
        {
          switch (pattern455 ())
            {
            case 0:
              if ((
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return gen_split_212 (insn, operands);
              break;

            case 1:
              if ((
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return gen_split_218 (insn, operands);
              break;

            case 2:
              if (((
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15310 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return gen_split_497 (insn, operands);
              break;

            case 3:
              if (((
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15310 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return gen_split_503 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!nonimmediate_operand (operands[0], E_SImode))
        return NULL;
      switch (pattern454 (
E_DImode))
        {
        case 0:
          if (!(
#line 6467 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTIWUZ
   && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE) && 
#line 6471 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_219 (insn, operands);

        case 1:
          if (!(
#line 6467 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTIWUZ
   && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE) && 
#line 6471 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_220 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_9 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      switch (GET_CODE (operands[2]))
        {
        case CONST_INT:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern397 (x2, 
E_SImode) != 0
                  || !(
#line 3840 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_2insn_and (operands[2], SImode)
   && !(rs6000_is_valid_and_mask (operands[2], SImode)
	|| logical_const_operand (operands[2], SImode))) && 
#line 3844 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_78 (insn, operands);

            case E_DImode:
              if (pattern397 (x2, 
E_DImode) != 0
                  || !((
#line 3840 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_2insn_and (operands[2], DImode)
   && !(rs6000_is_valid_and_mask (operands[2], DImode)
	|| logical_const_operand (operands[2], DImode))) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3844 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_79 (insn, operands);

            default:
              return NULL;
            }

        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_TImode:
              if (pattern355 (x2, 
E_TImode) != 0
                  || !
#line 7388 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], TImode)))
                return NULL;
              return gen_split_230 (insn, operands);

            case E_PTImode:
              if (pattern355 (x2, 
E_PTImode) != 0
                  || !
#line 7388 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], PTImode)))
                return NULL;
              return gen_split_231 (insn, operands);

            case E_V16QImode:
              if (pattern355 (x2, 
E_V16QImode) != 0
                  || !(
#line 7388 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V16QImode)) && 
#line 778 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return NULL;
              return gen_split_232 (insn, operands);

            case E_V8HImode:
              if (pattern355 (x2, 
E_V8HImode) != 0
                  || !(
#line 7388 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V8HImode)) && 
#line 779 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return NULL;
              return gen_split_233 (insn, operands);

            case E_V4SImode:
              if (pattern355 (x2, 
E_V4SImode) != 0
                  || !(
#line 7388 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V4SImode)) && 
#line 780 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return NULL;
              return gen_split_234 (insn, operands);

            case E_V4SFmode:
              if (pattern355 (x2, 
E_V4SFmode) != 0
                  || !(
#line 7388 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V4SFmode)) && 
#line 781 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return NULL;
              return gen_split_235 (insn, operands);

            case E_V2DImode:
              if (pattern355 (x2, 
E_V2DImode) != 0
                  || !(
#line 7388 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V2DImode)) && 
#line 782 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return NULL;
              return gen_split_236 (insn, operands);

            case E_V2DFmode:
              if (pattern355 (x2, 
E_V2DFmode) != 0
                  || !(
#line 7388 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V2DFmode)) && 
#line 783 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return NULL;
              return gen_split_237 (insn, operands);

            case E_V1TImode:
              if (pattern355 (x2, 
E_V1TImode) != 0
                  || !(
#line 7388 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V1TImode)) && 
#line 784 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return NULL;
              return gen_split_238 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case PLUS:
      if (GET_MODE (x3) != E_DImode)
        return NULL;
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + -16]
          || pattern120 (x2, 
E_DImode) != 0
          || !((
#line 9532 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC && reload_completed) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 9534 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
        return NULL;
      return gen_split_340 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_12 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (nonimmediate_operand (operands[0], E_TImode)
      && input_operand (operands[1], E_TImode)
      && 
#line 9660 "../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], TImode)
       || int_reg_operand (operands[1], TImode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], TImode)
           && !vsx_register_operand (operands[1], TImode)))))
    return gen_split_354 (insn, operands);
  if (int_reg_operand (operands[0], E_TImode)
      && const_scalar_int_operand (operands[1], E_TImode)
      && 
#line 10063 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64
   && (VECTOR_MEM_NONE_P (TImode)
       || (reload_completed && INT_REGNO_P (REGNO (operands[0]))))))
    return gen_split_387 (insn, operands);
  if (nonimmediate_operand (operands[0], E_TImode)
      && input_operand (operands[1], E_TImode))
    {
      if (
#line 10090 "../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
        return gen_split_389 (insn, operands);
      if (
#line 171 "../../gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TImode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
        return gen_split_523 (insn, operands);
    }
  if (indexed_or_indirect_operand (operands[0], E_TImode)
      && indexed_or_indirect_operand (operands[1], E_TImode)
      && (
#line 427 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN
   && TARGET_VSX
   && !TARGET_P9_VECTOR
   && can_create_pseudo_p ()) && 
#line 432 "../../gcc/config/rs6000/vsx.md"
( 1)))
    return gen_split_548 (insn, operands);
  if (vsx_register_operand (operands[0], E_TImode)
      && memory_operand (operands[1], E_TImode)
      && 
#line 1045 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[1], TImode)))
    return gen_split_571 (insn, operands);
  if (memory_operand (operands[0], E_TImode)
      && vsx_register_operand (operands[1], E_TImode))
    {
      if (
#line 1075 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], TImode)))
        return gen_split_575 (insn, operands);
      if (
#line 1131 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], TImode)))
        return gen_split_579 (insn, operands);
    }
  if (!altivec_register_operand (operands[0], E_TImode))
    return NULL;
  if (easy_vector_constant_msb (operands[1], E_TImode)
      && 
#line 286 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (TImode) && reload_completed))
    return gen_split_681 (insn, operands);
  if (easy_vector_constant_add_self (operands[1], E_TImode)
      && 
#line 324 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (TImode) && reload_completed))
    return gen_split_691 (insn, operands);
  if (!easy_vector_constant_vsldoi (operands[1], E_TImode)
      || !
#line 353 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (TImode) && can_create_pseudo_p ()))
    return NULL;
  return gen_split_701 (insn, operands);
}

 rtx_insn *
split_16 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case AND:
      res = split_9 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case IOR:
    case XOR:
      res = split_11 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    default:
      break;
    }
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != NOT)
    return NULL;
  operands[3] = x3;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (!boolean_operator (operands[3], E_TImode)
              || GET_MODE (x4) != E_TImode)
            return NULL;
          if (vlogical_operand (operands[0], E_TImode)
              && vlogical_operand (operands[2], E_TImode)
              && vlogical_operand (operands[1], E_TImode)
              && 
#line 7461 "../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], TImode)))
            return gen_split_248 (insn, operands);
          if (!int_reg_operand (operands[0], E_TImode)
              || !int_reg_operand (operands[2], E_TImode)
              || !int_reg_operand (operands[1], E_TImode)
              || !
#line 7490 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_P8_VECTOR && (GET_CODE (operands[3]) != AND)))
            return NULL;
          return gen_split_257 (insn, operands);

        case E_PTImode:
          if (!boolean_operator (operands[3], E_PTImode)
              || GET_MODE (x4) != E_PTImode)
            return NULL;
          if (vlogical_operand (operands[0], E_PTImode)
              && vlogical_operand (operands[2], E_PTImode)
              && vlogical_operand (operands[1], E_PTImode)
              && 
#line 7461 "../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], PTImode)))
            return gen_split_249 (insn, operands);
          if (!int_reg_operand (operands[0], E_PTImode)
              || !int_reg_operand (operands[2], E_PTImode)
              || !int_reg_operand (operands[1], E_PTImode)
              || !
#line 7490 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_P8_VECTOR && (GET_CODE (operands[3]) != AND)))
            return NULL;
          return gen_split_258 (insn, operands);

        case E_V16QImode:
          if (pattern359 (x4, 
E_V16QImode) != 0
              || !(
#line 7461 "../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V16QImode)) && 
#line 778 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_250 (insn, operands);

        case E_V8HImode:
          if (pattern359 (x4, 
E_V8HImode) != 0
              || !(
#line 7461 "../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V8HImode)) && 
#line 779 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_251 (insn, operands);

        case E_V4SImode:
          if (pattern359 (x4, 
E_V4SImode) != 0
              || !(
#line 7461 "../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V4SImode)) && 
#line 780 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_252 (insn, operands);

        case E_V4SFmode:
          if (pattern359 (x4, 
E_V4SFmode) != 0
              || !(
#line 7461 "../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V4SFmode)) && 
#line 781 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_253 (insn, operands);

        case E_V2DImode:
          if (pattern359 (x4, 
E_V2DImode) != 0
              || !(
#line 7461 "../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V2DImode)) && 
#line 782 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_254 (insn, operands);

        case E_V2DFmode:
          if (pattern359 (x4, 
E_V2DFmode) != 0
              || !(
#line 7461 "../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V2DFmode)) && 
#line 783 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_255 (insn, operands);

        case E_V1TImode:
          if (pattern359 (x4, 
E_V1TImode) != 0
              || !(
#line 7461 "../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V1TImode)) && 
#line 784 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_256 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (!boolean_operator (operands[3], E_TImode)
              || GET_MODE (x4) != E_TImode
              || GET_MODE (x5) != E_TImode)
            return NULL;
          if (vlogical_operand (operands[0], E_TImode)
              && vlogical_operand (operands[1], E_TImode)
              && vlogical_operand (operands[2], E_TImode)
              && 
#line 7521 "../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], TImode)))
            return gen_split_259 (insn, operands);
          if (!int_reg_operand (operands[0], E_TImode)
              || !int_reg_operand (operands[1], E_TImode)
              || !int_reg_operand (operands[2], E_TImode)
              || !
#line 7551 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_P8_VECTOR && (GET_CODE (operands[3]) != AND)))
            return NULL;
          return gen_split_268 (insn, operands);

        case E_PTImode:
          if (!boolean_operator (operands[3], E_PTImode)
              || GET_MODE (x4) != E_PTImode
              || GET_MODE (x5) != E_PTImode)
            return NULL;
          if (vlogical_operand (operands[0], E_PTImode)
              && vlogical_operand (operands[1], E_PTImode)
              && vlogical_operand (operands[2], E_PTImode)
              && 
#line 7521 "../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], PTImode)))
            return gen_split_260 (insn, operands);
          if (!int_reg_operand (operands[0], E_PTImode)
              || !int_reg_operand (operands[1], E_PTImode)
              || !int_reg_operand (operands[2], E_PTImode)
              || !
#line 7551 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_P8_VECTOR && (GET_CODE (operands[3]) != AND)))
            return NULL;
          return gen_split_269 (insn, operands);

        case E_V16QImode:
          if (pattern362 (x3, 
E_V16QImode) != 0
              || !(
#line 7521 "../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V16QImode)) && 
#line 778 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_261 (insn, operands);

        case E_V8HImode:
          if (pattern362 (x3, 
E_V8HImode) != 0
              || !(
#line 7521 "../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V8HImode)) && 
#line 779 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_262 (insn, operands);

        case E_V4SImode:
          if (pattern362 (x3, 
E_V4SImode) != 0
              || !(
#line 7521 "../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V4SImode)) && 
#line 780 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_263 (insn, operands);

        case E_V4SFmode:
          if (pattern362 (x3, 
E_V4SFmode) != 0
              || !(
#line 7521 "../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V4SFmode)) && 
#line 781 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_264 (insn, operands);

        case E_V2DImode:
          if (pattern362 (x3, 
E_V2DImode) != 0
              || !(
#line 7521 "../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V2DImode)) && 
#line 782 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_265 (insn, operands);

        case E_V2DFmode:
          if (pattern362 (x3, 
E_V2DFmode) != 0
              || !(
#line 7521 "../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V2DFmode)) && 
#line 783 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_266 (insn, operands);

        case E_V1TImode:
          if (pattern362 (x3, 
E_V1TImode) != 0
              || !(
#line 7521 "../../gcc/config/rs6000/rs6000.md"
((TARGET_P8_VECTOR || (GET_CODE (operands[3]) == AND))
   && reload_completed && int_reg_operand (operands[0], V1TImode)) && 
#line 784 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_267 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (peep2_current_count < 2)
    return NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return peephole2_2 (x1, insn, pmatch_len_);

    case PARALLEL:
      if (XVECLEN (x1, 0) != 2)
        return NULL;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return NULL;
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != UNSPEC
          || XVECLEN (x3, 0) != 3
          || pattern259 (x1, 
E_V1TImode, 
E_CCFPmode, 
106) != 0)
        return NULL;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V1TImode))
        return NULL;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V1TImode))
        return NULL;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!const_0_to_1_operand (operands[3], E_QImode))
        return NULL;
      x7 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x7) != PARALLEL
          || XVECLEN (x7, 0) != 2)
        return NULL;
      x8 = XVECEXP (x7, 0, 0);
      if (GET_CODE (x8) != SET)
        return NULL;
      x9 = XEXP (x8, 1);
      if (GET_CODE (x9) != COMPARE
          || GET_MODE (x9) != E_CCFPmode)
        return NULL;
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != UNSPEC
          || XVECLEN (x10, 0) != 3
          || GET_MODE (x10) != E_V2DFmode)
        return NULL;
      x11 = XEXP (x8, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 106
          || GET_MODE (x11) != E_CCFPmode)
        return NULL;
      x12 = XVECEXP (x7, 0, 1);
      if (GET_CODE (x12) != CLOBBER)
        return NULL;
      x13 = XEXP (x9, 1);
      operands[4] = x13;
      if (!zero_constant (operands[4], E_V2DFmode))
        return NULL;
      x14 = XEXP (x12, 0);
      operands[5] = x14;
      if (!register_operand (operands[5], E_V1TImode))
        return NULL;
      x15 = XVECEXP (x10, 0, 0);
      if (!rtx_equal_p (x15, operands[1]))
        return NULL;
      x16 = XVECEXP (x10, 0, 1);
      if (!rtx_equal_p (x16, operands[2]))
        return NULL;
      x17 = XVECEXP (x10, 0, 2);
      if (!rtx_equal_p (x17, operands[3]))
        return NULL;
      switch (XINT (x3, 1))
        {
        case 342:
          if (XINT (x10, 1) != 342
              || !
#line 4819 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_42 (insn, operands);

        case 343:
          if (XINT (x10, 1) != 343
              || !
#line 4819 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_43 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
