/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V2SFmode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 2)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) != CONST_INT
      || !vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x6 = XEXP (x2, 0);
  operands[1] = x6;
  return pattern6 (x3, 
E_V4SFmode); /* [-1, 1] */
}

int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != COMPARE
      || GET_MODE (x3) != E_CCFPmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x11) != CLOBBER)
    return -1;
  x12 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x2, 0);
  operands[0] = x13;
  if (!cc_reg_operand (operands[0], E_CCFPmode))
    return -1;
  x14 = XEXP (x3, 0);
  operands[1] = x14;
  x15 = XEXP (x3, 1);
  operands[2] = x15;
  x16 = XEXP (x4, 0);
  operands[3] = x16;
  if (!scratch_operand (operands[3], E_DFmode))
    return -1;
  x17 = XEXP (x5, 0);
  operands[4] = x17;
  if (!scratch_operand (operands[4], E_DFmode))
    return -1;
  x18 = XEXP (x6, 0);
  operands[5] = x18;
  if (!scratch_operand (operands[5], E_DFmode))
    return -1;
  x19 = XEXP (x7, 0);
  operands[6] = x19;
  if (!scratch_operand (operands[6], E_DFmode))
    return -1;
  x20 = XEXP (x8, 0);
  operands[7] = x20;
  if (!scratch_operand (operands[7], E_DFmode))
    return -1;
  x21 = XEXP (x9, 0);
  operands[8] = x21;
  if (!scratch_operand (operands[8], E_DFmode))
    return -1;
  x22 = XEXP (x10, 0);
  operands[9] = x22;
  if (!scratch_operand (operands[9], E_DFmode))
    return -1;
  x23 = XEXP (x11, 0);
  operands[10] = x23;
  if (!scratch_operand (operands[10], E_DFmode))
    return -1;
  x24 = XEXP (x12, 0);
  operands[11] = x24;
  switch (GET_MODE (operands[1]))
    {
    case E_IFmode:
      return pattern17 (
E_IFmode); /* [-1, 1] */

    case E_TFmode:
      res = pattern17 (
E_TFmode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern52 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern59 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  x5 = XEXP (x1, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          return pattern37 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern37 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern55 (x1, 
E_V4SImode) != 0)
            return -1;
          return 2;

        case E_V8HImode:
          if (pattern55 (x1, 
E_V8HImode) != 0)
            return -1;
          return 3;

        case E_V16QImode:
          if (pattern55 (x1, 
E_V16QImode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern55 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 5;

        case E_V2DFmode:
          if (pattern55 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 6;

        case E_V2DImode:
          if (pattern55 (x1, 
E_V2DImode) != 0)
            return -1;
          return 7;

        case E_V1TImode:
          if (pattern55 (x1, 
E_V1TImode) != 0)
            return -1;
          return 8;

        case E_TImode:
          if (pattern55 (x1, 
E_TImode) != 0)
            return -1;
          return 9;

        case E_KFmode:
          if (pattern55 (x1, 
E_KFmode) != 0)
            return -1;
          return 10;

        case E_TFmode:
          if (pattern55 (x1, 
E_TFmode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    case NOT:
      res = pattern58 (x1);
      if (res >= 0)
        return res + 12; /* [12, 23] */
      return -1;

    default:
      return -1;
    }
}

int
pattern79 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x2, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      return 0;

    case E_QImode:
      if (GET_MODE (x5) != E_QImode)
        return -1;
      return 1;

    case E_HImode:
      if (GET_MODE (x5) != E_HImode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern86 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      return pattern85 (x5, 
E_V4SImode); /* [-1, 0] */

    case E_V2DImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern85 (x5, 
E_V2DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern94 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern103 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !scc_eq_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern105 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i2)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern107 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V4SFmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 102
      || GET_MODE (x4) != E_V4SFmode)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  if (!vfloat_operand (operands[0], E_V4SFmode))
    return -1;
  x9 = XEXP (x3, 1);
  operands[1] = x9;
  if (!vfloat_operand (operands[1], E_V4SFmode))
    return -1;
  x10 = XEXP (x6, 0);
  operands[2] = x10;
  if (!scratch_operand (operands[2], E_V4SFmode))
    return -1;
  x11 = XEXP (x7, 0);
  operands[3] = x11;
  if (!scratch_operand (operands[3], E_V4SFmode))
    return -1;
  return 0;
}

int
pattern118 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern124 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !vector_shift_constant (operands[2], i1))
    return -1;
  return 0;
}

int
pattern132 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!gpc_reg_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern141 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern133 (x3, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern133 (x3, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern150 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4SFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V4SFmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V4SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern158 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V16QImode)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_V16QImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_V16QImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!gpc_reg_operand (operands[1], E_DImode))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[0] = x6;
  if (!vsx_register_operand (operands[0], E_V16QImode))
    return -1;
  x7 = XVECEXP (x2, 0, 2);
  operands[2] = x7;
  if (!register_operand (operands[2], E_DImode))
    return -1;
  x8 = XEXP (x3, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  return 0;
}

int
pattern166 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!gpc_reg_operand (operands[0], E_DImode)
      || GET_MODE (x2) != E_DImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!gpc_reg_operand (operands[1], E_DImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  if (!scc_eq_operand (operands[2], E_DImode))
    return -1;
  x7 = XEXP (x2, 1);
  operands[3] = x7;
  if (!gpc_reg_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

int
pattern173 (rtx x1, int *pnum_clobbers, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XEXP (x2, 0);
  operands[3] = x7;
  if (!cc_reg_operand (operands[3], E_CCmode))
    return -1;
  return 0;
}

int
pattern178 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!non_update_memory_operand (operands[1], i1)
      || !const_0_to_1_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!scratch_operand (operands[0], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!scratch_operand (operands[0], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern183 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern182 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern182 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern188 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != i2
      || XINT (x2, 1) != i1)
    return -1;
  return 0;
}

int
pattern193 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case CLOBBER:
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      x6 = XEXP (x5, 0);
      switch (GET_MODE (x6))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[1], E_SImode)
              || !gpc_reg_operand (operands[2], E_SImode)
              || !scratch_operand (operands[0], E_SImode))
            return -1;
          return 0;

        case E_DImode:
          if (!gpc_reg_operand (operands[1], E_DImode)
              || !gpc_reg_operand (operands[2], E_DImode)
              || !scratch_operand (operands[0], E_DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case SET:
      x7 = XEXP (x2, 1);
      if (GET_CODE (x7) != i1)
        return -1;
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      x8 = XEXP (x7, 0);
      if (!rtx_equal_p (x8, operands[1]))
        return -1;
      x9 = XEXP (x7, 1);
      if (!rtx_equal_p (x9, operands[2]))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      x6 = XEXP (x5, 0);
      switch (GET_MODE (x6))
        {
        case E_SImode:
          if (pattern192 (x7, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_DImode:
          if (pattern192 (x7, 
E_DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern218 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern227 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 356
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 106
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XVECEXP (x7, 0, 0);
  operands[1] = x8;
  x9 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!altivec_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x7) != E_V8HImode
          || !altivec_register_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!altivec_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x7) != E_V16QImode
          || !altivec_register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern243 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x1, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          return pattern184 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern184 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern240 (x1, 
E_V4SImode) != 0)
            return -1;
          return 2;

        case E_V8HImode:
          if (pattern240 (x1, 
E_V8HImode) != 0)
            return -1;
          return 3;

        case E_V16QImode:
          if (pattern240 (x1, 
E_V16QImode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern240 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 5;

        case E_V2DFmode:
          if (pattern240 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 6;

        case E_V2DImode:
          if (pattern240 (x1, 
E_V2DImode) != 0)
            return -1;
          return 7;

        case E_V1TImode:
          if (pattern240 (x1, 
E_V1TImode) != 0)
            return -1;
          return 8;

        case E_TImode:
          if (pattern240 (x1, 
E_TImode) != 0)
            return -1;
          return 9;

        case E_KFmode:
          if (pattern240 (x1, 
E_KFmode) != 0)
            return -1;
          return 10;

        case E_TFmode:
          if (pattern240 (x1, 
E_TFmode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          if (pattern241 (x1, 
E_SImode) != 0)
            return -1;
          return 12;

        case E_DImode:
          if (pattern241 (x1, 
E_DImode) != 0)
            return -1;
          return 13;

        case E_V4SImode:
          if (pattern242 (x1, 
E_V4SImode) != 0)
            return -1;
          return 14;

        case E_V8HImode:
          if (pattern242 (x1, 
E_V8HImode) != 0)
            return -1;
          return 15;

        case E_V16QImode:
          if (pattern242 (x1, 
E_V16QImode) != 0)
            return -1;
          return 16;

        case E_V4SFmode:
          if (pattern242 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 17;

        case E_V2DFmode:
          if (pattern242 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 18;

        case E_V2DImode:
          if (pattern242 (x1, 
E_V2DImode) != 0)
            return -1;
          return 19;

        case E_V1TImode:
          if (pattern242 (x1, 
E_V1TImode) != 0)
            return -1;
          return 20;

        case E_TImode:
          if (pattern242 (x1, 
E_TImode) != 0)
            return -1;
          return 21;

        case E_KFmode:
          if (pattern242 (x1, 
E_KFmode) != 0)
            return -1;
          return 22;

        case E_TFmode:
          if (pattern242 (x1, 
E_TFmode) != 0)
            return -1;
          return 23;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern279 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != NOT)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case NOT:
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      x8 = XEXP (x5, 1);
      switch (GET_CODE (x8))
        {
        case NOT:
          return pattern274 (x1); /* [-1, 11] */

        case REG:
        case SUBREG:
          res = pattern271 (x1);
          if (res >= 0)
            return res + 12; /* [12, 23] */
          return -1;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      res = pattern268 (x1);
      if (res >= 0)
        return res + 24; /* [24, 35] */
      return -1;

    default:
      return -1;
    }
}

int
pattern290 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsx_register_operand (operands[4], i1)
      || !vsx_register_operand (operands[5], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SFmode:
      if (!vsx_register_operand (operands[2], E_SFmode)
          || !vsx_register_operand (operands[3], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!vsx_register_operand (operands[2], E_DFmode)
          || !vsx_register_operand (operands[3], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern303 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern309 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !scc_comparison_operator (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_CCmode:
      if (!cc_reg_operand (operands[2], E_CCmode))
        return -1;
      return 0;

    case E_CCUNSmode:
      if (!cc_reg_operand (operands[2], E_CCUNSmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern320 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!vsx_register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!vsx_register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern331 (rtx x1, machine_mode i1, unsigned int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern339 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 98
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!gpc_reg_operand (operands[0], E_DImode))
    return -1;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != E_DImode)
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_DImode))
    return -1;
  x10 = XVECEXP (x1, 0, 2);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  if (!scratch_operand (operands[4], E_DImode))
    return -1;
  return pattern338 (x7); /* [-1, 1] */
}

int
pattern347 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!int_reg_operand (operands[0], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != COMPARE
      || GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  if (!cc_reg_operand (operands[2], E_CCmode))
    return -1;
  x5 = XEXP (x2, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  return 0;
}

int
pattern356 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || !boolean_or_operator (operands[3], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !logical_const_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern362 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!vlogical_operand (operands[0], i1)
      || !boolean_operator (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vlogical_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !vlogical_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern373 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern379 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x1, 1);
  return pattern375 (x5, 
i1); /* [-1, 0] */
}

int
pattern387 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != XOR)
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != NOT)
    return -1;
  x6 = XEXP (x4, 0);
  operands[0] = x6;
  x7 = XEXP (x4, 1);
  operands[1] = x7;
  x8 = XEXP (x5, 0);
  operands[2] = x8;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern385 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern385 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern386 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern386 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern386 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern386 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern386 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern386 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern386 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern386 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern386 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern386 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern402 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern400 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern400 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern401 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern401 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern401 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern401 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern401 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern401 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern401 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern401 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern401 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern401 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern424 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern422 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern422 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern423 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern423 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern423 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern423 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern423 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern423 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern423 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern423 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern423 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern423 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern443 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern454 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!scratch_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern463 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (!register_operand (x3, i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (!register_operand (x4, i1))
    return -1;
  return 0;
}

int
pattern467 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern475 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  switch (GET_CODE (x2))
    {
    case USE:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x3) != SET)
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != UNSPEC
          || XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != 3
          || GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 2
          || GET_MODE (x5) != E_DImode)
        return -1;
      return 0;

    case SET:
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != UNSPEC
          || XVECLEN (x6, 0) != 1
          || XINT (x6, 1) != 3
          || GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 2
          || GET_MODE (x7) != E_DImode)
        return -1;
      x3 = XVECEXP (x1, 0, 3);
      if (pattern474 (x3, 
96) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern491 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  x8 = XEXP (x4, 1);
  operands[2] = x8;
  x9 = XEXP (x6, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  x10 = XEXP (x6, 1);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  return 0;
}

int
pattern503 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern507 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 98
      || GET_MODE (x3) != E_DImode
      || !gpc_reg_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_DImode
      || !gpc_reg_operand (operands[1], E_DImode)
      || !scc_eq_operand (operands[2], E_DImode)
      || !scratch_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

int
pattern517 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !d_form_memory (operands[1], i1)
      || !vsx_register_operand (operands[2], E_DImode)
      || !base_reg_operand (operands[4], E_DImode))
    return -1;
  return 0;
}

int
pattern523 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!gpc_reg_operand (operands[1], E_DImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[2] = x7;
  if (!gpc_reg_operand (operands[2], E_DImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[3] = x8;
  if (!gpc_reg_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

int
pattern537 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V1TImode:
      if (!register_operand (operands[1], E_V1TImode)
          || !register_operand (operands[2], E_V1TImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode)
          || !register_operand (operands[2], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern545 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !reg_or_aligned_short_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern554 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case EQ:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x8, 1);
      x10 = XEXP (x9, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      return 0;

    case NE:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x8, 1);
      x10 = XEXP (x9, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern310 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 5627 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 362; /* *setnbcr_cc_si */

        case 1:
          if (!
#line 5627 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 364; /* *setnbcr_ccuns_si */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern310 (x2, 
E_DImode))
        {
        case 0:
          if (!(
#line 5627 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 363; /* *setnbcr_cc_di */

        case 1:
          if (!(
#line 5627 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 365; /* *setnbcr_ccuns_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 2);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!cc_reg_operand (operands[1], E_VOIDmode))
    return -1;
  x8 = XEXP (x2, 1);
  switch (GET_CODE (x8))
    {
    case RETURN:
      if (!
#line 13383 "../../gcc/config/rs6000/rs6000.md"
(direct_return ()))
        return -1;
      return 885; /* *creturn */

    case SIMPLE_RETURN:
      return 886; /* *creturn */

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      switch (pattern59 (x3))
        {
        case 0:
          if (!
#line 367 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2374; /* *fuse_and_and */

        case 1:
          if (!(
#line 367 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2375; /* *fuse_and_and */

        case 2:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2542; /* *fuse_vand_vand */

        case 3:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2543; /* *fuse_vand_vand */

        case 4:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2544; /* *fuse_vand_vand */

        case 5:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2545; /* *fuse_vand_vand */

        case 6:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2546; /* *fuse_vand_vand */

        case 7:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2547; /* *fuse_vand_vand */

        case 8:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2548; /* *fuse_vand_vand */

        case 9:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2549; /* *fuse_vand_vand */

        case 10:
          if (!(
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2550; /* *fuse_vand_vand */

        case 11:
          if (!(
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2551; /* *fuse_vand_vand */

        case 12:
          if (!
#line 547 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2394; /* *fuse_and_andc */

        case 13:
          if (!(
#line 547 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2395; /* *fuse_and_andc */

        case 14:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2622; /* *fuse_vand_vandc */

        case 15:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2623; /* *fuse_vand_vandc */

        case 16:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2624; /* *fuse_vand_vandc */

        case 17:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2625; /* *fuse_vand_vandc */

        case 18:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2626; /* *fuse_vand_vandc */

        case 19:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2627; /* *fuse_vand_vandc */

        case 20:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2628; /* *fuse_vand_vandc */

        case 21:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2629; /* *fuse_vand_vandc */

        case 22:
          if (!(
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2630; /* *fuse_vand_vandc */

        case 23:
          if (!(
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2631; /* *fuse_vand_vandc */

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x5, 0);
      operands[0] = x6;
      x7 = XEXP (x4, 1);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          switch (pattern54 (x3))
            {
            case 0:
              if (!
#line 385 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2376; /* *fuse_andc_and */

            case 1:
              if (!(
#line 385 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2377; /* *fuse_andc_and */

            case 2:
              if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2552; /* *fuse_vandc_vand */

            case 3:
              if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2553; /* *fuse_vandc_vand */

            case 4:
              if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2554; /* *fuse_vandc_vand */

            case 5:
              if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2555; /* *fuse_vandc_vand */

            case 6:
              if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2556; /* *fuse_vandc_vand */

            case 7:
              if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2557; /* *fuse_vandc_vand */

            case 8:
              if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2558; /* *fuse_vandc_vand */

            case 9:
              if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2559; /* *fuse_vandc_vand */

            case 10:
              if (!(
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2560; /* *fuse_vandc_vand */

            case 11:
              if (!(
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2561; /* *fuse_vandc_vand */

            case 12:
              if (!
#line 565 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2396; /* *fuse_andc_andc */

            case 13:
              if (!(
#line 565 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2397; /* *fuse_andc_andc */

            case 14:
              if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2632; /* *fuse_vandc_vandc */

            case 15:
              if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2633; /* *fuse_vandc_vandc */

            case 16:
              if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2634; /* *fuse_vandc_vandc */

            case 17:
              if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2635; /* *fuse_vandc_vandc */

            case 18:
              if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2636; /* *fuse_vandc_vandc */

            case 19:
              if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2637; /* *fuse_vandc_vandc */

            case 20:
              if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2638; /* *fuse_vandc_vandc */

            case 21:
              if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2639; /* *fuse_vandc_vandc */

            case 22:
              if (!(
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2640; /* *fuse_vandc_vandc */

            case 23:
              if (!(
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2641; /* *fuse_vandc_vandc */

            default:
              return -1;
            }

        case NOT:
          switch (pattern48 (x3))
            {
            case 0:
              if (!
#line 439 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2382; /* *fuse_nor_and */

            case 1:
              if (!(
#line 439 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2383; /* *fuse_nor_and */

            case 2:
              if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2582; /* *fuse_vnor_vand */

            case 3:
              if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2583; /* *fuse_vnor_vand */

            case 4:
              if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2584; /* *fuse_vnor_vand */

            case 5:
              if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2585; /* *fuse_vnor_vand */

            case 6:
              if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2586; /* *fuse_vnor_vand */

            case 7:
              if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2587; /* *fuse_vnor_vand */

            case 8:
              if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2588; /* *fuse_vnor_vand */

            case 9:
              if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2589; /* *fuse_vnor_vand */

            case 10:
              if (!(
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2590; /* *fuse_vnor_vand */

            case 11:
              if (!(
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2591; /* *fuse_vnor_vand */

            case 12:
              if (!
#line 619 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2402; /* *fuse_nor_andc */

            case 13:
              if (!(
#line 619 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2403; /* *fuse_nor_andc */

            case 14:
              if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2662; /* *fuse_vnor_vandc */

            case 15:
              if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2663; /* *fuse_vnor_vandc */

            case 16:
              if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2664; /* *fuse_vnor_vandc */

            case 17:
              if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2665; /* *fuse_vnor_vandc */

            case 18:
              if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2666; /* *fuse_vnor_vandc */

            case 19:
              if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2667; /* *fuse_vnor_vandc */

            case 20:
              if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2668; /* *fuse_vnor_vandc */

            case 21:
              if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2669; /* *fuse_vnor_vandc */

            case 22:
              if (!(
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2670; /* *fuse_vnor_vandc */

            case 23:
              if (!(
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2671; /* *fuse_vnor_vandc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pnum_clobbers == NULL
          || !gpc_reg_operand (operands[0], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      switch (pattern302 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
            return -1;
          *pnum_clobbers = 3;
          return 818; /* lesisi2_isel */

        case 1:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 838; /* lesidi2_isel */

        default:
          return -1;
        }

    case E_DImode:
      if (pnum_clobbers == NULL
          || !gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      switch (pattern302 (x2, 
E_DImode))
        {
        case 0:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 828; /* ledisi2_isel */

        case 1:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 848; /* ledidi2_isel */

        default:
          return -1;
        }

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern10 (x2, 
E_V4SFmode) != 0
          || !
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
        return -1;
      return 1125; /* vector_lev4sf */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern10 (x2, 
E_V2DFmode) != 0
          || !
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
        return -1;
      return 1132; /* vector_lev2df */

    default:
      return -1;
    }
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pnum_clobbers == NULL
          || !gpc_reg_operand (operands[0], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      switch (pattern302 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
            return -1;
          *pnum_clobbers = 3;
          return 820; /* gesisi2_isel */

        case 1:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 840; /* gesidi2_isel */

        default:
          return -1;
        }

    case E_DImode:
      if (pnum_clobbers == NULL
          || !gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      switch (pattern302 (x2, 
E_DImode))
        {
        case 0:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 830; /* gedisi2_isel */

        case 1:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 850; /* gedidi2_isel */

        default:
          return -1;
        }

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      if (vsx_register_operand (operands[0], E_V4SFmode)
          && vsx_register_operand (operands[1], E_V4SFmode)
          && vsx_register_operand (operands[2], E_V4SFmode)
          && 
#line 2175 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return 1273; /* *vsx_gev4sf */
      if (!altivec_register_operand (operands[0], E_V4SFmode)
          || !altivec_register_operand (operands[1], E_V4SFmode)
          || !altivec_register_operand (operands[2], E_V4SFmode)
          || !
#line 690 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
        return -1;
      return 1748; /* *altivec_gev4sf */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern2 (x2, 
E_V2DFmode) != 0
          || !
#line 2175 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1274; /* *vsx_gev2df */

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      res = recog_30 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL
          || GET_CODE (x3) != REG
          || REGNO (x3) != 98)
        return -1;
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || GET_MODE (x3) != E_SImode)
            return -1;
          *pnum_clobbers = 1;
          return 113; /* subfsi3_carry_in_xx */

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || GET_MODE (x3) != E_DImode
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 114; /* subfdi3_carry_in_xx */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x4 = XEXP (x2, 1);
      operands[3] = x4;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case ASHIFTRT:
          if (pattern282 (x2) != 0)
            return -1;
          x7 = XEXP (x3, 1);
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              x8 = XEXP (x6, 0);
              operands[2] = x8;
              x9 = XEXP (x7, 0);
              operands[1] = x9;
              if (!gpc_reg_operand (operands[1], E_HImode)
                  || !
#line 1286 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 35; /* *macchw */

            case ASHIFTRT:
              x10 = XEXP (x7, 1);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x8 = XEXP (x6, 0);
              operands[1] = x8;
              x9 = XEXP (x7, 0);
              operands[2] = x9;
              if (!gpc_reg_operand (operands[2], E_SImode)
                  || !
#line 1353 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 39; /* *machhw */

            default:
              return -1;
            }

        case LSHIFTRT:
          if (pattern282 (x2) != 0)
            return -1;
          x7 = XEXP (x3, 1);
          switch (GET_CODE (x7))
            {
            case ZERO_EXTEND:
              x8 = XEXP (x6, 0);
              operands[2] = x8;
              x9 = XEXP (x7, 0);
              operands[1] = x9;
              if (!gpc_reg_operand (operands[1], E_HImode)
                  || !
#line 1318 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 37; /* *macchwu */

            case LSHIFTRT:
              x10 = XEXP (x7, 1);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x8 = XEXP (x6, 0);
              operands[1] = x8;
              x9 = XEXP (x7, 0);
              operands[2] = x9;
              if (!gpc_reg_operand (operands[2], E_SImode)
                  || !
#line 1388 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 41; /* *machhwu */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern283 (x2, 
SIGN_EXTEND) != 0
              || !
#line 1417 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 43; /* *maclhw */

        case ZERO_EXTEND:
          if (pattern283 (x2, 
ZERO_EXTEND) != 0
              || !
#line 1446 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 45; /* *maclhwu */

        case REG:
        case SUBREG:
          operands[1] = x6;
          x7 = XEXP (x3, 1);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern410 (x2, 
E_SImode) != 0
                  || !
#line 3265 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MADDLD))
                return -1;
              return 170; /* maddldsi4 */

            case E_DImode:
              if (pattern410 (x2, 
E_DImode) != 0
                  || !(
#line 3265 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MADDLD) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 171; /* maddlddi4 */

            case E_V8HImode:
              if (!register_operand (operands[0], E_V8HImode)
                  || GET_MODE (x2) != E_V8HImode
                  || GET_MODE (x3) != E_V8HImode
                  || !register_operand (operands[1], E_V8HImode)
                  || !register_operand (operands[2], E_V8HImode)
                  || !register_operand (operands[3], E_V8HImode)
                  || !
#line 1144 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 1838; /* fmav8hi4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) == REG
              && REGNO (x4) == 98)
            {
              x5 = XEXP (x1, 0);
              operands[0] = x5;
              x7 = XEXP (x3, 1);
              operands[2] = x7;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern465 (x2, 
E_SImode) == 0)
                    {
                      *pnum_clobbers = 1;
                      return 80; /* *addsi3_carry_in_internal */
                    }
                  break;

                case E_DImode:
                  if (pattern465 (x2, 
E_DImode) == 0
                      && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    {
                      *pnum_clobbers = 1;
                      return 81; /* *adddi3_carry_in_internal */
                    }
                  break;

                default:
                  break;
                }
            }
          operands[0] = x6;
          if (altivec_register_operand (operands[0], E_V2DImode))
            {
              x5 = XEXP (x1, 0);
              operands[3] = x5;
              if (altivec_register_operand (operands[3], E_V2DImode)
                  && GET_MODE (x2) == E_V2DImode
                  && GET_MODE (x3) == E_V2DImode)
                {
                  x7 = XEXP (x3, 1);
                  operands[1] = x7;
                  if (altivec_register_operand (operands[1], E_V2DImode))
                    {
                      operands[2] = x4;
                      if (altivec_register_operand (operands[2], E_V2DImode)
                          && 
#line 3049 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        {
                          *pnum_clobbers = 1;
                          return 3184; /* *fuse_vaddudm_vaddudm */
                        }
                    }
                }
            }
          operands[1] = x6;
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 98)
            return -1;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              operands[2] = x4;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern481 (x2, 
E_SImode) != 0)
                    return -1;
                  *pnum_clobbers = 1;
                  return 82; /* *addsi3_carry_in_internal2 */

                case E_DImode:
                  if (pattern481 (x2, 
E_DImode) != 0
                      || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    return -1;
                  *pnum_clobbers = 1;
                  return 83; /* *adddi3_carry_in_internal2 */

                default:
                  return -1;
                }

            case CONST_INT:
              if (XWINT (x4, 0) != -1L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern482 (x2, 
E_SImode) != 0)
                    return -1;
                  *pnum_clobbers = 1;
                  return 86; /* addsi3_carry_in_m1 */

                case E_DImode:
                  if (pattern482 (x2, 
E_DImode) != 0
                      || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    return -1;
                  *pnum_clobbers = 1;
                  return 87; /* adddi3_carry_in_m1 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case NOT:
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 98)
            return -1;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          x4 = XEXP (x2, 1);
          operands[2] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern466 (x2, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 107; /* *subfsi3_carry_in_internal */

            case E_DImode:
              if (pattern466 (x2, 
E_DImode) != 0
                  || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              *pnum_clobbers = 1;
              return 108; /* *subfdi3_carry_in_internal */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 98)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern411 (x2, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 109; /* subfsi3_carry_in_0 */

        case E_DImode:
          if (pattern411 (x2, 
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 110; /* subfdi3_carry_in_0 */

        default:
          return -1;
        }

    case MINUS:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 98)
        return -1;
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + -2])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x7 = XEXP (x3, 1);
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern436 (x2, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 111; /* subfsi3_carry_in_m1 */

        case E_DImode:
          if (pattern436 (x2, 
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 112; /* subfdi3_carry_in_m1 */

        default:
          return -1;
        }

    case AND:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != ASHIFT)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern210 (x2))
        {
        case 0:
          if (!
#line 4333 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)))
            return -1;
          return 251; /* *rotlsi3_insert_3_plus */

        case 1:
          if (!(
#line 4333 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 253; /* *rotldi3_insert_3_plus */

        default:
          return -1;
        }

    case VEC_CONCAT:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_V2DFmode)
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != VEC_SELECT
          || GET_MODE (x6) != E_DFmode)
        return -1;
      x11 = XEXP (x6, 1);
      if (GET_CODE (x11) != PARALLEL
          || XVECLEN (x11, 0) != 1)
        return -1;
      x12 = XVECEXP (x11, 0, 0);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != VEC_SELECT
          || GET_MODE (x7) != E_DFmode)
        return -1;
      x10 = XEXP (x7, 1);
      if (GET_CODE (x10) != PARALLEL
          || XVECLEN (x10, 0) != 1)
        return -1;
      x13 = XVECEXP (x10, 0, 0);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (pattern4 (x2) != 0
          || !
#line 4927 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      *pnum_clobbers = 1;
      return 1520; /* vsx_reduc_plus_v2df */

    case UNSPEC:
      if (pnum_clobbers == NULL
          || XVECLEN (x3, 0) != 1
          || XINT (x3, 1) != 102
          || GET_MODE (x3) != E_V4SFmode)
        return -1;
      x14 = XVECEXP (x3, 0, 0);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (!vfloat_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode)
        return -1;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      if (!vfloat_operand (operands[1], E_V4SFmode)
          || !
#line 4949 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      *pnum_clobbers = 2;
      return 1523; /* vsx_reduc_plus_v4sf */

    default:
      return -1;
    }
}

 int
recog_89 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2DImode
      || !altivec_register_operand (operands[0], E_V2DImode))
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[1]))
    {
    case E_KFmode:
      if (!altivec_register_operand (operands[1], E_KFmode)
          || !(
#line 5200 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1544; /* xsxexpqp_kf_v2di */

    case E_TFmode:
      if (!altivec_register_operand (operands[1], E_TFmode)
          || !(
#line 5200 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1546; /* xsxexpqp_tf_v2di */

    default:
      return -1;
    }
}

 int
recog_99 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V16QImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V16QImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V16QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!const_0_to_12_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      if (!register_operand (operands[2], E_SImode)
          || !
#line 4423 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1450; /* vreplace_un_si */

    case E_SFmode:
      if (!register_operand (operands[2], E_SFmode)
          || !
#line 4423 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1451; /* vreplace_un_sf */

    case E_DImode:
      if (!register_operand (operands[2], E_DImode)
          || !
#line 4423 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1452; /* vreplace_un_di */

    case E_DFmode:
      if (!register_operand (operands[2], E_DFmode)
          || !
#line 4423 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1453; /* vreplace_un_df */

    default:
      return -1;
    }
}

 int
recog_104 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XINT (x3, 1))
    {
    case 32:
      return recog_84 (x1, insn, pnum_clobbers);

    case 50:
      return recog_60 (x1, insn, pnum_clobbers);

    case 33:
      return recog_75 (x1, insn, pnum_clobbers);

    case 46:
      return recog_76 (x1, insn, pnum_clobbers);

    case 85:
      return recog_73 (x1, insn, pnum_clobbers);

    case 54:
      if (GET_MODE (x3) != E_DImode
          || !gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!reg_or_indexed_operand (operands[1], E_SImode)
          || !
#line 5861 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX))
        return -1;
      return 390; /* lfiwax */

    case 55:
      if (GET_MODE (x3) != E_DImode
          || !gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!reg_or_indexed_operand (operands[1], E_SImode)
          || !
#line 5963 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX))
        return -1;
      return 399; /* lfiwzx */

    case 5:
      switch (pattern212 (x3, 
FIX))
        {
        case 0:
          if (!
#line 6669 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 453; /* fctiwz_sf */

        case 1:
          if (!
#line 6669 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 454; /* fctiwz_df */

        default:
          return -1;
        }

    case 56:
      switch (pattern212 (x3, 
UNSIGNED_FIX))
        {
        case 0:
          if (!
#line 6680 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTIWUZ))
            return -1;
          return 455; /* fctiwuz_sf */

        case 1:
          if (!
#line 6680 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTIWUZ))
            return -1;
          return 456; /* fctiwuz_df */

        default:
          return -1;
        }

    case 53:
      if (GET_MODE (x3) != E_DImode
          || !gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!gpc_reg_operand (operands[1], E_SFmode)
              || !
#line 6776 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTID))
            return -1;
          return 462; /* lrintsfdi2 */

        case E_DFmode:
          if (!gpc_reg_operand (operands[1], E_DFmode)
              || !
#line 6776 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTID))
            return -1;
          return 463; /* lrintdfdi2 */

        default:
          return -1;
        }

    case 52:
      return recog_92 (x1, insn, pnum_clobbers);

    case 9:
      return recog_61 (x1, insn, pnum_clobbers);

    case 8:
      return recog_70 (x1, insn, pnum_clobbers);

    case 6:
      return recog_71 (x1, insn, pnum_clobbers);

    case 7:
      return recog_67 (x1, insn, pnum_clobbers);

    case 10:
      return recog_83 (x1, insn, pnum_clobbers);

    case 31:
      if (GET_MODE (x3) != E_SImode
          || !memory_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !
#line 6880 "../../gcc/config/rs6000/rs6000.md"
(TARGET_PPC_GFXOPT))
        return -1;
      return 478; /* stfiwx */

    case 87:
      return recog_74 (x1, insn, pnum_clobbers);

    case 86:
      return recog_68 (x1, insn, pnum_clobbers);

    case 97:
      switch (pattern214 (x3))
        {
        case 0:
          if (!
#line 8733 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 586; /* xxspltidp_sf_internal */

        case 1:
          if (!
#line 8733 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 587; /* xxspltidp_df_internal */

        default:
          return -1;
        }

    case 98:
      switch (pattern214 (x3))
        {
        case 0:
          if (!
#line 8742 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 588; /* xxspltiw_sf_internal */

        case 1:
          if (!
#line 8742 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 589; /* xxspltiw_df_internal */

        default:
          return -1;
        }

    case 60:
      return recog_87 (x1, insn, pnum_clobbers);

    case 62:
      return recog_72 (x1, insn, pnum_clobbers);

    case 64:
      return recog_62 (x1, insn, pnum_clobbers);

    case 15:
      if (GET_MODE (x3) != E_DImode
          || !gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
          if (XWINT (x4, 0) != 0L)
            return -1;
          return 737; /* *tls_ld_pcrel64 */

        case REG:
        case SUBREG:
          operands[1] = x4;
          if (!gpc_reg_operand (operands[1], E_DImode))
            return -1;
          return 738; /* *tls_ld64 */

        default:
          return -1;
        }

    case 73:
      return recog_82 (x1, insn, pnum_clobbers);

    case 83:
      return recog_81 (x1, insn, pnum_clobbers);

    case 84:
      return recog_91 (x1, insn, pnum_clobbers);

    case 36:
      if (GET_MODE (x3) != E_BLKmode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      return 1102; /* *hwsync */

    case 37:
      if (GET_MODE (x3) != E_BLKmode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      return 1103; /* *lwsync */

    case 72:
      return recog_86 (x1, insn, pnum_clobbers);

    case 122:
      return recog_80 (x1, insn, pnum_clobbers);

    case 19:
      if (GET_MODE (x3) != E_CCmode
          || !cc_reg_operand (operands[0], E_CCmode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V16QImode)
          || !
#line 2214 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1279; /* *xvtlsbb_internal */

    case 124:
      switch (pattern215 (x3))
        {
        case 0:
          if (!
#line 2308 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (DFmode)))
            return -1;
          return 1292; /* vsx_xsrdpi */

        case 1:
          if (!
#line 2308 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1293; /* vsx_xvrspi */

        case 2:
          if (!
#line 2308 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1294; /* vsx_xvrdpi */

        default:
          return -1;
        }

    case 125:
      switch (pattern215 (x3))
        {
        case 0:
          if (!
#line 2316 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (DFmode)))
            return -1;
          return 1295; /* vsx_xsrdpic */

        case 1:
          if (!
#line 2316 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1296; /* vsx_xvrspic */

        case 2:
          if (!
#line 2316 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1297; /* vsx_xvrdpic */

        default:
          return -1;
        }

    case 107:
      return recog_65 (x1, insn, pnum_clobbers);

    case 108:
      if (GET_MODE (x3) != E_V4SFmode
          || !vsx_register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V16QImode)
          || !
#line 2427 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1313; /* vsx_xvcvhpsp */

    case 143:
      if (GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 2436 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1314; /* vsx_xvcvsphp */

    case 110:
      return recog_90 (x1, insn, pnum_clobbers);

    case 109:
      return recog_79 (x1, insn, pnum_clobbers);

    case 105:
      if (GET_MODE (x3) != E_V4SImode
          || !vsx_register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V2DFmode)
          || !
#line 2596 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1328; /* vsx_xvcvdpsxws */

    case 106:
      if (GET_MODE (x3) != E_V4SImode
          || !vsx_register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V2DFmode)
          || !
#line 2604 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1329; /* vsx_xvcvdpuxws */

    case 113:
      if (GET_MODE (x3) != E_V4SFmode
          || !vsx_register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V2DImode)
          || !
#line 2612 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1330; /* vsx_xvcvsxdsp */

    case 114:
      if (GET_MODE (x3) != E_V4SFmode
          || !vsx_register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V2DImode)
          || !
#line 2620 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1331; /* vsx_xvcvuxdsp */

    case 111:
      if (GET_MODE (x3) != E_DFmode
          || !vsx_register_operand (operands[0], E_DFmode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V4SImode)
          || !
#line 2661 "../../gcc/config/rs6000/vsx.md"
(TARGET_VSX))
        return -1;
      return 1336; /* vsx_xvcvsxwdp_df */

    case 112:
      if (GET_MODE (x3) != E_DFmode
          || !vsx_register_operand (operands[0], E_DFmode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V4SImode)
          || !
#line 2669 "../../gcc/config/rs6000/vsx.md"
(TARGET_VSX))
        return -1;
      return 1337; /* vsx_xvcvuxwdp_df */

    case 139:
      return recog_66 (x1, insn, pnum_clobbers);

    case 190:
      if (GET_MODE (x3) != E_TImode
          || !gpc_reg_operand (operands[0], E_TImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], E_TImode)
          || !
#line 5187 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1543; /* extendditi2_vector */

    case 146:
      return recog_89 (x1, insn, pnum_clobbers);

    case 147:
      return recog_88 (x1, insn, pnum_clobbers);

    case 155:
      switch (pattern216 (x3))
        {
        case 0:
          if (!
#line 5463 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1572; /* xvxexpsp */

        case 1:
          if (!
#line 5463 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1573; /* xvxexpdp */

        default:
          return -1;
        }

    case 156:
      switch (pattern216 (x3))
        {
        case 0:
          if (!
#line 5473 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1574; /* xvxsigsp */

        case 1:
          if (!
#line 5473 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1575; /* xvxsigdp */

        default:
          return -1;
        }

    case 141:
      if (GET_MODE (x3) != E_V16QImode
          || !vsx_register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V16QImode)
          || !
#line 6447 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1621; /* vsx_xvcvspbf16 */

    case 140:
      if (GET_MODE (x3) != E_V16QImode
          || !vsx_register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V16QImode)
          || !
#line 6447 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1622; /* vsx_xvcvbf16spn */

    case 189:
      return recog_63 (x1, insn, pnum_clobbers);

    case 192:
      return recog_64 (x1, insn, pnum_clobbers);

    case 204:
      return recog_77 (x1, insn, pnum_clobbers);

    case 205:
      if (GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[0], E_V2DFmode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!c32bit_cint_operand (operands[1], E_SImode)
          || !
#line 6628 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1662; /* xxspltidp_v2df_inst */

    case 356:
      switch (pattern217 (x3))
        {
        case 0:
          if (!
#line 907 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1801; /* vstrir_direct_v8hi */

        case 1:
          if (!
#line 907 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1802; /* vstrir_direct_v16qi */

        default:
          return -1;
        }

    case 357:
      switch (pattern217 (x3))
        {
        case 0:
          if (!
#line 959 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1805; /* vstril_direct_v8hi */

        case 1:
          if (!
#line 959 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1806; /* vstril_direct_v16qi */

        default:
          return -1;
        }

    case 360:
      return recog_85 (x1, insn, pnum_clobbers);

    case 256:
      if (GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode)
          || !
#line 2581 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1987; /* altivec_vrfin */

    case 261:
      if (GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode)
          || !
#line 2635 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1993; /* altivec_vlogefp */

    case 262:
      if (GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode)
          || !
#line 2643 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1994; /* altivec_vexptefp */

    case 264:
      switch (pattern218 (x3))
        {
        case 0:
          if (!
#line 2693 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 2007; /* altivec_vupkhsw */

        case 1:
          if (!
#line 2693 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 2008; /* altivec_vupkhsh */

        case 2:
          if (!
#line 2693 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 2009; /* altivec_vupkhsb */

        default:
          return -1;
        }

    case 266:
      switch (pattern218 (x3))
        {
        case 0:
          if (!
#line 2706 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 2010; /* altivec_vupkhsw_direct */

        case 1:
          if (!
#line 2706 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 2011; /* altivec_vupkhsh_direct */

        case 2:
          if (!
#line 2706 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 2012; /* altivec_vupkhsb_direct */

        default:
          return -1;
        }

    case 265:
      switch (pattern218 (x3))
        {
        case 0:
          if (!
#line 2714 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 2013; /* altivec_vupklsw */

        case 1:
          if (!
#line 2714 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 2014; /* altivec_vupklsh */

        case 2:
          if (!
#line 2714 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 2015; /* altivec_vupklsb */

        default:
          return -1;
        }

    case 267:
      switch (pattern218 (x3))
        {
        case 0:
          if (!
#line 2727 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 2016; /* *altivec_vupklsw_direct */

        case 1:
          if (!
#line 2727 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 2017; /* *altivec_vupklsh_direct */

        case 2:
          if (!
#line 2727 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 2018; /* *altivec_vupklsb_direct */

        default:
          return -1;
        }

    case 268:
      if (GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8HImode)
          || !
#line 2735 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2019; /* altivec_vupkhpx */

    case 269:
      if (GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8HImode)
          || !
#line 2748 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2020; /* altivec_vupklpx */

    case 162:
      switch (pattern219 (x3))
        {
        case 0:
          if (!
#line 3020 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2048; /* altivec_lvsl_reg_si */

        case 1:
          if (!(
#line 3020 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2049; /* altivec_lvsl_reg_di */

        default:
          return -1;
        }

    case 276:
      if (GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_V16QImode)
          || !
#line 3028 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2050; /* altivec_lvsl_direct */

    case 163:
      switch (pattern219 (x3))
        {
        case 0:
          if (!
#line 3058 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2051; /* altivec_lvsr_reg_si */

        case 1:
          if (!(
#line 3058 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2052; /* altivec_lvsr_reg_di */

        default:
          return -1;
        }

    case 277:
      if (GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_V16QImode)
          || !
#line 3066 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2053; /* altivec_lvsr_direct */

    case 281:
      return recog_69 (x1, insn, pnum_clobbers);

    case 301:
      if (GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode)
          || !
#line 4247 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
        return -1;
      return 2138; /* altivec_lvlx */

    case 302:
      if (GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode)
          || !
#line 4255 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
        return -1;
      return 2139; /* altivec_lvlxl */

    case 303:
      if (GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode)
          || !
#line 4263 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
        return -1;
      return 2140; /* altivec_lvrx */

    case 304:
      if (GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode)
          || !
#line 4271 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
        return -1;
      return 2141; /* altivec_lvrxl */

    case 329:
      if (GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V16QImode)
          || !
#line 4419 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2166; /* p8v_vgbbd */

    case 420:
      if (GET_MODE (x3) != E_XOmode
          || !fpr_reg_operand (operands[0], E_XOmode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!fpr_reg_operand (operands[1], E_XOmode)
          || !
#line 467 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2205; /* mma_xxmfacc */

    case 421:
      if (GET_MODE (x3) != E_XOmode
          || !fpr_reg_operand (operands[0], E_XOmode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!fpr_reg_operand (operands[1], E_XOmode)
          || !
#line 467 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2206; /* mma_xxmtacc */

    case 423:
      if (GET_MODE (x3) != E_DDmode
          || !nonimmediate_operand (operands[0], E_DDmode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!input_operand (operands[1], E_SDmode)
          || !
#line 41 "../../gcc/config/rs6000/dfp.md"
((gpc_reg_operand (operands[0], DDmode)
   || gpc_reg_operand (operands[1], SDmode))
   && TARGET_HARD_FLOAT))
        return -1;
      return 2266; /* movsd_store */

    case 422:
      if (GET_MODE (x3) != E_SDmode
          || !nonimmediate_operand (operands[0], E_SDmode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!input_operand (operands[1], E_DDmode)
          || !
#line 51 "../../gcc/config/rs6000/dfp.md"
((gpc_reg_operand (operands[0], SDmode)
   || gpc_reg_operand (operands[1], DDmode))
   && TARGET_HARD_FLOAT))
        return -1;
      return 2267; /* movsd_load */

    case 436:
      return recog_78 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_124 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (GET_MODE (x3) != E_SFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_SFmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (pnum_clobbers != NULL
                      && nonimmediate_operand (operands[1], E_SImode)
                      && 
#line 5976 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFIDS))
                    {
                      *pnum_clobbers = 1;
                      return 400; /* floatunssisf2_lfiwzx */
                    }
                  break;

                case E_DImode:
                  if (gpc_reg_operand (operands[1], E_DImode)
                      && 
#line 7118 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDUS))
                    return 494; /* floatunsdisf2_fcfidus */
                  if (pnum_clobbers != NULL
                      && memory_operand (operands[1], E_DImode)
                      && 
#line 7129 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDUS))
                    {
                      *pnum_clobbers = 1;
                      return 495; /* *floatunsdisf2_mem */
                    }
                  break;

                default:
                  break;
                }
            }
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern315 (
E_SFmode))
            {
            case 0:
              if (!
#line 6269 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 2;
              return 410; /* *floatunsqisf2_internal */

            case 1:
              if (!
#line 6269 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 2;
              return 411; /* *floatunshisf2_internal */

            default:
              return -1;
            }

        case E_DFmode:
          if (GET_MODE (x3) != E_DFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_DFmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (pnum_clobbers != NULL
                      && nonimmediate_operand (operands[1], E_SImode)
                      && 
#line 5976 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFID))
                    {
                      *pnum_clobbers = 1;
                      return 401; /* floatunssidf2_lfiwzx */
                    }
                  break;

                case E_DImode:
                  if (gpc_reg_operand (operands[1], E_DImode)
                      && 
#line 6994 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDU))
                    return 489; /* *floatunsdidf2_fcfidu */
                  if (pnum_clobbers != NULL
                      && memory_operand (operands[1], E_DImode)
                      && 
#line 7004 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && (TARGET_FCFIDU || VECTOR_UNIT_VSX_P (DFmode))))
                    {
                      *pnum_clobbers = 1;
                      return 490; /* *floatunsdidf2_mem */
                    }
                  break;

                default:
                  break;
                }
            }
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern315 (
E_DFmode))
            {
            case 0:
              if (!
#line 6269 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 2;
              return 412; /* *floatunsqidf2_internal */

            case 1:
              if (!
#line 6269 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 2;
              return 413; /* *floatunshidf2_internal */

            default:
              return -1;
            }

        case E_KFmode:
          if (GET_MODE (x3) != E_KFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_KFmode)
              && vsx_register_operand (operands[1], E_TImode)
              && (
#line 6942 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return 482; /* floatunstikf2 */
          if (!altivec_register_operand (operands[0], E_KFmode))
            return -1;
          switch (pattern316 (pnum_clobbers))
            {
            case 0:
              if (!(
#line 15384 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1055; /* floatuns_kfdi2_hw */

            case 1:
              if (!(
#line 15394 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1057; /* floatuns_kfsi2_hw */

            case 2:
              if (!(
#line 15414 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1059; /* floatunsqikf2 */

            case 3:
              if (!(
#line 15414 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1060; /* floatunshikf2 */

            default:
              return -1;
            }

        case E_TFmode:
          if (GET_MODE (x3) != E_TFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_TFmode)
              && vsx_register_operand (operands[1], E_TImode)
              && (
#line 6942 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return 483; /* floatunstitf2 */
          if (!altivec_register_operand (operands[0], E_TFmode))
            return -1;
          switch (pattern316 (pnum_clobbers))
            {
            case 0:
              if (!(
#line 15384 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1056; /* floatuns_tfdi2_hw */

            case 1:
              if (!(
#line 15394 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1058; /* floatuns_tfsi2_hw */

            case 2:
              if (!(
#line 15414 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1061; /* floatunsqitf2 */

            case 3:
              if (!(
#line 15414 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1062; /* floatunshitf2 */

            default:
              return -1;
            }

        case E_V4SFmode:
          if (GET_MODE (x3) != E_V4SFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_V4SFmode)
              && gpc_reg_operand (operands[1], E_V4SImode)
              && 
#line 2285 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return 1286; /* vsx_floatunsv4siv4sf2 */
          if (!vsx_register_operand (operands[0], E_V4SFmode)
              || !vsx_register_operand (operands[1], E_V4SImode)
              || !
#line 2489 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1321; /* vsx_xvcvuxwsp */

        case E_V2DFmode:
          if (GET_MODE (x3) != E_V2DFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_V2DFmode)
              && gpc_reg_operand (operands[1], E_V2DImode)
              && 
#line 2285 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return 1287; /* vsx_floatunsv2div2df2 */
          if (!vsx_register_operand (operands[0], E_V2DFmode)
              || !vsx_register_operand (operands[1], E_V2DImode)
              || !
#line 2496 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1323; /* vsx_xvcvuxddp */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern62 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 6016 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFIDS))
            return -1;
          *pnum_clobbers = 1;
          return 402; /* floatunssisf2_lfiwzx_mem */

        case 1:
          if (!
#line 6016 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFID))
            return -1;
          *pnum_clobbers = 1;
          return 403; /* floatunssidf2_lfiwzx_mem */

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!gpc_reg_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !gpc_reg_operand (operands[1], E_SFmode)
              || !
#line 6744 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_LFIWZX && TARGET_STFIWX && TARGET_FCFIDU && !TARGET_DIRECT_MOVE
   && can_create_pseudo_p ()))
            return -1;
          *pnum_clobbers = 2;
          return 460; /* *roundu32sf2_fprs */

        case E_DFmode:
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !gpc_reg_operand (operands[1], E_DFmode)
              || !
#line 6744 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_LFIWZX && TARGET_STFIWX && TARGET_FCFIDU && !TARGET_DIRECT_MOVE
   && can_create_pseudo_p ()))
            return -1;
          *pnum_clobbers = 2;
          return 461; /* *roundu32df2_fprs */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern64 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 2631 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode) && BYTES_BIG_ENDIAN))
            return -1;
          return 1333; /* vsx_xvcvuxwdp_be */

        case 1:
          if (!
#line 2640 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode) && !BYTES_BIG_ENDIAN))
            return -1;
          return 1335; /* vsx_xvcvuxwdp_le */

        case 2:
          if (const_0_to_3_operand (operands[2], E_QImode)
              && 
#line 4437 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
            {
              *pnum_clobbers = 1;
              return 1455; /* *vsx_extract_si_unsfloat_df */
            }
          if (!const_int_operand (operands[2], E_QImode)
              || !
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1485; /* *vsx_ext_SI_ufl_df */

        case 3:
          if (!
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1477; /* *vsx_ext_QI_ufl_df */

        case 4:
          if (!
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1481; /* *vsx_ext_HI_ufl_df */

        case 5:
          if (const_0_to_3_operand (operands[2], E_QImode)
              && 
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
            {
              *pnum_clobbers = 2;
              return 1457; /* *vsx_extract_si_unsfloat_sf */
            }
          if (!const_int_operand (operands[2], E_QImode)
              || !
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1484; /* *vsx_ext_SI_ufl_sf */

        case 6:
          if (!
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1476; /* *vsx_ext_QI_ufl_sf */

        case 7:
          if (!
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 1480; /* *vsx_ext_HI_ufl_sf */

        case 8:
          if (!(
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 230 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (IFmode))))
            return -1;
          *pnum_clobbers = 2;
          return 1459; /* *vsx_extract_si_unsfloat_if */

        case 9:
          if (const_0_to_3_operand (operands[2], E_QImode)
              && (
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 231 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            {
              *pnum_clobbers = 2;
              return 1461; /* *vsx_extract_si_unsfloat_kf */
            }
          if (!const_int_operand (operands[2], E_QImode)
              || !(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            return -1;
          *pnum_clobbers = 1;
          return 1486; /* *vsx_ext_SI_ufl_kf */

        case 10:
          if (!(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            return -1;
          *pnum_clobbers = 1;
          return 1478; /* *vsx_ext_QI_ufl_kf */

        case 11:
          if (!(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)))
            return -1;
          *pnum_clobbers = 1;
          return 1482; /* *vsx_ext_HI_ufl_kf */

        case 12:
          if (const_0_to_3_operand (operands[2], E_QImode)
              && (
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 232 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (TFmode)
					   || (FLOAT128_IEEE_P (TFmode)
					       && TARGET_FLOAT128_HW))))
            {
              *pnum_clobbers = 2;
              return 1463; /* *vsx_extract_si_unsfloat_tf */
            }
          if (!const_int_operand (operands[2], E_QImode)
              || !(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 1487; /* *vsx_ext_SI_ufl_tf */

        case 13:
          if (!(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 1479; /* *vsx_ext_QI_ufl_tf */

        case 14:
          if (!(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 1483; /* *vsx_ext_HI_ufl_tf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_138 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (GET_MODE (x3) != E_SFmode)
        return -1;
      if (gpc_reg_operand (operands[0], E_SFmode)
          && gpc_reg_operand (operands[1], E_DFmode)
          && 
#line 5278 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
        return 319; /* *truncdfsf2_fpr */
      if (pnum_clobbers == NULL
          || !vsx_register_operand (operands[0], E_SFmode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_KFmode:
          if (!altivec_register_operand (operands[1], E_KFmode)
              || !(
#line 15257 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 1017; /* trunckfsf2_hw */

        case E_TFmode:
          if (!altivec_register_operand (operands[1], E_TFmode)
              || !(
#line 15257 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 1018; /* trunctfsf2_hw */

        default:
          return -1;
        }

    case E_DFmode:
      if (GET_MODE (x3) != E_DFmode)
        return -1;
      if (gpc_reg_operand (operands[0], E_DFmode))
        {
          switch (GET_MODE (operands[1]))
            {
            case E_IFmode:
              if (gpc_reg_operand (operands[1], E_IFmode))
                {
                  if ((
#line 8978 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
                    return 604; /* truncifdf2_internal1 */
                  if ((
#line 8994 "../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT && TARGET_HARD_FLOAT
   && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
                    return 606; /* truncifdf2_internal2 */
                }
              break;

            case E_TFmode:
              if (gpc_reg_operand (operands[1], E_TFmode))
                {
                  if ((
#line 8978 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
                    return 605; /* trunctfdf2_internal1 */
                  if ((
#line 8994 "../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT && TARGET_HARD_FLOAT
   && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
                    return 607; /* trunctfdf2_internal2 */
                }
              break;

            default:
              break;
            }
        }
      if (!altivec_register_operand (operands[0], E_DFmode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_KFmode:
          if (!altivec_register_operand (operands[1], E_KFmode)
              || !(
#line 15244 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1015; /* trunckfdf2_hw */

        case E_TFmode:
          if (!altivec_register_operand (operands[1], E_TFmode)
              || !(
#line 15244 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1016; /* trunctfdf2_hw */

        default:
          return -1;
        }

    case E_SDmode:
      if (!gpc_reg_operand (operands[0], E_SDmode)
          || GET_MODE (x3) != E_SDmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DDmode:
          if (!gpc_reg_operand (operands[1], E_DDmode)
              || !
#line 80 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2269; /* truncddsd2 */

        case E_TDmode:
          if (pnum_clobbers == NULL
              || !gpc_reg_operand (operands[1], E_TDmode)
              || !
#line 165 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2278; /* trunctdsd2 */

        default:
          return -1;
        }

    case E_DDmode:
      if (pnum_clobbers == NULL
          || !gpc_reg_operand (operands[0], E_DDmode)
          || GET_MODE (x3) != E_DDmode
          || !gpc_reg_operand (operands[1], E_TDmode)
          || !
#line 154 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
        return -1;
      *pnum_clobbers = 1;
      return 2277; /* trunctddd2 */

    default:
      return -1;
    }
}

 int
recog_147 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 1);
  operands[4] = x8;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  x9 = XEXP (x6, 1);
  operands[2] = x9;
  x10 = XEXP (x2, 0);
  operands[0] = x10;
  switch (GET_MODE (x6))
    {
    case E_SImode:
      if (pattern544 (x7, 
E_SImode) != 0
          || !
#line 3756 "../../gcc/config/rs6000/rs6000.md"
(logical_const_operand (GEN_INT (UINTVAL (operands[2])
				   << INTVAL (operands[4])),
			  DImode)
   && (SImode == Pmode
       || (UINTVAL (operands[2]) << INTVAL (operands[4])) <= 0x7fffffff)))
        return -1;
      return 198; /* *andsi3_imm_dot_shifted */

    case E_DImode:
      if (pattern544 (x7, 
E_DImode) != 0
          || !(
#line 3756 "../../gcc/config/rs6000/rs6000.md"
(logical_const_operand (GEN_INT (UINTVAL (operands[2])
				   << INTVAL (operands[4])),
			  DImode)
   && (DImode == Pmode
       || (UINTVAL (operands[2]) << INTVAL (operands[4])) <= 0x7fffffff)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
        return -1;
      return 199; /* *anddi3_imm_dot_shifted */

    default:
      return -1;
    }
}

 int
recog_152 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET
      || pattern289 (x1, 
E_DImode) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != E_DImode)
    return -1;
  switch (GET_CODE (x6))
    {
    case LTU:
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != PLUS
          || GET_MODE (x7) != E_DImode
          || !reg_or_short_operand (operands[2], E_DImode))
        return -1;
      x8 = XEXP (x7, 0);
      if (!rtx_equal_p (x8, operands[1]))
        return -1;
      x9 = XEXP (x7, 1);
      if (!rtx_equal_p (x9, operands[2]))
        return -1;
      x10 = XEXP (x6, 1);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      return 75; /* adddi3_carry */

    case GEU:
      if (!short_cint_operand (operands[2], E_DImode))
        return -1;
      x10 = XEXP (x6, 1);
      operands[3] = x10;
      if (!const_int_operand (operands[3], E_DImode))
        return -1;
      x7 = XEXP (x6, 0);
      if (!rtx_equal_p (x7, operands[1])
          || !(
#line 2010 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) + INTVAL (operands[3]) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return -1;
      return 76; /* *adddi3_imm_carry_pos */

    case GTU:
      if (!short_cint_operand (operands[2], E_DImode))
        return -1;
      x10 = XEXP (x6, 1);
      operands[3] = x10;
      if (!const_int_operand (operands[3], E_DImode))
        return -1;
      x7 = XEXP (x6, 0);
      if (!rtx_equal_p (x7, operands[1])
          || !(
#line 2042 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) < 0
   && INTVAL (operands[2]) + INTVAL (operands[3]) == -1) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return -1;
      return 79; /* *adddi3_imm_carry_neg */

    default:
      return -1;
    }
}

 int
recog_158 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pattern189 (x1) != 0)
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_DImode:
      if (!gpc_reg_operand (operands[3], E_DImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_SImode:
          x5 = XEXP (x4, 0);
          switch (GET_MODE (x5))
            {
            case E_SImode:
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 1);
              if (pattern552 (x7, 
E_SImode) != 0
                  || !(
#line 10308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && !avoiding_indexed_address_p (DImode)) && (((((
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))))
                return -1;
              return 697; /* *movsi_update2 */

            case E_DImode:
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 1);
              if (pattern552 (x7, 
E_DImode) != 0
                  || !(
#line 10308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && !avoiding_indexed_address_p (DImode)) && (((((
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))))
                return -1;
              return 698; /* *movsi_update2 */

            default:
              return -1;
            }

        case E_HImode:
          x5 = XEXP (x4, 0);
          switch (GET_MODE (x5))
            {
            case E_SImode:
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 1);
              if (pattern527 (x7, 
E_SImode) != 0
                  || !(
#line 10389 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && !(avoiding_indexed_address_p (HImode)
	&& gpc_reg_operand (operands[2], Pmode))) && (((((
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))))
                return -1;
              return 708; /* *movhi_update3 */

            case E_DImode:
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 1);
              if (pattern527 (x7, 
E_DImode) != 0
                  || !(
#line 10389 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && !(avoiding_indexed_address_p (HImode)
	&& gpc_reg_operand (operands[2], Pmode))) && (((((
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))))
                return -1;
              return 710; /* *movhi_update3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_SImode:
      if (!gpc_reg_operand (operands[3], E_SImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_HImode)
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_MODE (x5))
        {
        case E_SImode:
          x6 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x6, 1);
          if (pattern527 (x7, 
E_SImode) != 0
              || !(
#line 10389 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && !(avoiding_indexed_address_p (HImode)
	&& gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 707; /* *movhi_update3 */

        case E_DImode:
          x6 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x6, 1);
          if (pattern527 (x7, 
E_DImode) != 0
              || !(
#line 10389 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && !(avoiding_indexed_address_p (HImode)
	&& gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 709; /* *movhi_update3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_164 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x3, 0);
      operands[0] = x6;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      x8 = XEXP (x2, 0);
      operands[3] = x8;
      if (!scratch_operand (operands[3], E_CCmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern470 (x4, 
E_SImode) != 0
              || !
#line 3642 "../../gcc/config/rs6000/rs6000.md"
(!rs6000_is_valid_and_mask (operands[2], SImode)))
            return -1;
          return 188; /* andsi3_imm */

        case E_DImode:
          if (pattern470 (x4, 
E_DImode) != 0
              || !(
#line 3642 "../../gcc/config/rs6000/rs6000.md"
(!rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 189; /* anddi3_imm */

        default:
          return -1;
        }

    case AND:
      switch (pattern244 (x1))
        {
        case 0:
          if (!
#line 367 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2374; /* *fuse_and_and */

        case 1:
          if (!(
#line 367 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2375; /* *fuse_and_and */

        case 2:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2542; /* *fuse_vand_vand */

        case 3:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2543; /* *fuse_vand_vand */

        case 4:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2544; /* *fuse_vand_vand */

        case 5:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2545; /* *fuse_vand_vand */

        case 6:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2546; /* *fuse_vand_vand */

        case 7:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2547; /* *fuse_vand_vand */

        case 8:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2548; /* *fuse_vand_vand */

        case 9:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2549; /* *fuse_vand_vand */

        case 10:
          if (!(
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2550; /* *fuse_vand_vand */

        case 11:
          if (!(
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2551; /* *fuse_vand_vand */

        case 12:
          if (!
#line 547 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2394; /* *fuse_and_andc */

        case 13:
          if (!(
#line 547 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2395; /* *fuse_and_andc */

        case 14:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2622; /* *fuse_vand_vandc */

        case 15:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2623; /* *fuse_vand_vandc */

        case 16:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2624; /* *fuse_vand_vandc */

        case 17:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2625; /* *fuse_vand_vandc */

        case 18:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2626; /* *fuse_vand_vandc */

        case 19:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2627; /* *fuse_vand_vandc */

        case 20:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2628; /* *fuse_vand_vandc */

        case 21:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2629; /* *fuse_vand_vandc */

        case 22:
          if (!(
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2630; /* *fuse_vand_vandc */

        case 23:
          if (!(
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2631; /* *fuse_vand_vandc */

        case 24:
          if (!
#line 385 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2376; /* *fuse_andc_and */

        case 25:
          if (!(
#line 385 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2377; /* *fuse_andc_and */

        case 26:
          if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2552; /* *fuse_vandc_vand */

        case 27:
          if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2553; /* *fuse_vandc_vand */

        case 28:
          if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2554; /* *fuse_vandc_vand */

        case 29:
          if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2555; /* *fuse_vandc_vand */

        case 30:
          if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2556; /* *fuse_vandc_vand */

        case 31:
          if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2557; /* *fuse_vandc_vand */

        case 32:
          if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2558; /* *fuse_vandc_vand */

        case 33:
          if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2559; /* *fuse_vandc_vand */

        case 34:
          if (!(
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2560; /* *fuse_vandc_vand */

        case 35:
          if (!(
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2561; /* *fuse_vandc_vand */

        case 36:
          if (!
#line 565 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2396; /* *fuse_andc_andc */

        case 37:
          if (!(
#line 565 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2397; /* *fuse_andc_andc */

        case 38:
          if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2632; /* *fuse_vandc_vandc */

        case 39:
          if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2633; /* *fuse_vandc_vandc */

        case 40:
          if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2634; /* *fuse_vandc_vandc */

        case 41:
          if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2635; /* *fuse_vandc_vandc */

        case 42:
          if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2636; /* *fuse_vandc_vandc */

        case 43:
          if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2637; /* *fuse_vandc_vandc */

        case 44:
          if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2638; /* *fuse_vandc_vandc */

        case 45:
          if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2639; /* *fuse_vandc_vandc */

        case 46:
          if (!(
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2640; /* *fuse_vandc_vandc */

        case 47:
          if (!(
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2641; /* *fuse_vandc_vandc */

        case 48:
          if (!
#line 439 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2382; /* *fuse_nor_and */

        case 49:
          if (!(
#line 439 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2383; /* *fuse_nor_and */

        case 50:
          if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2582; /* *fuse_vnor_vand */

        case 51:
          if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2583; /* *fuse_vnor_vand */

        case 52:
          if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2584; /* *fuse_vnor_vand */

        case 53:
          if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2585; /* *fuse_vnor_vand */

        case 54:
          if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2586; /* *fuse_vnor_vand */

        case 55:
          if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2587; /* *fuse_vnor_vand */

        case 56:
          if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2588; /* *fuse_vnor_vand */

        case 57:
          if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2589; /* *fuse_vnor_vand */

        case 58:
          if (!(
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2590; /* *fuse_vnor_vand */

        case 59:
          if (!(
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2591; /* *fuse_vnor_vand */

        case 60:
          if (!
#line 619 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2402; /* *fuse_nor_andc */

        case 61:
          if (!(
#line 619 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2403; /* *fuse_nor_andc */

        case 62:
          if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2662; /* *fuse_vnor_vandc */

        case 63:
          if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2663; /* *fuse_vnor_vandc */

        case 64:
          if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2664; /* *fuse_vnor_vandc */

        case 65:
          if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2665; /* *fuse_vnor_vandc */

        case 66:
          if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2666; /* *fuse_vnor_vandc */

        case 67:
          if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2667; /* *fuse_vnor_vandc */

        case 68:
          if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2668; /* *fuse_vnor_vandc */

        case 69:
          if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2669; /* *fuse_vnor_vandc */

        case 70:
          if (!(
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2670; /* *fuse_vnor_vandc */

        case 71:
          if (!(
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2671; /* *fuse_vnor_vandc */

        default:
          return -1;
        }

    case NOT:
      return recog_156 (x1, insn, pnum_clobbers);

    case IOR:
      switch (pattern245 (x1))
        {
        case 0:
          if (!
#line 421 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2380; /* *fuse_nand_and */

        case 1:
          if (!(
#line 421 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2381; /* *fuse_nand_and */

        case 2:
          if (!
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2572; /* *fuse_vnand_vand */

        case 3:
          if (!
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2573; /* *fuse_vnand_vand */

        case 4:
          if (!
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2574; /* *fuse_vnand_vand */

        case 5:
          if (!
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2575; /* *fuse_vnand_vand */

        case 6:
          if (!
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2576; /* *fuse_vnand_vand */

        case 7:
          if (!
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2577; /* *fuse_vnand_vand */

        case 8:
          if (!
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2578; /* *fuse_vnand_vand */

        case 9:
          if (!
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2579; /* *fuse_vnand_vand */

        case 10:
          if (!(
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2580; /* *fuse_vnand_vand */

        case 11:
          if (!(
#line 1933 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2581; /* *fuse_vnand_vand */

        case 12:
          if (!
#line 601 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2400; /* *fuse_nand_andc */

        case 13:
          if (!(
#line 601 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2401; /* *fuse_nand_andc */

        case 14:
          if (!
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2652; /* *fuse_vnand_vandc */

        case 15:
          if (!
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2653; /* *fuse_vnand_vandc */

        case 16:
          if (!
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2654; /* *fuse_vnand_vandc */

        case 17:
          if (!
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2655; /* *fuse_vnand_vandc */

        case 18:
          if (!
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2656; /* *fuse_vnand_vandc */

        case 19:
          if (!
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2657; /* *fuse_vnand_vandc */

        case 20:
          if (!
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2658; /* *fuse_vnand_vandc */

        case 21:
          if (!
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2659; /* *fuse_vnand_vandc */

        case 22:
          if (!(
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2660; /* *fuse_vnand_vandc */

        case 23:
          if (!(
#line 2077 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2661; /* *fuse_vnand_vandc */

        case 24:
          if (!
#line 475 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2386; /* *fuse_orc_and */

        case 25:
          if (!(
#line 475 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2387; /* *fuse_orc_and */

        case 26:
          if (!
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2602; /* *fuse_vorc_vand */

        case 27:
          if (!
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2603; /* *fuse_vorc_vand */

        case 28:
          if (!
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2604; /* *fuse_vorc_vand */

        case 29:
          if (!
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2605; /* *fuse_vorc_vand */

        case 30:
          if (!
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2606; /* *fuse_vorc_vand */

        case 31:
          if (!
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2607; /* *fuse_vorc_vand */

        case 32:
          if (!
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2608; /* *fuse_vorc_vand */

        case 33:
          if (!
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2609; /* *fuse_vorc_vand */

        case 34:
          if (!(
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2610; /* *fuse_vorc_vand */

        case 35:
          if (!(
#line 1987 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2611; /* *fuse_vorc_vand */

        case 36:
          if (!
#line 655 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2406; /* *fuse_orc_andc */

        case 37:
          if (!(
#line 655 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2407; /* *fuse_orc_andc */

        case 38:
          if (!
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2682; /* *fuse_vorc_vandc */

        case 39:
          if (!
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2683; /* *fuse_vorc_vandc */

        case 40:
          if (!
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2684; /* *fuse_vorc_vandc */

        case 41:
          if (!
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2685; /* *fuse_vorc_vandc */

        case 42:
          if (!
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2686; /* *fuse_vorc_vandc */

        case 43:
          if (!
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2687; /* *fuse_vorc_vandc */

        case 44:
          if (!
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2688; /* *fuse_vorc_vandc */

        case 45:
          if (!
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2689; /* *fuse_vorc_vandc */

        case 46:
          if (!(
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2690; /* *fuse_vorc_vandc */

        case 47:
          if (!(
#line 2131 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2691; /* *fuse_vorc_vandc */

        case 48:
          if (!
#line 457 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2384; /* *fuse_or_and */

        case 49:
          if (!(
#line 457 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2385; /* *fuse_or_and */

        case 50:
          if (!
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2592; /* *fuse_vor_vand */

        case 51:
          if (!
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2593; /* *fuse_vor_vand */

        case 52:
          if (!
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2594; /* *fuse_vor_vand */

        case 53:
          if (!
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2595; /* *fuse_vor_vand */

        case 54:
          if (!
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2596; /* *fuse_vor_vand */

        case 55:
          if (!
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2597; /* *fuse_vor_vand */

        case 56:
          if (!
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2598; /* *fuse_vor_vand */

        case 57:
          if (!
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2599; /* *fuse_vor_vand */

        case 58:
          if (!(
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2600; /* *fuse_vor_vand */

        case 59:
          if (!(
#line 1969 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2601; /* *fuse_vor_vand */

        case 60:
          if (!
#line 637 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2404; /* *fuse_or_andc */

        case 61:
          if (!(
#line 637 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2405; /* *fuse_or_andc */

        case 62:
          if (!
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2672; /* *fuse_vor_vandc */

        case 63:
          if (!
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2673; /* *fuse_vor_vandc */

        case 64:
          if (!
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2674; /* *fuse_vor_vandc */

        case 65:
          if (!
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2675; /* *fuse_vor_vandc */

        case 66:
          if (!
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2676; /* *fuse_vor_vandc */

        case 67:
          if (!
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2677; /* *fuse_vor_vandc */

        case 68:
          if (!
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2678; /* *fuse_vor_vandc */

        case 69:
          if (!
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2679; /* *fuse_vor_vandc */

        case 70:
          if (!(
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2680; /* *fuse_vor_vandc */

        case 71:
          if (!(
#line 2113 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2681; /* *fuse_vor_vandc */

        default:
          return -1;
        }

    case XOR:
      switch (pattern246 (x1))
        {
        case 0:
          if (!
#line 493 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2388; /* *fuse_xor_and */

        case 1:
          if (!(
#line 493 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2389; /* *fuse_xor_and */

        case 2:
          if (!
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2612; /* *fuse_vxor_vand */

        case 3:
          if (!
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2613; /* *fuse_vxor_vand */

        case 4:
          if (!
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2614; /* *fuse_vxor_vand */

        case 5:
          if (!
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2615; /* *fuse_vxor_vand */

        case 6:
          if (!
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2616; /* *fuse_vxor_vand */

        case 7:
          if (!
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2617; /* *fuse_vxor_vand */

        case 8:
          if (!
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2618; /* *fuse_vxor_vand */

        case 9:
          if (!
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2619; /* *fuse_vxor_vand */

        case 10:
          if (!(
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2620; /* *fuse_vxor_vand */

        case 11:
          if (!(
#line 2005 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2621; /* *fuse_vxor_vand */

        case 12:
          if (!
#line 673 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2408; /* *fuse_xor_andc */

        case 13:
          if (!(
#line 673 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2409; /* *fuse_xor_andc */

        case 14:
          if (!
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2692; /* *fuse_vxor_vandc */

        case 15:
          if (!
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2693; /* *fuse_vxor_vandc */

        case 16:
          if (!
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2694; /* *fuse_vxor_vandc */

        case 17:
          if (!
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2695; /* *fuse_vxor_vandc */

        case 18:
          if (!
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2696; /* *fuse_vxor_vandc */

        case 19:
          if (!
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2697; /* *fuse_vxor_vandc */

        case 20:
          if (!
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2698; /* *fuse_vxor_vandc */

        case 21:
          if (!
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2699; /* *fuse_vxor_vandc */

        case 22:
          if (!(
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2700; /* *fuse_vxor_vandc */

        case 23:
          if (!(
#line 2149 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2701; /* *fuse_vxor_vandc */

        default:
          return -1;
        }

    case PLUS:
      switch (pattern248 (x1))
        {
        case 0:
          if (!
#line 511 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2390; /* *fuse_add_and */

        case 1:
          if (!(
#line 511 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2391; /* *fuse_add_and */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern248 (x1))
        {
        case 0:
          if (!
#line 529 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2392; /* *fuse_subf_and */

        case 1:
          if (!(
#line 529 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2393; /* *fuse_subf_and */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ZERO_EXTEND:
      switch (pattern169 (x1, 
ZERO_EXTEND))
        {
        case 0:
          if (!
#line 886 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode)))
            return NULL;
          return gen_split_1 (insn, operands);

        case 1:
          if (!
#line 940 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode)))
            return NULL;
          return gen_split_5 (insn, operands);

        case 2:
          if (!(
#line 490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 886 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_2 (insn, operands);

        case 3:
          if (!(
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 940 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_6 (insn, operands);

        case 4:
          if (!(
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 997 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_9 (insn, operands);

        case 5:
          if (!
#line 907 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode)))
            return NULL;
          return gen_split_3 (insn, operands);

        case 6:
          if (!
#line 961 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode)))
            return NULL;
          return gen_split_7 (insn, operands);

        case 7:
          if (!(
#line 490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 907 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_4 (insn, operands);

        case 8:
          if (!(
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 961 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_8 (insn, operands);

        case 9:
          if (!(
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 1018 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_10 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      switch (pattern169 (x1, 
SIGN_EXTEND))
        {
        case 0:
          if (!
#line 1049 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode)))
            return NULL;
          return gen_split_11 (insn, operands);

        case 1:
          if (!
#line 1124 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode)))
            return NULL;
          return gen_split_17 (insn, operands);

        case 2:
          if (!(
#line 490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 1049 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_12 (insn, operands);

        case 3:
          if (!(
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 1124 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_18 (insn, operands);

        case 4:
          if (!(
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 1224 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_23 (insn, operands);

        case 5:
          if (!
#line 1070 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode)))
            return NULL;
          return gen_split_13 (insn, operands);

        case 6:
          if (!
#line 1145 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode)))
            return NULL;
          return gen_split_19 (insn, operands);

        case 7:
          if (!(
#line 490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 1070 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_14 (insn, operands);

        case 8:
          if (!(
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 1145 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_20 (insn, operands);

        case 9:
          if (!(
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 1245 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_24 (insn, operands);

        default:
          return NULL;
        }

    case PLUS:
      switch (pattern195 (x1, 
PLUS))
        {
        case 0:
          if (!(
#line 1872 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 1876 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_25 (insn, operands);

        case 1:
          if (!((
#line 1872 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 1876 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_26 (insn, operands);

        case 2:
          if (!(
#line 1896 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 1900 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_27 (insn, operands);

        case 3:
          if (!((
#line 1896 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 1900 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_28 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      switch (pattern172 (x1, 
NOT))
        {
        case 0:
          if (!(
#line 2132 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 2136 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_35 (insn, operands);

        case 1:
          if (!((
#line 2132 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 2136 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_36 (insn, operands);

        case 2:
          if (!(
#line 2153 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 2157 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_37 (insn, operands);

        case 3:
          if (!((
#line 2153 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 2157 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_38 (insn, operands);

        default:
          return NULL;
        }

    case MINUS:
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x6 = XEXP (x2, 0);
      operands[3] = x6;
      if (!cc_reg_operand (operands[3], E_CCmode)
          || GET_MODE (x3) != E_CCmode)
        return NULL;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      x8 = XEXP (x4, 1);
      operands[1] = x8;
      switch (pattern461 (x1))
        {
        case 0:
          if (!(
#line 2215 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 2219 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_39 (insn, operands);

        case 1:
          if (!((
#line 2215 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 2219 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_40 (insn, operands);

        case 2:
          if (!(
#line 2239 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 2243 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_41 (insn, operands);

        case 3:
          if (!((
#line 2239 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 2243 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_42 (insn, operands);

        default:
          return NULL;
        }

    case NEG:
      switch (pattern172 (x1, 
NEG))
        {
        case 0:
          if (!(
#line 2410 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 2414 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_46 (insn, operands);

        case 1:
          if (!((
#line 2410 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 2414 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_47 (insn, operands);

        case 2:
          if (!(
#line 2431 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 2435 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_48 (insn, operands);

        case 3:
          if (!((
#line 2431 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 2435 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_49 (insn, operands);

        default:
          return NULL;
        }

    case MULT:
      switch (pattern195 (x1, 
MULT))
        {
        case 0:
          if (!(
#line 3124 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 3128 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_58 (insn, operands);

        case 1:
          if (!((
#line 3124 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3128 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_59 (insn, operands);

        case 2:
          if (!(
#line 3149 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 3153 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_60 (insn, operands);

        case 3:
          if (!((
#line 3149 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3153 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_61 (insn, operands);

        default:
          return NULL;
        }

    case AND:
    case IOR:
    case XOR:
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x6 = XEXP (x2, 0);
      if (!cc_reg_operand (x6, E_CCmode)
          || GET_MODE (x3) != E_CCmode)
        return NULL;
      if (GET_CODE (x4) == AND)
        {
          res = split_1 (x1, insn);
          if (res != NULL_RTX)
            return res;
        }
      operands[4] = x6;
      switch (pattern372 (x1))
        {
        case 0:
          if (!(
#line 4016 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4020 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_89 (insn, operands);

        case 1:
          if (!((
#line 4016 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4020 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_90 (insn, operands);

        case 2:
          if (!(
#line 4039 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4043 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_91 (insn, operands);

        case 3:
          if (!((
#line 4039 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4043 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_92 (insn, operands);

        case 4:
          if (!(
#line 4071 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4075 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_93 (insn, operands);

        case 5:
          if (!((
#line 4071 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4075 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_94 (insn, operands);

        case 6:
          if (!(
#line 4094 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4098 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_95 (insn, operands);

        case 7:
          if (!((
#line 4094 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4098 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_96 (insn, operands);

        case 8:
          if (!(
#line 4126 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4130 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_97 (insn, operands);

        case 9:
          if (!((
#line 4126 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4130 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_98 (insn, operands);

        case 10:
          if (!(
#line 4149 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4153 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_99 (insn, operands);

        case 11:
          if (!((
#line 4149 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4153 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_100 (insn, operands);

        default:
          return NULL;
        }

    case ROTATE:
      switch (pattern175 (x1, 
ROTATE))
        {
        case 0:
          if (!(
#line 4590 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4594 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_129 (insn, operands);

        case 1:
          if (!((
#line 4590 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4594 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_130 (insn, operands);

        case 2:
          if (!(
#line 4615 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4619 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_131 (insn, operands);

        case 3:
          if (!((
#line 4615 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4619 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_132 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      switch (pattern176 (x1))
        {
        case 0:
          if (!(
#line 4658 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4662 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_133 (insn, operands);

        case 1:
          if (!((
#line 4658 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4662 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_134 (insn, operands);

        case 2:
          if (!(
#line 4683 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4687 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_135 (insn, operands);

        case 3:
          if (!((
#line 4683 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4687 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_136 (insn, operands);

        case 4:
          if (!(
#line 4732 "../../gcc/config/rs6000/rs6000.md"
(TARGET_EXTSWSLI) && 
#line 4738 "../../gcc/config/rs6000/rs6000.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[3], CCmode)
       || memory_operand (operands[1], SImode)))))
            return NULL;
          return gen_split_138 (insn, operands);

        case 5:
          if (!(
#line 4782 "../../gcc/config/rs6000/rs6000.md"
(TARGET_EXTSWSLI) && 
#line 4788 "../../gcc/config/rs6000/rs6000.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[3], CCmode)
       || memory_operand (operands[1], SImode)))))
            return NULL;
          return gen_split_139 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      switch (pattern175 (x1, 
LSHIFTRT))
        {
        case 0:
          if (!(
#line 4847 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4851 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_140 (insn, operands);

        case 1:
          if (!((
#line 4847 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4851 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_141 (insn, operands);

        case 2:
          if (!(
#line 4872 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4876 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_142 (insn, operands);

        case 3:
          if (!((
#line 4872 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4876 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_143 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return NULL;
      x6 = XEXP (x2, 0);
      operands[2] = x6;
      if (!cc_reg_not_cr0_operand (operands[2], E_CCmode))
        return NULL;
      switch (pattern421 (x1))
        {
        case 0:
          if (!(
#line 8088 "../../gcc/config/rs6000/rs6000.md"
(reload_completed) && 
#line 513 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64)))
            return NULL;
          return gen_split_297 (insn, operands);

        case 1:
          if (!(
#line 8088 "../../gcc/config/rs6000/rs6000.md"
(reload_completed) && 
#line 513 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return NULL;
          return gen_split_298 (insn, operands);

        default:
          return NULL;
        }

    case MEM:
      switch (pattern181 (x1))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 30 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      DImode, NON_PREFIXED_DS)))))
            return NULL;
          return gen_split_724 (insn, operands);

        case 1:
          if (!(
#line 112 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 114 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      SImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_728 (insn, operands);

        case 2:
          if (!(
#line 239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 241 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      HImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_734 (insn, operands);

        case 3:
          if (!((
#line 239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 241 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      HImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_735 (insn, operands);

        case 4:
          if (!(
#line 49 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 51 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      DImode, NON_PREFIXED_DS)))))
            return NULL;
          return gen_split_725 (insn, operands);

        case 5:
          if (!(
#line 133 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 135 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      SImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_729 (insn, operands);

        case 6:
          if (!(
#line 260 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 262 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      HImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_736 (insn, operands);

        case 7:
          if (!((
#line 260 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 262 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      HImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_737 (insn, operands);

        case 8:
          if (!(
#line 323 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 325 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      QImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_742 (insn, operands);

        case 9:
          if (!((
#line 323 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 325 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      QImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_743 (insn, operands);

        case 10:
          if (!(
#line 70 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 72 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      DImode, NON_PREFIXED_DS)))))
            return NULL;
          return gen_split_726 (insn, operands);

        case 11:
          if (!(
#line 154 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 156 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      SImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_730 (insn, operands);

        case 12:
          if (!(
#line 91 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 93 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      DImode, NON_PREFIXED_DS)))))
            return NULL;
          return gen_split_727 (insn, operands);

        case 13:
          if (!(
#line 175 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 177 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      SImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_731 (insn, operands);

        case 14:
          if (!((
#line 196 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 198 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      SImode, NON_PREFIXED_DS)))))
            return NULL;
          return gen_split_732 (insn, operands);

        case 15:
          if (!(
#line 281 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 283 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      HImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_738 (insn, operands);

        case 16:
          if (!((
#line 281 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 283 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      HImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_739 (insn, operands);

        case 17:
          if (!((
#line 218 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 220 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      SImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_733 (insn, operands);

        case 18:
          if (!(
#line 302 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 304 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      HImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_740 (insn, operands);

        case 19:
          if (!((
#line 302 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 304 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      HImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_741 (insn, operands);

        case 20:
          if (!(
#line 344 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 346 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      QImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_744 (insn, operands);

        case 21:
          if (!((
#line 344 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 346 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      QImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_745 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          return split_7 (x1, insn);

        case 3:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x3 = XEXP (x2, 1);
          switch (GET_CODE (x3))
            {
            case COMPARE:
              switch (pattern95 (x1))
                {
                case 0:
                  if (!(
#line 1919 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 1923 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_29 (insn, operands);

                case 1:
                  if (!((
#line 1919 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 1923 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_30 (insn, operands);

                case 2:
                  if (!(
#line 1944 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 1948 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_31 (insn, operands);

                case 3:
                  if (!((
#line 1944 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 1948 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_32 (insn, operands);

                case 4:
                  if (!((
#line 2275 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 2279 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_43 (insn, operands);

                case 5:
                  if (!((
#line 2275 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 2279 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_44 (insn, operands);

                case 6:
                  if (!(
#line 3394 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 3398 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_62 (insn, operands);

                case 7:
                  if (!((
#line 3394 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3398 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_63 (insn, operands);

                case 8:
                  if (!(
#line 3420 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 3424 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_64 (insn, operands);

                case 9:
                  if (!((
#line 3420 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3424 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_65 (insn, operands);

                case 10:
                  if (!(
#line 3654 "../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], SImode)) && 
#line 3659 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_66 (insn, operands);

                case 11:
                  if (!((
#line 3654 "../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3659 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_67 (insn, operands);

                case 12:
                  if (!(
#line 3681 "../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], SImode)) && 
#line 3686 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_68 (insn, operands);

                case 13:
                  if (!((
#line 3681 "../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3686 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_69 (insn, operands);

                case 14:
                  if (!(
#line 4918 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4922 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_144 (insn, operands);

                case 15:
                  if (!((
#line 4918 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4922 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_145 (insn, operands);

                case 16:
                  if (!(
#line 4945 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4949 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_146 (insn, operands);

                case 17:
                  if (!((
#line 4945 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4949 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
                    return NULL;
                  return gen_split_147 (insn, operands);

                default:
                  return NULL;
                }

            case BSWAP:
              if (GET_MODE (x3) != E_DImode)
                return NULL;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != CLOBBER)
                return NULL;
              x5 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x5) != CLOBBER)
                return NULL;
              x6 = XEXP (x2, 0);
              operands[0] = x6;
              x7 = XEXP (x3, 0);
              operands[1] = x7;
              x8 = XEXP (x4, 0);
              operands[2] = x8;
              if (!gpc_reg_operand (operands[2], E_DImode))
                return NULL;
              x9 = XEXP (x5, 0);
              operands[3] = x9;
              if (!gpc_reg_operand (operands[3], E_DImode))
                return NULL;
              switch (GET_CODE (operands[1]))
                {
                case MEM:
                  if (!indexed_or_indirect_operand (operands[1], E_DImode)
                      || !gpc_reg_operand (operands[0], E_DImode)
                      || !
#line 2828 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && !TARGET_LDBRX && reload_completed))
                    return NULL;
                  return gen_split_52 (insn, operands);

                case REG:
                case SUBREG:
                  if (!gpc_reg_operand (operands[1], E_DImode))
                    return NULL;
                  switch (GET_CODE (operands[0]))
                    {
                    case MEM:
                      if (!indexed_or_indirect_operand (operands[0], E_DImode)
                          || !
#line 2891 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && !TARGET_LDBRX && reload_completed))
                        return NULL;
                      return gen_split_53 (insn, operands);

                    case REG:
                    case SUBREG:
                      if (!gpc_reg_operand (operands[0], E_DImode)
                          || !
#line 2953 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && !TARGET_P9_VECTOR && reload_completed))
                        return NULL;
                      return gen_split_54 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            case IF_THEN_ELSE:
              switch (pattern96 (x1))
                {
                case 0:
                  if (!(
#line 3906 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_rotate_dot_mask (operands[2], DImode)
  && TARGET_POWERPC64) && 
#line 3909 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_84 (insn, operands);

                case 1:
                  if (!(
#line 7954 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && num_insns_constant (operands[2], DImode) > 1
   && (can_be_rotated_to_positive_16bits (INTVAL (operands[2]))
       || can_be_rotated_to_negative_15bits (INTVAL (operands[2])))) && 
#line 7958 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_293 (insn, operands);

                case 2:
                  if (!(
#line 7954 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && num_insns_constant (operands[2], DImode) > 1
   && (can_be_rotated_to_positive_16bits (INTVAL (operands[2]))
       || can_be_rotated_to_negative_15bits (INTVAL (operands[2])))) && 
#line 7958 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_294 (insn, operands);

                default:
                  return NULL;
                }

            case UNSIGNED_FLOAT:
              switch (pattern100 (x1))
                {
                case 0:
                  if (!(
#line 6269 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT) && 
#line 6271 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_191 (insn, operands);

                case 1:
                  if (!(
#line 6269 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT) && 
#line 6271 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_192 (insn, operands);

                case 2:
                  if (!(
#line 6269 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT) && 
#line 6271 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_193 (insn, operands);

                case 3:
                  if (!(
#line 6269 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && TARGET_DIRECT_MOVE_64BIT) && 
#line 6271 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_194 (insn, operands);

                case 4:
                  if (!(
#line 6744 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_LFIWZX && TARGET_STFIWX && TARGET_FCFIDU && !TARGET_DIRECT_MOVE
   && can_create_pseudo_p ()) && 
#line 6748 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_223 (insn, operands);

                case 5:
                  if (!(
#line 6744 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_LFIWZX && TARGET_STFIWX && TARGET_FCFIDU && !TARGET_DIRECT_MOVE
   && can_create_pseudo_p ()) && 
#line 6748 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_224 (insn, operands);

                case 6:
                  if (!(
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4483 "../../gcc/config/rs6000/vsx.md"
( 1)))
                    return NULL;
                  return gen_split_624 (insn, operands);

                case 7:
                  if (!((
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 230 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (IFmode))) && 
#line 4483 "../../gcc/config/rs6000/vsx.md"
( 1)))
                    return NULL;
                  return gen_split_626 (insn, operands);

                case 8:
                  if (!((
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 231 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)) && 
#line 4483 "../../gcc/config/rs6000/vsx.md"
( 1)))
                    return NULL;
                  return gen_split_628 (insn, operands);

                case 9:
                  if (!((
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 232 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (TFmode)
					   || (FLOAT128_IEEE_P (TFmode)
					       && TARGET_FLOAT128_HW))) && 
#line 4483 "../../gcc/config/rs6000/vsx.md"
( 1)))
                    return NULL;
                  return gen_split_630 (insn, operands);

                default:
                  return NULL;
                }

            case FIX:
              switch (pattern101 (x1))
                {
                case 0:
                  if (!(
#line 6362 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && !TARGET_DIRECT_MOVE) && 
#line 6365 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_197 (insn, operands);

                case 1:
                  if (!(
#line 6362 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && !TARGET_DIRECT_MOVE) && 
#line 6365 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_198 (insn, operands);

                default:
                  return NULL;
                }

            case FLOAT:
              switch (pattern102 (x1))
                {
                case 0:
                  if (!(
#line 6711 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_FCFIDS && TARGET_LFIWAX && TARGET_STFIWX && TARGET_FCFID
   && !TARGET_DIRECT_MOVE && can_create_pseudo_p ()) && 
#line 6715 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_221 (insn, operands);

                case 1:
                  if (!(
#line 6711 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT
   && TARGET_FCFID && TARGET_LFIWAX && TARGET_STFIWX && TARGET_FCFID
   && !TARGET_DIRECT_MOVE && can_create_pseudo_p ()) && 
#line 6715 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_222 (insn, operands);

                case 2:
                  if (!(
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4483 "../../gcc/config/rs6000/vsx.md"
( 1)))
                    return NULL;
                  return gen_split_623 (insn, operands);

                case 3:
                  if (!((
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 230 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (IFmode))) && 
#line 4483 "../../gcc/config/rs6000/vsx.md"
( 1)))
                    return NULL;
                  return gen_split_625 (insn, operands);

                case 4:
                  if (!((
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 231 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)) && 
#line 4483 "../../gcc/config/rs6000/vsx.md"
( 1)))
                    return NULL;
                  return gen_split_627 (insn, operands);

                case 5:
                  if (!((
#line 4481 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 232 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_2REG_P (TFmode)
					   || (FLOAT128_IEEE_P (TFmode)
					       && TARGET_FLOAT128_HW))) && 
#line 4483 "../../gcc/config/rs6000/vsx.md"
( 1)))
                    return NULL;
                  return gen_split_629 (insn, operands);

                default:
                  return NULL;
                }

            case EQ:
              switch (pattern104 (x1))
                {
                case 0:
                  if (!(
#line 12928 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && 
#line 12930 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_441 (insn, operands);

                case 1:
                  if (!((
#line 12928 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && !(TARGET_ISEL && operands[2] != const0_rtx)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 12930 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_442 (insn, operands);

                case 2:
                  if (!((
#line 13220 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10) && 
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 13222 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_450 (insn, operands);

                default:
                  return NULL;
                }

            case UNSPEC:
              if (XVECLEN (x3, 0) != 2
                  || XINT (x3, 1) != 145)
                return NULL;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != CLOBBER)
                return NULL;
              x5 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x5) != CLOBBER)
                return NULL;
              x6 = XEXP (x2, 0);
              operands[0] = x6;
              x10 = XVECEXP (x3, 0, 0);
              operands[1] = x10;
              x11 = XVECEXP (x3, 0, 1);
              operands[2] = x11;
              switch (pattern457 (x1))
                {
                case 0:
                  if (!(
#line 3658 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 3660 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_592 (insn, operands);

                case 1:
                  if (!(
#line 3658 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 3660 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_593 (insn, operands);

                case 2:
                  if (!(
#line 3745 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 3747 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_598 (insn, operands);

                case 3:
                  if (!(
#line 4185 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4187 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_615 (insn, operands);

                case 4:
                  if (!(
#line 4185 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4187 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_616 (insn, operands);

                case 5:
                  if (!(
#line 4185 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4187 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_617 (insn, operands);

                default:
                  return NULL;
                }

            case VEC_SELECT:
              switch (pattern106 (x1))
                {
                case 0:
                  if (!(
#line 4049 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_VEXTRACTUB) && 
#line 4051 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_606 (insn, operands);

                case 1:
                  if (!(
#line 4049 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_VEXTRACTUB) && 
#line 4051 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_607 (insn, operands);

                case 2:
                  if (!(
#line 4049 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_VEXTRACTUB) && 
#line 4051 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_608 (insn, operands);

                default:
                  return NULL;
                }

            case PLUS:
              if (pattern107 (x1) != 0
                  || !(
#line 4949 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)) && 
#line 4951 "../../gcc/config/rs6000/vsx.md"
( 1)))
                return NULL;
              return gen_split_662 (insn, operands);

            case SMIN:
              if (pattern107 (x1) != 0
                  || !(
#line 4949 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)) && 
#line 4951 "../../gcc/config/rs6000/vsx.md"
( 1)))
                return NULL;
              return gen_split_663 (insn, operands);

            case SMAX:
              if (pattern107 (x1) != 0
                  || !(
#line 4949 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)) && 
#line 4951 "../../gcc/config/rs6000/vsx.md"
( 1)))
                return NULL;
              return gen_split_664 (insn, operands);

            default:
              return NULL;
            }

        case 6:
          if (pattern16 (x1) != 0
              || !(
#line 6081 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_FCFID && TARGET_HARD_FLOAT) && 
#line 6083 "../../gcc/config/rs6000/rs6000.md"
( 1)))
            return NULL;
          return gen_split_185 (insn, operands);

        case 5:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x12 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x12) != CLOBBER)
            return NULL;
          x13 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x13) != CLOBBER)
            return NULL;
          x3 = XEXP (x2, 1);
          switch (GET_CODE (x3))
            {
            case UNSIGNED_FLOAT:
              if (GET_MODE (x3) != E_DFmode)
                return NULL;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != USE)
                return NULL;
              x5 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x5) != USE
                  || pattern392 (x1) != 0
                  || !(
#line 6170 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_FCFIDU && TARGET_HARD_FLOAT
   && !(TARGET_FCFID && TARGET_POWERPC64)) && 
#line 6173 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_186 (insn, operands);

            case FIX:
              if (GET_MODE (x3) != E_SImode)
                return NULL;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != CLOBBER)
                return NULL;
              x5 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x5) != CLOBBER)
                return NULL;
              switch (pattern393 (x1))
                {
                case 0:
                  if (!((
#line 9097 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))) && 
#line 9099 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_328 (insn, operands);

                case 1:
                  if (!((
#line 9097 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))) && 
#line 9099 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_329 (insn, operands);

                default:
                  return NULL;
                }

            case IF_THEN_ELSE:
              x7 = XEXP (x3, 0);
              if (GET_CODE (x7) != AND)
                return NULL;
              x14 = XEXP (x7, 0);
              if (!comparison_operator (x14, E_VOIDmode))
                return NULL;
              operands[1] = x14;
              x15 = XEXP (x14, 1);
              if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return NULL;
              x16 = XEXP (x7, 1);
              if (!branch_comparison_operator (x16, E_VOIDmode))
                return NULL;
              operands[3] = x16;
              x17 = XEXP (x16, 1);
              if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              x6 = XEXP (x2, 0);
              if (GET_CODE (x6) != PC)
                return NULL;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != SET)
                return NULL;
              x18 = XEXP (x4, 1);
              if (GET_CODE (x18) != PLUS
                  || GET_MODE (x18) != E_DImode)
                return NULL;
              x19 = XEXP (x18, 1);
              if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
                return NULL;
              x5 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x5) != CLOBBER)
                return NULL;
              x20 = XEXP (x14, 0);
              operands[0] = x20;
              if (!gpc_reg_operand (operands[0], E_DImode))
                return NULL;
              x21 = XEXP (x16, 0);
              operands[2] = x21;
              if (!cc_reg_operand (operands[2], E_VOIDmode))
                return NULL;
              x22 = XEXP (x3, 1);
              operands[4] = x22;
              x23 = XEXP (x3, 2);
              operands[5] = x23;
              x8 = XEXP (x4, 0);
              operands[6] = x8;
              if (!nonimmediate_operand (operands[6], E_DImode))
                return NULL;
              x9 = XEXP (x5, 0);
              operands[7] = x9;
              if (!scratch_operand (operands[7], E_DImode))
                return NULL;
              x24 = XEXP (x12, 0);
              operands[8] = x24;
              if (!scratch_operand (operands[8], E_CCmode))
                return NULL;
              x25 = XEXP (x13, 0);
              operands[9] = x25;
              if (!scratch_operand (operands[9], E_CCEQmode))
                return NULL;
              x26 = XEXP (x18, 0);
              if (!rtx_equal_p (x26, operands[0])
                  || !(
#line 13862 "../../gcc/config/rs6000/rs6000.md"
(reload_completed) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return NULL;
              return gen_split_475 (insn, operands);

            default:
              return NULL;
            }

        case 4:
          return split_8 (x1, insn);

        case 10:
          switch (pattern18 (x1))
            {
            case 0:
              if (!((
#line 12723 "../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))) && 
#line 12726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_397 (insn, operands);

            case 1:
              if (!((
#line 12723 "../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))) && 
#line 12726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_398 (insn, operands);

            case 2:
              if (!((
#line 12723 "../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))) && 
#line 12726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_399 (insn, operands);

            case 3:
              if (!((
#line 12723 "../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))) && 
#line 12726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_400 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SET:
      return split_18 (x1, insn);

    case EH_RETURN:
      if (!
#line 14331 "../../gcc/config/rs6000/rs6000.md"
(epilogue_completed))
        return NULL;
      return gen_split_477 (insn, operands);

    default:
      return NULL;
    }
}
