/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      return 0;

    case VEC_SELECT:
      res = pattern7 (x3, 
E_V2DImode);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    default:
      return -1;
    }
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern2 (x3, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern2 (x3, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern22 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  if (!cc_reg_operand (operands[2], E_CCmode)
      || GET_MODE (x2) != E_CCmode)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  switch (GET_MODE (x5))
    {
    case E_SImode:
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!gpc_reg_operand (operands[1], E_QImode))
            return -1;
          return 0;

        case E_HImode:
          if (!gpc_reg_operand (operands[1], E_HImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_DImode:
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!gpc_reg_operand (operands[1], E_QImode))
            return -1;
          return 2;

        case E_HImode:
          if (!gpc_reg_operand (operands[1], E_HImode))
            return -1;
          return 3;

        case E_SImode:
          if (!gpc_reg_operand (operands[1], E_SImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern38 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern37 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern37 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern45 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern54 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[2] = x4;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          return pattern49 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern49 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern50 (x1, 
E_V4SImode) != 0)
            return -1;
          return 2;

        case E_V8HImode:
          if (pattern50 (x1, 
E_V8HImode) != 0)
            return -1;
          return 3;

        case E_V16QImode:
          if (pattern50 (x1, 
E_V16QImode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern50 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 5;

        case E_V2DFmode:
          if (pattern50 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 6;

        case E_V2DImode:
          if (pattern50 (x1, 
E_V2DImode) != 0)
            return -1;
          return 7;

        case E_V1TImode:
          if (pattern50 (x1, 
E_V1TImode) != 0)
            return -1;
          return 8;

        case E_TImode:
          if (pattern50 (x1, 
E_TImode) != 0)
            return -1;
          return 9;

        case E_KFmode:
          if (pattern50 (x1, 
E_KFmode) != 0)
            return -1;
          return 10;

        case E_TFmode:
          if (pattern50 (x1, 
E_TFmode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    case NOT:
      res = pattern53 (x1);
      if (res >= 0)
        return res + 12; /* [12, 23] */
      return -1;

    default:
      return -1;
    }
}

int
pattern77 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return pattern69 (); /* [-1, 2] */
}

int
pattern80 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x2, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (GET_MODE (x5) != E_QImode)
        return -1;
      return 0;

    case E_HImode:
      if (GET_MODE (x5) != E_HImode)
        return -1;
      return 1;

    case E_SImode:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern88 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !short_cint_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern91 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !exact_log2_cint_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern98 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_DImode))
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !gpc_reg_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !gpc_reg_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern108 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !reg_or_short_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !reg_or_short_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern112 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !scratch_operand (operands[3], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !reg_or_u_short_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !reg_or_u_short_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern122 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  operands[1] = x6;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern37 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern37 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern131 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!gpc_reg_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!gpc_reg_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern140 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!altivec_register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!altivec_register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern149 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  return 0;
}

int
pattern157 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V16QImode)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_V16QImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!vsx_register_operand (operands[0], E_V16QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  if (!gpc_reg_operand (operands[1], E_DImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[2] = x6;
  if (!register_operand (operands[2], E_DImode))
    return -1;
  x7 = XEXP (x3, 0);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  return 0;
}

int
pattern164 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_1_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V1TImode:
      return pattern142 (x3, 
E_V1TImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern142 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern172 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  if (!cc_reg_operand (operands[2], E_CCmode)
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x8))
    {
    case CLOBBER:
      return pattern170 (x1); /* [-1, 1] */

    case SET:
      x9 = XEXP (x8, 1);
      if (GET_CODE (x9) != i1)
        return -1;
      x10 = XEXP (x8, 0);
      operands[0] = x10;
      x11 = XEXP (x9, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      res = pattern171 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern180 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!non_update_memory_operand (operands[1], i1)
      || !const_0_to_1_operand (operands[3], i1))
    return -1;
  return pattern179 (x1); /* [-1, 1] */
}

int
pattern186 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 1);
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  operands[4] = x7;
  x8 = XEXP (x5, 0);
  x9 = XEXP (x8, 0);
  switch (GET_CODE (x9))
    {
    case REG:
    case SUBREG:
      return pattern183 (x5); /* [-1, 1] */

    case NOT:
      res = pattern185 (x5);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern192 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern194 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  return pattern193 (x1, 
i1); /* [-1, 3] */
}

int
pattern200 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  if (!gpc_reg_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  if (!gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern206 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V1TImode:
      return pattern205 (x1, 
E_V1TImode); /* [-1, 0] */

    case E_TImode:
      if (pattern205 (x1, 
E_TImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern215 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!vsx_register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !vsx_register_operand (operands[1], E_DFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!vsx_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !vsx_register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    case E_V2DFmode:
      if (!vsx_register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || !vsx_register_operand (operands[1], E_V2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern226 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V4SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 282
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 109
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  if (!register_operand (operands[0], E_V4SImode))
    return -1;
  x9 = XVECEXP (x3, 0, 0);
  operands[1] = x9;
  if (!register_operand (operands[1], E_V4SFmode))
    return -1;
  x10 = XVECEXP (x3, 0, 1);
  operands[2] = x10;
  if (!immediate_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern240 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern247 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[1] = x5;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[4] = x8;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern182 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern182 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern252 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 440
      || GET_MODE (x5) != E_BLKmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[1] = x6;
  if (!cc_reg_operand (operands[1], E_CCmode))
    return -1;
  x7 = XVECEXP (x3, 0, 0);
  operands[0] = x7;
  if (!const_0_to_1_operand (operands[0], E_VOIDmode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[2] = x8;
  x9 = XVECEXP (x5, 0, 0);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  return 0;
}

int
pattern259 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern267 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern274 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern272 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern272 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern273 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern273 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern273 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern273 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern273 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern273 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern273 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern273 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern273 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern273 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern293 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_KFmode:
      if (!register_operand (operands[0], E_KFmode)
          || GET_MODE (x1) != E_KFmode
          || !register_operand (operands[1], E_KFmode))
        return -1;
      return 0;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x1) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern304 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern303 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern303 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern311 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !exact_log2_cint_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern318 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_KFmode:
      if (!altivec_register_operand (operands[1], E_KFmode))
        return -1;
      return 0;

    case E_TFmode:
      if (!altivec_register_operand (operands[1], E_TFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern326 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern335 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 98
      || GET_MODE (x5) != E_DImode
      || !gpc_reg_operand (operands[0], E_DImode))
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != E_DImode
      || !gpc_reg_operand (operands[1], E_DImode))
    return -1;
  x8 = XEXP (x3, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  return 0;
}

int
pattern343 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vlogical_operand (operands[0], i1)
      || !boolean_or_operator (operands[3], i1)
      || !vlogical_operand (operands[1], i1)
      || !vlogical_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern348 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!base_reg_operand (operands[0], i1))
    return -1;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x1, 1);
  operands[3] = x3;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!base_reg_operand (operands[2], E_QImode)
          || !fusion_gpr_mem_load (operands[3], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!base_reg_operand (operands[2], E_HImode)
          || !fusion_gpr_mem_load (operands[3], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!base_reg_operand (operands[2], E_SImode)
          || !fusion_gpr_mem_load (operands[3], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!base_reg_operand (operands[2], E_DImode)
          || !fusion_gpr_mem_load (operands[3], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern368 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!boolean_operator (operands[3], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern376 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x1, 1);
  return pattern375 (x4, 
i1); /* [-1, 0] */
}

int
pattern384 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != NOT)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      return pattern377 (x1); /* [-1, 11] */

    case NOT:
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      x8 = XEXP (x5, 1);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          res = pattern380 (x1);
          if (res >= 0)
            return res + 12; /* [12, 23] */
          return -1;

        case NOT:
          res = pattern383 (x1);
          if (res >= 0)
            return res + 24; /* [24, 35] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern392 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!gpc_reg_operand (operands[0], E_DFmode))
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!gpc_reg_operand (operands[1], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!gpc_reg_operand (operands[2], E_SImode))
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!gpc_reg_operand (operands[3], E_DFmode))
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  if (!offsettable_mem_operand (operands[4], E_DFmode))
    return -1;
  x12 = XVECEXP (x1, 0, 4);
  x13 = XEXP (x12, 0);
  operands[5] = x13;
  if (!gpc_reg_operand (operands[5], E_DFmode))
    return -1;
  return 0;
}

int
pattern401 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern410 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern415 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V2DImode
      || !register_operand (operands[0], E_V2DImode)
      || !register_operand (operands[1], E_V2DImode)
      || !register_operand (operands[2], E_V2DImode)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern421 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !gpc_reg_operand (operands[0], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !gpc_reg_operand (operands[0], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern432 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !altivec_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern437 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern447 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], E_V4SFmode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 2);
  if (!const_0_to_3_operand (x4, E_QImode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (!scratch_operand (x6, E_SImode))
    return -1;
  x7 = XVECEXP (x3, 0, 1);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[2] = x7;
      if (!gpc_reg_operand (operands[2], E_SFmode))
        return -1;
      operands[3] = x4;
      operands[4] = x6;
      return 0;

    case CONST_DOUBLE:
      operands[2] = x7;
      if (!zero_fp_constant (operands[2], E_SFmode))
        return -1;
      operands[3] = x4;
      operands[4] = x6;
      return 1;

    case VEC_SELECT:
      if (GET_MODE (x7) != E_SFmode)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != PARALLEL
          || XVECLEN (x8, 0) != 1)
        return -1;
      x9 = XEXP (x7, 0);
      operands[2] = x9;
      if (!gpc_reg_operand (operands[2], E_V4SFmode))
        return -1;
      x10 = XVECEXP (x8, 0, 0);
      operands[3] = x10;
      if (!const_0_to_3_operand (operands[3], E_QImode))
        return -1;
      operands[4] = x4;
      operands[5] = x6;
      return 2;

    default:
      return -1;
    }
}

int
pattern470 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !logical_const_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern476 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsx_register_operand (operands[1], E_V2DImode)
      || !vsx_register_operand (operands[3], i1)
      || !vsx_register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern480 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[2], i1)
      || !altivec_register_operand (operands[3], i1)
      || !altivec_register_operand (operands[4], i1)
      || !altivec_register_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern487 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!rotate_mask_operator (operands[4], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !const_int_operand (operands[3], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern492 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern500 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern509 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !memory_operand (operands[1], i1)
      || !const_0_to_1_operand (operands[2], E_QImode)
      || !scratch_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

int
pattern515 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      return pattern514 (x1, 
E_V4SFmode, 
E_V8SFmode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern514 (x1, 
E_V4SImode, 
E_V8SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern526 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern539 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      return pattern538 (x6, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (pattern538 (x6, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern548 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V1TImode:
      if (!register_operand (operands[1], E_V1TImode)
          || !register_operand (operands[2], E_V1TImode)
          || !scratch_operand (operands[0], E_V1TImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode)
          || !register_operand (operands[2], E_V16QImode)
          || !scratch_operand (operands[0], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCFPmode)
    return -1;
  x3 = XEXP (x2, 0);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      switch (XINT (x3, 1))
        {
        case 150:
          if (GET_MODE (x3) != E_DFmode
              || !cc_reg_operand (operands[0], E_CCFPmode)
              || !vsx_register_operand (operands[1], E_DFmode)
              || !vsx_register_operand (operands[2], E_DFmode))
            return -1;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          if (!zero_constant (operands[3], E_SImode)
              || !
#line 5305 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1565; /* *xscmpexpdp */

        case 151:
          if (!cc_reg_operand (operands[0], E_CCFPmode))
            return -1;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          if (!zero_constant (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_KFmode:
              if (!altivec_register_operand (operands[1], E_KFmode)
                  || !altivec_register_operand (operands[2], E_KFmode)
                  || !(
#line 5339 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1566; /* *xscmpexpqp */

            case E_TFmode:
              if (!altivec_register_operand (operands[1], E_TFmode)
                  || !altivec_register_operand (operands[2], E_TFmode)
                  || !(
#line 5339 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1567; /* *xscmpexpqp */

            default:
              return -1;
            }

        case 152:
          x7 = XEXP (x2, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !u7bit_cint_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_SFmode:
              if (!vsx_register_operand (operands[1], E_SFmode)
                  || !
#line 5452 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR
   && (!FLOAT128_IEEE_P (SFmode) || TARGET_FLOAT128_HW)))
                return -1;
              return 1568; /* *xststdc_sf */

            case E_DFmode:
              if (!vsx_register_operand (operands[1], E_DFmode)
                  || !
#line 5452 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR
   && (!FLOAT128_IEEE_P (DFmode) || TARGET_FLOAT128_HW)))
                return -1;
              return 1569; /* *xststdc_df */

            case E_KFmode:
              if (!altivec_register_operand (operands[1], E_KFmode)
                  || !(
#line 5452 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR
   && (!FLOAT128_IEEE_P (KFmode) || TARGET_FLOAT128_HW)) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1570; /* *xststdc_kf */

            case E_TFmode:
              if (!altivec_register_operand (operands[1], E_TFmode)
                  || !(
#line 5452 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR
   && (!FLOAT128_IEEE_P (TFmode) || TARGET_FLOAT128_HW)) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1571; /* *xststdc_tf */

            default:
              return -1;
            }

        case 429:
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          if (!zero_constant (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_DDmode:
              if (!gpc_reg_operand (operands[2], E_DDmode)
                  || !
#line 368 "../../gcc/config/rs6000/dfp.md"
(TARGET_P9_MISC))
                return -1;
              return 2306; /* *dfp_sgnfcnc_dd */

            case E_TDmode:
              if (!gpc_reg_operand (operands[2], E_TDmode)
                  || !
#line 368 "../../gcc/config/rs6000/dfp.md"
(TARGET_P9_MISC))
                return -1;
              return 2307; /* *dfp_sgnfcnc_td */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 106
          || GET_MODE (x4) != E_CCFPmode
          || GET_MODE (x3) != E_V2DFmode)
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      x8 = XVECEXP (x3, 0, 2);
      operands[3] = x8;
      if (!const_0_to_1_operand (operands[3], E_QImode))
        return -1;
      x7 = XEXP (x2, 1);
      operands[4] = x7;
      if (!zero_constant (operands[4], E_V2DFmode))
        return -1;
      switch (XINT (x3, 1))
        {
        case 342:
          switch (pattern537 ())
            {
            case 0:
              if (!
#line 4610 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              *pnum_clobbers = 1;
              return 2182; /* *bcdadd_test_v1ti */

            case 1:
              if (!
#line 4610 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              *pnum_clobbers = 1;
              return 2184; /* *bcdadd_test_v16qi */

            default:
              return -1;
            }

        case 343:
          switch (pattern537 ())
            {
            case 0:
              if (!
#line 4610 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              *pnum_clobbers = 1;
              return 2183; /* *bcdsub_test_v1ti */

            case 1:
              if (!
#line 4610 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              *pnum_clobbers = 1;
              return 2185; /* *bcdsub_test_v16qi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (pnum_clobbers == NULL
          || XINT (x3, 1) != 343
          || GET_MODE (x3) != E_V2DFmode)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 106
          || GET_MODE (x4) != E_CCFPmode)
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      if (!zero_constant (operands[2], E_V2DFmode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1TImode:
          if (!register_operand (operands[1], E_V1TImode)
              || !
#line 4737 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 2198; /* *bcdinvalid_v1ti */

        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode)
              || !
#line 4737 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 2199; /* *bcdinvalid_v16qi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[3] = x2;
  res = recog_18 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  switch (GET_CODE (x2))
    {
    case IOR:
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case AND:
          return recog_21 (x1, insn, pnum_clobbers);

        case REG:
        case SUBREG:
          if (pnum_clobbers == NULL)
            return -1;
          operands[1] = x3;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern397 (x2, 
E_SImode) != 0
                  || !
#line 4472 "../../gcc/config/rs6000/rs6000.md"
(!logical_const_operand (operands[2], SImode)
   && rs6000_is_valid_mask (operands[2], NULL, NULL, SImode)))
                return -1;
              *pnum_clobbers = 1;
              return 259; /* *iorsi_mask */

            case E_DImode:
              if (pattern397 (x2, 
E_DImode) != 0
                  || !(
#line 4472 "../../gcc/config/rs6000/rs6000.md"
(!logical_const_operand (operands[2], DImode)
   && rs6000_is_valid_mask (operands[2], NULL, NULL, DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 260; /* *iordi_mask */

            default:
              return -1;
            }

        case ASHIFT:
          if (pnum_clobbers == NULL
              || GET_MODE (x3) != E_DImode)
            return -1;
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != ZERO_EXTEND
              || GET_MODE (x5) != E_DImode)
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != UNSPEC
              || XVECLEN (x6, 0) != 1
              || XINT (x6, 1) != 87)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode)
            return -1;
          x7 = XEXP (x3, 0);
          operands[1] = x7;
          if (!gpc_reg_operand (operands[1], E_DImode))
            return -1;
          x8 = XEXP (x3, 1);
          operands[2] = x8;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x9 = XVECEXP (x6, 0, 0);
          operands[3] = x9;
          if (!memory_operand (operands[3], E_SFmode))
            return -1;
          switch (GET_MODE (x6))
            {
            case E_QImode:
              if (!
#line 4528 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && INTVAL (operands[2]) == 8))
                return -1;
              *pnum_clobbers = 1;
              return 261; /* *rotldi3_insert_sf */

            case E_HImode:
              if (!
#line 4528 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && INTVAL (operands[2]) == 16))
                return -1;
              *pnum_clobbers = 1;
              return 262; /* *rotldi3_insert_sf */

            case E_SImode:
              if (!
#line 4528 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && INTVAL (operands[2]) == 32))
                return -1;
              *pnum_clobbers = 1;
              return 263; /* *rotldi3_insert_sf */

            default:
              return -1;
            }

        case NOT:
          return recog_20 (x1, insn, pnum_clobbers);

        case IOR:
          switch (pattern60 (x1, pnum_clobbers))
            {
            case 0:
              if (!
#line 1249 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2472; /* *fuse_nand_or */

            case 1:
              if (!(
#line 1249 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2473; /* *fuse_nand_or */

            case 2:
              if (!
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2972; /* *fuse_vnand_vor */

            case 3:
              if (!
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2973; /* *fuse_vnand_vor */

            case 4:
              if (!
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2974; /* *fuse_vnand_vor */

            case 5:
              if (!
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2975; /* *fuse_vnand_vor */

            case 6:
              if (!
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2976; /* *fuse_vnand_vor */

            case 7:
              if (!
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2977; /* *fuse_vnand_vor */

            case 8:
              if (!
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2978; /* *fuse_vnand_vor */

            case 9:
              if (!
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2979; /* *fuse_vnand_vor */

            case 10:
              if (!(
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2980; /* *fuse_vnand_vor */

            case 11:
              if (!(
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2981; /* *fuse_vnand_vor */

            case 12:
              if (!
#line 1429 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2492; /* *fuse_nand_orc */

            case 13:
              if (!(
#line 1429 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2493; /* *fuse_nand_orc */

            case 14:
              if (!
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3052; /* *fuse_vnand_vorc */

            case 15:
              if (!
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3053; /* *fuse_vnand_vorc */

            case 16:
              if (!
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3054; /* *fuse_vnand_vorc */

            case 17:
              if (!
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3055; /* *fuse_vnand_vorc */

            case 18:
              if (!
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3056; /* *fuse_vnand_vorc */

            case 19:
              if (!
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3057; /* *fuse_vnand_vorc */

            case 20:
              if (!
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3058; /* *fuse_vnand_vorc */

            case 21:
              if (!
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3059; /* *fuse_vnand_vorc */

            case 22:
              if (!(
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3060; /* *fuse_vnand_vorc */

            case 23:
              if (!(
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3061; /* *fuse_vnand_vorc */

            case 24:
              if (!
#line 1303 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2478; /* *fuse_orc_or */

            case 25:
              if (!(
#line 1303 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2479; /* *fuse_orc_or */

            case 26:
              if (!
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3002; /* *fuse_vorc_vor */

            case 27:
              if (!
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3003; /* *fuse_vorc_vor */

            case 28:
              if (!
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3004; /* *fuse_vorc_vor */

            case 29:
              if (!
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3005; /* *fuse_vorc_vor */

            case 30:
              if (!
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3006; /* *fuse_vorc_vor */

            case 31:
              if (!
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3007; /* *fuse_vorc_vor */

            case 32:
              if (!
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3008; /* *fuse_vorc_vor */

            case 33:
              if (!
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3009; /* *fuse_vorc_vor */

            case 34:
              if (!(
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3010; /* *fuse_vorc_vor */

            case 35:
              if (!(
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3011; /* *fuse_vorc_vor */

            case 36:
              if (!
#line 1483 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2498; /* *fuse_orc_orc */

            case 37:
              if (!(
#line 1483 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2499; /* *fuse_orc_orc */

            case 38:
              if (!
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3082; /* *fuse_vorc_vorc */

            case 39:
              if (!
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3083; /* *fuse_vorc_vorc */

            case 40:
              if (!
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3084; /* *fuse_vorc_vorc */

            case 41:
              if (!
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3085; /* *fuse_vorc_vorc */

            case 42:
              if (!
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3086; /* *fuse_vorc_vorc */

            case 43:
              if (!
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3087; /* *fuse_vorc_vorc */

            case 44:
              if (!
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3088; /* *fuse_vorc_vorc */

            case 45:
              if (!
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3089; /* *fuse_vorc_vorc */

            case 46:
              if (!(
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3090; /* *fuse_vorc_vorc */

            case 47:
              if (!(
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3091; /* *fuse_vorc_vorc */

            case 48:
              if (!
#line 1285 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2476; /* *fuse_or_or */

            case 49:
              if (!(
#line 1285 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2477; /* *fuse_or_or */

            case 50:
              if (!
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2992; /* *fuse_vor_vor */

            case 51:
              if (!
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2993; /* *fuse_vor_vor */

            case 52:
              if (!
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2994; /* *fuse_vor_vor */

            case 53:
              if (!
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2995; /* *fuse_vor_vor */

            case 54:
              if (!
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2996; /* *fuse_vor_vor */

            case 55:
              if (!
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2997; /* *fuse_vor_vor */

            case 56:
              if (!
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2998; /* *fuse_vor_vor */

            case 57:
              if (!
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2999; /* *fuse_vor_vor */

            case 58:
              if (!(
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3000; /* *fuse_vor_vor */

            case 59:
              if (!(
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3001; /* *fuse_vor_vor */

            case 60:
              if (!
#line 1465 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2496; /* *fuse_or_orc */

            case 61:
              if (!(
#line 1465 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2497; /* *fuse_or_orc */

            case 62:
              if (!
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3072; /* *fuse_vor_vorc */

            case 63:
              if (!
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3073; /* *fuse_vor_vorc */

            case 64:
              if (!
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3074; /* *fuse_vor_vorc */

            case 65:
              if (!
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3075; /* *fuse_vor_vorc */

            case 66:
              if (!
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3076; /* *fuse_vor_vorc */

            case 67:
              if (!
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3077; /* *fuse_vor_vorc */

            case 68:
              if (!
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3078; /* *fuse_vor_vorc */

            case 69:
              if (!
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3079; /* *fuse_vor_vorc */

            case 70:
              if (!(
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3080; /* *fuse_vor_vorc */

            case 71:
              if (!(
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3081; /* *fuse_vor_vorc */

            default:
              return -1;
            }

        case XOR:
          switch (pattern61 (x1, pnum_clobbers))
            {
            case 0:
              if (!
#line 1321 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2480; /* *fuse_xor_or */

            case 1:
              if (!(
#line 1321 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2481; /* *fuse_xor_or */

            case 2:
              if (!
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3012; /* *fuse_vxor_vor */

            case 3:
              if (!
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3013; /* *fuse_vxor_vor */

            case 4:
              if (!
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3014; /* *fuse_vxor_vor */

            case 5:
              if (!
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3015; /* *fuse_vxor_vor */

            case 6:
              if (!
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3016; /* *fuse_vxor_vor */

            case 7:
              if (!
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3017; /* *fuse_vxor_vor */

            case 8:
              if (!
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3018; /* *fuse_vxor_vor */

            case 9:
              if (!
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3019; /* *fuse_vxor_vor */

            case 10:
              if (!(
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3020; /* *fuse_vxor_vor */

            case 11:
              if (!(
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3021; /* *fuse_vxor_vor */

            case 12:
              if (!
#line 1501 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2500; /* *fuse_xor_orc */

            case 13:
              if (!(
#line 1501 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2501; /* *fuse_xor_orc */

            case 14:
              if (!
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3092; /* *fuse_vxor_vorc */

            case 15:
              if (!
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3093; /* *fuse_vxor_vorc */

            case 16:
              if (!
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3094; /* *fuse_vxor_vorc */

            case 17:
              if (!
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3095; /* *fuse_vxor_vorc */

            case 18:
              if (!
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3096; /* *fuse_vxor_vorc */

            case 19:
              if (!
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3097; /* *fuse_vxor_vorc */

            case 20:
              if (!
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3098; /* *fuse_vxor_vorc */

            case 21:
              if (!
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3099; /* *fuse_vxor_vorc */

            case 22:
              if (!(
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3100; /* *fuse_vxor_vorc */

            case 23:
              if (!(
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 3101; /* *fuse_vxor_vorc */

            default:
              return -1;
            }

        case PLUS:
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern122 (x1))
            {
            case 0:
              if (!
#line 1339 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2482; /* *fuse_add_or */

            case 1:
              if (!(
#line 1339 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2483; /* *fuse_add_or */

            default:
              return -1;
            }

        case MINUS:
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern122 (x1))
            {
            case 0:
              if (!
#line 1357 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2484; /* *fuse_subf_or */

            case 1:
              if (!(
#line 1357 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2485; /* *fuse_subf_or */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case XOR:
      return recog_22 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!cc_reg_operand (operands[0], E_CCmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!gpc_reg_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_DImode)
      || !
#line 15834 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC && TARGET_64BIT))
    return -1;
  return 1099; /* *cmpeqb_internal */
}

 int
recog_64 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!vsx_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x2) != E_V16QImode
          || !vsx_register_operand (operands[1], E_V16QImode)
          || !
#line 6488 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1638; /* vec_expand_v16qi */

    case E_V8HImode:
      if (!vsx_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x2) != E_V8HImode
          || !vsx_register_operand (operands[1], E_V8HImode)
          || !
#line 6488 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1639; /* vec_expand_v8hi */

    case E_V4SImode:
      if (!vsx_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x2) != E_V4SImode
          || !vsx_register_operand (operands[1], E_V4SImode)
          || !
#line 6488 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1640; /* vec_expand_v4si */

    case E_V2DImode:
      if (!vsx_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode
          || !vsx_register_operand (operands[1], E_V2DImode)
          || !
#line 6488 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1641; /* vec_expand_v2di */

    case E_V1TImode:
      if (!vsx_register_operand (operands[0], E_V1TImode)
          || GET_MODE (x2) != E_V1TImode
          || !vsx_register_operand (operands[1], E_V1TImode)
          || !
#line 6488 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1642; /* vec_expand_v1ti */

    default:
      return -1;
    }
}

 int
recog_68 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SFmode)
    return -1;
  if (nonimmediate_operand (operands[0], E_SFmode))
    {
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (input_operand (operands[1], E_SImode)
          && 
#line 8385 "../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG
   && (register_operand (operands[0], SFmode)
       || register_operand (operands[1], SImode))))
        {
          *pnum_clobbers = 1;
          return 575; /* movsf_from_si */
        }
    }
  x3 = XVECEXP (x2, 0, 0);
  if (!lowpart_subreg_operator (x3, E_SImode))
    return -1;
  operands[3] = x3;
  if (!gpc_reg_operand (operands[0], E_SFmode))
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  switch (GET_CODE (x4))
    {
    case ASHIFTRT:
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!input_operand (operands[1], E_DImode)
          || !
#line 8452 "../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG))
        return -1;
      *pnum_clobbers = 1;
      return 576; /* movsf_from_si2_ashiftrt */

    case LSHIFTRT:
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!input_operand (operands[1], E_DImode)
          || !
#line 8452 "../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG))
        return -1;
      *pnum_clobbers = 1;
      return 577; /* movsf_from_si2_lshiftrt */

    default:
      return -1;
    }
}

 int
recog_79 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!vsx_register_operand (operands[0], E_DFmode)
          || GET_MODE (x2) != E_DFmode
          || !vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 2463 "../../gcc/config/rs6000/vsx.md"
(TARGET_XSCVSPDPN))
        return -1;
      return 1317; /* vsx_xscvspdpn */

    case E_SFmode:
      if (!vsx_register_operand (operands[0], E_SFmode)
          || GET_MODE (x2) != E_SFmode
          || !vsx_register_operand (operands[1], E_SFmode)
          || !
#line 2480 "../../gcc/config/rs6000/vsx.md"
(TARGET_XSCVSPDPN))
        return -1;
      return 1319; /* vsx_xscvspdpn_directmove */

    default:
      return -1;
    }
}

 int
recog_88 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V1TImode:
      switch (pattern321 (x2, 
E_V1TImode))
        {
        case 0:
          if (!(
#line 5219 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1550; /* xsxsigqp_kf_v1ti */

        case 1:
          if (!(
#line 5219 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1551; /* xsxsigqp_tf_v1ti */

        default:
          return -1;
        }

    case E_TImode:
      switch (pattern321 (x2, 
E_TImode))
        {
        case 0:
          if (!(
#line 5219 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1552; /* xsxsigqp_kf_ti */

        case 1:
          if (!(
#line 5219 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1553; /* xsxsigqp_tf_ti */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_101 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_0_to_3_operand (operands[3], E_SImode))
    return -1;
  switch (GET_CODE (operands[1]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_DDmode:
          if (pattern364 (x3, 
E_DDmode) != 0
              || !
#line 406 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2312; /* dfp_dqua_dd */

        case E_TDmode:
          if (pattern364 (x3, 
E_TDmode) != 0
              || !
#line 406 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2313; /* dfp_dqua_td */

        default:
          return -1;
        }

    case CONST_INT:
      if (!s5bit_cint_operand (operands[1], E_SImode))
        return -1;
      switch (pattern365 (x3))
        {
        case 0:
          if (!
#line 417 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2314; /* dfp_dquai_dd */

        case 1:
          if (!
#line 417 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2315; /* dfp_dquai_td */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_107 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      switch (XINT (x3, 1))
        {
        case 0:
          if (GET_MODE (x3) != E_DImode)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !memory_operand (operands[0], E_DImode))
            return -1;
          return 796; /* probe_stack_di */

        case 74:
          if (GET_MODE (x3) != E_DImode)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !gpc_reg_operand (operands[0], E_DImode))
            return -1;
          return 938; /* load_split_stack_limit_di */

        case 73:
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!base_reg_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !fusion_addis_mem_combo_load (operands[1], E_SImode)
                  || !
#line 14733 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION))
                return -1;
              return 958; /* *fusion_gpr_load_si */

            case E_DImode:
              if (!base_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !fusion_addis_mem_combo_load (operands[1], E_DImode)
                  || !(
#line 14733 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION) && 
#line 484 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 959; /* *fusion_gpr_load_di */

            default:
              return -1;
            }

        case 66:
          if (GET_MODE (x3) != E_SImode
              || !register_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 14829 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD))
            return -1;
          return 961; /* cdtbcd */

        case 67:
          if (GET_MODE (x3) != E_SImode
              || !register_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 14837 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD))
            return -1;
          return 962; /* cbcdtd */

        case 139:
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              switch (pattern320 (x3, 
E_DImode))
                {
                case 0:
                  if (!
#line 5099 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                    return -1;
                  return 1535; /* vsx_sign_extend_v16qi_di */

                case 1:
                  if (!
#line 5108 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                    return -1;
                  return 1539; /* vsx_sign_extend_v8hi_di */

                default:
                  return -1;
                }

            case E_SImode:
              switch (pattern320 (x3, 
E_SImode))
                {
                case 0:
                  if (!
#line 5099 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                    return -1;
                  return 1536; /* vsx_sign_extend_v16qi_si */

                case 1:
                  if (!
#line 5108 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                    return -1;
                  return 1540; /* vsx_sign_extend_v8hi_si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 146:
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (GET_MODE (x3) != E_DImode)
                return -1;
              if (altivec_register_operand (operands[0], E_DImode))
                {
                  switch (GET_MODE (operands[1]))
                    {
                    case E_KFmode:
                      if (altivec_register_operand (operands[1], E_KFmode)
                          && (
#line 5200 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                        return 1545; /* xsxexpqp_kf_di */
                      break;

                    case E_TFmode:
                      if (altivec_register_operand (operands[1], E_TFmode)
                          && (
#line 5200 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                        return 1547; /* xsxexpqp_tf_di */
                      break;

                    default:
                      break;
                    }
                }
              if (!register_operand (operands[0], E_DImode)
                  || !vsx_register_operand (operands[1], E_DFmode)
                  || !(
#line 5209 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 1549; /* xsxexpdp_di */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !vsx_register_operand (operands[1], E_DFmode)
                  || !
#line 5209 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1548; /* xsxexpdp_si */

            default:
              return -1;
            }

        case 147:
          if (GET_MODE (x3) != E_DImode
              || !register_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!vsx_register_operand (operands[1], E_DFmode)
              || !
#line 5228 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && TARGET_POWERPC64))
            return -1;
          return 1554; /* xsxsigdp */

        case 168:
          switch (pattern220 (x3))
            {
            case 0:
              if (!
#line 5963 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1603; /* vclzlsbb_v16qi */

            case 1:
              if (!
#line 5963 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1605; /* vclzlsbb_v8hi */

            case 2:
              if (!
#line 5963 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1607; /* vclzlsbb_v4si */

            default:
              return -1;
            }

        case 169:
          switch (pattern220 (x3))
            {
            case 0:
              if (!
#line 5963 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1604; /* vctzlsbb_v16qi */

            case 1:
              if (!
#line 5963 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1606; /* vctzlsbb_v8hi */

            case 2:
              if (!
#line 5963 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1608; /* vctzlsbb_v4si */

            default:
              return -1;
            }

        case 193:
          if (GET_MODE (x3) != E_SImode
              || !register_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[1]))
            {
            case E_V16QImode:
              if (!altivec_register_operand (operands[1], E_V16QImode)
                  || !
#line 6480 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1633; /* vec_extract_v16qi */

            case E_V8HImode:
              if (!altivec_register_operand (operands[1], E_V8HImode)
                  || !
#line 6480 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1634; /* vec_extract_v8hi */

            case E_V4SImode:
              if (!altivec_register_operand (operands[1], E_V4SImode)
                  || !
#line 6480 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1635; /* vec_extract_v4si */

            case E_V2DImode:
              if (!altivec_register_operand (operands[1], E_V2DImode)
                  || !
#line 6480 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1636; /* vec_extract_v2di */

            case E_V1TImode:
              if (!altivec_register_operand (operands[1], E_V1TImode)
                  || !
#line 6480 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1637; /* vec_extract_v1ti */

            default:
              return -1;
            }

        case 283:
          if (pattern65 (x3, 
E_SImode, 
108, 
E_SImode) != 0
              || !register_operand (operands[0], E_SImode)
              || !
#line 407 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1694; /* get_vrsave_internal */

        case 281:
          if (GET_MODE (x3) != E_SImode
              || !memory_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_V4SImode)
              || !
#line 3242 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2130; /* altivec_stvewx */

        case 426:
          if (GET_MODE (x3) != E_DImode
              || !gpc_reg_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[1]))
            {
            case E_DDmode:
              if (!gpc_reg_operand (operands[1], E_DDmode)
                  || !
#line 325 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
                return -1;
              return 2302; /* dfp_dxex_dd */

            case E_TDmode:
              if (!gpc_reg_operand (operands[1], E_TDmode)
                  || !
#line 325 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
                return -1;
              return 2303; /* dfp_dxex_td */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      switch (XINT (x3, 1))
        {
        case 17:
          if (pattern65 (x3, 
E_CCmode, 
102, 
E_SImode) != 0)
            return -1;
          x5 = XVECEXP (x3, 0, 1);
          if (GET_CODE (x5) != REG
              || REGNO (x5) != 103
              || GET_MODE (x5) != E_CCmode)
            return -1;
          x6 = XVECEXP (x3, 0, 2);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 104
              || GET_MODE (x6) != E_CCmode
              || !gpc_reg_operand (operands[0], E_SImode))
            return -1;
          return 911; /* prologue_movesi_from_cr */

        case 444:
          if (pnum_clobbers == NULL)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x3, 0, 1);
          operands[2] = x5;
          if (!int_reg_operand (operands[2], E_DImode))
            return -1;
          x6 = XVECEXP (x3, 0, 2);
          operands[3] = x6;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!int_reg_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !d_form_memory (operands[1], E_SImode)
                  || !
#line 152 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                return -1;
              *pnum_clobbers = 1;
              return 3189; /* *pcrel_opt_ldsi_gpr */

            case E_DImode:
              if (!int_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !d_form_memory (operands[1], E_DImode)
                  || !
#line 152 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                return -1;
              *pnum_clobbers = 1;
              return 3190; /* *pcrel_opt_lddi_gpr */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      switch (XINT (x3, 1))
        {
        case 49:
          if (pattern322 (x3, 
E_DImode) != 0
              || !(
#line 14443 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 940; /* bpermd_di */

        case 65:
          if (GET_MODE (x3) != E_SImode
              || !register_operand (operands[0], E_SImode)
              || !register_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_SImode)
              || !
#line 14821 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD))
            return -1;
          return 960; /* addg6s */

        case 68:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern142 (x3, 
E_SImode) != 0
                  || !
#line 14852 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD))
                return -1;
              return 963; /* dive_si */

            case E_DImode:
              if (pattern142 (x3, 
E_DImode) != 0
                  || !(
#line 14852 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 965; /* dive_di */

            default:
              return -1;
            }

        case 69:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern142 (x3, 
E_SImode) != 0
                  || !
#line 14852 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD))
                return -1;
              return 964; /* diveu_si */

            case E_DImode:
              if (pattern142 (x3, 
E_DImode) != 0
                  || !(
#line 14852 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 966; /* diveu_di */

            default:
              return -1;
            }

        case 70:
          if (GET_MODE (x3) != E_DImode
              || !const_0_to_1_operand (operands[2], E_QImode))
            return -1;
          if (nonimmediate_operand (operands[0], E_DImode)
              && register_operand (operands[1], E_TDmode))
            {
              if ((
#line 14881 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (TDmode)) && 
#line 545 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)))
                return 969; /* unpacktd_dm */
              if ((
#line 14904 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (TDmode)) && 
#line 545 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)))
                return 972; /* unpacktd_nodm */
            }
          if (!register_operand (operands[0], E_DImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V1TImode:
              if (!register_operand (operands[1], E_V1TImode)
                  || !
#line 14991 "../../gcc/config/rs6000/rs6000.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode)))
                return -1;
              return 977; /* unpackv1ti */

            case E_KFmode:
              if (!register_operand (operands[1], E_KFmode)
                  || !
#line 14991 "../../gcc/config/rs6000/rs6000.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode)))
                return -1;
              return 978; /* unpackkf */

            default:
              return -1;
            }

        case 144:
          if (pattern322 (x3, 
E_V2DImode) != 0
              || !
#line 3646 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && TARGET_DIRECT_MOVE_64BIT))
            return -1;
          return 1388; /* vsx_vslo_v2di */

        case 145:
          if (pnum_clobbers == NULL
              || !gpc_reg_operand (operands[2], E_DImode))
            return -1;
          switch (pattern207 (x3))
            {
            case 0:
              if (gpc_reg_operand (operands[1], E_V2DImode)
                  && 
#line 3658 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && TARGET_DIRECT_MOVE_64BIT))
                {
                  *pnum_clobbers = 2;
                  return 1390; /* vsx_extract_v2di_var */
                }
              if (!memory_operand (operands[1], E_V2DImode)
                  || !
#line 3675 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 1392; /* *vsx_extract_v2di_var_load */

            case 1:
              if (gpc_reg_operand (operands[1], E_V4SImode)
                  && 
#line 4185 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
                {
                  *pnum_clobbers = 2;
                  return 1418; /* vsx_extract_v4si_var */
                }
              if (!memory_operand (operands[1], E_V4SImode)
                  || !
#line 4204 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 1421; /* *vsx_extract_v4si_var_load */

            default:
              return -1;
            }

        case 170:
          if (pattern323 (x3, 
E_V16QImode) != 0
              || !
#line 5974 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1609; /* vextublx */

        case 173:
          if (pattern323 (x3, 
E_V16QImode) != 0
              || !
#line 5985 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1610; /* vextubrx */

        case 171:
          if (pattern323 (x3, 
E_V8HImode) != 0
              || !
#line 5996 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1611; /* vextuhlx */

        case 174:
          if (pattern323 (x3, 
E_V8HImode) != 0
              || !
#line 6007 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1612; /* vextuhrx */

        case 172:
          if (pattern323 (x3, 
E_V4SImode) != 0
              || !
#line 6018 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1613; /* vextuwlx */

        case 175:
          if (pattern323 (x3, 
E_V4SImode) != 0
              || !
#line 6029 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1614; /* vextuwrx */

        case 191:
          if (GET_MODE (x3) != E_DImode
              || !gpc_reg_operand (operands[0], E_DImode)
              || !const_0_to_1_operand (operands[2], E_QImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16QImode:
              if (!altivec_register_operand (operands[1], E_V16QImode)
                  || !
#line 6472 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1629; /* vec_cntmb_v16qi */

            case E_V8HImode:
              if (!altivec_register_operand (operands[1], E_V8HImode)
                  || !
#line 6472 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1630; /* vec_cntmb_v8hi */

            case E_V4SImode:
              if (!altivec_register_operand (operands[1], E_V4SImode)
                  || !
#line 6472 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1631; /* vec_cntmb_v4si */

            case E_V2DImode:
              if (!altivec_register_operand (operands[1], E_V2DImode)
                  || !
#line 6472 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1632; /* vec_cntmb_v2di */

            default:
              return -1;
            }

        case 351:
          if (GET_MODE (x3) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || !altivec_register_operand (operands[1], E_V2DImode)
              || !u3bit_cint_operand (operands[2], E_QImode)
              || !
#line 4681 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 2195; /* vgnb */

        case 443:
          if (GET_MODE (x3) != E_DImode
              || !base_reg_operand (operands[0], E_DImode)
              || !pcrel_external_address (operands[1], E_DImode)
              || !const_int_operand (operands[2], E_VOIDmode)
              || !
#line 125 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
            return -1;
          return 3186; /* pcrel_opt_ld_addr_same_reg */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_123 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      return recog_117 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      switch (XVECLEN (x3, 0))
        {
        case 2:
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          x8 = XVECEXP (x3, 0, 0);
          operands[3] = x8;
          if (!const_0_to_1_operand (operands[3], E_VOIDmode))
            return -1;
          x9 = XVECEXP (x3, 0, 1);
          operands[4] = x9;
          if (!const_2_to_3_operand (operands[4], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (pattern486 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
                  || !
#line 3855 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
                return -1;
              return 1397; /* vsx_xxpermdi2_v2df_1 */

            case E_V2DImode:
              if (pattern486 (x2, 
E_V2DImode, 
E_V4DImode) != 0
                  || !
#line 3855 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
                return -1;
              return 1398; /* vsx_xxpermdi2_v2di_1 */

            default:
              return -1;
            }

        case 16:
          if (pattern221 (x3) != 0
              || pattern513 (x2, 
E_V16QImode, 
E_V32QImode) != 0)
            return -1;
          x8 = XVECEXP (x3, 0, 0);
          switch (XWINT (x8, 0))
            {
            case 0L:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 16L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 1L)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 17L)
                return -1;
              x12 = XVECEXP (x3, 0, 4);
              if (XWINT (x12, 0) != 2L)
                return -1;
              x13 = XVECEXP (x3, 0, 5);
              if (XWINT (x13, 0) != 18L)
                return -1;
              x14 = XVECEXP (x3, 0, 6);
              if (XWINT (x14, 0) != 3L)
                return -1;
              x15 = XVECEXP (x3, 0, 7);
              if (XWINT (x15, 0) != 19L)
                return -1;
              x16 = XVECEXP (x3, 0, 8);
              if (XWINT (x16, 0) != 4L)
                return -1;
              x17 = XVECEXP (x3, 0, 9);
              if (XWINT (x17, 0) != 20L)
                return -1;
              x18 = XVECEXP (x3, 0, 10);
              if (XWINT (x18, 0) != 5L)
                return -1;
              x19 = XVECEXP (x3, 0, 11);
              if (XWINT (x19, 0) != 21L)
                return -1;
              x20 = XVECEXP (x3, 0, 12);
              if (XWINT (x20, 0) != 6L)
                return -1;
              x21 = XVECEXP (x3, 0, 13);
              if (XWINT (x21, 0) != 22L)
                return -1;
              x22 = XVECEXP (x3, 0, 14);
              if (XWINT (x22, 0) != 7L)
                return -1;
              x23 = XVECEXP (x3, 0, 15);
              if (XWINT (x23, 0) != 23L)
                return -1;
              x6 = XEXP (x5, 0);
              operands[1] = x6;
              x7 = XEXP (x5, 1);
              operands[2] = x7;
              if (
#line 1177 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                return 1839; /* altivec_vmrghb_direct_be */
              operands[2] = x6;
              operands[1] = x7;
              if (!
#line 1351 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                return -1;
              return 1849; /* altivec_vmrglb_direct_le */

            case 8L:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 24L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 9L)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 25L)
                return -1;
              x12 = XVECEXP (x3, 0, 4);
              if (XWINT (x12, 0) != 10L)
                return -1;
              x13 = XVECEXP (x3, 0, 5);
              if (XWINT (x13, 0) != 26L)
                return -1;
              x14 = XVECEXP (x3, 0, 6);
              if (XWINT (x14, 0) != 11L)
                return -1;
              x15 = XVECEXP (x3, 0, 7);
              if (XWINT (x15, 0) != 27L)
                return -1;
              x16 = XVECEXP (x3, 0, 8);
              if (XWINT (x16, 0) != 12L)
                return -1;
              x17 = XVECEXP (x3, 0, 9);
              if (XWINT (x17, 0) != 28L)
                return -1;
              x18 = XVECEXP (x3, 0, 10);
              if (XWINT (x18, 0) != 13L)
                return -1;
              x19 = XVECEXP (x3, 0, 11);
              if (XWINT (x19, 0) != 29L)
                return -1;
              x20 = XVECEXP (x3, 0, 12);
              if (XWINT (x20, 0) != 14L)
                return -1;
              x21 = XVECEXP (x3, 0, 13);
              if (XWINT (x21, 0) != 30L)
                return -1;
              x22 = XVECEXP (x3, 0, 14);
              if (XWINT (x22, 0) != 15L)
                return -1;
              x23 = XVECEXP (x3, 0, 15);
              if (XWINT (x23, 0) != 31L)
                return -1;
              x6 = XEXP (x5, 0);
              operands[2] = x6;
              x7 = XEXP (x5, 1);
              operands[1] = x7;
              if (
#line 1195 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                return 1840; /* altivec_vmrghb_direct_le */
              operands[1] = x6;
              operands[2] = x7;
              if (!
#line 1333 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                return -1;
              return 1848; /* altivec_vmrglb_direct_be */

            default:
              return -1;
            }

        case 8:
          if (pattern222 (x3) != 0
              || pattern513 (x2, 
E_V8HImode, 
E_V16HImode) != 0)
            return -1;
          x8 = XVECEXP (x3, 0, 0);
          switch (XWINT (x8, 0))
            {
            case 0L:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 8L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 1L)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 9L)
                return -1;
              x12 = XVECEXP (x3, 0, 4);
              if (XWINT (x12, 0) != 2L)
                return -1;
              x13 = XVECEXP (x3, 0, 5);
              if (XWINT (x13, 0) != 10L)
                return -1;
              x14 = XVECEXP (x3, 0, 6);
              if (XWINT (x14, 0) != 3L)
                return -1;
              x15 = XVECEXP (x3, 0, 7);
              if (XWINT (x15, 0) != 11L)
                return -1;
              x6 = XEXP (x5, 0);
              operands[1] = x6;
              x7 = XEXP (x5, 1);
              operands[2] = x7;
              if (
#line 1224 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                return 1841; /* altivec_vmrghh_direct_be */
              operands[2] = x6;
              operands[1] = x7;
              if (!
#line 1394 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                return -1;
              return 1851; /* altivec_vmrglh_direct_le */

            case 4L:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 12L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 5L)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 13L)
                return -1;
              x12 = XVECEXP (x3, 0, 4);
              if (XWINT (x12, 0) != 6L)
                return -1;
              x13 = XVECEXP (x3, 0, 5);
              if (XWINT (x13, 0) != 14L)
                return -1;
              x14 = XVECEXP (x3, 0, 6);
              if (XWINT (x14, 0) != 7L)
                return -1;
              x15 = XVECEXP (x3, 0, 7);
              if (XWINT (x15, 0) != 15L)
                return -1;
              x6 = XEXP (x5, 0);
              operands[2] = x6;
              x7 = XEXP (x5, 1);
              operands[1] = x7;
              if (
#line 1238 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                return 1842; /* altivec_vmrghh_direct_le */
              operands[1] = x6;
              operands[2] = x7;
              if (!
#line 1380 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                return -1;
              return 1850; /* altivec_vmrglh_direct_be */

            default:
              return -1;
            }

        case 4:
          if (pattern223 (x3) != 0)
            return -1;
          x8 = XVECEXP (x3, 0, 0);
          switch (XWINT (x8, 0))
            {
            case 0L:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 4L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              switch (XWINT (x10, 0))
                {
                case 1L:
                  x11 = XVECEXP (x3, 0, 3);
                  if (XWINT (x11, 0) != 5L)
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V4SFmode:
                      if (pattern513 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0)
                        return -1;
                      x7 = XEXP (x5, 1);
                      operands[2] = x7;
                      x6 = XEXP (x5, 0);
                      operands[1] = x6;
                      if (
#line 1267 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                        return 1843; /* altivec_vmrghw_direct_v4sf_be */
                      if (
#line 1295 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (V4SFmode)))
                        return 1847; /* *altivec_vmrghsf */
                      operands[1] = x7;
                      operands[2] = x6;
                      if (!
#line 1437 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 1854; /* altivec_vmrglw_direct_v4sf_le */

                    case E_V4SImode:
                      if (pattern513 (x2, 
E_V4SImode, 
E_V8SImode) != 0)
                        return -1;
                      x7 = XEXP (x5, 1);
                      operands[2] = x7;
                      x6 = XEXP (x5, 0);
                      operands[1] = x6;
                      if (
#line 1267 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                        return 1844; /* altivec_vmrghw_direct_v4si_be */
                      operands[1] = x7;
                      operands[2] = x6;
                      if (!
#line 1437 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 1855; /* altivec_vmrglw_direct_v4si_le */

                    default:
                      return -1;
                    }

                case 2L:
                  x11 = XVECEXP (x3, 0, 3);
                  if (XWINT (x11, 0) != 6L)
                    return -1;
                  switch (pattern515 (x2))
                    {
                    case 0:
                      if (!
#line 1487 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                        return -1;
                      return 1857; /* p8_vmrgew_v4sf */

                    case 1:
                      if (!
#line 1487 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                        return -1;
                      return 1858; /* p8_vmrgew_v4si */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 2L:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 6L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 3L)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 7L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SFmode:
                  if (pattern513 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0)
                    return -1;
                  x7 = XEXP (x5, 1);
                  operands[1] = x7;
                  x6 = XEXP (x5, 0);
                  operands[2] = x6;
                  if (
#line 1281 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                    return 1845; /* altivec_vmrghw_direct_v4sf_le */
                  operands[2] = x7;
                  operands[1] = x6;
                  if (
#line 1423 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                    return 1852; /* altivec_vmrglw_direct_v4sf_be */
                  if (!
#line 1451 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (V4SFmode)))
                    return -1;
                  return 1856; /* *altivec_vmrglsf */

                case E_V4SImode:
                  if (pattern513 (x2, 
E_V4SImode, 
E_V8SImode) != 0)
                    return -1;
                  x7 = XEXP (x5, 1);
                  operands[1] = x7;
                  x6 = XEXP (x5, 0);
                  operands[2] = x6;
                  if (
#line 1281 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                    return 1846; /* altivec_vmrghw_direct_v4si_le */
                  operands[2] = x7;
                  operands[1] = x6;
                  if (!
#line 1423 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                    return -1;
                  return 1853; /* altivec_vmrglw_direct_v4si_be */

                default:
                  return -1;
                }

            case 1L:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 5L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 3L)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 7L)
                return -1;
              switch (pattern515 (x2))
                {
                case 0:
                  if (!
#line 1504 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                    return -1;
                  return 1859; /* p8_vmrgow_v4sf */

                case 1:
                  if (!
#line 1504 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                    return -1;
                  return 1860; /* p8_vmrgow_v4si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      switch (pattern167 (x2, pnum_clobbers))
        {
        case 0:
          if (!
#line 4997 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 1526; /* *vsx_reduc_plus_v2df_scalar */

        case 1:
          if (!
#line 5024 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          *pnum_clobbers = 3;
          return 1529; /* *vsx_reduc_plus_v4sf_scalar */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern167 (x2, pnum_clobbers))
        {
        case 0:
          if (!
#line 4997 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 1527; /* *vsx_reduc_smin_v2df_scalar */

        case 1:
          if (!
#line 5024 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          *pnum_clobbers = 3;
          return 1530; /* *vsx_reduc_smin_v4sf_scalar */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern167 (x2, pnum_clobbers))
        {
        case 0:
          if (!
#line 4997 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 1528; /* *vsx_reduc_smax_v2df_scalar */

        case 1:
          if (!
#line 5024 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          *pnum_clobbers = 3;
          return 1531; /* *vsx_reduc_smax_v4sf_scalar */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_135 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !gpc_reg_operand (operands[1], E_SFmode)
          || !
#line 5018 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 295; /* *abssf2_fpr */

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !gpc_reg_operand (operands[1], E_DFmode)
          || !
#line 5018 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 296; /* *absdf2_fpr */

    case E_KFmode:
      if (pnum_clobbers != NULL
          && register_operand (operands[0], E_KFmode)
          && GET_MODE (x3) == E_KFmode
          && register_operand (operands[1], E_KFmode)
          && (
#line 9327 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        {
          *pnum_clobbers = 1;
          return 618; /* ieee_128bit_vsx_abskf2 */
        }
      if (!altivec_register_operand (operands[0], E_KFmode)
          || GET_MODE (x3) != E_KFmode
          || !altivec_register_operand (operands[1], E_KFmode)
          || !(
#line 15132 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 997; /* abskf2_hw */

    case E_TFmode:
      if (pnum_clobbers != NULL
          && register_operand (operands[0], E_TFmode)
          && GET_MODE (x3) == E_TFmode
          && register_operand (operands[1], E_TFmode)
          && (
#line 9327 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        {
          *pnum_clobbers = 1;
          return 619; /* ieee_128bit_vsx_abstf2 */
        }
      if (!altivec_register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !altivec_register_operand (operands[1], E_TFmode)
          || !(
#line 15132 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 998; /* abstf2_hw */

    case E_V4SFmode:
      if (!vsx_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 1991 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1246; /* *vsx_absv4sf2 */

    case E_V2DFmode:
      if (!vsx_register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !vsx_register_operand (operands[1], E_V2DFmode)
          || !
#line 1991 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1247; /* *vsx_absv2df2 */

    case E_DDmode:
      if (!gpc_reg_operand (operands[0], E_DDmode)
          || GET_MODE (x3) != E_DDmode
          || !gpc_reg_operand (operands[1], E_DDmode)
          || !
#line 94 "../../gcc/config/rs6000/dfp.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2271; /* absdd2 */

    case E_TDmode:
      if (!gpc_reg_operand (operands[0], E_TDmode)
          || GET_MODE (x3) != E_TDmode
          || !gpc_reg_operand (operands[1], E_TDmode)
          || !
#line 118 "../../gcc/config/rs6000/dfp.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2274; /* abstd2 */

    default:
      return -1;
    }
}

 int
recog_139 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern5 (x1, pnum_clobbers))
    {
    case 0:
      if (vsx_register_operand (operands[0], E_SFmode)
          && vsx_register_operand (operands[1], E_SFmode)
          && vsx_register_operand (operands[2], E_SFmode)
          && 
#line 5488 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && TARGET_HARD_FLOAT))
        return 327; /* *smaxsf3_vsx */
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || !gpc_reg_operand (operands[1], E_SFmode)
          || !gpc_reg_operand (operands[2], E_SFmode)
          || !
#line 5515 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_MINMAX))
        return -1;
      return 335; /* *smaxsf3_fpr */

    case 1:
      if (vsx_register_operand (operands[0], E_DFmode)
          && vsx_register_operand (operands[1], E_DFmode)
          && vsx_register_operand (operands[2], E_DFmode)
          && 
#line 5488 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && TARGET_HARD_FLOAT))
        return 329; /* *smaxdf3_vsx */
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || !gpc_reg_operand (operands[1], E_DFmode)
          || !gpc_reg_operand (operands[2], E_DFmode)
          || !
#line 5515 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_MINMAX))
        return -1;
      return 337; /* *smaxdf3_fpr */

    case 2:
      if (!(
#line 5502 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 331; /* smaxkf3 */

    case 3:
      if (!(
#line 5502 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 333; /* smaxtf3 */

    case 4:
      if (vsx_register_operand (operands[0], E_V4SFmode)
          && vsx_register_operand (operands[1], E_V4SFmode)
          && vsx_register_operand (operands[2], E_V4SFmode)
          && 
#line 2008 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return 1250; /* vsx_smaxv4sf3 */
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode)
          || !register_operand (operands[2], E_V4SFmode)
          || !
#line 1089 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
        return -1;
      return 1826; /* *altivec_smaxv4sf3 */

    case 5:
      if (!
#line 2008 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1251; /* vsx_smaxv2df3 */

    case 6:
      if (!
#line 1081 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
        return -1;
      return 1822; /* smaxv4si3 */

    case 7:
      if (!
#line 1081 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
        return -1;
      return 1823; /* smaxv8hi3 */

    case 8:
      if (!
#line 1081 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
        return -1;
      return 1824; /* smaxv16qi3 */

    case 9:
      if (!
#line 1081 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
        return -1;
      return 1825; /* smaxv2di3 */

    case 10:
      if (!
#line 4927 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      *pnum_clobbers = 1;
      return 1522; /* vsx_reduc_smax_v2df */

    case 11:
      if (!
#line 4949 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      *pnum_clobbers = 2;
      return 1525; /* vsx_reduc_smax_v4sf */

    default:
      return -1;
    }
}

 int
recog_148 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x2, 0);
      operands[3] = x6;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      x8 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x8))
        {
        case SET:
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) != AND)
            return -1;
          switch (pattern174 (x1))
            {
            case 0:
              if (logical_const_operand (operands[2], E_SImode))
                {
                  if (pnum_clobbers != NULL
                      && 
#line 3681 "../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], SImode)))
                    {
                      *pnum_clobbers = 1;
                      return 192; /* *andsi3_imm_dot2 */
                    }
                  if (
#line 3730 "../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_and_mask (operands[2], SImode)))
                    return 196; /* *andsi3_imm_mask_dot2 */
                }
              if (!const_int_operand (operands[2], E_SImode))
                return -1;
              if (
#line 3814 "../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !logical_const_operand (operands[2], SImode)
   && rs6000_is_valid_and_mask (operands[2], SImode)))
                return 204; /* *andsi3_mask_dot2 */
              if (!
#line 3882 "../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_2insn_and (operands[2], SImode)
   && !(rs6000_is_valid_and_mask (operands[2], SImode)
	|| logical_const_operand (operands[2], SImode))))
                return -1;
              return 210; /* *andsi3_2insn_dot2 */

            case 1:
              if (logical_const_operand (operands[2], E_DImode))
                {
                  if (pnum_clobbers != NULL
                      && (
#line 3681 "../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    {
                      *pnum_clobbers = 1;
                      return 193; /* *anddi3_imm_dot2 */
                    }
                  if ((
#line 3730 "../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return 197; /* *anddi3_imm_mask_dot2 */
                }
              if (!const_int_operand (operands[2], E_DImode))
                return -1;
              if ((
#line 3814 "../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !logical_const_operand (operands[2], DImode)
   && rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return 205; /* *anddi3_mask_dot2 */
              if (!(
#line 3882 "../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_2insn_and (operands[2], DImode)
   && !(rs6000_is_valid_and_mask (operands[2], DImode)
	|| logical_const_operand (operands[2], DImode))) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 211; /* *anddi3_2insn_dot2 */

            default:
              return -1;
            }

        case CLOBBER:
          switch (pattern170 (x1))
            {
            case 0:
              if (logical_const_operand (operands[2], E_SImode)
                  && 
#line 3705 "../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_and_mask (operands[2], SImode)))
                return 194; /* *andsi3_imm_mask_dot */
              if (!const_int_operand (operands[2], E_SImode))
                return -1;
              if (
#line 3785 "../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !logical_const_operand (operands[2], SImode)
   && rs6000_is_valid_and_mask (operands[2], SImode)))
                return 202; /* *andsi3_mask_dot */
              if (!
#line 3859 "../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_2insn_and (operands[2], SImode)
   && !(rs6000_is_valid_and_mask (operands[2], SImode)
	|| logical_const_operand (operands[2], SImode))))
                return -1;
              return 208; /* *andsi3_2insn_dot */

            case 1:
              if (logical_const_operand (operands[2], E_DImode)
                  && (
#line 3705 "../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return 195; /* *anddi3_imm_mask_dot */
              if (!const_int_operand (operands[2], E_DImode))
                return -1;
              if ((
#line 3785 "../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && !logical_const_operand (operands[2], DImode)
   && rs6000_is_valid_and_mask (operands[2], DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return 203; /* *anddi3_mask_dot */
              if (!(
#line 3859 "../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[2]) <= 0x7fffffff)
   && rs6000_is_valid_2insn_and (operands[2], DImode)
   && !(rs6000_is_valid_and_mask (operands[2], DImode)
	|| logical_const_operand (operands[2], DImode))) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 209; /* *anddi3_2insn_dot */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
    case ROTATE:
    case LSHIFTRT:
      x10 = XEXP (x5, 0);
      operands[1] = x10;
      if (GET_CODE (x5) == LSHIFTRT)
        {
          res = recog_147 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x6 = XEXP (x2, 0);
      operands[5] = x6;
      operands[4] = x5;
      switch (pattern489 (x1))
        {
        case 0:
          if (!
#line 4198 "../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[3]) <= 0x7fffffff)
   && rs6000_is_valid_shift_mask (operands[3], operands[4], SImode)))
            return -1;
          return 237; /* *rotlsi3_mask_dot */

        case 1:
          if (!(
#line 4198 "../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[3]) <= 0x7fffffff)
   && rs6000_is_valid_shift_mask (operands[3], operands[4], DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 238; /* *rotldi3_mask_dot */

        case 2:
          if (!
#line 4230 "../../gcc/config/rs6000/rs6000.md"
((SImode == Pmode || UINTVAL (operands[3]) <= 0x7fffffff)
   && rs6000_is_valid_shift_mask (operands[3], operands[4], SImode)))
            return -1;
          return 239; /* *rotlsi3_mask_dot2 */

        case 3:
          if (!(
#line 4230 "../../gcc/config/rs6000/rs6000.md"
((DImode == Pmode || UINTVAL (operands[3]) <= 0x7fffffff)
   && rs6000_is_valid_shift_mask (operands[3], operands[4], DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 240; /* *rotldi3_mask_dot2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_163 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x3, 0);
      operands[0] = x6;
      switch (pattern337 (x1))
        {
        case 0:
          if (!
#line 4472 "../../gcc/config/rs6000/rs6000.md"
(!logical_const_operand (operands[2], SImode)
   && rs6000_is_valid_mask (operands[2], NULL, NULL, SImode)))
            return -1;
          return 259; /* *iorsi_mask */

        case 1:
          if (!(
#line 4472 "../../gcc/config/rs6000/rs6000.md"
(!logical_const_operand (operands[2], DImode)
   && rs6000_is_valid_mask (operands[2], NULL, NULL, DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 260; /* *iordi_mask */

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern249 (x4) != 0)
        return -1;
      x6 = XEXP (x3, 0);
      operands[0] = x6;
      switch (pattern502 (x1))
        {
        case 0:
          if (!
#line 4528 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && INTVAL (operands[2]) == 8))
            return -1;
          return 261; /* *rotldi3_insert_sf */

        case 1:
          if (!
#line 4528 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && INTVAL (operands[2]) == 16))
            return -1;
          return 262; /* *rotldi3_insert_sf */

        case 2:
          if (!
#line 4528 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && INTVAL (operands[2]) == 32))
            return -1;
          return 263; /* *rotldi3_insert_sf */

        default:
          return -1;
        }

    case NOT:
      return recog_157 (x1, insn, pnum_clobbers);

    case AND:
      switch (pattern244 (x1))
        {
        case 0:
          if (!
#line 1195 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2466; /* *fuse_and_or */

        case 1:
          if (!(
#line 1195 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2467; /* *fuse_and_or */

        case 2:
          if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2942; /* *fuse_vand_vor */

        case 3:
          if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2943; /* *fuse_vand_vor */

        case 4:
          if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2944; /* *fuse_vand_vor */

        case 5:
          if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2945; /* *fuse_vand_vor */

        case 6:
          if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2946; /* *fuse_vand_vor */

        case 7:
          if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2947; /* *fuse_vand_vor */

        case 8:
          if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2948; /* *fuse_vand_vor */

        case 9:
          if (!
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2949; /* *fuse_vand_vor */

        case 10:
          if (!(
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2950; /* *fuse_vand_vor */

        case 11:
          if (!(
#line 2599 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2951; /* *fuse_vand_vor */

        case 12:
          if (!
#line 1375 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2486; /* *fuse_and_orc */

        case 13:
          if (!(
#line 1375 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2487; /* *fuse_and_orc */

        case 14:
          if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3022; /* *fuse_vand_vorc */

        case 15:
          if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3023; /* *fuse_vand_vorc */

        case 16:
          if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3024; /* *fuse_vand_vorc */

        case 17:
          if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3025; /* *fuse_vand_vorc */

        case 18:
          if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3026; /* *fuse_vand_vorc */

        case 19:
          if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3027; /* *fuse_vand_vorc */

        case 20:
          if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3028; /* *fuse_vand_vorc */

        case 21:
          if (!
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3029; /* *fuse_vand_vorc */

        case 22:
          if (!(
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3030; /* *fuse_vand_vorc */

        case 23:
          if (!(
#line 2743 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3031; /* *fuse_vand_vorc */

        case 24:
          if (!
#line 1213 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2468; /* *fuse_andc_or */

        case 25:
          if (!(
#line 1213 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2469; /* *fuse_andc_or */

        case 26:
          if (!
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2952; /* *fuse_vandc_vor */

        case 27:
          if (!
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2953; /* *fuse_vandc_vor */

        case 28:
          if (!
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2954; /* *fuse_vandc_vor */

        case 29:
          if (!
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2955; /* *fuse_vandc_vor */

        case 30:
          if (!
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2956; /* *fuse_vandc_vor */

        case 31:
          if (!
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2957; /* *fuse_vandc_vor */

        case 32:
          if (!
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2958; /* *fuse_vandc_vor */

        case 33:
          if (!
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2959; /* *fuse_vandc_vor */

        case 34:
          if (!(
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2960; /* *fuse_vandc_vor */

        case 35:
          if (!(
#line 2617 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2961; /* *fuse_vandc_vor */

        case 36:
          if (!
#line 1393 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2488; /* *fuse_andc_orc */

        case 37:
          if (!(
#line 1393 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2489; /* *fuse_andc_orc */

        case 38:
          if (!
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3032; /* *fuse_vandc_vorc */

        case 39:
          if (!
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3033; /* *fuse_vandc_vorc */

        case 40:
          if (!
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3034; /* *fuse_vandc_vorc */

        case 41:
          if (!
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3035; /* *fuse_vandc_vorc */

        case 42:
          if (!
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3036; /* *fuse_vandc_vorc */

        case 43:
          if (!
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3037; /* *fuse_vandc_vorc */

        case 44:
          if (!
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3038; /* *fuse_vandc_vorc */

        case 45:
          if (!
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3039; /* *fuse_vandc_vorc */

        case 46:
          if (!(
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3040; /* *fuse_vandc_vorc */

        case 47:
          if (!(
#line 2761 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3041; /* *fuse_vandc_vorc */

        case 48:
          if (!
#line 1267 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2474; /* *fuse_nor_or */

        case 49:
          if (!(
#line 1267 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2475; /* *fuse_nor_or */

        case 50:
          if (!
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2982; /* *fuse_vnor_vor */

        case 51:
          if (!
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2983; /* *fuse_vnor_vor */

        case 52:
          if (!
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2984; /* *fuse_vnor_vor */

        case 53:
          if (!
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2985; /* *fuse_vnor_vor */

        case 54:
          if (!
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2986; /* *fuse_vnor_vor */

        case 55:
          if (!
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2987; /* *fuse_vnor_vor */

        case 56:
          if (!
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2988; /* *fuse_vnor_vor */

        case 57:
          if (!
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2989; /* *fuse_vnor_vor */

        case 58:
          if (!(
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2990; /* *fuse_vnor_vor */

        case 59:
          if (!(
#line 2671 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2991; /* *fuse_vnor_vor */

        case 60:
          if (!
#line 1447 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2494; /* *fuse_nor_orc */

        case 61:
          if (!(
#line 1447 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2495; /* *fuse_nor_orc */

        case 62:
          if (!
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3062; /* *fuse_vnor_vorc */

        case 63:
          if (!
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3063; /* *fuse_vnor_vorc */

        case 64:
          if (!
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3064; /* *fuse_vnor_vorc */

        case 65:
          if (!
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3065; /* *fuse_vnor_vorc */

        case 66:
          if (!
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3066; /* *fuse_vnor_vorc */

        case 67:
          if (!
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3067; /* *fuse_vnor_vorc */

        case 68:
          if (!
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3068; /* *fuse_vnor_vorc */

        case 69:
          if (!
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3069; /* *fuse_vnor_vorc */

        case 70:
          if (!(
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3070; /* *fuse_vnor_vorc */

        case 71:
          if (!(
#line 2815 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3071; /* *fuse_vnor_vorc */

        default:
          return -1;
        }

    case IOR:
      switch (pattern245 (x1))
        {
        case 0:
          if (!
#line 1249 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2472; /* *fuse_nand_or */

        case 1:
          if (!(
#line 1249 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2473; /* *fuse_nand_or */

        case 2:
          if (!
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2972; /* *fuse_vnand_vor */

        case 3:
          if (!
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2973; /* *fuse_vnand_vor */

        case 4:
          if (!
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2974; /* *fuse_vnand_vor */

        case 5:
          if (!
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2975; /* *fuse_vnand_vor */

        case 6:
          if (!
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2976; /* *fuse_vnand_vor */

        case 7:
          if (!
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2977; /* *fuse_vnand_vor */

        case 8:
          if (!
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2978; /* *fuse_vnand_vor */

        case 9:
          if (!
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2979; /* *fuse_vnand_vor */

        case 10:
          if (!(
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2980; /* *fuse_vnand_vor */

        case 11:
          if (!(
#line 2653 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2981; /* *fuse_vnand_vor */

        case 12:
          if (!
#line 1429 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2492; /* *fuse_nand_orc */

        case 13:
          if (!(
#line 1429 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2493; /* *fuse_nand_orc */

        case 14:
          if (!
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3052; /* *fuse_vnand_vorc */

        case 15:
          if (!
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3053; /* *fuse_vnand_vorc */

        case 16:
          if (!
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3054; /* *fuse_vnand_vorc */

        case 17:
          if (!
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3055; /* *fuse_vnand_vorc */

        case 18:
          if (!
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3056; /* *fuse_vnand_vorc */

        case 19:
          if (!
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3057; /* *fuse_vnand_vorc */

        case 20:
          if (!
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3058; /* *fuse_vnand_vorc */

        case 21:
          if (!
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3059; /* *fuse_vnand_vorc */

        case 22:
          if (!(
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3060; /* *fuse_vnand_vorc */

        case 23:
          if (!(
#line 2797 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3061; /* *fuse_vnand_vorc */

        case 24:
          if (!
#line 1303 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2478; /* *fuse_orc_or */

        case 25:
          if (!(
#line 1303 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2479; /* *fuse_orc_or */

        case 26:
          if (!
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3002; /* *fuse_vorc_vor */

        case 27:
          if (!
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3003; /* *fuse_vorc_vor */

        case 28:
          if (!
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3004; /* *fuse_vorc_vor */

        case 29:
          if (!
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3005; /* *fuse_vorc_vor */

        case 30:
          if (!
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3006; /* *fuse_vorc_vor */

        case 31:
          if (!
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3007; /* *fuse_vorc_vor */

        case 32:
          if (!
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3008; /* *fuse_vorc_vor */

        case 33:
          if (!
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3009; /* *fuse_vorc_vor */

        case 34:
          if (!(
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3010; /* *fuse_vorc_vor */

        case 35:
          if (!(
#line 2707 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3011; /* *fuse_vorc_vor */

        case 36:
          if (!
#line 1483 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2498; /* *fuse_orc_orc */

        case 37:
          if (!(
#line 1483 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2499; /* *fuse_orc_orc */

        case 38:
          if (!
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3082; /* *fuse_vorc_vorc */

        case 39:
          if (!
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3083; /* *fuse_vorc_vorc */

        case 40:
          if (!
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3084; /* *fuse_vorc_vorc */

        case 41:
          if (!
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3085; /* *fuse_vorc_vorc */

        case 42:
          if (!
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3086; /* *fuse_vorc_vorc */

        case 43:
          if (!
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3087; /* *fuse_vorc_vorc */

        case 44:
          if (!
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3088; /* *fuse_vorc_vorc */

        case 45:
          if (!
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3089; /* *fuse_vorc_vorc */

        case 46:
          if (!(
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3090; /* *fuse_vorc_vorc */

        case 47:
          if (!(
#line 2851 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3091; /* *fuse_vorc_vorc */

        case 48:
          if (!
#line 1285 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2476; /* *fuse_or_or */

        case 49:
          if (!(
#line 1285 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2477; /* *fuse_or_or */

        case 50:
          if (!
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2992; /* *fuse_vor_vor */

        case 51:
          if (!
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2993; /* *fuse_vor_vor */

        case 52:
          if (!
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2994; /* *fuse_vor_vor */

        case 53:
          if (!
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2995; /* *fuse_vor_vor */

        case 54:
          if (!
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2996; /* *fuse_vor_vor */

        case 55:
          if (!
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2997; /* *fuse_vor_vor */

        case 56:
          if (!
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2998; /* *fuse_vor_vor */

        case 57:
          if (!
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2999; /* *fuse_vor_vor */

        case 58:
          if (!(
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3000; /* *fuse_vor_vor */

        case 59:
          if (!(
#line 2689 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3001; /* *fuse_vor_vor */

        case 60:
          if (!
#line 1465 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2496; /* *fuse_or_orc */

        case 61:
          if (!(
#line 1465 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2497; /* *fuse_or_orc */

        case 62:
          if (!
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3072; /* *fuse_vor_vorc */

        case 63:
          if (!
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3073; /* *fuse_vor_vorc */

        case 64:
          if (!
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3074; /* *fuse_vor_vorc */

        case 65:
          if (!
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3075; /* *fuse_vor_vorc */

        case 66:
          if (!
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3076; /* *fuse_vor_vorc */

        case 67:
          if (!
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3077; /* *fuse_vor_vorc */

        case 68:
          if (!
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3078; /* *fuse_vor_vorc */

        case 69:
          if (!
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3079; /* *fuse_vor_vorc */

        case 70:
          if (!(
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3080; /* *fuse_vor_vorc */

        case 71:
          if (!(
#line 2833 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3081; /* *fuse_vor_vorc */

        default:
          return -1;
        }

    case XOR:
      switch (pattern246 (x1))
        {
        case 0:
          if (!
#line 1321 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2480; /* *fuse_xor_or */

        case 1:
          if (!(
#line 1321 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2481; /* *fuse_xor_or */

        case 2:
          if (!
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3012; /* *fuse_vxor_vor */

        case 3:
          if (!
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3013; /* *fuse_vxor_vor */

        case 4:
          if (!
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3014; /* *fuse_vxor_vor */

        case 5:
          if (!
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3015; /* *fuse_vxor_vor */

        case 6:
          if (!
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3016; /* *fuse_vxor_vor */

        case 7:
          if (!
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3017; /* *fuse_vxor_vor */

        case 8:
          if (!
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3018; /* *fuse_vxor_vor */

        case 9:
          if (!
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3019; /* *fuse_vxor_vor */

        case 10:
          if (!(
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3020; /* *fuse_vxor_vor */

        case 11:
          if (!(
#line 2725 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3021; /* *fuse_vxor_vor */

        case 12:
          if (!
#line 1501 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2500; /* *fuse_xor_orc */

        case 13:
          if (!(
#line 1501 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2501; /* *fuse_xor_orc */

        case 14:
          if (!
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3092; /* *fuse_vxor_vorc */

        case 15:
          if (!
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3093; /* *fuse_vxor_vorc */

        case 16:
          if (!
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3094; /* *fuse_vxor_vorc */

        case 17:
          if (!
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3095; /* *fuse_vxor_vorc */

        case 18:
          if (!
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3096; /* *fuse_vxor_vorc */

        case 19:
          if (!
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3097; /* *fuse_vxor_vorc */

        case 20:
          if (!
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3098; /* *fuse_vxor_vorc */

        case 21:
          if (!
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3099; /* *fuse_vxor_vorc */

        case 22:
          if (!(
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3100; /* *fuse_vxor_vorc */

        case 23:
          if (!(
#line 2869 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3101; /* *fuse_vxor_vorc */

        default:
          return -1;
        }

    case PLUS:
      switch (pattern248 (x1))
        {
        case 0:
          if (!
#line 1339 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2482; /* *fuse_add_or */

        case 1:
          if (!(
#line 1339 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2483; /* *fuse_add_or */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern248 (x1))
        {
        case 0:
          if (!
#line 1357 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2484; /* *fuse_subf_or */

        case 1:
          if (!(
#line 1357 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2485; /* *fuse_subf_or */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_186 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          res = recog_180 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 3:
          res = recog_181 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 6:
          if (pattern16 (x1) == 0
              && 
#line 6081 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_FCFID && TARGET_HARD_FLOAT))
            return 404; /* *floatsidf2_internal */
          break;

        case 5:
          res = recog_182 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 4:
          res = recog_183 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 10:
          switch (pattern18 (x1))
            {
            case 0:
              if ((
#line 12723 "../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
                return 806; /* *cmpif_internal2 */
              break;

            case 1:
              if ((
#line 12723 "../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                return 807; /* *cmpif_internal2 */
              break;

            case 2:
              if ((
#line 12723 "../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
                return 808; /* *cmptf_internal2 */
              break;

            case 3:
              if ((
#line 12723 "../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                return 809; /* *cmptf_internal2 */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      operands[0] = x1;
      if (XVECLEN (operands[0], 0) >= 1)
        {
          res = recog_184 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XVECLEN (operands[0], 0) >= 4
          && any_parallel_operand (operands[0], E_VOIDmode))
        {
          res = recog_185 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XVECLEN (operands[0], 0) < 5
          || !any_parallel_operand (operands[0], E_VOIDmode))
        return -1;
      x2 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x2) != USE)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != REG
          || GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XVECEXP (x1, 0, 0);
      switch (GET_CODE (x5))
        {
        case RETURN:
          x6 = XVECEXP (x1, 0, 1);
          if (pattern331 (x6, 
E_DImode, 
96, 
CLOBBER) != 0)
            return -1;
          x7 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x7) != USE)
            return -1;
          x8 = XEXP (x7, 0);
          operands[1] = x8;
          if (!symbol_ref_operand (operands[1], E_DImode))
            return -1;
          x9 = XEXP (x4, 0);
          operands[2] = x9;
          x10 = XEXP (x4, 1);
          operands[3] = x10;
          switch (REGNO (x3))
            {
            case 11:
              switch (pattern546 ())
                {
                case 0:
                  return 927; /* *return_and_restore_gpregs_di_r11 */

                case 1:
                  return 930; /* *return_and_restore_fpregs_di_r11 */

                default:
                  return -1;
                }

            case 12:
              switch (pattern546 ())
                {
                case 0:
                  return 928; /* *return_and_restore_gpregs_di_r12 */

                case 1:
                  return 931; /* *return_and_restore_fpregs_di_r12 */

                default:
                  return -1;
                }

            case 1:
              switch (pattern546 ())
                {
                case 0:
                  return 929; /* *return_and_restore_gpregs_di_r1 */

                case 1:
                  return 932; /* *return_and_restore_fpregs_di_r1 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case CLOBBER:
          x11 = XEXP (x5, 0);
          if (GET_CODE (x11) != REG
              || REGNO (x11) != 96
              || GET_MODE (x11) != E_DImode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != USE)
            return -1;
          x7 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x7) != CLOBBER)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x3) != 0)
            return -1;
          x12 = XEXP (x6, 0);
          operands[1] = x12;
          if (!symbol_ref_operand (operands[1], E_DImode)
              || GET_MODE (x8) != E_DImode)
            return -1;
          switch (REGNO (x8))
            {
            case 11:
              switch (pattern553 (x4))
                {
                case 0:
                  if (!(
#line 461 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 1696; /* *save_vregs_di_r11 */

                case 1:
                  if (!(
#line 487 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 1698; /* *restore_vregs_di_r11 */

                default:
                  return -1;
                }

            case 12:
              switch (pattern553 (x4))
                {
                case 0:
                  if (!(
#line 474 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 1697; /* *save_vregs_di_r12 */

                case 1:
                  if (!(
#line 500 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 1699; /* *restore_vregs_di_r12 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 1:
          switch (XINT (x1, 1))
            {
            case 15:
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              if (!u5bit_cint_operand (operands[0], E_SImode)
                  || !
#line 6511 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 448; /* rs6000_mtfsb0 */

            case 16:
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              if (!u5bit_cint_operand (operands[0], E_SImode)
                  || !
#line 6518 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 449; /* rs6000_mtfsb1 */

            case 0:
              x5 = XVECEXP (x1, 0, 0);
              if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 795; /* blockage */

            case 18:
              if (GET_MODE (x1) != E_BLKmode)
                return -1;
              x5 = XVECEXP (x1, 0, 0);
              if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 902; /* speculation_barrier */

            case 4:
              if (pnum_clobbers == NULL)
                return -1;
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              if (!register_operand (operands[0], E_DImode))
                return -1;
              *pnum_clobbers = 1;
              return 935; /* eh_set_lr_di */

            case 5:
              if (GET_MODE (x1) != E_BLKmode)
                return -1;
              x5 = XVECEXP (x1, 0, 0);
              switch (GET_CODE (x5))
                {
                case CONST_INT:
                  if (XWINT (x5, 0) != 0L)
                    return -1;
                  return 1104; /* isync */

                case REG:
                case SUBREG:
                  if (pnum_clobbers == NULL)
                    return -1;
                  operands[0] = x5;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_QImode:
                      if (!register_operand (operands[0], E_QImode))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1105; /* loadsync_qi */

                    case E_HImode:
                      if (!register_operand (operands[0], E_HImode))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1106; /* loadsync_hi */

                    case E_SImode:
                      if (!register_operand (operands[0], E_SImode))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1107; /* loadsync_si */

                    case E_DImode:
                      if (!register_operand (operands[0], E_DImode)
                          || !
#line 111 "../../gcc/config/rs6000/sync.md"
(TARGET_POWERPC64))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1108; /* loadsync_di */

                    case E_TImode:
                      if (!register_operand (operands[0], E_TImode)
                          || !
#line 112 "../../gcc/config/rs6000/sync.md"
(TARGET_SYNC_TI))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1109; /* loadsync_ti */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 24:
              x5 = XVECEXP (x1, 0, 0);
              if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || !
#line 2951 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2042; /* altivec_dssall */

            case 25:
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              if (!immediate_operand (operands[0], E_QImode)
                  || !
#line 2958 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2043; /* altivec_dss */

            default:
              return -1;
            }

        case 2:
          switch (XINT (x1, 1))
            {
            case 17:
              x5 = XVECEXP (x1, 0, 0);
              if (GET_CODE (x5) != REG
                  || REGNO (x5) != 0
                  || GET_MODE (x5) != E_SImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != REG
                  || REGNO (x6) != 96
                  || GET_MODE (x6) != E_SImode)
                return -1;
              return 939; /* split_stack_return */

            case 13:
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              if (!const_int_operand (operands[0], E_SImode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              operands[1] = x6;
              if (!gpc_reg_operand (operands[1], E_DFmode)
                  || !
#line 14688 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 954; /* rs6000_mtfsf */

            case 14:
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              if (!const_int_operand (operands[0], E_SImode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              operands[1] = x6;
              if (!gpc_reg_operand (operands[1], E_DFmode)
                  || !
#line 14695 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 955; /* rs6000_mtfsf_hi */

            case 96:
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              if (!int_reg_operand (operands[0], E_DImode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              operands[1] = x6;
              if (!simple_offsettable_mem_operand (operands[1], E_DImode)
                  || !
#line 15858 "../../gcc/config/rs6000/rs6000.md"
(rs6000_rop_protect))
                return -1;
              return 1101; /* hashchk */

            case 39:
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              x6 = XVECEXP (x1, 0, 1);
              operands[1] = x6;
              if (!u10bit_cint_operand (operands[1], E_VOIDmode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!gpc_reg_operand (operands[0], E_SImode)
                      || !
#line 280 "../../gcc/config/rs6000/htm.md"
(TARGET_HTM))
                    return -1;
                  return 2350; /* htm_mtspr_si */

                case E_DImode:
                  if (!gpc_reg_operand (operands[0], E_DImode)
                      || !(
#line 280 "../../gcc/config/rs6000/htm.md"
(TARGET_HTM) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2351; /* htm_mtspr_di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case RETURN:
      if (!
#line 13515 "../../gcc/config/rs6000/rs6000.md"
(direct_return ()))
        return -1;
      return 894; /* return */

    case SIMPLE_RETURN:
      return 895; /* simple_return */

    case UNSPEC:
      switch (XVECLEN (x1, 0))
        {
        case 1:
          x5 = XVECEXP (x1, 0, 0);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (XINT (x1, 1))
            {
            case 57:
              return 900; /* nop */

            case 58:
              return 901; /* group_ending_nop */

            default:
              return -1;
            }

        case 3:
          x5 = XVECEXP (x1, 0, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_VOIDmode))
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x7 = XVECEXP (x1, 0, 2);
          operands[2] = x7;
          if (!immediate_operand (operands[2], E_QImode))
            return -1;
          switch (XINT (x1, 1))
            {
            case 272:
              if (!
#line 2966 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && GET_MODE (operands[0]) == Pmode))
                return -1;
              return 2044; /* altivec_dst */

            case 273:
              if (!
#line 2974 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && GET_MODE (operands[0]) == Pmode))
                return -1;
              return 2045; /* altivec_dstt */

            case 274:
              if (!
#line 2982 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && GET_MODE (operands[0]) == Pmode))
                return -1;
              return 2046; /* altivec_dstst */

            case 275:
              if (!
#line 2990 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && GET_MODE (operands[0]) == Pmode))
                return -1;
              return 2047; /* altivec_dststt */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case TRAP_IF:
      x13 = XEXP (x1, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x14 = XEXP (x1, 0);
      switch (GET_CODE (x14))
        {
        case CONST_INT:
          if (XWINT (x14, 0) != 1L)
            return -1;
          return 907; /* trap */

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
          operands[0] = x14;
          if (!ordered_comparison_operator (operands[0], E_VOIDmode))
            return -1;
          x15 = XEXP (x14, 0);
          operands[1] = x15;
          x16 = XEXP (x14, 1);
          operands[2] = x16;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !reg_or_short_operand (operands[2], E_SImode))
                return -1;
              return 908; /* *rs6000.md:13918 */

            case E_DImode:
              if (!register_operand (operands[1], E_DImode)
                  || !reg_or_short_operand (operands[2], E_DImode)
                  || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 909; /* *rs6000.md:13918 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case EH_RETURN:
      return 936; /* eh_return_internal */

    case PREFETCH:
      x14 = XEXP (x1, 0);
      operands[0] = x14;
      if (!indexed_or_indirect_address (operands[0], E_VOIDmode))
        return -1;
      x13 = XEXP (x1, 1);
      operands[1] = x13;
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      x17 = XEXP (x1, 2);
      operands[2] = x17;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      return 937; /* prefetch */

    default:
      return -1;
    }
}

 rtx_insn *
split_11 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case IOR:
      res = split_10 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case XOR:
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          switch (pattern257 (x2))
            {
            case 0:
              return gen_split_86 (insn, operands);

            case 1:
              if (
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return gen_split_88 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case AND:
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) == ASHIFT)
            {
              switch (pattern210 (x2))
                {
                case 0:
                  if ((
#line 4333 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)) && 
#line 4336 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return gen_split_106 (insn, operands);
                  break;

                case 1:
                  if (((
#line 4333 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4336 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return gen_split_108 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        case ASHIFT:
          switch (pattern198 (x2))
            {
            case 0:
              if (
#line 4348 "../../gcc/config/rs6000/rs6000.md"
(nonzero_bits (operands[3], SImode)
   < HOST_WIDE_INT_1U << INTVAL (operands[2])))
                return gen_split_111 (insn, operands);
              break;

            case 1:
              if ((
#line 4348 "../../gcc/config/rs6000/rs6000.md"
(nonzero_bits (operands[3], DImode)
   < HOST_WIDE_INT_1U << INTVAL (operands[2])) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return gen_split_114 (insn, operands);
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      if (pattern343 (
E_TImode) != 0
          || !
#line 7424 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], TImode)))
        return NULL;
      return gen_split_239 (insn, operands);

    case E_PTImode:
      if (pattern343 (
E_PTImode) != 0
          || !
#line 7424 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], PTImode)))
        return NULL;
      return gen_split_240 (insn, operands);

    case E_V16QImode:
      if (pattern343 (
E_V16QImode) != 0
          || !(
#line 7424 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V16QImode)) && 
#line 778 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
        return NULL;
      return gen_split_241 (insn, operands);

    case E_V8HImode:
      if (pattern343 (
E_V8HImode) != 0
          || !(
#line 7424 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V8HImode)) && 
#line 779 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
        return NULL;
      return gen_split_242 (insn, operands);

    case E_V4SImode:
      if (pattern343 (
E_V4SImode) != 0
          || !(
#line 7424 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V4SImode)) && 
#line 780 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
        return NULL;
      return gen_split_243 (insn, operands);

    case E_V4SFmode:
      if (pattern343 (
E_V4SFmode) != 0
          || !(
#line 7424 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V4SFmode)) && 
#line 781 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
        return NULL;
      return gen_split_244 (insn, operands);

    case E_V2DImode:
      if (pattern343 (
E_V2DImode) != 0
          || !(
#line 7424 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V2DImode)) && 
#line 782 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
        return NULL;
      return gen_split_245 (insn, operands);

    case E_V2DFmode:
      if (pattern343 (
E_V2DFmode) != 0
          || !(
#line 7424 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V2DFmode)) && 
#line 783 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
        return NULL;
      return gen_split_246 (insn, operands);

    case E_V1TImode:
      if (pattern343 (
E_V1TImode) != 0
          || !(
#line 7424 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V1TImode)) && 
#line 784 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
        return NULL;
      return gen_split_247 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_15 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_VECTOR:
    case VEC_DUPLICATE:
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (gpc_reg_operand (operands[0], E_SImode)
              && const_int_operand (operands[1], E_SImode)
              && 
#line 8013 "../../gcc/config/rs6000/rs6000.md"
(num_insns_constant (operands[1], SImode) > 1))
            return gen_split_295 (insn, operands);
          if (altivec_register_operand (operands[0], E_SImode)
              && xxspltib_constant_split (operands[1], E_SImode)
              && 
#line 10009 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && reload_completed))
            return gen_split_385 (insn, operands);
          break;

        case E_DImode:
          if (altivec_register_operand (operands[0], E_DImode)
              && xxspltib_constant_split (operands[1], E_DImode)
              && 
#line 8026 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && reload_completed))
            return gen_split_296 (insn, operands);
          if (gpc_reg_operand (operands[0], E_DImode)
              && const_int_operand (operands[1], E_DImode)
              && 
#line 9838 "../../gcc/config/rs6000/rs6000.md"
(! TARGET_POWERPC64 && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])))
            return gen_split_376 (insn, operands);
          break;

        case E_DFmode:
          if (gpc_reg_operand (operands[0], E_DFmode)
              && const_int_operand (operands[1], E_DFmode)
              && 
#line 8483 "../../gcc/config/rs6000/rs6000.md"
(! TARGET_POWERPC64 && reload_completed
   && ((REG_P (operands[0]) && REGNO (operands[0]) <= 31)
       || (SUBREG_P (operands[0])
	   && REG_P (SUBREG_REG (operands[0]))
	   && REGNO (SUBREG_REG (operands[0])) <= 31))))
            return gen_split_304 (insn, operands);
          break;

        case E_DDmode:
          if (gpc_reg_operand (operands[0], E_DDmode)
              && const_int_operand (operands[1], E_DDmode)
              && 
#line 8483 "../../gcc/config/rs6000/rs6000.md"
(! TARGET_POWERPC64 && reload_completed
   && ((REG_P (operands[0]) && REGNO (operands[0]) <= 31)
       || (SUBREG_P (operands[0])
	   && REG_P (SUBREG_REG (operands[0]))
	   && REGNO (SUBREG_REG (operands[0])) <= 31))))
            return gen_split_305 (insn, operands);
          break;

        case E_QImode:
          if (altivec_register_operand (operands[0], E_QImode)
              && xxspltib_constant_split (operands[1], E_QImode)
              && 
#line 10009 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && reload_completed))
            return gen_split_383 (insn, operands);
          break;

        case E_HImode:
          if (altivec_register_operand (operands[0], E_HImode)
              && xxspltib_constant_split (operands[1], E_HImode)
              && 
#line 10009 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && reload_completed))
            return gen_split_384 (insn, operands);
          break;

        case E_PTImode:
          if (int_reg_operand (operands[0], E_PTImode)
              && const_scalar_int_operand (operands[1], E_PTImode)
              && 
#line 10063 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64
   && (VECTOR_MEM_NONE_P (PTImode)
       || (reload_completed && INT_REGNO_P (REGNO (operands[0]))))))
            return gen_split_388 (insn, operands);
          break;

        default:
          break;
        }
      if (GET_CODE (x3) == VEC_DUPLICATE
          && GET_MODE (x3) == E_V4SFmode
          && vsx_register_operand (operands[0], E_V4SFmode))
        {
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          if (splat_input_operand (operands[1], E_SFmode)
              && (
#line 4832 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR) && 
#line 4837 "../../gcc/config/rs6000/vsx.md"
( reload_completed && vsx_register_operand (operands[1], SFmode))))
            return gen_split_658 (insn, operands);
        }
      break;

    case CONST_DOUBLE:
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (gpc_reg_operand (operands[0], E_SFmode)
              && const_double_operand (operands[1], E_SFmode)
              && 
#line 8216 "../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && ((REG_P (operands[0]) && REGNO (operands[0]) <= 31)
       || (SUBREG_P (operands[0])
	   && REG_P (SUBREG_REG (operands[0]))
	   && REGNO (SUBREG_REG (operands[0])) <= 31))))
            return gen_split_299 (insn, operands);
          break;

        case E_SDmode:
          if (gpc_reg_operand (operands[0], E_SDmode)
              && const_double_operand (operands[1], E_SDmode)
              && 
#line 8216 "../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && ((REG_P (operands[0]) && REGNO (operands[0]) <= 31)
       || (SUBREG_P (operands[0])
	   && REG_P (SUBREG_REG (operands[0]))
	   && REGNO (SUBREG_REG (operands[0])) <= 31))))
            return gen_split_300 (insn, operands);
          break;

        case E_DFmode:
          if (gpc_reg_operand (operands[0], E_DFmode)
              && const_double_operand (operands[1], E_DFmode))
            {
              if (
#line 8503 "../../gcc/config/rs6000/rs6000.md"
(! TARGET_POWERPC64 && reload_completed
   && ((REG_P (operands[0]) && REGNO (operands[0]) <= 31)
       || (SUBREG_P (operands[0])
	   && REG_P (SUBREG_REG (operands[0]))
	   && REGNO (SUBREG_REG (operands[0])) <= 31))))
                return gen_split_306 (insn, operands);
              if (
#line 8525 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && reload_completed
   && ((REG_P (operands[0]) && REGNO (operands[0]) <= 31)
       || (SUBREG_P (operands[0])
	   && REG_P (SUBREG_REG (operands[0]))
	   && REGNO (SUBREG_REG (operands[0])) <= 31))))
                return gen_split_308 (insn, operands);
            }
          break;

        case E_DDmode:
          if (gpc_reg_operand (operands[0], E_DDmode)
              && const_double_operand (operands[1], E_DDmode))
            {
              if (
#line 8503 "../../gcc/config/rs6000/rs6000.md"
(! TARGET_POWERPC64 && reload_completed
   && ((REG_P (operands[0]) && REGNO (operands[0]) <= 31)
       || (SUBREG_P (operands[0])
	   && REG_P (SUBREG_REG (operands[0]))
	   && REGNO (SUBREG_REG (operands[0])) <= 31))))
                return gen_split_307 (insn, operands);
              if (
#line 8525 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && reload_completed
   && ((REG_P (operands[0]) && REGNO (operands[0]) <= 31)
       || (SUBREG_P (operands[0])
	   && REG_P (SUBREG_REG (operands[0]))
	   && REGNO (SUBREG_REG (operands[0])) <= 31))))
                return gen_split_309 (insn, operands);
            }
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[1] = x3;
  res = split_13 (x1, insn);
  if (res != NULL_RTX)
    return res;
  if (vsx_register_operand (operands[0], E_V1TImode)
      && GET_CODE (x3) == SUBREG
      && known_eq (SUBREG_BYTE (x3), 0)
      && GET_MODE (x3) == E_V1TImode)
    {
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (int_reg_operand (operands[1], E_TImode)
          && 
#line 6769 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && !reload_completed))
        return gen_split_672 (insn, operands);
    }
  operands[1] = x3;
  if (vsx_register_operand (operands[1], E_V1TImode)
      && gpc_reg_operand (operands[0], E_V1TImode)
      && 
#line 6796 "../../gcc/config/rs6000/vsx.md"
(reload_completed
   && TARGET_DIRECT_MOVE_64BIT
   && int_reg_operand (operands[0], V1TImode)
   && vsx_register_operand (operands[1], V1TImode)))
    return gen_split_673 (insn, operands);
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!altivec_register_operand (operands[0], E_DImode)
          || !xxspltib_constant_split (operands[1], E_DImode)
          || !
#line 10009 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_VECTOR && reload_completed))
        return NULL;
      return gen_split_386 (insn, operands);

    case E_V8HImode:
      if (!altivec_register_operand (operands[0], E_V8HImode))
        return NULL;
      if (xxspltib_constant_split (operands[1], E_V8HImode)
          && (
#line 1174 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR) && 
#line 1176 "../../gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_581 (insn, operands);
      if (easy_vector_constant_msb (operands[1], E_V8HImode)
          && 
#line 286 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V8HImode) && reload_completed))
        return gen_split_675 (insn, operands);
      if (easy_vector_constant_add_self (operands[1], E_V8HImode)
          && 
#line 324 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V8HImode) && reload_completed))
        return gen_split_685 (insn, operands);
      if (!easy_vector_constant_vsldoi (operands[1], E_V8HImode)
          || !
#line 353 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V8HImode) && can_create_pseudo_p ()))
        return NULL;
      return gen_split_695 (insn, operands);

    case E_V4SImode:
      if (!altivec_register_operand (operands[0], E_V4SImode))
        return NULL;
      if (xxspltib_constant_split (operands[1], E_V4SImode)
          && (
#line 1174 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR) && 
#line 1176 "../../gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_582 (insn, operands);
      if (easy_vector_constant_msb (operands[1], E_V4SImode)
          && 
#line 286 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SImode) && reload_completed))
        return gen_split_674 (insn, operands);
      if (easy_vector_constant_add_self (operands[1], E_V4SImode)
          && 
#line 324 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SImode) && reload_completed))
        return gen_split_684 (insn, operands);
      if (!easy_vector_constant_vsldoi (operands[1], E_V4SImode)
          || !
#line 353 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SImode) && can_create_pseudo_p ()))
        return NULL;
      return gen_split_694 (insn, operands);

    case E_V2DImode:
      if (!altivec_register_operand (operands[0], E_V2DImode))
        return NULL;
      if (xxspltib_constant_split (operands[1], E_V2DImode)
          && (
#line 1174 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR) && 
#line 1176 "../../gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_583 (insn, operands);
      if (vspltisw_vupkhsw_constant_split (operands[1], E_V2DImode)
          && (
#line 1213 "../../gcc/config/rs6000/vsx.md"
(TARGET_P8_VECTOR && vspltisw_vupkhsw_constant_split (operands[1], V2DImode)) && 
#line 1215 "../../gcc/config/rs6000/vsx.md"
( 1)))
        return gen_split_584 (insn, operands);
      if (easy_vector_constant_msb (operands[1], E_V2DImode)
          && 
#line 286 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DImode) && reload_completed))
        return gen_split_679 (insn, operands);
      if (easy_vector_constant_add_self (operands[1], E_V2DImode)
          && 
#line 324 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DImode) && reload_completed))
        return gen_split_689 (insn, operands);
      if (!easy_vector_constant_vsldoi (operands[1], E_V2DImode)
          || !
#line 353 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DImode) && can_create_pseudo_p ()))
        return NULL;
      return gen_split_699 (insn, operands);

    default:
      return NULL;
    }
}
